"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _base = _interopRequireDefault(require("./base"));

var DOM = _interopRequireWildcard(require("../../util/dom"));

var _lngLat = require("@antv/geo-coord/lib/geo/geometry/lng-lat");

var _event = require("../../util/event");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Scale =
/*#__PURE__*/
function (_Control) {
  _inherits(Scale, _Control);

  function Scale(cfg) {
    var _this;

    _classCallCheck(this, Scale);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Scale).call(this, _objectSpread({
      position: 'bottomleft',
      maxWidth: 100,
      metric: true,
      updateWhenIdle: false,
      imperial: false
    }, cfg)));
    (0, _event.bindAll)(['_update'], _assertThisInitialized(_this));
    return _this;
  }

  _createClass(Scale, [{
    key: "onAdd",
    value: function onAdd(scene) {
      var className = 'l7-control-scale';
      var container = DOM.create('div', className);

      this._addScales(className + '-line', container);

      scene.on(this.get('updateWhenIdle') ? 'moveend' : 'mapmove', this._update);

      this._update();

      return container;
    }
  }, {
    key: "onRemove",
    value: function onRemove(scene) {
      scene.off(this.get('updateWhenIdle') ? 'moveend' : 'mapmove', this._update);
    }
  }, {
    key: "_addScales",
    value: function _addScales(className, container) {
      if (this.get('metric')) {
        this._mScale = DOM.create('div', className, container);
      }

      if (this.get('imperial')) {
        this._iScale = DOM.create('div', className, container);
      }
    }
  }, {
    key: "_update",
    value: function _update() {
      var scene = this._scene;
      var y = this._scene.getSize().height / 2;
      var p1 = scene.containerToLngLat({
        x: 0,
        y: y
      });
      var p2 = scene.containerToLngLat({
        x: this.get('maxWidth'),
        y: y
      });
      var maxMeters = scene.crs.distance((0, _lngLat.toLngLat)(p1.lng, p1.lat), (0, _lngLat.toLngLat)(p2.lng, p2.lat));

      this._updateScales(maxMeters);
    }
  }, {
    key: "_updateScales",
    value: function _updateScales(maxMeters) {
      if (this.get('metric') && maxMeters) {
        this._updateMetric(maxMeters);
      }

      if (this.get('imperial') && maxMeters) {
        this._updateImperial(maxMeters);
      }
    }
  }, {
    key: "_updateMetric",
    value: function _updateMetric(maxMeters) {
      var meters = this._getRoundNum(maxMeters),
          label = meters < 1000 ? meters + ' m' : meters / 1000 + ' km';

      this._updateScale(this._mScale, label, meters / maxMeters);
    }
  }, {
    key: "_updateImperial",
    value: function _updateImperial(maxMeters) {
      var maxFeet = maxMeters * 3.2808399;
      var maxMiles, miles, feet;

      if (maxFeet > 5280) {
        maxMiles = maxFeet / 5280;
        miles = this._getRoundNum(maxMiles);

        this._updateScale(this._iScale, miles + ' mi', miles / maxMiles);
      } else {
        feet = this._getRoundNum(maxFeet);

        this._updateScale(this._iScale, feet + ' ft', feet / maxFeet);
      }
    }
  }, {
    key: "_updateScale",
    value: function _updateScale(scale, text, ratio) {
      scale.style.width = Math.round(this.get('maxWidth') * ratio) + 'px';
      scale.innerHTML = text;
    }
  }, {
    key: "_getRoundNum",
    value: function _getRoundNum(num) {
      var pow10 = Math.pow(10, (Math.floor(num) + '').length - 1);
      var d = num / pow10;
      d = d >= 10 ? 10 : d >= 5 ? 5 : d >= 3 ? 3 : d >= 2 ? 2 : 1;
      return pow10 * d;
    }
  }]);

  return Scale;
}(_base["default"]);

exports["default"] = Scale;