"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _base = _interopRequireDefault(require("./base"));

var DOM = _interopRequireWildcard(require("../../util/dom"));

var _event = require("../../util/event");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Layers =
/*#__PURE__*/
function (_Control) {
  _inherits(Layers, _Control);

  function Layers(cfg) {
    var _this;

    _classCallCheck(this, Layers);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Layers).call(this, _objectSpread({
      collapsed: true,
      position: 'topright',
      autoZIndex: true,
      hideSingleBase: false,
      sortLayers: false
    }, cfg)));
    _this._layerControlInputs = [];
    _this._layers = [];
    _this._lastZIndex = 0;
    _this._handlingClick = false;

    var baseLayers = _this.get('baseLayers');

    var overlays = _this.get('overlayers');

    for (var i in baseLayers) {
      _this._addLayer(baseLayers[i], i);
    }

    for (var _i in overlays) {
      _this._addLayer(overlays[_i], _i, true);
    }

    (0, _event.bindAll)(['_checkDisabledLayers', '_onLayerChange', 'collapse', 'extend', 'expand', '_onInputClick'], _assertThisInitialized(_this));
    return _this;
  }

  _createClass(Layers, [{
    key: "onAdd",
    value: function onAdd(scene) {
      this._initLayout();

      this._update();

      this._scene = scene;
      scene.on('zoomend', this._checkDisabledLayers, this);

      for (var i = 0; i < this._layers.length; i++) {
        this._layers[i].layer.on('remove', this._onLayerChange);

        this._layers[i].layer.on('add', this._onLayerChange);
      }

      return this._container;
    }
  }, {
    key: "addTo",
    value: function addTo(scene) {
      _get(_getPrototypeOf(Layers.prototype), "addTo", this).call(this, scene);
    }
  }, {
    key: "addVisualLayer",
    value: function addVisualLayer(layer, name) {
      this._addLayer(layer, name, true);

      return this._scene ? this._update() : this;
    }
  }, {
    key: "_initLayout",
    value: function _initLayout() {
      var className = 'l7-control-layers',
          container = this._container = DOM.create('div', className),
          collapsed = this.get('collapsed'); // makes this work on IE touch devices by stopping it from firing a mouseout event when the touch is released

      container.setAttribute('aria-haspopup', true);
      var form = this._form = DOM.create('form', className + '-list');

      if (collapsed) {
        this._scene.on('click', this.collapse);

        container.addEventListener('mouseenter', this.expand);
        container.addEventListener('mouseleave', this.collapse);
      }

      var link = this._layersLink = DOM.create('a', className + '-toggle', container);
      link.href = '#';
      link.title = 'Layers';

      if (!collapsed) {
        this.expand();
      }

      this._baseLayersList = DOM.create('div', className + '-base', form);
      this._separator = DOM.create('div', className + '-separator', form);
      this._overlaysList = DOM.create('div', className + '-overlays', form);
      container.appendChild(form);
    }
  }, {
    key: "_update",
    value: function _update() {
      if (!this._container) {
        return this;
      }

      DOM.empty(this._baseLayersList);
      DOM.empty(this._overlaysList);
      this._layerControlInputs = [];
      var baseLayersPresent,
          overlaysPresent,
          i,
          obj,
          baseLayersCount = 0;

      for (i = 0; i < this._layers.length; i++) {
        obj = this._layers[i];

        this._addItem(obj);

        overlaysPresent = overlaysPresent || obj.overlay;
        baseLayersPresent = baseLayersPresent || !obj.overlay;
        baseLayersCount += !obj.overlay ? 1 : 0;
      } // Hide base layers section if there's only one layer.


      if (this.get('hideSingleBase')) {
        baseLayersPresent = baseLayersPresent && baseLayersCount > 1;
        this._baseLayersList.style.display = baseLayersPresent ? '' : 'none';
      }

      this._separator.style.display = overlaysPresent && baseLayersPresent ? '' : 'none';
      return this;
    }
  }, {
    key: "expand",
    value: function expand() {
      DOM.addClass(this._container, 'l7-control-layers-expanded');
      this._form.style.height = null;
      var acceptableHeight = this._scene.getSize().height - (this._container.offsetTop + 50);

      if (acceptableHeight < this._form.clientHeight) {
        DOM.addClass(this._form, 'l7-control-layers-scrollbar');
        this._form.style.height = acceptableHeight + 'px';
      } else {
        DOM.removeClass(this._form, 'l7-control-layers-scrollbar');
      }

      this._checkDisabledLayers();

      return this;
    }
  }, {
    key: "collapse",
    value: function collapse() {
      DOM.removeClass(this._container, 'l7-control-layers-expanded');
      return this;
    }
  }, {
    key: "_checkDisabledLayers",
    value: function _checkDisabledLayers() {
      var inputs = this._layerControlInputs;
      var input, layer;

      var zoom = this._scene.getZoom();

      for (var i = inputs.length - 1; i >= 0; i--) {
        input = inputs[i];
        layer = this._scene.getLayer(input.layerId);
        input.disabled = layer.get('minZoom') !== undefined && zoom < layer.get('minZoom') || zoom < layer.get('maxZoom') !== undefined && zoom > layer.get('maxZoom');
      }
    }
  }, {
    key: "_addLayer",
    value: function _addLayer(layer, name, overlay) {
      var _this2 = this;

      if (this._scene) {
        layer.on('add', this._onLayerChange);
        layer.on('remove', this._onLayerChange);
      }

      this._layers.push({
        layer: layer,
        name: name,
        overlay: overlay
      });

      if (this.get('sortLayers')) {
        this._layers.sort(function (a, b) {
          return _this2.get('sortFunction')(a.layer, b.layer, a.name, b.name);
        });
      }

      if (this.get('autoZIndex') && layer.setZIndex) {
        this._lastZIndex++;
        layer.setZIndex(this._lastZIndex);
      }

      this._expandIfNotCollapsed();
    }
  }, {
    key: "_expandIfNotCollapsed",
    value: function _expandIfNotCollapsed() {
      if (this._scene && !this.get('collapsed')) {
        this.expand();
      }

      return this;
    }
  }, {
    key: "_onLayerChange",
    value: function _onLayerChange(e) {
      if (!this._handlingClick) {
        this._update();
      }

      var obj = this._scene.getLayer(e.target.layerId);

      var type = obj.overlay ? e.type === 'add' ? 'overlayadd' : 'overlayremove' : e.type === 'add' ? 'baselayerchange' : null;

      if (type) {
        this._map.fire(type, obj);
      }
    }
  }, {
    key: "_createRadioElement",
    value: function _createRadioElement(name, checked) {
      var radioHtml = '<input type="radio" class="l7-control-layers-selector" name="' + name + '"' + (checked ? ' checked="checked"' : '') + '/>';
      var radioFragment = document.createElement('div');
      radioFragment.innerHTML = radioHtml;
      return radioFragment.firstChild;
    }
  }, {
    key: "_addItem",
    value: function _addItem(obj) {
      var label = document.createElement('label'),
          checked = !!this._scene.getLayer(obj.layer.layerId);
      var input;

      if (obj.overlay) {
        input = document.createElement('input');
        input.type = 'checkbox';
        input.className = 'l7-control-layers-selector';
        input.defaultChecked = checked;
      } else {
        input = this._createRadioElement('l7-base-layers', checked);
      }

      this._layerControlInputs.push(input);

      input.layerId = obj.layer.layerId;
      input.addEventListener('click', this._onInputClick);
      var name = document.createElement('span');
      name.innerHTML = ' ' + obj.name;
      var holder = document.createElement('div');
      label.appendChild(holder);
      holder.appendChild(input);
      holder.appendChild(name);
      var container = obj.overlay ? this._overlaysList : this._baseLayersList;
      container.appendChild(label);

      this._checkDisabledLayers();

      return label;
    }
  }, {
    key: "_onInputClick",
    value: function _onInputClick() {
      var inputs = this._layerControlInputs;
      var input, layer;
      var addedLayers = [],
          removedLayers = [];
      this._handlingClick = true;

      for (var i = inputs.length - 1; i >= 0; i--) {
        input = inputs[i];
        layer = this._scene.getLayer(input.layerId);

        if (input.checked) {
          addedLayers.push(layer);
        } else if (!input.checked) {
          removedLayers.push(layer);
        }
      }

      for (var _i2 = 0; _i2 < removedLayers.length; _i2++) {
        removedLayers[_i2].hide();
      }

      for (var _i3 = 0; _i3 < addedLayers.length; _i3++) {
        addedLayers[_i3].show();
      }

      this._handlingClick = false;

      this._refocusOnMap();
    }
  }]);

  return Layers;
}(_base["default"]);

exports["default"] = Layers;