"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _base = _interopRequireDefault(require("./base"));

var DOM = _interopRequireWildcard(require("../../util/dom"));

var _event = require("../../util/event");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Zoom =
/*#__PURE__*/
function (_Control) {
  _inherits(Zoom, _Control);

  function Zoom(cfg) {
    var _this;

    _classCallCheck(this, Zoom);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Zoom).call(this, _objectSpread({
      position: 'topleft',
      zoomInText: '+',
      zoomInTitle: 'Zoom in',
      zoomOutText: '&#x2212;',
      zoomOutTitle: 'Zoom out'
    }, cfg)));
    (0, _event.bindAll)(['_updateDisabled', '_zoomIn', '_zoomOut'], _assertThisInitialized(_this));
    _this._disabled = false;
    return _this;
  }

  _createClass(Zoom, [{
    key: "onAdd",
    value: function onAdd(scene) {
      var zoomName = 'l7-control-zoom';
      var container = DOM.create('div', zoomName + ' l7-bar');
      this._zoomInButton = this._createButton(this.get('zoomInText'), this.get('zoomInTitle'), zoomName + '-in', container, this._zoomIn);
      this._zoomOutButton = this._createButton(this.get('zoomOutText'), this.get('zoomOutTitle'), zoomName + '-out', container, this._zoomOut);
      scene.on('zoomend', this._updateDisabled);
      scene.on('zoomchange', this._updateDisabled);

      this._updateDisabled();

      return container;
    }
  }, {
    key: "onRemove",
    value: function onRemove(scene) {
      scene.off('zoomend', this._updateDisabled);
      scene.off('zoomchange', this._updateDisabled);
    }
  }, {
    key: "disable",
    value: function disable() {
      this._disabled = true;

      this._updateDisabled();

      return this;
    }
  }, {
    key: "enable",
    value: function enable() {
      this._disabled = false;

      this._updateDisabled();

      return this;
    }
  }, {
    key: "_zoomIn",
    value: function _zoomIn() {
      if (!this._disabled && this._scene.getZoom() < this._scene.get('maxZoom')) {
        this._scene.zoomIn();
      }
    }
  }, {
    key: "_zoomOut",
    value: function _zoomOut() {
      if (!this._disabled && this._scene.getZoom() > this._scene.get('minZoom')) {
        this._scene.zoomOut();
      }
    }
  }, {
    key: "_createButton",
    value: function _createButton(html, tile, className, container, fn) {
      var link = DOM.create('a', className, container);
      link.innerHTML = html;
      link.href = '#';
      link.tile = tile;
      link.addEventListener('click', fn);
      return link;
    }
  }, {
    key: "_updateDisabled",
    value: function _updateDisabled() {
      var scene = this._scene;
      var className = 'l7-disabled';
      DOM.removeClass(this._zoomInButton, className);
      DOM.removeClass(this._zoomOutButton, className);

      if (this._disabled || scene.getZoom() <= scene.get('minZoom')) {
        DOM.addClass(this._zoomOutButton, className);
      }

      if (this._disabled || scene.getZoom() >= scene.get('maxZoom')) {
        DOM.addClass(this._zoomInButton, className);
      }
    }
  }]);

  return Zoom;
}(_base["default"]);

exports["default"] = Zoom;