"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _base = _interopRequireDefault(require("../core/base"));

var _event = require("../util/event");

var _anchor = require("../util/anchor");

var DOM = _interopRequireWildcard(require("../util/dom"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Marker =
/*#__PURE__*/
function (_Base) {
  _inherits(Marker, _Base);

  function Marker(cfg) {
    var _this;

    _classCallCheck(this, Marker);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Marker).call(this, _objectSpread({
      element: '',
      // DOM element
      anchor: 'center',
      offset: [0, 0],
      color: '#2f54eb',
      draggable: false
    }, cfg)));
    (0, _event.bindAll)(['_update', '_onMove', '_onUp', '_addDragHandler', '_onMapClick'], _assertThisInitialized(_this));

    _this._init();

    return _this;
  }

  _createClass(Marker, [{
    key: "_init",
    value: function _init() {
      var _this2 = this;

      var element = this.get('element');

      if (!element) {
        this._defaultMarker = true;
        element = DOM.create('div');
        this.set('element', element);
        var svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        svg.setAttributeNS(null, 'display', 'block');
        svg.setAttributeNS(null, 'height', '48px');
        svg.setAttributeNS(null, 'width', '48px');
        svg.setAttributeNS(null, 'viewBox', '0 0 1024 1024');
        var path = document.createElementNS('http://www.w3.org/2000/svg', 'path');
        path.setAttributeNS(null, 'd', 'M512 490.666667C453.12 490.666667 405.333333 442.88 405.333333 384 405.333333 325.12 453.12 277.333333 512 277.333333 570.88 277.333333 618.666667 325.12 618.666667 384 618.666667 442.88 570.88 490.666667 512 490.666667M512 85.333333C346.88 85.333333 213.333333 218.88 213.333333 384 213.333333 608 512 938.666667 512 938.666667 512 938.666667 810.666667 608 810.666667 384 810.666667 218.88 677.12 85.333333 512 85.333333Z');
        path.setAttributeNS(null, 'fill', this.get('color'));
        svg.appendChild(path);
        element.appendChild(svg);
      }

      DOM.addClass(element, 'l7-marker');
      element.addEventListener('click', function (e) {
        _this2._onMapClick(e);
      });
      (0, _anchor.applyAnchorClass)(element, this.get('anchor'), 'marker');
      this._popup = null;
    }
  }, {
    key: "addTo",
    value: function addTo(scene) {
      this.remove();
      this._scene = scene;

      this._scene.getMarkerContainer().appendChild(this.get('element'));

      this._scene.on('camerachange', this._update);

      this.setDraggable(this.get('draggable'));

      this._update();

      return this;
    }
  }, {
    key: "remove",
    value: function remove() {
      if (this._scene) {
        this._scene.off('click', this._onMapClick);

        this._scene.off('move', this._update);

        this._scene.off('moveend', this._update);

        this._scene.off('mousedown', this._addDragHandler);

        this._scene.off('touchstart', this._addDragHandler);

        this._scene.off('mouseup', this._onUp);

        this._scene.off('touchend', this._onUp);

        delete this._scene;
      }

      DOM.remove(this.get('element'));
      if (this._popup) this._popup.remove();
      return this;
    }
  }, {
    key: "setLnglat",
    value: function setLnglat(lngLat) {
      this._lngLat = lngLat;
      if (this._popup) this._popup.setLnglat(this._lngLat);
      return this;
    }
  }, {
    key: "getLnglat",
    value: function getLnglat() {
      return this._lngLat;
    }
  }, {
    key: "getElement",
    value: function getElement() {
      return this.get('element');
    }
  }, {
    key: "setPopup",
    value: function setPopup(popup) {
      this._popup = popup;
      if (this._lngLat) this._popup.setLnglat(this._lngLat);
      return this;
    }
  }, {
    key: "togglePopup",
    value: function togglePopup() {
      var popup = this._popup;
      if (!popup) return this;else if (popup.isOpen()) popup.remove();else popup.addTo(this._scene);
      return this;
    }
  }, {
    key: "getPopup",
    value: function getPopup() {
      return this._popup;
    }
  }, {
    key: "getOffset",
    value: function getOffset() {}
  }, {
    key: "setDraggable",
    value: function setDraggable() {}
  }, {
    key: "isDraggable",
    value: function isDraggable() {
      return this._draggable;
    }
  }, {
    key: "_update",
    value: function _update() {
      if (!this._scene) return;

      this._updatePosition();

      DOM.setTransform(this.get('element'), "".concat(_anchor.anchorTranslate[this.get('anchor')]));
    }
  }, {
    key: "_onMapClick",
    value: function _onMapClick() {
      // this._scene.emit('click'); // 触发map点击事件，关闭其他popup
      var element = this.get('element');

      if (this._popup && element) {
        this.togglePopup();
      }
    }
  }, {
    key: "_updatePosition",
    value: function _updatePosition() {
      if (!this._scene) {
        return;
      }

      var pos = this._pos = this._scene.lngLatToContainer(this._lngLat);

      this.get('element').style.left = pos.x + 'px';
      this.get('element').style.top = pos.y + 'px';
    }
  }, {
    key: "_bubbleUp",
    value: function _bubbleUp() {
      var _this3 = this;

      var eventsName = ['mouseout', 'mouseover', 'mousemove', 'mousedown', 'mouseleave', 'mouseup', 'rightclick', 'click', 'dblclick', 'wheel'];
      var element = this.get('element');
      eventsName.forEach(function (event) {
        element.addEventListener(event, function (e) {
          _this3._scene.emit(event, e);
        });
      });
    }
  }, {
    key: "_addDragHandler",
    value: function _addDragHandler() {}
  }, {
    key: "_onUp",
    value: function _onUp() {}
  }]);

  return Marker;
}(_base["default"]);

exports["default"] = Marker;