"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _base = _interopRequireDefault(require("../core/base"));

var _event = require("../util/event");

var DOM = _interopRequireWildcard(require("../util/dom"));

var _anchor = require("../util/anchor");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Popup =
/*#__PURE__*/
function (_Base) {
  _inherits(Popup, _Base);

  function Popup(cfg) {
    var _this;

    _classCallCheck(this, Popup);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Popup).call(this, _objectSpread({
      closeButton: true,
      closeOnClick: true,
      maxWidth: '240px',
      anchor: 'bottom'
    }, cfg)));
    (0, _event.bindAll)(['_update', '_onClickClose', 'remove'], _assertThisInitialized(_this));
    return _this;
  }

  _createClass(Popup, [{
    key: "addTo",
    value: function addTo(scene) {
      var _this2 = this;

      this._scene = scene;

      this._scene.on('camerachange', this._update);

      this._update();

      if (this.get('closeOnClick')) {
        setTimeout(function () {
          // TODO 事件冲突
          _this2._scene.on('click', _this2._onClickClose);
        }, 30);
      }
    }
  }, {
    key: "setLnglat",
    value: function setLnglat(lngLat) {
      this.lngLat = lngLat;

      if (this._scene) {
        this._scene.on('camerachange', this._update);
      }

      this._update(lngLat);

      return this;
    }
  }, {
    key: "_update",
    value: function _update() {
      var _this3 = this;

      var hasPosition = this.lngLat;

      if (!this._scene || !hasPosition || !this._content) {
        return;
      }

      if (!this._container) {
        this._container = this.creatDom('div', 'l7-popup', this._scene.getMarkerContainer().parentNode);
        this._tip = this.creatDom('div', 'l7-popup-tip', this._container);

        this._container.appendChild(this._content);

        if (this.get('className')) {
          this.get('className').split(' ').forEach(function (name) {
            return _this3._container.classList.add(name);
          });
        }

        this._container.addEventListener('mousedown', function (e) {
          e.stopPropagation();
        });
      }

      if (this.get('maxWidth') && this._container.style.maxWidth !== this.get('maxWidth')) {
        this._container.style.maxWidth = this.get('maxWidth');
      }

      this._updatePosition();

      DOM.setTransform(this._container, "".concat(_anchor.anchorTranslate[this.get('anchor')]));
      (0, _anchor.applyAnchorClass)(this._container, this.get('anchor'), 'popup');
    }
  }, {
    key: "_updatePosition",
    value: function _updatePosition() {
      if (!this._scene) {
        return;
      }

      var pos = this._scene.lngLatToContainer(this.lngLat);

      this._container.style.left = pos.x + 'px';
      this._container.style.top = pos.y + 'px';
    }
  }, {
    key: "setHTML",
    value: function setHTML(html) {
      var frag = window.document.createDocumentFragment();
      var temp = window.document.createElement('body');
      var child;
      temp.innerHTML = html;

      while (true) {
        // eslint-disable-line
        child = temp.firstChild;
        if (!child) break;
        frag.appendChild(child);
      }

      return this.setDOMContent(frag);
    }
  }, {
    key: "setText",
    value: function setText(text) {
      return this.setDOMContent(window.document.createTextNode(text));
    }
  }, {
    key: "setMaxWidth",
    value: function setMaxWidth(maxWidth) {
      this.set('maxWidth', maxWidth);

      this._update();

      return this;
    }
  }, {
    key: "setDOMContent",
    value: function setDOMContent(htmlNode) {
      this._createContent();

      this._content.appendChild(htmlNode);

      this._update();

      return this;
    }
  }, {
    key: "_createContent",
    value: function _createContent() {
      if (this._content) {
        DOM.remove(this._content);
      }

      this._content = DOM.create('div', 'l7-popup-content', this._container);

      if (this.get('closeButton')) {
        this._closeButton = DOM.create('button', 'l7-popup-close-button', this._content);
        this._closeButton.type = 'button';

        this._closeButton.setAttribute('aria-label', 'Close popup');

        this._closeButton.innerHTML = '&#215;';

        this._closeButton.addEventListener('click', this._onClickClose);
      }
    }
  }, {
    key: "_onClickClose",
    value: function _onClickClose() {
      this.remove();
    }
  }, {
    key: "creatDom",
    value: function creatDom(tagName, className, container) {
      var el = window.document.createElement(tagName);
      if (className !== undefined) el.className = className;
      if (container) container.appendChild(el);
      return el;
    }
  }, {
    key: "removeDom",
    value: function removeDom(node) {
      if (node.parentNode) {
        node.parentNode.removeChild(node);
      }
    } // 移除popup

  }, {
    key: "remove",
    value: function remove() {
      if (this._content) {
        this.removeDom(this._content);
      }

      if (this._container) {
        this.removeDom(this._container);
        delete this._container;
      }

      if (this._scene) {
        this._scene.off('camerachange', this._update);

        this._scene.off('click', this._onClickClose);

        delete this._scene;
      }

      this.emit('close');
      return this;
    }
  }, {
    key: "isOpen",
    value: function isOpen() {
      return !!this._scene;
    }
  }]);

  return Popup;
}(_base["default"]);

exports["default"] = Popup;