"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _util = _interopRequireDefault(require("../../util"));

var DOM = _interopRequireWildcard(require("../../util/dom"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Control =
/*#__PURE__*/
function () {
  function Control(cfg) {
    _classCallCheck(this, Control);

    _util["default"].assign(this, cfg);

    this._initControlPos();
  }

  _createClass(Control, [{
    key: "addControl",
    value: function addControl(control) {
      control.addTo(this.scene);
    }
  }, {
    key: "removeControl",
    value: function removeControl(control) {
      control.remove();
      return this;
    }
  }, {
    key: "_initControlPos",
    value: function _initControlPos() {
      var corners = this._controlCorners = {};
      var l = 'l7-';
      var container = this._controlContainer = DOM.create('div', l + 'control-container', this.scene.getContainer());

      function createCorner(vSide, hSide) {
        var className = l + vSide + ' ' + l + hSide;
        corners[vSide + hSide] = DOM.create('div', className, container);
      }

      createCorner('top', 'left');
      createCorner('top', 'right');
      createCorner('bottom', 'left');
      createCorner('bottom', 'right');
    }
  }, {
    key: "_clearControlPos",
    value: function _clearControlPos() {
      for (var i in this._controlCorners) {
        DOM.remove(this._controlCorners[i]);
      }

      DOM.remove(this._controlContainer);
      delete this._controlCorners;
      delete this._controlContainer;
    }
  }]);

  return Control;
}();

exports["default"] = Control;