"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _engine = _interopRequireDefault(require("./engine"));

var _layer = require("../layer");

var _base = _interopRequireDefault(require("./base"));

var _image = _interopRequireDefault(require("./image"));

var _fontManager = _interopRequireDefault(require("./atlas/font-manager"));

var _index = require("../map/index");

var _global = _interopRequireDefault(require("../global"));

var _index2 = require("../interaction/index");

var _shader = require("../geom/shader");

var _style = _interopRequireDefault(require("./style"));

var _control = _interopRequireDefault(require("./controller/control"));

var Control = _interopRequireWildcard(require("../component/control"));

var _crsEpsg = require("@antv/geo-coord/lib/geo/crs/crs-epsg3857");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Scene =
/*#__PURE__*/
function (_Base) {
  _inherits(Scene, _Base);

  _createClass(Scene, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return _global["default"].scene;
    }
  }]);

  function Scene(cfg) {
    var _this;

    _classCallCheck(this, Scene);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Scene).call(this, cfg));

    _this._initMap();

    _this.crs = _crsEpsg.epsg3857;
    _this.fontAtlasManager = new _fontManager["default"]();
    _this._layers = [];
    _this.animateCount = 0;
    _this.inited = false;
    return _this;
  }

  _createClass(Scene, [{
    key: "_initEngine",
    value: function _initEngine(mapContainer) {
      this._engine = new _engine["default"](mapContainer, this);
      this.addImage(); // 初始化图标加载器

      this.registerMapEvent(); // 和高德地图同步状态
      // this._engine.run();

      (0, _shader.compileBuiltinModules)();
    }
  }, {
    key: "_initContoller",
    value: function _initContoller() {
      var controlCtr = new _control["default"]({
        scene: this
      });
      this.set('controlController', controlCtr);

      if (this.get('zoomControl')) {
        var zoomControl = new Control.Zoom().addTo(this);
        this.set('zoomControl', zoomControl);
      }

      if (this.get('scaleControl')) {
        var scaleControl = new Control.Scale().addTo(this);
        this.set('scaleControl', scaleControl);
      }

      if (this.get('attributionControl')) {
        var attributionControl = new Control.Attribution().addTo(this);
        this.set('attributionControl', attributionControl);
      }
    } // 为pickup场景添加 object 对象

  }, {
    key: "addPickMesh",
    value: function addPickMesh(object) {
      this._engine._picking.add(object);
    }
  }, {
    key: "_initMap",
    value: function _initMap() {
      var _this2 = this;

      this.mapContainer = this.get('id');
      this.mapType = this.get('mapType') || 'amap';
      var MapProvider = (0, _index.getMap)(this.mapType);
      var Map = new MapProvider(this._attrs);
      Map.mixMap(this);
      this._container = Map.container;
      Map.on('mapLoad', function () {
        _this2.map = Map.map;
        _this2._markerContainier = Map.l7_marker_Container;

        _this2._initEngine(Map.renderDom);

        Map.asyncCamera(_this2._engine);

        _this2.initLayer();

        _this2._registEvents();

        var hash = _this2.get('hash');

        if (hash) {
          var Ctor = (0, _index2.getInteraction)('hash');
          var interaction = new Ctor({
            layer: _this2
          });

          interaction._onHashChange();
        }

        _this2.style = new _style["default"](_this2, {});

        _this2._initContoller();

        _this2.emit('loaded');
      });
    }
  }, {
    key: "initLayer",
    value: function initLayer() {
      var _this3 = this;

      var _loop = function _loop(key) {
        Scene.prototype[key] = function (cfg) {
          var layer = new _layer.LAYER_MAP[key](_this3, cfg);

          _this3._layers.push(layer);

          return layer;
        };
      };

      for (var key in _layer.LAYER_MAP) {
        _loop(key);
      }
    } // 添加 Tile Source

  }, {
    key: "addTileSource",
    value: function addTileSource(id, Sourcecfg) {
      this.style.addSource(id, Sourcecfg);
    }
  }, {
    key: "getTileSource",
    value: function getTileSource(id) {
      return this.style.getSource(id);
    }
  }, {
    key: "on",
    value: function on(type, hander) {
      if (this.map) {
        this.map.on(type, hander);
      }

      _get(_getPrototypeOf(Scene.prototype), "on", this).call(this, type, hander);
    }
  }, {
    key: "off",
    value: function off(type, hander) {
      if (this.map) {
        this.map.off(type, hander);
      }

      _get(_getPrototypeOf(Scene.prototype), "off", this).call(this, type, hander);
    }
  }, {
    key: "addImage",
    value: function addImage() {
      var _this4 = this;

      this.image = new _image["default"]();
      this.image.on('imageLoaded', function () {
        _this4._engine.update();
      });
    }
  }, {
    key: "_initEvent",
    value: function _initEvent() {}
  }, {
    key: "getLayers",
    value: function getLayers() {
      return this._layers;
    }
  }, {
    key: "getLayer",
    value: function getLayer(id) {
      var res = false;

      this._layers.forEach(function (layer) {
        if (layer.layerId === id) {
          res = layer;
          return;
        }
      });

      return res;
    }
  }, {
    key: "_addLayer",
    value: function _addLayer() {}
  }, {
    key: "getContainer",
    value: function getContainer() {
      return this._container;
    }
  }, {
    key: "getMarkerContainer",
    value: function getMarkerContainer() {
      return this._markerContainier;
    }
  }, {
    key: "map2Png",
    value: function map2Png() {
      this.scene._engine.update();

      var vis = this.scene._engine._renderer.domElement.toDataURL();

      var map = this.scene.map.getContainer().getElementsByClassName('amap-layer')[0].toDataURL();
      return [map, vis];
    }
  }, {
    key: "_registEvents",
    value: function _registEvents() {
      var _this5 = this;

      var events = ['mouseout', 'mouseover', 'mousemove', 'mousedown', 'mouseleave', 'touchstart', 'touchmove', 'touchend', 'mouseup', 'rightclick', 'click', 'dblclick'];
      events.forEach(function (event) {
        _this5._container.addEventListener(event, function (e) {
          // 要素拾取
          if (e.target.nodeName !== 'CANVAS') return;

          _this5._engine._picking.pickdata(e);
        }, true);
      });
    }
  }, {
    key: "removeLayer",
    value: function removeLayer(layer) {
      var layerIndex = this._layers.indexOf(layer);

      if (layerIndex > -1) {
        this._layers.splice(layerIndex, 1);
      }

      layer.destroy();
      layer = null;
    }
  }, {
    key: "startAnimate",
    value: function startAnimate() {
      if (this.animateCount === 0) {
        this.unRegsterMapEvent();

        this._engine.run();
      }

      this.animateCount++;
    }
  }, {
    key: "stopAnimate",
    value: function stopAnimate() {
      if (this.animateCount === 1) {
        this._engine.stop();

        this.registerMapEvent();
      }

      this.animateCount++;
    } // 地图状态变化时更新可视化渲染

  }, {
    key: "registerMapEvent",
    value: function registerMapEvent() {
      var _this6 = this;

      this._updateRender = function () {
        return _this6._engine.update();
      }; // this.map.on('mousemove', this._updateRender);


      this.map.on('mapmove', this._updateRender);
      this.map.on('camerachange', this._updateRender);
    }
  }, {
    key: "unRegsterMapEvent",
    value: function unRegsterMapEvent() {
      // this.map.off('mousemove', this._updateRender);
      this.map.off('mapmove', this._updateRender);
      this.map.off('camerachange', this._updateRender);
    } // control

  }, {
    key: "addControl",
    value: function addControl(ctr) {
      this.get('controlController').addControl(ctr);
      return this;
    }
  }, {
    key: "removeControl",
    value: function removeControl(ctr) {
      this.get('controlController').removeControl(ctr);
    }
  }]);

  return Scene;
}(_base["default"]);

exports["default"] = Scene;