"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = TextMaterial;

var _material = _interopRequireDefault(require("./material"));

var _shaderModule = require("../../util/shaderModule");

var _deepMix = _interopRequireDefault(require("@antv/util/lib/deep-mix"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function TextMaterial(_uniforms) {
  var _getModule = (0, _shaderModule.getModule)('text'),
      vs = _getModule.vs,
      fs = _getModule.fs,
      uniforms = _getModule.uniforms;

  var material = new _material["default"]({
    defines: {
      SDF_PX: '8.0',
      EDGE_GAMMA: 0.105 / window.devicePixelRatio
    },
    uniforms: (0, _shaderModule.wrapUniforms)((0, _deepMix["default"])(uniforms, _uniforms)),
    vertexShader: vs,
    fragmentShader: fs,
    transparent: true
  });
  return material;
}