"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.applyAnchorClass = applyAnchorClass;
exports.anchorTranslate = void 0;
var anchorTranslate = {
  center: 'translate(-50%,-50%)',
  top: 'translate(-50%,0)',
  'top-left': 'translate(0,0)',
  'top-right': 'translate(-100%,0)',
  bottom: 'translate(-50%,-100%)',
  'bottom-left': 'translate(0,-100%)',
  'bottom-right': 'translate(-100%,-100%)',
  left: 'translate(0,-50%)',
  right: 'translate(-100%,-50%)'
};
exports.anchorTranslate = anchorTranslate;

function applyAnchorClass(element, anchor, prefix) {
  var classList = element.classList;

  for (var key in anchorTranslate) {
    classList.remove("l7-".concat(prefix, "-anchor-").concat(key));
  }

  classList.add("l7-".concat(prefix, "-anchor-").concat(anchor));
}