(function (global, factory) {
typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
typeof define === 'function' && define.amd ? define(factory) :
(global = global || self, global.L7 = factory());
}(this, function () { 'use strict';

/* eslint-disable */

var shared, worker, L7;
// define gets called three times: one for each chunk. we rely on the order
// they're imported to know which is which
function define(_, chunk) {
if (!shared) {
    shared = chunk;
} else if (!worker) {
    worker = chunk;
} else {
    var workerBundleString = 'var sharedChunk = {}; (' + shared + ')(sharedChunk); (' + worker + ')(sharedChunk);'

    var sharedChunk = {};
    shared(sharedChunk);
    L7 = chunk(sharedChunk);
    L7.workerUrl = window.URL.createObjectURL(new Blob([workerBundleString], { type: 'text/javascript' }));
}
}


define(["exports"],function(t){"use strict";function e(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}function n(t,e){return t(e={exports:{}},e.exports),e.exports}var r=n(function(t){!function(e){function n(){}var r=n.prototype,i=e.EventEmitter;function a(t,e){for(var n=t.length;n--;)if(t[n].listener===e)return n;return -1}function o(t){return function(){return this[t].apply(this,arguments)}}r.getListeners=function(t){var e,n,r=this._getEvents();if(t instanceof RegExp)for(n in e={},r)r.hasOwnProperty(n)&&t.test(n)&&(e[n]=r[n]);else e=r[t]||(r[t]=[]);return e},r.flattenListeners=function(t){var e,n=[];for(e=0;e<t.length;e+=1)n.push(t[e].listener);return n},r.getListenersAsObject=function(t){var e,n=this.getListeners(t);return n instanceof Array&&((e={})[t]=n),e||n},r.addListener=function(t,e){if(!function t(e){return "function"==typeof e||e instanceof RegExp||!(!e||"object"!=typeof e)&&t(e.listener)}(e))throw new TypeError("listener must be a function");var n,r=this.getListenersAsObject(t),i="object"==typeof e;for(n in r)r.hasOwnProperty(n)&&-1===a(r[n],e)&&r[n].push(i?e:{listener:e,once:!1});return this},r.on=o("addListener"),r.addOnceListener=function(t,e){return this.addListener(t,{listener:e,once:!0})},r.once=o("addOnceListener"),r.defineEvent=function(t){return this.getListeners(t),this},r.defineEvents=function(t){for(var e=0;e<t.length;e+=1)this.defineEvent(t[e]);return this},r.removeListener=function(t,e){var n,r,i=this.getListenersAsObject(t);for(r in i)i.hasOwnProperty(r)&&-1!==(n=a(i[r],e))&&i[r].splice(n,1);return this},r.off=o("removeListener"),r.addListeners=function(t,e){return this.manipulateListeners(!1,t,e)},r.removeListeners=function(t,e){return this.manipulateListeners(!0,t,e)},r.manipulateListeners=function(t,e,n){var r,i,a=t?this.removeListener:this.addListener,o=t?this.removeListeners:this.addListeners;if("object"!=typeof e||e instanceof RegExp)for(r=n.length;r--;)a.call(this,e,n[r]);else for(r in e)e.hasOwnProperty(r)&&(i=e[r])&&("function"==typeof i?a.call(this,r,i):o.call(this,r,i));return this},r.removeEvent=function(t){var e,n=typeof t,r=this._getEvents();if("string"===n)delete r[t];else if(t instanceof RegExp)for(e in r)r.hasOwnProperty(e)&&t.test(e)&&delete r[e];else delete this._events;return this},r.removeAllListeners=o("removeEvent"),r.emitEvent=function(t,e){var n,r,i,a,o=this.getListenersAsObject(t);for(a in o)if(o.hasOwnProperty(a))for(n=o[a].slice(0),i=0;i<n.length;i++)!0===(r=n[i]).once&&this.removeListener(t,r.listener),r.listener.apply(this,e||[])===this._getOnceReturnValue()&&this.removeListener(t,r.listener);return this},r.trigger=o("emitEvent"),r.emit=function(t){var e=Array.prototype.slice.call(arguments,1);return this.emitEvent(t,e)},r.setOnceReturnValue=function(t){return this._onceReturnValue=t,this},r._getOnceReturnValue=function(){return !this.hasOwnProperty("_onceReturnValue")||this._onceReturnValue},r._getEvents=function(){return this._events||(this._events={})},n.noConflict=function(){return e.EventEmitter=i,n},t.exports?t.exports=n:e.EventEmitter=n;}("undefined"!=typeof window?window:this||{});});function i(t,e,n,r){this.x=t||0,this.y=e||0,this.z=n||0,this.w=void 0!==r?r:1;}void 0===Number.EPSILON&&(Number.EPSILON=Math.pow(2,-52)),void 0===Number.isInteger&&(Number.isInteger=function(t){return "number"==typeof t&&isFinite(t)&&Math.floor(t)===t}),void 0===Math.sign&&(Math.sign=function(t){return t<0?-1:t>0?1:+t}),"name"in Function.prototype==!1&&Object.defineProperty(Function.prototype,"name",{get:function(){return this.toString().match(/^\s*function\s*([^\(\s]*)/)[1]}}),void 0===Object.assign&&(Object.assign=function(t){var e=arguments;if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var n=Object(t),r=1;r<arguments.length;r++){var i=e[r];if(null!=i)for(var a in i)Object.prototype.hasOwnProperty.call(i,a)&&(n[a]=i[a]);}return n}),Object.assign(i.prototype,{isVector4:!0,set:function(t,e,n,r){return this.x=t,this.y=e,this.z=n,this.w=r,this},setScalar:function(t){return this.x=t,this.y=t,this.z=t,this.w=t,this},setX:function(t){return this.x=t,this},setY:function(t){return this.y=t,this},setZ:function(t){return this.z=t,this},setW:function(t){return this.w=t,this},setComponent:function(t,e){switch(t){case 0:this.x=e;break;case 1:this.y=e;break;case 2:this.z=e;break;case 3:this.w=e;break;default:throw new Error("index is out of range: "+t)}return this},getComponent:function(t){switch(t){case 0:return this.x;case 1:return this.y;case 2:return this.z;case 3:return this.w;default:throw new Error("index is out of range: "+t)}},clone:function(){return new this.constructor(this.x,this.y,this.z,this.w)},copy:function(t){return this.x=t.x,this.y=t.y,this.z=t.z,this.w=void 0!==t.w?t.w:1,this},add:function(t,e){return void 0!==e?(console.warn("THREE.Vector4: .add() now only accepts one argument. Use .addVectors( a, b ) instead."),this.addVectors(t,e)):(this.x+=t.x,this.y+=t.y,this.z+=t.z,this.w+=t.w,this)},addScalar:function(t){return this.x+=t,this.y+=t,this.z+=t,this.w+=t,this},addVectors:function(t,e){return this.x=t.x+e.x,this.y=t.y+e.y,this.z=t.z+e.z,this.w=t.w+e.w,this},addScaledVector:function(t,e){return this.x+=t.x*e,this.y+=t.y*e,this.z+=t.z*e,this.w+=t.w*e,this},sub:function(t,e){return void 0!==e?(console.warn("THREE.Vector4: .sub() now only accepts one argument. Use .subVectors( a, b ) instead."),this.subVectors(t,e)):(this.x-=t.x,this.y-=t.y,this.z-=t.z,this.w-=t.w,this)},subScalar:function(t){return this.x-=t,this.y-=t,this.z-=t,this.w-=t,this},subVectors:function(t,e){return this.x=t.x-e.x,this.y=t.y-e.y,this.z=t.z-e.z,this.w=t.w-e.w,this},multiplyScalar:function(t){return this.x*=t,this.y*=t,this.z*=t,this.w*=t,this},applyMatrix4:function(t){var e=this.x,n=this.y,r=this.z,i=this.w,a=t.elements;return this.x=a[0]*e+a[4]*n+a[8]*r+a[12]*i,this.y=a[1]*e+a[5]*n+a[9]*r+a[13]*i,this.z=a[2]*e+a[6]*n+a[10]*r+a[14]*i,this.w=a[3]*e+a[7]*n+a[11]*r+a[15]*i,this},divideScalar:function(t){return this.multiplyScalar(1/t)},setAxisAngleFromQuaternion:function(t){this.w=2*Math.acos(t.w);var e=Math.sqrt(1-t.w*t.w);return e<1e-4?(this.x=1,this.y=0,this.z=0):(this.x=t.x/e,this.y=t.y/e,this.z=t.z/e),this},setAxisAngleFromRotationMatrix:function(t){var e,n,r,i,a=t.elements,o=a[0],s=a[4],u=a[8],l=a[1],c=a[5],h=a[9],f=a[2],d=a[6],p=a[10];if(Math.abs(s-l)<.01&&Math.abs(u-f)<.01&&Math.abs(h-d)<.01){if(Math.abs(s+l)<.1&&Math.abs(u+f)<.1&&Math.abs(h+d)<.1&&Math.abs(o+c+p-3)<.1)return this.set(1,0,0,0),this;e=Math.PI;var m=(o+1)/2,g=(c+1)/2,v=(p+1)/2,y=(s+l)/4,_=(u+f)/4,x=(h+d)/4;return m>g&&m>v?m<.01?(n=0,r=.707106781,i=.707106781):(r=y/(n=Math.sqrt(m)),i=_/n):g>v?g<.01?(n=.707106781,r=0,i=.707106781):(n=y/(r=Math.sqrt(g)),i=x/r):v<.01?(n=.707106781,r=.707106781,i=0):(n=_/(i=Math.sqrt(v)),r=x/i),this.set(n,r,i,e),this}var M=Math.sqrt((d-h)*(d-h)+(u-f)*(u-f)+(l-s)*(l-s));return Math.abs(M)<.001&&(M=1),this.x=(d-h)/M,this.y=(u-f)/M,this.z=(l-s)/M,this.w=Math.acos((o+c+p-1)/2),this},min:function(t){return this.x=Math.min(this.x,t.x),this.y=Math.min(this.y,t.y),this.z=Math.min(this.z,t.z),this.w=Math.min(this.w,t.w),this},max:function(t){return this.x=Math.max(this.x,t.x),this.y=Math.max(this.y,t.y),this.z=Math.max(this.z,t.z),this.w=Math.max(this.w,t.w),this},clamp:function(t,e){return this.x=Math.max(t.x,Math.min(e.x,this.x)),this.y=Math.max(t.y,Math.min(e.y,this.y)),this.z=Math.max(t.z,Math.min(e.z,this.z)),this.w=Math.max(t.w,Math.min(e.w,this.w)),this},clampScalar:function(){var t,e;return function(n,r){return void 0===t&&(t=new i,e=new i),t.set(n,n,n,n),e.set(r,r,r,r),this.clamp(t,e)}}(),clampLength:function(t,e){var n=this.length();return this.divideScalar(n||1).multiplyScalar(Math.max(t,Math.min(e,n)))},floor:function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this.w=Math.floor(this.w),this},ceil:function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this.w=Math.ceil(this.w),this},round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this.w=Math.round(this.w),this},roundToZero:function(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this.z=this.z<0?Math.ceil(this.z):Math.floor(this.z),this.w=this.w<0?Math.ceil(this.w):Math.floor(this.w),this},negate:function(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this.w=-this.w,this},dot:function(t){return this.x*t.x+this.y*t.y+this.z*t.z+this.w*t.w},lengthSq:function(){return this.x*this.x+this.y*this.y+this.z*this.z+this.w*this.w},length:function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z+this.w*this.w)},manhattanLength:function(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)+Math.abs(this.w)},normalize:function(){return this.divideScalar(this.length()||1)},setLength:function(t){return this.normalize().multiplyScalar(t)},lerp:function(t,e){return this.x+=(t.x-this.x)*e,this.y+=(t.y-this.y)*e,this.z+=(t.z-this.z)*e,this.w+=(t.w-this.w)*e,this},lerpVectors:function(t,e,n){return this.subVectors(e,t).multiplyScalar(n).add(t)},equals:function(t){return t.x===this.x&&t.y===this.y&&t.z===this.z&&t.w===this.w},fromArray:function(t,e){return void 0===e&&(e=0),this.x=t[e],this.y=t[e+1],this.z=t[e+2],this.w=t[e+3],this},toArray:function(t,e){return void 0===t&&(t=[]),void 0===e&&(e=0),t[e]=this.x,t[e+1]=this.y,t[e+2]=this.z,t[e+3]=this.w,t},fromBufferAttribute:function(t,e,n){return void 0!==n&&console.warn("THREE.Vector4: offset has been removed from .fromBufferAttribute()."),this.x=t.getX(e),this.y=t.getY(e),this.z=t.getZ(e),this.w=t.getW(e),this}});var a,o,s,u,l,c,h,f,d={DEG2RAD:Math.PI/180,RAD2DEG:180/Math.PI,generateUUID:function(){for(var t=[],e=0;e<256;e++)t[e]=(e<16?"0":"")+e.toString(16);return function(){var e=4294967295*Math.random()|0,n=4294967295*Math.random()|0,r=4294967295*Math.random()|0,i=4294967295*Math.random()|0;return (t[255&e]+t[e>>8&255]+t[e>>16&255]+t[e>>24&255]+"-"+t[255&n]+t[n>>8&255]+"-"+t[n>>16&15|64]+t[n>>24&255]+"-"+t[63&r|128]+t[r>>8&255]+"-"+t[r>>16&255]+t[r>>24&255]+t[255&i]+t[i>>8&255]+t[i>>16&255]+t[i>>24&255]).toUpperCase()}}(),clamp:function(t,e,n){return Math.max(e,Math.min(n,t))},euclideanModulo:function(t,e){return (t%e+e)%e},mapLinear:function(t,e,n,r,i){return r+(t-e)*(i-r)/(n-e)},lerp:function(t,e,n){return (1-n)*t+n*e},smoothstep:function(t,e,n){return t<=e?0:t>=n?1:(t=(t-e)/(n-e))*t*(3-2*t)},smootherstep:function(t,e,n){return t<=e?0:t>=n?1:(t=(t-e)/(n-e))*t*t*(t*(6*t-15)+10)},randInt:function(t,e){return t+Math.floor(Math.random()*(e-t+1))},randFloat:function(t,e){return t+Math.random()*(e-t)},randFloatSpread:function(t){return t*(.5-Math.random())},degToRad:function(t){return t*d.DEG2RAD},radToDeg:function(t){return t*d.RAD2DEG},isPowerOfTwo:function(t){return 0==(t&t-1)&&0!==t},ceilPowerOfTwo:function(t){return Math.pow(2,Math.ceil(Math.log(t)/Math.LN2))},floorPowerOfTwo:function(t){return Math.pow(2,Math.floor(Math.log(t)/Math.LN2))}};function p(){this.elements=[1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1],arguments.length>0&&console.error("THREE.Matrix4: the constructor no longer reads arguments. use .set() instead.");}function m(t,e,n,r){this._x=t||0,this._y=e||0,this._z=n||0,this._w=void 0!==r?r:1;}function g(t,e,n){this.x=t||0,this.y=e||0,this.z=n||0;}function v(t,e){this.x=t||0,this.y=e||0;}Object.assign(p.prototype,{isMatrix4:!0,set:function(t,e,n,r,i,a,o,s,u,l,c,h,f,d,p,m){var g=this.elements;return g[0]=t,g[4]=e,g[8]=n,g[12]=r,g[1]=i,g[5]=a,g[9]=o,g[13]=s,g[2]=u,g[6]=l,g[10]=c,g[14]=h,g[3]=f,g[7]=d,g[11]=p,g[15]=m,this},identity:function(){return this.set(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1),this},clone:function(){return (new p).fromArray(this.elements)},copy:function(t){var e=this.elements,n=t.elements;return e[0]=n[0],e[1]=n[1],e[2]=n[2],e[3]=n[3],e[4]=n[4],e[5]=n[5],e[6]=n[6],e[7]=n[7],e[8]=n[8],e[9]=n[9],e[10]=n[10],e[11]=n[11],e[12]=n[12],e[13]=n[13],e[14]=n[14],e[15]=n[15],this},copyPosition:function(t){var e=this.elements,n=t.elements;return e[12]=n[12],e[13]=n[13],e[14]=n[14],this},extractBasis:function(t,e,n){return t.setFromMatrixColumn(this,0),e.setFromMatrixColumn(this,1),n.setFromMatrixColumn(this,2),this},makeBasis:function(t,e,n){return this.set(t.x,e.x,n.x,0,t.y,e.y,n.y,0,t.z,e.z,n.z,0,0,0,0,1),this},extractRotation:(c=new g,function(t){var e=this.elements,n=t.elements,r=1/c.setFromMatrixColumn(t,0).length(),i=1/c.setFromMatrixColumn(t,1).length(),a=1/c.setFromMatrixColumn(t,2).length();return e[0]=n[0]*r,e[1]=n[1]*r,e[2]=n[2]*r,e[3]=0,e[4]=n[4]*i,e[5]=n[5]*i,e[6]=n[6]*i,e[7]=0,e[8]=n[8]*a,e[9]=n[9]*a,e[10]=n[10]*a,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,this}),makeRotationFromEuler:function(t){t&&t.isEuler||console.error("THREE.Matrix4: .makeRotationFromEuler() now expects a Euler rotation rather than a Vector3 and order.");var e=this.elements,n=t.x,r=t.y,i=t.z,a=Math.cos(n),o=Math.sin(n),s=Math.cos(r),u=Math.sin(r),l=Math.cos(i),c=Math.sin(i);if("XYZ"===t.order){var h=a*l,f=a*c,d=o*l,p=o*c;e[0]=s*l,e[4]=-s*c,e[8]=u,e[1]=f+d*u,e[5]=h-p*u,e[9]=-o*s,e[2]=p-h*u,e[6]=d+f*u,e[10]=a*s;}else if("YXZ"===t.order){var m=s*l,g=s*c,v=u*l,y=u*c;e[0]=m+y*o,e[4]=v*o-g,e[8]=a*u,e[1]=a*c,e[5]=a*l,e[9]=-o,e[2]=g*o-v,e[6]=y+m*o,e[10]=a*s;}else if("ZXY"===t.order){m=s*l,g=s*c,v=u*l,y=u*c;e[0]=m-y*o,e[4]=-a*c,e[8]=v+g*o,e[1]=g+v*o,e[5]=a*l,e[9]=y-m*o,e[2]=-a*u,e[6]=o,e[10]=a*s;}else if("ZYX"===t.order){h=a*l,f=a*c,d=o*l,p=o*c;e[0]=s*l,e[4]=d*u-f,e[8]=h*u+p,e[1]=s*c,e[5]=p*u+h,e[9]=f*u-d,e[2]=-u,e[6]=o*s,e[10]=a*s;}else if("YZX"===t.order){var _=a*s,x=a*u,M=o*s,b=o*u;e[0]=s*l,e[4]=b-_*c,e[8]=M*c+x,e[1]=c,e[5]=a*l,e[9]=-o*l,e[2]=-u*l,e[6]=x*c+M,e[10]=_-b*c;}else if("XZY"===t.order){_=a*s,x=a*u,M=o*s,b=o*u;e[0]=s*l,e[4]=-c,e[8]=u*l,e[1]=_*c+b,e[5]=a*l,e[9]=x*c-M,e[2]=M*c-x,e[6]=o*l,e[10]=b*c+_;}return e[3]=0,e[7]=0,e[11]=0,e[12]=0,e[13]=0,e[14]=0,e[15]=1,this},makeRotationFromQuaternion:(u=new g(0,0,0),l=new g(1,1,1),function(t){return this.compose(u,t,l)}),lookAt:(a=new g,o=new g,s=new g,function(t,e,n){var r=this.elements;return s.subVectors(t,e),0===s.lengthSq()&&(s.z=1),s.normalize(),a.crossVectors(n,s),0===a.lengthSq()&&(1===Math.abs(n.z)?s.x+=1e-4:s.z+=1e-4,s.normalize(),a.crossVectors(n,s)),a.normalize(),o.crossVectors(s,a),r[0]=a.x,r[4]=o.x,r[8]=s.x,r[1]=a.y,r[5]=o.y,r[9]=s.y,r[2]=a.z,r[6]=o.z,r[10]=s.z,this}),multiply:function(t,e){return void 0!==e?(console.warn("THREE.Matrix4: .multiply() now only accepts one argument. Use .multiplyMatrices( a, b ) instead."),this.multiplyMatrices(t,e)):this.multiplyMatrices(this,t)},premultiply:function(t){return this.multiplyMatrices(t,this)},multiplyMatrices:function(t,e){var n=t.elements,r=e.elements,i=this.elements,a=n[0],o=n[4],s=n[8],u=n[12],l=n[1],c=n[5],h=n[9],f=n[13],d=n[2],p=n[6],m=n[10],g=n[14],v=n[3],y=n[7],_=n[11],x=n[15],M=r[0],b=r[4],w=r[8],E=r[12],S=r[1],T=r[5],A=r[9],L=r[13],C=r[2],P=r[6],R=r[10],F=r[14],D=r[3],I=r[7],N=r[11],O=r[15];return i[0]=a*M+o*S+s*C+u*D,i[4]=a*b+o*T+s*P+u*I,i[8]=a*w+o*A+s*R+u*N,i[12]=a*E+o*L+s*F+u*O,i[1]=l*M+c*S+h*C+f*D,i[5]=l*b+c*T+h*P+f*I,i[9]=l*w+c*A+h*R+f*N,i[13]=l*E+c*L+h*F+f*O,i[2]=d*M+p*S+m*C+g*D,i[6]=d*b+p*T+m*P+g*I,i[10]=d*w+p*A+m*R+g*N,i[14]=d*E+p*L+m*F+g*O,i[3]=v*M+y*S+_*C+x*D,i[7]=v*b+y*T+_*P+x*I,i[11]=v*w+y*A+_*R+x*N,i[15]=v*E+y*L+_*F+x*O,this},multiplyScalar:function(t){var e=this.elements;return e[0]*=t,e[4]*=t,e[8]*=t,e[12]*=t,e[1]*=t,e[5]*=t,e[9]*=t,e[13]*=t,e[2]*=t,e[6]*=t,e[10]*=t,e[14]*=t,e[3]*=t,e[7]*=t,e[11]*=t,e[15]*=t,this},applyToBufferAttribute:function(){var t=new g;return function(e){for(var n=0,r=e.count;n<r;n++)t.x=e.getX(n),t.y=e.getY(n),t.z=e.getZ(n),t.applyMatrix4(this),e.setXYZ(n,t.x,t.y,t.z);return e}}(),determinant:function(){var t=this.elements,e=t[0],n=t[4],r=t[8],i=t[12],a=t[1],o=t[5],s=t[9],u=t[13],l=t[2],c=t[6],h=t[10],f=t[14];return t[3]*(+i*s*c-r*u*c-i*o*h+n*u*h+r*o*f-n*s*f)+t[7]*(+e*s*f-e*u*h+i*a*h-r*a*f+r*u*l-i*s*l)+t[11]*(+e*u*c-e*o*f-i*a*c+n*a*f+i*o*l-n*u*l)+t[15]*(-r*o*l-e*s*c+e*o*h+r*a*c-n*a*h+n*s*l)},transpose:function(){var t,e=this.elements;return t=e[1],e[1]=e[4],e[4]=t,t=e[2],e[2]=e[8],e[8]=t,t=e[6],e[6]=e[9],e[9]=t,t=e[3],e[3]=e[12],e[12]=t,t=e[7],e[7]=e[13],e[13]=t,t=e[11],e[11]=e[14],e[14]=t,this},setPosition:function(t){var e=this.elements;return e[12]=t.x,e[13]=t.y,e[14]=t.z,this},getInverse:function(t,e){var n=this.elements,r=t.elements,i=r[0],a=r[1],o=r[2],s=r[3],u=r[4],l=r[5],c=r[6],h=r[7],f=r[8],d=r[9],p=r[10],m=r[11],g=r[12],v=r[13],y=r[14],_=r[15],x=d*y*h-v*p*h+v*c*m-l*y*m-d*c*_+l*p*_,M=g*p*h-f*y*h-g*c*m+u*y*m+f*c*_-u*p*_,b=f*v*h-g*d*h+g*l*m-u*v*m-f*l*_+u*d*_,w=g*d*c-f*v*c-g*l*p+u*v*p+f*l*y-u*d*y,E=i*x+a*M+o*b+s*w;if(0===E){var S="THREE.Matrix4: .getInverse() can't invert matrix, determinant is 0";if(!0===e)throw new Error(S);return console.warn(S),this.identity()}var T=1/E;return n[0]=x*T,n[1]=(v*p*s-d*y*s-v*o*m+a*y*m+d*o*_-a*p*_)*T,n[2]=(l*y*s-v*c*s+v*o*h-a*y*h-l*o*_+a*c*_)*T,n[3]=(d*c*s-l*p*s-d*o*h+a*p*h+l*o*m-a*c*m)*T,n[4]=M*T,n[5]=(f*y*s-g*p*s+g*o*m-i*y*m-f*o*_+i*p*_)*T,n[6]=(g*c*s-u*y*s-g*o*h+i*y*h+u*o*_-i*c*_)*T,n[7]=(u*p*s-f*c*s+f*o*h-i*p*h-u*o*m+i*c*m)*T,n[8]=b*T,n[9]=(g*d*s-f*v*s-g*a*m+i*v*m+f*a*_-i*d*_)*T,n[10]=(u*v*s-g*l*s+g*a*h-i*v*h-u*a*_+i*l*_)*T,n[11]=(f*l*s-u*d*s-f*a*h+i*d*h+u*a*m-i*l*m)*T,n[12]=w*T,n[13]=(f*v*o-g*d*o+g*a*p-i*v*p-f*a*y+i*d*y)*T,n[14]=(g*l*o-u*v*o-g*a*c+i*v*c+u*a*y-i*l*y)*T,n[15]=(u*d*o-f*l*o+f*a*c-i*d*c-u*a*p+i*l*p)*T,this},scale:function(t){var e=this.elements,n=t.x,r=t.y,i=t.z;return e[0]*=n,e[4]*=r,e[8]*=i,e[1]*=n,e[5]*=r,e[9]*=i,e[2]*=n,e[6]*=r,e[10]*=i,e[3]*=n,e[7]*=r,e[11]*=i,this},getMaxScaleOnAxis:function(){var t=this.elements,e=t[0]*t[0]+t[1]*t[1]+t[2]*t[2],n=t[4]*t[4]+t[5]*t[5]+t[6]*t[6],r=t[8]*t[8]+t[9]*t[9]+t[10]*t[10];return Math.sqrt(Math.max(e,n,r))},makeTranslation:function(t,e,n){return this.set(1,0,0,t,0,1,0,e,0,0,1,n,0,0,0,1),this},makeRotationX:function(t){var e=Math.cos(t),n=Math.sin(t);return this.set(1,0,0,0,0,e,-n,0,0,n,e,0,0,0,0,1),this},makeRotationY:function(t){var e=Math.cos(t),n=Math.sin(t);return this.set(e,0,n,0,0,1,0,0,-n,0,e,0,0,0,0,1),this},makeRotationZ:function(t){var e=Math.cos(t),n=Math.sin(t);return this.set(e,-n,0,0,n,e,0,0,0,0,1,0,0,0,0,1),this},makeRotationAxis:function(t,e){var n=Math.cos(e),r=Math.sin(e),i=1-n,a=t.x,o=t.y,s=t.z,u=i*a,l=i*o;return this.set(u*a+n,u*o-r*s,u*s+r*o,0,u*o+r*s,l*o+n,l*s-r*a,0,u*s-r*o,l*s+r*a,i*s*s+n,0,0,0,0,1),this},makeScale:function(t,e,n){return this.set(t,0,0,0,0,e,0,0,0,0,n,0,0,0,0,1),this},makeShear:function(t,e,n){return this.set(1,e,n,0,t,1,n,0,t,e,1,0,0,0,0,1),this},compose:function(t,e,n){var r=this.elements,i=e._x,a=e._y,o=e._z,s=e._w,u=i+i,l=a+a,c=o+o,h=i*u,f=i*l,d=i*c,p=a*l,m=a*c,g=o*c,v=s*u,y=s*l,_=s*c,x=n.x,M=n.y,b=n.z;return r[0]=(1-(p+g))*x,r[1]=(f+_)*x,r[2]=(d-y)*x,r[3]=0,r[4]=(f-_)*M,r[5]=(1-(h+g))*M,r[6]=(m+v)*M,r[7]=0,r[8]=(d+y)*b,r[9]=(m-v)*b,r[10]=(1-(h+p))*b,r[11]=0,r[12]=t.x,r[13]=t.y,r[14]=t.z,r[15]=1,this},decompose:function(){var t=new g,e=new p;return function(n,r,i){var a=this.elements,o=t.set(a[0],a[1],a[2]).length(),s=t.set(a[4],a[5],a[6]).length(),u=t.set(a[8],a[9],a[10]).length();this.determinant()<0&&(o=-o),n.x=a[12],n.y=a[13],n.z=a[14],e.copy(this);var l=1/o,c=1/s,h=1/u;return e.elements[0]*=l,e.elements[1]*=l,e.elements[2]*=l,e.elements[4]*=c,e.elements[5]*=c,e.elements[6]*=c,e.elements[8]*=h,e.elements[9]*=h,e.elements[10]*=h,r.setFromRotationMatrix(e),i.x=o,i.y=s,i.z=u,this}}(),makePerspective:function(t,e,n,r,i,a){void 0===a&&console.warn("THREE.Matrix4: .makePerspective() has been redefined and has a new signature. Please check the docs.");var o=this.elements,s=2*i/(e-t),u=2*i/(n-r),l=(e+t)/(e-t),c=(n+r)/(n-r),h=-(a+i)/(a-i),f=-2*a*i/(a-i);return o[0]=s,o[4]=0,o[8]=l,o[12]=0,o[1]=0,o[5]=u,o[9]=c,o[13]=0,o[2]=0,o[6]=0,o[10]=h,o[14]=f,o[3]=0,o[7]=0,o[11]=-1,o[15]=0,this},makeOrthographic:function(t,e,n,r,i,a){var o=this.elements,s=1/(e-t),u=1/(n-r),l=1/(a-i),c=(e+t)*s,h=(n+r)*u,f=(a+i)*l;return o[0]=2*s,o[4]=0,o[8]=0,o[12]=-c,o[1]=0,o[5]=2*u,o[9]=0,o[13]=-h,o[2]=0,o[6]=0,o[10]=-2*l,o[14]=-f,o[3]=0,o[7]=0,o[11]=0,o[15]=1,this},equals:function(t){for(var e=this.elements,n=t.elements,r=0;r<16;r++)if(e[r]!==n[r])return !1;return !0},fromArray:function(t,e){void 0===e&&(e=0);for(var n=0;n<16;n++)this.elements[n]=t[n+e];return this},toArray:function(t,e){void 0===t&&(t=[]),void 0===e&&(e=0);var n=this.elements;return t[e]=n[0],t[e+1]=n[1],t[e+2]=n[2],t[e+3]=n[3],t[e+4]=n[4],t[e+5]=n[5],t[e+6]=n[6],t[e+7]=n[7],t[e+8]=n[8],t[e+9]=n[9],t[e+10]=n[10],t[e+11]=n[11],t[e+12]=n[12],t[e+13]=n[13],t[e+14]=n[14],t[e+15]=n[15],t}}),Object.assign(m,{slerp:function(t,e,n,r){return n.copy(t).slerp(e,r)},slerpFlat:function(t,e,n,r,i,a,o){var s=n[r+0],u=n[r+1],l=n[r+2],c=n[r+3],h=i[a+0],f=i[a+1],d=i[a+2],p=i[a+3];if(c!==p||s!==h||u!==f||l!==d){var m=1-o,g=s*h+u*f+l*d+c*p,v=g>=0?1:-1,y=1-g*g;if(y>Number.EPSILON){var _=Math.sqrt(y),x=Math.atan2(_,g*v);m=Math.sin(m*x)/_,o=Math.sin(o*x)/_;}var M=o*v;if(s=s*m+h*M,u=u*m+f*M,l=l*m+d*M,c=c*m+p*M,m===1-o){var b=1/Math.sqrt(s*s+u*u+l*l+c*c);s*=b,u*=b,l*=b,c*=b;}}t[e]=s,t[e+1]=u,t[e+2]=l,t[e+3]=c;}}),Object.defineProperties(m.prototype,{x:{get:function(){return this._x},set:function(t){this._x=t,this.onChangeCallback();}},y:{get:function(){return this._y},set:function(t){this._y=t,this.onChangeCallback();}},z:{get:function(){return this._z},set:function(t){this._z=t,this.onChangeCallback();}},w:{get:function(){return this._w},set:function(t){this._w=t,this.onChangeCallback();}}}),Object.assign(m.prototype,{isQuaternion:!0,set:function(t,e,n,r){return this._x=t,this._y=e,this._z=n,this._w=r,this.onChangeCallback(),this},clone:function(){return new this.constructor(this._x,this._y,this._z,this._w)},copy:function(t){return this._x=t.x,this._y=t.y,this._z=t.z,this._w=t.w,this.onChangeCallback(),this},setFromEuler:function(t,e){if(!t||!t.isEuler)throw new Error("THREE.Quaternion: .setFromEuler() now expects an Euler rotation rather than a Vector3 and order.");var n=t._x,r=t._y,i=t._z,a=t.order,o=Math.cos,s=Math.sin,u=o(n/2),l=o(r/2),c=o(i/2),h=s(n/2),f=s(r/2),d=s(i/2);return "XYZ"===a?(this._x=h*l*c+u*f*d,this._y=u*f*c-h*l*d,this._z=u*l*d+h*f*c,this._w=u*l*c-h*f*d):"YXZ"===a?(this._x=h*l*c+u*f*d,this._y=u*f*c-h*l*d,this._z=u*l*d-h*f*c,this._w=u*l*c+h*f*d):"ZXY"===a?(this._x=h*l*c-u*f*d,this._y=u*f*c+h*l*d,this._z=u*l*d+h*f*c,this._w=u*l*c-h*f*d):"ZYX"===a?(this._x=h*l*c-u*f*d,this._y=u*f*c+h*l*d,this._z=u*l*d-h*f*c,this._w=u*l*c+h*f*d):"YZX"===a?(this._x=h*l*c+u*f*d,this._y=u*f*c+h*l*d,this._z=u*l*d-h*f*c,this._w=u*l*c-h*f*d):"XZY"===a&&(this._x=h*l*c-u*f*d,this._y=u*f*c-h*l*d,this._z=u*l*d+h*f*c,this._w=u*l*c+h*f*d),!1!==e&&this.onChangeCallback(),this},setFromAxisAngle:function(t,e){var n=e/2,r=Math.sin(n);return this._x=t.x*r,this._y=t.y*r,this._z=t.z*r,this._w=Math.cos(n),this.onChangeCallback(),this},setFromRotationMatrix:function(t){var e,n=t.elements,r=n[0],i=n[4],a=n[8],o=n[1],s=n[5],u=n[9],l=n[2],c=n[6],h=n[10],f=r+s+h;return f>0?(e=.5/Math.sqrt(f+1),this._w=.25/e,this._x=(c-u)*e,this._y=(a-l)*e,this._z=(o-i)*e):r>s&&r>h?(e=2*Math.sqrt(1+r-s-h),this._w=(c-u)/e,this._x=.25*e,this._y=(i+o)/e,this._z=(a+l)/e):s>h?(e=2*Math.sqrt(1+s-r-h),this._w=(a-l)/e,this._x=(i+o)/e,this._y=.25*e,this._z=(u+c)/e):(e=2*Math.sqrt(1+h-r-s),this._w=(o-i)/e,this._x=(a+l)/e,this._y=(u+c)/e,this._z=.25*e),this.onChangeCallback(),this},setFromUnitVectors:function(){var t,e=new g;return function(n,r){return void 0===e&&(e=new g),(t=n.dot(r)+1)<1e-6?(t=0,Math.abs(n.x)>Math.abs(n.z)?e.set(-n.y,n.x,0):e.set(0,-n.z,n.y)):e.crossVectors(n,r),this._x=e.x,this._y=e.y,this._z=e.z,this._w=t,this.normalize()}}(),angleTo:function(t){return 2*Math.acos(Math.abs(d.clamp(this.dot(t),-1,1)))},rotateTowards:function(t,e){var n=this.angleTo(t);if(0===n)return this;var r=Math.min(1,e/n);return this.slerp(t,r),this},inverse:function(){return this.conjugate()},conjugate:function(){return this._x*=-1,this._y*=-1,this._z*=-1,this.onChangeCallback(),this},dot:function(t){return this._x*t._x+this._y*t._y+this._z*t._z+this._w*t._w},lengthSq:function(){return this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w},length:function(){return Math.sqrt(this._x*this._x+this._y*this._y+this._z*this._z+this._w*this._w)},normalize:function(){var t=this.length();return 0===t?(this._x=0,this._y=0,this._z=0,this._w=1):(t=1/t,this._x=this._x*t,this._y=this._y*t,this._z=this._z*t,this._w=this._w*t),this.onChangeCallback(),this},multiply:function(t,e){return void 0!==e?(console.warn("THREE.Quaternion: .multiply() now only accepts one argument. Use .multiplyQuaternions( a, b ) instead."),this.multiplyQuaternions(t,e)):this.multiplyQuaternions(this,t)},premultiply:function(t){return this.multiplyQuaternions(t,this)},multiplyQuaternions:function(t,e){var n=t._x,r=t._y,i=t._z,a=t._w,o=e._x,s=e._y,u=e._z,l=e._w;return this._x=n*l+a*o+r*u-i*s,this._y=r*l+a*s+i*o-n*u,this._z=i*l+a*u+n*s-r*o,this._w=a*l-n*o-r*s-i*u,this.onChangeCallback(),this},slerp:function(t,e){if(0===e)return this;if(1===e)return this.copy(t);var n=this._x,r=this._y,i=this._z,a=this._w,o=a*t._w+n*t._x+r*t._y+i*t._z;if(o<0?(this._w=-t._w,this._x=-t._x,this._y=-t._y,this._z=-t._z,o=-o):this.copy(t),o>=1)return this._w=a,this._x=n,this._y=r,this._z=i,this;var s=1-o*o;if(s<=Number.EPSILON){var u=1-e;return this._w=u*a+e*this._w,this._x=u*n+e*this._x,this._y=u*r+e*this._y,this._z=u*i+e*this._z,this.normalize()}var l=Math.sqrt(s),c=Math.atan2(l,o),h=Math.sin((1-e)*c)/l,f=Math.sin(e*c)/l;return this._w=a*h+this._w*f,this._x=n*h+this._x*f,this._y=r*h+this._y*f,this._z=i*h+this._z*f,this.onChangeCallback(),this},equals:function(t){return t._x===this._x&&t._y===this._y&&t._z===this._z&&t._w===this._w},fromArray:function(t,e){return void 0===e&&(e=0),this._x=t[e],this._y=t[e+1],this._z=t[e+2],this._w=t[e+3],this.onChangeCallback(),this},toArray:function(t,e){return void 0===t&&(t=[]),void 0===e&&(e=0),t[e]=this._x,t[e+1]=this._y,t[e+2]=this._z,t[e+3]=this._w,t},onChange:function(t){return this.onChangeCallback=t,this},onChangeCallback:function(){}}),Object.assign(g.prototype,{isVector3:!0,set:function(t,e,n){return this.x=t,this.y=e,this.z=n,this},setScalar:function(t){return this.x=t,this.y=t,this.z=t,this},setX:function(t){return this.x=t,this},setY:function(t){return this.y=t,this},setZ:function(t){return this.z=t,this},setComponent:function(t,e){switch(t){case 0:this.x=e;break;case 1:this.y=e;break;case 2:this.z=e;break;default:throw new Error("index is out of range: "+t)}return this},getComponent:function(t){switch(t){case 0:return this.x;case 1:return this.y;case 2:return this.z;default:throw new Error("index is out of range: "+t)}},clone:function(){return new this.constructor(this.x,this.y,this.z)},copy:function(t){return this.x=t.x,this.y=t.y,this.z=t.z,this},add:function(t,e){return void 0!==e?(console.warn("THREE.Vector3: .add() now only accepts one argument. Use .addVectors( a, b ) instead."),this.addVectors(t,e)):(this.x+=t.x,this.y+=t.y,this.z+=t.z,this)},addScalar:function(t){return this.x+=t,this.y+=t,this.z+=t,this},addVectors:function(t,e){return this.x=t.x+e.x,this.y=t.y+e.y,this.z=t.z+e.z,this},addScaledVector:function(t,e){return this.x+=t.x*e,this.y+=t.y*e,this.z+=t.z*e,this},sub:function(t,e){return void 0!==e?(console.warn("THREE.Vector3: .sub() now only accepts one argument. Use .subVectors( a, b ) instead."),this.subVectors(t,e)):(this.x-=t.x,this.y-=t.y,this.z-=t.z,this)},subScalar:function(t){return this.x-=t,this.y-=t,this.z-=t,this},subVectors:function(t,e){return this.x=t.x-e.x,this.y=t.y-e.y,this.z=t.z-e.z,this},multiply:function(t,e){return void 0!==e?(console.warn("THREE.Vector3: .multiply() now only accepts one argument. Use .multiplyVectors( a, b ) instead."),this.multiplyVectors(t,e)):(this.x*=t.x,this.y*=t.y,this.z*=t.z,this)},multiplyScalar:function(t){return this.x*=t,this.y*=t,this.z*=t,this},multiplyVectors:function(t,e){return this.x=t.x*e.x,this.y=t.y*e.y,this.z=t.z*e.z,this},applyEuler:(f=new m,function(t){return t&&t.isEuler||console.error("THREE.Vector3: .applyEuler() now expects an Euler rotation rather than a Vector3 and order."),this.applyQuaternion(f.setFromEuler(t))}),applyAxisAngle:function(){var t=new m;return function(e,n){return this.applyQuaternion(t.setFromAxisAngle(e,n))}}(),applyMatrix3:function(t){var e=this.x,n=this.y,r=this.z,i=t.elements;return this.x=i[0]*e+i[3]*n+i[6]*r,this.y=i[1]*e+i[4]*n+i[7]*r,this.z=i[2]*e+i[5]*n+i[8]*r,this},applyMatrix4:function(t){var e=this.x,n=this.y,r=this.z,i=t.elements,a=1/(i[3]*e+i[7]*n+i[11]*r+i[15]);return this.x=(i[0]*e+i[4]*n+i[8]*r+i[12])*a,this.y=(i[1]*e+i[5]*n+i[9]*r+i[13])*a,this.z=(i[2]*e+i[6]*n+i[10]*r+i[14])*a,this},applyQuaternion:function(t){var e=this.x,n=this.y,r=this.z,i=t.x,a=t.y,o=t.z,s=t.w,u=s*e+a*r-o*n,l=s*n+o*e-i*r,c=s*r+i*n-a*e,h=-i*e-a*n-o*r;return this.x=u*s+h*-i+l*-o-c*-a,this.y=l*s+h*-a+c*-i-u*-o,this.z=c*s+h*-o+u*-a-l*-i,this},project:function(t){return this.applyMatrix4(t.matrixWorldInverse).applyMatrix4(t.projectionMatrix)},unproject:(h=new p,function(t){return this.applyMatrix4(h.getInverse(t.projectionMatrix)).applyMatrix4(t.matrixWorld)}),transformDirection:function(t){var e=this.x,n=this.y,r=this.z,i=t.elements;return this.x=i[0]*e+i[4]*n+i[8]*r,this.y=i[1]*e+i[5]*n+i[9]*r,this.z=i[2]*e+i[6]*n+i[10]*r,this.normalize()},divide:function(t){return this.x/=t.x,this.y/=t.y,this.z/=t.z,this},divideScalar:function(t){return this.multiplyScalar(1/t)},min:function(t){return this.x=Math.min(this.x,t.x),this.y=Math.min(this.y,t.y),this.z=Math.min(this.z,t.z),this},max:function(t){return this.x=Math.max(this.x,t.x),this.y=Math.max(this.y,t.y),this.z=Math.max(this.z,t.z),this},clamp:function(t,e){return this.x=Math.max(t.x,Math.min(e.x,this.x)),this.y=Math.max(t.y,Math.min(e.y,this.y)),this.z=Math.max(t.z,Math.min(e.z,this.z)),this},clampScalar:function(){var t=new g,e=new g;return function(n,r){return t.set(n,n,n),e.set(r,r,r),this.clamp(t,e)}}(),clampLength:function(t,e){var n=this.length();return this.divideScalar(n||1).multiplyScalar(Math.max(t,Math.min(e,n)))},floor:function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this.z=Math.floor(this.z),this},ceil:function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this.z=Math.ceil(this.z),this},round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this.z=Math.round(this.z),this},roundToZero:function(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this.z=this.z<0?Math.ceil(this.z):Math.floor(this.z),this},negate:function(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},dot:function(t){return this.x*t.x+this.y*t.y+this.z*t.z},lengthSq:function(){return this.x*this.x+this.y*this.y+this.z*this.z},length:function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},manhattanLength:function(){return Math.abs(this.x)+Math.abs(this.y)+Math.abs(this.z)},normalize:function(){return this.divideScalar(this.length()||1)},setLength:function(t){return this.normalize().multiplyScalar(t)},lerp:function(t,e){return this.x+=(t.x-this.x)*e,this.y+=(t.y-this.y)*e,this.z+=(t.z-this.z)*e,this},lerpVectors:function(t,e,n){return this.subVectors(e,t).multiplyScalar(n).add(t)},cross:function(t,e){return void 0!==e?(console.warn("THREE.Vector3: .cross() now only accepts one argument. Use .crossVectors( a, b ) instead."),this.crossVectors(t,e)):this.crossVectors(this,t)},crossVectors:function(t,e){var n=t.x,r=t.y,i=t.z,a=e.x,o=e.y,s=e.z;return this.x=r*s-i*o,this.y=i*a-n*s,this.z=n*o-r*a,this},projectOnVector:function(t){var e=t.dot(this)/t.lengthSq();return this.copy(t).multiplyScalar(e)},projectOnPlane:function(){var t=new g;return function(e){return t.copy(this).projectOnVector(e),this.sub(t)}}(),reflect:function(){var t=new g;return function(e){return this.sub(t.copy(e).multiplyScalar(2*this.dot(e)))}}(),angleTo:function(t){var e=this.dot(t)/Math.sqrt(this.lengthSq()*t.lengthSq());return Math.acos(d.clamp(e,-1,1))},distanceTo:function(t){return Math.sqrt(this.distanceToSquared(t))},distanceToSquared:function(t){var e=this.x-t.x,n=this.y-t.y,r=this.z-t.z;return e*e+n*n+r*r},manhattanDistanceTo:function(t){return Math.abs(this.x-t.x)+Math.abs(this.y-t.y)+Math.abs(this.z-t.z)},setFromSpherical:function(t){return this.setFromSphericalCoords(t.radius,t.phi,t.theta)},setFromSphericalCoords:function(t,e,n){var r=Math.sin(e)*t;return this.x=r*Math.sin(n),this.y=Math.cos(e)*t,this.z=r*Math.cos(n),this},setFromCylindrical:function(t){return this.setFromCylindricalCoords(t.radius,t.theta,t.y)},setFromCylindricalCoords:function(t,e,n){return this.x=t*Math.sin(e),this.y=n,this.z=t*Math.cos(e),this},setFromMatrixPosition:function(t){var e=t.elements;return this.x=e[12],this.y=e[13],this.z=e[14],this},setFromMatrixScale:function(t){var e=this.setFromMatrixColumn(t,0).length(),n=this.setFromMatrixColumn(t,1).length(),r=this.setFromMatrixColumn(t,2).length();return this.x=e,this.y=n,this.z=r,this},setFromMatrixColumn:function(t,e){return this.fromArray(t.elements,4*e)},equals:function(t){return t.x===this.x&&t.y===this.y&&t.z===this.z},fromArray:function(t,e){return void 0===e&&(e=0),this.x=t[e],this.y=t[e+1],this.z=t[e+2],this},toArray:function(t,e){return void 0===t&&(t=[]),void 0===e&&(e=0),t[e]=this.x,t[e+1]=this.y,t[e+2]=this.z,t},fromBufferAttribute:function(t,e,n){return void 0!==n&&console.warn("THREE.Vector3: offset has been removed from .fromBufferAttribute()."),this.x=t.getX(e),this.y=t.getY(e),this.z=t.getZ(e),this}}),Object.defineProperties(v.prototype,{width:{get:function(){return this.x},set:function(t){this.x=t;}},height:{get:function(){return this.y},set:function(t){this.y=t;}}}),Object.assign(v.prototype,{isVector2:!0,set:function(t,e){return this.x=t,this.y=e,this},setScalar:function(t){return this.x=t,this.y=t,this},setX:function(t){return this.x=t,this},setY:function(t){return this.y=t,this},setComponent:function(t,e){switch(t){case 0:this.x=e;break;case 1:this.y=e;break;default:throw new Error("index is out of range: "+t)}return this},getComponent:function(t){switch(t){case 0:return this.x;case 1:return this.y;default:throw new Error("index is out of range: "+t)}},clone:function(){return new this.constructor(this.x,this.y)},copy:function(t){return this.x=t.x,this.y=t.y,this},add:function(t,e){return void 0!==e?(console.warn("THREE.Vector2: .add() now only accepts one argument. Use .addVectors( a, b ) instead."),this.addVectors(t,e)):(this.x+=t.x,this.y+=t.y,this)},addScalar:function(t){return this.x+=t,this.y+=t,this},addVectors:function(t,e){return this.x=t.x+e.x,this.y=t.y+e.y,this},addScaledVector:function(t,e){return this.x+=t.x*e,this.y+=t.y*e,this},sub:function(t,e){return void 0!==e?(console.warn("THREE.Vector2: .sub() now only accepts one argument. Use .subVectors( a, b ) instead."),this.subVectors(t,e)):(this.x-=t.x,this.y-=t.y,this)},subScalar:function(t){return this.x-=t,this.y-=t,this},subVectors:function(t,e){return this.x=t.x-e.x,this.y=t.y-e.y,this},multiply:function(t){return this.x*=t.x,this.y*=t.y,this},multiplyScalar:function(t){return this.x*=t,this.y*=t,this},divide:function(t){return this.x/=t.x,this.y/=t.y,this},divideScalar:function(t){return this.multiplyScalar(1/t)},applyMatrix3:function(t){var e=this.x,n=this.y,r=t.elements;return this.x=r[0]*e+r[3]*n+r[6],this.y=r[1]*e+r[4]*n+r[7],this},min:function(t){return this.x=Math.min(this.x,t.x),this.y=Math.min(this.y,t.y),this},max:function(t){return this.x=Math.max(this.x,t.x),this.y=Math.max(this.y,t.y),this},clamp:function(t,e){return this.x=Math.max(t.x,Math.min(e.x,this.x)),this.y=Math.max(t.y,Math.min(e.y,this.y)),this},clampScalar:function(){var t=new v,e=new v;return function(n,r){return t.set(n,n),e.set(r,r),this.clamp(t,e)}}(),clampLength:function(t,e){var n=this.length();return this.divideScalar(n||1).multiplyScalar(Math.max(t,Math.min(e,n)))},floor:function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this},ceil:function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this},round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this},roundToZero:function(){return this.x=this.x<0?Math.ceil(this.x):Math.floor(this.x),this.y=this.y<0?Math.ceil(this.y):Math.floor(this.y),this},negate:function(){return this.x=-this.x,this.y=-this.y,this},dot:function(t){return this.x*t.x+this.y*t.y},cross:function(t){return this.x*t.y-this.y*t.x},lengthSq:function(){return this.x*this.x+this.y*this.y},length:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},manhattanLength:function(){return Math.abs(this.x)+Math.abs(this.y)},normalize:function(){return this.divideScalar(this.length()||1)},angle:function(){var t=Math.atan2(this.y,this.x);return t<0&&(t+=2*Math.PI),t},distanceTo:function(t){return Math.sqrt(this.distanceToSquared(t))},distanceToSquared:function(t){var e=this.x-t.x,n=this.y-t.y;return e*e+n*n},manhattanDistanceTo:function(t){return Math.abs(this.x-t.x)+Math.abs(this.y-t.y)},setLength:function(t){return this.normalize().multiplyScalar(t)},lerp:function(t,e){return this.x+=(t.x-this.x)*e,this.y+=(t.y-this.y)*e,this},lerpVectors:function(t,e,n){return this.subVectors(e,t).multiplyScalar(n).add(t)},equals:function(t){return t.x===this.x&&t.y===this.y},fromArray:function(t,e){return void 0===e&&(e=0),this.x=t[e],this.y=t[e+1],this},toArray:function(t,e){return void 0===t&&(t=[]),void 0===e&&(e=0),t[e]=this.x,t[e+1]=this.y,t},fromBufferAttribute:function(t,e,n){return void 0!==n&&console.warn("THREE.Vector2: offset has been removed from .fromBufferAttribute()."),this.x=t.getX(e),this.y=t.getY(e),this},rotateAround:function(t,e){var n=Math.cos(e),r=Math.sin(e),i=this.x-t.x,a=this.y-t.y;return this.x=i*n-a*r+t.x,this.y=i*r+a*n+t.y,this}});var y,_,x,M={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function b(t,e,n){return void 0===e&&void 0===n?this.set(t):this.setRGB(t,e,n)}function w(t,e,n){if(Array.isArray(t))throw new TypeError("THREE.BufferAttribute: array should be a Typed Array.");this.name="",this.array=t,this.itemSize=e,this.count=void 0!==t?t.length/e:0,this.normalized=!0===n,this.dynamic=!1,this.updateRange={offset:0,count:-1},this.version=0;}function E(t,e,n){w.call(this,new Int8Array(t),e,n);}function S(t,e,n){w.call(this,new Uint8Array(t),e,n);}function T(t,e,n){w.call(this,new Uint8ClampedArray(t),e,n);}function A(t,e,n){w.call(this,new Int16Array(t),e,n);}function L(t,e,n){w.call(this,new Uint16Array(t),e,n);}function C(t,e,n){w.call(this,new Int32Array(t),e,n);}function P(t,e,n){w.call(this,new Uint32Array(t),e,n);}function R(t,e,n){w.call(this,new Float32Array(t),e,n);}function F(t,e,n){w.call(this,new Float64Array(t),e,n);}Object.assign(b.prototype,{isColor:!0,r:1,g:1,b:1,set:function(t){return t&&t.isColor?this.copy(t):"number"==typeof t?this.setHex(t):"string"==typeof t&&this.setStyle(t),this},setScalar:function(t){return this.r=t,this.g=t,this.b=t,this},setHex:function(t){return t=Math.floor(t),this.r=(t>>16&255)/255,this.g=(t>>8&255)/255,this.b=(255&t)/255,this},setRGB:function(t,e,n){return this.r=t,this.g=e,this.b=n,this},setHSL:function(){function t(t,e,n){return n<0&&(n+=1),n>1&&(n-=1),n<1/6?t+6*(e-t)*n:n<.5?e:n<2/3?t+6*(e-t)*(2/3-n):t}return function(e,n,r){if(e=d.euclideanModulo(e,1),n=d.clamp(n,0,1),r=d.clamp(r,0,1),0===n)this.r=this.g=this.b=r;else{var i=r<=.5?r*(1+n):r+n-r*n,a=2*r-i;this.r=t(a,i,e+1/3),this.g=t(a,i,e),this.b=t(a,i,e-1/3);}return this}}(),setStyle:function(t){function e(e){void 0!==e&&parseFloat(e)<1&&console.warn("THREE.Color: Alpha component of "+t+" will be ignored.");}var n;if(n=/^((?:rgb|hsl)a?)\(\s*([^\)]*)\)/.exec(t)){var r,i=n[1],a=n[2];switch(i){case"rgb":case"rgba":if(r=/^(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*(,\s*([0-9]*\.?[0-9]+)\s*)?$/.exec(a))return this.r=Math.min(255,parseInt(r[1],10))/255,this.g=Math.min(255,parseInt(r[2],10))/255,this.b=Math.min(255,parseInt(r[3],10))/255,e(r[5]),this;if(r=/^(\d+)\%\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*(,\s*([0-9]*\.?[0-9]+)\s*)?$/.exec(a))return this.r=Math.min(100,parseInt(r[1],10))/100,this.g=Math.min(100,parseInt(r[2],10))/100,this.b=Math.min(100,parseInt(r[3],10))/100,e(r[5]),this;break;case"hsl":case"hsla":if(r=/^([0-9]*\.?[0-9]+)\s*,\s*(\d+)\%\s*,\s*(\d+)\%\s*(,\s*([0-9]*\.?[0-9]+)\s*)?$/.exec(a)){var o=parseFloat(r[1])/360,s=parseInt(r[2],10)/100,u=parseInt(r[3],10)/100;return e(r[5]),this.setHSL(o,s,u)}}}else if(n=/^\#([A-Fa-f0-9]+)$/.exec(t)){var l,c=(l=n[1]).length;if(3===c)return this.r=parseInt(l.charAt(0)+l.charAt(0),16)/255,this.g=parseInt(l.charAt(1)+l.charAt(1),16)/255,this.b=parseInt(l.charAt(2)+l.charAt(2),16)/255,this;if(6===c)return this.r=parseInt(l.charAt(0)+l.charAt(1),16)/255,this.g=parseInt(l.charAt(2)+l.charAt(3),16)/255,this.b=parseInt(l.charAt(4)+l.charAt(5),16)/255,this}t&&t.length>0&&(void 0!==(l=M[t])?this.setHex(l):console.warn("THREE.Color: Unknown color "+t));return this},clone:function(){return new this.constructor(this.r,this.g,this.b)},copy:function(t){return this.r=t.r,this.g=t.g,this.b=t.b,this},copyGammaToLinear:function(t,e){return void 0===e&&(e=2),this.r=Math.pow(t.r,e),this.g=Math.pow(t.g,e),this.b=Math.pow(t.b,e),this},copyLinearToGamma:function(t,e){void 0===e&&(e=2);var n=e>0?1/e:1;return this.r=Math.pow(t.r,n),this.g=Math.pow(t.g,n),this.b=Math.pow(t.b,n),this},convertGammaToLinear:function(t){return this.copyGammaToLinear(this,t),this},convertLinearToGamma:function(t){return this.copyLinearToGamma(this,t),this},copySRGBToLinear:function(){function t(t){return t<.04045?.0773993808*t:Math.pow(.9478672986*t+.0521327014,2.4)}return function(e){return this.r=t(e.r),this.g=t(e.g),this.b=t(e.b),this}}(),copyLinearToSRGB:function(){function t(t){return t<.0031308?12.92*t:1.055*Math.pow(t,.41666)-.055}return function(e){return this.r=t(e.r),this.g=t(e.g),this.b=t(e.b),this}}(),convertSRGBToLinear:function(){return this.copySRGBToLinear(this),this},convertLinearToSRGB:function(){return this.copyLinearToSRGB(this),this},getHex:function(){return 255*this.r<<16^255*this.g<<8^255*this.b<<0},getHexString:function(){return ("000000"+this.getHex().toString(16)).slice(-6)},getHSL:function(t){void 0===t&&(console.warn("THREE.Color: .getHSL() target is now required"),t={h:0,s:0,l:0});var e,n,r=this.r,i=this.g,a=this.b,o=Math.max(r,i,a),s=Math.min(r,i,a),u=(s+o)/2;if(s===o)e=0,n=0;else{var l=o-s;switch(n=u<=.5?l/(o+s):l/(2-o-s),o){case r:e=(i-a)/l+(i<a?6:0);break;case i:e=(a-r)/l+2;break;case a:e=(r-i)/l+4;}e/=6;}return t.h=e,t.s=n,t.l=u,t},getStyle:function(){return "rgb("+(255*this.r|0)+","+(255*this.g|0)+","+(255*this.b|0)+")"},offsetHSL:(x={},function(t,e,n){return this.getHSL(x),x.h+=t,x.s+=e,x.l+=n,this.setHSL(x.h,x.s,x.l),this}),add:function(t){return this.r+=t.r,this.g+=t.g,this.b+=t.b,this},addColors:function(t,e){return this.r=t.r+e.r,this.g=t.g+e.g,this.b=t.b+e.b,this},addScalar:function(t){return this.r+=t,this.g+=t,this.b+=t,this},sub:function(t){return this.r=Math.max(0,this.r-t.r),this.g=Math.max(0,this.g-t.g),this.b=Math.max(0,this.b-t.b),this},multiply:function(t){return this.r*=t.r,this.g*=t.g,this.b*=t.b,this},multiplyScalar:function(t){return this.r*=t,this.g*=t,this.b*=t,this},lerp:function(t,e){return this.r+=(t.r-this.r)*e,this.g+=(t.g-this.g)*e,this.b+=(t.b-this.b)*e,this},lerpHSL:(y={h:0,s:0,l:0},_={h:0,s:0,l:0},function(t,e){this.getHSL(y),t.getHSL(_);var n=d.lerp(y.h,_.h,e),r=d.lerp(y.s,_.s,e),i=d.lerp(y.l,_.l,e);return this.setHSL(n,r,i),this}),equals:function(t){return t.r===this.r&&t.g===this.g&&t.b===this.b},fromArray:function(t,e){return void 0===e&&(e=0),this.r=t[e],this.g=t[e+1],this.b=t[e+2],this},toArray:function(t,e){return void 0===t&&(t=[]),void 0===e&&(e=0),t[e]=this.r,t[e+1]=this.g,t[e+2]=this.b,t},toJSON:function(){return this.getHex()}}),Object.defineProperty(w.prototype,"needsUpdate",{set:function(t){!0===t&&this.version++;}}),Object.assign(w.prototype,{isBufferAttribute:!0,onUploadCallback:function(){},setArray:function(t){if(Array.isArray(t))throw new TypeError("THREE.BufferAttribute: array should be a Typed Array.");return this.count=void 0!==t?t.length/this.itemSize:0,this.array=t,this},setDynamic:function(t){return this.dynamic=t,this},copy:function(t){return this.name=t.name,this.array=new t.array.constructor(t.array),this.itemSize=t.itemSize,this.count=t.count,this.normalized=t.normalized,this.dynamic=t.dynamic,this},copyAt:function(t,e,n){t*=this.itemSize,n*=e.itemSize;for(var r=0,i=this.itemSize;r<i;r++)this.array[t+r]=e.array[n+r];return this},copyArray:function(t){return this.array.set(t),this},copyColorsArray:function(t){for(var e=this.array,n=0,r=0,i=t.length;r<i;r++){var a=t[r];void 0===a&&(console.warn("THREE.BufferAttribute.copyColorsArray(): color is undefined",r),a=new b),e[n++]=a.r,e[n++]=a.g,e[n++]=a.b;}return this},copyVector2sArray:function(t){for(var e=this.array,n=0,r=0,i=t.length;r<i;r++){var a=t[r];void 0===a&&(console.warn("THREE.BufferAttribute.copyVector2sArray(): vector is undefined",r),a=new v),e[n++]=a.x,e[n++]=a.y;}return this},copyVector3sArray:function(t){for(var e=this.array,n=0,r=0,i=t.length;r<i;r++){var a=t[r];void 0===a&&(console.warn("THREE.BufferAttribute.copyVector3sArray(): vector is undefined",r),a=new g),e[n++]=a.x,e[n++]=a.y,e[n++]=a.z;}return this},copyVector4sArray:function(t){for(var e=this.array,n=0,r=0,a=t.length;r<a;r++){var o=t[r];void 0===o&&(console.warn("THREE.BufferAttribute.copyVector4sArray(): vector is undefined",r),o=new i),e[n++]=o.x,e[n++]=o.y,e[n++]=o.z,e[n++]=o.w;}return this},set:function(t,e){return void 0===e&&(e=0),this.array.set(t,e),this},getX:function(t){return this.array[t*this.itemSize]},setX:function(t,e){return this.array[t*this.itemSize]=e,this},getY:function(t){return this.array[t*this.itemSize+1]},setY:function(t,e){return this.array[t*this.itemSize+1]=e,this},getZ:function(t){return this.array[t*this.itemSize+2]},setZ:function(t,e){return this.array[t*this.itemSize+2]=e,this},getW:function(t){return this.array[t*this.itemSize+3]},setW:function(t,e){return this.array[t*this.itemSize+3]=e,this},setXY:function(t,e,n){return t*=this.itemSize,this.array[t+0]=e,this.array[t+1]=n,this},setXYZ:function(t,e,n,r){return t*=this.itemSize,this.array[t+0]=e,this.array[t+1]=n,this.array[t+2]=r,this},setXYZW:function(t,e,n,r,i){return t*=this.itemSize,this.array[t+0]=e,this.array[t+1]=n,this.array[t+2]=r,this.array[t+3]=i,this},onUpload:function(t){return this.onUploadCallback=t,this},clone:function(){return new this.constructor(this.array,this.itemSize).copy(this)}}),E.prototype=Object.create(w.prototype),E.prototype.constructor=E,S.prototype=Object.create(w.prototype),S.prototype.constructor=S,T.prototype=Object.create(w.prototype),T.prototype.constructor=T,A.prototype=Object.create(w.prototype),A.prototype.constructor=A,L.prototype=Object.create(w.prototype),L.prototype.constructor=L,C.prototype=Object.create(w.prototype),C.prototype.constructor=C,P.prototype=Object.create(w.prototype),P.prototype.constructor=P,R.prototype=Object.create(w.prototype),R.prototype.constructor=R,F.prototype=Object.create(w.prototype),F.prototype.constructor=F;var D,I="101",N=0,O=1,U=2,B=1,z=2,G=0,k=1,V=2,H=0,j=0,W=1,X=2,q=3,Y=4,Z=5,J=100,Q=101,K=102,$=103,tt=104,et=200,nt=201,rt=202,it=203,at=204,ot=205,st=206,ut=207,lt=208,ct=209,ht=210,ft=0,dt=1,pt=2,mt=3,gt=4,vt=5,yt=6,_t=7,xt=0,Mt=1,bt=2,wt=0,Et=1,St=2,Tt=3,At=4,Lt=5,Ct=301,Pt=302,Rt=303,Ft=304,Dt=305,It=306,Nt=307,Ot=1e3,Ut=1001,Bt=1002,zt=1003,Gt=1004,kt=1005,Vt=1006,Ht=1007,jt=1008,Wt=1009,Xt=1010,qt=1011,Yt=1012,Zt=1013,Jt=1014,Qt=1015,Kt=1016,$t=1017,te=1018,ee=1019,ne=1020,re=1021,ie=1022,ae=1023,oe=1024,se=1025,ue=ae,le=1026,ce=1027,he=1028,fe=33776,de=33777,pe=33778,me=33779,ge=35840,ve=35841,ye=35842,_e=35843,xe=36196,Me=37808,be=37809,we=37810,Ee=37811,Se=37812,Te=37813,Ae=37814,Le=37815,Ce=37816,Pe=37817,Re=37818,Fe=37819,De=37820,Ie=37821,Ne=0,Oe=1,Ue=2,Be=3e3,ze=3001,Ge=3007,ke=3002,Ve=3004,He=3005,je=3006,We=3200,Xe=3201,qe=1;function Ye(){}function Ze(t,e,n,r){this._x=t||0,this._y=e||0,this._z=n||0,this._order=r||Ze.DefaultOrder;}function Je(){this.mask=1;}function Qe(){this.elements=[1,0,0,0,1,0,0,0,1],arguments.length>0&&console.error("THREE.Matrix3: the constructor no longer reads arguments. use .set() instead.");}Object.assign(Ye.prototype,{addEventListener:function(t,e){void 0===this._listeners&&(this._listeners={});var n=this._listeners;void 0===n[t]&&(n[t]=[]),-1===n[t].indexOf(e)&&n[t].push(e);},hasEventListener:function(t,e){if(void 0===this._listeners)return !1;var n=this._listeners;return void 0!==n[t]&&-1!==n[t].indexOf(e)},removeEventListener:function(t,e){if(void 0!==this._listeners){var n=this._listeners[t];if(void 0!==n){var r=n.indexOf(e);-1!==r&&n.splice(r,1);}}},dispatchEvent:function(t){if(void 0!==this._listeners){var e=this._listeners[t.type];if(void 0!==e){t.target=this;for(var n=e.slice(0),r=0,i=n.length;r<i;r++)n[r].call(this,t);}}}}),Ze.RotationOrders=["XYZ","YZX","ZXY","XZY","YXZ","ZYX"],Ze.DefaultOrder="XYZ",Object.defineProperties(Ze.prototype,{x:{get:function(){return this._x},set:function(t){this._x=t,this.onChangeCallback();}},y:{get:function(){return this._y},set:function(t){this._y=t,this.onChangeCallback();}},z:{get:function(){return this._z},set:function(t){this._z=t,this.onChangeCallback();}},order:{get:function(){return this._order},set:function(t){this._order=t,this.onChangeCallback();}}}),Object.assign(Ze.prototype,{isEuler:!0,set:function(t,e,n,r){return this._x=t,this._y=e,this._z=n,this._order=r||this._order,this.onChangeCallback(),this},clone:function(){return new this.constructor(this._x,this._y,this._z,this._order)},copy:function(t){return this._x=t._x,this._y=t._y,this._z=t._z,this._order=t._order,this.onChangeCallback(),this},setFromRotationMatrix:function(t,e,n){var r=d.clamp,i=t.elements,a=i[0],o=i[4],s=i[8],u=i[1],l=i[5],c=i[9],h=i[2],f=i[6],p=i[10];return "XYZ"===(e=e||this._order)?(this._y=Math.asin(r(s,-1,1)),Math.abs(s)<.99999?(this._x=Math.atan2(-c,p),this._z=Math.atan2(-o,a)):(this._x=Math.atan2(f,l),this._z=0)):"YXZ"===e?(this._x=Math.asin(-r(c,-1,1)),Math.abs(c)<.99999?(this._y=Math.atan2(s,p),this._z=Math.atan2(u,l)):(this._y=Math.atan2(-h,a),this._z=0)):"ZXY"===e?(this._x=Math.asin(r(f,-1,1)),Math.abs(f)<.99999?(this._y=Math.atan2(-h,p),this._z=Math.atan2(-o,l)):(this._y=0,this._z=Math.atan2(u,a))):"ZYX"===e?(this._y=Math.asin(-r(h,-1,1)),Math.abs(h)<.99999?(this._x=Math.atan2(f,p),this._z=Math.atan2(u,a)):(this._x=0,this._z=Math.atan2(-o,l))):"YZX"===e?(this._z=Math.asin(r(u,-1,1)),Math.abs(u)<.99999?(this._x=Math.atan2(-c,l),this._y=Math.atan2(-h,a)):(this._x=0,this._y=Math.atan2(s,p))):"XZY"===e?(this._z=Math.asin(-r(o,-1,1)),Math.abs(o)<.99999?(this._x=Math.atan2(f,l),this._y=Math.atan2(s,a)):(this._x=Math.atan2(-c,p),this._y=0)):console.warn("THREE.Euler: .setFromRotationMatrix() given unsupported order: "+e),this._order=e,!1!==n&&this.onChangeCallback(),this},setFromQuaternion:function(){var t=new p;return function(e,n,r){return t.makeRotationFromQuaternion(e),this.setFromRotationMatrix(t,n,r)}}(),setFromVector3:function(t,e){return this.set(t.x,t.y,t.z,e||this._order)},reorder:(D=new m,function(t){return D.setFromEuler(this),this.setFromQuaternion(D,t)}),equals:function(t){return t._x===this._x&&t._y===this._y&&t._z===this._z&&t._order===this._order},fromArray:function(t){return this._x=t[0],this._y=t[1],this._z=t[2],void 0!==t[3]&&(this._order=t[3]),this.onChangeCallback(),this},toArray:function(t,e){return void 0===t&&(t=[]),void 0===e&&(e=0),t[e]=this._x,t[e+1]=this._y,t[e+2]=this._z,t[e+3]=this._order,t},toVector3:function(t){return t?t.set(this._x,this._y,this._z):new g(this._x,this._y,this._z)},onChange:function(t){return this.onChangeCallback=t,this},onChangeCallback:function(){}}),Object.assign(Je.prototype,{set:function(t){this.mask=1<<t|0;},enable:function(t){this.mask|=1<<t|0;},toggle:function(t){this.mask^=1<<t|0;},disable:function(t){this.mask&=~(1<<t|0);},test:function(t){return 0!=(this.mask&t.mask)}}),Object.assign(Qe.prototype,{isMatrix3:!0,set:function(t,e,n,r,i,a,o,s,u){var l=this.elements;return l[0]=t,l[1]=r,l[2]=o,l[3]=e,l[4]=i,l[5]=s,l[6]=n,l[7]=a,l[8]=u,this},identity:function(){return this.set(1,0,0,0,1,0,0,0,1),this},clone:function(){return (new this.constructor).fromArray(this.elements)},copy:function(t){var e=this.elements,n=t.elements;return e[0]=n[0],e[1]=n[1],e[2]=n[2],e[3]=n[3],e[4]=n[4],e[5]=n[5],e[6]=n[6],e[7]=n[7],e[8]=n[8],this},setFromMatrix4:function(t){var e=t.elements;return this.set(e[0],e[4],e[8],e[1],e[5],e[9],e[2],e[6],e[10]),this},applyToBufferAttribute:function(){var t=new g;return function(e){for(var n=0,r=e.count;n<r;n++)t.x=e.getX(n),t.y=e.getY(n),t.z=e.getZ(n),t.applyMatrix3(this),e.setXYZ(n,t.x,t.y,t.z);return e}}(),multiply:function(t){return this.multiplyMatrices(this,t)},premultiply:function(t){return this.multiplyMatrices(t,this)},multiplyMatrices:function(t,e){var n=t.elements,r=e.elements,i=this.elements,a=n[0],o=n[3],s=n[6],u=n[1],l=n[4],c=n[7],h=n[2],f=n[5],d=n[8],p=r[0],m=r[3],g=r[6],v=r[1],y=r[4],_=r[7],x=r[2],M=r[5],b=r[8];return i[0]=a*p+o*v+s*x,i[3]=a*m+o*y+s*M,i[6]=a*g+o*_+s*b,i[1]=u*p+l*v+c*x,i[4]=u*m+l*y+c*M,i[7]=u*g+l*_+c*b,i[2]=h*p+f*v+d*x,i[5]=h*m+f*y+d*M,i[8]=h*g+f*_+d*b,this},multiplyScalar:function(t){var e=this.elements;return e[0]*=t,e[3]*=t,e[6]*=t,e[1]*=t,e[4]*=t,e[7]*=t,e[2]*=t,e[5]*=t,e[8]*=t,this},determinant:function(){var t=this.elements,e=t[0],n=t[1],r=t[2],i=t[3],a=t[4],o=t[5],s=t[6],u=t[7],l=t[8];return e*a*l-e*o*u-n*i*l+n*o*s+r*i*u-r*a*s},getInverse:function(t,e){t&&t.isMatrix4&&console.error("THREE.Matrix3: .getInverse() no longer takes a Matrix4 argument.");var n=t.elements,r=this.elements,i=n[0],a=n[1],o=n[2],s=n[3],u=n[4],l=n[5],c=n[6],h=n[7],f=n[8],d=f*u-l*h,p=l*c-f*s,m=h*s-u*c,g=i*d+a*p+o*m;if(0===g){var v="THREE.Matrix3: .getInverse() can't invert matrix, determinant is 0";if(!0===e)throw new Error(v);return console.warn(v),this.identity()}var y=1/g;return r[0]=d*y,r[1]=(o*h-f*a)*y,r[2]=(l*a-o*u)*y,r[3]=p*y,r[4]=(f*i-o*c)*y,r[5]=(o*s-l*i)*y,r[6]=m*y,r[7]=(a*c-h*i)*y,r[8]=(u*i-a*s)*y,this},transpose:function(){var t,e=this.elements;return t=e[1],e[1]=e[3],e[3]=t,t=e[2],e[2]=e[6],e[6]=t,t=e[5],e[5]=e[7],e[7]=t,this},getNormalMatrix:function(t){return this.setFromMatrix4(t).getInverse(this).transpose()},transposeIntoArray:function(t){var e=this.elements;return t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8],this},setUvTransform:function(t,e,n,r,i,a,o){var s=Math.cos(i),u=Math.sin(i);this.set(n*s,n*u,-n*(s*a+u*o)+a+t,-r*u,r*s,-r*(-u*a+s*o)+o+e,0,0,1);},scale:function(t,e){var n=this.elements;return n[0]*=t,n[3]*=t,n[6]*=t,n[1]*=e,n[4]*=e,n[7]*=e,this},rotate:function(t){var e=Math.cos(t),n=Math.sin(t),r=this.elements,i=r[0],a=r[3],o=r[6],s=r[1],u=r[4],l=r[7];return r[0]=e*i+n*s,r[3]=e*a+n*u,r[6]=e*o+n*l,r[1]=-n*i+e*s,r[4]=-n*a+e*u,r[7]=-n*o+e*l,this},translate:function(t,e){var n=this.elements;return n[0]+=t*n[2],n[3]+=t*n[5],n[6]+=t*n[8],n[1]+=e*n[2],n[4]+=e*n[5],n[7]+=e*n[8],this},equals:function(t){for(var e=this.elements,n=t.elements,r=0;r<9;r++)if(e[r]!==n[r])return !1;return !0},fromArray:function(t,e){void 0===e&&(e=0);for(var n=0;n<9;n++)this.elements[n]=t[n+e];return this},toArray:function(t,e){void 0===t&&(t=[]),void 0===e&&(e=0);var n=this.elements;return t[e]=n[0],t[e+1]=n[1],t[e+2]=n[2],t[e+3]=n[3],t[e+4]=n[4],t[e+5]=n[5],t[e+6]=n[6],t[e+7]=n[7],t[e+8]=n[8],t}});var Ke,$e,tn,en=0;function nn(){Object.defineProperty(this,"id",{value:en++}),this.uuid=d.generateUUID(),this.name="",this.type="Object3D",this.parent=null,this.children=[],this.up=nn.DefaultUp.clone();var t=new g,e=new Ze,n=new m,r=new g(1,1,1);e.onChange(function(){n.setFromEuler(e,!1);}),n.onChange(function(){e.setFromQuaternion(n,void 0,!1);}),Object.defineProperties(this,{position:{configurable:!0,enumerable:!0,value:t},rotation:{configurable:!0,enumerable:!0,value:e},quaternion:{configurable:!0,enumerable:!0,value:n},scale:{configurable:!0,enumerable:!0,value:r},modelViewMatrix:{value:new p},normalMatrix:{value:new Qe}}),this.matrix=new p,this.matrixWorld=new p,this.matrixAutoUpdate=nn.DefaultMatrixAutoUpdate,this.matrixWorldNeedsUpdate=!1,this.layers=new Je,this.visible=!0,this.castShadow=!1,this.receiveShadow=!1,this.frustumCulled=!0,this.renderOrder=0,this.userData={};}function rn(){nn.call(this),this.type="Scene",this.background=null,this.fog=null,this.overrideMaterial=null,this.autoUpdate=!0;}nn.DefaultUp=new g(0,1,0),nn.DefaultMatrixAutoUpdate=!0,nn.prototype=Object.assign(Object.create(Ye.prototype),{constructor:nn,isObject3D:!0,onBeforeRender:function(){},onAfterRender:function(){},applyMatrix:function(t){this.matrix.multiplyMatrices(t,this.matrix),this.matrix.decompose(this.position,this.quaternion,this.scale);},applyQuaternion:function(t){return this.quaternion.premultiply(t),this},setRotationFromAxisAngle:function(t,e){this.quaternion.setFromAxisAngle(t,e);},setRotationFromEuler:function(t){this.quaternion.setFromEuler(t,!0);},setRotationFromMatrix:function(t){this.quaternion.setFromRotationMatrix(t);},setRotationFromQuaternion:function(t){this.quaternion.copy(t);},rotateOnAxis:($e=new m,function(t,e){return $e.setFromAxisAngle(t,e),this.quaternion.multiply($e),this}),rotateOnWorldAxis:function(){var t=new m;return function(e,n){return t.setFromAxisAngle(e,n),this.quaternion.premultiply(t),this}}(),rotateX:function(){var t=new g(1,0,0);return function(e){return this.rotateOnAxis(t,e)}}(),rotateY:function(){var t=new g(0,1,0);return function(e){return this.rotateOnAxis(t,e)}}(),rotateZ:function(){var t=new g(0,0,1);return function(e){return this.rotateOnAxis(t,e)}}(),translateOnAxis:function(){var t=new g;return function(e,n){return t.copy(e).applyQuaternion(this.quaternion),this.position.add(t.multiplyScalar(n)),this}}(),translateX:function(){var t=new g(1,0,0);return function(e){return this.translateOnAxis(t,e)}}(),translateY:function(){var t=new g(0,1,0);return function(e){return this.translateOnAxis(t,e)}}(),translateZ:function(){var t=new g(0,0,1);return function(e){return this.translateOnAxis(t,e)}}(),localToWorld:function(t){return t.applyMatrix4(this.matrixWorld)},worldToLocal:(Ke=new p,function(t){return t.applyMatrix4(Ke.getInverse(this.matrixWorld))}),lookAt:function(){var t=new m,e=new p,n=new g,r=new g;return function(i,a,o){i.isVector3?n.copy(i):n.set(i,a,o);var s=this.parent;this.updateWorldMatrix(!0,!1),r.setFromMatrixPosition(this.matrixWorld),this.isCamera||this.isLight?e.lookAt(r,n,this.up):e.lookAt(n,r,this.up),this.quaternion.setFromRotationMatrix(e),s&&(e.extractRotation(s.matrixWorld),t.setFromRotationMatrix(e),this.quaternion.premultiply(t.inverse()));}}(),add:function(t){var e=arguments;if(arguments.length>1){for(var n=0;n<arguments.length;n++)this.add(e[n]);return this}return t===this?(console.error("THREE.Object3D.add: object can't be added as a child of itself.",t),this):(t&&t.isObject3D?(null!==t.parent&&t.parent.remove(t),t.parent=this,t.dispatchEvent({type:"added"}),this.children.push(t)):console.error("THREE.Object3D.add: object not an instance of THREE.Object3D.",t),this)},remove:function(t){var e=arguments;if(arguments.length>1){for(var n=0;n<arguments.length;n++)this.remove(e[n]);return this}var r=this.children.indexOf(t);return -1!==r&&(t.parent=null,t.dispatchEvent({type:"removed"}),this.children.splice(r,1)),this},getObjectById:function(t){return this.getObjectByProperty("id",t)},getObjectByName:function(t){return this.getObjectByProperty("name",t)},getObjectByProperty:function(t,e){if(this[t]===e)return this;for(var n=0,r=this.children.length;n<r;n++){var i=this.children[n].getObjectByProperty(t,e);if(void 0!==i)return i}},getWorldPosition:function(t){return void 0===t&&(console.warn("THREE.Object3D: .getWorldPosition() target is now required"),t=new g),this.updateMatrixWorld(!0),t.setFromMatrixPosition(this.matrixWorld)},getWorldQuaternion:function(){var t=new g,e=new g;return function(n){return void 0===n&&(console.warn("THREE.Object3D: .getWorldQuaternion() target is now required"),n=new m),this.updateMatrixWorld(!0),this.matrixWorld.decompose(t,n,e),n}}(),getWorldScale:function(){var t=new g,e=new m;return function(n){return void 0===n&&(console.warn("THREE.Object3D: .getWorldScale() target is now required"),n=new g),this.updateMatrixWorld(!0),this.matrixWorld.decompose(t,e,n),n}}(),getWorldDirection:function(t){void 0===t&&(console.warn("THREE.Object3D: .getWorldDirection() target is now required"),t=new g),this.updateMatrixWorld(!0);var e=this.matrixWorld.elements;return t.set(e[8],e[9],e[10]).normalize()},raycast:function(){},traverse:function(t){t(this);for(var e=this.children,n=0,r=e.length;n<r;n++)e[n].traverse(t);},traverseVisible:function(t){if(!1!==this.visible){t(this);for(var e=this.children,n=0,r=e.length;n<r;n++)e[n].traverseVisible(t);}},traverseAncestors:function(t){var e=this.parent;null!==e&&(t(e),e.traverseAncestors(t));},updateMatrix:function(){this.matrix.compose(this.position,this.quaternion,this.scale),this.matrixWorldNeedsUpdate=!0;},updateMatrixWorld:function(t){this.matrixAutoUpdate&&this.updateMatrix(),(this.matrixWorldNeedsUpdate||t)&&(null===this.parent?this.matrixWorld.copy(this.matrix):this.matrixWorld.multiplyMatrices(this.parent.matrixWorld,this.matrix),this.matrixWorldNeedsUpdate=!1,t=!0);for(var e=this.children,n=0,r=e.length;n<r;n++)e[n].updateMatrixWorld(t);},updateWorldMatrix:function(t,e){var n=this.parent;if(!0===t&&null!==n&&n.updateWorldMatrix(!0,!1),this.matrixAutoUpdate&&this.updateMatrix(),null===this.parent?this.matrixWorld.copy(this.matrix):this.matrixWorld.multiplyMatrices(this.parent.matrixWorld,this.matrix),!0===e)for(var r=this.children,i=0,a=r.length;i<a;i++)r[i].updateWorldMatrix(!1,!0);},toJSON:function(t){var e=void 0===t||"string"==typeof t,n={};e&&(t={geometries:{},materials:{},textures:{},images:{},shapes:{}},n.metadata={version:4.5,type:"Object",generator:"Object3D.toJSON"});var r={};function i(e,n){return void 0===e[n.uuid]&&(e[n.uuid]=n.toJSON(t)),n.uuid}if(r.uuid=this.uuid,r.type=this.type,""!==this.name&&(r.name=this.name),!0===this.castShadow&&(r.castShadow=!0),!0===this.receiveShadow&&(r.receiveShadow=!0),!1===this.visible&&(r.visible=!1),!1===this.frustumCulled&&(r.frustumCulled=!1),0!==this.renderOrder&&(r.renderOrder=this.renderOrder),"{}"!==JSON.stringify(this.userData)&&(r.userData=this.userData),r.layers=this.layers.mask,r.matrix=this.matrix.toArray(),!1===this.matrixAutoUpdate&&(r.matrixAutoUpdate=!1),this.isMesh&&this.drawMode!==Ne&&(r.drawMode=this.drawMode),this.isMesh||this.isLine||this.isPoints){r.geometry=i(t.geometries,this.geometry);var a=this.geometry.parameters;if(void 0!==a&&void 0!==a.shapes){var o=a.shapes;if(Array.isArray(o))for(var s=0,u=o.length;s<u;s++){var l=o[s];i(t.shapes,l);}else i(t.shapes,o);}}if(void 0!==this.material)if(Array.isArray(this.material)){var c=[];for(s=0,u=this.material.length;s<u;s++)c.push(i(t.materials,this.material[s]));r.material=c;}else r.material=i(t.materials,this.material);if(this.children.length>0){r.children=[];for(s=0;s<this.children.length;s++)r.children.push(this.children[s].toJSON(t).object);}if(e){var h=m(t.geometries),f=m(t.materials),d=m(t.textures),p=m(t.images);o=m(t.shapes);h.length>0&&(n.geometries=h),f.length>0&&(n.materials=f),d.length>0&&(n.textures=d),p.length>0&&(n.images=p),o.length>0&&(n.shapes=o);}return n.object=r,n;function m(t){var e=[];for(var n in t){var r=t[n];delete r.metadata,e.push(r);}return e}},clone:function(t){return (new this.constructor).copy(this,t)},copy:function(t,e){if(void 0===e&&(e=!0),this.name=t.name,this.up.copy(t.up),this.position.copy(t.position),this.quaternion.copy(t.quaternion),this.scale.copy(t.scale),this.matrix.copy(t.matrix),this.matrixWorld.copy(t.matrixWorld),this.matrixAutoUpdate=t.matrixAutoUpdate,this.matrixWorldNeedsUpdate=t.matrixWorldNeedsUpdate,this.layers.mask=t.layers.mask,this.visible=t.visible,this.castShadow=t.castShadow,this.receiveShadow=t.receiveShadow,this.frustumCulled=t.frustumCulled,this.renderOrder=t.renderOrder,this.userData=JSON.parse(JSON.stringify(t.userData)),!0===e)for(var n=0;n<t.children.length;n++){var r=t.children[n];this.add(r.clone());}return this}}),rn.prototype=Object.assign(Object.create(nn.prototype),{constructor:rn,isScene:!0,copy:function(t,e){return nn.prototype.copy.call(this,t,e),null!==t.background&&(this.background=t.background.clone()),null!==t.fog&&(this.fog=t.fog.clone()),null!==t.overrideMaterial&&(this.overrideMaterial=t.overrideMaterial.clone()),this.autoUpdate=t.autoUpdate,this.matrixAutoUpdate=t.matrixAutoUpdate,this},toJSON:function(t){var e=nn.prototype.toJSON.call(this,t);return null!==this.background&&(e.object.background=this.background.toJSON(t)),null!==this.fog&&(e.object.fog=this.fog.toJSON()),e},dispose:function(){this.dispatchEvent({type:"dispose"});}});var an,on,sn,un,ln,cn=function(t){var e;if("undefined"==typeof HTMLCanvasElement)return t.src;if(t instanceof HTMLCanvasElement)e=t;else{void 0===tn&&(tn=document.createElementNS("http://www.w3.org/1999/xhtml","canvas")),tn.width=t.width,tn.height=t.height;var n=tn.getContext("2d");t instanceof ImageData?n.putImageData(t,0,0):n.drawImage(t,0,0,t.width,t.height),e=tn;}return e.width>2048||e.height>2048?e.toDataURL("image/jpeg",.6):e.toDataURL("image/png")},hn=0;function fn(t,e,n,r,i,a,o,s,u,l){Object.defineProperty(this,"id",{value:hn++}),this.uuid=d.generateUUID(),this.name="",this.image=void 0!==t?t:fn.DEFAULT_IMAGE,this.mipmaps=[],this.mapping=void 0!==e?e:fn.DEFAULT_MAPPING,this.wrapS=void 0!==n?n:Ut,this.wrapT=void 0!==r?r:Ut,this.magFilter=void 0!==i?i:Vt,this.minFilter=void 0!==a?a:jt,this.anisotropy=void 0!==u?u:1,this.format=void 0!==o?o:ae,this.type=void 0!==s?s:Wt,this.offset=new v(0,0),this.repeat=new v(1,1),this.center=new v(0,0),this.rotation=0,this.matrixAutoUpdate=!0,this.matrix=new Qe,this.generateMipmaps=!0,this.premultiplyAlpha=!1,this.flipY=!0,this.unpackAlignment=4,this.encoding=void 0!==l?l:Be,this.version=0,this.onUpdate=null;}function dn(t,e,n,r,i,a,o,s,u,l,c,h){fn.call(this,null,a,o,s,u,l,r,i,c,h),this.image={data:t,width:e,height:n},this.magFilter=void 0!==u?u:zt,this.minFilter=void 0!==l?l:zt,this.generateMipmaps=!1,this.flipY=!1,this.unpackAlignment=1;}function pn(t,e){this.min=void 0!==t?t:new g(1/0,1/0,1/0),this.max=void 0!==e?e:new g(-1/0,-1/0,-1/0);}function mn(t,e){this.center=void 0!==t?t:new g,this.radius=void 0!==e?e:0;}function gn(t,e){this.normal=void 0!==t?t:new g(1,0,0),this.constant=void 0!==e?e:0;}function vn(t,e,n,r,i,a){this.planes=[void 0!==t?t:new gn,void 0!==e?e:new gn,void 0!==n?n:new gn,void 0!==r?r:new gn,void 0!==i?i:new gn,void 0!==a?a:new gn];}fn.DEFAULT_IMAGE=void 0,fn.DEFAULT_MAPPING=300,fn.prototype=Object.assign(Object.create(Ye.prototype),{constructor:fn,isTexture:!0,updateMatrix:function(){this.matrix.setUvTransform(this.offset.x,this.offset.y,this.repeat.x,this.repeat.y,this.rotation,this.center.x,this.center.y);},clone:function(){return (new this.constructor).copy(this)},copy:function(t){return this.name=t.name,this.image=t.image,this.mipmaps=t.mipmaps.slice(0),this.mapping=t.mapping,this.wrapS=t.wrapS,this.wrapT=t.wrapT,this.magFilter=t.magFilter,this.minFilter=t.minFilter,this.anisotropy=t.anisotropy,this.format=t.format,this.type=t.type,this.offset.copy(t.offset),this.repeat.copy(t.repeat),this.center.copy(t.center),this.rotation=t.rotation,this.matrixAutoUpdate=t.matrixAutoUpdate,this.matrix.copy(t.matrix),this.generateMipmaps=t.generateMipmaps,this.premultiplyAlpha=t.premultiplyAlpha,this.flipY=t.flipY,this.unpackAlignment=t.unpackAlignment,this.encoding=t.encoding,this},toJSON:function(t){var e=void 0===t||"string"==typeof t;if(!e&&void 0!==t.textures[this.uuid])return t.textures[this.uuid];var n={metadata:{version:4.5,type:"Texture",generator:"Texture.toJSON"},uuid:this.uuid,name:this.name,mapping:this.mapping,repeat:[this.repeat.x,this.repeat.y],offset:[this.offset.x,this.offset.y],center:[this.center.x,this.center.y],rotation:this.rotation,wrap:[this.wrapS,this.wrapT],format:this.format,type:this.type,encoding:this.encoding,minFilter:this.minFilter,magFilter:this.magFilter,anisotropy:this.anisotropy,flipY:this.flipY,premultiplyAlpha:this.premultiplyAlpha,unpackAlignment:this.unpackAlignment};if(void 0!==this.image){var r=this.image;if(void 0===r.uuid&&(r.uuid=d.generateUUID()),!e&&void 0===t.images[r.uuid]){var i;if(Array.isArray(r)){i=[];for(var a=0,o=r.length;a<o;a++)i.push(cn(r[a]));}else i=cn(r);t.images[r.uuid]={uuid:r.uuid,url:i};}n.image=r.uuid;}return e||(t.textures[this.uuid]=n),n},dispose:function(){this.dispatchEvent({type:"dispose"});},transformUv:function(t){if(300!==this.mapping)return t;if(t.applyMatrix3(this.matrix),t.x<0||t.x>1)switch(this.wrapS){case Ot:t.x=t.x-Math.floor(t.x);break;case Ut:t.x=t.x<0?0:1;break;case Bt:1===Math.abs(Math.floor(t.x)%2)?t.x=Math.ceil(t.x)-t.x:t.x=t.x-Math.floor(t.x);}if(t.y<0||t.y>1)switch(this.wrapT){case Ot:t.y=t.y-Math.floor(t.y);break;case Ut:t.y=t.y<0?0:1;break;case Bt:1===Math.abs(Math.floor(t.y)%2)?t.y=Math.ceil(t.y)-t.y:t.y=t.y-Math.floor(t.y);}return this.flipY&&(t.y=1-t.y),t}}),Object.defineProperty(fn.prototype,"needsUpdate",{set:function(t){!0===t&&this.version++;}}),dn.prototype=Object.create(fn.prototype),dn.prototype.constructor=dn,dn.prototype.isDataTexture=!0,Object.assign(pn.prototype,{isBox3:!0,set:function(t,e){return this.min.copy(t),this.max.copy(e),this},setFromArray:function(t){for(var e=1/0,n=1/0,r=1/0,i=-1/0,a=-1/0,o=-1/0,s=0,u=t.length;s<u;s+=3){var l=t[s],c=t[s+1],h=t[s+2];l<e&&(e=l),c<n&&(n=c),h<r&&(r=h),l>i&&(i=l),c>a&&(a=c),h>o&&(o=h);}return this.min.set(e,n,r),this.max.set(i,a,o),this},setFromBufferAttribute:function(t){for(var e=1/0,n=1/0,r=1/0,i=-1/0,a=-1/0,o=-1/0,s=0,u=t.count;s<u;s++){var l=t.getX(s),c=t.getY(s),h=t.getZ(s);l<e&&(e=l),c<n&&(n=c),h<r&&(r=h),l>i&&(i=l),c>a&&(a=c),h>o&&(o=h);}return this.min.set(e,n,r),this.max.set(i,a,o),this},setFromPoints:function(t){this.makeEmpty();for(var e=0,n=t.length;e<n;e++)this.expandByPoint(t[e]);return this},setFromCenterAndSize:function(){var t=new g;return function(e,n){var r=t.copy(n).multiplyScalar(.5);return this.min.copy(e).sub(r),this.max.copy(e).add(r),this}}(),setFromObject:function(t){return this.makeEmpty(),this.expandByObject(t)},clone:function(){return (new this.constructor).copy(this)},copy:function(t){return this.min.copy(t.min),this.max.copy(t.max),this},makeEmpty:function(){return this.min.x=this.min.y=this.min.z=1/0,this.max.x=this.max.y=this.max.z=-1/0,this},isEmpty:function(){return this.max.x<this.min.x||this.max.y<this.min.y||this.max.z<this.min.z},getCenter:function(t){return void 0===t&&(console.warn("THREE.Box3: .getCenter() target is now required"),t=new g),this.isEmpty()?t.set(0,0,0):t.addVectors(this.min,this.max).multiplyScalar(.5)},getSize:function(t){return void 0===t&&(console.warn("THREE.Box3: .getSize() target is now required"),t=new g),this.isEmpty()?t.set(0,0,0):t.subVectors(this.max,this.min)},expandByPoint:function(t){return this.min.min(t),this.max.max(t),this},expandByVector:function(t){return this.min.sub(t),this.max.add(t),this},expandByScalar:function(t){return this.min.addScalar(-t),this.max.addScalar(t),this},expandByObject:function(){var t,e,n,r=new g;function i(i){var a=i.geometry;if(void 0!==a)if(a.isGeometry){var o=a.vertices;for(e=0,n=o.length;e<n;e++)r.copy(o[e]),r.applyMatrix4(i.matrixWorld),t.expandByPoint(r);}else if(a.isBufferGeometry){var s=a.attributes.position;if(void 0!==s)for(e=0,n=s.count;e<n;e++)r.fromBufferAttribute(s,e).applyMatrix4(i.matrixWorld),t.expandByPoint(r);}}return function(e){return t=this,e.updateMatrixWorld(!0),e.traverse(i),this}}(),containsPoint:function(t){return !(t.x<this.min.x||t.x>this.max.x||t.y<this.min.y||t.y>this.max.y||t.z<this.min.z||t.z>this.max.z)},containsBox:function(t){return this.min.x<=t.min.x&&t.max.x<=this.max.x&&this.min.y<=t.min.y&&t.max.y<=this.max.y&&this.min.z<=t.min.z&&t.max.z<=this.max.z},getParameter:function(t,e){return void 0===e&&(console.warn("THREE.Box3: .getParameter() target is now required"),e=new g),e.set((t.x-this.min.x)/(this.max.x-this.min.x),(t.y-this.min.y)/(this.max.y-this.min.y),(t.z-this.min.z)/(this.max.z-this.min.z))},intersectsBox:function(t){return !(t.max.x<this.min.x||t.min.x>this.max.x||t.max.y<this.min.y||t.min.y>this.max.y||t.max.z<this.min.z||t.min.z>this.max.z)},intersectsSphere:(on=new g,function(t){return this.clampPoint(t.center,on),on.distanceToSquared(t.center)<=t.radius*t.radius}),intersectsPlane:function(t){var e,n;return t.normal.x>0?(e=t.normal.x*this.min.x,n=t.normal.x*this.max.x):(e=t.normal.x*this.max.x,n=t.normal.x*this.min.x),t.normal.y>0?(e+=t.normal.y*this.min.y,n+=t.normal.y*this.max.y):(e+=t.normal.y*this.max.y,n+=t.normal.y*this.min.y),t.normal.z>0?(e+=t.normal.z*this.min.z,n+=t.normal.z*this.max.z):(e+=t.normal.z*this.max.z,n+=t.normal.z*this.min.z),e<=-t.constant&&n>=-t.constant},intersectsTriangle:function(){var t=new g,e=new g,n=new g,r=new g,i=new g,a=new g,o=new g,s=new g,u=new g,l=new g;function c(r){var i,a;for(i=0,a=r.length-3;i<=a;i+=3){o.fromArray(r,i);var s=u.x*Math.abs(o.x)+u.y*Math.abs(o.y)+u.z*Math.abs(o.z),l=t.dot(o),c=e.dot(o),h=n.dot(o);if(Math.max(-Math.max(l,c,h),Math.min(l,c,h))>s)return !1}return !0}return function(o){if(this.isEmpty())return !1;this.getCenter(s),u.subVectors(this.max,s),t.subVectors(o.a,s),e.subVectors(o.b,s),n.subVectors(o.c,s),r.subVectors(e,t),i.subVectors(n,e),a.subVectors(t,n);var h=[0,-r.z,r.y,0,-i.z,i.y,0,-a.z,a.y,r.z,0,-r.x,i.z,0,-i.x,a.z,0,-a.x,-r.y,r.x,0,-i.y,i.x,0,-a.y,a.x,0];return !!c(h)&&(!!c(h=[1,0,0,0,1,0,0,0,1])&&(l.crossVectors(r,i),c(h=[l.x,l.y,l.z])))}}(),clampPoint:function(t,e){return void 0===e&&(console.warn("THREE.Box3: .clampPoint() target is now required"),e=new g),e.copy(t).clamp(this.min,this.max)},distanceToPoint:function(){var t=new g;return function(e){return t.copy(e).clamp(this.min,this.max).sub(e).length()}}(),getBoundingSphere:function(){var t=new g;return function(e){return void 0===e&&(console.warn("THREE.Box3: .getBoundingSphere() target is now required"),e=new mn),this.getCenter(e.center),e.radius=.5*this.getSize(t).length(),e}}(),intersect:function(t){return this.min.max(t.min),this.max.min(t.max),this.isEmpty()&&this.makeEmpty(),this},union:function(t){return this.min.min(t.min),this.max.max(t.max),this},applyMatrix4:(an=[new g,new g,new g,new g,new g,new g,new g,new g],function(t){return this.isEmpty()?this:(an[0].set(this.min.x,this.min.y,this.min.z).applyMatrix4(t),an[1].set(this.min.x,this.min.y,this.max.z).applyMatrix4(t),an[2].set(this.min.x,this.max.y,this.min.z).applyMatrix4(t),an[3].set(this.min.x,this.max.y,this.max.z).applyMatrix4(t),an[4].set(this.max.x,this.min.y,this.min.z).applyMatrix4(t),an[5].set(this.max.x,this.min.y,this.max.z).applyMatrix4(t),an[6].set(this.max.x,this.max.y,this.min.z).applyMatrix4(t),an[7].set(this.max.x,this.max.y,this.max.z).applyMatrix4(t),this.setFromPoints(an),this)}),translate:function(t){return this.min.add(t),this.max.add(t),this},equals:function(t){return t.min.equals(this.min)&&t.max.equals(this.max)}}),Object.assign(mn.prototype,{set:function(t,e){return this.center.copy(t),this.radius=e,this},setFromPoints:(sn=new pn,function(t,e){var n=this.center;void 0!==e?n.copy(e):sn.setFromPoints(t).getCenter(n);for(var r=0,i=0,a=t.length;i<a;i++)r=Math.max(r,n.distanceToSquared(t[i]));return this.radius=Math.sqrt(r),this}),clone:function(){return (new this.constructor).copy(this)},copy:function(t){return this.center.copy(t.center),this.radius=t.radius,this},empty:function(){return this.radius<=0},containsPoint:function(t){return t.distanceToSquared(this.center)<=this.radius*this.radius},distanceToPoint:function(t){return t.distanceTo(this.center)-this.radius},intersectsSphere:function(t){var e=this.radius+t.radius;return t.center.distanceToSquared(this.center)<=e*e},intersectsBox:function(t){return t.intersectsSphere(this)},intersectsPlane:function(t){return Math.abs(t.distanceToPoint(this.center))<=this.radius},clampPoint:function(t,e){var n=this.center.distanceToSquared(t);return void 0===e&&(console.warn("THREE.Sphere: .clampPoint() target is now required"),e=new g),e.copy(t),n>this.radius*this.radius&&(e.sub(this.center).normalize(),e.multiplyScalar(this.radius).add(this.center)),e},getBoundingBox:function(t){return void 0===t&&(console.warn("THREE.Sphere: .getBoundingBox() target is now required"),t=new pn),t.set(this.center,this.center),t.expandByScalar(this.radius),t},applyMatrix4:function(t){return this.center.applyMatrix4(t),this.radius=this.radius*t.getMaxScaleOnAxis(),this},translate:function(t){return this.center.add(t),this},equals:function(t){return t.center.equals(this.center)&&t.radius===this.radius}}),Object.assign(gn.prototype,{set:function(t,e){return this.normal.copy(t),this.constant=e,this},setComponents:function(t,e,n,r){return this.normal.set(t,e,n),this.constant=r,this},setFromNormalAndCoplanarPoint:function(t,e){return this.normal.copy(t),this.constant=-e.dot(this.normal),this},setFromCoplanarPoints:function(){var t=new g,e=new g;return function(n,r,i){var a=t.subVectors(i,r).cross(e.subVectors(n,r)).normalize();return this.setFromNormalAndCoplanarPoint(a,n),this}}(),clone:function(){return (new this.constructor).copy(this)},copy:function(t){return this.normal.copy(t.normal),this.constant=t.constant,this},normalize:function(){var t=1/this.normal.length();return this.normal.multiplyScalar(t),this.constant*=t,this},negate:function(){return this.constant*=-1,this.normal.negate(),this},distanceToPoint:function(t){return this.normal.dot(t)+this.constant},distanceToSphere:function(t){return this.distanceToPoint(t.center)-t.radius},projectPoint:function(t,e){return void 0===e&&(console.warn("THREE.Plane: .projectPoint() target is now required"),e=new g),e.copy(this.normal).multiplyScalar(-this.distanceToPoint(t)).add(t)},intersectLine:function(){var t=new g;return function(e,n){void 0===n&&(console.warn("THREE.Plane: .intersectLine() target is now required"),n=new g);var r=e.delta(t),i=this.normal.dot(r);if(0===i)return 0===this.distanceToPoint(e.start)?n.copy(e.start):void 0;var a=-(e.start.dot(this.normal)+this.constant)/i;return a<0||a>1?void 0:n.copy(r).multiplyScalar(a).add(e.start)}}(),intersectsLine:function(t){var e=this.distanceToPoint(t.start),n=this.distanceToPoint(t.end);return e<0&&n>0||n<0&&e>0},intersectsBox:function(t){return t.intersectsPlane(this)},intersectsSphere:function(t){return t.intersectsPlane(this)},coplanarPoint:function(t){return void 0===t&&(console.warn("THREE.Plane: .coplanarPoint() target is now required"),t=new g),t.copy(this.normal).multiplyScalar(-this.constant)},applyMatrix4:function(){var t=new g,e=new Qe;return function(n,r){var i=r||e.getNormalMatrix(n),a=this.coplanarPoint(t).applyMatrix4(n),o=this.normal.applyMatrix3(i).normalize();return this.constant=-a.dot(o),this}}(),translate:function(t){return this.constant-=t.dot(this.normal),this},equals:function(t){return t.normal.equals(this.normal)&&t.constant===this.constant}}),Object.assign(vn.prototype,{set:function(t,e,n,r,i,a){var o=this.planes;return o[0].copy(t),o[1].copy(e),o[2].copy(n),o[3].copy(r),o[4].copy(i),o[5].copy(a),this},clone:function(){return (new this.constructor).copy(this)},copy:function(t){for(var e=this.planes,n=0;n<6;n++)e[n].copy(t.planes[n]);return this},setFromMatrix:function(t){var e=this.planes,n=t.elements,r=n[0],i=n[1],a=n[2],o=n[3],s=n[4],u=n[5],l=n[6],c=n[7],h=n[8],f=n[9],d=n[10],p=n[11],m=n[12],g=n[13],v=n[14],y=n[15];return e[0].setComponents(o-r,c-s,p-h,y-m).normalize(),e[1].setComponents(o+r,c+s,p+h,y+m).normalize(),e[2].setComponents(o+i,c+u,p+f,y+g).normalize(),e[3].setComponents(o-i,c-u,p-f,y-g).normalize(),e[4].setComponents(o-a,c-l,p-d,y-v).normalize(),e[5].setComponents(o+a,c+l,p+d,y+v).normalize(),this},intersectsObject:(ln=new mn,function(t){var e=t.geometry;return null===e.boundingSphere&&e.computeBoundingSphere(),ln.copy(e.boundingSphere).applyMatrix4(t.matrixWorld),this.intersectsSphere(ln)}),intersectsSprite:function(){var t=new mn;return function(e){return t.center.set(0,0,0),t.radius=.7071067811865476,t.applyMatrix4(e.matrixWorld),this.intersectsSphere(t)}}(),intersectsSphere:function(t){for(var e=this.planes,n=t.center,r=-t.radius,i=0;i<6;i++){if(e[i].distanceToPoint(n)<r)return !1}return !0},intersectsBox:(un=new g,function(t){for(var e=this.planes,n=0;n<6;n++){var r=e[n];if(un.x=r.normal.x>0?t.max.x:t.min.x,un.y=r.normal.y>0?t.max.y:t.min.y,un.z=r.normal.z>0?t.max.z:t.min.z,r.distanceToPoint(un)<0)return !1}return !0}),containsPoint:function(t){for(var e=this.planes,n=0;n<6;n++)if(e[n].distanceToPoint(t)<0)return !1;return !0}});var yn={alphamap_fragment:"\n#ifdef USE_ALPHAMAP\n\n\tdiffuseColor.a *= texture2D( alphaMap, vUv ).g;\n\n#endif\n",alphamap_pars_fragment:"\n#ifdef USE_ALPHAMAP\n\n\tuniform sampler2D alphaMap;\n\n#endif\n",alphatest_fragment:"\n#ifdef ALPHATEST\n\n\tif ( diffuseColor.a < ALPHATEST ) discard;\n\n#endif\n",aomap_fragment:"\n#ifdef USE_AOMAP\n\n\t// reads channel R, compatible with a combined OcclusionRoughnessMetallic (RGB) texture\n\tfloat ambientOcclusion = ( texture2D( aoMap, vUv2 ).r - 1.0 ) * aoMapIntensity + 1.0;\n\n\treflectedLight.indirectDiffuse *= ambientOcclusion;\n\n\t#if defined( USE_ENVMAP ) && defined( PHYSICAL )\n\n\t\tfloat dotNV = saturate( dot( geometry.normal, geometry.viewDir ) );\n\n\t\treflectedLight.indirectSpecular *= computeSpecularOcclusion( dotNV, ambientOcclusion, material.specularRoughness );\n\n\t#endif\n\n#endif\n",aomap_pars_fragment:"\n#ifdef USE_AOMAP\n\n\tuniform sampler2D aoMap;\n\tuniform float aoMapIntensity;\n\n#endif\n",begin_vertex:"\nvec3 transformed = vec3( position );\n",beginnormal_vertex:"\nvec3 objectNormal = vec3( normal );\n",bsdfs:'\n\n// Analytical approximation of the DFG LUT, one half of the\n// split-sum approximation used in indirect specular lighting.\n// via \'environmentBRDF\' from "Physically Based Shading on Mobile"\n// https://www.unrealengine.com/blog/physically-based-shading-on-mobile - environmentBRDF for GGX on mobile\nvec2 integrateSpecularBRDF( const in float dotNV, const in float roughness ) {\n\tconst vec4 c0 = vec4( - 1, - 0.0275, - 0.572, 0.022 );\n\n\tconst vec4 c1 = vec4( 1, 0.0425, 1.04, - 0.04 );\n\n\tvec4 r = roughness * c0 + c1;\n\n\tfloat a004 = min( r.x * r.x, exp2( - 9.28 * dotNV ) ) * r.x + r.y;\n\n\treturn vec2( -1.04, 1.04 ) * a004 + r.zw;\n\n}\n\nfloat punctualLightIntensityToIrradianceFactor( const in float lightDistance, const in float cutoffDistance, const in float decayExponent ) {\n\n#if defined ( PHYSICALLY_CORRECT_LIGHTS )\n\n\t// based upon Frostbite 3 Moving to Physically-based Rendering\n\t// page 32, equation 26: E[window1]\n\t// https://seblagarde.files.wordpress.com/2015/07/course_notes_moving_frostbite_to_pbr_v32.pdf\n\t// this is intended to be used on spot and point lights who are represented as luminous intensity\n\t// but who must be converted to luminous irradiance for surface lighting calculation\n\tfloat distanceFalloff = 1.0 / max( pow( lightDistance, decayExponent ), 0.01 );\n\n\tif( cutoffDistance > 0.0 ) {\n\n\t\tdistanceFalloff *= pow2( saturate( 1.0 - pow4( lightDistance / cutoffDistance ) ) );\n\n\t}\n\n\treturn distanceFalloff;\n\n#else\n\n\tif( cutoffDistance > 0.0 && decayExponent > 0.0 ) {\n\n\t\treturn pow( saturate( -lightDistance / cutoffDistance + 1.0 ), decayExponent );\n\n\t}\n\n\treturn 1.0;\n\n#endif\n\n}\n\nvec3 BRDF_Diffuse_Lambert( const in vec3 diffuseColor ) {\n\n\treturn RECIPROCAL_PI * diffuseColor;\n\n} // validated\n\nvec3 F_Schlick( const in vec3 specularColor, const in float dotLH ) {\n\n\t// Original approximation by Christophe Schlick \'94\n\t// float fresnel = pow( 1.0 - dotLH, 5.0 );\n\n\t// Optimized variant (presented by Epic at SIGGRAPH \'13)\n\t// https://cdn2.unrealengine.com/Resources/files/2013SiggraphPresentationsNotes-26915738.pdf\n\tfloat fresnel = exp2( ( -5.55473 * dotLH - 6.98316 ) * dotLH );\n\n\treturn ( 1.0 - specularColor ) * fresnel + specularColor;\n\n} // validated\n\n// Microfacet Models for Refraction through Rough Surfaces - equation (34)\n// http://graphicrants.blogspot.com/2013/08/specular-brdf-reference.html\n// alpha is "roughness squared" in Disney’s reparameterization\nfloat G_GGX_Smith( const in float alpha, const in float dotNL, const in float dotNV ) {\n\n\t// geometry term (normalized) = G(l)⋅G(v) / 4(n⋅l)(n⋅v)\n\t// also see #12151\n\n\tfloat a2 = pow2( alpha );\n\n\tfloat gl = dotNL + sqrt( a2 + ( 1.0 - a2 ) * pow2( dotNL ) );\n\tfloat gv = dotNV + sqrt( a2 + ( 1.0 - a2 ) * pow2( dotNV ) );\n\n\treturn 1.0 / ( gl * gv );\n\n} // validated\n\n// Moving Frostbite to Physically Based Rendering 3.0 - page 12, listing 2\n// https://seblagarde.files.wordpress.com/2015/07/course_notes_moving_frostbite_to_pbr_v32.pdf\nfloat G_GGX_SmithCorrelated( const in float alpha, const in float dotNL, const in float dotNV ) {\n\n\tfloat a2 = pow2( alpha );\n\n\t// dotNL and dotNV are explicitly swapped. This is not a mistake.\n\tfloat gv = dotNL * sqrt( a2 + ( 1.0 - a2 ) * pow2( dotNV ) );\n\tfloat gl = dotNV * sqrt( a2 + ( 1.0 - a2 ) * pow2( dotNL ) );\n\n\treturn 0.5 / max( gv + gl, EPSILON );\n\n}\n\n// Microfacet Models for Refraction through Rough Surfaces - equation (33)\n// http://graphicrants.blogspot.com/2013/08/specular-brdf-reference.html\n// alpha is "roughness squared" in Disney’s reparameterization\nfloat D_GGX( const in float alpha, const in float dotNH ) {\n\n\tfloat a2 = pow2( alpha );\n\n\tfloat denom = pow2( dotNH ) * ( a2 - 1.0 ) + 1.0; // avoid alpha = 0 with dotNH = 1\n\n\treturn RECIPROCAL_PI * a2 / pow2( denom );\n\n}\n\n// GGX Distribution, Schlick Fresnel, GGX-Smith Visibility\nvec3 BRDF_Specular_GGX( const in IncidentLight incidentLight, const in GeometricContext geometry, const in vec3 specularColor, const in float roughness ) {\n\n\tfloat alpha = pow2( roughness ); // UE4\'s roughness\n\n\tvec3 halfDir = normalize( incidentLight.direction + geometry.viewDir );\n\n\tfloat dotNL = saturate( dot( geometry.normal, incidentLight.direction ) );\n\tfloat dotNV = saturate( dot( geometry.normal, geometry.viewDir ) );\n\tfloat dotNH = saturate( dot( geometry.normal, halfDir ) );\n\tfloat dotLH = saturate( dot( incidentLight.direction, halfDir ) );\n\n\tvec3 F = F_Schlick( specularColor, dotLH );\n\n\tfloat G = G_GGX_SmithCorrelated( alpha, dotNL, dotNV );\n\n\tfloat D = D_GGX( alpha, dotNH );\n\n\treturn F * ( G * D );\n\n} // validated\n\n// Rect Area Light\n\n// Real-Time Polygonal-Light Shading with Linearly Transformed Cosines\n// by Eric Heitz, Jonathan Dupuy, Stephen Hill and David Neubelt\n// code: https://github.com/selfshadow/ltc_code/\n\nvec2 LTC_Uv( const in vec3 N, const in vec3 V, const in float roughness ) {\n\n\tconst float LUT_SIZE  = 64.0;\n\tconst float LUT_SCALE = ( LUT_SIZE - 1.0 ) / LUT_SIZE;\n\tconst float LUT_BIAS  = 0.5 / LUT_SIZE;\n\n\tfloat dotNV = saturate( dot( N, V ) );\n\n\t// texture parameterized by sqrt( GGX alpha ) and sqrt( 1 - cos( theta ) )\n\tvec2 uv = vec2( roughness, sqrt( 1.0 - dotNV ) );\n\n\tuv = uv * LUT_SCALE + LUT_BIAS;\n\n\treturn uv;\n\n}\n\nfloat LTC_ClippedSphereFormFactor( const in vec3 f ) {\n\n\t// Real-Time Area Lighting: a Journey from Research to Production (p.102)\n\t// An approximation of the form factor of a horizon-clipped rectangle.\n\n\tfloat l = length( f );\n\n\treturn max( ( l * l + f.z ) / ( l + 1.0 ), 0.0 );\n\n}\n\nvec3 LTC_EdgeVectorFormFactor( const in vec3 v1, const in vec3 v2 ) {\n\n\tfloat x = dot( v1, v2 );\n\n\tfloat y = abs( x );\n\n\t// rational polynomial approximation to theta / sin( theta ) / 2PI\n\tfloat a = 0.8543985 + ( 0.4965155 + 0.0145206 * y ) * y;\n\tfloat b = 3.4175940 + ( 4.1616724 + y ) * y;\n\tfloat v = a / b;\n\n\tfloat theta_sintheta = ( x > 0.0 ) ? v : 0.5 * inversesqrt( max( 1.0 - x * x, 1e-7 ) ) - v;\n\n\treturn cross( v1, v2 ) * theta_sintheta;\n\n}\n\nvec3 LTC_Evaluate( const in vec3 N, const in vec3 V, const in vec3 P, const in mat3 mInv, const in vec3 rectCoords[ 4 ] ) {\n\n\t// bail if point is on back side of plane of light\n\t// assumes ccw winding order of light vertices\n\tvec3 v1 = rectCoords[ 1 ] - rectCoords[ 0 ];\n\tvec3 v2 = rectCoords[ 3 ] - rectCoords[ 0 ];\n\tvec3 lightNormal = cross( v1, v2 );\n\n\tif( dot( lightNormal, P - rectCoords[ 0 ] ) < 0.0 ) return vec3( 0.0 );\n\n\t// construct orthonormal basis around N\n\tvec3 T1, T2;\n\tT1 = normalize( V - N * dot( V, N ) );\n\tT2 = - cross( N, T1 ); // negated from paper; possibly due to a different handedness of world coordinate system\n\n\t// compute transform\n\tmat3 mat = mInv * transposeMat3( mat3( T1, T2, N ) );\n\n\t// transform rect\n\tvec3 coords[ 4 ];\n\tcoords[ 0 ] = mat * ( rectCoords[ 0 ] - P );\n\tcoords[ 1 ] = mat * ( rectCoords[ 1 ] - P );\n\tcoords[ 2 ] = mat * ( rectCoords[ 2 ] - P );\n\tcoords[ 3 ] = mat * ( rectCoords[ 3 ] - P );\n\n\t// project rect onto sphere\n\tcoords[ 0 ] = normalize( coords[ 0 ] );\n\tcoords[ 1 ] = normalize( coords[ 1 ] );\n\tcoords[ 2 ] = normalize( coords[ 2 ] );\n\tcoords[ 3 ] = normalize( coords[ 3 ] );\n\n\t// calculate vector form factor\n\tvec3 vectorFormFactor = vec3( 0.0 );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 0 ], coords[ 1 ] );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 1 ], coords[ 2 ] );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 2 ], coords[ 3 ] );\n\tvectorFormFactor += LTC_EdgeVectorFormFactor( coords[ 3 ], coords[ 0 ] );\n\n\t// adjust for horizon clipping\n\tfloat result = LTC_ClippedSphereFormFactor( vectorFormFactor );\n\n/*\n\t// alternate method of adjusting for horizon clipping (see referece)\n\t// refactoring required\n\tfloat len = length( vectorFormFactor );\n\tfloat z = vectorFormFactor.z / len;\n\n\tconst float LUT_SIZE  = 64.0;\n\tconst float LUT_SCALE = ( LUT_SIZE - 1.0 ) / LUT_SIZE;\n\tconst float LUT_BIAS  = 0.5 / LUT_SIZE;\n\n\t// tabulated horizon-clipped sphere, apparently...\n\tvec2 uv = vec2( z * 0.5 + 0.5, len );\n\tuv = uv * LUT_SCALE + LUT_BIAS;\n\n\tfloat scale = texture2D( ltc_2, uv ).w;\n\n\tfloat result = len * scale;\n*/\n\n\treturn vec3( result );\n\n}\n\n// End Rect Area Light\n\n// ref: https://www.unrealengine.com/blog/physically-based-shading-on-mobile - environmentBRDF for GGX on mobile\nvec3 BRDF_Specular_GGX_Environment( const in GeometricContext geometry, const in vec3 specularColor, const in float roughness ) {\n\n\tfloat dotNV = saturate( dot( geometry.normal, geometry.viewDir ) );\n\n\tvec2 brdf = integrateSpecularBRDF( dotNV, roughness );\n\n\treturn specularColor * brdf.x + brdf.y;\n\n} // validated\n\n// Fdez-Agüera\'s "Multiple-Scattering Microfacet Model for Real-Time Image Based Lighting"\n// Approximates multiscattering in order to preserve energy.\n// http://www.jcgt.org/published/0008/01/03/\nvoid BRDF_Specular_Multiscattering_Environment( const in GeometricContext geometry, const in vec3 specularColor, const in float roughness, inout vec3 singleScatter, inout vec3 multiScatter ) {\n\n\tfloat dotNV = saturate( dot( geometry.normal, geometry.viewDir ) );\n\n\tvec3 F = F_Schlick( specularColor, dotNV );\n\tvec2 brdf = integrateSpecularBRDF( dotNV, roughness );\n\tvec3 FssEss = F * brdf.x + brdf.y;\n\n\tfloat Ess = brdf.x + brdf.y;\n\tfloat Ems = 1.0 - Ess;\n\n\t// Paper incorrect indicates coefficient is PI/21, and will\n\t// be corrected to 1/21 in future updates.\n\tvec3 Favg = specularColor + ( 1.0 - specularColor ) * 0.047619; // 1/21\n\tvec3 Fms = FssEss * Favg / ( 1.0 - Ems * Favg );\n\n\tsingleScatter += FssEss;\n\tmultiScatter += Fms * Ems;\n\n}\n\nfloat G_BlinnPhong_Implicit( /* const in float dotNL, const in float dotNV */ ) {\n\n\t// geometry term is (n dot l)(n dot v) / 4(n dot l)(n dot v)\n\treturn 0.25;\n\n}\n\nfloat D_BlinnPhong( const in float shininess, const in float dotNH ) {\n\n\treturn RECIPROCAL_PI * ( shininess * 0.5 + 1.0 ) * pow( dotNH, shininess );\n\n}\n\nvec3 BRDF_Specular_BlinnPhong( const in IncidentLight incidentLight, const in GeometricContext geometry, const in vec3 specularColor, const in float shininess ) {\n\n\tvec3 halfDir = normalize( incidentLight.direction + geometry.viewDir );\n\n\t//float dotNL = saturate( dot( geometry.normal, incidentLight.direction ) );\n\t//float dotNV = saturate( dot( geometry.normal, geometry.viewDir ) );\n\tfloat dotNH = saturate( dot( geometry.normal, halfDir ) );\n\tfloat dotLH = saturate( dot( incidentLight.direction, halfDir ) );\n\n\tvec3 F = F_Schlick( specularColor, dotLH );\n\n\tfloat G = G_BlinnPhong_Implicit( /* dotNL, dotNV */ );\n\n\tfloat D = D_BlinnPhong( shininess, dotNH );\n\n\treturn F * ( G * D );\n\n} // validated\n\n// source: http://simonstechblog.blogspot.ca/2011/12/microfacet-brdf.html\nfloat GGXRoughnessToBlinnExponent( const in float ggxRoughness ) {\n\treturn ( 2.0 / pow2( ggxRoughness + 0.0001 ) - 2.0 );\n}\n\nfloat BlinnExponentToGGXRoughness( const in float blinnExponent ) {\n\treturn sqrt( 2.0 / ( blinnExponent + 2.0 ) );\n}\n',bumpmap_pars_fragment:"\n#ifdef USE_BUMPMAP\n\n\tuniform sampler2D bumpMap;\n\tuniform float bumpScale;\n\n\t// Bump Mapping Unparametrized Surfaces on the GPU by Morten S. Mikkelsen\n\t// http://api.unrealengine.com/attachments/Engine/Rendering/LightingAndShadows/BumpMappingWithoutTangentSpace/mm_sfgrad_bump.pdf\n\n\t// Evaluate the derivative of the height w.r.t. screen-space using forward differencing (listing 2)\n\n\tvec2 dHdxy_fwd() {\n\n\t\tvec2 dSTdx = dFdx( vUv );\n\t\tvec2 dSTdy = dFdy( vUv );\n\n\t\tfloat Hll = bumpScale * texture2D( bumpMap, vUv ).x;\n\t\tfloat dBx = bumpScale * texture2D( bumpMap, vUv + dSTdx ).x - Hll;\n\t\tfloat dBy = bumpScale * texture2D( bumpMap, vUv + dSTdy ).x - Hll;\n\n\t\treturn vec2( dBx, dBy );\n\n\t}\n\n\tvec3 perturbNormalArb( vec3 surf_pos, vec3 surf_norm, vec2 dHdxy ) {\n\n\t\t// Workaround for Adreno 3XX dFd*( vec3 ) bug. See #9988\n\n\t\tvec3 vSigmaX = vec3( dFdx( surf_pos.x ), dFdx( surf_pos.y ), dFdx( surf_pos.z ) );\n\t\tvec3 vSigmaY = vec3( dFdy( surf_pos.x ), dFdy( surf_pos.y ), dFdy( surf_pos.z ) );\n\t\tvec3 vN = surf_norm;\t\t// normalized\n\n\t\tvec3 R1 = cross( vSigmaY, vN );\n\t\tvec3 R2 = cross( vN, vSigmaX );\n\n\t\tfloat fDet = dot( vSigmaX, R1 );\n\n\t\tfDet *= ( float( gl_FrontFacing ) * 2.0 - 1.0 );\n\n\t\tvec3 vGrad = sign( fDet ) * ( dHdxy.x * R1 + dHdxy.y * R2 );\n\t\treturn normalize( abs( fDet ) * surf_norm - vGrad );\n\n\t}\n\n#endif\n",clipping_planes_fragment:"\n#if NUM_CLIPPING_PLANES > 0\n\n\tvec4 plane;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < UNION_CLIPPING_PLANES; i ++ ) {\n\n\t\tplane = clippingPlanes[ i ];\n\t\tif ( dot( vViewPosition, plane.xyz ) > plane.w ) discard;\n\n\t}\n\n\t#if UNION_CLIPPING_PLANES < NUM_CLIPPING_PLANES\n\n\t\tbool clipped = true;\n\n\t\t#pragma unroll_loop\n\t\tfor ( int i = UNION_CLIPPING_PLANES; i < NUM_CLIPPING_PLANES; i ++ ) {\n\n\t\t\tplane = clippingPlanes[ i ];\n\t\t\tclipped = ( dot( vViewPosition, plane.xyz ) > plane.w ) && clipped;\n\n\t\t}\n\n\t\tif ( clipped ) discard;\n\n\t#endif\n\n#endif\n",clipping_planes_pars_fragment:"\n#if NUM_CLIPPING_PLANES > 0\n\n\t#if ! defined( PHYSICAL ) && ! defined( PHONG ) && ! defined( MATCAP )\n\t\tvarying vec3 vViewPosition;\n\t#endif\n\n\tuniform vec4 clippingPlanes[ NUM_CLIPPING_PLANES ];\n\n#endif\n",clipping_planes_pars_vertex:"\n#if NUM_CLIPPING_PLANES > 0 && ! defined( PHYSICAL ) && ! defined( PHONG ) && ! defined( MATCAP )\n\tvarying vec3 vViewPosition;\n#endif\n",clipping_planes_vertex:"\n#if NUM_CLIPPING_PLANES > 0 && ! defined( PHYSICAL ) && ! defined( PHONG ) && ! defined( MATCAP )\n\tvViewPosition = - mvPosition.xyz;\n#endif\n",color_fragment:"\n#ifdef USE_COLOR\n\n\tdiffuseColor.rgb *= vColor;\n\n#endif\n",color_pars_fragment:"\n#ifdef USE_COLOR\n\n\tvarying vec3 vColor;\n\n#endif\n",color_pars_vertex:"\n#ifdef USE_COLOR\n\n\tvarying vec3 vColor;\n\n#endif\n",color_vertex:"\n#ifdef USE_COLOR\n\n\tvColor.xyz = color.xyz;\n\n#endif\n",common:"\n#define PI 3.14159265359\n#define PI2 6.28318530718\n#define PI_HALF 1.5707963267949\n#define RECIPROCAL_PI 0.31830988618\n#define RECIPROCAL_PI2 0.15915494\n#define LOG2 1.442695\n#define EPSILON 1e-6\n\n#define saturate(a) clamp( a, 0.0, 1.0 )\n#define whiteCompliment(a) ( 1.0 - saturate( a ) )\n\nfloat pow2( const in float x ) { return x*x; }\nfloat pow3( const in float x ) { return x*x*x; }\nfloat pow4( const in float x ) { float x2 = x*x; return x2*x2; }\nfloat average( const in vec3 color ) { return dot( color, vec3( 0.3333 ) ); }\n// expects values in the range of [0,1]x[0,1], returns values in the [0,1] range.\n// do not collapse into a single function per: http://byteblacksmith.com/improvements-to-the-canonical-one-liner-glsl-rand-for-opengl-es-2-0/\nhighp float rand( const in vec2 uv ) {\n\tconst highp float a = 12.9898, b = 78.233, c = 43758.5453;\n\thighp float dt = dot( uv.xy, vec2( a,b ) ), sn = mod( dt, PI );\n\treturn fract(sin(sn) * c);\n}\n\nstruct IncidentLight {\n\tvec3 color;\n\tvec3 direction;\n\tbool visible;\n};\n\nstruct ReflectedLight {\n\tvec3 directDiffuse;\n\tvec3 directSpecular;\n\tvec3 indirectDiffuse;\n\tvec3 indirectSpecular;\n};\n\nstruct GeometricContext {\n\tvec3 position;\n\tvec3 normal;\n\tvec3 viewDir;\n};\n\nvec3 transformDirection( in vec3 dir, in mat4 matrix ) {\n\n\treturn normalize( ( matrix * vec4( dir, 0.0 ) ).xyz );\n\n}\n\n// http://en.wikibooks.org/wiki/GLSL_Programming/Applying_Matrix_Transformations\nvec3 inverseTransformDirection( in vec3 dir, in mat4 matrix ) {\n\n\treturn normalize( ( vec4( dir, 0.0 ) * matrix ).xyz );\n\n}\n\nvec3 projectOnPlane(in vec3 point, in vec3 pointOnPlane, in vec3 planeNormal ) {\n\n\tfloat distance = dot( planeNormal, point - pointOnPlane );\n\n\treturn - distance * planeNormal + point;\n\n}\n\nfloat sideOfPlane( in vec3 point, in vec3 pointOnPlane, in vec3 planeNormal ) {\n\n\treturn sign( dot( point - pointOnPlane, planeNormal ) );\n\n}\n\nvec3 linePlaneIntersect( in vec3 pointOnLine, in vec3 lineDirection, in vec3 pointOnPlane, in vec3 planeNormal ) {\n\n\treturn lineDirection * ( dot( planeNormal, pointOnPlane - pointOnLine ) / dot( planeNormal, lineDirection ) ) + pointOnLine;\n\n}\n\nmat3 transposeMat3( const in mat3 m ) {\n\n\tmat3 tmp;\n\n\ttmp[ 0 ] = vec3( m[ 0 ].x, m[ 1 ].x, m[ 2 ].x );\n\ttmp[ 1 ] = vec3( m[ 0 ].y, m[ 1 ].y, m[ 2 ].y );\n\ttmp[ 2 ] = vec3( m[ 0 ].z, m[ 1 ].z, m[ 2 ].z );\n\n\treturn tmp;\n\n}\n\n// https://en.wikipedia.org/wiki/Relative_luminance\nfloat linearToRelativeLuminance( const in vec3 color ) {\n\n\tvec3 weights = vec3( 0.2126, 0.7152, 0.0722 );\n\n\treturn dot( weights, color.rgb );\n\n}\n",cube_uv_reflection_fragment:"\n#ifdef ENVMAP_TYPE_CUBE_UV\n\n#define cubeUV_textureSize (1024.0)\n\nint getFaceFromDirection(vec3 direction) {\n\tvec3 absDirection = abs(direction);\n\tint face = -1;\n\tif( absDirection.x > absDirection.z ) {\n\t\tif(absDirection.x > absDirection.y )\n\t\t\tface = direction.x > 0.0 ? 0 : 3;\n\t\telse\n\t\t\tface = direction.y > 0.0 ? 1 : 4;\n\t}\n\telse {\n\t\tif(absDirection.z > absDirection.y )\n\t\t\tface = direction.z > 0.0 ? 2 : 5;\n\t\telse\n\t\t\tface = direction.y > 0.0 ? 1 : 4;\n\t}\n\treturn face;\n}\n#define cubeUV_maxLods1  (log2(cubeUV_textureSize*0.25) - 1.0)\n#define cubeUV_rangeClamp (exp2((6.0 - 1.0) * 2.0))\n\nvec2 MipLevelInfo( vec3 vec, float roughnessLevel, float roughness ) {\n\tfloat scale = exp2(cubeUV_maxLods1 - roughnessLevel);\n\tfloat dxRoughness = dFdx(roughness);\n\tfloat dyRoughness = dFdy(roughness);\n\tvec3 dx = dFdx( vec * scale * dxRoughness );\n\tvec3 dy = dFdy( vec * scale * dyRoughness );\n\tfloat d = max( dot( dx, dx ), dot( dy, dy ) );\n\t// Clamp the value to the max mip level counts. hard coded to 6 mips\n\td = clamp(d, 1.0, cubeUV_rangeClamp);\n\tfloat mipLevel = 0.5 * log2(d);\n\treturn vec2(floor(mipLevel), fract(mipLevel));\n}\n\n#define cubeUV_maxLods2 (log2(cubeUV_textureSize*0.25) - 2.0)\n#define cubeUV_rcpTextureSize (1.0 / cubeUV_textureSize)\n\nvec2 getCubeUV(vec3 direction, float roughnessLevel, float mipLevel) {\n\tmipLevel = roughnessLevel > cubeUV_maxLods2 - 3.0 ? 0.0 : mipLevel;\n\tfloat a = 16.0 * cubeUV_rcpTextureSize;\n\n\tvec2 exp2_packed = exp2( vec2( roughnessLevel, mipLevel ) );\n\tvec2 rcp_exp2_packed = vec2( 1.0 ) / exp2_packed;\n\t// float powScale = exp2(roughnessLevel + mipLevel);\n\tfloat powScale = exp2_packed.x * exp2_packed.y;\n\t// float scale =  1.0 / exp2(roughnessLevel + 2.0 + mipLevel);\n\tfloat scale = rcp_exp2_packed.x * rcp_exp2_packed.y * 0.25;\n\t// float mipOffset = 0.75*(1.0 - 1.0/exp2(mipLevel))/exp2(roughnessLevel);\n\tfloat mipOffset = 0.75*(1.0 - rcp_exp2_packed.y) * rcp_exp2_packed.x;\n\n\tbool bRes = mipLevel == 0.0;\n\tscale =  bRes && (scale < a) ? a : scale;\n\n\tvec3 r;\n\tvec2 offset;\n\tint face = getFaceFromDirection(direction);\n\n\tfloat rcpPowScale = 1.0 / powScale;\n\n\tif( face == 0) {\n\t\tr = vec3(direction.x, -direction.z, direction.y);\n\t\toffset = vec2(0.0+mipOffset,0.75 * rcpPowScale);\n\t\toffset.y = bRes && (offset.y < 2.0*a) ? a : offset.y;\n\t}\n\telse if( face == 1) {\n\t\tr = vec3(direction.y, direction.x, direction.z);\n\t\toffset = vec2(scale+mipOffset, 0.75 * rcpPowScale);\n\t\toffset.y = bRes && (offset.y < 2.0*a) ? a : offset.y;\n\t}\n\telse if( face == 2) {\n\t\tr = vec3(direction.z, direction.x, direction.y);\n\t\toffset = vec2(2.0*scale+mipOffset, 0.75 * rcpPowScale);\n\t\toffset.y = bRes && (offset.y < 2.0*a) ? a : offset.y;\n\t}\n\telse if( face == 3) {\n\t\tr = vec3(direction.x, direction.z, direction.y);\n\t\toffset = vec2(0.0+mipOffset,0.5 * rcpPowScale);\n\t\toffset.y = bRes && (offset.y < 2.0*a) ? 0.0 : offset.y;\n\t}\n\telse if( face == 4) {\n\t\tr = vec3(direction.y, direction.x, -direction.z);\n\t\toffset = vec2(scale+mipOffset, 0.5 * rcpPowScale);\n\t\toffset.y = bRes && (offset.y < 2.0*a) ? 0.0 : offset.y;\n\t}\n\telse {\n\t\tr = vec3(direction.z, -direction.x, direction.y);\n\t\toffset = vec2(2.0*scale+mipOffset, 0.5 * rcpPowScale);\n\t\toffset.y = bRes && (offset.y < 2.0*a) ? 0.0 : offset.y;\n\t}\n\tr = normalize(r);\n\tfloat texelOffset = 0.5 * cubeUV_rcpTextureSize;\n\tvec2 s = ( r.yz / abs( r.x ) + vec2( 1.0 ) ) * 0.5;\n\tvec2 base = offset + vec2( texelOffset );\n\treturn base + s * ( scale - 2.0 * texelOffset );\n}\n\n#define cubeUV_maxLods3 (log2(cubeUV_textureSize*0.25) - 3.0)\n\nvec4 textureCubeUV( sampler2D envMap, vec3 reflectedDirection, float roughness ) {\n\tfloat roughnessVal = roughness* cubeUV_maxLods3;\n\tfloat r1 = floor(roughnessVal);\n\tfloat r2 = r1 + 1.0;\n\tfloat t = fract(roughnessVal);\n\tvec2 mipInfo = MipLevelInfo(reflectedDirection, r1, roughness);\n\tfloat s = mipInfo.y;\n\tfloat level0 = mipInfo.x;\n\tfloat level1 = level0 + 1.0;\n\tlevel1 = level1 > 5.0 ? 5.0 : level1;\n\n\t// round to nearest mipmap if we are not interpolating.\n\tlevel0 += min( floor( s + 0.5 ), 5.0 );\n\n\t// Tri linear interpolation.\n\tvec2 uv_10 = getCubeUV(reflectedDirection, r1, level0);\n\tvec4 color10 = envMapTexelToLinear(texture2D(envMap, uv_10));\n\n\tvec2 uv_20 = getCubeUV(reflectedDirection, r2, level0);\n\tvec4 color20 = envMapTexelToLinear(texture2D(envMap, uv_20));\n\n\tvec4 result = mix(color10, color20, t);\n\n\treturn vec4(result.rgb, 1.0);\n}\n\n#endif\n",defaultnormal_vertex:"\nvec3 transformedNormal = normalMatrix * objectNormal;\n\n#ifdef FLIP_SIDED\n\n\ttransformedNormal = - transformedNormal;\n\n#endif\n",displacementmap_pars_vertex:"\n#ifdef USE_DISPLACEMENTMAP\n\n\tuniform sampler2D displacementMap;\n\tuniform float displacementScale;\n\tuniform float displacementBias;\n\n#endif\n",displacementmap_vertex:"\n#ifdef USE_DISPLACEMENTMAP\n\n\ttransformed += normalize( objectNormal ) * ( texture2D( displacementMap, uv ).x * displacementScale + displacementBias );\n\n#endif\n",emissivemap_fragment:"\n#ifdef USE_EMISSIVEMAP\n\n\tvec4 emissiveColor = texture2D( emissiveMap, vUv );\n\n\temissiveColor.rgb = emissiveMapTexelToLinear( emissiveColor ).rgb;\n\n\ttotalEmissiveRadiance *= emissiveColor.rgb;\n\n#endif\n",emissivemap_pars_fragment:"\n#ifdef USE_EMISSIVEMAP\n\n\tuniform sampler2D emissiveMap;\n\n#endif\n",encodings_fragment:"\n  gl_FragColor = linearToOutputTexel( gl_FragColor );\n",encodings_pars_fragment:"\n// For a discussion of what this is, please read this: http://lousodrome.net/blog/light/2013/05/26/gamma-correct-and-hdr-rendering-in-a-32-bits-buffer/\n\nvec4 LinearToLinear( in vec4 value ) {\n\treturn value;\n}\n\nvec4 GammaToLinear( in vec4 value, in float gammaFactor ) {\n\treturn vec4( pow( value.rgb, vec3( gammaFactor ) ), value.a );\n}\n\nvec4 LinearToGamma( in vec4 value, in float gammaFactor ) {\n\treturn vec4( pow( value.rgb, vec3( 1.0 / gammaFactor ) ), value.a );\n}\n\nvec4 sRGBToLinear( in vec4 value ) {\n\treturn vec4( mix( pow( value.rgb * 0.9478672986 + vec3( 0.0521327014 ), vec3( 2.4 ) ), value.rgb * 0.0773993808, vec3( lessThanEqual( value.rgb, vec3( 0.04045 ) ) ) ), value.a );\n}\n\nvec4 LinearTosRGB( in vec4 value ) {\n\treturn vec4( mix( pow( value.rgb, vec3( 0.41666 ) ) * 1.055 - vec3( 0.055 ), value.rgb * 12.92, vec3( lessThanEqual( value.rgb, vec3( 0.0031308 ) ) ) ), value.a );\n}\n\nvec4 RGBEToLinear( in vec4 value ) {\n\treturn vec4( value.rgb * exp2( value.a * 255.0 - 128.0 ), 1.0 );\n}\n\nvec4 LinearToRGBE( in vec4 value ) {\n\tfloat maxComponent = max( max( value.r, value.g ), value.b );\n\tfloat fExp = clamp( ceil( log2( maxComponent ) ), -128.0, 127.0 );\n\treturn vec4( value.rgb / exp2( fExp ), ( fExp + 128.0 ) / 255.0 );\n//  return vec4( value.brg, ( 3.0 + 128.0 ) / 256.0 );\n}\n\n// reference: http://iwasbeingirony.blogspot.ca/2010/06/difference-between-rgbm-and-rgbd.html\nvec4 RGBMToLinear( in vec4 value, in float maxRange ) {\n\treturn vec4( value.rgb * value.a * maxRange, 1.0 );\n}\n\nvec4 LinearToRGBM( in vec4 value, in float maxRange ) {\n\tfloat maxRGB = max( value.r, max( value.g, value.b ) );\n\tfloat M = clamp( maxRGB / maxRange, 0.0, 1.0 );\n\tM = ceil( M * 255.0 ) / 255.0;\n\treturn vec4( value.rgb / ( M * maxRange ), M );\n}\n\n// reference: http://iwasbeingirony.blogspot.ca/2010/06/difference-between-rgbm-and-rgbd.html\nvec4 RGBDToLinear( in vec4 value, in float maxRange ) {\n\treturn vec4( value.rgb * ( ( maxRange / 255.0 ) / value.a ), 1.0 );\n}\n\nvec4 LinearToRGBD( in vec4 value, in float maxRange ) {\n\tfloat maxRGB = max( value.r, max( value.g, value.b ) );\n\tfloat D = max( maxRange / maxRGB, 1.0 );\n\tD = min( floor( D ) / 255.0, 1.0 );\n\treturn vec4( value.rgb * ( D * ( 255.0 / maxRange ) ), D );\n}\n\n// LogLuv reference: http://graphicrants.blogspot.ca/2009/04/rgbm-color-encoding.html\n\n// M matrix, for encoding\nconst mat3 cLogLuvM = mat3( 0.2209, 0.3390, 0.4184, 0.1138, 0.6780, 0.7319, 0.0102, 0.1130, 0.2969 );\nvec4 LinearToLogLuv( in vec4 value )  {\n\tvec3 Xp_Y_XYZp = cLogLuvM * value.rgb;\n\tXp_Y_XYZp = max( Xp_Y_XYZp, vec3( 1e-6, 1e-6, 1e-6 ) );\n\tvec4 vResult;\n\tvResult.xy = Xp_Y_XYZp.xy / Xp_Y_XYZp.z;\n\tfloat Le = 2.0 * log2(Xp_Y_XYZp.y) + 127.0;\n\tvResult.w = fract( Le );\n\tvResult.z = ( Le - ( floor( vResult.w * 255.0 ) ) / 255.0 ) / 255.0;\n\treturn vResult;\n}\n\n// Inverse M matrix, for decoding\nconst mat3 cLogLuvInverseM = mat3( 6.0014, -2.7008, -1.7996, -1.3320, 3.1029, -5.7721, 0.3008, -1.0882, 5.6268 );\nvec4 LogLuvToLinear( in vec4 value ) {\n\tfloat Le = value.z * 255.0 + value.w;\n\tvec3 Xp_Y_XYZp;\n\tXp_Y_XYZp.y = exp2( ( Le - 127.0 ) / 2.0 );\n\tXp_Y_XYZp.z = Xp_Y_XYZp.y / value.y;\n\tXp_Y_XYZp.x = value.x * Xp_Y_XYZp.z;\n\tvec3 vRGB = cLogLuvInverseM * Xp_Y_XYZp.rgb;\n\treturn vec4( max( vRGB, 0.0 ), 1.0 );\n}\n",envmap_fragment:"\n#ifdef USE_ENVMAP\n\n\t#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG )\n\n\t\tvec3 cameraToVertex = normalize( vWorldPosition - cameraPosition );\n\n\t\t// Transforming Normal Vectors with the Inverse Transformation\n\t\tvec3 worldNormal = inverseTransformDirection( normal, viewMatrix );\n\n\t\t#ifdef ENVMAP_MODE_REFLECTION\n\n\t\t\tvec3 reflectVec = reflect( cameraToVertex, worldNormal );\n\n\t\t#else\n\n\t\t\tvec3 reflectVec = refract( cameraToVertex, worldNormal, refractionRatio );\n\n\t\t#endif\n\n\t#else\n\n\t\tvec3 reflectVec = vReflect;\n\n\t#endif\n\n\t#ifdef ENVMAP_TYPE_CUBE\n\n\t\tvec4 envColor = textureCube( envMap, vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );\n\n\t#elif defined( ENVMAP_TYPE_EQUIREC )\n\n\t\tvec2 sampleUV;\n\n\t\treflectVec = normalize( reflectVec );\n\n\t\tsampleUV.y = asin( clamp( reflectVec.y, - 1.0, 1.0 ) ) * RECIPROCAL_PI + 0.5;\n\n\t\tsampleUV.x = atan( reflectVec.z, reflectVec.x ) * RECIPROCAL_PI2 + 0.5;\n\n\t\tvec4 envColor = texture2D( envMap, sampleUV );\n\n\t#elif defined( ENVMAP_TYPE_SPHERE )\n\n\t\treflectVec = normalize( reflectVec );\n\n\t\tvec3 reflectView = normalize( ( viewMatrix * vec4( reflectVec, 0.0 ) ).xyz + vec3( 0.0, 0.0, 1.0 ) );\n\n\t\tvec4 envColor = texture2D( envMap, reflectView.xy * 0.5 + 0.5 );\n\n\t#else\n\n\t\tvec4 envColor = vec4( 0.0 );\n\n\t#endif\n\n\tenvColor = envMapTexelToLinear( envColor );\n\n\t#ifdef ENVMAP_BLENDING_MULTIPLY\n\n\t\toutgoingLight = mix( outgoingLight, outgoingLight * envColor.xyz, specularStrength * reflectivity );\n\n\t#elif defined( ENVMAP_BLENDING_MIX )\n\n\t\toutgoingLight = mix( outgoingLight, envColor.xyz, specularStrength * reflectivity );\n\n\t#elif defined( ENVMAP_BLENDING_ADD )\n\n\t\toutgoingLight += envColor.xyz * specularStrength * reflectivity;\n\n\t#endif\n\n#endif\n",envmap_pars_fragment:"\n#if defined( USE_ENVMAP ) || defined( PHYSICAL )\n\tuniform float reflectivity;\n\tuniform float envMapIntensity;\n#endif\n\n#ifdef USE_ENVMAP\n\n\t#if ! defined( PHYSICAL ) && ( defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG ) )\n\t\tvarying vec3 vWorldPosition;\n\t#endif\n\n\t#ifdef ENVMAP_TYPE_CUBE\n\t\tuniform samplerCube envMap;\n\t#else\n\t\tuniform sampler2D envMap;\n\t#endif\n\tuniform float flipEnvMap;\n\tuniform int maxMipLevel;\n\n\t#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG ) || defined( PHYSICAL )\n\t\tuniform float refractionRatio;\n\t#else\n\t\tvarying vec3 vReflect;\n\t#endif\n\n#endif\n",envmap_pars_vertex:"\n#ifdef USE_ENVMAP\n\n\t#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG )\n\t\tvarying vec3 vWorldPosition;\n\n\t#else\n\n\t\tvarying vec3 vReflect;\n\t\tuniform float refractionRatio;\n\n\t#endif\n\n#endif\n",envmap_physical_pars_fragment:"\n#if defined( USE_ENVMAP ) && defined( PHYSICAL )\n\n\tvec3 getLightProbeIndirectIrradiance( /*const in SpecularLightProbe specularLightProbe,*/ const in GeometricContext geometry, const in int maxMIPLevel ) {\n\n\t\tvec3 worldNormal = inverseTransformDirection( geometry.normal, viewMatrix );\n\n\t\t#ifdef ENVMAP_TYPE_CUBE\n\n\t\t\tvec3 queryVec = vec3( flipEnvMap * worldNormal.x, worldNormal.yz );\n\n\t\t\t// TODO: replace with properly filtered cubemaps and access the irradiance LOD level, be it the last LOD level\n\t\t\t// of a specular cubemap, or just the default level of a specially created irradiance cubemap.\n\n\t\t\t#ifdef TEXTURE_LOD_EXT\n\n\t\t\t\tvec4 envMapColor = textureCubeLodEXT( envMap, queryVec, float( maxMIPLevel ) );\n\n\t\t\t#else\n\n\t\t\t\t// force the bias high to get the last LOD level as it is the most blurred.\n\t\t\t\tvec4 envMapColor = textureCube( envMap, queryVec, float( maxMIPLevel ) );\n\n\t\t\t#endif\n\n\t\t\tenvMapColor.rgb = envMapTexelToLinear( envMapColor ).rgb;\n\n\t\t#elif defined( ENVMAP_TYPE_CUBE_UV )\n\n\t\t\tvec3 queryVec = vec3( flipEnvMap * worldNormal.x, worldNormal.yz );\n\t\t\tvec4 envMapColor = textureCubeUV( envMap, queryVec, 1.0 );\n\n\t\t#else\n\n\t\t\tvec4 envMapColor = vec4( 0.0 );\n\n\t\t#endif\n\n\t\treturn PI * envMapColor.rgb * envMapIntensity;\n\n\t}\n\n\t// taken from here: http://casual-effects.blogspot.ca/2011/08/plausible-environment-lighting-in-two.html\n\tfloat getSpecularMIPLevel( const in float blinnShininessExponent, const in int maxMIPLevel ) {\n\n\t\t//float envMapWidth = pow( 2.0, maxMIPLevelScalar );\n\t\t//float desiredMIPLevel = log2( envMapWidth * sqrt( 3.0 ) ) - 0.5 * log2( pow2( blinnShininessExponent ) + 1.0 );\n\n\t\tfloat maxMIPLevelScalar = float( maxMIPLevel );\n\t\tfloat desiredMIPLevel = maxMIPLevelScalar + 0.79248 - 0.5 * log2( pow2( blinnShininessExponent ) + 1.0 );\n\n\t\t// clamp to allowable LOD ranges.\n\t\treturn clamp( desiredMIPLevel, 0.0, maxMIPLevelScalar );\n\n\t}\n\n\tvec3 getLightProbeIndirectRadiance( /*const in SpecularLightProbe specularLightProbe,*/ const in GeometricContext geometry, const in float blinnShininessExponent, const in int maxMIPLevel ) {\n\n\t\t#ifdef ENVMAP_MODE_REFLECTION\n\n\t\t\tvec3 reflectVec = reflect( -geometry.viewDir, geometry.normal );\n\n\t\t#else\n\n\t\t\tvec3 reflectVec = refract( -geometry.viewDir, geometry.normal, refractionRatio );\n\n\t\t#endif\n\n\t\treflectVec = inverseTransformDirection( reflectVec, viewMatrix );\n\n\t\tfloat specularMIPLevel = getSpecularMIPLevel( blinnShininessExponent, maxMIPLevel );\n\n\t\t#ifdef ENVMAP_TYPE_CUBE\n\n\t\t\tvec3 queryReflectVec = vec3( flipEnvMap * reflectVec.x, reflectVec.yz );\n\n\t\t\t#ifdef TEXTURE_LOD_EXT\n\n\t\t\t\tvec4 envMapColor = textureCubeLodEXT( envMap, queryReflectVec, specularMIPLevel );\n\n\t\t\t#else\n\n\t\t\t\tvec4 envMapColor = textureCube( envMap, queryReflectVec, specularMIPLevel );\n\n\t\t\t#endif\n\n\t\t\tenvMapColor.rgb = envMapTexelToLinear( envMapColor ).rgb;\n\n\t\t#elif defined( ENVMAP_TYPE_CUBE_UV )\n\n\t\t\tvec3 queryReflectVec = vec3( flipEnvMap * reflectVec.x, reflectVec.yz );\n\t\t\tvec4 envMapColor = textureCubeUV( envMap, queryReflectVec, BlinnExponentToGGXRoughness(blinnShininessExponent ));\n\n\t\t#elif defined( ENVMAP_TYPE_EQUIREC )\n\n\t\t\tvec2 sampleUV;\n\t\t\tsampleUV.y = asin( clamp( reflectVec.y, - 1.0, 1.0 ) ) * RECIPROCAL_PI + 0.5;\n\t\t\tsampleUV.x = atan( reflectVec.z, reflectVec.x ) * RECIPROCAL_PI2 + 0.5;\n\n\t\t\t#ifdef TEXTURE_LOD_EXT\n\n\t\t\t\tvec4 envMapColor = texture2DLodEXT( envMap, sampleUV, specularMIPLevel );\n\n\t\t\t#else\n\n\t\t\t\tvec4 envMapColor = texture2D( envMap, sampleUV, specularMIPLevel );\n\n\t\t\t#endif\n\n\t\t\tenvMapColor.rgb = envMapTexelToLinear( envMapColor ).rgb;\n\n\t\t#elif defined( ENVMAP_TYPE_SPHERE )\n\n\t\t\tvec3 reflectView = normalize( ( viewMatrix * vec4( reflectVec, 0.0 ) ).xyz + vec3( 0.0,0.0,1.0 ) );\n\n\t\t\t#ifdef TEXTURE_LOD_EXT\n\n\t\t\t\tvec4 envMapColor = texture2DLodEXT( envMap, reflectView.xy * 0.5 + 0.5, specularMIPLevel );\n\n\t\t\t#else\n\n\t\t\t\tvec4 envMapColor = texture2D( envMap, reflectView.xy * 0.5 + 0.5, specularMIPLevel );\n\n\t\t\t#endif\n\n\t\t\tenvMapColor.rgb = envMapTexelToLinear( envMapColor ).rgb;\n\n\t\t#endif\n\n\t\treturn envMapColor.rgb * envMapIntensity;\n\n\t}\n\n#endif\n",envmap_vertex:"\n#ifdef USE_ENVMAP\n\n\t#if defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( PHONG )\n\n\t\tvWorldPosition = worldPosition.xyz;\n\n\t#else\n\n\t\tvec3 cameraToVertex = normalize( worldPosition.xyz - cameraPosition );\n\n\t\tvec3 worldNormal = inverseTransformDirection( transformedNormal, viewMatrix );\n\n\t\t#ifdef ENVMAP_MODE_REFLECTION\n\n\t\t\tvReflect = reflect( cameraToVertex, worldNormal );\n\n\t\t#else\n\n\t\t\tvReflect = refract( cameraToVertex, worldNormal, refractionRatio );\n\n\t\t#endif\n\n\t#endif\n\n#endif\n",fog_vertex:"\n#ifdef USE_FOG\n\n\tfogDepth = -mvPosition.z;\n\n#endif\n",fog_pars_vertex:"\n#ifdef USE_FOG\n\n\tvarying float fogDepth;\n\n#endif\n",fog_fragment:"\n#ifdef USE_FOG\n\n\t#ifdef FOG_EXP2\n\n\t\tfloat fogFactor = whiteCompliment( exp2( - fogDensity * fogDensity * fogDepth * fogDepth * LOG2 ) );\n\n\t#else\n\n\t\tfloat fogFactor = smoothstep( fogNear, fogFar, fogDepth );\n\n\t#endif\n\n\tgl_FragColor.rgb = mix( gl_FragColor.rgb, fogColor, fogFactor );\n\n#endif\n",fog_pars_fragment:"\n#ifdef USE_FOG\n\n\tuniform vec3 fogColor;\n\tvarying float fogDepth;\n\n\t#ifdef FOG_EXP2\n\n\t\tuniform float fogDensity;\n\n\t#else\n\n\t\tuniform float fogNear;\n\t\tuniform float fogFar;\n\n\t#endif\n\n#endif\n",gradientmap_pars_fragment:"\n#ifdef TOON\n\n\tuniform sampler2D gradientMap;\n\n\tvec3 getGradientIrradiance( vec3 normal, vec3 lightDirection ) {\n\n\t\t// dotNL will be from -1.0 to 1.0\n\t\tfloat dotNL = dot( normal, lightDirection );\n\t\tvec2 coord = vec2( dotNL * 0.5 + 0.5, 0.0 );\n\n\t\t#ifdef USE_GRADIENTMAP\n\n\t\t\treturn texture2D( gradientMap, coord ).rgb;\n\n\t\t#else\n\n\t\t\treturn ( coord.x < 0.7 ) ? vec3( 0.7 ) : vec3( 1.0 );\n\n\t\t#endif\n\n\n\t}\n\n#endif\n",lightmap_fragment:"\n#ifdef USE_LIGHTMAP\n\n\treflectedLight.indirectDiffuse += PI * texture2D( lightMap, vUv2 ).xyz * lightMapIntensity; // factor of PI should not be present; included here to prevent breakage\n\n#endif\n",lightmap_pars_fragment:"\n#ifdef USE_LIGHTMAP\n\n\tuniform sampler2D lightMap;\n\tuniform float lightMapIntensity;\n\n#endif\n",lights_lambert_vertex:"\nvec3 diffuse = vec3( 1.0 );\n\nGeometricContext geometry;\ngeometry.position = mvPosition.xyz;\ngeometry.normal = normalize( transformedNormal );\ngeometry.viewDir = normalize( -mvPosition.xyz );\n\nGeometricContext backGeometry;\nbackGeometry.position = geometry.position;\nbackGeometry.normal = -geometry.normal;\nbackGeometry.viewDir = geometry.viewDir;\n\nvLightFront = vec3( 0.0 );\nvIndirectFront = vec3( 0.0 );\n\n#ifdef DOUBLE_SIDED\n\tvLightBack = vec3( 0.0 );\n\tvIndirectBack = vec3( 0.0 );\n#endif\n\nIncidentLight directLight;\nfloat dotNL;\nvec3 directLightColor_Diffuse;\n\n#if NUM_POINT_LIGHTS > 0\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_POINT_LIGHTS; i ++ ) {\n\n\t\tgetPointDirectLightIrradiance( pointLights[ i ], geometry, directLight );\n\n\t\tdotNL = dot( geometry.normal, directLight.direction );\n\t\tdirectLightColor_Diffuse = PI * directLight.color;\n\n\t\tvLightFront += saturate( dotNL ) * directLightColor_Diffuse;\n\n\t\t#ifdef DOUBLE_SIDED\n\n\t\t\tvLightBack += saturate( -dotNL ) * directLightColor_Diffuse;\n\n\t\t#endif\n\n\t}\n\n#endif\n\n#if NUM_SPOT_LIGHTS > 0\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_SPOT_LIGHTS; i ++ ) {\n\n\t\tgetSpotDirectLightIrradiance( spotLights[ i ], geometry, directLight );\n\n\t\tdotNL = dot( geometry.normal, directLight.direction );\n\t\tdirectLightColor_Diffuse = PI * directLight.color;\n\n\t\tvLightFront += saturate( dotNL ) * directLightColor_Diffuse;\n\n\t\t#ifdef DOUBLE_SIDED\n\n\t\t\tvLightBack += saturate( -dotNL ) * directLightColor_Diffuse;\n\n\t\t#endif\n\t}\n\n#endif\n\n/*\n#if NUM_RECT_AREA_LIGHTS > 0\n\n\tfor ( int i = 0; i < NUM_RECT_AREA_LIGHTS; i ++ ) {\n\n\t\t// TODO (abelnation): implement\n\n\t}\n\n#endif\n*/\n\n#if NUM_DIR_LIGHTS > 0\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_DIR_LIGHTS; i ++ ) {\n\n\t\tgetDirectionalDirectLightIrradiance( directionalLights[ i ], geometry, directLight );\n\n\t\tdotNL = dot( geometry.normal, directLight.direction );\n\t\tdirectLightColor_Diffuse = PI * directLight.color;\n\n\t\tvLightFront += saturate( dotNL ) * directLightColor_Diffuse;\n\n\t\t#ifdef DOUBLE_SIDED\n\n\t\t\tvLightBack += saturate( -dotNL ) * directLightColor_Diffuse;\n\n\t\t#endif\n\n\t}\n\n#endif\n\n#if NUM_HEMI_LIGHTS > 0\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_HEMI_LIGHTS; i ++ ) {\n\n\t\tvIndirectFront += getHemisphereLightIrradiance( hemisphereLights[ i ], geometry );\n\n\t\t#ifdef DOUBLE_SIDED\n\n\t\t\tvIndirectBack += getHemisphereLightIrradiance( hemisphereLights[ i ], backGeometry );\n\n\t\t#endif\n\n\t}\n\n#endif\n",lights_pars_begin:"\nuniform vec3 ambientLightColor;\n\nvec3 getAmbientLightIrradiance( const in vec3 ambientLightColor ) {\n\n\tvec3 irradiance = ambientLightColor;\n\n\t#ifndef PHYSICALLY_CORRECT_LIGHTS\n\n\t\tirradiance *= PI;\n\n\t#endif\n\n\treturn irradiance;\n\n}\n\n#if NUM_DIR_LIGHTS > 0\n\n\tstruct DirectionalLight {\n\t\tvec3 direction;\n\t\tvec3 color;\n\n\t\tint shadow;\n\t\tfloat shadowBias;\n\t\tfloat shadowRadius;\n\t\tvec2 shadowMapSize;\n\t};\n\n\tuniform DirectionalLight directionalLights[ NUM_DIR_LIGHTS ];\n\n\tvoid getDirectionalDirectLightIrradiance( const in DirectionalLight directionalLight, const in GeometricContext geometry, out IncidentLight directLight ) {\n\n\t\tdirectLight.color = directionalLight.color;\n\t\tdirectLight.direction = directionalLight.direction;\n\t\tdirectLight.visible = true;\n\n\t}\n\n#endif\n\n\n#if NUM_POINT_LIGHTS > 0\n\n\tstruct PointLight {\n\t\tvec3 position;\n\t\tvec3 color;\n\t\tfloat distance;\n\t\tfloat decay;\n\n\t\tint shadow;\n\t\tfloat shadowBias;\n\t\tfloat shadowRadius;\n\t\tvec2 shadowMapSize;\n\t\tfloat shadowCameraNear;\n\t\tfloat shadowCameraFar;\n\t};\n\n\tuniform PointLight pointLights[ NUM_POINT_LIGHTS ];\n\n\t// directLight is an out parameter as having it as a return value caused compiler errors on some devices\n\tvoid getPointDirectLightIrradiance( const in PointLight pointLight, const in GeometricContext geometry, out IncidentLight directLight ) {\n\n\t\tvec3 lVector = pointLight.position - geometry.position;\n\t\tdirectLight.direction = normalize( lVector );\n\n\t\tfloat lightDistance = length( lVector );\n\n\t\tdirectLight.color = pointLight.color;\n\t\tdirectLight.color *= punctualLightIntensityToIrradianceFactor( lightDistance, pointLight.distance, pointLight.decay );\n\t\tdirectLight.visible = ( directLight.color != vec3( 0.0 ) );\n\n\t}\n\n#endif\n\n\n#if NUM_SPOT_LIGHTS > 0\n\n\tstruct SpotLight {\n\t\tvec3 position;\n\t\tvec3 direction;\n\t\tvec3 color;\n\t\tfloat distance;\n\t\tfloat decay;\n\t\tfloat coneCos;\n\t\tfloat penumbraCos;\n\n\t\tint shadow;\n\t\tfloat shadowBias;\n\t\tfloat shadowRadius;\n\t\tvec2 shadowMapSize;\n\t};\n\n\tuniform SpotLight spotLights[ NUM_SPOT_LIGHTS ];\n\n\t// directLight is an out parameter as having it as a return value caused compiler errors on some devices\n\tvoid getSpotDirectLightIrradiance( const in SpotLight spotLight, const in GeometricContext geometry, out IncidentLight directLight  ) {\n\n\t\tvec3 lVector = spotLight.position - geometry.position;\n\t\tdirectLight.direction = normalize( lVector );\n\n\t\tfloat lightDistance = length( lVector );\n\t\tfloat angleCos = dot( directLight.direction, spotLight.direction );\n\n\t\tif ( angleCos > spotLight.coneCos ) {\n\n\t\t\tfloat spotEffect = smoothstep( spotLight.coneCos, spotLight.penumbraCos, angleCos );\n\n\t\t\tdirectLight.color = spotLight.color;\n\t\t\tdirectLight.color *= spotEffect * punctualLightIntensityToIrradianceFactor( lightDistance, spotLight.distance, spotLight.decay );\n\t\t\tdirectLight.visible = true;\n\n\t\t} else {\n\n\t\t\tdirectLight.color = vec3( 0.0 );\n\t\t\tdirectLight.visible = false;\n\n\t\t}\n\t}\n\n#endif\n\n\n#if NUM_RECT_AREA_LIGHTS > 0\n\n\tstruct RectAreaLight {\n\t\tvec3 color;\n\t\tvec3 position;\n\t\tvec3 halfWidth;\n\t\tvec3 halfHeight;\n\t};\n\n\t// Pre-computed values of LinearTransformedCosine approximation of BRDF\n\t// BRDF approximation Texture is 64x64\n\tuniform sampler2D ltc_1; // RGBA Float\n\tuniform sampler2D ltc_2; // RGBA Float\n\n\tuniform RectAreaLight rectAreaLights[ NUM_RECT_AREA_LIGHTS ];\n\n#endif\n\n\n#if NUM_HEMI_LIGHTS > 0\n\n\tstruct HemisphereLight {\n\t\tvec3 direction;\n\t\tvec3 skyColor;\n\t\tvec3 groundColor;\n\t};\n\n\tuniform HemisphereLight hemisphereLights[ NUM_HEMI_LIGHTS ];\n\n\tvec3 getHemisphereLightIrradiance( const in HemisphereLight hemiLight, const in GeometricContext geometry ) {\n\n\t\tfloat dotNL = dot( geometry.normal, hemiLight.direction );\n\t\tfloat hemiDiffuseWeight = 0.5 * dotNL + 0.5;\n\n\t\tvec3 irradiance = mix( hemiLight.groundColor, hemiLight.skyColor, hemiDiffuseWeight );\n\n\t\t#ifndef PHYSICALLY_CORRECT_LIGHTS\n\n\t\t\tirradiance *= PI;\n\n\t\t#endif\n\n\t\treturn irradiance;\n\n\t}\n\n#endif\n",lights_phong_fragment:"\nBlinnPhongMaterial material;\nmaterial.diffuseColor = diffuseColor.rgb;\nmaterial.specularColor = specular;\nmaterial.specularShininess = shininess;\nmaterial.specularStrength = specularStrength;\n",lights_phong_pars_fragment:"\nvarying vec3 vViewPosition;\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n\nstruct BlinnPhongMaterial {\n\n\tvec3\tdiffuseColor;\n\tvec3\tspecularColor;\n\tfloat\tspecularShininess;\n\tfloat\tspecularStrength;\n\n};\n\nvoid RE_Direct_BlinnPhong( const in IncidentLight directLight, const in GeometricContext geometry, const in BlinnPhongMaterial material, inout ReflectedLight reflectedLight ) {\n\n\t#ifdef TOON\n\n\t\tvec3 irradiance = getGradientIrradiance( geometry.normal, directLight.direction ) * directLight.color;\n\n\t#else\n\n\t\tfloat dotNL = saturate( dot( geometry.normal, directLight.direction ) );\n\t\tvec3 irradiance = dotNL * directLight.color;\n\n\t#endif\n\n\t#ifndef PHYSICALLY_CORRECT_LIGHTS\n\n\t\tirradiance *= PI; // punctual light\n\n\t#endif\n\n\treflectedLight.directDiffuse += irradiance * BRDF_Diffuse_Lambert( material.diffuseColor );\n\n\treflectedLight.directSpecular += irradiance * BRDF_Specular_BlinnPhong( directLight, geometry, material.specularColor, material.specularShininess ) * material.specularStrength;\n\n}\n\nvoid RE_IndirectDiffuse_BlinnPhong( const in vec3 irradiance, const in GeometricContext geometry, const in BlinnPhongMaterial material, inout ReflectedLight reflectedLight ) {\n\n\treflectedLight.indirectDiffuse += irradiance * BRDF_Diffuse_Lambert( material.diffuseColor );\n\n}\n\n#define RE_Direct\t\t\t\tRE_Direct_BlinnPhong\n#define RE_IndirectDiffuse\t\tRE_IndirectDiffuse_BlinnPhong\n\n#define Material_LightProbeLOD( material )\t(0)\n",lights_physical_fragment:"\nPhysicalMaterial material;\nmaterial.diffuseColor = diffuseColor.rgb * ( 1.0 - metalnessFactor );\nmaterial.specularRoughness = clamp( roughnessFactor, 0.04, 1.0 );\n#ifdef STANDARD\n\tmaterial.specularColor = mix( vec3( DEFAULT_SPECULAR_COEFFICIENT ), diffuseColor.rgb, metalnessFactor );\n#else\n\tmaterial.specularColor = mix( vec3( MAXIMUM_SPECULAR_COEFFICIENT * pow2( reflectivity ) ), diffuseColor.rgb, metalnessFactor );\n\tmaterial.clearCoat = saturate( clearCoat ); // Burley clearcoat model\n\tmaterial.clearCoatRoughness = clamp( clearCoatRoughness, 0.04, 1.0 );\n#endif\n",lights_physical_pars_fragment:"\nstruct PhysicalMaterial {\n\n\tvec3\tdiffuseColor;\n\tfloat\tspecularRoughness;\n\tvec3\tspecularColor;\n\n\t#ifndef STANDARD\n\t\tfloat clearCoat;\n\t\tfloat clearCoatRoughness;\n\t#endif\n\n};\n\n#define MAXIMUM_SPECULAR_COEFFICIENT 0.16\n#define DEFAULT_SPECULAR_COEFFICIENT 0.04\n\n// Clear coat directional hemishperical reflectance (this approximation should be improved)\nfloat clearCoatDHRApprox( const in float roughness, const in float dotNL ) {\n\n\treturn DEFAULT_SPECULAR_COEFFICIENT + ( 1.0 - DEFAULT_SPECULAR_COEFFICIENT ) * ( pow( 1.0 - dotNL, 5.0 ) * pow( 1.0 - roughness, 2.0 ) );\n\n}\n\n#if NUM_RECT_AREA_LIGHTS > 0\n\n\tvoid RE_Direct_RectArea_Physical( const in RectAreaLight rectAreaLight, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight ) {\n\n\t\tvec3 normal = geometry.normal;\n\t\tvec3 viewDir = geometry.viewDir;\n\t\tvec3 position = geometry.position;\n\t\tvec3 lightPos = rectAreaLight.position;\n\t\tvec3 halfWidth = rectAreaLight.halfWidth;\n\t\tvec3 halfHeight = rectAreaLight.halfHeight;\n\t\tvec3 lightColor = rectAreaLight.color;\n\t\tfloat roughness = material.specularRoughness;\n\n\t\tvec3 rectCoords[ 4 ];\n\t\trectCoords[ 0 ] = lightPos + halfWidth - halfHeight; // counterclockwise; light shines in local neg z direction\n\t\trectCoords[ 1 ] = lightPos - halfWidth - halfHeight;\n\t\trectCoords[ 2 ] = lightPos - halfWidth + halfHeight;\n\t\trectCoords[ 3 ] = lightPos + halfWidth + halfHeight;\n\n\t\tvec2 uv = LTC_Uv( normal, viewDir, roughness );\n\n\t\tvec4 t1 = texture2D( ltc_1, uv );\n\t\tvec4 t2 = texture2D( ltc_2, uv );\n\n\t\tmat3 mInv = mat3(\n\t\t\tvec3( t1.x, 0, t1.y ),\n\t\t\tvec3(    0, 1,    0 ),\n\t\t\tvec3( t1.z, 0, t1.w )\n\t\t);\n\n\t\t// LTC Fresnel Approximation by Stephen Hill\n\t\t// http://blog.selfshadow.com/publications/s2016-advances/s2016_ltc_fresnel.pdf\n\t\tvec3 fresnel = ( material.specularColor * t2.x + ( vec3( 1.0 ) - material.specularColor ) * t2.y );\n\n\t\treflectedLight.directSpecular += lightColor * fresnel * LTC_Evaluate( normal, viewDir, position, mInv, rectCoords );\n\n\t\treflectedLight.directDiffuse += lightColor * material.diffuseColor * LTC_Evaluate( normal, viewDir, position, mat3( 1.0 ), rectCoords );\n\n\t}\n\n#endif\n\nvoid RE_Direct_Physical( const in IncidentLight directLight, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight ) {\n\n\tfloat dotNL = saturate( dot( geometry.normal, directLight.direction ) );\n\n\tvec3 irradiance = dotNL * directLight.color;\n\n\t#ifndef PHYSICALLY_CORRECT_LIGHTS\n\n\t\tirradiance *= PI; // punctual light\n\n\t#endif\n\n\t#ifndef STANDARD\n\t\tfloat clearCoatDHR = material.clearCoat * clearCoatDHRApprox( material.clearCoatRoughness, dotNL );\n\t#else\n\t\tfloat clearCoatDHR = 0.0;\n\t#endif\n\n\treflectedLight.directSpecular += ( 1.0 - clearCoatDHR ) * irradiance * BRDF_Specular_GGX( directLight, geometry, material.specularColor, material.specularRoughness );\n\n\treflectedLight.directDiffuse += ( 1.0 - clearCoatDHR ) * irradiance * BRDF_Diffuse_Lambert( material.diffuseColor );\n\n\t#ifndef STANDARD\n\n\t\treflectedLight.directSpecular += irradiance * material.clearCoat * BRDF_Specular_GGX( directLight, geometry, vec3( DEFAULT_SPECULAR_COEFFICIENT ), material.clearCoatRoughness );\n\n\t#endif\n\n}\n\nvoid RE_IndirectDiffuse_Physical( const in vec3 irradiance, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight ) {\n\n\t// Defer to the IndirectSpecular function to compute\n\t// the indirectDiffuse if energy preservation is enabled.\n\t#ifndef ENVMAP_TYPE_CUBE_UV\n\n\t\treflectedLight.indirectDiffuse += irradiance * BRDF_Diffuse_Lambert( material.diffuseColor );\n\n\t#endif\n\n}\n\nvoid RE_IndirectSpecular_Physical( const in vec3 radiance, const in vec3 irradiance, const in vec3 clearCoatRadiance, const in GeometricContext geometry, const in PhysicalMaterial material, inout ReflectedLight reflectedLight) {\n\n\t#ifndef STANDARD\n\t\tfloat dotNV = saturate( dot( geometry.normal, geometry.viewDir ) );\n\t\tfloat dotNL = dotNV;\n\t\tfloat clearCoatDHR = material.clearCoat * clearCoatDHRApprox( material.clearCoatRoughness, dotNL );\n\t#else\n\t\tfloat clearCoatDHR = 0.0;\n\t#endif\n\n\tfloat clearCoatInv = 1.0 - clearCoatDHR;\n\n\t// Both indirect specular and diffuse light accumulate here\n\t// if energy preservation enabled, and PMREM provided.\n\t#if defined( ENVMAP_TYPE_CUBE_UV )\n\n\t\tvec3 singleScattering = vec3( 0.0 );\n\t\tvec3 multiScattering = vec3( 0.0 );\n\t\tvec3 cosineWeightedIrradiance = irradiance * RECIPROCAL_PI;\n\n\t\tBRDF_Specular_Multiscattering_Environment( geometry, material.specularColor, material.specularRoughness, singleScattering, multiScattering );\n\n\t\t// The multiscattering paper uses the below formula for calculating diffuse \n\t\t// for dielectrics, but this is already handled when initially computing the \n\t\t// specular and diffuse color, so we can just use the diffuseColor directly.\n\t\t//vec3 diffuse = material.diffuseColor * ( 1.0 - ( singleScattering + multiScattering ) );\n\t\tvec3 diffuse = material.diffuseColor;\n\n\t\treflectedLight.indirectSpecular += clearCoatInv * radiance * singleScattering;\n\t\treflectedLight.indirectDiffuse += multiScattering * cosineWeightedIrradiance;\n\t\treflectedLight.indirectDiffuse += diffuse * cosineWeightedIrradiance;\n\n\t#else\n\n\t\treflectedLight.indirectSpecular += clearCoatInv * radiance * BRDF_Specular_GGX_Environment( geometry, material.specularColor, material.specularRoughness );\n\n\t#endif\n\n\t#ifndef STANDARD\n\n\t\treflectedLight.indirectSpecular += clearCoatRadiance * material.clearCoat * BRDF_Specular_GGX_Environment( geometry, vec3( DEFAULT_SPECULAR_COEFFICIENT ), material.clearCoatRoughness );\n\n\t#endif\n}\n\n#define RE_Direct\t\t\t\tRE_Direct_Physical\n#define RE_Direct_RectArea\t\tRE_Direct_RectArea_Physical\n#define RE_IndirectDiffuse\t\tRE_IndirectDiffuse_Physical\n#define RE_IndirectSpecular\t\tRE_IndirectSpecular_Physical\n\n#define Material_BlinnShininessExponent( material )   GGXRoughnessToBlinnExponent( material.specularRoughness )\n#define Material_ClearCoat_BlinnShininessExponent( material )   GGXRoughnessToBlinnExponent( material.clearCoatRoughness )\n\n// ref: https://seblagarde.files.wordpress.com/2015/07/course_notes_moving_frostbite_to_pbr_v32.pdf\nfloat computeSpecularOcclusion( const in float dotNV, const in float ambientOcclusion, const in float roughness ) {\n\n\treturn saturate( pow( dotNV + ambientOcclusion, exp2( - 16.0 * roughness - 1.0 ) ) - 1.0 + ambientOcclusion );\n\n}\n",lights_fragment_begin:"\n/**\n * This is a template that can be used to light a material, it uses pluggable\n * RenderEquations (RE)for specific lighting scenarios.\n *\n * Instructions for use:\n * - Ensure that both RE_Direct, RE_IndirectDiffuse and RE_IndirectSpecular are defined\n * - If you have defined an RE_IndirectSpecular, you need to also provide a Material_LightProbeLOD. <---- ???\n * - Create a material parameter that is to be passed as the third parameter to your lighting functions.\n *\n * TODO:\n * - Add area light support.\n * - Add sphere light support.\n * - Add diffuse light probe (irradiance cubemap) support.\n */\n\nGeometricContext geometry;\n\ngeometry.position = - vViewPosition;\ngeometry.normal = normal;\ngeometry.viewDir = normalize( vViewPosition );\n\nIncidentLight directLight;\n\n#if ( NUM_POINT_LIGHTS > 0 ) && defined( RE_Direct )\n\n\tPointLight pointLight;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_POINT_LIGHTS; i ++ ) {\n\n\t\tpointLight = pointLights[ i ];\n\n\t\tgetPointDirectLightIrradiance( pointLight, geometry, directLight );\n\n\t\t#ifdef USE_SHADOWMAP\n\t\tdirectLight.color *= all( bvec2( pointLight.shadow, directLight.visible ) ) ? getPointShadow( pointShadowMap[ i ], pointLight.shadowMapSize, pointLight.shadowBias, pointLight.shadowRadius, vPointShadowCoord[ i ], pointLight.shadowCameraNear, pointLight.shadowCameraFar ) : 1.0;\n\t\t#endif\n\n\t\tRE_Direct( directLight, geometry, material, reflectedLight );\n\n\t}\n\n#endif\n\n#if ( NUM_SPOT_LIGHTS > 0 ) && defined( RE_Direct )\n\n\tSpotLight spotLight;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_SPOT_LIGHTS; i ++ ) {\n\n\t\tspotLight = spotLights[ i ];\n\n\t\tgetSpotDirectLightIrradiance( spotLight, geometry, directLight );\n\n\t\t#ifdef USE_SHADOWMAP\n\t\tdirectLight.color *= all( bvec2( spotLight.shadow, directLight.visible ) ) ? getShadow( spotShadowMap[ i ], spotLight.shadowMapSize, spotLight.shadowBias, spotLight.shadowRadius, vSpotShadowCoord[ i ] ) : 1.0;\n\t\t#endif\n\n\t\tRE_Direct( directLight, geometry, material, reflectedLight );\n\n\t}\n\n#endif\n\n#if ( NUM_DIR_LIGHTS > 0 ) && defined( RE_Direct )\n\n\tDirectionalLight directionalLight;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_DIR_LIGHTS; i ++ ) {\n\n\t\tdirectionalLight = directionalLights[ i ];\n\n\t\tgetDirectionalDirectLightIrradiance( directionalLight, geometry, directLight );\n\n\t\t#ifdef USE_SHADOWMAP\n\t\tdirectLight.color *= all( bvec2( directionalLight.shadow, directLight.visible ) ) ? getShadow( directionalShadowMap[ i ], directionalLight.shadowMapSize, directionalLight.shadowBias, directionalLight.shadowRadius, vDirectionalShadowCoord[ i ] ) : 1.0;\n\t\t#endif\n\n\t\tRE_Direct( directLight, geometry, material, reflectedLight );\n\n\t}\n\n#endif\n\n#if ( NUM_RECT_AREA_LIGHTS > 0 ) && defined( RE_Direct_RectArea )\n\n\tRectAreaLight rectAreaLight;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_RECT_AREA_LIGHTS; i ++ ) {\n\n\t\trectAreaLight = rectAreaLights[ i ];\n\t\tRE_Direct_RectArea( rectAreaLight, geometry, material, reflectedLight );\n\n\t}\n\n#endif\n\n#if defined( RE_IndirectDiffuse )\n\n\tvec3 irradiance = getAmbientLightIrradiance( ambientLightColor );\n\n\t#if ( NUM_HEMI_LIGHTS > 0 )\n\n\t\t#pragma unroll_loop\n\t\tfor ( int i = 0; i < NUM_HEMI_LIGHTS; i ++ ) {\n\n\t\t\tirradiance += getHemisphereLightIrradiance( hemisphereLights[ i ], geometry );\n\n\t\t}\n\n\t#endif\n\n#endif\n\n#if defined( RE_IndirectSpecular )\n\n\tvec3 radiance = vec3( 0.0 );\n\tvec3 clearCoatRadiance = vec3( 0.0 );\n\n#endif\n",lights_fragment_maps:"\n#if defined( RE_IndirectDiffuse )\n\n\t#ifdef USE_LIGHTMAP\n\n\t\tvec3 lightMapIrradiance = texture2D( lightMap, vUv2 ).xyz * lightMapIntensity;\n\n\t\t#ifndef PHYSICALLY_CORRECT_LIGHTS\n\n\t\t\tlightMapIrradiance *= PI; // factor of PI should not be present; included here to prevent breakage\n\n\t\t#endif\n\n\t\tirradiance += lightMapIrradiance;\n\n\t#endif\n\n\t#if defined( USE_ENVMAP ) && defined( PHYSICAL ) && defined( ENVMAP_TYPE_CUBE_UV )\n\n\t\tirradiance += getLightProbeIndirectIrradiance( /*lightProbe,*/ geometry, maxMipLevel );\n\n\t#endif\n\n#endif\n\n#if defined( USE_ENVMAP ) && defined( RE_IndirectSpecular )\n\n\tradiance += getLightProbeIndirectRadiance( /*specularLightProbe,*/ geometry, Material_BlinnShininessExponent( material ), maxMipLevel );\n\n\t#ifndef STANDARD\n\t\tclearCoatRadiance += getLightProbeIndirectRadiance( /*specularLightProbe,*/ geometry, Material_ClearCoat_BlinnShininessExponent( material ), maxMipLevel );\n\t#endif\n\n#endif\n",lights_fragment_end:"\n#if defined( RE_IndirectDiffuse )\n\n\tRE_IndirectDiffuse( irradiance, geometry, material, reflectedLight );\n\n#endif\n\n#if defined( RE_IndirectSpecular )\n\n\tRE_IndirectSpecular( radiance, irradiance, clearCoatRadiance, geometry, material, reflectedLight );\n\n#endif\n",logdepthbuf_fragment:"\n#if defined( USE_LOGDEPTHBUF ) && defined( USE_LOGDEPTHBUF_EXT )\n\n\tgl_FragDepthEXT = log2( vFragDepth ) * logDepthBufFC * 0.5;\n\n#endif\n",logdepthbuf_pars_fragment:"\n#if defined( USE_LOGDEPTHBUF ) && defined( USE_LOGDEPTHBUF_EXT )\n\n\tuniform float logDepthBufFC;\n\tvarying float vFragDepth;\n\n#endif\n",logdepthbuf_pars_vertex:"\n#ifdef USE_LOGDEPTHBUF\n\n\t#ifdef USE_LOGDEPTHBUF_EXT\n\n\t\tvarying float vFragDepth;\n\n\t#else\n\n\t\tuniform float logDepthBufFC;\n\n\t#endif\n\n#endif\n",logdepthbuf_vertex:"\n#ifdef USE_LOGDEPTHBUF\n\n\t#ifdef USE_LOGDEPTHBUF_EXT\n\n\t\tvFragDepth = 1.0 + gl_Position.w;\n\n\t#else\n\n\t\tgl_Position.z = log2( max( EPSILON, gl_Position.w + 1.0 ) ) * logDepthBufFC - 1.0;\n\n\t\tgl_Position.z *= gl_Position.w;\n\n\t#endif\n\n#endif\n",map_fragment:"\n#ifdef USE_MAP\n\n\tvec4 texelColor = texture2D( map, vUv );\n\n\ttexelColor = mapTexelToLinear( texelColor );\n\tdiffuseColor *= texelColor;\n\n#endif\n",map_pars_fragment:"\n#ifdef USE_MAP\n\n\tuniform sampler2D map;\n\n#endif\n",map_particle_fragment:"\n#ifdef USE_MAP\n\n\tvec2 uv = ( uvTransform * vec3( gl_PointCoord.x, 1.0 - gl_PointCoord.y, 1 ) ).xy;\n\tvec4 mapTexel = texture2D( map, uv );\n\tdiffuseColor *= mapTexelToLinear( mapTexel );\n\n#endif\n",map_particle_pars_fragment:"\n#ifdef USE_MAP\n\n\tuniform mat3 uvTransform;\n\tuniform sampler2D map;\n\n#endif\n",metalnessmap_fragment:"\nfloat metalnessFactor = metalness;\n\n#ifdef USE_METALNESSMAP\n\n\tvec4 texelMetalness = texture2D( metalnessMap, vUv );\n\n\t// reads channel B, compatible with a combined OcclusionRoughnessMetallic (RGB) texture\n\tmetalnessFactor *= texelMetalness.b;\n\n#endif\n",metalnessmap_pars_fragment:"\n#ifdef USE_METALNESSMAP\n\n\tuniform sampler2D metalnessMap;\n\n#endif\n",morphnormal_vertex:"\n#ifdef USE_MORPHNORMALS\n\n\tobjectNormal += ( morphNormal0 - normal ) * morphTargetInfluences[ 0 ];\n\tobjectNormal += ( morphNormal1 - normal ) * morphTargetInfluences[ 1 ];\n\tobjectNormal += ( morphNormal2 - normal ) * morphTargetInfluences[ 2 ];\n\tobjectNormal += ( morphNormal3 - normal ) * morphTargetInfluences[ 3 ];\n\n#endif\n",morphtarget_pars_vertex:"\n#ifdef USE_MORPHTARGETS\n\n\t#ifndef USE_MORPHNORMALS\n\n\tuniform float morphTargetInfluences[ 8 ];\n\n\t#else\n\n\tuniform float morphTargetInfluences[ 4 ];\n\n\t#endif\n\n#endif\n",morphtarget_vertex:"\n#ifdef USE_MORPHTARGETS\n\n\ttransformed += ( morphTarget0 - position ) * morphTargetInfluences[ 0 ];\n\ttransformed += ( morphTarget1 - position ) * morphTargetInfluences[ 1 ];\n\ttransformed += ( morphTarget2 - position ) * morphTargetInfluences[ 2 ];\n\ttransformed += ( morphTarget3 - position ) * morphTargetInfluences[ 3 ];\n\n\t#ifndef USE_MORPHNORMALS\n\n\ttransformed += ( morphTarget4 - position ) * morphTargetInfluences[ 4 ];\n\ttransformed += ( morphTarget5 - position ) * morphTargetInfluences[ 5 ];\n\ttransformed += ( morphTarget6 - position ) * morphTargetInfluences[ 6 ];\n\ttransformed += ( morphTarget7 - position ) * morphTargetInfluences[ 7 ];\n\n\t#endif\n\n#endif\n",normal_fragment_begin:"\n#ifdef FLAT_SHADED\n\n\t// Workaround for Adreno/Nexus5 not able able to do dFdx( vViewPosition ) ...\n\n\tvec3 fdx = vec3( dFdx( vViewPosition.x ), dFdx( vViewPosition.y ), dFdx( vViewPosition.z ) );\n\tvec3 fdy = vec3( dFdy( vViewPosition.x ), dFdy( vViewPosition.y ), dFdy( vViewPosition.z ) );\n\tvec3 normal = normalize( cross( fdx, fdy ) );\n\n#else\n\n\tvec3 normal = normalize( vNormal );\n\n\t#ifdef DOUBLE_SIDED\n\n\t\tnormal = normal * ( float( gl_FrontFacing ) * 2.0 - 1.0 );\n\n\t#endif\n\n#endif\n",normal_fragment_maps:"\n#ifdef USE_NORMALMAP\n\n\t#ifdef OBJECTSPACE_NORMALMAP\n\n\t\tnormal = texture2D( normalMap, vUv ).xyz * 2.0 - 1.0; // overrides both flatShading and attribute normals\n\n\t\t#ifdef FLIP_SIDED\n\n\t\t\tnormal = - normal;\n\n\t\t#endif\n\n\t\t#ifdef DOUBLE_SIDED\n\n\t\t\tnormal = normal * ( float( gl_FrontFacing ) * 2.0 - 1.0 );\n\n\t\t#endif\n\n\t\tnormal = normalize( normalMatrix * normal );\n\n\t#else // tangent-space normal map\n\n\t\tnormal = perturbNormal2Arb( -vViewPosition, normal );\n\n\t#endif\n\n#elif defined( USE_BUMPMAP )\n\n\tnormal = perturbNormalArb( -vViewPosition, normal, dHdxy_fwd() );\n\n#endif\n",normalmap_pars_fragment:"\n#ifdef USE_NORMALMAP\n\n\tuniform sampler2D normalMap;\n\tuniform vec2 normalScale;\n\n\t#ifdef OBJECTSPACE_NORMALMAP\n\n\t\tuniform mat3 normalMatrix;\n\n\t#else\n\n\t\t// Per-Pixel Tangent Space Normal Mapping\n\t\t// http://hacksoflife.blogspot.ch/2009/11/per-pixel-tangent-space-normal-mapping.html\n\n\t\tvec3 perturbNormal2Arb( vec3 eye_pos, vec3 surf_norm ) {\n\n\t\t\t// Workaround for Adreno 3XX dFd*( vec3 ) bug. See #9988\n\n\t\t\tvec3 q0 = vec3( dFdx( eye_pos.x ), dFdx( eye_pos.y ), dFdx( eye_pos.z ) );\n\t\t\tvec3 q1 = vec3( dFdy( eye_pos.x ), dFdy( eye_pos.y ), dFdy( eye_pos.z ) );\n\t\t\tvec2 st0 = dFdx( vUv.st );\n\t\t\tvec2 st1 = dFdy( vUv.st );\n\n\t\t\tfloat scale = sign( st1.t * st0.s - st0.t * st1.s ); // we do not care about the magnitude\n\n\t\t\tvec3 S = normalize( ( q0 * st1.t - q1 * st0.t ) * scale );\n\t\t\tvec3 T = normalize( ( - q0 * st1.s + q1 * st0.s ) * scale );\n\t\t\tvec3 N = normalize( surf_norm );\n\t\t\tmat3 tsn = mat3( S, T, N );\n\n\t\t\tvec3 mapN = texture2D( normalMap, vUv ).xyz * 2.0 - 1.0;\n\n\t\t\tmapN.xy *= normalScale;\n\t\t\tmapN.xy *= ( float( gl_FrontFacing ) * 2.0 - 1.0 );\n\n\t\t\treturn normalize( tsn * mapN );\n\n\t\t}\n\n\t#endif\n\n#endif\n",packing:"\nvec3 packNormalToRGB( const in vec3 normal ) {\n\treturn normalize( normal ) * 0.5 + 0.5;\n}\n\nvec3 unpackRGBToNormal( const in vec3 rgb ) {\n\treturn 2.0 * rgb.xyz - 1.0;\n}\n\nconst float PackUpscale = 256. / 255.; // fraction -> 0..1 (including 1)\nconst float UnpackDownscale = 255. / 256.; // 0..1 -> fraction (excluding 1)\n\nconst vec3 PackFactors = vec3( 256. * 256. * 256., 256. * 256.,  256. );\nconst vec4 UnpackFactors = UnpackDownscale / vec4( PackFactors, 1. );\n\nconst float ShiftRight8 = 1. / 256.;\n\nvec4 packDepthToRGBA( const in float v ) {\n\tvec4 r = vec4( fract( v * PackFactors ), v );\n\tr.yzw -= r.xyz * ShiftRight8; // tidy overflow\n\treturn r * PackUpscale;\n}\n\nfloat unpackRGBAToDepth( const in vec4 v ) {\n\treturn dot( v, UnpackFactors );\n}\n\n// NOTE: viewZ/eyeZ is < 0 when in front of the camera per OpenGL conventions\n\nfloat viewZToOrthographicDepth( const in float viewZ, const in float near, const in float far ) {\n\treturn ( viewZ + near ) / ( near - far );\n}\nfloat orthographicDepthToViewZ( const in float linearClipZ, const in float near, const in float far ) {\n\treturn linearClipZ * ( near - far ) - near;\n}\n\nfloat viewZToPerspectiveDepth( const in float viewZ, const in float near, const in float far ) {\n\treturn (( near + viewZ ) * far ) / (( far - near ) * viewZ );\n}\nfloat perspectiveDepthToViewZ( const in float invClipZ, const in float near, const in float far ) {\n\treturn ( near * far ) / ( ( far - near ) * invClipZ - far );\n}\n",premultiplied_alpha_fragment:"\n#ifdef PREMULTIPLIED_ALPHA\n\n\t// Get get normal blending with premultipled, use with CustomBlending, OneFactor, OneMinusSrcAlphaFactor, AddEquation.\n\tgl_FragColor.rgb *= gl_FragColor.a;\n\n#endif\n",project_vertex:"\nvec4 mvPosition = modelViewMatrix * vec4( transformed, 1.0 );\n\ngl_Position = projectionMatrix * mvPosition;\n",dithering_fragment:"\n#if defined( DITHERING )\n\n  gl_FragColor.rgb = dithering( gl_FragColor.rgb );\n\n#endif\n",dithering_pars_fragment:"\n#if defined( DITHERING )\n\n\t// based on https://www.shadertoy.com/view/MslGR8\n\tvec3 dithering( vec3 color ) {\n\t\t//Calculate grid position\n\t\tfloat grid_position = rand( gl_FragCoord.xy );\n\n\t\t//Shift the individual colors differently, thus making it even harder to see the dithering pattern\n\t\tvec3 dither_shift_RGB = vec3( 0.25 / 255.0, -0.25 / 255.0, 0.25 / 255.0 );\n\n\t\t//modify shift acording to grid position.\n\t\tdither_shift_RGB = mix( 2.0 * dither_shift_RGB, -2.0 * dither_shift_RGB, grid_position );\n\n\t\t//shift the color by dither_shift\n\t\treturn color + dither_shift_RGB;\n\t}\n\n#endif\n",roughnessmap_fragment:"\nfloat roughnessFactor = roughness;\n\n#ifdef USE_ROUGHNESSMAP\n\n\tvec4 texelRoughness = texture2D( roughnessMap, vUv );\n\n\t// reads channel G, compatible with a combined OcclusionRoughnessMetallic (RGB) texture\n\troughnessFactor *= texelRoughness.g;\n\n#endif\n",roughnessmap_pars_fragment:"\n#ifdef USE_ROUGHNESSMAP\n\n\tuniform sampler2D roughnessMap;\n\n#endif\n",shadowmap_pars_fragment:"\n#ifdef USE_SHADOWMAP\n\n\t#if NUM_DIR_LIGHTS > 0\n\n\t\tuniform sampler2D directionalShadowMap[ NUM_DIR_LIGHTS ];\n\t\tvarying vec4 vDirectionalShadowCoord[ NUM_DIR_LIGHTS ];\n\n\t#endif\n\n\t#if NUM_SPOT_LIGHTS > 0\n\n\t\tuniform sampler2D spotShadowMap[ NUM_SPOT_LIGHTS ];\n\t\tvarying vec4 vSpotShadowCoord[ NUM_SPOT_LIGHTS ];\n\n\t#endif\n\n\t#if NUM_POINT_LIGHTS > 0\n\n\t\tuniform sampler2D pointShadowMap[ NUM_POINT_LIGHTS ];\n\t\tvarying vec4 vPointShadowCoord[ NUM_POINT_LIGHTS ];\n\n\t#endif\n\n\t/*\n\t#if NUM_RECT_AREA_LIGHTS > 0\n\n\t\t// TODO (abelnation): create uniforms for area light shadows\n\n\t#endif\n\t*/\n\n\tfloat texture2DCompare( sampler2D depths, vec2 uv, float compare ) {\n\n\t\treturn step( compare, unpackRGBAToDepth( texture2D( depths, uv ) ) );\n\n\t}\n\n\tfloat texture2DShadowLerp( sampler2D depths, vec2 size, vec2 uv, float compare ) {\n\n\t\tconst vec2 offset = vec2( 0.0, 1.0 );\n\n\t\tvec2 texelSize = vec2( 1.0 ) / size;\n\t\tvec2 centroidUV = floor( uv * size + 0.5 ) / size;\n\n\t\tfloat lb = texture2DCompare( depths, centroidUV + texelSize * offset.xx, compare );\n\t\tfloat lt = texture2DCompare( depths, centroidUV + texelSize * offset.xy, compare );\n\t\tfloat rb = texture2DCompare( depths, centroidUV + texelSize * offset.yx, compare );\n\t\tfloat rt = texture2DCompare( depths, centroidUV + texelSize * offset.yy, compare );\n\n\t\tvec2 f = fract( uv * size + 0.5 );\n\n\t\tfloat a = mix( lb, lt, f.y );\n\t\tfloat b = mix( rb, rt, f.y );\n\t\tfloat c = mix( a, b, f.x );\n\n\t\treturn c;\n\n\t}\n\n\tfloat getShadow( sampler2D shadowMap, vec2 shadowMapSize, float shadowBias, float shadowRadius, vec4 shadowCoord ) {\n\n\t\tfloat shadow = 1.0;\n\n\t\tshadowCoord.xyz /= shadowCoord.w;\n\t\tshadowCoord.z += shadowBias;\n\n\t\t// if ( something && something ) breaks ATI OpenGL shader compiler\n\t\t// if ( all( something, something ) ) using this instead\n\n\t\tbvec4 inFrustumVec = bvec4 ( shadowCoord.x >= 0.0, shadowCoord.x <= 1.0, shadowCoord.y >= 0.0, shadowCoord.y <= 1.0 );\n\t\tbool inFrustum = all( inFrustumVec );\n\n\t\tbvec2 frustumTestVec = bvec2( inFrustum, shadowCoord.z <= 1.0 );\n\n\t\tbool frustumTest = all( frustumTestVec );\n\n\t\tif ( frustumTest ) {\n\n\t\t#if defined( SHADOWMAP_TYPE_PCF )\n\n\t\t\tvec2 texelSize = vec2( 1.0 ) / shadowMapSize;\n\n\t\t\tfloat dx0 = - texelSize.x * shadowRadius;\n\t\t\tfloat dy0 = - texelSize.y * shadowRadius;\n\t\t\tfloat dx1 = + texelSize.x * shadowRadius;\n\t\t\tfloat dy1 = + texelSize.y * shadowRadius;\n\n\t\t\tshadow = (\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx0, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( 0.0, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx1, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx0, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy, shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx1, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx0, dy1 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( 0.0, dy1 ), shadowCoord.z ) +\n\t\t\t\ttexture2DCompare( shadowMap, shadowCoord.xy + vec2( dx1, dy1 ), shadowCoord.z )\n\t\t\t) * ( 1.0 / 9.0 );\n\n\t\t#elif defined( SHADOWMAP_TYPE_PCF_SOFT )\n\n\t\t\tvec2 texelSize = vec2( 1.0 ) / shadowMapSize;\n\n\t\t\tfloat dx0 = - texelSize.x * shadowRadius;\n\t\t\tfloat dy0 = - texelSize.y * shadowRadius;\n\t\t\tfloat dx1 = + texelSize.x * shadowRadius;\n\t\t\tfloat dy1 = + texelSize.y * shadowRadius;\n\n\t\t\tshadow = (\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( dx0, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( 0.0, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( dx1, dy0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( dx0, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy, shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( dx1, 0.0 ), shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( dx0, dy1 ), shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( 0.0, dy1 ), shadowCoord.z ) +\n\t\t\t\ttexture2DShadowLerp( shadowMap, shadowMapSize, shadowCoord.xy + vec2( dx1, dy1 ), shadowCoord.z )\n\t\t\t) * ( 1.0 / 9.0 );\n\n\t\t#else // no percentage-closer filtering:\n\n\t\t\tshadow = texture2DCompare( shadowMap, shadowCoord.xy, shadowCoord.z );\n\n\t\t#endif\n\n\t\t}\n\n\t\treturn shadow;\n\n\t}\n\n\t// cubeToUV() maps a 3D direction vector suitable for cube texture mapping to a 2D\n\t// vector suitable for 2D texture mapping. This code uses the following layout for the\n\t// 2D texture:\n\t//\n\t// xzXZ\n\t//  y Y\n\t//\n\t// Y - Positive y direction\n\t// y - Negative y direction\n\t// X - Positive x direction\n\t// x - Negative x direction\n\t// Z - Positive z direction\n\t// z - Negative z direction\n\t//\n\t// Source and test bed:\n\t// https://gist.github.com/tschw/da10c43c467ce8afd0c4\n\n\tvec2 cubeToUV( vec3 v, float texelSizeY ) {\n\n\t\t// Number of texels to avoid at the edge of each square\n\n\t\tvec3 absV = abs( v );\n\n\t\t// Intersect unit cube\n\n\t\tfloat scaleToCube = 1.0 / max( absV.x, max( absV.y, absV.z ) );\n\t\tabsV *= scaleToCube;\n\n\t\t// Apply scale to avoid seams\n\n\t\t// two texels less per square (one texel will do for NEAREST)\n\t\tv *= scaleToCube * ( 1.0 - 2.0 * texelSizeY );\n\n\t\t// Unwrap\n\n\t\t// space: -1 ... 1 range for each square\n\t\t//\n\t\t// #X##\t\tdim    := ( 4 , 2 )\n\t\t//  # #\t\tcenter := ( 1 , 1 )\n\n\t\tvec2 planar = v.xy;\n\n\t\tfloat almostATexel = 1.5 * texelSizeY;\n\t\tfloat almostOne = 1.0 - almostATexel;\n\n\t\tif ( absV.z >= almostOne ) {\n\n\t\t\tif ( v.z > 0.0 )\n\t\t\t\tplanar.x = 4.0 - v.x;\n\n\t\t} else if ( absV.x >= almostOne ) {\n\n\t\t\tfloat signX = sign( v.x );\n\t\t\tplanar.x = v.z * signX + 2.0 * signX;\n\n\t\t} else if ( absV.y >= almostOne ) {\n\n\t\t\tfloat signY = sign( v.y );\n\t\t\tplanar.x = v.x + 2.0 * signY + 2.0;\n\t\t\tplanar.y = v.z * signY - 2.0;\n\n\t\t}\n\n\t\t// Transform to UV space\n\n\t\t// scale := 0.5 / dim\n\t\t// translate := ( center + 0.5 ) / dim\n\t\treturn vec2( 0.125, 0.25 ) * planar + vec2( 0.375, 0.75 );\n\n\t}\n\n\tfloat getPointShadow( sampler2D shadowMap, vec2 shadowMapSize, float shadowBias, float shadowRadius, vec4 shadowCoord, float shadowCameraNear, float shadowCameraFar ) {\n\n\t\tvec2 texelSize = vec2( 1.0 ) / ( shadowMapSize * vec2( 4.0, 2.0 ) );\n\n\t\t// for point lights, the uniform @vShadowCoord is re-purposed to hold\n\t\t// the vector from the light to the world-space position of the fragment.\n\t\tvec3 lightToPosition = shadowCoord.xyz;\n\n\t\t// dp = normalized distance from light to fragment position\n\t\tfloat dp = ( length( lightToPosition ) - shadowCameraNear ) / ( shadowCameraFar - shadowCameraNear ); // need to clamp?\n\t\tdp += shadowBias;\n\n\t\t// bd3D = base direction 3D\n\t\tvec3 bd3D = normalize( lightToPosition );\n\n\t\t#if defined( SHADOWMAP_TYPE_PCF ) || defined( SHADOWMAP_TYPE_PCF_SOFT )\n\n\t\t\tvec2 offset = vec2( - 1, 1 ) * shadowRadius * texelSize.y;\n\n\t\t\treturn (\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xyy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yyy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xyx, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yyx, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xxy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yxy, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.xxx, texelSize.y ), dp ) +\n\t\t\t\ttexture2DCompare( shadowMap, cubeToUV( bd3D + offset.yxx, texelSize.y ), dp )\n\t\t\t) * ( 1.0 / 9.0 );\n\n\t\t#else // no percentage-closer filtering\n\n\t\t\treturn texture2DCompare( shadowMap, cubeToUV( bd3D, texelSize.y ), dp );\n\n\t\t#endif\n\n\t}\n\n#endif\n",shadowmap_pars_vertex:"\n#ifdef USE_SHADOWMAP\n\n\t#if NUM_DIR_LIGHTS > 0\n\n\t\tuniform mat4 directionalShadowMatrix[ NUM_DIR_LIGHTS ];\n\t\tvarying vec4 vDirectionalShadowCoord[ NUM_DIR_LIGHTS ];\n\n\t#endif\n\n\t#if NUM_SPOT_LIGHTS > 0\n\n\t\tuniform mat4 spotShadowMatrix[ NUM_SPOT_LIGHTS ];\n\t\tvarying vec4 vSpotShadowCoord[ NUM_SPOT_LIGHTS ];\n\n\t#endif\n\n\t#if NUM_POINT_LIGHTS > 0\n\n\t\tuniform mat4 pointShadowMatrix[ NUM_POINT_LIGHTS ];\n\t\tvarying vec4 vPointShadowCoord[ NUM_POINT_LIGHTS ];\n\n\t#endif\n\n\t/*\n\t#if NUM_RECT_AREA_LIGHTS > 0\n\n\t\t// TODO (abelnation): uniforms for area light shadows\n\n\t#endif\n\t*/\n\n#endif\n",shadowmap_vertex:"\n#ifdef USE_SHADOWMAP\n\n\t#if NUM_DIR_LIGHTS > 0\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_DIR_LIGHTS; i ++ ) {\n\n\t\tvDirectionalShadowCoord[ i ] = directionalShadowMatrix[ i ] * worldPosition;\n\n\t}\n\n\t#endif\n\n\t#if NUM_SPOT_LIGHTS > 0\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_SPOT_LIGHTS; i ++ ) {\n\n\t\tvSpotShadowCoord[ i ] = spotShadowMatrix[ i ] * worldPosition;\n\n\t}\n\n\t#endif\n\n\t#if NUM_POINT_LIGHTS > 0\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_POINT_LIGHTS; i ++ ) {\n\n\t\tvPointShadowCoord[ i ] = pointShadowMatrix[ i ] * worldPosition;\n\n\t}\n\n\t#endif\n\n\t/*\n\t#if NUM_RECT_AREA_LIGHTS > 0\n\n\t\t// TODO (abelnation): update vAreaShadowCoord with area light info\n\n\t#endif\n\t*/\n\n#endif\n",shadowmask_pars_fragment:"\nfloat getShadowMask() {\n\n\tfloat shadow = 1.0;\n\n\t#ifdef USE_SHADOWMAP\n\n\t#if NUM_DIR_LIGHTS > 0\n\n\tDirectionalLight directionalLight;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_DIR_LIGHTS; i ++ ) {\n\n\t\tdirectionalLight = directionalLights[ i ];\n\t\tshadow *= bool( directionalLight.shadow ) ? getShadow( directionalShadowMap[ i ], directionalLight.shadowMapSize, directionalLight.shadowBias, directionalLight.shadowRadius, vDirectionalShadowCoord[ i ] ) : 1.0;\n\n\t}\n\n\t#endif\n\n\t#if NUM_SPOT_LIGHTS > 0\n\n\tSpotLight spotLight;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_SPOT_LIGHTS; i ++ ) {\n\n\t\tspotLight = spotLights[ i ];\n\t\tshadow *= bool( spotLight.shadow ) ? getShadow( spotShadowMap[ i ], spotLight.shadowMapSize, spotLight.shadowBias, spotLight.shadowRadius, vSpotShadowCoord[ i ] ) : 1.0;\n\n\t}\n\n\t#endif\n\n\t#if NUM_POINT_LIGHTS > 0\n\n\tPointLight pointLight;\n\n\t#pragma unroll_loop\n\tfor ( int i = 0; i < NUM_POINT_LIGHTS; i ++ ) {\n\n\t\tpointLight = pointLights[ i ];\n\t\tshadow *= bool( pointLight.shadow ) ? getPointShadow( pointShadowMap[ i ], pointLight.shadowMapSize, pointLight.shadowBias, pointLight.shadowRadius, vPointShadowCoord[ i ], pointLight.shadowCameraNear, pointLight.shadowCameraFar ) : 1.0;\n\n\t}\n\n\t#endif\n\n\t/*\n\t#if NUM_RECT_AREA_LIGHTS > 0\n\n\t\t// TODO (abelnation): update shadow for Area light\n\n\t#endif\n\t*/\n\n\t#endif\n\n\treturn shadow;\n\n}\n",skinbase_vertex:"\n#ifdef USE_SKINNING\n\n\tmat4 boneMatX = getBoneMatrix( skinIndex.x );\n\tmat4 boneMatY = getBoneMatrix( skinIndex.y );\n\tmat4 boneMatZ = getBoneMatrix( skinIndex.z );\n\tmat4 boneMatW = getBoneMatrix( skinIndex.w );\n\n#endif\n",skinning_pars_vertex:"\n#ifdef USE_SKINNING\n\n\tuniform mat4 bindMatrix;\n\tuniform mat4 bindMatrixInverse;\n\n\t#ifdef BONE_TEXTURE\n\n\t\tuniform sampler2D boneTexture;\n\t\tuniform int boneTextureSize;\n\n\t\tmat4 getBoneMatrix( const in float i ) {\n\n\t\t\tfloat j = i * 4.0;\n\t\t\tfloat x = mod( j, float( boneTextureSize ) );\n\t\t\tfloat y = floor( j / float( boneTextureSize ) );\n\n\t\t\tfloat dx = 1.0 / float( boneTextureSize );\n\t\t\tfloat dy = 1.0 / float( boneTextureSize );\n\n\t\t\ty = dy * ( y + 0.5 );\n\n\t\t\tvec4 v1 = texture2D( boneTexture, vec2( dx * ( x + 0.5 ), y ) );\n\t\t\tvec4 v2 = texture2D( boneTexture, vec2( dx * ( x + 1.5 ), y ) );\n\t\t\tvec4 v3 = texture2D( boneTexture, vec2( dx * ( x + 2.5 ), y ) );\n\t\t\tvec4 v4 = texture2D( boneTexture, vec2( dx * ( x + 3.5 ), y ) );\n\n\t\t\tmat4 bone = mat4( v1, v2, v3, v4 );\n\n\t\t\treturn bone;\n\n\t\t}\n\n\t#else\n\n\t\tuniform mat4 boneMatrices[ MAX_BONES ];\n\n\t\tmat4 getBoneMatrix( const in float i ) {\n\n\t\t\tmat4 bone = boneMatrices[ int(i) ];\n\t\t\treturn bone;\n\n\t\t}\n\n\t#endif\n\n#endif\n",skinning_vertex:"\n#ifdef USE_SKINNING\n\n\tvec4 skinVertex = bindMatrix * vec4( transformed, 1.0 );\n\n\tvec4 skinned = vec4( 0.0 );\n\tskinned += boneMatX * skinVertex * skinWeight.x;\n\tskinned += boneMatY * skinVertex * skinWeight.y;\n\tskinned += boneMatZ * skinVertex * skinWeight.z;\n\tskinned += boneMatW * skinVertex * skinWeight.w;\n\n\ttransformed = ( bindMatrixInverse * skinned ).xyz;\n\n#endif\n",skinnormal_vertex:"\n#ifdef USE_SKINNING\n\n\tmat4 skinMatrix = mat4( 0.0 );\n\tskinMatrix += skinWeight.x * boneMatX;\n\tskinMatrix += skinWeight.y * boneMatY;\n\tskinMatrix += skinWeight.z * boneMatZ;\n\tskinMatrix += skinWeight.w * boneMatW;\n\tskinMatrix  = bindMatrixInverse * skinMatrix * bindMatrix;\n\n\tobjectNormal = vec4( skinMatrix * vec4( objectNormal, 0.0 ) ).xyz;\n\n#endif\n",specularmap_fragment:"\nfloat specularStrength;\n\n#ifdef USE_SPECULARMAP\n\n\tvec4 texelSpecular = texture2D( specularMap, vUv );\n\tspecularStrength = texelSpecular.r;\n\n#else\n\n\tspecularStrength = 1.0;\n\n#endif\n",specularmap_pars_fragment:"\n#ifdef USE_SPECULARMAP\n\n\tuniform sampler2D specularMap;\n\n#endif\n",tonemapping_fragment:"\n#if defined( TONE_MAPPING )\n\n  gl_FragColor.rgb = toneMapping( gl_FragColor.rgb );\n\n#endif\n",tonemapping_pars_fragment:"\n#ifndef saturate\n\t#define saturate(a) clamp( a, 0.0, 1.0 )\n#endif\n\nuniform float toneMappingExposure;\nuniform float toneMappingWhitePoint;\n\n// exposure only\nvec3 LinearToneMapping( vec3 color ) {\n\n\treturn toneMappingExposure * color;\n\n}\n\n// source: https://www.cs.utah.edu/~reinhard/cdrom/\nvec3 ReinhardToneMapping( vec3 color ) {\n\n\tcolor *= toneMappingExposure;\n\treturn saturate( color / ( vec3( 1.0 ) + color ) );\n\n}\n\n// source: http://filmicgames.com/archives/75\n#define Uncharted2Helper( x ) max( ( ( x * ( 0.15 * x + 0.10 * 0.50 ) + 0.20 * 0.02 ) / ( x * ( 0.15 * x + 0.50 ) + 0.20 * 0.30 ) ) - 0.02 / 0.30, vec3( 0.0 ) )\nvec3 Uncharted2ToneMapping( vec3 color ) {\n\n\t// John Hable's filmic operator from Uncharted 2 video game\n\tcolor *= toneMappingExposure;\n\treturn saturate( Uncharted2Helper( color ) / Uncharted2Helper( vec3( toneMappingWhitePoint ) ) );\n\n}\n\n// source: http://filmicgames.com/archives/75\nvec3 OptimizedCineonToneMapping( vec3 color ) {\n\n\t// optimized filmic operator by Jim Hejl and Richard Burgess-Dawson\n\tcolor *= toneMappingExposure;\n\tcolor = max( vec3( 0.0 ), color - 0.004 );\n\treturn pow( ( color * ( 6.2 * color + 0.5 ) ) / ( color * ( 6.2 * color + 1.7 ) + 0.06 ), vec3( 2.2 ) );\n\n}\n\n// source: https://knarkowicz.wordpress.com/2016/01/06/aces-filmic-tone-mapping-curve/\nvec3 ACESFilmicToneMapping( vec3 color ) {\n\n\tcolor *= toneMappingExposure;\n\treturn saturate( ( color * ( 2.51 * color + 0.03 ) ) / ( color * ( 2.43 * color + 0.59 ) + 0.14 ) );\n\n}\n",uv_pars_fragment:"\n#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP ) || defined( USE_ALPHAMAP ) || defined( USE_EMISSIVEMAP ) || defined( USE_ROUGHNESSMAP ) || defined( USE_METALNESSMAP )\n\n\tvarying vec2 vUv;\n\n#endif\n",uv_pars_vertex:"\n#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP ) || defined( USE_ALPHAMAP ) || defined( USE_EMISSIVEMAP ) || defined( USE_ROUGHNESSMAP ) || defined( USE_METALNESSMAP )\n\n\tvarying vec2 vUv;\n\tuniform mat3 uvTransform;\n\n#endif\n",uv_vertex:"\n#if defined( USE_MAP ) || defined( USE_BUMPMAP ) || defined( USE_NORMALMAP ) || defined( USE_SPECULARMAP ) || defined( USE_ALPHAMAP ) || defined( USE_EMISSIVEMAP ) || defined( USE_ROUGHNESSMAP ) || defined( USE_METALNESSMAP )\n\n\tvUv = ( uvTransform * vec3( uv, 1 ) ).xy;\n\n#endif\n",uv2_pars_fragment:"\n#if defined( USE_LIGHTMAP ) || defined( USE_AOMAP )\n\n\tvarying vec2 vUv2;\n\n#endif\n",uv2_pars_vertex:"\n#if defined( USE_LIGHTMAP ) || defined( USE_AOMAP )\n\n\tattribute vec2 uv2;\n\tvarying vec2 vUv2;\n\n#endif\n",uv2_vertex:"\n#if defined( USE_LIGHTMAP ) || defined( USE_AOMAP )\n\n\tvUv2 = uv2;\n\n#endif\n",worldpos_vertex:"\n#if defined( USE_ENVMAP ) || defined( DISTANCE ) || defined ( USE_SHADOWMAP )\n\n\tvec4 worldPosition = modelMatrix * vec4( transformed, 1.0 );\n\n#endif\n",background_frag:"\nuniform sampler2D t2D;\n\nvarying vec2 vUv;\n\nvoid main() {\n\n\tvec4 texColor = texture2D( t2D, vUv );\n\n\tgl_FragColor = mapTexelToLinear( texColor );\n\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\n}\n",background_vert:"\nvarying vec2 vUv;\nuniform mat3 uvTransform;\n\nvoid main() {\n\n\tvUv = ( uvTransform * vec3( uv, 1 ) ).xy;\n\n\tgl_Position = vec4( position.xy, 1.0, 1.0 );\n\n}\n",cube_frag:"\nuniform samplerCube tCube;\nuniform float tFlip;\nuniform float opacity;\n\nvarying vec3 vWorldDirection;\n\nvoid main() {\n\n\tvec4 texColor = textureCube( tCube, vec3( tFlip * vWorldDirection.x, vWorldDirection.yz ) );\n\n\tgl_FragColor = mapTexelToLinear( texColor );\n\tgl_FragColor.a *= opacity;\n\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\n}\n",cube_vert:"\nvarying vec3 vWorldDirection;\n\n#include <common>\n\nvoid main() {\n\n\tvWorldDirection = transformDirection( position, modelMatrix );\n\n\t#include <begin_vertex>\n\t#include <project_vertex>\n\n\tgl_Position.z = gl_Position.w; // set z to camera.far\n\n}\n",depth_frag:"\n#if DEPTH_PACKING == 3200\n\n\tuniform float opacity;\n\n#endif\n\n#include <common>\n#include <packing>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec4 diffuseColor = vec4( 1.0 );\n\n\t#if DEPTH_PACKING == 3200\n\n\t\tdiffuseColor.a = opacity;\n\n\t#endif\n\n\t#include <map_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\n\t#include <logdepthbuf_fragment>\n\n\t#if DEPTH_PACKING == 3200\n\n\t\tgl_FragColor = vec4( vec3( 1.0 - gl_FragCoord.z ), opacity );\n\n\t#elif DEPTH_PACKING == 3201\n\n\t\tgl_FragColor = packDepthToRGBA( gl_FragCoord.z );\n\n\t#endif\n\n}\n",depth_vert:"\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\n\t#include <skinbase_vertex>\n\n\t#ifdef USE_DISPLACEMENTMAP\n\n\t\t#include <beginnormal_vertex>\n\t\t#include <morphnormal_vertex>\n\t\t#include <skinnormal_vertex>\n\n\t#endif\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\n}\n",distanceRGBA_frag:"\n#define DISTANCE\n\nuniform vec3 referencePosition;\nuniform float nearDistance;\nuniform float farDistance;\nvarying vec3 vWorldPosition;\n\n#include <common>\n#include <packing>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main () {\n\n\t#include <clipping_planes_fragment>\n\n\tvec4 diffuseColor = vec4( 1.0 );\n\n\t#include <map_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\n\tfloat dist = length( vWorldPosition - referencePosition );\n\tdist = ( dist - nearDistance ) / ( farDistance - nearDistance );\n\tdist = saturate( dist ); // clamp to [ 0, 1 ]\n\n\tgl_FragColor = packDepthToRGBA( dist );\n\n}\n",distanceRGBA_vert:"\n#define DISTANCE\n\nvarying vec3 vWorldPosition;\n\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\n\t#include <skinbase_vertex>\n\n\t#ifdef USE_DISPLACEMENTMAP\n\n\t\t#include <beginnormal_vertex>\n\t\t#include <morphnormal_vertex>\n\t\t#include <skinnormal_vertex>\n\n\t#endif\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <worldpos_vertex>\n\t#include <clipping_planes_vertex>\n\n\tvWorldPosition = worldPosition.xyz;\n\n}\n",equirect_frag:"\nuniform sampler2D tEquirect;\n\nvarying vec3 vWorldDirection;\n\n#include <common>\n\nvoid main() {\n\n\tvec3 direction = normalize( vWorldDirection );\n\n\tvec2 sampleUV;\n\n\tsampleUV.y = asin( clamp( direction.y, - 1.0, 1.0 ) ) * RECIPROCAL_PI + 0.5;\n\n\tsampleUV.x = atan( direction.z, direction.x ) * RECIPROCAL_PI2 + 0.5;\n\n\tvec4 texColor = texture2D( tEquirect, sampleUV );\n\n\tgl_FragColor = mapTexelToLinear( texColor );\n\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\n}\n",equirect_vert:"\nvarying vec3 vWorldDirection;\n\n#include <common>\n\nvoid main() {\n\n\tvWorldDirection = transformDirection( position, modelMatrix );\n\n\t#include <begin_vertex>\n\t#include <project_vertex>\n\n}\n",linedashed_frag:"\nuniform vec3 diffuse;\nuniform float opacity;\n\nuniform float dashSize;\nuniform float totalSize;\n\nvarying float vLineDistance;\n\n#include <common>\n#include <color_pars_fragment>\n#include <fog_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tif ( mod( vLineDistance, totalSize ) > dashSize ) {\n\n\t\tdiscard;\n\n\t}\n\n\tvec3 outgoingLight = vec3( 0.0 );\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\n\t#include <logdepthbuf_fragment>\n\t#include <color_fragment>\n\n\toutgoingLight = diffuseColor.rgb; // simple shader\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <premultiplied_alpha_fragment>\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\n}\n",linedashed_vert:"\nuniform float scale;\nattribute float lineDistance;\n\nvarying float vLineDistance;\n\n#include <common>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <color_vertex>\n\n\tvLineDistance = scale * lineDistance;\n\n\tvec4 mvPosition = modelViewMatrix * vec4( position, 1.0 );\n\tgl_Position = projectionMatrix * mvPosition;\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <fog_vertex>\n\n}\n",meshbasic_frag:"\nuniform vec3 diffuse;\nuniform float opacity;\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <common>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <uv2_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <envmap_pars_fragment>\n#include <fog_pars_fragment>\n#include <specularmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <specularmap_fragment>\n\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\n\t// accumulation (baked indirect lighting only)\n\t#ifdef USE_LIGHTMAP\n\n\t\treflectedLight.indirectDiffuse += texture2D( lightMap, vUv2 ).xyz * lightMapIntensity;\n\n\t#else\n\n\t\treflectedLight.indirectDiffuse += vec3( 1.0 );\n\n\t#endif\n\n\t// modulation\n\t#include <aomap_fragment>\n\n\treflectedLight.indirectDiffuse *= diffuseColor.rgb;\n\n\tvec3 outgoingLight = reflectedLight.indirectDiffuse;\n\n\t#include <envmap_fragment>\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <premultiplied_alpha_fragment>\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\n}\n",meshbasic_vert:"\n#include <common>\n#include <uv_pars_vertex>\n#include <uv2_pars_vertex>\n#include <envmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\t#include <uv2_vertex>\n\t#include <color_vertex>\n\t#include <skinbase_vertex>\n\n\t#ifdef USE_ENVMAP\n\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\n\t#endif\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\n\t#include <worldpos_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <envmap_vertex>\n\t#include <fog_vertex>\n\n}\n",meshlambert_frag:"\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform float opacity;\n\nvarying vec3 vLightFront;\nvarying vec3 vIndirectFront;\n\n#ifdef DOUBLE_SIDED\n\tvarying vec3 vLightBack;\n\tvarying vec3 vIndirectBack;\n#endif\n\n\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <uv2_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <envmap_pars_fragment>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <fog_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <shadowmask_pars_fragment>\n#include <specularmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\tvec3 totalEmissiveRadiance = emissive;\n\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <specularmap_fragment>\n\t#include <emissivemap_fragment>\n\n\t// accumulation\n\treflectedLight.indirectDiffuse = getAmbientLightIrradiance( ambientLightColor );\n\n\t#ifdef DOUBLE_SIDED\n\n\t\treflectedLight.indirectDiffuse += ( gl_FrontFacing ) ? vIndirectFront : vIndirectBack;\n\n\t#else\n\n\t\treflectedLight.indirectDiffuse += vIndirectFront;\n\n\t#endif\n\n\t#include <lightmap_fragment>\n\n\treflectedLight.indirectDiffuse *= BRDF_Diffuse_Lambert( diffuseColor.rgb );\n\n\t#ifdef DOUBLE_SIDED\n\n\t\treflectedLight.directDiffuse = ( gl_FrontFacing ) ? vLightFront : vLightBack;\n\n\t#else\n\n\t\treflectedLight.directDiffuse = vLightFront;\n\n\t#endif\n\n\treflectedLight.directDiffuse *= BRDF_Diffuse_Lambert( diffuseColor.rgb ) * getShadowMask();\n\n\t// modulation\n\t#include <aomap_fragment>\n\n\tvec3 outgoingLight = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse + totalEmissiveRadiance;\n\n\t#include <envmap_fragment>\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n}\n",meshlambert_vert:"\n#define LAMBERT\n\nvarying vec3 vLightFront;\nvarying vec3 vIndirectFront;\n\n#ifdef DOUBLE_SIDED\n\tvarying vec3 vLightBack;\n\tvarying vec3 vIndirectBack;\n#endif\n\n#include <common>\n#include <uv_pars_vertex>\n#include <uv2_pars_vertex>\n#include <envmap_pars_vertex>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\t#include <uv2_vertex>\n\t#include <color_vertex>\n\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\n\t#include <worldpos_vertex>\n\t#include <envmap_vertex>\n\t#include <lights_lambert_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n}\n",meshmatcap_frag:"\n#define MATCAP\n\nuniform vec3 diffuse;\nuniform float opacity;\nuniform sampler2D matcap;\n\nvarying vec3 vViewPosition;\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <common>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n\n#include <fog_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\n\tvec3 viewDir = normalize( vViewPosition );\n\tvec3 x = normalize( vec3( viewDir.z, 0.0, - viewDir.x ) );\n\tvec3 y = cross( viewDir, x );\n\tvec2 uv = vec2( dot( x, normal ), dot( y, normal ) ) * 0.495 + 0.5; // 0.495 to remove artifacts caused by undersized matcap disks\n\n\t#ifdef USE_MATCAP\n\n\t\tvec4 matcapColor = texture2D( matcap, uv );\n\t\tmatcapColor = matcapTexelToLinear( matcapColor );\n\n\t#else\n\n\t\tvec4 matcapColor = vec4( 1.0 );\n\n\t#endif\n\n\tvec3 outgoingLight = diffuseColor.rgb * matcapColor.rgb;\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <premultiplied_alpha_fragment>\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\n}\n",meshmatcap_vert:"\n#define MATCAP\n\nvarying vec3 vViewPosition;\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <common>\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\n\t#ifndef FLAT_SHADED // Normal computed with derivatives when FLAT_SHADED\n\n\t\tvNormal = normalize( transformedNormal );\n\n\t#endif\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <fog_vertex>\n\n\tvViewPosition = - mvPosition.xyz;\n\n}\n",meshphong_frag:"\n#define PHONG\n\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform vec3 specular;\nuniform float shininess;\nuniform float opacity;\n\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <uv2_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <envmap_pars_fragment>\n#include <gradientmap_pars_fragment>\n#include <fog_pars_fragment>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <lights_phong_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <specularmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\tvec3 totalEmissiveRadiance = emissive;\n\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <specularmap_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\t#include <emissivemap_fragment>\n\n\t// accumulation\n\t#include <lights_phong_fragment>\n\t#include <lights_fragment_begin>\n\t#include <lights_fragment_maps>\n\t#include <lights_fragment_end>\n\n\t// modulation\n\t#include <aomap_fragment>\n\n\tvec3 outgoingLight = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse + reflectedLight.directSpecular + reflectedLight.indirectSpecular + totalEmissiveRadiance;\n\n\t#include <envmap_fragment>\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n\n}\n",meshphong_vert:"\n#define PHONG\n\nvarying vec3 vViewPosition;\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <common>\n#include <uv_pars_vertex>\n#include <uv2_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <envmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\t#include <uv2_vertex>\n\t#include <color_vertex>\n\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\n#ifndef FLAT_SHADED // Normal computed with derivatives when FLAT_SHADED\n\n\tvNormal = normalize( transformedNormal );\n\n#endif\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\n\tvViewPosition = - mvPosition.xyz;\n\n\t#include <worldpos_vertex>\n\t#include <envmap_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n\n}\n",meshphysical_frag:"\n#define PHYSICAL\n\nuniform vec3 diffuse;\nuniform vec3 emissive;\nuniform float roughness;\nuniform float metalness;\nuniform float opacity;\n\n#ifndef STANDARD\n\tuniform float clearCoat;\n\tuniform float clearCoatRoughness;\n#endif\n\nvarying vec3 vViewPosition;\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <common>\n#include <packing>\n#include <dithering_pars_fragment>\n#include <color_pars_fragment>\n#include <uv_pars_fragment>\n#include <uv2_pars_fragment>\n#include <map_pars_fragment>\n#include <alphamap_pars_fragment>\n#include <aomap_pars_fragment>\n#include <lightmap_pars_fragment>\n#include <emissivemap_pars_fragment>\n#include <bsdfs>\n#include <cube_uv_reflection_fragment>\n#include <envmap_pars_fragment>\n#include <envmap_physical_pars_fragment>\n#include <fog_pars_fragment>\n#include <lights_pars_begin>\n#include <lights_physical_pars_fragment>\n#include <shadowmap_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <roughnessmap_pars_fragment>\n#include <metalnessmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\tReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n\tvec3 totalEmissiveRadiance = emissive;\n\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <color_fragment>\n\t#include <alphamap_fragment>\n\t#include <alphatest_fragment>\n\t#include <roughnessmap_fragment>\n\t#include <metalnessmap_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\t#include <emissivemap_fragment>\n\n\t// accumulation\n\t#include <lights_physical_fragment>\n\t#include <lights_fragment_begin>\n\t#include <lights_fragment_maps>\n\t#include <lights_fragment_end>\n\n\t// modulation\n\t#include <aomap_fragment>\n\n\tvec3 outgoingLight = reflectedLight.directDiffuse + reflectedLight.indirectDiffuse + reflectedLight.directSpecular + reflectedLight.indirectSpecular + totalEmissiveRadiance;\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\t#include <premultiplied_alpha_fragment>\n\t#include <dithering_fragment>\n\n}\n",meshphysical_vert:"\n#define PHYSICAL\n\nvarying vec3 vViewPosition;\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <common>\n#include <uv_pars_vertex>\n#include <uv2_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <shadowmap_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\t#include <uv2_vertex>\n\t#include <color_vertex>\n\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\n#ifndef FLAT_SHADED // Normal computed with derivatives when FLAT_SHADED\n\n\tvNormal = normalize( transformedNormal );\n\n#endif\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\n\tvViewPosition = - mvPosition.xyz;\n\n\t#include <worldpos_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n\n}\n",normal_frag:"\n#define NORMAL\n\nuniform float opacity;\n\n#if defined( FLAT_SHADED ) || defined( USE_BUMPMAP ) || ( defined( USE_NORMALMAP ) && ! defined( OBJECTSPACE_NORMALMAP ) )\n\n\tvarying vec3 vViewPosition;\n\n#endif\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <packing>\n#include <uv_pars_fragment>\n#include <bumpmap_pars_fragment>\n#include <normalmap_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n\nvoid main() {\n\n\t#include <logdepthbuf_fragment>\n\t#include <normal_fragment_begin>\n\t#include <normal_fragment_maps>\n\n\tgl_FragColor = vec4( packNormalToRGB( normal ), opacity );\n\n}\n",normal_vert:"\n#define NORMAL\n\n#if defined( FLAT_SHADED ) || defined( USE_BUMPMAP ) || ( defined( USE_NORMALMAP ) && ! defined( OBJECTSPACE_NORMALMAP ) )\n\n\tvarying vec3 vViewPosition;\n\n#endif\n\n#ifndef FLAT_SHADED\n\n\tvarying vec3 vNormal;\n\n#endif\n\n#include <uv_pars_vertex>\n#include <displacementmap_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <skinning_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\n\t#include <beginnormal_vertex>\n\t#include <morphnormal_vertex>\n\t#include <skinbase_vertex>\n\t#include <skinnormal_vertex>\n\t#include <defaultnormal_vertex>\n\n#ifndef FLAT_SHADED // Normal computed with derivatives when FLAT_SHADED\n\n\tvNormal = normalize( transformedNormal );\n\n#endif\n\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <skinning_vertex>\n\t#include <displacementmap_vertex>\n\t#include <project_vertex>\n\t#include <logdepthbuf_vertex>\n\n#if defined( FLAT_SHADED ) || defined( USE_BUMPMAP ) || ( defined( USE_NORMALMAP ) && ! defined( OBJECTSPACE_NORMALMAP ) )\n\n\tvViewPosition = - mvPosition.xyz;\n\n#endif\n\n}\n",points_frag:"\nuniform vec3 diffuse;\nuniform float opacity;\n\n#include <common>\n#include <color_pars_fragment>\n#include <map_particle_pars_fragment>\n#include <fog_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec3 outgoingLight = vec3( 0.0 );\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\n\t#include <logdepthbuf_fragment>\n\t#include <map_particle_fragment>\n\t#include <color_fragment>\n\t#include <alphatest_fragment>\n\n\toutgoingLight = diffuseColor.rgb;\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <premultiplied_alpha_fragment>\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\n}\n",points_vert:"\nuniform float size;\nuniform float scale;\n\n#include <common>\n#include <color_pars_vertex>\n#include <fog_pars_vertex>\n#include <morphtarget_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <color_vertex>\n\t#include <begin_vertex>\n\t#include <morphtarget_vertex>\n\t#include <project_vertex>\n\n\tgl_PointSize = size;\n\n\t#ifdef USE_SIZEATTENUATION\n\n\t\tbool isPerspective = ( projectionMatrix[ 2 ][ 3 ] == - 1.0 );\n\n\t\tif ( isPerspective ) gl_PointSize *= ( scale / - mvPosition.z );\n\n\t#endif\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <worldpos_vertex>\n\t#include <fog_vertex>\n\n}\n",shadow_frag:"\nuniform vec3 color;\nuniform float opacity;\n\n#include <common>\n#include <packing>\n#include <fog_pars_fragment>\n#include <bsdfs>\n#include <lights_pars_begin>\n#include <shadowmap_pars_fragment>\n#include <shadowmask_pars_fragment>\n\nvoid main() {\n\n\tgl_FragColor = vec4( color, opacity * ( 1.0 - getShadowMask() ) );\n\n\t#include <fog_fragment>\n\n}\n",shadow_vert:"\n#include <fog_pars_vertex>\n#include <shadowmap_pars_vertex>\n\nvoid main() {\n\n\t#include <begin_vertex>\n\t#include <project_vertex>\n\t#include <worldpos_vertex>\n\t#include <shadowmap_vertex>\n\t#include <fog_vertex>\n\n}\n",sprite_frag:"\nuniform vec3 diffuse;\nuniform float opacity;\n\n#include <common>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <fog_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvoid main() {\n\n\t#include <clipping_planes_fragment>\n\n\tvec3 outgoingLight = vec3( 0.0 );\n\tvec4 diffuseColor = vec4( diffuse, opacity );\n\n\t#include <logdepthbuf_fragment>\n\t#include <map_fragment>\n\t#include <alphatest_fragment>\n\n\toutgoingLight = diffuseColor.rgb;\n\n\tgl_FragColor = vec4( outgoingLight, diffuseColor.a );\n\n\t#include <tonemapping_fragment>\n\t#include <encodings_fragment>\n\t#include <fog_fragment>\n\n}\n",sprite_vert:"\nuniform float rotation;\nuniform vec2 center;\n\n#include <common>\n#include <uv_pars_vertex>\n#include <fog_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nvoid main() {\n\n\t#include <uv_vertex>\n\n\tvec4 mvPosition = modelViewMatrix * vec4( 0.0, 0.0, 0.0, 1.0 );\n\n\tvec2 scale;\n\tscale.x = length( vec3( modelMatrix[ 0 ].x, modelMatrix[ 0 ].y, modelMatrix[ 0 ].z ) );\n\tscale.y = length( vec3( modelMatrix[ 1 ].x, modelMatrix[ 1 ].y, modelMatrix[ 1 ].z ) );\n\n\t#ifndef USE_SIZEATTENUATION\n\n\t\tbool isPerspective = ( projectionMatrix[ 2 ][ 3 ] == - 1.0 );\n\n\t\tif ( isPerspective ) scale *= - mvPosition.z;\n\n\t#endif\n\n\tvec2 alignedPosition = ( position.xy - ( center - vec2( 0.5 ) ) ) * scale;\n\n\tvec2 rotatedPosition;\n\trotatedPosition.x = cos( rotation ) * alignedPosition.x - sin( rotation ) * alignedPosition.y;\n\trotatedPosition.y = sin( rotation ) * alignedPosition.x + cos( rotation ) * alignedPosition.y;\n\n\tmvPosition.xy += rotatedPosition;\n\n\tgl_Position = projectionMatrix * mvPosition;\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\t#include <fog_vertex>\n\n}\n"};function _n(t){var e={};for(var n in t)for(var r in e[n]={},t[n]){var i=t[n][r];i&&(i.isColor||i.isMatrix3||i.isMatrix4||i.isVector2||i.isVector3||i.isVector4||i.isTexture)?e[n][r]=i.clone():Array.isArray(i)?e[n][r]=i.slice():e[n][r]=i;}return e}function xn(t){for(var e={},n=0;n<t.length;n++){var r=_n(t[n]);for(var i in r)e[i]=r[i];}return e}var Mn={clone:_n,merge:xn},bn={common:{diffuse:{value:new b(15658734)},opacity:{value:1},map:{value:null},uvTransform:{value:new Qe},alphaMap:{value:null}},specularmap:{specularMap:{value:null}},envmap:{envMap:{value:null},flipEnvMap:{value:-1},reflectivity:{value:1},refractionRatio:{value:.98},maxMipLevel:{value:0}},aomap:{aoMap:{value:null},aoMapIntensity:{value:1}},lightmap:{lightMap:{value:null},lightMapIntensity:{value:1}},emissivemap:{emissiveMap:{value:null}},bumpmap:{bumpMap:{value:null},bumpScale:{value:1}},normalmap:{normalMap:{value:null},normalScale:{value:new v(1,1)}},displacementmap:{displacementMap:{value:null},displacementScale:{value:1},displacementBias:{value:0}},roughnessmap:{roughnessMap:{value:null}},metalnessmap:{metalnessMap:{value:null}},gradientmap:{gradientMap:{value:null}},fog:{fogDensity:{value:25e-5},fogNear:{value:1},fogFar:{value:2e3},fogColor:{value:new b(16777215)}},lights:{ambientLightColor:{value:[]},directionalLights:{value:[],properties:{direction:{},color:{},shadow:{},shadowBias:{},shadowRadius:{},shadowMapSize:{}}},directionalShadowMap:{value:[]},directionalShadowMatrix:{value:[]},spotLights:{value:[],properties:{color:{},position:{},direction:{},distance:{},coneCos:{},penumbraCos:{},decay:{},shadow:{},shadowBias:{},shadowRadius:{},shadowMapSize:{}}},spotShadowMap:{value:[]},spotShadowMatrix:{value:[]},pointLights:{value:[],properties:{color:{},position:{},decay:{},distance:{},shadow:{},shadowBias:{},shadowRadius:{},shadowMapSize:{},shadowCameraNear:{},shadowCameraFar:{}}},pointShadowMap:{value:[]},pointShadowMatrix:{value:[]},hemisphereLights:{value:[],properties:{direction:{},skyColor:{},groundColor:{}}},rectAreaLights:{value:[],properties:{color:{},position:{},width:{},height:{}}}},points:{diffuse:{value:new b(15658734)},opacity:{value:1},size:{value:1},scale:{value:1},map:{value:null},uvTransform:{value:new Qe}},sprite:{diffuse:{value:new b(15658734)},opacity:{value:1},center:{value:new v(.5,.5)},rotation:{value:0},map:{value:null},uvTransform:{value:new Qe}}},wn={basic:{uniforms:xn([bn.common,bn.specularmap,bn.envmap,bn.aomap,bn.lightmap,bn.fog]),vertexShader:yn.meshbasic_vert,fragmentShader:yn.meshbasic_frag},lambert:{uniforms:xn([bn.common,bn.specularmap,bn.envmap,bn.aomap,bn.lightmap,bn.emissivemap,bn.fog,bn.lights,{emissive:{value:new b(0)}}]),vertexShader:yn.meshlambert_vert,fragmentShader:yn.meshlambert_frag},phong:{uniforms:xn([bn.common,bn.specularmap,bn.envmap,bn.aomap,bn.lightmap,bn.emissivemap,bn.bumpmap,bn.normalmap,bn.displacementmap,bn.gradientmap,bn.fog,bn.lights,{emissive:{value:new b(0)},specular:{value:new b(1118481)},shininess:{value:30}}]),vertexShader:yn.meshphong_vert,fragmentShader:yn.meshphong_frag},standard:{uniforms:xn([bn.common,bn.envmap,bn.aomap,bn.lightmap,bn.emissivemap,bn.bumpmap,bn.normalmap,bn.displacementmap,bn.roughnessmap,bn.metalnessmap,bn.fog,bn.lights,{emissive:{value:new b(0)},roughness:{value:.5},metalness:{value:.5},envMapIntensity:{value:1}}]),vertexShader:yn.meshphysical_vert,fragmentShader:yn.meshphysical_frag},matcap:{uniforms:xn([bn.common,bn.bumpmap,bn.normalmap,bn.displacementmap,bn.fog,{matcap:{value:null}}]),vertexShader:yn.meshmatcap_vert,fragmentShader:yn.meshmatcap_frag},points:{uniforms:xn([bn.points,bn.fog]),vertexShader:yn.points_vert,fragmentShader:yn.points_frag},dashed:{uniforms:xn([bn.common,bn.fog,{scale:{value:1},dashSize:{value:1},totalSize:{value:2}}]),vertexShader:yn.linedashed_vert,fragmentShader:yn.linedashed_frag},depth:{uniforms:xn([bn.common,bn.displacementmap]),vertexShader:yn.depth_vert,fragmentShader:yn.depth_frag},normal:{uniforms:xn([bn.common,bn.bumpmap,bn.normalmap,bn.displacementmap,{opacity:{value:1}}]),vertexShader:yn.normal_vert,fragmentShader:yn.normal_frag},sprite:{uniforms:xn([bn.sprite,bn.fog]),vertexShader:yn.sprite_vert,fragmentShader:yn.sprite_frag},background:{uniforms:{uvTransform:{value:new Qe},t2D:{value:null}},vertexShader:yn.background_vert,fragmentShader:yn.background_frag},cube:{uniforms:{tCube:{value:null},tFlip:{value:-1},opacity:{value:1}},vertexShader:yn.cube_vert,fragmentShader:yn.cube_frag},equirect:{uniforms:{tEquirect:{value:null}},vertexShader:yn.equirect_vert,fragmentShader:yn.equirect_frag},distanceRGBA:{uniforms:xn([bn.common,bn.displacementmap,{referencePosition:{value:new g},nearDistance:{value:1},farDistance:{value:1e3}}]),vertexShader:yn.distanceRGBA_vert,fragmentShader:yn.distanceRGBA_frag},shadow:{uniforms:xn([bn.lights,bn.fog,{color:{value:new b(0)},opacity:{value:1}}]),vertexShader:yn.shadow_vert,fragmentShader:yn.shadow_frag}};function En(){var t=null,e=!1,n=null;function r(i,a){!1!==e&&(n(i,a),t.requestAnimationFrame(r));}return {start:function(){!0!==e&&null!==n&&(t.requestAnimationFrame(r),e=!0);},stop:function(){e=!1;},setAnimationLoop:function(t){n=t;},setContext:function(e){t=e;}}}function Sn(t){var e=new WeakMap;return {get:function(t){return t.isInterleavedBufferAttribute&&(t=t.data),e.get(t)},remove:function(n){n.isInterleavedBufferAttribute&&(n=n.data);var r=e.get(n);r&&(t.deleteBuffer(r.buffer),e.delete(n));},update:function(n,r){n.isInterleavedBufferAttribute&&(n=n.data);var i=e.get(n);void 0===i?e.set(n,function(e,n){var r=e.array,i=e.dynamic?t.DYNAMIC_DRAW:t.STATIC_DRAW,a=t.createBuffer();t.bindBuffer(n,a),t.bufferData(n,r,i),e.onUploadCallback();var o=t.FLOAT;return r instanceof Float32Array?o=t.FLOAT:r instanceof Float64Array?console.warn("THREE.WebGLAttributes: Unsupported data buffer format: Float64Array."):r instanceof Uint16Array?o=t.UNSIGNED_SHORT:r instanceof Int16Array?o=t.SHORT:r instanceof Uint32Array?o=t.UNSIGNED_INT:r instanceof Int32Array?o=t.INT:r instanceof Int8Array?o=t.BYTE:r instanceof Uint8Array&&(o=t.UNSIGNED_BYTE),{buffer:a,type:o,bytesPerElement:r.BYTES_PER_ELEMENT,version:e.version}}(n,r)):i.version<n.version&&(function(e,n,r){var i=n.array,a=n.updateRange;t.bindBuffer(r,e),!1===n.dynamic?t.bufferData(r,i,t.STATIC_DRAW):-1===a.count?t.bufferSubData(r,0,i):0===a.count?console.error("THREE.WebGLObjects.updateBuffer: dynamic THREE.BufferAttribute marked as needsUpdate but updateRange.count is 0, ensure you are using set methods or updating manually."):(t.bufferSubData(r,a.offset*i.BYTES_PER_ELEMENT,i.subarray(a.offset,a.offset+a.count)),a.count=-1);}(i.buffer,n,r),i.version=n.version);}}}function Tn(t,e,n,r,i,a){this.a=t,this.b=e,this.c=n,this.normal=r&&r.isVector3?r:new g,this.vertexNormals=Array.isArray(r)?r:[],this.color=i&&i.isColor?i:new b,this.vertexColors=Array.isArray(i)?i:[],this.materialIndex=void 0!==a?a:0;}wn.physical={uniforms:xn([wn.standard.uniforms,{clearCoat:{value:0},clearCoatRoughness:{value:0}}]),vertexShader:yn.meshphysical_vert,fragmentShader:yn.meshphysical_frag},Object.assign(Tn.prototype,{clone:function(){return (new this.constructor).copy(this)},copy:function(t){this.a=t.a,this.b=t.b,this.c=t.c,this.normal.copy(t.normal),this.color.copy(t.color),this.materialIndex=t.materialIndex;for(var e=0,n=t.vertexNormals.length;e<n;e++)this.vertexNormals[e]=t.vertexNormals[e].clone();for(e=0,n=t.vertexColors.length;e<n;e++)this.vertexColors[e]=t.vertexColors[e].clone();return this}});var An,Ln,Cn=0;function Pn(){Object.defineProperty(this,"id",{value:Cn+=2}),this.uuid=d.generateUUID(),this.name="",this.type="Geometry",this.vertices=[],this.colors=[],this.faces=[],this.faceVertexUvs=[[]],this.morphTargets=[],this.morphNormals=[],this.skinWeights=[],this.skinIndices=[],this.lineDistances=[],this.boundingBox=null,this.boundingSphere=null,this.elementsNeedUpdate=!1,this.verticesNeedUpdate=!1,this.uvsNeedUpdate=!1,this.normalsNeedUpdate=!1,this.colorsNeedUpdate=!1,this.lineDistancesNeedUpdate=!1,this.groupsNeedUpdate=!1;}function Rn(){this.vertices=[],this.normals=[],this.colors=[],this.uvs=[],this.uvs2=[],this.groups=[],this.morphTargets={},this.skinWeights=[],this.skinIndices=[],this.boundingBox=null,this.boundingSphere=null,this.verticesNeedUpdate=!1,this.normalsNeedUpdate=!1,this.colorsNeedUpdate=!1,this.uvsNeedUpdate=!1,this.groupsNeedUpdate=!1;}function Fn(t){if(0===t.length)return -1/0;for(var e=t[0],n=1,r=t.length;n<r;++n)t[n]>e&&(e=t[n]);return e}Pn.prototype=Object.assign(Object.create(Ye.prototype),{constructor:Pn,isGeometry:!0,applyMatrix:function(t){for(var e=(new Qe).getNormalMatrix(t),n=0,r=this.vertices.length;n<r;n++){this.vertices[n].applyMatrix4(t);}for(n=0,r=this.faces.length;n<r;n++){var i=this.faces[n];i.normal.applyMatrix3(e).normalize();for(var a=0,o=i.vertexNormals.length;a<o;a++)i.vertexNormals[a].applyMatrix3(e).normalize();}return null!==this.boundingBox&&this.computeBoundingBox(),null!==this.boundingSphere&&this.computeBoundingSphere(),this.verticesNeedUpdate=!0,this.normalsNeedUpdate=!0,this},rotateX:function(){var t=new p;return function(e){return t.makeRotationX(e),this.applyMatrix(t),this}}(),rotateY:function(){var t=new p;return function(e){return t.makeRotationY(e),this.applyMatrix(t),this}}(),rotateZ:function(){var t=new p;return function(e){return t.makeRotationZ(e),this.applyMatrix(t),this}}(),translate:function(){var t=new p;return function(e,n,r){return t.makeTranslation(e,n,r),this.applyMatrix(t),this}}(),scale:function(){var t=new p;return function(e,n,r){return t.makeScale(e,n,r),this.applyMatrix(t),this}}(),lookAt:(Ln=new nn,function(t){Ln.lookAt(t),Ln.updateMatrix(),this.applyMatrix(Ln.matrix);}),fromBufferGeometry:function(t){var e=this,n=null!==t.index?t.index.array:void 0,r=t.attributes,i=r.position.array,a=void 0!==r.normal?r.normal.array:void 0,o=void 0!==r.color?r.color.array:void 0,s=void 0!==r.uv?r.uv.array:void 0,u=void 0!==r.uv2?r.uv2.array:void 0;void 0!==u&&(this.faceVertexUvs[1]=[]);for(var l=0,c=0;l<i.length;l+=3,c+=2)e.vertices.push((new g).fromArray(i,l)),void 0!==o&&e.colors.push((new b).fromArray(o,l));function h(t,n,r,i){var l=void 0===o?[]:[e.colors[t].clone(),e.colors[n].clone(),e.colors[r].clone()],c=new Tn(t,n,r,void 0===a?[]:[(new g).fromArray(a,3*t),(new g).fromArray(a,3*n),(new g).fromArray(a,3*r)],l,i);e.faces.push(c),void 0!==s&&e.faceVertexUvs[0].push([(new v).fromArray(s,2*t),(new v).fromArray(s,2*n),(new v).fromArray(s,2*r)]),void 0!==u&&e.faceVertexUvs[1].push([(new v).fromArray(u,2*t),(new v).fromArray(u,2*n),(new v).fromArray(u,2*r)]);}var f=t.groups;if(f.length>0)for(l=0;l<f.length;l++)for(var d=f[l],p=d.start,m=(c=p,p+d.count);c<m;c+=3)void 0!==n?h(n[c],n[c+1],n[c+2],d.materialIndex):h(c,c+1,c+2,d.materialIndex);else if(void 0!==n)for(l=0;l<n.length;l+=3)h(n[l],n[l+1],n[l+2]);else for(l=0;l<i.length/3;l+=3)h(l,l+1,l+2);return this.computeFaceNormals(),null!==t.boundingBox&&(this.boundingBox=t.boundingBox.clone()),null!==t.boundingSphere&&(this.boundingSphere=t.boundingSphere.clone()),this},center:(An=new g,function(){return this.computeBoundingBox(),this.boundingBox.getCenter(An).negate(),this.translate(An.x,An.y,An.z),this}),normalize:function(){this.computeBoundingSphere();var t=this.boundingSphere.center,e=this.boundingSphere.radius,n=0===e?1:1/e,r=new p;return r.set(n,0,0,-n*t.x,0,n,0,-n*t.y,0,0,n,-n*t.z,0,0,0,1),this.applyMatrix(r),this},computeFaceNormals:function(){for(var t=new g,e=new g,n=0,r=this.faces.length;n<r;n++){var i=this.faces[n],a=this.vertices[i.a],o=this.vertices[i.b],s=this.vertices[i.c];t.subVectors(s,o),e.subVectors(a,o),t.cross(e),t.normalize(),i.normal.copy(t);}},computeVertexNormals:function(t){var e,n,r,i,a,o;for(void 0===t&&(t=!0),o=new Array(this.vertices.length),e=0,n=this.vertices.length;e<n;e++)o[e]=new g;if(t){var s,u,l,c=new g,h=new g;for(r=0,i=this.faces.length;r<i;r++)a=this.faces[r],s=this.vertices[a.a],u=this.vertices[a.b],l=this.vertices[a.c],c.subVectors(l,u),h.subVectors(s,u),c.cross(h),o[a.a].add(c),o[a.b].add(c),o[a.c].add(c);}else for(this.computeFaceNormals(),r=0,i=this.faces.length;r<i;r++)o[(a=this.faces[r]).a].add(a.normal),o[a.b].add(a.normal),o[a.c].add(a.normal);for(e=0,n=this.vertices.length;e<n;e++)o[e].normalize();for(r=0,i=this.faces.length;r<i;r++){var f=(a=this.faces[r]).vertexNormals;3===f.length?(f[0].copy(o[a.a]),f[1].copy(o[a.b]),f[2].copy(o[a.c])):(f[0]=o[a.a].clone(),f[1]=o[a.b].clone(),f[2]=o[a.c].clone());}this.faces.length>0&&(this.normalsNeedUpdate=!0);},computeFlatVertexNormals:function(){var t,e,n;for(this.computeFaceNormals(),t=0,e=this.faces.length;t<e;t++){var r=(n=this.faces[t]).vertexNormals;3===r.length?(r[0].copy(n.normal),r[1].copy(n.normal),r[2].copy(n.normal)):(r[0]=n.normal.clone(),r[1]=n.normal.clone(),r[2]=n.normal.clone());}this.faces.length>0&&(this.normalsNeedUpdate=!0);},computeMorphNormals:function(){var t,e,n,r,i;for(n=0,r=this.faces.length;n<r;n++)for((i=this.faces[n]).__originalFaceNormal?i.__originalFaceNormal.copy(i.normal):i.__originalFaceNormal=i.normal.clone(),i.__originalVertexNormals||(i.__originalVertexNormals=[]),t=0,e=i.vertexNormals.length;t<e;t++)i.__originalVertexNormals[t]?i.__originalVertexNormals[t].copy(i.vertexNormals[t]):i.__originalVertexNormals[t]=i.vertexNormals[t].clone();var a=new Pn;for(a.faces=this.faces,t=0,e=this.morphTargets.length;t<e;t++){if(!this.morphNormals[t]){this.morphNormals[t]={},this.morphNormals[t].faceNormals=[],this.morphNormals[t].vertexNormals=[];var o=this.morphNormals[t].faceNormals,s=this.morphNormals[t].vertexNormals;for(n=0,r=this.faces.length;n<r;n++)u=new g,l={a:new g,b:new g,c:new g},o.push(u),s.push(l);}var u,l,c=this.morphNormals[t];for(a.vertices=this.morphTargets[t].vertices,a.computeFaceNormals(),a.computeVertexNormals(),n=0,r=this.faces.length;n<r;n++)i=this.faces[n],u=c.faceNormals[n],l=c.vertexNormals[n],u.copy(i.normal),l.a.copy(i.vertexNormals[0]),l.b.copy(i.vertexNormals[1]),l.c.copy(i.vertexNormals[2]);}for(n=0,r=this.faces.length;n<r;n++)(i=this.faces[n]).normal=i.__originalFaceNormal,i.vertexNormals=i.__originalVertexNormals;},computeBoundingBox:function(){null===this.boundingBox&&(this.boundingBox=new pn),this.boundingBox.setFromPoints(this.vertices);},computeBoundingSphere:function(){null===this.boundingSphere&&(this.boundingSphere=new mn),this.boundingSphere.setFromPoints(this.vertices);},merge:function(t,e,n){if(t&&t.isGeometry){var r,i=this.vertices.length,a=this.vertices,o=t.vertices,s=this.faces,u=t.faces,l=this.faceVertexUvs[0],c=t.faceVertexUvs[0],h=this.colors,f=t.colors;void 0===n&&(n=0),void 0!==e&&(r=(new Qe).getNormalMatrix(e));for(var d=0,p=o.length;d<p;d++){var m=o[d].clone();void 0!==e&&m.applyMatrix4(e),a.push(m);}for(d=0,p=f.length;d<p;d++)h.push(f[d].clone());for(d=0,p=u.length;d<p;d++){var g,v,y,_=u[d],x=_.vertexNormals,M=_.vertexColors;(g=new Tn(_.a+i,_.b+i,_.c+i)).normal.copy(_.normal),void 0!==r&&g.normal.applyMatrix3(r).normalize();for(var b=0,w=x.length;b<w;b++)v=x[b].clone(),void 0!==r&&v.applyMatrix3(r).normalize(),g.vertexNormals.push(v);g.color.copy(_.color);for(b=0,w=M.length;b<w;b++)y=M[b],g.vertexColors.push(y.clone());g.materialIndex=_.materialIndex+n,s.push(g);}for(d=0,p=c.length;d<p;d++){var E=c[d],S=[];if(void 0!==E){for(b=0,w=E.length;b<w;b++)S.push(E[b].clone());l.push(S);}}}else console.error("THREE.Geometry.merge(): geometry not an instance of THREE.Geometry.",t);},mergeMesh:function(t){t&&t.isMesh?(t.matrixAutoUpdate&&t.updateMatrix(),this.merge(t.geometry,t.matrix)):console.error("THREE.Geometry.mergeMesh(): mesh not an instance of THREE.Mesh.",t);},mergeVertices:function(){var t,e,n,r,i,a,o,s,u={},l=[],c=[],h=Math.pow(10,4);for(n=0,r=this.vertices.length;n<r;n++)t=this.vertices[n],void 0===u[e=Math.round(t.x*h)+"_"+Math.round(t.y*h)+"_"+Math.round(t.z*h)]?(u[e]=n,l.push(this.vertices[n]),c[n]=l.length-1):c[n]=c[u[e]];var f=[];for(n=0,r=this.faces.length;n<r;n++){(i=this.faces[n]).a=c[i.a],i.b=c[i.b],i.c=c[i.c],a=[i.a,i.b,i.c];for(var d=0;d<3;d++)if(a[d]===a[(d+1)%3]){f.push(n);break}}for(n=f.length-1;n>=0;n--){var p=f[n];for(this.faces.splice(p,1),o=0,s=this.faceVertexUvs.length;o<s;o++)this.faceVertexUvs[o].splice(p,1);}var m=this.vertices.length-l.length;return this.vertices=l,m},setFromPoints:function(t){this.vertices=[];for(var e=0,n=t.length;e<n;e++){var r=t[e];this.vertices.push(new g(r.x,r.y,r.z||0));}return this},sortFacesByMaterialIndex:function(){for(var t=this.faces,e=t.length,n=0;n<e;n++)t[n]._id=n;t.sort(function(t,e){return t.materialIndex-e.materialIndex});var r,i,a=this.faceVertexUvs[0],o=this.faceVertexUvs[1];a&&a.length===e&&(r=[]),o&&o.length===e&&(i=[]);for(n=0;n<e;n++){var s=t[n]._id;r&&r.push(a[s]),i&&i.push(o[s]);}r&&(this.faceVertexUvs[0]=r),i&&(this.faceVertexUvs[1]=i);},toJSON:function(){var t={metadata:{version:4.5,type:"Geometry",generator:"Geometry.toJSON"}};if(t.uuid=this.uuid,t.type=this.type,""!==this.name&&(t.name=this.name),void 0!==this.parameters){var e=this.parameters;for(var n in e)void 0!==e[n]&&(t[n]=e[n]);return t}for(var r=[],i=0;i<this.vertices.length;i++){var a=this.vertices[i];r.push(a.x,a.y,a.z);}var o=[],s=[],u={},l=[],c={},h=[],f={};for(i=0;i<this.faces.length;i++){var d=this.faces[i],p=void 0!==this.faceVertexUvs[0][i],m=d.normal.length()>0,g=d.vertexNormals.length>0,v=1!==d.color.r||1!==d.color.g||1!==d.color.b,y=d.vertexColors.length>0,_=0;if(_=w(_,0,0),_=w(_,1,!0),_=w(_,2,!1),_=w(_,3,p),_=w(_,4,m),_=w(_,5,g),_=w(_,6,v),_=w(_,7,y),o.push(_),o.push(d.a,d.b,d.c),o.push(d.materialIndex),p){var x=this.faceVertexUvs[0][i];o.push(T(x[0]),T(x[1]),T(x[2]));}if(m&&o.push(E(d.normal)),g){var M=d.vertexNormals;o.push(E(M[0]),E(M[1]),E(M[2]));}if(v&&o.push(S(d.color)),y){var b=d.vertexColors;o.push(S(b[0]),S(b[1]),S(b[2]));}}function w(t,e,n){return n?t|1<<e:t&~(1<<e)}function E(t){var e=t.x.toString()+t.y.toString()+t.z.toString();return void 0!==u[e]?u[e]:(u[e]=s.length/3,s.push(t.x,t.y,t.z),u[e])}function S(t){var e=t.r.toString()+t.g.toString()+t.b.toString();return void 0!==c[e]?c[e]:(c[e]=l.length,l.push(t.getHex()),c[e])}function T(t){var e=t.x.toString()+t.y.toString();return void 0!==f[e]?f[e]:(f[e]=h.length/2,h.push(t.x,t.y),f[e])}return t.data={},t.data.vertices=r,t.data.normals=s,l.length>0&&(t.data.colors=l),h.length>0&&(t.data.uvs=[h]),t.data.faces=o,t},clone:function(){return (new Pn).copy(this)},copy:function(t){var e,n,r,i,a,o;this.vertices=[],this.colors=[],this.faces=[],this.faceVertexUvs=[[]],this.morphTargets=[],this.morphNormals=[],this.skinWeights=[],this.skinIndices=[],this.lineDistances=[],this.boundingBox=null,this.boundingSphere=null,this.name=t.name;var s=t.vertices;for(e=0,n=s.length;e<n;e++)this.vertices.push(s[e].clone());var u=t.colors;for(e=0,n=u.length;e<n;e++)this.colors.push(u[e].clone());var l=t.faces;for(e=0,n=l.length;e<n;e++)this.faces.push(l[e].clone());for(e=0,n=t.faceVertexUvs.length;e<n;e++){var c=t.faceVertexUvs[e];for(void 0===this.faceVertexUvs[e]&&(this.faceVertexUvs[e]=[]),r=0,i=c.length;r<i;r++){var h=c[r],f=[];for(a=0,o=h.length;a<o;a++){var d=h[a];f.push(d.clone());}this.faceVertexUvs[e].push(f);}}var p=t.morphTargets;for(e=0,n=p.length;e<n;e++){var m={};if(m.name=p[e].name,void 0!==p[e].vertices)for(m.vertices=[],r=0,i=p[e].vertices.length;r<i;r++)m.vertices.push(p[e].vertices[r].clone());if(void 0!==p[e].normals)for(m.normals=[],r=0,i=p[e].normals.length;r<i;r++)m.normals.push(p[e].normals[r].clone());this.morphTargets.push(m);}var g=t.morphNormals;for(e=0,n=g.length;e<n;e++){var v={};if(void 0!==g[e].vertexNormals)for(v.vertexNormals=[],r=0,i=g[e].vertexNormals.length;r<i;r++){var y=g[e].vertexNormals[r],_={};_.a=y.a.clone(),_.b=y.b.clone(),_.c=y.c.clone(),v.vertexNormals.push(_);}if(void 0!==g[e].faceNormals)for(v.faceNormals=[],r=0,i=g[e].faceNormals.length;r<i;r++)v.faceNormals.push(g[e].faceNormals[r].clone());this.morphNormals.push(v);}var x=t.skinWeights;for(e=0,n=x.length;e<n;e++)this.skinWeights.push(x[e].clone());var M=t.skinIndices;for(e=0,n=M.length;e<n;e++)this.skinIndices.push(M[e].clone());var b=t.lineDistances;for(e=0,n=b.length;e<n;e++)this.lineDistances.push(b[e]);var w=t.boundingBox;null!==w&&(this.boundingBox=w.clone());var E=t.boundingSphere;return null!==E&&(this.boundingSphere=E.clone()),this.elementsNeedUpdate=t.elementsNeedUpdate,this.verticesNeedUpdate=t.verticesNeedUpdate,this.uvsNeedUpdate=t.uvsNeedUpdate,this.normalsNeedUpdate=t.normalsNeedUpdate,this.colorsNeedUpdate=t.colorsNeedUpdate,this.lineDistancesNeedUpdate=t.lineDistancesNeedUpdate,this.groupsNeedUpdate=t.groupsNeedUpdate,this},dispose:function(){this.dispatchEvent({type:"dispose"});}}),Object.assign(Rn.prototype,{computeGroups:function(t){for(var e,n=[],r=void 0,i=t.faces,a=0;a<i.length;a++){var o=i[a];o.materialIndex!==r&&(r=o.materialIndex,void 0!==e&&(e.count=3*a-e.start,n.push(e)),e={start:3*a,materialIndex:r});}void 0!==e&&(e.count=3*a-e.start,n.push(e)),this.groups=n;},fromGeometry:function(t){var e,n=t.faces,r=t.vertices,i=t.faceVertexUvs,a=i[0]&&i[0].length>0,o=i[1]&&i[1].length>0,s=t.morphTargets,u=s.length;if(u>0){e=[];for(var l=0;l<u;l++)e[l]={name:s[l].name,data:[]};this.morphTargets.position=e;}var c,h=t.morphNormals,f=h.length;if(f>0){c=[];for(l=0;l<f;l++)c[l]={name:h[l].name,data:[]};this.morphTargets.normal=c;}var d=t.skinIndices,p=t.skinWeights,m=d.length===r.length,g=p.length===r.length;r.length>0&&0===n.length&&console.error("THREE.DirectGeometry: Faceless geometries are not supported.");for(l=0;l<n.length;l++){var y=n[l];this.vertices.push(r[y.a],r[y.b],r[y.c]);var _=y.vertexNormals;if(3===_.length)this.normals.push(_[0],_[1],_[2]);else{var x=y.normal;this.normals.push(x,x,x);}var M,b=y.vertexColors;if(3===b.length)this.colors.push(b[0],b[1],b[2]);else{var w=y.color;this.colors.push(w,w,w);}if(!0===a)void 0!==(M=i[0][l])?this.uvs.push(M[0],M[1],M[2]):(console.warn("THREE.DirectGeometry.fromGeometry(): Undefined vertexUv ",l),this.uvs.push(new v,new v,new v));if(!0===o)void 0!==(M=i[1][l])?this.uvs2.push(M[0],M[1],M[2]):(console.warn("THREE.DirectGeometry.fromGeometry(): Undefined vertexUv2 ",l),this.uvs2.push(new v,new v,new v));for(var E=0;E<u;E++){var S=s[E].vertices;e[E].data.push(S[y.a],S[y.b],S[y.c]);}for(E=0;E<f;E++){var T=h[E].vertexNormals[l];c[E].data.push(T.a,T.b,T.c);}m&&this.skinIndices.push(d[y.a],d[y.b],d[y.c]),g&&this.skinWeights.push(p[y.a],p[y.b],p[y.c]);}return this.computeGroups(t),this.verticesNeedUpdate=t.verticesNeedUpdate,this.normalsNeedUpdate=t.normalsNeedUpdate,this.colorsNeedUpdate=t.colorsNeedUpdate,this.uvsNeedUpdate=t.uvsNeedUpdate,this.groupsNeedUpdate=t.groupsNeedUpdate,this}});var Dn=1;function In(){Object.defineProperty(this,"id",{value:Dn+=2}),this.uuid=d.generateUUID(),this.name="",this.type="BufferGeometry",this.index=null,this.attributes={},this.morphAttributes={},this.groups=[],this.boundingBox=null,this.boundingSphere=null,this.drawRange={start:0,count:1/0},this.userData={};}function Nn(t,e,n,r,i,a){Pn.call(this),this.type="BoxGeometry",this.parameters={width:t,height:e,depth:n,widthSegments:r,heightSegments:i,depthSegments:a},this.fromBufferGeometry(new On(t,e,n,r,i,a)),this.mergeVertices();}function On(t,e,n,r,i,a){In.call(this),this.type="BoxBufferGeometry",this.parameters={width:t,height:e,depth:n,widthSegments:r,heightSegments:i,depthSegments:a};var o=this;t=t||1,e=e||1,n=n||1,r=Math.floor(r)||1,i=Math.floor(i)||1,a=Math.floor(a)||1;var s=[],u=[],l=[],c=[],h=0,f=0;function d(t,e,n,r,i,a,d,p,m,v,y){var _,x,M=a/m,b=d/v,w=a/2,E=d/2,S=p/2,T=m+1,A=v+1,L=0,C=0,P=new g;for(x=0;x<A;x++){var R=x*b-E;for(_=0;_<T;_++){var F=_*M-w;P[t]=F*r,P[e]=R*i,P[n]=S,u.push(P.x,P.y,P.z),P[t]=0,P[e]=0,P[n]=p>0?1:-1,l.push(P.x,P.y,P.z),c.push(_/m),c.push(1-x/v),L+=1;}}for(x=0;x<v;x++)for(_=0;_<m;_++){var D=h+_+T*x,I=h+_+T*(x+1),N=h+(_+1)+T*(x+1),O=h+(_+1)+T*x;s.push(D,I,O),s.push(I,N,O),C+=6;}o.addGroup(f,C,y),f+=C,h+=L;}d("z","y","x",-1,-1,n,e,t,a,i,0),d("z","y","x",1,-1,n,e,-t,a,i,1),d("x","z","y",1,1,t,n,e,r,a,2),d("x","z","y",1,-1,t,n,-e,r,a,3),d("x","y","z",1,-1,t,e,n,r,i,4),d("x","y","z",-1,-1,t,e,-n,r,i,5),this.setIndex(s),this.addAttribute("position",new R(u,3)),this.addAttribute("normal",new R(l,3)),this.addAttribute("uv",new R(c,2));}function Un(t,e,n,r){Pn.call(this),this.type="PlaneGeometry",this.parameters={width:t,height:e,widthSegments:n,heightSegments:r},this.fromBufferGeometry(new Bn(t,e,n,r)),this.mergeVertices();}function Bn(t,e,n,r){In.call(this),this.type="PlaneBufferGeometry",this.parameters={width:t,height:e,widthSegments:n,heightSegments:r};var i,a,o=(t=t||1)/2,s=(e=e||1)/2,u=Math.floor(n)||1,l=Math.floor(r)||1,c=u+1,h=l+1,f=t/u,d=e/l,p=[],m=[],g=[],v=[];for(a=0;a<h;a++){var y=a*d-s;for(i=0;i<c;i++){var _=i*f-o;m.push(_,-y,0),g.push(0,0,1),v.push(i/u),v.push(1-a/l);}}for(a=0;a<l;a++)for(i=0;i<u;i++){var x=i+c*a,M=i+c*(a+1),b=i+1+c*(a+1),w=i+1+c*a;p.push(x,M,w),p.push(M,b,w);}this.setIndex(p),this.addAttribute("position",new R(m,3)),this.addAttribute("normal",new R(g,3)),this.addAttribute("uv",new R(v,2));}In.prototype=Object.assign(Object.create(Ye.prototype),{constructor:In,isBufferGeometry:!0,getIndex:function(){return this.index},setIndex:function(t){Array.isArray(t)?this.index=new(Fn(t)>65535?P:L)(t,1):this.index=t;},addAttribute:function(t,e){return e&&e.isBufferAttribute||e&&e.isInterleavedBufferAttribute?"index"===t?(console.warn("THREE.BufferGeometry.addAttribute: Use .setIndex() for index attribute."),this.setIndex(e),this):(this.attributes[t]=e,this):(console.warn("THREE.BufferGeometry: .addAttribute() now expects ( name, attribute )."),this.addAttribute(t,new w(arguments[1],arguments[2])))},getAttribute:function(t){return this.attributes[t]},removeAttribute:function(t){return delete this.attributes[t],this},addGroup:function(t,e,n){this.groups.push({start:t,count:e,materialIndex:void 0!==n?n:0});},clearGroups:function(){this.groups=[];},setDrawRange:function(t,e){this.drawRange.start=t,this.drawRange.count=e;},applyMatrix:function(t){var e=this.attributes.position;void 0!==e&&(t.applyToBufferAttribute(e),e.needsUpdate=!0);var n=this.attributes.normal;void 0!==n&&((new Qe).getNormalMatrix(t).applyToBufferAttribute(n),n.needsUpdate=!0);return null!==this.boundingBox&&this.computeBoundingBox(),null!==this.boundingSphere&&this.computeBoundingSphere(),this},rotateX:function(){var t=new p;return function(e){return t.makeRotationX(e),this.applyMatrix(t),this}}(),rotateY:function(){var t=new p;return function(e){return t.makeRotationY(e),this.applyMatrix(t),this}}(),rotateZ:function(){var t=new p;return function(e){return t.makeRotationZ(e),this.applyMatrix(t),this}}(),translate:function(){var t=new p;return function(e,n,r){return t.makeTranslation(e,n,r),this.applyMatrix(t),this}}(),scale:function(){var t=new p;return function(e,n,r){return t.makeScale(e,n,r),this.applyMatrix(t),this}}(),lookAt:function(){var t=new nn;return function(e){t.lookAt(e),t.updateMatrix(),this.applyMatrix(t.matrix);}}(),center:function(){var t=new g;return function(){return this.computeBoundingBox(),this.boundingBox.getCenter(t).negate(),this.translate(t.x,t.y,t.z),this}}(),setFromObject:function(t){var e=t.geometry;if(t.isPoints||t.isLine){var n=new R(3*e.vertices.length,3),r=new R(3*e.colors.length,3);if(this.addAttribute("position",n.copyVector3sArray(e.vertices)),this.addAttribute("color",r.copyColorsArray(e.colors)),e.lineDistances&&e.lineDistances.length===e.vertices.length){var i=new R(e.lineDistances.length,1);this.addAttribute("lineDistance",i.copyArray(e.lineDistances));}null!==e.boundingSphere&&(this.boundingSphere=e.boundingSphere.clone()),null!==e.boundingBox&&(this.boundingBox=e.boundingBox.clone());}else t.isMesh&&e&&e.isGeometry&&this.fromGeometry(e);return this},setFromPoints:function(t){for(var e=[],n=0,r=t.length;n<r;n++){var i=t[n];e.push(i.x,i.y,i.z||0);}return this.addAttribute("position",new R(e,3)),this},updateFromObject:function(t){var e,n=t.geometry;if(t.isMesh){var r=n.__directGeometry;if(!0===n.elementsNeedUpdate&&(r=void 0,n.elementsNeedUpdate=!1),void 0===r)return this.fromGeometry(n);r.verticesNeedUpdate=n.verticesNeedUpdate,r.normalsNeedUpdate=n.normalsNeedUpdate,r.colorsNeedUpdate=n.colorsNeedUpdate,r.uvsNeedUpdate=n.uvsNeedUpdate,r.groupsNeedUpdate=n.groupsNeedUpdate,n.verticesNeedUpdate=!1,n.normalsNeedUpdate=!1,n.colorsNeedUpdate=!1,n.uvsNeedUpdate=!1,n.groupsNeedUpdate=!1,n=r;}return !0===n.verticesNeedUpdate&&(void 0!==(e=this.attributes.position)&&(e.copyVector3sArray(n.vertices),e.needsUpdate=!0),n.verticesNeedUpdate=!1),!0===n.normalsNeedUpdate&&(void 0!==(e=this.attributes.normal)&&(e.copyVector3sArray(n.normals),e.needsUpdate=!0),n.normalsNeedUpdate=!1),!0===n.colorsNeedUpdate&&(void 0!==(e=this.attributes.color)&&(e.copyColorsArray(n.colors),e.needsUpdate=!0),n.colorsNeedUpdate=!1),n.uvsNeedUpdate&&(void 0!==(e=this.attributes.uv)&&(e.copyVector2sArray(n.uvs),e.needsUpdate=!0),n.uvsNeedUpdate=!1),n.lineDistancesNeedUpdate&&(void 0!==(e=this.attributes.lineDistance)&&(e.copyArray(n.lineDistances),e.needsUpdate=!0),n.lineDistancesNeedUpdate=!1),n.groupsNeedUpdate&&(n.computeGroups(t.geometry),this.groups=n.groups,n.groupsNeedUpdate=!1),this},fromGeometry:function(t){return t.__directGeometry=(new Rn).fromGeometry(t),this.fromDirectGeometry(t.__directGeometry)},fromDirectGeometry:function(t){var e=new Float32Array(3*t.vertices.length);if(this.addAttribute("position",new w(e,3).copyVector3sArray(t.vertices)),t.normals.length>0){var n=new Float32Array(3*t.normals.length);this.addAttribute("normal",new w(n,3).copyVector3sArray(t.normals));}if(t.colors.length>0){var r=new Float32Array(3*t.colors.length);this.addAttribute("color",new w(r,3).copyColorsArray(t.colors));}if(t.uvs.length>0){var i=new Float32Array(2*t.uvs.length);this.addAttribute("uv",new w(i,2).copyVector2sArray(t.uvs));}if(t.uvs2.length>0){var a=new Float32Array(2*t.uvs2.length);this.addAttribute("uv2",new w(a,2).copyVector2sArray(t.uvs2));}for(var o in this.groups=t.groups,t.morphTargets){for(var s=[],u=t.morphTargets[o],l=0,c=u.length;l<c;l++){var h=u[l],f=new R(3*h.data.length,3);f.name=h.name,s.push(f.copyVector3sArray(h.data));}this.morphAttributes[o]=s;}if(t.skinIndices.length>0){var d=new R(4*t.skinIndices.length,4);this.addAttribute("skinIndex",d.copyVector4sArray(t.skinIndices));}if(t.skinWeights.length>0){var p=new R(4*t.skinWeights.length,4);this.addAttribute("skinWeight",p.copyVector4sArray(t.skinWeights));}return null!==t.boundingSphere&&(this.boundingSphere=t.boundingSphere.clone()),null!==t.boundingBox&&(this.boundingBox=t.boundingBox.clone()),this},computeBoundingBox:function(){null===this.boundingBox&&(this.boundingBox=new pn);var t=this.attributes.position;void 0!==t?this.boundingBox.setFromBufferAttribute(t):this.boundingBox.makeEmpty(),(isNaN(this.boundingBox.min.x)||isNaN(this.boundingBox.min.y)||isNaN(this.boundingBox.min.z))&&console.error('THREE.BufferGeometry.computeBoundingBox: Computed min/max have NaN values. The "position" attribute is likely to have NaN values.',this);},computeBoundingSphere:function(){var t=new pn,e=new g;return function(){null===this.boundingSphere&&(this.boundingSphere=new mn);var n=this.attributes.position;if(n){var r=this.boundingSphere.center;t.setFromBufferAttribute(n),t.getCenter(r);for(var i=0,a=0,o=n.count;a<o;a++)e.x=n.getX(a),e.y=n.getY(a),e.z=n.getZ(a),i=Math.max(i,r.distanceToSquared(e));this.boundingSphere.radius=Math.sqrt(i),isNaN(this.boundingSphere.radius)&&console.error('THREE.BufferGeometry.computeBoundingSphere(): Computed radius is NaN. The "position" attribute is likely to have NaN values.',this);}}}(),computeFaceNormals:function(){},computeVertexNormals:function(){var t=this.index,e=this.attributes;if(e.position){var n=e.position.array;if(void 0===e.normal)this.addAttribute("normal",new w(new Float32Array(n.length),3));else for(var r=e.normal.array,i=0,a=r.length;i<a;i++)r[i]=0;var o,s,u,l=e.normal.array,c=new g,h=new g,f=new g,d=new g,p=new g;if(t){var m=t.array;for(i=0,a=t.count;i<a;i+=3)o=3*m[i+0],s=3*m[i+1],u=3*m[i+2],c.fromArray(n,o),h.fromArray(n,s),f.fromArray(n,u),d.subVectors(f,h),p.subVectors(c,h),d.cross(p),l[o]+=d.x,l[o+1]+=d.y,l[o+2]+=d.z,l[s]+=d.x,l[s+1]+=d.y,l[s+2]+=d.z,l[u]+=d.x,l[u+1]+=d.y,l[u+2]+=d.z;}else for(i=0,a=n.length;i<a;i+=9)c.fromArray(n,i),h.fromArray(n,i+3),f.fromArray(n,i+6),d.subVectors(f,h),p.subVectors(c,h),d.cross(p),l[i]=d.x,l[i+1]=d.y,l[i+2]=d.z,l[i+3]=d.x,l[i+4]=d.y,l[i+5]=d.z,l[i+6]=d.x,l[i+7]=d.y,l[i+8]=d.z;this.normalizeNormals(),e.normal.needsUpdate=!0;}},merge:function(t,e){if(t&&t.isBufferGeometry){void 0===e&&(e=0,console.warn("THREE.BufferGeometry.merge(): Overwriting original geometry, starting at offset=0. Use BufferGeometryUtils.mergeBufferGeometries() for lossless merge."));var n=this.attributes;for(var r in n)if(void 0!==t.attributes[r])for(var i=n[r].array,a=t.attributes[r],o=a.array,s=0,u=a.itemSize*e;s<o.length;s++,u++)i[u]=o[s];return this}console.error("THREE.BufferGeometry.merge(): geometry not an instance of THREE.BufferGeometry.",t);},normalizeNormals:function(){var t=new g;return function(){for(var e=this.attributes.normal,n=0,r=e.count;n<r;n++)t.x=e.getX(n),t.y=e.getY(n),t.z=e.getZ(n),t.normalize(),e.setXYZ(n,t.x,t.y,t.z);}}(),toNonIndexed:function(){function t(t,e){for(var n=t.array,r=t.itemSize,i=new n.constructor(e.length*r),a=0,o=0,s=0,u=e.length;s<u;s++){a=e[s]*r;for(var l=0;l<r;l++)i[o++]=n[a++];}return new w(i,r)}if(null===this.index)return console.warn("THREE.BufferGeometry.toNonIndexed(): Geometry is already non-indexed."),this;var e=new In,n=this.index.array,r=this.attributes;for(var i in r){var a=t(r[i],n);e.addAttribute(i,a);}var o=this.morphAttributes;for(i in o){for(var s=[],u=o[i],l=0,c=u.length;l<c;l++){a=t(u[l],n);s.push(a);}e.morphAttributes[i]=s;}for(var h=this.groups,f=(l=0,h.length);l<f;l++){var d=h[l];e.addGroup(d.start,d.count,d.materialIndex);}return e},toJSON:function(){var t={metadata:{version:4.5,type:"BufferGeometry",generator:"BufferGeometry.toJSON"}};if(t.uuid=this.uuid,t.type=this.type,""!==this.name&&(t.name=this.name),Object.keys(this.userData).length>0&&(t.userData=this.userData),void 0!==this.parameters){var e=this.parameters;for(var n in e)void 0!==e[n]&&(t[n]=e[n]);return t}t.data={attributes:{}};var r=this.index;if(null!==r){var i=Array.prototype.slice.call(r.array);t.data.index={type:r.array.constructor.name,array:i};}var a=this.attributes;for(var n in a){var o=a[n];i=Array.prototype.slice.call(o.array);t.data.attributes[n]={itemSize:o.itemSize,type:o.array.constructor.name,array:i,normalized:o.normalized};}var s=this.groups;s.length>0&&(t.data.groups=JSON.parse(JSON.stringify(s)));var u=this.boundingSphere;return null!==u&&(t.data.boundingSphere={center:u.center.toArray(),radius:u.radius}),t},clone:function(){return (new In).copy(this)},copy:function(t){var e,n,r;this.index=null,this.attributes={},this.morphAttributes={},this.groups=[],this.boundingBox=null,this.boundingSphere=null,this.name=t.name;var i=t.index;null!==i&&this.setIndex(i.clone());var a=t.attributes;for(e in a){var o=a[e];this.addAttribute(e,o.clone());}var s=t.morphAttributes;for(e in s){var u=[],l=s[e];for(n=0,r=l.length;n<r;n++)u.push(l[n].clone());this.morphAttributes[e]=u;}var c=t.groups;for(n=0,r=c.length;n<r;n++){var h=c[n];this.addGroup(h.start,h.count,h.materialIndex);}var f=t.boundingBox;null!==f&&(this.boundingBox=f.clone());var d=t.boundingSphere;return null!==d&&(this.boundingSphere=d.clone()),this.drawRange.start=t.drawRange.start,this.drawRange.count=t.drawRange.count,this.userData=t.userData,this},dispose:function(){this.dispatchEvent({type:"dispose"});}}),Nn.prototype=Object.create(Pn.prototype),Nn.prototype.constructor=Nn,On.prototype=Object.create(In.prototype),On.prototype.constructor=On,Un.prototype=Object.create(Pn.prototype),Un.prototype.constructor=Un,Bn.prototype=Object.create(In.prototype),Bn.prototype.constructor=Bn;var zn,Gn,kn,Vn,Hn,jn,Wn,Xn,qn,Yn,Zn,Jn,Qn=0;function Kn(){Object.defineProperty(this,"id",{value:Qn++}),this.uuid=d.generateUUID(),this.name="",this.type="Material",this.fog=!0,this.lights=!0,this.blending=W,this.side=G,this.flatShading=!1,this.vertexColors=H,this.opacity=1,this.transparent=!1,this.blendSrc=at,this.blendDst=ot,this.blendEquation=J,this.blendSrcAlpha=null,this.blendDstAlpha=null,this.blendEquationAlpha=null,this.depthFunc=mt,this.depthTest=!0,this.depthWrite=!0,this.clippingPlanes=null,this.clipIntersection=!1,this.clipShadows=!1,this.shadowSide=null,this.colorWrite=!0,this.precision=null,this.polygonOffset=!1,this.polygonOffsetFactor=0,this.polygonOffsetUnits=0,this.dithering=!1,this.alphaTest=0,this.premultipliedAlpha=!1,this.visible=!0,this.userData={},this.needsUpdate=!0;}function $n(t){Kn.call(this),this.type="ShaderMaterial",this.defines={},this.uniforms={},this.vertexShader="void main() {\n\tgl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}",this.fragmentShader="void main() {\n\tgl_FragColor = vec4( 1.0, 0.0, 0.0, 1.0 );\n}",this.linewidth=1,this.wireframe=!1,this.wireframeLinewidth=1,this.fog=!1,this.lights=!1,this.clipping=!1,this.skinning=!1,this.morphTargets=!1,this.morphNormals=!1,this.extensions={derivatives:!1,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1},this.defaultAttributeValues={color:[1,1,1],uv:[0,0],uv2:[0,0]},this.index0AttributeName=void 0,this.uniformsNeedUpdate=!1,void 0!==t&&(void 0!==t.attributes&&console.error("THREE.ShaderMaterial: attributes should now be defined in THREE.BufferGeometry instead."),this.setValues(t));}function tr(t,e){this.origin=void 0!==t?t:new g,this.direction=void 0!==e?e:new g;}function er(t,e,n){this.a=void 0!==t?t:new g,this.b=void 0!==e?e:new g,this.c=void 0!==n?n:new g;}function nr(t){Kn.call(this),this.type="MeshBasicMaterial",this.color=new b(16777215),this.map=null,this.lightMap=null,this.lightMapIntensity=1,this.aoMap=null,this.aoMapIntensity=1,this.specularMap=null,this.alphaMap=null,this.envMap=null,this.combine=xt,this.reflectivity=1,this.refractionRatio=.98,this.wireframe=!1,this.wireframeLinewidth=1,this.wireframeLinecap="round",this.wireframeLinejoin="round",this.skinning=!1,this.morphTargets=!1,this.lights=!1,this.setValues(t);}function rr(t,e){nn.call(this),this.type="Mesh",this.geometry=void 0!==t?t:new In,this.material=void 0!==e?e:new nr({color:16777215*Math.random()}),this.drawMode=Ne,this.updateMorphTargets();}function ir(t,e,n,r){var i,a,o=new b(0),s=0,u=null,l=0;function c(t,n){e.buffers.color.setClear(t.r,t.g,t.b,n,r);}return {getClearColor:function(){return o},setClearColor:function(t,e){o.set(t),c(o,s=void 0!==e?e:1);},getClearAlpha:function(){return s},setClearAlpha:function(t){c(o,s=t);},render:function(e,r,h,f){var d=r.background;if(null===d?(c(o,s),u=null,l=0):d&&d.isColor&&(c(d,1),f=!0,u=null,l=0),(t.autoClear||f)&&t.clear(t.autoClearColor,t.autoClearDepth,t.autoClearStencil),d&&(d.isCubeTexture||d.isWebGLRenderTargetCube)){void 0===a&&((a=new rr(new On(1,1,1),new $n({type:"BackgroundCubeMaterial",uniforms:_n(wn.cube.uniforms),vertexShader:wn.cube.vertexShader,fragmentShader:wn.cube.fragmentShader,side:k,depthTest:!1,depthWrite:!1,fog:!1}))).geometry.removeAttribute("normal"),a.geometry.removeAttribute("uv"),a.onBeforeRender=function(t,e,n){this.matrixWorld.copyPosition(n.matrixWorld);},Object.defineProperty(a.material,"map",{get:function(){return this.uniforms.tCube.value}}),n.update(a));var p=d.isWebGLRenderTargetCube?d.texture:d;a.material.uniforms.tCube.value=p,a.material.uniforms.tFlip.value=d.isWebGLRenderTargetCube?1:-1,u===d&&l===p.version||(a.material.needsUpdate=!0,u=d,l=p.version),e.unshift(a,a.geometry,a.material,0,0,null);}else d&&d.isTexture&&(void 0===i&&((i=new rr(new Bn(2,2),new $n({type:"BackgroundMaterial",uniforms:_n(wn.background.uniforms),vertexShader:wn.background.vertexShader,fragmentShader:wn.background.fragmentShader,side:G,depthTest:!1,depthWrite:!1,fog:!1}))).geometry.removeAttribute("normal"),Object.defineProperty(i.material,"map",{get:function(){return this.uniforms.t2D.value}}),n.update(i)),i.material.uniforms.t2D.value=d,!0===d.matrixAutoUpdate&&d.updateMatrix(),i.material.uniforms.uvTransform.value.copy(d.matrix),u===d&&l===d.version||(i.material.needsUpdate=!0,u=d,l=d.version),e.unshift(i,i.geometry,i.material,0,0,null));}}}function ar(t,e,n,r){var i;this.setMode=function(t){i=t;},this.render=function(e,r){t.drawArrays(i,e,r),n.update(r,i);},this.renderInstances=function(a,o,s){var u;if(r.isWebGL2)u=t;else if(null===(u=e.get("ANGLE_instanced_arrays")))return void console.error("THREE.WebGLBufferRenderer: using THREE.InstancedBufferGeometry but hardware does not support extension ANGLE_instanced_arrays.");u[r.isWebGL2?"drawArraysInstanced":"drawArraysInstancedANGLE"](i,o,s,a.maxInstancedCount),n.update(s,i,a.maxInstancedCount);};}function or(t,e,n){var r;function i(e){if("highp"===e){if(t.getShaderPrecisionFormat(t.VERTEX_SHADER,t.HIGH_FLOAT).precision>0&&t.getShaderPrecisionFormat(t.FRAGMENT_SHADER,t.HIGH_FLOAT).precision>0)return "highp";e="mediump";}return "mediump"===e&&t.getShaderPrecisionFormat(t.VERTEX_SHADER,t.MEDIUM_FLOAT).precision>0&&t.getShaderPrecisionFormat(t.FRAGMENT_SHADER,t.MEDIUM_FLOAT).precision>0?"mediump":"lowp"}var a="undefined"!=typeof WebGL2RenderingContext&&t instanceof WebGL2RenderingContext,o=void 0!==n.precision?n.precision:"highp",s=i(o);s!==o&&(console.warn("THREE.WebGLRenderer:",o,"not supported, using",s,"instead."),o=s);var u=!0===n.logarithmicDepthBuffer,l=t.getParameter(t.MAX_TEXTURE_IMAGE_UNITS),c=t.getParameter(t.MAX_VERTEX_TEXTURE_IMAGE_UNITS),h=t.getParameter(t.MAX_TEXTURE_SIZE),f=t.getParameter(t.MAX_CUBE_MAP_TEXTURE_SIZE),d=t.getParameter(t.MAX_VERTEX_ATTRIBS),p=t.getParameter(t.MAX_VERTEX_UNIFORM_VECTORS),m=t.getParameter(t.MAX_VARYING_VECTORS),g=t.getParameter(t.MAX_FRAGMENT_UNIFORM_VECTORS),v=c>0,y=a||!!e.get("OES_texture_float");return {isWebGL2:a,getMaxAnisotropy:function(){if(void 0!==r)return r;var n=e.get("EXT_texture_filter_anisotropic");return r=null!==n?t.getParameter(n.MAX_TEXTURE_MAX_ANISOTROPY_EXT):0},getMaxPrecision:i,precision:o,logarithmicDepthBuffer:u,maxTextures:l,maxVertexTextures:c,maxTextureSize:h,maxCubemapSize:f,maxAttributes:d,maxVertexUniforms:p,maxVaryings:m,maxFragmentUniforms:g,vertexTextures:v,floatFragmentTextures:y,floatVertexTextures:v&&y,maxSamples:a?t.getParameter(t.MAX_SAMPLES):0}}function sr(){var t=this,e=null,n=0,r=!1,i=!1,a=new gn,o=new Qe,s={value:null,needsUpdate:!1};function u(){s.value!==e&&(s.value=e,s.needsUpdate=n>0),t.numPlanes=n,t.numIntersection=0;}function l(e,n,r,i){var u=null!==e?e.length:0,l=null;if(0!==u){if(l=s.value,!0!==i||null===l){var c=r+4*u,h=n.matrixWorldInverse;o.getNormalMatrix(h),(null===l||l.length<c)&&(l=new Float32Array(c));for(var f=0,d=r;f!==u;++f,d+=4)a.copy(e[f]).applyMatrix4(h,o),a.normal.toArray(l,d),l[d+3]=a.constant;}s.value=l,s.needsUpdate=!0;}return t.numPlanes=u,l}this.uniform=s,this.numPlanes=0,this.numIntersection=0,this.init=function(t,i,a){var o=0!==t.length||i||0!==n||r;return r=i,e=l(t,a,0),n=t.length,o},this.beginShadows=function(){i=!0,l(null);},this.endShadows=function(){i=!1,u();},this.setState=function(t,a,o,c,h,f){if(!r||null===t||0===t.length||i&&!o)i?l(null):u();else{var d=i?0:n,p=4*d,m=h.clippingState||null;s.value=m,m=l(t,c,p,f);for(var g=0;g!==p;++g)m[g]=e[g];h.clippingState=m,this.numIntersection=a?this.numPlanes:0,this.numPlanes+=d;}};}function ur(t){var e={};return {get:function(n){if(void 0!==e[n])return e[n];var r;switch(n){case"WEBGL_depth_texture":r=t.getExtension("WEBGL_depth_texture")||t.getExtension("MOZ_WEBGL_depth_texture")||t.getExtension("WEBKIT_WEBGL_depth_texture");break;case"EXT_texture_filter_anisotropic":r=t.getExtension("EXT_texture_filter_anisotropic")||t.getExtension("MOZ_EXT_texture_filter_anisotropic")||t.getExtension("WEBKIT_EXT_texture_filter_anisotropic");break;case"WEBGL_compressed_texture_s3tc":r=t.getExtension("WEBGL_compressed_texture_s3tc")||t.getExtension("MOZ_WEBGL_compressed_texture_s3tc")||t.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc");break;case"WEBGL_compressed_texture_pvrtc":r=t.getExtension("WEBGL_compressed_texture_pvrtc")||t.getExtension("WEBKIT_WEBGL_compressed_texture_pvrtc");break;default:r=t.getExtension(n);}return null===r&&console.warn("THREE.WebGLRenderer: "+n+" extension not supported."),e[n]=r,r}}}function lr(t,e,n){var r={},i={};function a(t){var o=t.target,s=r[o.id];for(var u in null!==s.index&&e.remove(s.index),s.attributes)e.remove(s.attributes[u]);o.removeEventListener("dispose",a),delete r[o.id];var l=i[s.id];l&&(e.remove(l),delete i[s.id]),n.memory.geometries--;}return {get:function(t,e){var i=r[e.id];return i||(e.addEventListener("dispose",a),e.isBufferGeometry?i=e:e.isGeometry&&(void 0===e._bufferGeometry&&(e._bufferGeometry=(new In).setFromObject(t)),i=e._bufferGeometry),r[e.id]=i,n.memory.geometries++,i)},update:function(n){var r=n.index,i=n.attributes;for(var a in null!==r&&e.update(r,t.ELEMENT_ARRAY_BUFFER),i)e.update(i[a],t.ARRAY_BUFFER);var o=n.morphAttributes;for(var a in o)for(var s=o[a],u=0,l=s.length;u<l;u++)e.update(s[u],t.ARRAY_BUFFER);},getWireframeAttribute:function(n){var r=i[n.id];if(r)return r;var a,o=[],s=n.index,u=n.attributes;if(null!==s)for(var l=0,c=(a=s.array).length;l<c;l+=3){var h=a[l+0],f=a[l+1],d=a[l+2];o.push(h,f,f,d,d,h);}else for(l=0,c=(a=u.position.array).length/3-1;l<c;l+=3)h=l+0,f=l+1,d=l+2,o.push(h,f,f,d,d,h);return r=new(Fn(o)>65535?P:L)(o,1),e.update(r,t.ELEMENT_ARRAY_BUFFER),i[n.id]=r,r}}}function cr(t,e,n,r){var i,a,o;this.setMode=function(t){i=t;},this.setIndex=function(t){a=t.type,o=t.bytesPerElement;},this.render=function(e,r){t.drawElements(i,r,a,e*o),n.update(r,i);},this.renderInstances=function(s,u,l){var c;if(r.isWebGL2)c=t;else if(null===(c=e.get("ANGLE_instanced_arrays")))return void console.error("THREE.WebGLIndexedBufferRenderer: using THREE.InstancedBufferGeometry but hardware does not support extension ANGLE_instanced_arrays.");c[r.isWebGL2?"drawElementsInstanced":"drawElementsInstancedANGLE"](i,l,a,u*o,s.maxInstancedCount),n.update(l,i,s.maxInstancedCount);};}function hr(t){var e={frame:0,calls:0,triangles:0,points:0,lines:0};return {memory:{geometries:0,textures:0},render:e,programs:null,autoReset:!0,reset:function(){e.frame++,e.calls=0,e.triangles=0,e.points=0,e.lines=0;},update:function(n,r,i){switch(i=i||1,e.calls++,r){case t.TRIANGLES:e.triangles+=i*(n/3);break;case t.TRIANGLE_STRIP:case t.TRIANGLE_FAN:e.triangles+=i*(n-2);break;case t.LINES:e.lines+=i*(n/2);break;case t.LINE_STRIP:e.lines+=i*(n-1);break;case t.LINE_LOOP:e.lines+=i*n;break;case t.POINTS:e.points+=i*n;break;default:console.error("THREE.WebGLInfo: Unknown draw mode:",r);}}}}function fr(t,e){return Math.abs(e[1])-Math.abs(t[1])}function dr(t){var e={},n=new Float32Array(8);return {update:function(r,i,a,o){var s=r.morphTargetInfluences,u=s.length,l=e[i.id];if(void 0===l){l=[];for(var c=0;c<u;c++)l[c]=[c,0];e[i.id]=l;}var h=a.morphTargets&&i.morphAttributes.position,f=a.morphNormals&&i.morphAttributes.normal;for(c=0;c<u;c++)0!==(d=l[c])[1]&&(h&&i.removeAttribute("morphTarget"+c),f&&i.removeAttribute("morphNormal"+c));for(c=0;c<u;c++)(d=l[c])[0]=c,d[1]=s[c];for(l.sort(fr),c=0;c<8;c++){var d;if(d=l[c]){var p=d[0],m=d[1];if(m){h&&i.addAttribute("morphTarget"+c,h[p]),f&&i.addAttribute("morphNormal"+c,f[p]),n[c]=m;continue}}n[c]=0;}o.getUniforms().setValue(t,"morphTargetInfluences",n);}}}function pr(t,e){var n={};return {update:function(r){var i=e.render.frame,a=r.geometry,o=t.get(r,a);return n[o.id]!==i&&(a.isGeometry&&o.updateFromObject(r),t.update(o),n[o.id]=i),o},dispose:function(){n={};}}}function mr(t,e,n,r,i,a,o,s,u,l){t=void 0!==t?t:[],e=void 0!==e?e:Ct,fn.call(this,t,e,n,r,i,a,o,s,u,l),this.flipY=!1;}function gr(t,e,n,r){fn.call(this,null),this.image={data:t,width:e,height:n,depth:r},this.magFilter=zt,this.minFilter=zt,this.generateMipmaps=!1,this.flipY=!1;}Kn.prototype=Object.assign(Object.create(Ye.prototype),{constructor:Kn,isMaterial:!0,onBeforeCompile:function(){},setValues:function(t){if(void 0!==t)for(var e in t){var n=t[e];if(void 0!==n)if("shading"!==e){var r=this[e];void 0!==r?r&&r.isColor?r.set(n):r&&r.isVector3&&n&&n.isVector3?r.copy(n):this[e]=n:console.warn("THREE."+this.type+": '"+e+"' is not a property of this material.");}else console.warn("THREE."+this.type+": .shading has been removed. Use the boolean .flatShading instead."),this.flatShading=1===n;else console.warn("THREE.Material: '"+e+"' parameter is undefined.");}},toJSON:function(t){var e=void 0===t||"string"==typeof t;e&&(t={textures:{},images:{}});var n={metadata:{version:4.5,type:"Material",generator:"Material.toJSON"}};function r(t){var e=[];for(var n in t){var r=t[n];delete r.metadata,e.push(r);}return e}if(n.uuid=this.uuid,n.type=this.type,""!==this.name&&(n.name=this.name),this.color&&this.color.isColor&&(n.color=this.color.getHex()),void 0!==this.roughness&&(n.roughness=this.roughness),void 0!==this.metalness&&(n.metalness=this.metalness),this.emissive&&this.emissive.isColor&&(n.emissive=this.emissive.getHex()),1!==this.emissiveIntensity&&(n.emissiveIntensity=this.emissiveIntensity),this.specular&&this.specular.isColor&&(n.specular=this.specular.getHex()),void 0!==this.shininess&&(n.shininess=this.shininess),void 0!==this.clearCoat&&(n.clearCoat=this.clearCoat),void 0!==this.clearCoatRoughness&&(n.clearCoatRoughness=this.clearCoatRoughness),this.map&&this.map.isTexture&&(n.map=this.map.toJSON(t).uuid),this.alphaMap&&this.alphaMap.isTexture&&(n.alphaMap=this.alphaMap.toJSON(t).uuid),this.lightMap&&this.lightMap.isTexture&&(n.lightMap=this.lightMap.toJSON(t).uuid),this.aoMap&&this.aoMap.isTexture&&(n.aoMap=this.aoMap.toJSON(t).uuid,n.aoMapIntensity=this.aoMapIntensity),this.bumpMap&&this.bumpMap.isTexture&&(n.bumpMap=this.bumpMap.toJSON(t).uuid,n.bumpScale=this.bumpScale),this.normalMap&&this.normalMap.isTexture&&(n.normalMap=this.normalMap.toJSON(t).uuid,n.normalMapType=this.normalMapType,n.normalScale=this.normalScale.toArray()),this.displacementMap&&this.displacementMap.isTexture&&(n.displacementMap=this.displacementMap.toJSON(t).uuid,n.displacementScale=this.displacementScale,n.displacementBias=this.displacementBias),this.roughnessMap&&this.roughnessMap.isTexture&&(n.roughnessMap=this.roughnessMap.toJSON(t).uuid),this.metalnessMap&&this.metalnessMap.isTexture&&(n.metalnessMap=this.metalnessMap.toJSON(t).uuid),this.emissiveMap&&this.emissiveMap.isTexture&&(n.emissiveMap=this.emissiveMap.toJSON(t).uuid),this.specularMap&&this.specularMap.isTexture&&(n.specularMap=this.specularMap.toJSON(t).uuid),this.envMap&&this.envMap.isTexture&&(n.envMap=this.envMap.toJSON(t).uuid,n.reflectivity=this.reflectivity,void 0!==this.combine&&(n.combine=this.combine),void 0!==this.envMapIntensity&&(n.envMapIntensity=this.envMapIntensity)),this.gradientMap&&this.gradientMap.isTexture&&(n.gradientMap=this.gradientMap.toJSON(t).uuid),void 0!==this.size&&(n.size=this.size),void 0!==this.sizeAttenuation&&(n.sizeAttenuation=this.sizeAttenuation),this.blending!==W&&(n.blending=this.blending),!0===this.flatShading&&(n.flatShading=this.flatShading),this.side!==G&&(n.side=this.side),this.vertexColors!==H&&(n.vertexColors=this.vertexColors),this.opacity<1&&(n.opacity=this.opacity),!0===this.transparent&&(n.transparent=this.transparent),n.depthFunc=this.depthFunc,n.depthTest=this.depthTest,n.depthWrite=this.depthWrite,0!==this.rotation&&(n.rotation=this.rotation),!0===this.polygonOffset&&(n.polygonOffset=!0),0!==this.polygonOffsetFactor&&(n.polygonOffsetFactor=this.polygonOffsetFactor),0!==this.polygonOffsetUnits&&(n.polygonOffsetUnits=this.polygonOffsetUnits),1!==this.linewidth&&(n.linewidth=this.linewidth),void 0!==this.dashSize&&(n.dashSize=this.dashSize),void 0!==this.gapSize&&(n.gapSize=this.gapSize),void 0!==this.scale&&(n.scale=this.scale),!0===this.dithering&&(n.dithering=!0),this.alphaTest>0&&(n.alphaTest=this.alphaTest),!0===this.premultipliedAlpha&&(n.premultipliedAlpha=this.premultipliedAlpha),!0===this.wireframe&&(n.wireframe=this.wireframe),this.wireframeLinewidth>1&&(n.wireframeLinewidth=this.wireframeLinewidth),"round"!==this.wireframeLinecap&&(n.wireframeLinecap=this.wireframeLinecap),"round"!==this.wireframeLinejoin&&(n.wireframeLinejoin=this.wireframeLinejoin),!0===this.morphTargets&&(n.morphTargets=!0),!0===this.skinning&&(n.skinning=!0),!1===this.visible&&(n.visible=!1),"{}"!==JSON.stringify(this.userData)&&(n.userData=this.userData),e){var i=r(t.textures),a=r(t.images);i.length>0&&(n.textures=i),a.length>0&&(n.images=a);}return n},clone:function(){return (new this.constructor).copy(this)},copy:function(t){this.name=t.name,this.fog=t.fog,this.lights=t.lights,this.blending=t.blending,this.side=t.side,this.flatShading=t.flatShading,this.vertexColors=t.vertexColors,this.opacity=t.opacity,this.transparent=t.transparent,this.blendSrc=t.blendSrc,this.blendDst=t.blendDst,this.blendEquation=t.blendEquation,this.blendSrcAlpha=t.blendSrcAlpha,this.blendDstAlpha=t.blendDstAlpha,this.blendEquationAlpha=t.blendEquationAlpha,this.depthFunc=t.depthFunc,this.depthTest=t.depthTest,this.depthWrite=t.depthWrite,this.colorWrite=t.colorWrite,this.precision=t.precision,this.polygonOffset=t.polygonOffset,this.polygonOffsetFactor=t.polygonOffsetFactor,this.polygonOffsetUnits=t.polygonOffsetUnits,this.dithering=t.dithering,this.alphaTest=t.alphaTest,this.premultipliedAlpha=t.premultipliedAlpha,this.visible=t.visible,this.userData=JSON.parse(JSON.stringify(t.userData)),this.clipShadows=t.clipShadows,this.clipIntersection=t.clipIntersection;var e=t.clippingPlanes,n=null;if(null!==e){var r=e.length;n=new Array(r);for(var i=0;i!==r;++i)n[i]=e[i].clone();}return this.clippingPlanes=n,this.shadowSide=t.shadowSide,this},dispose:function(){this.dispatchEvent({type:"dispose"});}}),$n.prototype=Object.create(Kn.prototype),$n.prototype.constructor=$n,$n.prototype.isShaderMaterial=!0,$n.prototype.copy=function(t){return Kn.prototype.copy.call(this,t),this.fragmentShader=t.fragmentShader,this.vertexShader=t.vertexShader,this.uniforms=_n(t.uniforms),this.defines=Object.assign({},t.defines),this.wireframe=t.wireframe,this.wireframeLinewidth=t.wireframeLinewidth,this.lights=t.lights,this.clipping=t.clipping,this.skinning=t.skinning,this.morphTargets=t.morphTargets,this.morphNormals=t.morphNormals,this.extensions=t.extensions,this},$n.prototype.toJSON=function(t){var e=Kn.prototype.toJSON.call(this,t);for(var n in e.uniforms={},this.uniforms){var r=this.uniforms[n].value;r&&r.isTexture?e.uniforms[n]={type:"t",value:r.toJSON(t).uuid}:r&&r.isColor?e.uniforms[n]={type:"c",value:r.getHex()}:r&&r.isVector2?e.uniforms[n]={type:"v2",value:r.toArray()}:r&&r.isVector3?e.uniforms[n]={type:"v3",value:r.toArray()}:r&&r.isVector4?e.uniforms[n]={type:"v4",value:r.toArray()}:r&&r.isMatrix3?e.uniforms[n]={type:"m3",value:r.toArray()}:r&&r.isMatrix4?e.uniforms[n]={type:"m4",value:r.toArray()}:e.uniforms[n]={value:r};}Object.keys(this.defines).length>0&&(e.defines=this.defines),e.vertexShader=this.vertexShader,e.fragmentShader=this.fragmentShader;var i={};for(var a in this.extensions)!0===this.extensions[a]&&(i[a]=!0);return Object.keys(i).length>0&&(e.extensions=i),e},Object.assign(tr.prototype,{set:function(t,e){return this.origin.copy(t),this.direction.copy(e),this},clone:function(){return (new this.constructor).copy(this)},copy:function(t){return this.origin.copy(t.origin),this.direction.copy(t.direction),this},at:function(t,e){return void 0===e&&(console.warn("THREE.Ray: .at() target is now required"),e=new g),e.copy(this.direction).multiplyScalar(t).add(this.origin)},lookAt:function(t){return this.direction.copy(t).sub(this.origin).normalize(),this},recast:function(){var t=new g;return function(e){return this.origin.copy(this.at(e,t)),this}}(),closestPointToPoint:function(t,e){void 0===e&&(console.warn("THREE.Ray: .closestPointToPoint() target is now required"),e=new g),e.subVectors(t,this.origin);var n=e.dot(this.direction);return n<0?e.copy(this.origin):e.copy(this.direction).multiplyScalar(n).add(this.origin)},distanceToPoint:function(t){return Math.sqrt(this.distanceSqToPoint(t))},distanceSqToPoint:function(){var t=new g;return function(e){var n=t.subVectors(e,this.origin).dot(this.direction);return n<0?this.origin.distanceToSquared(e):(t.copy(this.direction).multiplyScalar(n).add(this.origin),t.distanceToSquared(e))}}(),distanceSqToSegment:(Gn=new g,kn=new g,Vn=new g,function(t,e,n,r){Gn.copy(t).add(e).multiplyScalar(.5),kn.copy(e).sub(t).normalize(),Vn.copy(this.origin).sub(Gn);var i,a,o,s,u=.5*t.distanceTo(e),l=-this.direction.dot(kn),c=Vn.dot(this.direction),h=-Vn.dot(kn),f=Vn.lengthSq(),d=Math.abs(1-l*l);if(d>0)if(a=l*c-h,s=u*d,(i=l*h-c)>=0)if(a>=-s)if(a<=s){var p=1/d;o=(i*=p)*(i+l*(a*=p)+2*c)+a*(l*i+a+2*h)+f;}else a=u,o=-(i=Math.max(0,-(l*a+c)))*i+a*(a+2*h)+f;else a=-u,o=-(i=Math.max(0,-(l*a+c)))*i+a*(a+2*h)+f;else a<=-s?o=-(i=Math.max(0,-(-l*u+c)))*i+(a=i>0?-u:Math.min(Math.max(-u,-h),u))*(a+2*h)+f:a<=s?(i=0,o=(a=Math.min(Math.max(-u,-h),u))*(a+2*h)+f):o=-(i=Math.max(0,-(l*u+c)))*i+(a=i>0?u:Math.min(Math.max(-u,-h),u))*(a+2*h)+f;else a=l>0?-u:u,o=-(i=Math.max(0,-(l*a+c)))*i+a*(a+2*h)+f;return n&&n.copy(this.direction).multiplyScalar(i).add(this.origin),r&&r.copy(kn).multiplyScalar(a).add(Gn),o}),intersectSphere:function(){var t=new g;return function(e,n){t.subVectors(e.center,this.origin);var r=t.dot(this.direction),i=t.dot(t)-r*r,a=e.radius*e.radius;if(i>a)return null;var o=Math.sqrt(a-i),s=r-o,u=r+o;return s<0&&u<0?null:s<0?this.at(u,n):this.at(s,n)}}(),intersectsSphere:function(t){return this.distanceSqToPoint(t.center)<=t.radius*t.radius},distanceToPlane:function(t){var e=t.normal.dot(this.direction);if(0===e)return 0===t.distanceToPoint(this.origin)?0:null;var n=-(this.origin.dot(t.normal)+t.constant)/e;return n>=0?n:null},intersectPlane:function(t,e){var n=this.distanceToPlane(t);return null===n?null:this.at(n,e)},intersectsPlane:function(t){var e=t.distanceToPoint(this.origin);return 0===e||t.normal.dot(this.direction)*e<0},intersectBox:function(t,e){var n,r,i,a,o,s,u=1/this.direction.x,l=1/this.direction.y,c=1/this.direction.z,h=this.origin;return u>=0?(n=(t.min.x-h.x)*u,r=(t.max.x-h.x)*u):(n=(t.max.x-h.x)*u,r=(t.min.x-h.x)*u),l>=0?(i=(t.min.y-h.y)*l,a=(t.max.y-h.y)*l):(i=(t.max.y-h.y)*l,a=(t.min.y-h.y)*l),n>a||i>r?null:((i>n||n!=n)&&(n=i),(a<r||r!=r)&&(r=a),c>=0?(o=(t.min.z-h.z)*c,s=(t.max.z-h.z)*c):(o=(t.max.z-h.z)*c,s=(t.min.z-h.z)*c),n>s||o>r?null:((o>n||n!=n)&&(n=o),(s<r||r!=r)&&(r=s),r<0?null:this.at(n>=0?n:r,e)))},intersectsBox:(zn=new g,function(t){return null!==this.intersectBox(t,zn)}),intersectTriangle:function(){var t=new g,e=new g,n=new g,r=new g;return function(i,a,o,s,u){e.subVectors(a,i),n.subVectors(o,i),r.crossVectors(e,n);var l,c=this.direction.dot(r);if(c>0){if(s)return null;l=1;}else{if(!(c<0))return null;l=-1,c=-c;}t.subVectors(this.origin,i);var h=l*this.direction.dot(n.crossVectors(t,n));if(h<0)return null;var f=l*this.direction.dot(e.cross(t));if(f<0)return null;if(h+f>c)return null;var d=-l*t.dot(r);return d<0?null:this.at(d/c,u)}}(),applyMatrix4:function(t){return this.origin.applyMatrix4(t),this.direction.transformDirection(t),this},equals:function(t){return t.origin.equals(this.origin)&&t.direction.equals(this.direction)}}),Object.assign(er,{getNormal:(jn=new g,function(t,e,n,r){void 0===r&&(console.warn("THREE.Triangle: .getNormal() target is now required"),r=new g),r.subVectors(n,e),jn.subVectors(t,e),r.cross(jn);var i=r.lengthSq();return i>0?r.multiplyScalar(1/Math.sqrt(i)):r.set(0,0,0)}),getBarycoord:function(){var t=new g,e=new g,n=new g;return function(r,i,a,o,s){t.subVectors(o,i),e.subVectors(a,i),n.subVectors(r,i);var u=t.dot(t),l=t.dot(e),c=t.dot(n),h=e.dot(e),f=e.dot(n),d=u*h-l*l;if(void 0===s&&(console.warn("THREE.Triangle: .getBarycoord() target is now required"),s=new g),0===d)return s.set(-2,-1,-1);var p=1/d,m=(h*c-l*f)*p,v=(u*f-l*c)*p;return s.set(1-m-v,v,m)}}(),containsPoint:function(){var t=new g;return function(e,n,r,i){return er.getBarycoord(e,n,r,i,t),t.x>=0&&t.y>=0&&t.x+t.y<=1}}(),getUV:(Hn=new g,function(t,e,n,r,i,a,o,s){return this.getBarycoord(t,e,n,r,Hn),s.set(0,0),s.addScaledVector(i,Hn.x),s.addScaledVector(a,Hn.y),s.addScaledVector(o,Hn.z),s})}),Object.assign(er.prototype,{set:function(t,e,n){return this.a.copy(t),this.b.copy(e),this.c.copy(n),this},setFromPointsAndIndices:function(t,e,n,r){return this.a.copy(t[e]),this.b.copy(t[n]),this.c.copy(t[r]),this},clone:function(){return (new this.constructor).copy(this)},copy:function(t){return this.a.copy(t.a),this.b.copy(t.b),this.c.copy(t.c),this},getArea:function(){var t=new g,e=new g;return function(){return t.subVectors(this.c,this.b),e.subVectors(this.a,this.b),.5*t.cross(e).length()}}(),getMidpoint:function(t){return void 0===t&&(console.warn("THREE.Triangle: .getMidpoint() target is now required"),t=new g),t.addVectors(this.a,this.b).add(this.c).multiplyScalar(1/3)},getNormal:function(t){return er.getNormal(this.a,this.b,this.c,t)},getPlane:function(t){return void 0===t&&(console.warn("THREE.Triangle: .getPlane() target is now required"),t=new g),t.setFromCoplanarPoints(this.a,this.b,this.c)},getBarycoord:function(t,e){return er.getBarycoord(t,this.a,this.b,this.c,e)},containsPoint:function(t){return er.containsPoint(t,this.a,this.b,this.c)},getUV:function(t,e,n,r,i){return er.getUV(t,this.a,this.b,this.c,e,n,r,i)},intersectsBox:function(t){return t.intersectsTriangle(this)},closestPointToPoint:(Wn=new g,Xn=new g,qn=new g,Yn=new g,Zn=new g,Jn=new g,function(t,e){void 0===e&&(console.warn("THREE.Triangle: .closestPointToPoint() target is now required"),e=new g);var n,r,i=this.a,a=this.b,o=this.c;Wn.subVectors(a,i),Xn.subVectors(o,i),Yn.subVectors(t,i);var s=Wn.dot(Yn),u=Xn.dot(Yn);if(s<=0&&u<=0)return e.copy(i);Zn.subVectors(t,a);var l=Wn.dot(Zn),c=Xn.dot(Zn);if(l>=0&&c<=l)return e.copy(a);var h=s*c-l*u;if(h<=0&&s>=0&&l<=0)return n=s/(s-l),e.copy(i).addScaledVector(Wn,n);Jn.subVectors(t,o);var f=Wn.dot(Jn),d=Xn.dot(Jn);if(d>=0&&f<=d)return e.copy(o);var p=f*u-s*d;if(p<=0&&u>=0&&d<=0)return r=u/(u-d),e.copy(i).addScaledVector(Xn,r);var m=l*d-f*c;if(m<=0&&c-l>=0&&f-d>=0)return qn.subVectors(o,a),r=(c-l)/(c-l+(f-d)),e.copy(a).addScaledVector(qn,r);var v=1/(m+p+h);return n=p*v,r=h*v,e.copy(i).addScaledVector(Wn,n).addScaledVector(Xn,r)}),equals:function(t){return t.a.equals(this.a)&&t.b.equals(this.b)&&t.c.equals(this.c)}}),nr.prototype=Object.create(Kn.prototype),nr.prototype.constructor=nr,nr.prototype.isMeshBasicMaterial=!0,nr.prototype.copy=function(t){return Kn.prototype.copy.call(this,t),this.color.copy(t.color),this.map=t.map,this.lightMap=t.lightMap,this.lightMapIntensity=t.lightMapIntensity,this.aoMap=t.aoMap,this.aoMapIntensity=t.aoMapIntensity,this.specularMap=t.specularMap,this.alphaMap=t.alphaMap,this.envMap=t.envMap,this.combine=t.combine,this.reflectivity=t.reflectivity,this.refractionRatio=t.refractionRatio,this.wireframe=t.wireframe,this.wireframeLinewidth=t.wireframeLinewidth,this.wireframeLinecap=t.wireframeLinecap,this.wireframeLinejoin=t.wireframeLinejoin,this.skinning=t.skinning,this.morphTargets=t.morphTargets,this},rr.prototype=Object.assign(Object.create(nn.prototype),{constructor:rr,isMesh:!0,setDrawMode:function(t){this.drawMode=t;},copy:function(t){return nn.prototype.copy.call(this,t),this.drawMode=t.drawMode,void 0!==t.morphTargetInfluences&&(this.morphTargetInfluences=t.morphTargetInfluences.slice()),void 0!==t.morphTargetDictionary&&(this.morphTargetDictionary=Object.assign({},t.morphTargetDictionary)),this},updateMorphTargets:function(){var t,e,n,r=this.geometry;if(r.isBufferGeometry){var i=r.morphAttributes,a=Object.keys(i);if(a.length>0){var o=i[a[0]];if(void 0!==o)for(this.morphTargetInfluences=[],this.morphTargetDictionary={},t=0,e=o.length;t<e;t++)n=o[t].name||String(t),this.morphTargetInfluences.push(0),this.morphTargetDictionary[n]=t;}}else{var s=r.morphTargets;void 0!==s&&s.length>0&&console.error("THREE.Mesh.updateMorphTargets() no longer supports THREE.Geometry. Use THREE.BufferGeometry instead.");}},raycast:function(){var t=new p,e=new tr,n=new mn,r=new g,i=new g,a=new g,o=new g,s=new g,u=new g,l=new v,c=new v,h=new v,f=new g,d=new g;function m(t,e,n,r,i,a,o,s){if(null===(e.side===k?r.intersectTriangle(o,a,i,!0,s):r.intersectTriangle(i,a,o,e.side!==V,s)))return null;d.copy(s),d.applyMatrix4(t.matrixWorld);var u=n.ray.origin.distanceTo(d);return u<n.near||u>n.far?null:{distance:u,point:d.clone(),object:t}}function y(t,e,n,o,s,u,d,p,g){r.fromBufferAttribute(s,d),i.fromBufferAttribute(s,p),a.fromBufferAttribute(s,g);var y=m(t,e,n,o,r,i,a,f);if(y){u&&(l.fromBufferAttribute(u,d),c.fromBufferAttribute(u,p),h.fromBufferAttribute(u,g),y.uv=er.getUV(f,r,i,a,l,c,h,new v));var _=new Tn(d,p,g);er.getNormal(r,i,a,_.normal),y.face=_;}return y}return function(d,p){var g,_=this.geometry,x=this.material,M=this.matrixWorld;if(void 0!==x&&(null===_.boundingSphere&&_.computeBoundingSphere(),n.copy(_.boundingSphere),n.applyMatrix4(M),!1!==d.ray.intersectsSphere(n)&&(t.getInverse(M),e.copy(d.ray).applyMatrix4(t),null===_.boundingBox||!1!==e.intersectsBox(_.boundingBox))))if(_.isBufferGeometry){var b,w,E,S,T,A,L,C,P,R=_.index,F=_.attributes.position,D=_.attributes.uv,I=_.groups,N=_.drawRange;if(null!==R)if(Array.isArray(x))for(S=0,A=I.length;S<A;S++)for(P=x[(C=I[S]).materialIndex],T=Math.max(C.start,N.start),L=Math.min(C.start+C.count,N.start+N.count);T<L;T+=3)b=R.getX(T),w=R.getX(T+1),E=R.getX(T+2),(g=y(this,P,d,e,F,D,b,w,E))&&(g.faceIndex=Math.floor(T/3),g.face.materialIndex=C.materialIndex,p.push(g));else for(S=Math.max(0,N.start),A=Math.min(R.count,N.start+N.count);S<A;S+=3)b=R.getX(S),w=R.getX(S+1),E=R.getX(S+2),(g=y(this,x,d,e,F,D,b,w,E))&&(g.faceIndex=Math.floor(S/3),p.push(g));else if(void 0!==F)if(Array.isArray(x))for(S=0,A=I.length;S<A;S++)for(P=x[(C=I[S]).materialIndex],T=Math.max(C.start,N.start),L=Math.min(C.start+C.count,N.start+N.count);T<L;T+=3)(g=y(this,P,d,e,F,D,b=T,w=T+1,E=T+2))&&(g.faceIndex=Math.floor(T/3),g.face.materialIndex=C.materialIndex,p.push(g));else for(S=Math.max(0,N.start),A=Math.min(F.count,N.start+N.count);S<A;S+=3)(g=y(this,x,d,e,F,D,b=S,w=S+1,E=S+2))&&(g.faceIndex=Math.floor(S/3),p.push(g));}else if(_.isGeometry){var O,U,B,z,G=Array.isArray(x),k=_.vertices,V=_.faces,H=_.faceVertexUvs[0];H.length>0&&(z=H);for(var j=0,W=V.length;j<W;j++){var X=V[j],q=G?x[X.materialIndex]:x;if(void 0!==q){if(O=k[X.a],U=k[X.b],B=k[X.c],!0===q.morphTargets){var Y=_.morphTargets,Z=this.morphTargetInfluences;r.set(0,0,0),i.set(0,0,0),a.set(0,0,0);for(var J=0,Q=Y.length;J<Q;J++){var K=Z[J];if(0!==K){var $=Y[J].vertices;r.addScaledVector(o.subVectors($[X.a],O),K),i.addScaledVector(s.subVectors($[X.b],U),K),a.addScaledVector(u.subVectors($[X.c],B),K);}}r.add(O),i.add(U),a.add(B),O=r,U=i,B=a;}if(g=m(this,q,d,e,O,U,B,f)){if(z&&z[j]){var tt=z[j];l.copy(tt[0]),c.copy(tt[1]),h.copy(tt[2]),g.uv=er.getUV(f,O,U,B,l,c,h,new v);}g.face=X,g.faceIndex=j,p.push(g);}}}}}}(),clone:function(){return new this.constructor(this.geometry,this.material).copy(this)}}),mr.prototype=Object.create(fn.prototype),mr.prototype.constructor=mr,mr.prototype.isCubeTexture=!0,Object.defineProperty(mr.prototype,"images",{get:function(){return this.image},set:function(t){this.image=t;}}),gr.prototype=Object.create(fn.prototype),gr.prototype.constructor=gr,gr.prototype.isDataTexture3D=!0;var vr=new fn,yr=new gr,_r=new mr;function xr(){this.seq=[],this.map={};}var Mr=[],br=[],wr=new Float32Array(16),Er=new Float32Array(9),Sr=new Float32Array(4);function Tr(t,e,n){var r=t[0];if(r<=0||r>0)return t;var i=e*n,a=Mr[i];if(void 0===a&&(a=new Float32Array(i),Mr[i]=a),0!==e){r.toArray(a,0);for(var o=1,s=0;o!==e;++o)s+=n,t[o].toArray(a,s);}return a}function Ar(t,e){if(t.length!==e.length)return !1;for(var n=0,r=t.length;n<r;n++)if(t[n]!==e[n])return !1;return !0}function Lr(t,e){for(var n=0,r=e.length;n<r;n++)t[n]=e[n];}function Cr(t,e){var n=br[e];void 0===n&&(n=new Int32Array(e),br[e]=n);for(var r=0;r!==e;++r)n[r]=t.allocTextureUnit();return n}function Pr(t,e){var n=this.cache;n[0]!==e&&(t.uniform1f(this.addr,e),n[0]=e);}function Rr(t,e){var n=this.cache;n[0]!==e&&(t.uniform1i(this.addr,e),n[0]=e);}function Fr(t,e){var n=this.cache;if(void 0!==e.x)n[0]===e.x&&n[1]===e.y||(t.uniform2f(this.addr,e.x,e.y),n[0]=e.x,n[1]=e.y);else{if(Ar(n,e))return;t.uniform2fv(this.addr,e),Lr(n,e);}}function Dr(t,e){var n=this.cache;if(void 0!==e.x)n[0]===e.x&&n[1]===e.y&&n[2]===e.z||(t.uniform3f(this.addr,e.x,e.y,e.z),n[0]=e.x,n[1]=e.y,n[2]=e.z);else if(void 0!==e.r)n[0]===e.r&&n[1]===e.g&&n[2]===e.b||(t.uniform3f(this.addr,e.r,e.g,e.b),n[0]=e.r,n[1]=e.g,n[2]=e.b);else{if(Ar(n,e))return;t.uniform3fv(this.addr,e),Lr(n,e);}}function Ir(t,e){var n=this.cache;if(void 0!==e.x)n[0]===e.x&&n[1]===e.y&&n[2]===e.z&&n[3]===e.w||(t.uniform4f(this.addr,e.x,e.y,e.z,e.w),n[0]=e.x,n[1]=e.y,n[2]=e.z,n[3]=e.w);else{if(Ar(n,e))return;t.uniform4fv(this.addr,e),Lr(n,e);}}function Nr(t,e){var n=this.cache,r=e.elements;if(void 0===r){if(Ar(n,e))return;t.uniformMatrix2fv(this.addr,!1,e),Lr(n,e);}else{if(Ar(n,r))return;Sr.set(r),t.uniformMatrix2fv(this.addr,!1,Sr),Lr(n,r);}}function Or(t,e){var n=this.cache,r=e.elements;if(void 0===r){if(Ar(n,e))return;t.uniformMatrix3fv(this.addr,!1,e),Lr(n,e);}else{if(Ar(n,r))return;Er.set(r),t.uniformMatrix3fv(this.addr,!1,Er),Lr(n,r);}}function Ur(t,e){var n=this.cache,r=e.elements;if(void 0===r){if(Ar(n,e))return;t.uniformMatrix4fv(this.addr,!1,e),Lr(n,e);}else{if(Ar(n,r))return;wr.set(r),t.uniformMatrix4fv(this.addr,!1,wr),Lr(n,r);}}function Br(t,e,n){var r=this.cache,i=n.allocTextureUnit();r[0]!==i&&(t.uniform1i(this.addr,i),r[0]=i),n.setTexture2D(e||vr,i);}function zr(t,e,n){var r=this.cache,i=n.allocTextureUnit();r[0]!==i&&(t.uniform1i(this.addr,i),r[0]=i),n.setTexture3D(e||yr,i);}function Gr(t,e,n){var r=this.cache,i=n.allocTextureUnit();r[0]!==i&&(t.uniform1i(this.addr,i),r[0]=i),n.setTextureCube(e||_r,i);}function kr(t,e){var n=this.cache;Ar(n,e)||(t.uniform2iv(this.addr,e),Lr(n,e));}function Vr(t,e){var n=this.cache;Ar(n,e)||(t.uniform3iv(this.addr,e),Lr(n,e));}function Hr(t,e){var n=this.cache;Ar(n,e)||(t.uniform4iv(this.addr,e),Lr(n,e));}function jr(t,e){var n=this.cache;Ar(n,e)||(t.uniform1fv(this.addr,e),Lr(n,e));}function Wr(t,e){var n=this.cache;Ar(n,e)||(t.uniform1iv(this.addr,e),Lr(n,e));}function Xr(t,e){var n=this.cache,r=Tr(e,this.size,2);Ar(n,r)||(t.uniform2fv(this.addr,r),this.updateCache(r));}function qr(t,e){var n=this.cache,r=Tr(e,this.size,3);Ar(n,r)||(t.uniform3fv(this.addr,r),this.updateCache(r));}function Yr(t,e){var n=this.cache,r=Tr(e,this.size,4);Ar(n,r)||(t.uniform4fv(this.addr,r),this.updateCache(r));}function Zr(t,e){var n=this.cache,r=Tr(e,this.size,4);Ar(n,r)||(t.uniformMatrix2fv(this.addr,!1,r),this.updateCache(r));}function Jr(t,e){var n=this.cache,r=Tr(e,this.size,9);Ar(n,r)||(t.uniformMatrix3fv(this.addr,!1,r),this.updateCache(r));}function Qr(t,e){var n=this.cache,r=Tr(e,this.size,16);Ar(n,r)||(t.uniformMatrix4fv(this.addr,!1,r),this.updateCache(r));}function Kr(t,e,n){var r=this.cache,i=e.length,a=Cr(n,i);!1===Ar(r,a)&&(t.uniform1iv(this.addr,a),Lr(r,a));for(var o=0;o!==i;++o)n.setTexture2D(e[o]||vr,a[o]);}function $r(t,e,n){var r=this.cache,i=e.length,a=Cr(n,i);!1===Ar(r,a)&&(t.uniform1iv(this.addr,a),Lr(r,a));for(var o=0;o!==i;++o)n.setTextureCube(e[o]||_r,a[o]);}function ti(t,e,n){this.id=t,this.addr=n,this.cache=[],this.setValue=function(t){switch(t){case 5126:return Pr;case 35664:return Fr;case 35665:return Dr;case 35666:return Ir;case 35674:return Nr;case 35675:return Or;case 35676:return Ur;case 35678:case 36198:return Br;case 35679:return zr;case 35680:return Gr;case 5124:case 35670:return Rr;case 35667:case 35671:return kr;case 35668:case 35672:return Vr;case 35669:case 35673:return Hr}}(e.type);}function ei(t,e,n){this.id=t,this.addr=n,this.cache=[],this.size=e.size,this.setValue=function(t){switch(t){case 5126:return jr;case 35664:return Xr;case 35665:return qr;case 35666:return Yr;case 35674:return Zr;case 35675:return Jr;case 35676:return Qr;case 35678:return Kr;case 35680:return $r;case 5124:case 35670:return Wr;case 35667:case 35671:return kr;case 35668:case 35672:return Vr;case 35669:case 35673:return Hr}}(e.type);}function ni(t){this.id=t,xr.call(this);}ei.prototype.updateCache=function(t){var e=this.cache;t instanceof Float32Array&&e.length!==t.length&&(this.cache=new Float32Array(t.length)),Lr(e,t);},ni.prototype.setValue=function(t,e,n){for(var r=this.seq,i=0,a=r.length;i!==a;++i){var o=r[i];o.setValue(t,e[o.id],n);}};var ri=/([\w\d_]+)(\])?(\[|\.)?/g;function ii(t,e){t.seq.push(e),t.map[e.id]=e;}function ai(t,e,n){var r=t.name,i=r.length;for(ri.lastIndex=0;;){var a=ri.exec(r),o=ri.lastIndex,s=a[1],u="]"===a[2],l=a[3];if(u&&(s|=0),void 0===l||"["===l&&o+2===i){ii(n,void 0===l?new ti(s,t,e):new ei(s,t,e));break}var c=n.map[s];void 0===c&&ii(n,c=new ni(s)),n=c;}}function oi(t,e,n){xr.call(this),this.renderer=n;for(var r=t.getProgramParameter(e,t.ACTIVE_UNIFORMS),i=0;i<r;++i){var a=t.getActiveUniform(e,i);ai(a,t.getUniformLocation(e,a.name),this);}}function si(t,e,n){var r=t.createShader(e);return t.shaderSource(r,n),t.compileShader(r),!1===t.getShaderParameter(r,t.COMPILE_STATUS)&&console.error("THREE.WebGLShader: Shader couldn't compile."),""!==t.getShaderInfoLog(r)&&console.warn("THREE.WebGLShader: gl.getShaderInfoLog()",e===t.VERTEX_SHADER?"vertex":"fragment",t.getShaderInfoLog(r),function(t){for(var e=t.split("\n"),n=0;n<e.length;n++)e[n]=n+1+": "+e[n];return e.join("\n")}(n)),r}oi.prototype.setValue=function(t,e,n){var r=this.map[e];void 0!==r&&r.setValue(t,n,this.renderer);},oi.prototype.setOptional=function(t,e,n){var r=e[n];void 0!==r&&this.setValue(t,n,r);},oi.upload=function(t,e,n,r){for(var i=0,a=e.length;i!==a;++i){var o=e[i],s=n[o.id];!1!==s.needsUpdate&&o.setValue(t,s.value,r);}},oi.seqWithValue=function(t,e){for(var n=[],r=0,i=t.length;r!==i;++r){var a=t[r];a.id in e&&n.push(a);}return n};var ui=0;function li(t){switch(t){case Be:return ["Linear","( value )"];case ze:return ["sRGB","( value )"];case ke:return ["RGBE","( value )"];case Ve:return ["RGBM","( value, 7.0 )"];case He:return ["RGBM","( value, 16.0 )"];case je:return ["RGBD","( value, 256.0 )"];case Ge:return ["Gamma","( value, float( GAMMA_FACTOR ) )"];default:throw new Error("unsupported encoding: "+t)}}function ci(t,e){var n=li(e);return "vec4 "+t+"( vec4 value ) { return "+n[0]+"ToLinear"+n[1]+"; }"}function hi(t,e){var n;switch(e){case Et:n="Linear";break;case St:n="Reinhard";break;case Tt:n="Uncharted2";break;case At:n="OptimizedCineon";break;case Lt:n="ACESFilmic";break;default:throw new Error("unsupported toneMapping: "+e)}return "vec3 "+t+"( vec3 color ) { return "+n+"ToneMapping( color ); }"}function fi(t){return ""!==t}function di(t,e){return t.replace(/NUM_DIR_LIGHTS/g,e.numDirLights).replace(/NUM_SPOT_LIGHTS/g,e.numSpotLights).replace(/NUM_RECT_AREA_LIGHTS/g,e.numRectAreaLights).replace(/NUM_POINT_LIGHTS/g,e.numPointLights).replace(/NUM_HEMI_LIGHTS/g,e.numHemiLights)}function pi(t,e){return t.replace(/NUM_CLIPPING_PLANES/g,e.numClippingPlanes).replace(/UNION_CLIPPING_PLANES/g,e.numClippingPlanes-e.numClipIntersection)}function mi(t){return t.replace(/^[ \t]*#include +<([\w\d.\/]+)>/gm,function(t,e){var n=yn[e];if(void 0===n)throw new Error("Can not resolve #include <"+e+">");return mi(n)})}function gi(t){return t.replace(/#pragma unroll_loop[\s]+?for \( int i \= (\d+)\; i < (\d+)\; i \+\+ \) \{([\s\S]+?)(?=\})\}/g,function(t,e,n,r){for(var i="",a=parseInt(e);a<parseInt(n);a++)i+=r.replace(/\[ i \]/g,"[ "+a+" ]");return i})}function vi(t,e,n,r,i,a,o){var s=t.context,u=r.defines,l=i.vertexShader,c=i.fragmentShader,h="SHADOWMAP_TYPE_BASIC";a.shadowMapType===B?h="SHADOWMAP_TYPE_PCF":a.shadowMapType===z&&(h="SHADOWMAP_TYPE_PCF_SOFT");var f="ENVMAP_TYPE_CUBE",d="ENVMAP_MODE_REFLECTION",p="ENVMAP_BLENDING_MULTIPLY";if(a.envMap){switch(r.envMap.mapping){case Ct:case Pt:f="ENVMAP_TYPE_CUBE";break;case It:case Nt:f="ENVMAP_TYPE_CUBE_UV";break;case Rt:case Ft:f="ENVMAP_TYPE_EQUIREC";break;case Dt:f="ENVMAP_TYPE_SPHERE";}switch(r.envMap.mapping){case Pt:case Ft:d="ENVMAP_MODE_REFRACTION";}switch(r.combine){case xt:p="ENVMAP_BLENDING_MULTIPLY";break;case Mt:p="ENVMAP_BLENDING_MIX";break;case bt:p="ENVMAP_BLENDING_ADD";}}var m,g,v,y,_,x=t.gammaFactor>0?t.gammaFactor:1,M=o.isWebGL2?"":function(t,e,n){return [(t=t||{}).derivatives||e.envMapCubeUV||e.bumpMap||e.normalMap&&!e.objectSpaceNormalMap||e.flatShading?"#extension GL_OES_standard_derivatives : enable":"",(t.fragDepth||e.logarithmicDepthBuffer)&&n.get("EXT_frag_depth")?"#extension GL_EXT_frag_depth : enable":"",t.drawBuffers&&n.get("WEBGL_draw_buffers")?"#extension GL_EXT_draw_buffers : require":"",(t.shaderTextureLOD||e.envMap)&&n.get("EXT_shader_texture_lod")?"#extension GL_EXT_shader_texture_lod : enable":""].filter(fi).join("\n")}(r.extensions,a,e),b=function(t){var e=[];for(var n in t){var r=t[n];!1!==r&&e.push("#define "+n+" "+r);}return e.join("\n")}(u),w=s.createProgram();if(r.isRawShaderMaterial?((m=[b].filter(fi).join("\n")).length>0&&(m+="\n"),(g=[M,b].filter(fi).join("\n")).length>0&&(g+="\n")):(m=["precision "+a.precision+" float;","precision "+a.precision+" int;","#define SHADER_NAME "+i.name,b,a.supportsVertexTextures?"#define VERTEX_TEXTURES":"","#define GAMMA_FACTOR "+x,"#define MAX_BONES "+a.maxBones,a.useFog&&a.fog?"#define USE_FOG":"",a.useFog&&a.fogExp?"#define FOG_EXP2":"",a.map?"#define USE_MAP":"",a.envMap?"#define USE_ENVMAP":"",a.envMap?"#define "+d:"",a.lightMap?"#define USE_LIGHTMAP":"",a.aoMap?"#define USE_AOMAP":"",a.emissiveMap?"#define USE_EMISSIVEMAP":"",a.bumpMap?"#define USE_BUMPMAP":"",a.normalMap?"#define USE_NORMALMAP":"",a.normalMap&&a.objectSpaceNormalMap?"#define OBJECTSPACE_NORMALMAP":"",a.displacementMap&&a.supportsVertexTextures?"#define USE_DISPLACEMENTMAP":"",a.specularMap?"#define USE_SPECULARMAP":"",a.roughnessMap?"#define USE_ROUGHNESSMAP":"",a.metalnessMap?"#define USE_METALNESSMAP":"",a.alphaMap?"#define USE_ALPHAMAP":"",a.vertexColors?"#define USE_COLOR":"",a.flatShading?"#define FLAT_SHADED":"",a.skinning?"#define USE_SKINNING":"",a.useVertexTexture?"#define BONE_TEXTURE":"",a.morphTargets?"#define USE_MORPHTARGETS":"",a.morphNormals&&!1===a.flatShading?"#define USE_MORPHNORMALS":"",a.doubleSided?"#define DOUBLE_SIDED":"",a.flipSided?"#define FLIP_SIDED":"",a.shadowMapEnabled?"#define USE_SHADOWMAP":"",a.shadowMapEnabled?"#define "+h:"",a.sizeAttenuation?"#define USE_SIZEATTENUATION":"",a.logarithmicDepthBuffer?"#define USE_LOGDEPTHBUF":"",a.logarithmicDepthBuffer&&(o.isWebGL2||e.get("EXT_frag_depth"))?"#define USE_LOGDEPTHBUF_EXT":"","uniform mat4 modelMatrix;","uniform mat4 modelViewMatrix;","uniform mat4 projectionMatrix;","uniform mat4 viewMatrix;","uniform mat3 normalMatrix;","uniform vec3 cameraPosition;","attribute vec3 position;","attribute vec3 normal;","attribute vec2 uv;","#ifdef USE_COLOR","\tattribute vec3 color;","#endif","#ifdef USE_MORPHTARGETS","\tattribute vec3 morphTarget0;","\tattribute vec3 morphTarget1;","\tattribute vec3 morphTarget2;","\tattribute vec3 morphTarget3;","\t#ifdef USE_MORPHNORMALS","\t\tattribute vec3 morphNormal0;","\t\tattribute vec3 morphNormal1;","\t\tattribute vec3 morphNormal2;","\t\tattribute vec3 morphNormal3;","\t#else","\t\tattribute vec3 morphTarget4;","\t\tattribute vec3 morphTarget5;","\t\tattribute vec3 morphTarget6;","\t\tattribute vec3 morphTarget7;","\t#endif","#endif","#ifdef USE_SKINNING","\tattribute vec4 skinIndex;","\tattribute vec4 skinWeight;","#endif","\n"].filter(fi).join("\n"),g=[M,"precision "+a.precision+" float;","precision "+a.precision+" int;","#define SHADER_NAME "+i.name,b,a.alphaTest?"#define ALPHATEST "+a.alphaTest+(a.alphaTest%1?"":".0"):"","#define GAMMA_FACTOR "+x,a.useFog&&a.fog?"#define USE_FOG":"",a.useFog&&a.fogExp?"#define FOG_EXP2":"",a.map?"#define USE_MAP":"",a.matcap?"#define USE_MATCAP":"",a.envMap?"#define USE_ENVMAP":"",a.envMap?"#define "+f:"",a.envMap?"#define "+d:"",a.envMap?"#define "+p:"",a.lightMap?"#define USE_LIGHTMAP":"",a.aoMap?"#define USE_AOMAP":"",a.emissiveMap?"#define USE_EMISSIVEMAP":"",a.bumpMap?"#define USE_BUMPMAP":"",a.normalMap?"#define USE_NORMALMAP":"",a.normalMap&&a.objectSpaceNormalMap?"#define OBJECTSPACE_NORMALMAP":"",a.specularMap?"#define USE_SPECULARMAP":"",a.roughnessMap?"#define USE_ROUGHNESSMAP":"",a.metalnessMap?"#define USE_METALNESSMAP":"",a.alphaMap?"#define USE_ALPHAMAP":"",a.vertexColors?"#define USE_COLOR":"",a.gradientMap?"#define USE_GRADIENTMAP":"",a.flatShading?"#define FLAT_SHADED":"",a.doubleSided?"#define DOUBLE_SIDED":"",a.flipSided?"#define FLIP_SIDED":"",a.shadowMapEnabled?"#define USE_SHADOWMAP":"",a.shadowMapEnabled?"#define "+h:"",a.premultipliedAlpha?"#define PREMULTIPLIED_ALPHA":"",a.physicallyCorrectLights?"#define PHYSICALLY_CORRECT_LIGHTS":"",a.logarithmicDepthBuffer?"#define USE_LOGDEPTHBUF":"",a.logarithmicDepthBuffer&&(o.isWebGL2||e.get("EXT_frag_depth"))?"#define USE_LOGDEPTHBUF_EXT":"",a.envMap&&(o.isWebGL2||e.get("EXT_shader_texture_lod"))?"#define TEXTURE_LOD_EXT":"","uniform mat4 viewMatrix;","uniform vec3 cameraPosition;",a.toneMapping!==wt?"#define TONE_MAPPING":"",a.toneMapping!==wt?yn.tonemapping_pars_fragment:"",a.toneMapping!==wt?hi("toneMapping",a.toneMapping):"",a.dithering?"#define DITHERING":"",a.outputEncoding||a.mapEncoding||a.matcapEncoding||a.envMapEncoding||a.emissiveMapEncoding?yn.encodings_pars_fragment:"",a.mapEncoding?ci("mapTexelToLinear",a.mapEncoding):"",a.matcapEncoding?ci("matcapTexelToLinear",a.matcapEncoding):"",a.envMapEncoding?ci("envMapTexelToLinear",a.envMapEncoding):"",a.emissiveMapEncoding?ci("emissiveMapTexelToLinear",a.emissiveMapEncoding):"",a.outputEncoding?(v="linearToOutputTexel",y=a.outputEncoding,_=li(y),"vec4 "+v+"( vec4 value ) { return LinearTo"+_[0]+_[1]+"; }"):"",a.depthPacking?"#define DEPTH_PACKING "+r.depthPacking:"","\n"].filter(fi).join("\n")),l=pi(l=di(l=mi(l),a),a),c=pi(c=di(c=mi(c),a),a),l=gi(l),c=gi(c),o.isWebGL2&&!r.isRawShaderMaterial){var E=!1,S=/^\s*#version\s+300\s+es\s*\n/;r.isShaderMaterial&&null!==l.match(S)&&null!==c.match(S)&&(E=!0,l=l.replace(S,""),c=c.replace(S,"")),m=["#version 300 es\n","#define attribute in","#define varying out","#define texture2D texture"].join("\n")+"\n"+m,g=["#version 300 es\n","#define varying in",E?"":"out highp vec4 pc_fragColor;",E?"":"#define gl_FragColor pc_fragColor","#define gl_FragDepthEXT gl_FragDepth","#define texture2D texture","#define textureCube texture","#define texture2DProj textureProj","#define texture2DLodEXT textureLod","#define texture2DProjLodEXT textureProjLod","#define textureCubeLodEXT textureLod","#define texture2DGradEXT textureGrad","#define texture2DProjGradEXT textureProjGrad","#define textureCubeGradEXT textureGrad"].join("\n")+"\n"+g;}var T=m+l,A=g+c,L=si(s,s.VERTEX_SHADER,T),C=si(s,s.FRAGMENT_SHADER,A);s.attachShader(w,L),s.attachShader(w,C),void 0!==r.index0AttributeName?s.bindAttribLocation(w,0,r.index0AttributeName):!0===a.morphTargets&&s.bindAttribLocation(w,0,"position"),s.linkProgram(w);var P,R,F=s.getProgramInfoLog(w).trim(),D=s.getShaderInfoLog(L).trim(),I=s.getShaderInfoLog(C).trim(),N=!0,O=!0;return !1===s.getProgramParameter(w,s.LINK_STATUS)?(N=!1,console.error("THREE.WebGLProgram: shader error: ",s.getError(),"gl.VALIDATE_STATUS",s.getProgramParameter(w,s.VALIDATE_STATUS),"gl.getProgramInfoLog",F,D,I)):""!==F?console.warn("THREE.WebGLProgram: gl.getProgramInfoLog()",F):""!==D&&""!==I||(O=!1),O&&(this.diagnostics={runnable:N,material:r,programLog:F,vertexShader:{log:D,prefix:m},fragmentShader:{log:I,prefix:g}}),s.deleteShader(L),s.deleteShader(C),this.getUniforms=function(){return void 0===P&&(P=new oi(s,w,t)),P},this.getAttributes=function(){return void 0===R&&(R=function(t,e){for(var n={},r=t.getProgramParameter(e,t.ACTIVE_ATTRIBUTES),i=0;i<r;i++){var a=t.getActiveAttrib(e,i).name;n[a]=t.getAttribLocation(e,a);}return n}(s,w)),R},this.destroy=function(){s.deleteProgram(w),this.program=void 0;},Object.defineProperties(this,{uniforms:{get:function(){return console.warn("THREE.WebGLProgram: .uniforms is now .getUniforms()."),this.getUniforms()}},attributes:{get:function(){return console.warn("THREE.WebGLProgram: .attributes is now .getAttributes()."),this.getAttributes()}}}),this.name=i.name,this.id=ui++,this.code=n,this.usedTimes=1,this.program=w,this.vertexShader=L,this.fragmentShader=C,this}function yi(t,e,n){var r=[],i={MeshDepthMaterial:"depth",MeshDistanceMaterial:"distanceRGBA",MeshNormalMaterial:"normal",MeshBasicMaterial:"basic",MeshLambertMaterial:"lambert",MeshPhongMaterial:"phong",MeshToonMaterial:"phong",MeshStandardMaterial:"physical",MeshPhysicalMaterial:"physical",MeshMatcapMaterial:"matcap",LineBasicMaterial:"basic",LineDashedMaterial:"dashed",PointsMaterial:"points",ShadowMaterial:"shadow",SpriteMaterial:"sprite"},a=["precision","supportsVertexTextures","map","mapEncoding","matcap","matcapEncoding","envMap","envMapMode","envMapEncoding","lightMap","aoMap","emissiveMap","emissiveMapEncoding","bumpMap","normalMap","objectSpaceNormalMap","displacementMap","specularMap","roughnessMap","metalnessMap","gradientMap","alphaMap","combine","vertexColors","fog","useFog","fogExp","flatShading","sizeAttenuation","logarithmicDepthBuffer","skinning","maxBones","useVertexTexture","morphTargets","morphNormals","maxMorphTargets","maxMorphNormals","premultipliedAlpha","numDirLights","numPointLights","numSpotLights","numHemiLights","numRectAreaLights","shadowMapEnabled","shadowMapType","toneMapping","physicallyCorrectLights","alphaTest","doubleSided","flipSided","numClippingPlanes","numClipIntersection","depthPacking","dithering"];function o(t,e){var n;return t?t.isTexture?n=t.encoding:t.isWebGLRenderTarget&&(console.warn("THREE.WebGLPrograms.getTextureEncodingFromMap: don't use render targets as textures. Use their .texture property instead."),n=t.texture.encoding):n=Be,n===Be&&e&&(n=Ge),n}this.getParameters=function(e,r,a,s,u,l,c){var h=i[e.type],f=c.isSkinnedMesh?function(t){var e=t.skeleton.bones;if(n.floatVertexTextures)return 1024;var r=n.maxVertexUniforms,i=Math.floor((r-20)/4),a=Math.min(i,e.length);return a<e.length?(console.warn("THREE.WebGLRenderer: Skeleton has "+e.length+" bones. This GPU supports "+a+"."),0):a}(c):0,d=n.precision;null!==e.precision&&(d=n.getMaxPrecision(e.precision))!==e.precision&&console.warn("THREE.WebGLProgram.getParameters:",e.precision,"not supported, using",d,"instead.");var p=t.getRenderTarget();return {shaderID:h,precision:d,supportsVertexTextures:n.vertexTextures,outputEncoding:o(p?p.texture:null,t.gammaOutput),map:!!e.map,mapEncoding:o(e.map,t.gammaInput),matcap:!!e.matcap,matcapEncoding:o(e.matcap,t.gammaInput),envMap:!!e.envMap,envMapMode:e.envMap&&e.envMap.mapping,envMapEncoding:o(e.envMap,t.gammaInput),envMapCubeUV:!!e.envMap&&(e.envMap.mapping===It||e.envMap.mapping===Nt),lightMap:!!e.lightMap,aoMap:!!e.aoMap,emissiveMap:!!e.emissiveMap,emissiveMapEncoding:o(e.emissiveMap,t.gammaInput),bumpMap:!!e.bumpMap,normalMap:!!e.normalMap,objectSpaceNormalMap:e.normalMapType===qe,displacementMap:!!e.displacementMap,roughnessMap:!!e.roughnessMap,metalnessMap:!!e.metalnessMap,specularMap:!!e.specularMap,alphaMap:!!e.alphaMap,gradientMap:!!e.gradientMap,combine:e.combine,vertexColors:e.vertexColors,fog:!!s,useFog:e.fog,fogExp:s&&s.isFogExp2,flatShading:e.flatShading,sizeAttenuation:e.sizeAttenuation,logarithmicDepthBuffer:n.logarithmicDepthBuffer,skinning:e.skinning&&f>0,maxBones:f,useVertexTexture:n.floatVertexTextures,morphTargets:e.morphTargets,morphNormals:e.morphNormals,maxMorphTargets:t.maxMorphTargets,maxMorphNormals:t.maxMorphNormals,numDirLights:r.directional.length,numPointLights:r.point.length,numSpotLights:r.spot.length,numRectAreaLights:r.rectArea.length,numHemiLights:r.hemi.length,numClippingPlanes:u,numClipIntersection:l,dithering:e.dithering,shadowMapEnabled:t.shadowMap.enabled&&c.receiveShadow&&a.length>0,shadowMapType:t.shadowMap.type,toneMapping:t.toneMapping,physicallyCorrectLights:t.physicallyCorrectLights,premultipliedAlpha:e.premultipliedAlpha,alphaTest:e.alphaTest,doubleSided:e.side===V,flipSided:e.side===k,depthPacking:void 0!==e.depthPacking&&e.depthPacking}},this.getProgramCode=function(e,n){var r=[];if(n.shaderID?r.push(n.shaderID):(r.push(e.fragmentShader),r.push(e.vertexShader)),void 0!==e.defines)for(var i in e.defines)r.push(i),r.push(e.defines[i]);for(var o=0;o<a.length;o++)r.push(n[a[o]]);return r.push(e.onBeforeCompile.toString()),r.push(t.gammaOutput),r.push(t.gammaFactor),r.join()},this.acquireProgram=function(i,a,o,s){for(var u,l=0,c=r.length;l<c;l++){var h=r[l];if(h.code===s){++(u=h).usedTimes;break}}return void 0===u&&(u=new vi(t,e,s,i,a,o,n),r.push(u)),u},this.releaseProgram=function(t){if(0==--t.usedTimes){var e=r.indexOf(t);r[e]=r[r.length-1],r.pop(),t.destroy();}},this.programs=r;}function _i(){var t=new WeakMap;return {get:function(e){var n=t.get(e);return void 0===n&&(n={},t.set(e,n)),n},remove:function(e){t.delete(e);},update:function(e,n,r){t.get(e)[n]=r;},dispose:function(){t=new WeakMap;}}}function xi(t,e){return t.groupOrder!==e.groupOrder?t.groupOrder-e.groupOrder:t.renderOrder!==e.renderOrder?t.renderOrder-e.renderOrder:t.program&&e.program&&t.program!==e.program?t.program.id-e.program.id:t.material.id!==e.material.id?t.material.id-e.material.id:t.z!==e.z?t.z-e.z:t.id-e.id}function Mi(t,e){return t.groupOrder!==e.groupOrder?t.groupOrder-e.groupOrder:t.renderOrder!==e.renderOrder?t.renderOrder-e.renderOrder:t.z!==e.z?e.z-t.z:t.id-e.id}function bi(){var t=[],e=0,n=[],r=[];function i(n,r,i,a,o,s){var u=t[e];return void 0===u?(u={id:n.id,object:n,geometry:r,material:i,program:i.program,groupOrder:a,renderOrder:n.renderOrder,z:o,group:s},t[e]=u):(u.id=n.id,u.object=n,u.geometry=r,u.material=i,u.program=i.program,u.groupOrder=a,u.renderOrder=n.renderOrder,u.z=o,u.group=s),e++,u}return {opaque:n,transparent:r,init:function(){e=0,n.length=0,r.length=0;},push:function(t,e,a,o,s,u){var l=i(t,e,a,o,s,u);(!0===a.transparent?r:n).push(l);},unshift:function(t,e,a,o,s,u){var l=i(t,e,a,o,s,u);(!0===a.transparent?r:n).unshift(l);},sort:function(){n.length>1&&n.sort(xi),r.length>1&&r.sort(Mi);}}}function wi(){var t={};function e(n){var r=n.target;r.removeEventListener("dispose",e),delete t[r.id];}return {get:function(n,r){var i,a=t[n.id];return void 0===a?(i=new bi,t[n.id]={},t[n.id][r.id]=i,n.addEventListener("dispose",e)):void 0===(i=a[r.id])&&(i=new bi,a[r.id]=i),i},dispose:function(){t={};}}}function Ei(){var t={};return {get:function(e){if(void 0!==t[e.id])return t[e.id];var n;switch(e.type){case"DirectionalLight":n={direction:new g,color:new b,shadow:!1,shadowBias:0,shadowRadius:1,shadowMapSize:new v};break;case"SpotLight":n={position:new g,direction:new g,color:new b,distance:0,coneCos:0,penumbraCos:0,decay:0,shadow:!1,shadowBias:0,shadowRadius:1,shadowMapSize:new v};break;case"PointLight":n={position:new g,color:new b,distance:0,decay:0,shadow:!1,shadowBias:0,shadowRadius:1,shadowMapSize:new v,shadowCameraNear:1,shadowCameraFar:1e3};break;case"HemisphereLight":n={direction:new g,skyColor:new b,groundColor:new b};break;case"RectAreaLight":n={color:new b,position:new g,halfWidth:new g,halfHeight:new g};}return t[e.id]=n,n}}}var Si=0;function Ti(){var t=new Ei,e={id:Si++,hash:{stateID:-1,directionalLength:-1,pointLength:-1,spotLength:-1,rectAreaLength:-1,hemiLength:-1,shadowsLength:-1},ambient:[0,0,0],directional:[],directionalShadowMap:[],directionalShadowMatrix:[],spot:[],spotShadowMap:[],spotShadowMatrix:[],rectArea:[],point:[],pointShadowMap:[],pointShadowMatrix:[],hemi:[]},n=new g,r=new p,i=new p;return {setup:function(a,o,s){for(var u=0,l=0,c=0,h=0,f=0,d=0,p=0,m=0,g=s.matrixWorldInverse,v=0,y=a.length;v<y;v++){var _=a[v],x=_.color,M=_.intensity,b=_.distance,w=_.shadow&&_.shadow.map?_.shadow.map.texture:null;if(_.isAmbientLight)u+=x.r*M,l+=x.g*M,c+=x.b*M;else if(_.isDirectionalLight){if((S=t.get(_)).color.copy(_.color).multiplyScalar(_.intensity),S.direction.setFromMatrixPosition(_.matrixWorld),n.setFromMatrixPosition(_.target.matrixWorld),S.direction.sub(n),S.direction.transformDirection(g),S.shadow=_.castShadow,_.castShadow){var E=_.shadow;S.shadowBias=E.bias,S.shadowRadius=E.radius,S.shadowMapSize=E.mapSize;}e.directionalShadowMap[h]=w,e.directionalShadowMatrix[h]=_.shadow.matrix,e.directional[h]=S,h++;}else if(_.isSpotLight)(S=t.get(_)).position.setFromMatrixPosition(_.matrixWorld),S.position.applyMatrix4(g),S.color.copy(x).multiplyScalar(M),S.distance=b,S.direction.setFromMatrixPosition(_.matrixWorld),n.setFromMatrixPosition(_.target.matrixWorld),S.direction.sub(n),S.direction.transformDirection(g),S.coneCos=Math.cos(_.angle),S.penumbraCos=Math.cos(_.angle*(1-_.penumbra)),S.decay=_.decay,S.shadow=_.castShadow,_.castShadow&&(E=_.shadow,S.shadowBias=E.bias,S.shadowRadius=E.radius,S.shadowMapSize=E.mapSize),e.spotShadowMap[d]=w,e.spotShadowMatrix[d]=_.shadow.matrix,e.spot[d]=S,d++;else if(_.isRectAreaLight)(S=t.get(_)).color.copy(x).multiplyScalar(M),S.position.setFromMatrixPosition(_.matrixWorld),S.position.applyMatrix4(g),i.identity(),r.copy(_.matrixWorld),r.premultiply(g),i.extractRotation(r),S.halfWidth.set(.5*_.width,0,0),S.halfHeight.set(0,.5*_.height,0),S.halfWidth.applyMatrix4(i),S.halfHeight.applyMatrix4(i),e.rectArea[p]=S,p++;else if(_.isPointLight)(S=t.get(_)).position.setFromMatrixPosition(_.matrixWorld),S.position.applyMatrix4(g),S.color.copy(_.color).multiplyScalar(_.intensity),S.distance=_.distance,S.decay=_.decay,S.shadow=_.castShadow,_.castShadow&&(E=_.shadow,S.shadowBias=E.bias,S.shadowRadius=E.radius,S.shadowMapSize=E.mapSize,S.shadowCameraNear=E.camera.near,S.shadowCameraFar=E.camera.far),e.pointShadowMap[f]=w,e.pointShadowMatrix[f]=_.shadow.matrix,e.point[f]=S,f++;else if(_.isHemisphereLight){var S;(S=t.get(_)).direction.setFromMatrixPosition(_.matrixWorld),S.direction.transformDirection(g),S.direction.normalize(),S.skyColor.copy(_.color).multiplyScalar(M),S.groundColor.copy(_.groundColor).multiplyScalar(M),e.hemi[m]=S,m++;}}e.ambient[0]=u,e.ambient[1]=l,e.ambient[2]=c,e.directional.length=h,e.spot.length=d,e.rectArea.length=p,e.point.length=f,e.hemi.length=m,e.hash.stateID=e.id,e.hash.directionalLength=h,e.hash.pointLength=f,e.hash.spotLength=d,e.hash.rectAreaLength=p,e.hash.hemiLength=m,e.hash.shadowsLength=o.length;},state:e}}function Ai(){var t=new Ti,e=[],n=[];return {init:function(){e.length=0,n.length=0;},state:{lightsArray:e,shadowsArray:n,lights:t},setupLights:function(r){t.setup(e,n,r);},pushLight:function(t){e.push(t);},pushShadow:function(t){n.push(t);}}}function Li(){var t={};function e(n){var r=n.target;r.removeEventListener("dispose",e),delete t[r.id];}return {get:function(n,r){var i;return void 0===t[n.id]?(i=new Ai,t[n.id]={},t[n.id][r.id]=i,n.addEventListener("dispose",e)):void 0===t[n.id][r.id]?(i=new Ai,t[n.id][r.id]=i):i=t[n.id][r.id],i},dispose:function(){t={};}}}function Ci(t,e,n){this.width=t,this.height=e,this.scissor=new i(0,0,t,e),this.scissorTest=!1,this.viewport=new i(0,0,t,e),n=n||{},this.texture=new fn(void 0,void 0,n.wrapS,n.wrapT,n.magFilter,n.minFilter,n.format,n.type,n.anisotropy,n.encoding),this.texture.generateMipmaps=void 0!==n.generateMipmaps&&n.generateMipmaps,this.texture.minFilter=void 0!==n.minFilter?n.minFilter:Vt,this.depthBuffer=void 0===n.depthBuffer||n.depthBuffer,this.stencilBuffer=void 0===n.stencilBuffer||n.stencilBuffer,this.depthTexture=void 0!==n.depthTexture?n.depthTexture:null;}function Pi(t){Kn.call(this),this.type="MeshDepthMaterial",this.depthPacking=We,this.skinning=!1,this.morphTargets=!1,this.map=null,this.alphaMap=null,this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.wireframe=!1,this.wireframeLinewidth=1,this.fog=!1,this.lights=!1,this.setValues(t);}function Ri(t){Kn.call(this),this.type="MeshDistanceMaterial",this.referencePosition=new g,this.nearDistance=1,this.farDistance=1e3,this.skinning=!1,this.morphTargets=!1,this.map=null,this.alphaMap=null,this.displacementMap=null,this.displacementScale=1,this.displacementBias=0,this.fog=!1,this.lights=!1,this.setValues(t);}function Fi(t,e,n){for(var r=new vn,a=new p,o=new v,s=new v(n,n),u=new g,l=new g,c=1,h=2,f=1+(c|h),d=new Array(f),m=new Array(f),y={},_={0:k,1:G,2:V},x=[new g(1,0,0),new g(-1,0,0),new g(0,0,1),new g(0,0,-1),new g(0,1,0),new g(0,-1,0)],M=[new g(0,1,0),new g(0,1,0),new g(0,1,0),new g(0,1,0),new g(0,0,1),new g(0,0,-1)],b=[new i,new i,new i,new i,new i,new i],w=0;w!==f;++w){var E=0!=(w&c),S=0!=(w&h),T=new Pi({depthPacking:Xe,morphTargets:E,skinning:S});d[w]=T;var A=new Ri({morphTargets:E,skinning:S});m[w]=A;}var L=this;function C(e,n,r,i,a,o){var s=e.geometry,u=null,l=d,f=e.customDepthMaterial;if(r&&(l=m,f=e.customDistanceMaterial),f)u=f;else{var p=!1;n.morphTargets&&(s&&s.isBufferGeometry?p=s.morphAttributes&&s.morphAttributes.position&&s.morphAttributes.position.length>0:s&&s.isGeometry&&(p=s.morphTargets&&s.morphTargets.length>0)),e.isSkinnedMesh&&!1===n.skinning&&console.warn("THREE.WebGLShadowMap: THREE.SkinnedMesh with material.skinning set to false:",e);var g=e.isSkinnedMesh&&n.skinning,v=0;p&&(v|=c),g&&(v|=h),u=l[v];}if(t.localClippingEnabled&&!0===n.clipShadows&&0!==n.clippingPlanes.length){var x=u.uuid,M=n.uuid,b=y[x];void 0===b&&(b={},y[x]=b);var w=b[M];void 0===w&&(w=u.clone(),b[M]=w),u=w;}return u.visible=n.visible,u.wireframe=n.wireframe,u.side=null!=n.shadowSide?n.shadowSide:_[n.side],u.clipShadows=n.clipShadows,u.clippingPlanes=n.clippingPlanes,u.clipIntersection=n.clipIntersection,u.wireframeLinewidth=n.wireframeLinewidth,u.linewidth=n.linewidth,r&&u.isMeshDistanceMaterial&&(u.referencePosition.copy(i),u.nearDistance=a,u.farDistance=o),u}function P(n,i,a,o){if(!1!==n.visible){if(n.layers.test(i.layers)&&(n.isMesh||n.isLine||n.isPoints)&&n.castShadow&&(!n.frustumCulled||r.intersectsObject(n))){n.modelViewMatrix.multiplyMatrices(a.matrixWorldInverse,n.matrixWorld);var s=e.update(n),u=n.material;if(Array.isArray(u))for(var c=s.groups,h=0,f=c.length;h<f;h++){var d=c[h],p=u[d.materialIndex];if(p&&p.visible){var m=C(n,p,o,l,a.near,a.far);t.renderBufferDirect(a,null,s,m,n,d);}}else if(u.visible){m=C(n,u,o,l,a.near,a.far);t.renderBufferDirect(a,null,s,m,n,null);}}for(var g=n.children,v=0,y=g.length;v<y;v++)P(g[v],i,a,o);}}this.enabled=!1,this.autoUpdate=!0,this.needsUpdate=!1,this.type=B,this.render=function(e,n,i){if(!1!==L.enabled&&(!1!==L.autoUpdate||!1!==L.needsUpdate)&&0!==e.length){var c,h=t.state;h.setBlending(j),h.buffers.color.setClear(1,1,1,1),h.buffers.depth.setTest(!0),h.setScissorTest(!1);for(var f=0,d=e.length;f<d;f++){var p=e[f],m=p.shadow,g=p&&p.isPointLight;if(void 0!==m){var v=m.camera;if(o.copy(m.mapSize),o.min(s),g){var y=o.x,_=o.y;b[0].set(2*y,_,y,_),b[1].set(0,_,y,_),b[2].set(3*y,_,y,_),b[3].set(y,_,y,_),b[4].set(3*y,0,y,_),b[5].set(y,0,y,_),o.x*=4,o.y*=2;}if(null===m.map){var w={minFilter:zt,magFilter:zt,format:ae};m.map=new Ci(o.x,o.y,w),m.map.texture.name=p.name+".shadowMap",v.updateProjectionMatrix();}m.isSpotLightShadow&&m.update(p);var E=m.map,S=m.matrix;l.setFromMatrixPosition(p.matrixWorld),v.position.copy(l),g?(c=6,S.makeTranslation(-l.x,-l.y,-l.z)):(c=1,u.setFromMatrixPosition(p.target.matrixWorld),v.lookAt(u),v.updateMatrixWorld(),S.set(.5,0,0,.5,0,.5,0,.5,0,0,.5,.5,0,0,0,1),S.multiply(v.projectionMatrix),S.multiply(v.matrixWorldInverse)),t.setRenderTarget(E),t.clear();for(var T=0;T<c;T++){if(g){u.copy(v.position),u.add(x[T]),v.up.copy(M[T]),v.lookAt(u),v.updateMatrixWorld();var A=b[T];h.viewport(A);}a.multiplyMatrices(v.projectionMatrix,v.matrixWorldInverse),r.setFromMatrix(a),P(n,i,v,g);}}else console.warn("THREE.WebGLShadowMap:",p,"has no shadow.");}L.needsUpdate=!1;}};}function Di(t,e,n,r){var a=new function(){var e=!1,n=new i,r=null,a=new i(0,0,0,0);return {setMask:function(n){r===n||e||(t.colorMask(n,n,n,n),r=n);},setLocked:function(t){e=t;},setClear:function(e,r,i,o,s){!0===s&&(e*=o,r*=o,i*=o),n.set(e,r,i,o),!1===a.equals(n)&&(t.clearColor(e,r,i,o),a.copy(n));},reset:function(){e=!1,r=null,a.set(-1,0,0,0);}}},o=new function(){var e=!1,n=null,r=null,i=null;return {setTest:function(e){e?K(t.DEPTH_TEST):$(t.DEPTH_TEST);},setMask:function(r){n===r||e||(t.depthMask(r),n=r);},setFunc:function(e){if(r!==e){if(e)switch(e){case ft:t.depthFunc(t.NEVER);break;case dt:t.depthFunc(t.ALWAYS);break;case pt:t.depthFunc(t.LESS);break;case mt:t.depthFunc(t.LEQUAL);break;case gt:t.depthFunc(t.EQUAL);break;case vt:t.depthFunc(t.GEQUAL);break;case yt:t.depthFunc(t.GREATER);break;case _t:t.depthFunc(t.NOTEQUAL);break;default:t.depthFunc(t.LEQUAL);}else t.depthFunc(t.LEQUAL);r=e;}},setLocked:function(t){e=t;},setClear:function(e){i!==e&&(t.clearDepth(e),i=e);},reset:function(){e=!1,n=null,r=null,i=null;}}},s=new function(){var e=!1,n=null,r=null,i=null,a=null,o=null,s=null,u=null,l=null;return {setTest:function(e){e?K(t.STENCIL_TEST):$(t.STENCIL_TEST);},setMask:function(r){n===r||e||(t.stencilMask(r),n=r);},setFunc:function(e,n,o){r===e&&i===n&&a===o||(t.stencilFunc(e,n,o),r=e,i=n,a=o);},setOp:function(e,n,r){o===e&&s===n&&u===r||(t.stencilOp(e,n,r),o=e,s=n,u=r);},setLocked:function(t){e=t;},setClear:function(e){l!==e&&(t.clearStencil(e),l=e);},reset:function(){e=!1,n=null,r=null,i=null,a=null,o=null,s=null,u=null,l=null;}}},u=t.getParameter(t.MAX_VERTEX_ATTRIBS),l=new Uint8Array(u),c=new Uint8Array(u),h=new Uint8Array(u),f={},d=null,p=null,m=null,g=null,v=null,y=null,_=null,x=null,M=null,b=null,w=!1,E=null,S=null,T=null,A=null,L=null,C=t.getParameter(t.MAX_COMBINED_TEXTURE_IMAGE_UNITS),P=!1,R=0,F=t.getParameter(t.VERSION);-1!==F.indexOf("WebGL")?(R=parseFloat(/^WebGL\ ([0-9])/.exec(F)[1]),P=R>=1):-1!==F.indexOf("OpenGL ES")&&(R=parseFloat(/^OpenGL\ ES\ ([0-9])/.exec(F)[1]),P=R>=2);var D=null,I={},B=new i,z=new i;function G(e,n,r){var i=new Uint8Array(4),a=t.createTexture();t.bindTexture(e,a),t.texParameteri(e,t.TEXTURE_MIN_FILTER,t.NEAREST),t.texParameteri(e,t.TEXTURE_MAG_FILTER,t.NEAREST);for(var o=0;o<r;o++)t.texImage2D(n+o,0,t.RGBA,1,1,0,t.RGBA,t.UNSIGNED_BYTE,i);return a}var H={};function Q(n,i){(l[n]=1,0===c[n]&&(t.enableVertexAttribArray(n),c[n]=1),h[n]!==i)&&((r.isWebGL2?t:e.get("ANGLE_instanced_arrays"))[r.isWebGL2?"vertexAttribDivisor":"vertexAttribDivisorANGLE"](n,i),h[n]=i);}function K(e){!0!==f[e]&&(t.enable(e),f[e]=!0);}function $(e){!1!==f[e]&&(t.disable(e),f[e]=!1);}function tt(e,r,i,a,o,s,u,l){if(e!==j){if(m||(K(t.BLEND),m=!0),e===Z)o=o||r,s=s||i,u=u||a,r===v&&o===x||(t.blendEquationSeparate(n.convert(r),n.convert(o)),v=r,x=o),i===y&&a===_&&s===M&&u===b||(t.blendFuncSeparate(n.convert(i),n.convert(a),n.convert(s),n.convert(u)),y=i,_=a,M=s,b=u),g=e,w=null;else if(e!==g||l!==w){if(v===J&&x===J||(t.blendEquation(t.FUNC_ADD),v=J,x=J),l)switch(e){case W:t.blendFuncSeparate(t.ONE,t.ONE_MINUS_SRC_ALPHA,t.ONE,t.ONE_MINUS_SRC_ALPHA);break;case X:t.blendFunc(t.ONE,t.ONE);break;case q:t.blendFuncSeparate(t.ZERO,t.ZERO,t.ONE_MINUS_SRC_COLOR,t.ONE_MINUS_SRC_ALPHA);break;case Y:t.blendFuncSeparate(t.ZERO,t.SRC_COLOR,t.ZERO,t.SRC_ALPHA);break;default:console.error("THREE.WebGLState: Invalid blending: ",e);}else switch(e){case W:t.blendFuncSeparate(t.SRC_ALPHA,t.ONE_MINUS_SRC_ALPHA,t.ONE,t.ONE_MINUS_SRC_ALPHA);break;case X:t.blendFunc(t.SRC_ALPHA,t.ONE);break;case q:t.blendFunc(t.ZERO,t.ONE_MINUS_SRC_COLOR);break;case Y:t.blendFunc(t.ZERO,t.SRC_COLOR);break;default:console.error("THREE.WebGLState: Invalid blending: ",e);}y=null,_=null,M=null,b=null,g=e,w=l;}}else m&&($(t.BLEND),m=!1);}function et(e){E!==e&&(e?t.frontFace(t.CW):t.frontFace(t.CCW),E=e);}function nt(e){e!==N?(K(t.CULL_FACE),e!==S&&(e===O?t.cullFace(t.BACK):e===U?t.cullFace(t.FRONT):t.cullFace(t.FRONT_AND_BACK))):$(t.CULL_FACE),S=e;}function rt(e,n,r){e?(K(t.POLYGON_OFFSET_FILL),A===n&&L===r||(t.polygonOffset(n,r),A=n,L=r)):$(t.POLYGON_OFFSET_FILL);}function it(e){void 0===e&&(e=t.TEXTURE0+C-1),D!==e&&(t.activeTexture(e),D=e);}return H[t.TEXTURE_2D]=G(t.TEXTURE_2D,t.TEXTURE_2D,1),H[t.TEXTURE_CUBE_MAP]=G(t.TEXTURE_CUBE_MAP,t.TEXTURE_CUBE_MAP_POSITIVE_X,6),a.setClear(0,0,0,1),o.setClear(1),s.setClear(0),K(t.DEPTH_TEST),o.setFunc(mt),et(!1),nt(O),K(t.CULL_FACE),tt(j),{buffers:{color:a,depth:o,stencil:s},initAttributes:function(){for(var t=0,e=l.length;t<e;t++)l[t]=0;},enableAttribute:function(t){Q(t,0);},enableAttributeAndDivisor:Q,disableUnusedAttributes:function(){for(var e=0,n=c.length;e!==n;++e)c[e]!==l[e]&&(t.disableVertexAttribArray(e),c[e]=0);},enable:K,disable:$,getCompressedTextureFormats:function(){if(null===d&&(d=[],e.get("WEBGL_compressed_texture_pvrtc")||e.get("WEBGL_compressed_texture_s3tc")||e.get("WEBGL_compressed_texture_etc1")||e.get("WEBGL_compressed_texture_astc")))for(var n=t.getParameter(t.COMPRESSED_TEXTURE_FORMATS),r=0;r<n.length;r++)d.push(n[r]);return d},useProgram:function(e){return p!==e&&(t.useProgram(e),p=e,!0)},setBlending:tt,setMaterial:function(e,n){e.side===V?$(t.CULL_FACE):K(t.CULL_FACE);var r=e.side===k;n&&(r=!r),et(r),e.blending===W&&!1===e.transparent?tt(j):tt(e.blending,e.blendEquation,e.blendSrc,e.blendDst,e.blendEquationAlpha,e.blendSrcAlpha,e.blendDstAlpha,e.premultipliedAlpha),o.setFunc(e.depthFunc),o.setTest(e.depthTest),o.setMask(e.depthWrite),a.setMask(e.colorWrite),rt(e.polygonOffset,e.polygonOffsetFactor,e.polygonOffsetUnits);},setFlipSided:et,setCullFace:nt,setLineWidth:function(e){e!==T&&(P&&t.lineWidth(e),T=e);},setPolygonOffset:rt,setScissorTest:function(e){e?K(t.SCISSOR_TEST):$(t.SCISSOR_TEST);},activeTexture:it,bindTexture:function(e,n){null===D&&it();var r=I[D];void 0===r&&(r={type:void 0,texture:void 0},I[D]=r),r.type===e&&r.texture===n||(t.bindTexture(e,n||H[e]),r.type=e,r.texture=n);},compressedTexImage2D:function(){try{t.compressedTexImage2D.apply(t,arguments);}catch(t){console.error("THREE.WebGLState:",t);}},texImage2D:function(){try{t.texImage2D.apply(t,arguments);}catch(t){console.error("THREE.WebGLState:",t);}},texImage3D:function(){try{t.texImage3D.apply(t,arguments);}catch(t){console.error("THREE.WebGLState:",t);}},scissor:function(e){!1===B.equals(e)&&(t.scissor(e.x,e.y,e.z,e.w),B.copy(e));},viewport:function(e){!1===z.equals(e)&&(t.viewport(e.x,e.y,e.z,e.w),z.copy(e));},reset:function(){for(var e=0;e<c.length;e++)1===c[e]&&(t.disableVertexAttribArray(e),c[e]=0);f={},d=null,D=null,I={},p=null,g=null,E=null,S=null,a.reset(),o.reset(),s.reset();}}}function Ii(t,e,n,r,i,a,o){var s,u={};function l(t,e,n,r){var i=1;if((t.width>r||t.height>r)&&(i=r/Math.max(t.width,t.height)),i<1||!0===e){if(t instanceof HTMLImageElement||t instanceof HTMLCanvasElement||t instanceof ImageBitmap){void 0===s&&(s=document.createElementNS("http://www.w3.org/1999/xhtml","canvas"));var a=n?document.createElementNS("http://www.w3.org/1999/xhtml","canvas"):s,o=e?d.floorPowerOfTwo:Math.floor;return a.width=o(i*t.width),a.height=o(i*t.height),a.getContext("2d").drawImage(t,0,0,a.width,a.height),console.warn("THREE.WebGLRenderer: Texture has been resized from ("+t.width+"x"+t.height+") to ("+a.width+"x"+a.height+")."),a}return "data"in t&&console.warn("THREE.WebGLRenderer: Image in DataTexture is too big ("+t.width+"x"+t.height+")."),t}return t}function c(t){return d.isPowerOfTwo(t.width)&&d.isPowerOfTwo(t.height)}function h(t,e){return t.generateMipmaps&&e&&t.minFilter!==zt&&t.minFilter!==Vt}function f(e,n,i,a){t.generateMipmap(e),r.get(n).__maxMipLevel=Math.log(Math.max(i,a))*Math.LOG2E;}function p(n,r){if(!i.isWebGL2)return n;var a=n;return n===t.RED&&(r===t.FLOAT&&(a=t.R32F),r===t.HALF_FLOAT&&(a=t.R16F),r===t.UNSIGNED_BYTE&&(a=t.R8)),n===t.RGB&&(r===t.FLOAT&&(a=t.RGB32F),r===t.HALF_FLOAT&&(a=t.RGB16F),r===t.UNSIGNED_BYTE&&(a=t.RGB8)),n===t.RGBA&&(r===t.FLOAT&&(a=t.RGBA32F),r===t.HALF_FLOAT&&(a=t.RGBA16F),r===t.UNSIGNED_BYTE&&(a=t.RGBA8)),a===t.R16F||a===t.R32F||a===t.RGBA16F||a===t.RGBA32F?e.get("EXT_color_buffer_float"):a!==t.RGB16F&&a!==t.RGB32F||console.warn("THREE.WebGLRenderer: Floating point textures with RGB format not supported. Please use RGBA instead."),a}function m(e){return e===zt||e===Gt||e===kt?t.NEAREST:t.LINEAR}function g(e){var n=e.target;n.removeEventListener("dispose",g),function(e){var n=r.get(e);if(e.image&&n.__image__webglTextureCube)t.deleteTexture(n.__image__webglTextureCube);else{if(void 0===n.__webglInit)return;t.deleteTexture(n.__webglTexture);}r.remove(e);}(n),n.isVideoTexture&&delete u[n.id],o.memory.textures--;}function v(e){var n=e.target;n.removeEventListener("dispose",v),function(e){var n=r.get(e),i=r.get(e.texture);if(!e)return;void 0!==i.__webglTexture&&t.deleteTexture(i.__webglTexture);e.depthTexture&&e.depthTexture.dispose();if(e.isWebGLRenderTargetCube)for(var a=0;a<6;a++)t.deleteFramebuffer(n.__webglFramebuffer[a]),n.__webglDepthbuffer&&t.deleteRenderbuffer(n.__webglDepthbuffer[a]);else t.deleteFramebuffer(n.__webglFramebuffer),n.__webglDepthbuffer&&t.deleteRenderbuffer(n.__webglDepthbuffer);r.remove(e.texture),r.remove(e);}(n),o.memory.textures--;}function y(e,i){var a=r.get(e);if(e.isVideoTexture&&function(t){var e=t.id,n=o.render.frame;u[e]!==n&&(u[e]=n,t.update());}(e),e.version>0&&a.__version!==e.version){var s=e.image;if(void 0===s)console.warn("THREE.WebGLRenderer: Texture marked for update but image is undefined");else{if(!1!==s.complete)return void x(a,e,i);console.warn("THREE.WebGLRenderer: Texture marked for update but image is incomplete");}}n.activeTexture(t.TEXTURE0+i),n.bindTexture(t.TEXTURE_2D,a.__webglTexture);}function _(n,o,s){var u;if(s?(t.texParameteri(n,t.TEXTURE_WRAP_S,a.convert(o.wrapS)),t.texParameteri(n,t.TEXTURE_WRAP_T,a.convert(o.wrapT)),t.texParameteri(n,t.TEXTURE_MAG_FILTER,a.convert(o.magFilter)),t.texParameteri(n,t.TEXTURE_MIN_FILTER,a.convert(o.minFilter))):(t.texParameteri(n,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE),t.texParameteri(n,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE),o.wrapS===Ut&&o.wrapT===Ut||console.warn("THREE.WebGLRenderer: Texture is not power of two. Texture.wrapS and Texture.wrapT should be set to THREE.ClampToEdgeWrapping."),t.texParameteri(n,t.TEXTURE_MAG_FILTER,m(o.magFilter)),t.texParameteri(n,t.TEXTURE_MIN_FILTER,m(o.minFilter)),o.minFilter!==zt&&o.minFilter!==Vt&&console.warn("THREE.WebGLRenderer: Texture is not power of two. Texture.minFilter should be set to THREE.NearestFilter or THREE.LinearFilter.")),u=e.get("EXT_texture_filter_anisotropic")){if(o.type===Qt&&null===e.get("OES_texture_float_linear"))return;if(o.type===Kt&&null===(i.isWebGL2||e.get("OES_texture_half_float_linear")))return;(o.anisotropy>1||r.get(o).__currentAnisotropy)&&(t.texParameterf(n,u.TEXTURE_MAX_ANISOTROPY_EXT,Math.min(o.anisotropy,i.getMaxAnisotropy())),r.get(o).__currentAnisotropy=o.anisotropy);}}function x(e,r,s){var u;u=r.isDataTexture3D?t.TEXTURE_3D:t.TEXTURE_2D,void 0===e.__webglInit&&(e.__webglInit=!0,r.addEventListener("dispose",g),e.__webglTexture=t.createTexture(),o.memory.textures++),n.activeTexture(t.TEXTURE0+s),n.bindTexture(u,e.__webglTexture),t.pixelStorei(t.UNPACK_FLIP_Y_WEBGL,r.flipY),t.pixelStorei(t.UNPACK_PREMULTIPLY_ALPHA_WEBGL,r.premultiplyAlpha),t.pixelStorei(t.UNPACK_ALIGNMENT,r.unpackAlignment);var d=function(t){return !i.isWebGL2&&(t.wrapS!==Ut||t.wrapT!==Ut||t.minFilter!==zt&&t.minFilter!==Vt)}(r)&&!1===c(r.image),m=l(r.image,d,!1,i.maxTextureSize),v=c(m)||i.isWebGL2,y=a.convert(r.format),x=a.convert(r.type),M=p(y,x);_(u,r,v);var b,w=r.mipmaps;if(r.isDepthTexture){if(M=t.DEPTH_COMPONENT,r.type===Qt){if(!i.isWebGL2)throw new Error("Float Depth Texture only supported in WebGL2.0");M=t.DEPTH_COMPONENT32F;}else i.isWebGL2&&(M=t.DEPTH_COMPONENT16);r.format===le&&M===t.DEPTH_COMPONENT&&r.type!==Yt&&r.type!==Jt&&(console.warn("THREE.WebGLRenderer: Use UnsignedShortType or UnsignedIntType for DepthFormat DepthTexture."),r.type=Yt,x=a.convert(r.type)),r.format===ce&&(M=t.DEPTH_STENCIL,r.type!==ne&&(console.warn("THREE.WebGLRenderer: Use UnsignedInt248Type for DepthStencilFormat DepthTexture."),r.type=ne,x=a.convert(r.type))),n.texImage2D(t.TEXTURE_2D,0,M,m.width,m.height,0,y,x,null);}else if(r.isDataTexture)if(w.length>0&&v){for(var E=0,S=w.length;E<S;E++)b=w[E],n.texImage2D(t.TEXTURE_2D,E,M,b.width,b.height,0,y,x,b.data);r.generateMipmaps=!1,e.__maxMipLevel=w.length-1;}else n.texImage2D(t.TEXTURE_2D,0,M,m.width,m.height,0,y,x,m.data),e.__maxMipLevel=0;else if(r.isCompressedTexture){for(E=0,S=w.length;E<S;E++)b=w[E],r.format!==ae&&r.format!==ie?n.getCompressedTextureFormats().indexOf(y)>-1?n.compressedTexImage2D(t.TEXTURE_2D,E,M,b.width,b.height,0,b.data):console.warn("THREE.WebGLRenderer: Attempt to load unsupported compressed texture format in .uploadTexture()"):n.texImage2D(t.TEXTURE_2D,E,M,b.width,b.height,0,y,x,b.data);e.__maxMipLevel=w.length-1;}else if(r.isDataTexture3D)n.texImage3D(t.TEXTURE_3D,0,M,m.width,m.height,m.depth,0,y,x,m.data),e.__maxMipLevel=0;else if(w.length>0&&v){for(E=0,S=w.length;E<S;E++)b=w[E],n.texImage2D(t.TEXTURE_2D,E,M,y,x,b);r.generateMipmaps=!1,e.__maxMipLevel=w.length-1;}else n.texImage2D(t.TEXTURE_2D,0,M,y,x,m),e.__maxMipLevel=0;h(r,v)&&f(t.TEXTURE_2D,r,m.width,m.height),e.__version=r.version,r.onUpdate&&r.onUpdate(r);}function M(e,i,o,s){var u=a.convert(i.texture.format),l=a.convert(i.texture.type),c=p(u,l);n.texImage2D(s,0,c,i.width,i.height,0,u,l,null),t.bindFramebuffer(t.FRAMEBUFFER,e),t.framebufferTexture2D(t.FRAMEBUFFER,o,s,r.get(i.texture).__webglTexture,0),t.bindFramebuffer(t.FRAMEBUFFER,null);}function b(e,n,r){if(t.bindRenderbuffer(t.RENDERBUFFER,e),n.depthBuffer&&!n.stencilBuffer){if(r){var i=E(n);t.renderbufferStorageMultisample(t.RENDERBUFFER,i,t.DEPTH_COMPONENT16,n.width,n.height);}else t.renderbufferStorage(t.RENDERBUFFER,t.DEPTH_COMPONENT16,n.width,n.height);t.framebufferRenderbuffer(t.FRAMEBUFFER,t.DEPTH_ATTACHMENT,t.RENDERBUFFER,e);}else if(n.depthBuffer&&n.stencilBuffer){if(r){i=E(n);t.renderbufferStorageMultisample(t.RENDERBUFFER,i,t.DEPTH_STENCIL,n.width,n.height);}else t.renderbufferStorage(t.RENDERBUFFER,t.DEPTH_STENCIL,n.width,n.height);t.framebufferRenderbuffer(t.FRAMEBUFFER,t.DEPTH_STENCIL_ATTACHMENT,t.RENDERBUFFER,e);}else{var o=p(a.convert(n.texture.format),a.convert(n.texture.type));if(r){i=E(n);t.renderbufferStorageMultisample(t.RENDERBUFFER,i,o,n.width,n.height);}else t.renderbufferStorage(t.RENDERBUFFER,o,n.width,n.height);}t.bindRenderbuffer(t.RENDERBUFFER,null);}function w(e){var n=r.get(e),i=!0===e.isWebGLRenderTargetCube;if(e.depthTexture){if(i)throw new Error("target.depthTexture not supported in Cube render targets");!function(e,n){if(n&&n.isWebGLRenderTargetCube)throw new Error("Depth Texture with cube render targets is not supported");if(t.bindFramebuffer(t.FRAMEBUFFER,e),!n.depthTexture||!n.depthTexture.isDepthTexture)throw new Error("renderTarget.depthTexture must be an instance of THREE.DepthTexture");r.get(n.depthTexture).__webglTexture&&n.depthTexture.image.width===n.width&&n.depthTexture.image.height===n.height||(n.depthTexture.image.width=n.width,n.depthTexture.image.height=n.height,n.depthTexture.needsUpdate=!0),y(n.depthTexture,0);var i=r.get(n.depthTexture).__webglTexture;if(n.depthTexture.format===le)t.framebufferTexture2D(t.FRAMEBUFFER,t.DEPTH_ATTACHMENT,t.TEXTURE_2D,i,0);else{if(n.depthTexture.format!==ce)throw new Error("Unknown depthTexture format");t.framebufferTexture2D(t.FRAMEBUFFER,t.DEPTH_STENCIL_ATTACHMENT,t.TEXTURE_2D,i,0);}}(n.__webglFramebuffer,e);}else if(i){n.__webglDepthbuffer=[];for(var a=0;a<6;a++)t.bindFramebuffer(t.FRAMEBUFFER,n.__webglFramebuffer[a]),n.__webglDepthbuffer[a]=t.createRenderbuffer(),b(n.__webglDepthbuffer[a],e);}else t.bindFramebuffer(t.FRAMEBUFFER,n.__webglFramebuffer),n.__webglDepthbuffer=t.createRenderbuffer(),b(n.__webglDepthbuffer,e);t.bindFramebuffer(t.FRAMEBUFFER,null);}function E(t){return i.isWebGL2&&t.isWebGLMultisampleRenderTarget?Math.min(i.maxSamples,t.samples):0}this.setTexture2D=y,this.setTexture3D=function(e,i){var a=r.get(e);e.version>0&&a.__version!==e.version?x(a,e,i):(n.activeTexture(t.TEXTURE0+i),n.bindTexture(t.TEXTURE_3D,a.__webglTexture));},this.setTextureCube=function(e,s){var u=r.get(e);if(6===e.image.length)if(e.version>0&&u.__version!==e.version){u.__image__webglTextureCube||(e.addEventListener("dispose",g),u.__image__webglTextureCube=t.createTexture(),o.memory.textures++),n.activeTexture(t.TEXTURE0+s),n.bindTexture(t.TEXTURE_CUBE_MAP,u.__image__webglTextureCube),t.pixelStorei(t.UNPACK_FLIP_Y_WEBGL,e.flipY);for(var d=e&&e.isCompressedTexture,m=e.image[0]&&e.image[0].isDataTexture,v=[],y=0;y<6;y++)v[y]=d||m?m?e.image[y].image:e.image[y]:l(e.image[y],!1,!0,i.maxCubemapSize);var x=v[0],M=c(x)||i.isWebGL2,b=a.convert(e.format),w=a.convert(e.type),E=p(b,w);for(_(t.TEXTURE_CUBE_MAP,e,M),y=0;y<6;y++)if(d)for(var S,T=v[y].mipmaps,A=0,L=T.length;A<L;A++)S=T[A],e.format!==ae&&e.format!==ie?n.getCompressedTextureFormats().indexOf(b)>-1?n.compressedTexImage2D(t.TEXTURE_CUBE_MAP_POSITIVE_X+y,A,E,S.width,S.height,0,S.data):console.warn("THREE.WebGLRenderer: Attempt to load unsupported compressed texture format in .setTextureCube()"):n.texImage2D(t.TEXTURE_CUBE_MAP_POSITIVE_X+y,A,E,S.width,S.height,0,b,w,S.data);else m?n.texImage2D(t.TEXTURE_CUBE_MAP_POSITIVE_X+y,0,E,v[y].width,v[y].height,0,b,w,v[y].data):n.texImage2D(t.TEXTURE_CUBE_MAP_POSITIVE_X+y,0,E,b,w,v[y]);u.__maxMipLevel=d?T.length-1:0,h(e,M)&&f(t.TEXTURE_CUBE_MAP,e,x.width,x.height),u.__version=e.version,e.onUpdate&&e.onUpdate(e);}else n.activeTexture(t.TEXTURE0+s),n.bindTexture(t.TEXTURE_CUBE_MAP,u.__image__webglTextureCube);},this.setTextureCubeDynamic=function(e,i){n.activeTexture(t.TEXTURE0+i),n.bindTexture(t.TEXTURE_CUBE_MAP,r.get(e).__webglTexture);},this.setupRenderTarget=function(e){var s=r.get(e),u=r.get(e.texture);e.addEventListener("dispose",v),u.__webglTexture=t.createTexture(),o.memory.textures++;var l=!0===e.isWebGLRenderTargetCube,d=!0===e.isWebGLMultisampleRenderTarget,m=c(e)||i.isWebGL2;if(l){s.__webglFramebuffer=[];for(var g=0;g<6;g++)s.__webglFramebuffer[g]=t.createFramebuffer();}else if(s.__webglFramebuffer=t.createFramebuffer(),d)if(i.isWebGL2){s.__webglMultisampledFramebuffer=t.createFramebuffer(),s.__webglColorRenderbuffer=t.createRenderbuffer(),t.bindRenderbuffer(t.RENDERBUFFER,s.__webglColorRenderbuffer);var y=p(a.convert(e.texture.format),a.convert(e.texture.type)),x=E(e);t.renderbufferStorageMultisample(t.RENDERBUFFER,x,y,e.width,e.height),t.bindFramebuffer(t.FRAMEBUFFER,s.__webglMultisampledFramebuffer),t.framebufferRenderbuffer(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.RENDERBUFFER,s.__webglColorRenderbuffer),t.bindRenderbuffer(t.RENDERBUFFER,null),e.depthBuffer&&(s.__webglDepthRenderbuffer=t.createRenderbuffer(),b(s.__webglDepthRenderbuffer,e,!0)),t.bindFramebuffer(t.FRAMEBUFFER,null);}else console.warn("THREE.WebGLRenderer: WebGLMultisampleRenderTarget can only be used with WebGL2.");if(l){for(n.bindTexture(t.TEXTURE_CUBE_MAP,u.__webglTexture),_(t.TEXTURE_CUBE_MAP,e.texture,m),g=0;g<6;g++)M(s.__webglFramebuffer[g],e,t.COLOR_ATTACHMENT0,t.TEXTURE_CUBE_MAP_POSITIVE_X+g);h(e.texture,m)&&f(t.TEXTURE_CUBE_MAP,e.texture,e.width,e.height),n.bindTexture(t.TEXTURE_CUBE_MAP,null);}else n.bindTexture(t.TEXTURE_2D,u.__webglTexture),_(t.TEXTURE_2D,e.texture,m),M(s.__webglFramebuffer,e,t.COLOR_ATTACHMENT0,t.TEXTURE_2D),h(e.texture,m)&&f(t.TEXTURE_2D,e.texture,e.width,e.height),n.bindTexture(t.TEXTURE_2D,null);e.depthBuffer&&w(e);},this.updateRenderTargetMipmap=function(e){var a=e.texture;if(h(a,c(e)||i.isWebGL2)){var o=e.isWebGLRenderTargetCube?t.TEXTURE_CUBE_MAP:t.TEXTURE_2D,s=r.get(a).__webglTexture;n.bindTexture(o,s),f(o,a,e.width,e.height),n.bindTexture(o,null);}},this.updateMultisampleRenderTarget=function(e){if(e.isWebGLMultisampleRenderTarget)if(i.isWebGL2){var n=r.get(e);t.bindFramebuffer(t.READ_FRAMEBUFFER,n.__webglMultisampledFramebuffer),t.bindFramebuffer(t.DRAW_FRAMEBUFFER,n.__webglFramebuffer);var a=e.width,o=e.height,s=t.COLOR_BUFFER_BIT;e.depthBuffer&&(s|=t.DEPTH_BUFFER_BIT),e.stencilBuffer&&(s|=t.STENCIL_BUFFER_BIT),t.blitFramebuffer(0,0,a,o,0,0,a,o,s,t.NEAREST);}else console.warn("THREE.WebGLRenderer: WebGLMultisampleRenderTarget can only be used with WebGL2.");};}function Ni(t,e,n){return {convert:function(r){var i;if(r===Ot)return t.REPEAT;if(r===Ut)return t.CLAMP_TO_EDGE;if(r===Bt)return t.MIRRORED_REPEAT;if(r===zt)return t.NEAREST;if(r===Gt)return t.NEAREST_MIPMAP_NEAREST;if(r===kt)return t.NEAREST_MIPMAP_LINEAR;if(r===Vt)return t.LINEAR;if(r===Ht)return t.LINEAR_MIPMAP_NEAREST;if(r===jt)return t.LINEAR_MIPMAP_LINEAR;if(r===Wt)return t.UNSIGNED_BYTE;if(r===$t)return t.UNSIGNED_SHORT_4_4_4_4;if(r===te)return t.UNSIGNED_SHORT_5_5_5_1;if(r===ee)return t.UNSIGNED_SHORT_5_6_5;if(r===Xt)return t.BYTE;if(r===qt)return t.SHORT;if(r===Yt)return t.UNSIGNED_SHORT;if(r===Zt)return t.INT;if(r===Jt)return t.UNSIGNED_INT;if(r===Qt)return t.FLOAT;if(r===Kt){if(n.isWebGL2)return t.HALF_FLOAT;if(null!==(i=e.get("OES_texture_half_float")))return i.HALF_FLOAT_OES}if(r===re)return t.ALPHA;if(r===ie)return t.RGB;if(r===ae)return t.RGBA;if(r===oe)return t.LUMINANCE;if(r===se)return t.LUMINANCE_ALPHA;if(r===le)return t.DEPTH_COMPONENT;if(r===ce)return t.DEPTH_STENCIL;if(r===he)return t.RED;if(r===J)return t.FUNC_ADD;if(r===Q)return t.FUNC_SUBTRACT;if(r===K)return t.FUNC_REVERSE_SUBTRACT;if(r===et)return t.ZERO;if(r===nt)return t.ONE;if(r===rt)return t.SRC_COLOR;if(r===it)return t.ONE_MINUS_SRC_COLOR;if(r===at)return t.SRC_ALPHA;if(r===ot)return t.ONE_MINUS_SRC_ALPHA;if(r===st)return t.DST_ALPHA;if(r===ut)return t.ONE_MINUS_DST_ALPHA;if(r===lt)return t.DST_COLOR;if(r===ct)return t.ONE_MINUS_DST_COLOR;if(r===ht)return t.SRC_ALPHA_SATURATE;if((r===fe||r===de||r===pe||r===me)&&null!==(i=e.get("WEBGL_compressed_texture_s3tc"))){if(r===fe)return i.COMPRESSED_RGB_S3TC_DXT1_EXT;if(r===de)return i.COMPRESSED_RGBA_S3TC_DXT1_EXT;if(r===pe)return i.COMPRESSED_RGBA_S3TC_DXT3_EXT;if(r===me)return i.COMPRESSED_RGBA_S3TC_DXT5_EXT}if((r===ge||r===ve||r===ye||r===_e)&&null!==(i=e.get("WEBGL_compressed_texture_pvrtc"))){if(r===ge)return i.COMPRESSED_RGB_PVRTC_4BPPV1_IMG;if(r===ve)return i.COMPRESSED_RGB_PVRTC_2BPPV1_IMG;if(r===ye)return i.COMPRESSED_RGBA_PVRTC_4BPPV1_IMG;if(r===_e)return i.COMPRESSED_RGBA_PVRTC_2BPPV1_IMG}if(r===xe&&null!==(i=e.get("WEBGL_compressed_texture_etc1")))return i.COMPRESSED_RGB_ETC1_WEBGL;if((r===Me||r===be||r===we||r===Ee||r===Se||r===Te||r===Ae||r===Le||r===Ce||r===Pe||r===Re||r===Fe||r===De||r===Ie)&&null!==(i=e.get("WEBGL_compressed_texture_astc")))return r;if(r===$||r===tt){if(n.isWebGL2){if(r===$)return t.MIN;if(r===tt)return t.MAX}if(null!==(i=e.get("EXT_blend_minmax"))){if(r===$)return i.MIN_EXT;if(r===tt)return i.MAX_EXT}}if(r===ne){if(n.isWebGL2)return t.UNSIGNED_INT_24_8;if(null!==(i=e.get("WEBGL_depth_texture")))return i.UNSIGNED_INT_24_8_WEBGL}return 0}}}function Oi(){nn.call(this),this.type="Group";}function Ui(){nn.call(this),this.type="Camera",this.matrixWorldInverse=new p,this.projectionMatrix=new p,this.projectionMatrixInverse=new p;}function Bi(t,e,n,r){Ui.call(this),this.type="PerspectiveCamera",this.fov=void 0!==t?t:50,this.zoom=1,this.near=void 0!==n?n:.1,this.far=void 0!==r?r:2e3,this.focus=10,this.aspect=void 0!==e?e:1,this.view=null,this.filmGauge=35,this.filmOffset=0,this.updateProjectionMatrix();}function zi(t){Bi.call(this),this.cameras=t||[];}Ci.prototype=Object.assign(Object.create(Ye.prototype),{constructor:Ci,isWebGLRenderTarget:!0,setSize:function(t,e){this.width===t&&this.height===e||(this.width=t,this.height=e,this.dispose()),this.viewport.set(0,0,t,e),this.scissor.set(0,0,t,e);},clone:function(){return (new this.constructor).copy(this)},copy:function(t){return this.width=t.width,this.height=t.height,this.viewport.copy(t.viewport),this.texture=t.texture.clone(),this.depthBuffer=t.depthBuffer,this.stencilBuffer=t.stencilBuffer,this.depthTexture=t.depthTexture,this},dispose:function(){this.dispatchEvent({type:"dispose"});}}),Pi.prototype=Object.create(Kn.prototype),Pi.prototype.constructor=Pi,Pi.prototype.isMeshDepthMaterial=!0,Pi.prototype.copy=function(t){return Kn.prototype.copy.call(this,t),this.depthPacking=t.depthPacking,this.skinning=t.skinning,this.morphTargets=t.morphTargets,this.map=t.map,this.alphaMap=t.alphaMap,this.displacementMap=t.displacementMap,this.displacementScale=t.displacementScale,this.displacementBias=t.displacementBias,this.wireframe=t.wireframe,this.wireframeLinewidth=t.wireframeLinewidth,this},Ri.prototype=Object.create(Kn.prototype),Ri.prototype.constructor=Ri,Ri.prototype.isMeshDistanceMaterial=!0,Ri.prototype.copy=function(t){return Kn.prototype.copy.call(this,t),this.referencePosition.copy(t.referencePosition),this.nearDistance=t.nearDistance,this.farDistance=t.farDistance,this.skinning=t.skinning,this.morphTargets=t.morphTargets,this.map=t.map,this.alphaMap=t.alphaMap,this.displacementMap=t.displacementMap,this.displacementScale=t.displacementScale,this.displacementBias=t.displacementBias,this},Oi.prototype=Object.assign(Object.create(nn.prototype),{constructor:Oi,isGroup:!0}),Ui.prototype=Object.assign(Object.create(nn.prototype),{constructor:Ui,isCamera:!0,copy:function(t,e){return nn.prototype.copy.call(this,t,e),this.matrixWorldInverse.copy(t.matrixWorldInverse),this.projectionMatrix.copy(t.projectionMatrix),this.projectionMatrixInverse.copy(t.projectionMatrixInverse),this},getWorldDirection:function(t){void 0===t&&(console.warn("THREE.Camera: .getWorldDirection() target is now required"),t=new g),this.updateMatrixWorld(!0);var e=this.matrixWorld.elements;return t.set(-e[8],-e[9],-e[10]).normalize()},updateMatrixWorld:function(t){nn.prototype.updateMatrixWorld.call(this,t),this.matrixWorldInverse.getInverse(this.matrixWorld);},clone:function(){return (new this.constructor).copy(this)}}),Bi.prototype=Object.assign(Object.create(Ui.prototype),{constructor:Bi,isPerspectiveCamera:!0,copy:function(t,e){return Ui.prototype.copy.call(this,t,e),this.fov=t.fov,this.zoom=t.zoom,this.near=t.near,this.far=t.far,this.focus=t.focus,this.aspect=t.aspect,this.view=null===t.view?null:Object.assign({},t.view),this.filmGauge=t.filmGauge,this.filmOffset=t.filmOffset,this},setFocalLength:function(t){var e=.5*this.getFilmHeight()/t;this.fov=2*d.RAD2DEG*Math.atan(e),this.updateProjectionMatrix();},getFocalLength:function(){var t=Math.tan(.5*d.DEG2RAD*this.fov);return .5*this.getFilmHeight()/t},getEffectiveFOV:function(){return 2*d.RAD2DEG*Math.atan(Math.tan(.5*d.DEG2RAD*this.fov)/this.zoom)},getFilmWidth:function(){return this.filmGauge*Math.min(this.aspect,1)},getFilmHeight:function(){return this.filmGauge/Math.max(this.aspect,1)},setViewOffset:function(t,e,n,r,i,a){this.aspect=t/e,null===this.view&&(this.view={enabled:!0,fullWidth:1,fullHeight:1,offsetX:0,offsetY:0,width:1,height:1}),this.view.enabled=!0,this.view.fullWidth=t,this.view.fullHeight=e,this.view.offsetX=n,this.view.offsetY=r,this.view.width=i,this.view.height=a,this.updateProjectionMatrix();},clearViewOffset:function(){null!==this.view&&(this.view.enabled=!1),this.updateProjectionMatrix();},updateProjectionMatrix:function(){var t=this.near,e=t*Math.tan(.5*d.DEG2RAD*this.fov)/this.zoom,n=2*e,r=this.aspect*n,i=-.5*r,a=this.view;if(null!==this.view&&this.view.enabled){var o=a.fullWidth,s=a.fullHeight;i+=a.offsetX*r/o,e-=a.offsetY*n/s,r*=a.width/o,n*=a.height/s;}var u=this.filmOffset;0!==u&&(i+=t*u/this.getFilmWidth()),this.projectionMatrix.makePerspective(i,i+r,e,e-n,t,this.far),this.projectionMatrixInverse.getInverse(this.projectionMatrix);},toJSON:function(t){var e=nn.prototype.toJSON.call(this,t);return e.object.fov=this.fov,e.object.zoom=this.zoom,e.object.near=this.near,e.object.far=this.far,e.object.focus=this.focus,e.object.aspect=this.aspect,null!==this.view&&(e.object.view=Object.assign({},this.view)),e.object.filmGauge=this.filmGauge,e.object.filmOffset=this.filmOffset,e}}),zi.prototype=Object.assign(Object.create(Bi.prototype),{constructor:zi,isArrayCamera:!0});var Gi,ki,Vi=new g,Hi=new g;function ji(t,e,n){Vi.setFromMatrixPosition(e.matrixWorld),Hi.setFromMatrixPosition(n.matrixWorld);var r=Vi.distanceTo(Hi),i=e.projectionMatrix.elements,a=n.projectionMatrix.elements,o=i[14]/(i[10]-1),s=i[14]/(i[10]+1),u=(i[9]+1)/i[5],l=(i[9]-1)/i[5],c=(i[8]-1)/i[0],h=(a[8]+1)/a[0],f=o*c,d=o*h,p=r/(-c+h),m=p*-c;e.matrixWorld.decompose(t.position,t.quaternion,t.scale),t.translateX(m),t.translateZ(p),t.matrixWorld.compose(t.position,t.quaternion,t.scale),t.matrixWorldInverse.getInverse(t.matrixWorld);var g=o+p,v=s+p,y=f-m,_=d+(r-m),x=u*s/v*g,M=l*s/v*g;t.projectionMatrix.makePerspective(y,_,x,M,g,v);}function Wi(t){var e=this,n=null,r=null,a=null,o=[],s=new p,u=new p,l=1,c="stage";"undefined"!=typeof window&&"VRFrameData"in window&&(r=new window.VRFrameData,window.addEventListener("vrdisplaypresentchange",w,!1));var h=new p,f=new m,d=new g,v=new Bi;v.bounds=new i(0,0,.5,1),v.layers.enable(1);var y=new Bi;y.bounds=new i(.5,0,.5,1),y.layers.enable(2);var _,x,M=new zi([v,y]);function b(){return null!==n&&!0===n.isPresenting}function w(){if(b()){var r=n.getEyeParameters("left"),i=r.renderWidth*l,a=r.renderHeight*l;x=t.getPixelRatio(),_=t.getSize(),t.setDrawingBufferSize(2*i,a,1),T.start();}else e.enabled&&t.setDrawingBufferSize(_.width,_.height,x),T.stop();}M.layers.enable(1),M.layers.enable(2);var E=[];function S(t){for(var e=navigator.getGamepads&&navigator.getGamepads(),n=0,r=0,i=e.length;n<i;n++){var a=e[n];if(a&&("Daydream Controller"===a.id||"Gear VR Controller"===a.id||"Oculus Go Controller"===a.id||"OpenVR Gamepad"===a.id||a.id.startsWith("Oculus Touch")||a.id.startsWith("Spatial Controller"))){if(r===t)return a;r++;}}}this.enabled=!1,this.getController=function(t){var e=o[t];return void 0===e&&((e=new Oi).matrixAutoUpdate=!1,e.visible=!1,o[t]=e),e},this.getDevice=function(){return n},this.setDevice=function(t){void 0!==t&&(n=t),T.setContext(t);},this.setFramebufferScaleFactor=function(t){l=t;},this.setFrameOfReferenceType=function(t){c=t;},this.setPoseTarget=function(t){void 0!==t&&(a=t);},this.getCamera=function(t){var e="stage"===c?1.6:0;if(null===n)return t.position.set(0,e,0),t;if(n.depthNear=t.near,n.depthFar=t.far,n.getFrameData(r),"stage"===c){var i=n.stageParameters;i?s.fromArray(i.sittingToStandingTransform):s.makeTranslation(0,e,0);}var l=r.pose,p=null!==a?a:t;if(p.matrix.copy(s),p.matrix.decompose(p.position,p.quaternion,p.scale),null!==l.orientation&&(f.fromArray(l.orientation),p.quaternion.multiply(f)),null!==l.position&&(f.setFromRotationMatrix(s),d.fromArray(l.position),d.applyQuaternion(f),p.position.add(d)),p.updateMatrixWorld(),!1===n.isPresenting)return t;v.near=t.near,y.near=t.near,v.far=t.far,y.far=t.far,v.matrixWorldInverse.fromArray(r.leftViewMatrix),y.matrixWorldInverse.fromArray(r.rightViewMatrix),u.getInverse(s),"stage"===c&&(v.matrixWorldInverse.multiply(u),y.matrixWorldInverse.multiply(u));var m=p.parent;null!==m&&(h.getInverse(m.matrixWorld),v.matrixWorldInverse.multiply(h),y.matrixWorldInverse.multiply(h)),v.matrixWorld.getInverse(v.matrixWorldInverse),y.matrixWorld.getInverse(y.matrixWorldInverse),v.projectionMatrix.fromArray(r.leftProjectionMatrix),y.projectionMatrix.fromArray(r.rightProjectionMatrix),ji(M,v,y);var g=n.getLayers();if(g.length){var _=g[0];null!==_.leftBounds&&4===_.leftBounds.length&&v.bounds.fromArray(_.leftBounds),null!==_.rightBounds&&4===_.rightBounds.length&&y.bounds.fromArray(_.rightBounds);}return function(){for(var t=0;t<o.length;t++){var e=o[t],n=S(t);if(void 0!==n&&void 0!==n.pose){if(null===n.pose)return;var r=n.pose;!1===r.hasPosition&&e.position.set(.2,-.6,-.05),null!==r.position&&e.position.fromArray(r.position),null!==r.orientation&&e.quaternion.fromArray(r.orientation),e.matrix.compose(e.position,e.quaternion,e.scale),e.matrix.premultiply(s),e.matrix.decompose(e.position,e.quaternion,e.scale),e.matrixWorldNeedsUpdate=!0,e.visible=!0;var i="Daydream Controller"===n.id?0:1;E[t]!==n.buttons[i].pressed&&(E[t]=n.buttons[i].pressed,!0===E[t]?e.dispatchEvent({type:"selectstart"}):(e.dispatchEvent({type:"selectend"}),e.dispatchEvent({type:"select"})));}else e.visible=!1;}}(),M},this.getStandingMatrix=function(){return s},this.isPresenting=b;var T=new En;this.setAnimationLoop=function(t){T.setAnimationLoop(t);},this.submitFrame=function(){b()&&n.submitFrame();},this.dispose=function(){"undefined"!=typeof window&&window.removeEventListener("vrdisplaypresentchange",w);};}function Xi(t){var e=t.context,n=null,r=null,a=1,o=null,s="stage",u=null,l=[],c=[];function h(){return null!==r&&null!==o}var f=new Bi;f.layers.enable(1),f.viewport=new i;var d=new Bi;d.layers.enable(2),d.viewport=new i;var p=new zi([f,d]);function m(t){var e=l[c.indexOf(t.inputSource)];e&&e.dispatchEvent({type:t.type});}function g(){t.setFramebuffer(null),_.stop();}function v(t,e){null===e?t.matrixWorld.copy(t.matrix):t.matrixWorld.multiplyMatrices(e.matrixWorld,t.matrix),t.matrixWorldInverse.getInverse(t.matrixWorld);}p.layers.enable(1),p.layers.enable(2),this.enabled=!1,this.getController=function(t){var e=l[t];return void 0===e&&((e=new Oi).matrixAutoUpdate=!1,e.visible=!1,l[t]=e),e},this.getDevice=function(){return n},this.setDevice=function(t){void 0!==t&&(n=t),t instanceof XRDevice&&e.setCompatibleXRDevice(t);},this.setFramebufferScaleFactor=function(t){a=t;},this.setFrameOfReferenceType=function(t){s=t;},this.setSession=function(n){null!==(r=n)&&(r.addEventListener("select",m),r.addEventListener("selectstart",m),r.addEventListener("selectend",m),r.addEventListener("end",g),r.baseLayer=new XRWebGLLayer(r,e,{framebufferScaleFactor:a}),r.requestFrameOfReference(s).then(function(e){o=e,t.setFramebuffer(r.baseLayer.framebuffer),_.setContext(r),_.start();}),c=r.getInputSources(),r.addEventListener("inputsourceschange",function(){c=r.getInputSources(),console.log(c);for(var t=0;t<l.length;t++){l[t].userData.inputSource=c[t];}}));},this.getCamera=function(t){if(h()){var e=t.parent,n=p.cameras;v(p,e);for(var r=0;r<n.length;r++)v(n[r],e);t.matrixWorld.copy(p.matrixWorld);for(var i=t.children,a=(r=0,i.length);r<a;r++)i[r].updateMatrixWorld(!0);return ji(p,f,d),p}return t},this.isPresenting=h;var y=null;var _=new En;_.setAnimationLoop(function(t,e){if(null!==(u=e.getDevicePose(o)))for(var n=r.baseLayer,i=e.views,a=0;a<i.length;a++){var s=i[a],h=n.getViewport(s),f=u.getViewMatrix(s),d=p.cameras[a];d.matrix.fromArray(f).getInverse(d.matrix),d.projectionMatrix.fromArray(s.projectionMatrix),d.viewport.set(h.x,h.y,h.width,h.height),0===a&&p.matrix.copy(d.matrix);}for(a=0;a<l.length;a++){var m=l[a],g=c[a];if(g){var v=e.getInputPose(g,o);if(null!==v){"targetRay"in v?m.matrix.elements=v.targetRay.transformMatrix:"pointerMatrix"in v&&(m.matrix.elements=v.pointerMatrix),m.matrix.decompose(m.position,m.rotation,m.scale),m.visible=!0;continue}}m.visible=!1;}y&&y(t);}),this.setAnimationLoop=function(t){y=t;},this.dispose=function(){},this.getStandingMatrix=function(){return console.warn("THREE.WebXRManager: getStandingMatrix() is no longer needed."),new THREE.Matrix4},this.submitFrame=function(){};}function qi(t){console.log("THREE.WebGLRenderer",I);var e=void 0!==(t=t||{}).canvas?t.canvas:document.createElementNS("http://www.w3.org/1999/xhtml","canvas"),n=void 0!==t.context?t.context:null,r=void 0!==t.alpha&&t.alpha,a=void 0===t.depth||t.depth,o=void 0===t.stencil||t.stencil,s=void 0!==t.antialias&&t.antialias,u=void 0===t.premultipliedAlpha||t.premultipliedAlpha,l=void 0!==t.preserveDrawingBuffer&&t.preserveDrawingBuffer,c=void 0!==t.powerPreference?t.powerPreference:"default",h=null,f=null;this.domElement=e,this.context=null,this.autoClear=!0,this.autoClearColor=!0,this.autoClearDepth=!0,this.autoClearStencil=!0,this.sortObjects=!0,this.clippingPlanes=[],this.localClippingEnabled=!1,this.gammaFactor=2,this.gammaInput=!1,this.gammaOutput=!1,this.physicallyCorrectLights=!1,this.toneMapping=Et,this.toneMappingExposure=1,this.toneMappingWhitePoint=1,this.maxMorphTargets=8,this.maxMorphNormals=4;var m,v,y,_,x,M,b,w,E,S,T,A,L,C,P,R,F,D,N=this,O=!1,U=null,B=null,z=null,G=-1,V={geometry:null,program:null,wireframe:!1},H=null,j=null,W=new i,X=new i,q=null,Y=0,Z=e.width,J=e.height,Q=1,K=new i(0,0,Z,J),$=new i(0,0,Z,J),tt=!1,et=new vn,nt=new sr,rt=!1,it=!1,at=new p,ot=new g;function st(){return null===B?Q:1}try{var ut={alpha:r,depth:a,stencil:o,antialias:s,premultipliedAlpha:u,preserveDrawingBuffer:l,powerPreference:c};if(e.addEventListener("webglcontextlost",ft,!1),e.addEventListener("webglcontextrestored",dt,!1),null===(m=n||e.getContext("webgl",ut)||e.getContext("experimental-webgl",ut)))throw null!==e.getContext("webgl")?new Error("Error creating WebGL context with your selected attributes."):new Error("Error creating WebGL context.");void 0===m.getShaderPrecisionFormat&&(m.getShaderPrecisionFormat=function(){return {rangeMin:1,rangeMax:1,precision:1}});}catch(t){console.error("THREE.WebGLRenderer: "+t.message);}function lt(){v=new ur(m),(y=new or(m,v,t)).isWebGL2||(v.get("WEBGL_depth_texture"),v.get("OES_texture_float"),v.get("OES_texture_half_float"),v.get("OES_texture_half_float_linear"),v.get("OES_standard_derivatives"),v.get("OES_element_index_uint"),v.get("ANGLE_instanced_arrays")),v.get("OES_texture_float_linear"),D=new Ni(m,v,y),(_=new Di(m,v,D,y)).scissor(X.copy($).multiplyScalar(Q)),_.viewport(W.copy(K).multiplyScalar(Q)),x=new hr(m),M=new _i,b=new Ii(m,v,_,M,y,D,x),w=new Sn(m),E=new lr(m,w,x),S=new pr(E,x),P=new dr(m),T=new yi(N,v,y),A=new wi,L=new Li,C=new ir(N,_,S,u),R=new ar(m,v,x,y),F=new cr(m,v,x,y),x.programs=T.programs,N.context=m,N.capabilities=y,N.extensions=v,N.properties=M,N.renderLists=A,N.state=_,N.info=x;}lt();var ct=null;"undefined"!=typeof navigator&&(ct="xr"in navigator?new Xi(N):new Wi(N)),this.vr=ct;var ht=new Fi(N,S,y.maxTextureSize);function ft(t){t.preventDefault(),console.log("THREE.WebGLRenderer: Context Lost."),O=!0;}function dt(){console.log("THREE.WebGLRenderer: Context Restored."),O=!1,lt();}function pt(t){var e=t.target;e.removeEventListener("dispose",pt),function(t){mt(t),M.remove(t);}(e);}function mt(t){var e=M.get(t).program;t.program=void 0,void 0!==e&&T.releaseProgram(e);}this.shadowMap=ht,this.getContext=function(){return m},this.getContextAttributes=function(){return m.getContextAttributes()},this.forceContextLoss=function(){var t=v.get("WEBGL_lose_context");t&&t.loseContext();},this.forceContextRestore=function(){var t=v.get("WEBGL_lose_context");t&&t.restoreContext();},this.getPixelRatio=function(){return Q},this.setPixelRatio=function(t){void 0!==t&&(Q=t,this.setSize(Z,J,!1));},this.getSize=function(){return {width:Z,height:J}},this.setSize=function(t,n,r){ct.isPresenting()?console.warn("THREE.WebGLRenderer: Can't change size while VR device is presenting."):(Z=t,J=n,e.width=t*Q,e.height=n*Q,!1!==r&&(e.style.width=t+"px",e.style.height=n+"px"),this.setViewport(0,0,t,n));},this.getDrawingBufferSize=function(){return {width:Z*Q,height:J*Q}},this.setDrawingBufferSize=function(t,n,r){Z=t,J=n,Q=r,e.width=t*r,e.height=n*r,this.setViewport(0,0,t,n);},this.getCurrentViewport=function(){return W},this.setViewport=function(t,e,n,r){K.set(t,J-e-r,n,r),_.viewport(W.copy(K).multiplyScalar(Q));},this.setScissor=function(t,e,n,r){$.set(t,J-e-r,n,r),_.scissor(X.copy($).multiplyScalar(Q));},this.setScissorTest=function(t){_.setScissorTest(tt=t);},this.getClearColor=function(){return C.getClearColor()},this.setClearColor=function(){C.setClearColor.apply(C,arguments);},this.getClearAlpha=function(){return C.getClearAlpha()},this.setClearAlpha=function(){C.setClearAlpha.apply(C,arguments);},this.clear=function(t,e,n){var r=0;(void 0===t||t)&&(r|=m.COLOR_BUFFER_BIT),(void 0===e||e)&&(r|=m.DEPTH_BUFFER_BIT),(void 0===n||n)&&(r|=m.STENCIL_BUFFER_BIT),m.clear(r);},this.clearColor=function(){this.clear(!0,!1,!1);},this.clearDepth=function(){this.clear(!1,!0,!1);},this.clearStencil=function(){this.clear(!1,!1,!0);},this.dispose=function(){e.removeEventListener("webglcontextlost",ft,!1),e.removeEventListener("webglcontextrestored",dt,!1),A.dispose(),L.dispose(),M.dispose(),S.dispose(),ct.dispose(),yt.stop();},this.renderBufferImmediate=function(t,e){_.initAttributes();var n=M.get(t);t.hasPositions&&!n.position&&(n.position=m.createBuffer()),t.hasNormals&&!n.normal&&(n.normal=m.createBuffer()),t.hasUvs&&!n.uv&&(n.uv=m.createBuffer()),t.hasColors&&!n.color&&(n.color=m.createBuffer());var r=e.getAttributes();t.hasPositions&&(m.bindBuffer(m.ARRAY_BUFFER,n.position),m.bufferData(m.ARRAY_BUFFER,t.positionArray,m.DYNAMIC_DRAW),_.enableAttribute(r.position),m.vertexAttribPointer(r.position,3,m.FLOAT,!1,0,0)),t.hasNormals&&(m.bindBuffer(m.ARRAY_BUFFER,n.normal),m.bufferData(m.ARRAY_BUFFER,t.normalArray,m.DYNAMIC_DRAW),_.enableAttribute(r.normal),m.vertexAttribPointer(r.normal,3,m.FLOAT,!1,0,0)),t.hasUvs&&(m.bindBuffer(m.ARRAY_BUFFER,n.uv),m.bufferData(m.ARRAY_BUFFER,t.uvArray,m.DYNAMIC_DRAW),_.enableAttribute(r.uv),m.vertexAttribPointer(r.uv,2,m.FLOAT,!1,0,0)),t.hasColors&&(m.bindBuffer(m.ARRAY_BUFFER,n.color),m.bufferData(m.ARRAY_BUFFER,t.colorArray,m.DYNAMIC_DRAW),_.enableAttribute(r.color),m.vertexAttribPointer(r.color,3,m.FLOAT,!1,0,0)),_.disableUnusedAttributes(),m.drawArrays(m.TRIANGLES,0,t.count),t.count=0;},this.renderBufferDirect=function(t,e,n,r,i,a){var o=i.isMesh&&i.normalMatrix.determinant()<0;_.setMaterial(r,o);var s=bt(t,e,r,i),u=!1;V.geometry===n.id&&V.program===s.id&&V.wireframe===(!0===r.wireframe)||(V.geometry=n.id,V.program=s.id,V.wireframe=!0===r.wireframe,u=!0),i.morphTargetInfluences&&(P.update(i,n,r,s),u=!0);var l,c=n.index,h=n.attributes.position,f=1;!0===r.wireframe&&(c=E.getWireframeAttribute(n),f=2);var d=R;null!==c&&(l=w.get(c),(d=F).setIndex(l)),u&&(!function(t,e,n){if(n&&n.isInstancedBufferGeometry&!y.isWebGL2&&null===v.get("ANGLE_instanced_arrays"))return void console.error("THREE.WebGLRenderer.setupVertexAttributes: using THREE.InstancedBufferGeometry but hardware does not support extension ANGLE_instanced_arrays.");_.initAttributes();var r=n.attributes,i=e.getAttributes(),a=t.defaultAttributeValues;for(var o in i){var s=i[o];if(s>=0){var u=r[o];if(void 0!==u){var l=u.normalized,c=u.itemSize,h=w.get(u);if(void 0===h)continue;var f=h.buffer,d=h.type,p=h.bytesPerElement;if(u.isInterleavedBufferAttribute){var g=u.data,x=g.stride,M=u.offset;g&&g.isInstancedInterleavedBuffer?(_.enableAttributeAndDivisor(s,g.meshPerAttribute),void 0===n.maxInstancedCount&&(n.maxInstancedCount=g.meshPerAttribute*g.count)):_.enableAttribute(s),m.bindBuffer(m.ARRAY_BUFFER,f),m.vertexAttribPointer(s,c,d,l,x*p,M*p);}else u.isInstancedBufferAttribute?(_.enableAttributeAndDivisor(s,u.meshPerAttribute),void 0===n.maxInstancedCount&&(n.maxInstancedCount=u.meshPerAttribute*u.count)):_.enableAttribute(s),m.bindBuffer(m.ARRAY_BUFFER,f),m.vertexAttribPointer(s,c,d,l,0,0);}else if(void 0!==a){var b=a[o];if(void 0!==b)switch(b.length){case 2:m.vertexAttrib2fv(s,b);break;case 3:m.vertexAttrib3fv(s,b);break;case 4:m.vertexAttrib4fv(s,b);break;default:m.vertexAttrib1fv(s,b);}}}}_.disableUnusedAttributes();}(r,s,n),null!==c&&m.bindBuffer(m.ELEMENT_ARRAY_BUFFER,l.buffer));var p=1/0;null!==c?p=c.count:void 0!==h&&(p=h.count);var g=n.drawRange.start*f,x=n.drawRange.count*f,M=null!==a?a.start*f:0,b=null!==a?a.count*f:1/0,S=Math.max(g,M),T=Math.min(p,g+x,M+b)-1,A=Math.max(0,T-S+1);if(0!==A){if(i.isMesh)if(!0===r.wireframe)_.setLineWidth(r.wireframeLinewidth*st()),d.setMode(m.LINES);else switch(i.drawMode){case Ne:d.setMode(m.TRIANGLES);break;case Oe:d.setMode(m.TRIANGLE_STRIP);break;case Ue:d.setMode(m.TRIANGLE_FAN);}else if(i.isLine){var L=r.linewidth;void 0===L&&(L=1),_.setLineWidth(L*st()),i.isLineSegments?d.setMode(m.LINES):i.isLineLoop?d.setMode(m.LINE_LOOP):d.setMode(m.LINE_STRIP);}else i.isPoints?d.setMode(m.POINTS):i.isSprite&&d.setMode(m.TRIANGLES);n&&n.isInstancedBufferGeometry?n.maxInstancedCount>0&&d.renderInstances(n,S,A):d.render(S,A);}},this.compile=function(t,e){(f=L.get(t,e)).init(),t.traverse(function(t){t.isLight&&(f.pushLight(t),t.castShadow&&f.pushShadow(t));}),f.setupLights(e),t.traverse(function(e){if(e.material)if(Array.isArray(e.material))for(var n=0;n<e.material.length;n++)Mt(e.material[n],t.fog,e);else Mt(e.material,t.fog,e);});};var gt=null;var vt,yt=new En;function _t(t,e,n,r){for(var i=0,a=t.length;i<a;i++){var o=t[i],s=o.object,u=o.geometry,l=void 0===r?o.material:r,c=o.group;if(n.isArrayCamera){j=n;for(var h=n.cameras,d=0,p=h.length;d<p;d++){var m=h[d];if(s.layers.test(m.layers)){if("viewport"in m)_.viewport(W.copy(m.viewport));else{var g=m.bounds,v=g.x*Z,y=g.y*J,x=g.z*Z,M=g.w*J;_.viewport(W.set(v,y,x,M).multiplyScalar(Q));}f.setupLights(m),xt(s,e,m,u,l,c);}}}else j=null,xt(s,e,n,u,l,c);}}function xt(t,e,n,r,i,a){if(t.onBeforeRender(N,e,n,r,i,a),f=L.get(e,j||n),t.modelViewMatrix.multiplyMatrices(n.matrixWorldInverse,t.matrixWorld),t.normalMatrix.getNormalMatrix(t.modelViewMatrix),t.isImmediateRenderObject){_.setMaterial(i);var o=bt(n,e.fog,i,t);V.geometry=null,V.program=null,V.wireframe=!1,function(t,e){t.render(function(t){N.renderBufferImmediate(t,e);});}(t,o);}else N.renderBufferDirect(n,e.fog,r,i,t,a);t.onAfterRender(N,e,n,r,i,a),f=L.get(e,j||n);}function Mt(t,e,n){var r=M.get(t),i=f.state.lights,a=f.state.shadowsArray,o=r.lightsHash,s=i.state.hash,u=T.getParameters(t,i.state,a,e,nt.numPlanes,nt.numIntersection,n),l=T.getProgramCode(t,u),c=r.program,h=!0;if(void 0===c)t.addEventListener("dispose",pt);else if(c.code!==l)mt(t);else if(o.stateID!==s.stateID||o.directionalLength!==s.directionalLength||o.pointLength!==s.pointLength||o.spotLength!==s.spotLength||o.rectAreaLength!==s.rectAreaLength||o.hemiLength!==s.hemiLength||o.shadowsLength!==s.shadowsLength)o.stateID=s.stateID,o.directionalLength=s.directionalLength,o.pointLength=s.pointLength,o.spotLength=s.spotLength,o.rectAreaLength=s.rectAreaLength,o.hemiLength=s.hemiLength,o.shadowsLength=s.shadowsLength,h=!1;else{if(void 0!==u.shaderID)return;h=!1;}if(h){if(u.shaderID){var d=wn[u.shaderID];r.shader={name:t.type,uniforms:_n(d.uniforms),vertexShader:d.vertexShader,fragmentShader:d.fragmentShader};}else r.shader={name:t.type,uniforms:t.uniforms,vertexShader:t.vertexShader,fragmentShader:t.fragmentShader};t.onBeforeCompile(r.shader,N),l=T.getProgramCode(t,u),c=T.acquireProgram(t,r.shader,u,l),r.program=c,t.program=c;}var p=c.getAttributes();if(t.morphTargets){t.numSupportedMorphTargets=0;for(var m=0;m<N.maxMorphTargets;m++)p["morphTarget"+m]>=0&&t.numSupportedMorphTargets++;}if(t.morphNormals){t.numSupportedMorphNormals=0;for(m=0;m<N.maxMorphNormals;m++)p["morphNormal"+m]>=0&&t.numSupportedMorphNormals++;}var g=r.shader.uniforms;(t.isShaderMaterial||t.isRawShaderMaterial)&&!0!==t.clipping||(r.numClippingPlanes=nt.numPlanes,r.numIntersection=nt.numIntersection,g.clippingPlanes=nt.uniform),r.fog=e,void 0===o&&(r.lightsHash=o={}),o.stateID=s.stateID,o.directionalLength=s.directionalLength,o.pointLength=s.pointLength,o.spotLength=s.spotLength,o.rectAreaLength=s.rectAreaLength,o.hemiLength=s.hemiLength,o.shadowsLength=s.shadowsLength,t.lights&&(g.ambientLightColor.value=i.state.ambient,g.directionalLights.value=i.state.directional,g.spotLights.value=i.state.spot,g.rectAreaLights.value=i.state.rectArea,g.pointLights.value=i.state.point,g.hemisphereLights.value=i.state.hemi,g.directionalShadowMap.value=i.state.directionalShadowMap,g.directionalShadowMatrix.value=i.state.directionalShadowMatrix,g.spotShadowMap.value=i.state.spotShadowMap,g.spotShadowMatrix.value=i.state.spotShadowMatrix,g.pointShadowMap.value=i.state.pointShadowMap,g.pointShadowMatrix.value=i.state.pointShadowMatrix);var v=r.program.getUniforms(),y=oi.seqWithValue(v.seq,g);r.uniformsList=y;}function bt(t,e,n,r){Y=0;var i=M.get(n),a=f.state.lights,o=i.lightsHash,s=a.state.hash;if(rt&&(it||t!==H)){var u=t===H&&n.id===G;nt.setState(n.clippingPlanes,n.clipIntersection,n.clipShadows,t,i,u);}!1===n.needsUpdate&&(void 0===i.program?n.needsUpdate=!0:n.fog&&i.fog!==e?n.needsUpdate=!0:(!n.lights||o.stateID===s.stateID&&o.directionalLength===s.directionalLength&&o.pointLength===s.pointLength&&o.spotLength===s.spotLength&&o.rectAreaLength===s.rectAreaLength&&o.hemiLength===s.hemiLength&&o.shadowsLength===s.shadowsLength)&&(void 0===i.numClippingPlanes||i.numClippingPlanes===nt.numPlanes&&i.numIntersection===nt.numIntersection)||(n.needsUpdate=!0)),n.needsUpdate&&(Mt(n,e,r),n.needsUpdate=!1);var l,c,h=!1,p=!1,g=!1,v=i.program,x=v.getUniforms(),b=i.shader.uniforms;if(_.useProgram(v.program)&&(h=!0,p=!0,g=!0),n.id!==G&&(G=n.id,p=!0),h||H!==t){if(x.setValue(m,"projectionMatrix",t.projectionMatrix),y.logarithmicDepthBuffer&&x.setValue(m,"logDepthBufFC",2/(Math.log(t.far+1)/Math.LN2)),H!==t&&(H=t,p=!0,g=!0),n.isShaderMaterial||n.isMeshPhongMaterial||n.isMeshStandardMaterial||n.envMap){var w=x.map.cameraPosition;void 0!==w&&w.setValue(m,ot.setFromMatrixPosition(t.matrixWorld));}(n.isMeshPhongMaterial||n.isMeshLambertMaterial||n.isMeshBasicMaterial||n.isMeshStandardMaterial||n.isShaderMaterial||n.skinning)&&x.setValue(m,"viewMatrix",t.matrixWorldInverse);}if(n.skinning){x.setOptional(m,r,"bindMatrix"),x.setOptional(m,r,"bindMatrixInverse");var E=r.skeleton;if(E){var S=E.bones;if(y.floatVertexTextures){if(void 0===E.boneTexture){var T=Math.sqrt(4*S.length);T=d.ceilPowerOfTwo(T),T=Math.max(T,4);var A=new Float32Array(T*T*4);A.set(E.boneMatrices);var L=new dn(A,T,T,ae,Qt);L.needsUpdate=!0,E.boneMatrices=A,E.boneTexture=L,E.boneTextureSize=T;}x.setValue(m,"boneTexture",E.boneTexture),x.setValue(m,"boneTextureSize",E.boneTextureSize);}else x.setOptional(m,E,"boneMatrices");}}return p&&(x.setValue(m,"toneMappingExposure",N.toneMappingExposure),x.setValue(m,"toneMappingWhitePoint",N.toneMappingWhitePoint),n.lights&&(c=g,(l=b).ambientLightColor.needsUpdate=c,l.directionalLights.needsUpdate=c,l.pointLights.needsUpdate=c,l.spotLights.needsUpdate=c,l.rectAreaLights.needsUpdate=c,l.hemisphereLights.needsUpdate=c),e&&n.fog&&function(t,e){t.fogColor.value=e.color,e.isFog?(t.fogNear.value=e.near,t.fogFar.value=e.far):e.isFogExp2&&(t.fogDensity.value=e.density);}(b,e),n.isMeshBasicMaterial?wt(b,n):n.isMeshLambertMaterial?(wt(b,n),function(t,e){e.emissiveMap&&(t.emissiveMap.value=e.emissiveMap);}(b,n)):n.isMeshPhongMaterial?(wt(b,n),n.isMeshToonMaterial?function(t,e){St(t,e),e.gradientMap&&(t.gradientMap.value=e.gradientMap);}(b,n):St(b,n)):n.isMeshStandardMaterial?(wt(b,n),n.isMeshPhysicalMaterial?function(t,e){Tt(t,e),t.reflectivity.value=e.reflectivity,t.clearCoat.value=e.clearCoat,t.clearCoatRoughness.value=e.clearCoatRoughness;}(b,n):Tt(b,n)):n.isMeshMatcapMaterial?(wt(b,n),function(t,e){e.matcap&&(t.matcap.value=e.matcap);e.bumpMap&&(t.bumpMap.value=e.bumpMap,t.bumpScale.value=e.bumpScale,e.side===k&&(t.bumpScale.value*=-1));e.normalMap&&(t.normalMap.value=e.normalMap,t.normalScale.value.copy(e.normalScale),e.side===k&&t.normalScale.value.negate());e.displacementMap&&(t.displacementMap.value=e.displacementMap,t.displacementScale.value=e.displacementScale,t.displacementBias.value=e.displacementBias);}(b,n)):n.isMeshDepthMaterial?(wt(b,n),function(t,e){e.displacementMap&&(t.displacementMap.value=e.displacementMap,t.displacementScale.value=e.displacementScale,t.displacementBias.value=e.displacementBias);}(b,n)):n.isMeshDistanceMaterial?(wt(b,n),function(t,e){e.displacementMap&&(t.displacementMap.value=e.displacementMap,t.displacementScale.value=e.displacementScale,t.displacementBias.value=e.displacementBias);t.referencePosition.value.copy(e.referencePosition),t.nearDistance.value=e.nearDistance,t.farDistance.value=e.farDistance;}(b,n)):n.isMeshNormalMaterial?(wt(b,n),function(t,e){e.bumpMap&&(t.bumpMap.value=e.bumpMap,t.bumpScale.value=e.bumpScale,e.side===k&&(t.bumpScale.value*=-1));e.normalMap&&(t.normalMap.value=e.normalMap,t.normalScale.value.copy(e.normalScale),e.side===k&&t.normalScale.value.negate());e.displacementMap&&(t.displacementMap.value=e.displacementMap,t.displacementScale.value=e.displacementScale,t.displacementBias.value=e.displacementBias);}(b,n)):n.isLineBasicMaterial?(function(t,e){t.diffuse.value=e.color,t.opacity.value=e.opacity;}(b,n),n.isLineDashedMaterial&&function(t,e){t.dashSize.value=e.dashSize,t.totalSize.value=e.dashSize+e.gapSize,t.scale.value=e.scale;}(b,n)):n.isPointsMaterial?function(t,e){t.diffuse.value=e.color,t.opacity.value=e.opacity,t.size.value=e.size*Q,t.scale.value=.5*J,t.map.value=e.map,null!==e.map&&(!0===e.map.matrixAutoUpdate&&e.map.updateMatrix(),t.uvTransform.value.copy(e.map.matrix));}(b,n):n.isSpriteMaterial?function(t,e){t.diffuse.value=e.color,t.opacity.value=e.opacity,t.rotation.value=e.rotation,t.map.value=e.map,null!==e.map&&(!0===e.map.matrixAutoUpdate&&e.map.updateMatrix(),t.uvTransform.value.copy(e.map.matrix));}(b,n):n.isShadowMaterial&&(b.color.value=n.color,b.opacity.value=n.opacity),void 0!==b.ltc_1&&(b.ltc_1.value=bn.LTC_1),void 0!==b.ltc_2&&(b.ltc_2.value=bn.LTC_2),oi.upload(m,i.uniformsList,b,N)),n.isShaderMaterial&&!0===n.uniformsNeedUpdate&&(oi.upload(m,i.uniformsList,b,N),n.uniformsNeedUpdate=!1),n.isSpriteMaterial&&x.setValue(m,"center",r.center),x.setValue(m,"modelViewMatrix",r.modelViewMatrix),x.setValue(m,"normalMatrix",r.normalMatrix),x.setValue(m,"modelMatrix",r.matrixWorld),v}function wt(t,e){var n;t.opacity.value=e.opacity,e.color&&(t.diffuse.value=e.color),e.emissive&&t.emissive.value.copy(e.emissive).multiplyScalar(e.emissiveIntensity),e.map&&(t.map.value=e.map),e.alphaMap&&(t.alphaMap.value=e.alphaMap),e.specularMap&&(t.specularMap.value=e.specularMap),e.envMap&&(t.envMap.value=e.envMap,t.flipEnvMap.value=e.envMap.isCubeTexture?-1:1,t.reflectivity.value=e.reflectivity,t.refractionRatio.value=e.refractionRatio,t.maxMipLevel.value=M.get(e.envMap).__maxMipLevel),e.lightMap&&(t.lightMap.value=e.lightMap,t.lightMapIntensity.value=e.lightMapIntensity),e.aoMap&&(t.aoMap.value=e.aoMap,t.aoMapIntensity.value=e.aoMapIntensity),e.map?n=e.map:e.specularMap?n=e.specularMap:e.displacementMap?n=e.displacementMap:e.normalMap?n=e.normalMap:e.bumpMap?n=e.bumpMap:e.roughnessMap?n=e.roughnessMap:e.metalnessMap?n=e.metalnessMap:e.alphaMap?n=e.alphaMap:e.emissiveMap&&(n=e.emissiveMap),void 0!==n&&(n.isWebGLRenderTarget&&(n=n.texture),!0===n.matrixAutoUpdate&&n.updateMatrix(),t.uvTransform.value.copy(n.matrix));}function St(t,e){t.specular.value=e.specular,t.shininess.value=Math.max(e.shininess,1e-4),e.emissiveMap&&(t.emissiveMap.value=e.emissiveMap),e.bumpMap&&(t.bumpMap.value=e.bumpMap,t.bumpScale.value=e.bumpScale,e.side===k&&(t.bumpScale.value*=-1)),e.normalMap&&(t.normalMap.value=e.normalMap,t.normalScale.value.copy(e.normalScale),e.side===k&&t.normalScale.value.negate()),e.displacementMap&&(t.displacementMap.value=e.displacementMap,t.displacementScale.value=e.displacementScale,t.displacementBias.value=e.displacementBias);}function Tt(t,e){t.roughness.value=e.roughness,t.metalness.value=e.metalness,e.roughnessMap&&(t.roughnessMap.value=e.roughnessMap),e.metalnessMap&&(t.metalnessMap.value=e.metalnessMap),e.emissiveMap&&(t.emissiveMap.value=e.emissiveMap),e.bumpMap&&(t.bumpMap.value=e.bumpMap,t.bumpScale.value=e.bumpScale,e.side===k&&(t.bumpScale.value*=-1)),e.normalMap&&(t.normalMap.value=e.normalMap,t.normalScale.value.copy(e.normalScale),e.side===k&&t.normalScale.value.negate()),e.displacementMap&&(t.displacementMap.value=e.displacementMap,t.displacementScale.value=e.displacementScale,t.displacementBias.value=e.displacementBias),e.envMap&&(t.envMapIntensity.value=e.envMapIntensity);}yt.setAnimationLoop(function(t){ct.isPresenting()||gt&&gt(t);}),"undefined"!=typeof window&&yt.setContext(window),this.setAnimationLoop=function(t){gt=t,ct.setAnimationLoop(t),yt.start();},this.render=function(t,e,n,r){if(e&&e.isCamera){if(!O){V.geometry=null,V.program=null,V.wireframe=!1,G=-1,H=null,!0===t.autoUpdate&&t.updateMatrixWorld(),null===e.parent&&e.updateMatrixWorld(),ct.enabled&&(e=ct.getCamera(e)),(f=L.get(t,e)).init(),t.onBeforeRender(N,t,e,n),at.multiplyMatrices(e.projectionMatrix,e.matrixWorldInverse),et.setFromMatrix(at),it=this.localClippingEnabled,rt=nt.init(this.clippingPlanes,it,e),(h=A.get(t,e)).init(),function t(e,n,r,i){if(!1===e.visible)return;var a=e.layers.test(n.layers);if(a)if(e.isGroup)r=e.renderOrder;else if(e.isLight)f.pushLight(e),e.castShadow&&f.pushShadow(e);else if(e.isSprite){if(!e.frustumCulled||et.intersectsSprite(e)){i&&ot.setFromMatrixPosition(e.matrixWorld).applyMatrix4(at);var o=S.update(e),s=e.material;h.push(e,o,s,r,ot.z,null);}}else if(e.isImmediateRenderObject)i&&ot.setFromMatrixPosition(e.matrixWorld).applyMatrix4(at),h.push(e,null,e.material,r,ot.z,null);else if((e.isMesh||e.isLine||e.isPoints)&&(e.isSkinnedMesh&&e.skeleton.update(),!e.frustumCulled||et.intersectsObject(e))){i&&ot.setFromMatrixPosition(e.matrixWorld).applyMatrix4(at);var o=S.update(e),s=e.material;if(Array.isArray(s))for(var u=o.groups,l=0,c=u.length;l<c;l++){var d=u[l],p=s[d.materialIndex];p&&p.visible&&h.push(e,o,p,r,ot.z,d);}else s.visible&&h.push(e,o,s,r,ot.z,null);}var m=e.children;for(var l=0,c=m.length;l<c;l++)t(m[l],n,r,i);}(t,e,0,N.sortObjects),!0===N.sortObjects&&h.sort(),rt&&nt.beginShadows();var i=f.state.shadowsArray;ht.render(i,t,e),f.setupLights(e),rt&&nt.endShadows(),this.info.autoReset&&this.info.reset(),void 0===n&&(n=null),this.setRenderTarget(n),C.render(h,t,e,r);var a=h.opaque,o=h.transparent;if(t.overrideMaterial){var s=t.overrideMaterial;a.length&&_t(a,t,e,s),o.length&&_t(o,t,e,s);}else a.length&&_t(a,t,e),o.length&&_t(o,t,e);n&&(b.updateRenderTargetMipmap(n),b.updateMultisampleRenderTarget(n)),_.buffers.depth.setTest(!0),_.buffers.depth.setMask(!0),_.buffers.color.setMask(!0),_.setPolygonOffset(!1),t.onAfterRender(N,t,e),ct.enabled&&ct.submitFrame(),h=null,f=null;}}else console.error("THREE.WebGLRenderer.render: camera is not an instance of THREE.Camera.");},this.allocTextureUnit=function(){var t=Y;return t>=y.maxTextures&&console.warn("THREE.WebGLRenderer: Trying to use "+t+" texture units while this GPU supports only "+y.maxTextures),Y+=1,t},this.setTexture2D=(vt=!1,function(t,e){t&&t.isWebGLRenderTarget&&(vt||(console.warn("THREE.WebGLRenderer.setTexture2D: don't use render targets as textures. Use their .texture property instead."),vt=!0),t=t.texture),b.setTexture2D(t,e);}),this.setTexture3D=function(t,e){b.setTexture3D(t,e);},this.setTexture=function(){var t=!1;return function(e,n){t||(console.warn("THREE.WebGLRenderer: .setTexture is deprecated, use setTexture2D instead."),t=!0),b.setTexture2D(e,n);}}(),this.setTextureCube=function(){var t=!1;return function(e,n){e&&e.isWebGLRenderTargetCube&&(t||(console.warn("THREE.WebGLRenderer.setTextureCube: don't use cube render targets as textures. Use their .texture property instead."),t=!0),e=e.texture),e&&e.isCubeTexture||Array.isArray(e.image)&&6===e.image.length?b.setTextureCube(e,n):b.setTextureCubeDynamic(e,n);}}(),this.setFramebuffer=function(t){U=t;},this.getRenderTarget=function(){return B},this.setRenderTarget=function(t){B=t,t&&void 0===M.get(t).__webglFramebuffer&&b.setupRenderTarget(t);var e=U,n=!1;if(t){var r=M.get(t).__webglFramebuffer;t.isWebGLRenderTargetCube?(e=r[t.activeCubeFace],n=!0):e=t.isWebGLMultisampleRenderTarget?M.get(t).__webglMultisampledFramebuffer:r,W.copy(t.viewport),X.copy(t.scissor),q=t.scissorTest;}else W.copy(K).multiplyScalar(Q),X.copy($).multiplyScalar(Q),q=tt;if(z!==e&&(m.bindFramebuffer(m.FRAMEBUFFER,e),z=e),_.viewport(W),_.scissor(X),_.setScissorTest(q),n){var i=M.get(t.texture);m.framebufferTexture2D(m.FRAMEBUFFER,m.COLOR_ATTACHMENT0,m.TEXTURE_CUBE_MAP_POSITIVE_X+t.activeCubeFace,i.__webglTexture,t.activeMipMapLevel);}},this.readRenderTargetPixels=function(t,e,n,r,i,a){if(t&&t.isWebGLRenderTarget){var o=M.get(t).__webglFramebuffer;if(o){var s=!1;o!==z&&(m.bindFramebuffer(m.FRAMEBUFFER,o),s=!0);try{var u=t.texture,l=u.format,c=u.type;if(l!==ae&&D.convert(l)!==m.getParameter(m.IMPLEMENTATION_COLOR_READ_FORMAT))return void console.error("THREE.WebGLRenderer.readRenderTargetPixels: renderTarget is not in RGBA or implementation defined format.");if(!(c===Wt||D.convert(c)===m.getParameter(m.IMPLEMENTATION_COLOR_READ_TYPE)||c===Qt&&(y.isWebGL2||v.get("OES_texture_float")||v.get("WEBGL_color_buffer_float"))||c===Kt&&(y.isWebGL2?v.get("EXT_color_buffer_float"):v.get("EXT_color_buffer_half_float"))))return void console.error("THREE.WebGLRenderer.readRenderTargetPixels: renderTarget is not in UnsignedByteType or implementation defined type.");m.checkFramebufferStatus(m.FRAMEBUFFER)===m.FRAMEBUFFER_COMPLETE?e>=0&&e<=t.width-r&&n>=0&&n<=t.height-i&&m.readPixels(e,n,r,i,D.convert(l),D.convert(c),a):console.error("THREE.WebGLRenderer.readRenderTargetPixels: readPixels from renderTarget failed. Framebuffer not complete.");}finally{s&&m.bindFramebuffer(m.FRAMEBUFFER,z);}}}else console.error("THREE.WebGLRenderer.readRenderTargetPixels: renderTarget is not THREE.WebGLRenderTarget.");},this.copyFramebufferToTexture=function(t,e,n){var r=e.image.width,i=e.image.height,a=D.convert(e.format);this.setTexture2D(e,0),m.copyTexImage2D(m.TEXTURE_2D,n||0,a,t.x,t.y,r,i,0);},this.copyTextureToTexture=function(t,e,n,r){var i=e.image.width,a=e.image.height,o=D.convert(n.format),s=D.convert(n.type);this.setTexture2D(n,0),e.isDataTexture?m.texSubImage2D(m.TEXTURE_2D,r||0,t.x,t.y,i,a,o,s,e.image.data):m.texSubImage2D(m.TEXTURE_2D,r||0,t.x,t.y,o,s,e.image);};}function Yi(t,e,n,r,i,a,o,s,u){fn.call(this,t,e,n,r,i,a,o,s,u),this.needsUpdate=!0;}function Zi(t){this.autoStart=void 0===t||t,this.startTime=0,this.oldTime=0,this.elapsedTime=0,this.running=!1;}function Ji(t){Kn.call(this),this.type="PointsMaterial",this.color=new b(16777215),this.map=null,this.size=1,this.sizeAttenuation=!0,this.morphTargets=!1,this.lights=!1,this.setValues(t);}function Qi(t,e){nn.call(this),this.type="Points",this.geometry=void 0!==t?t:new In,this.material=void 0!==e?e:new Ji({color:16777215*Math.random()});}function Ki(t){Kn.call(this),this.type="LineBasicMaterial",this.color=new b(16777215),this.linewidth=1,this.linecap="round",this.linejoin="round",this.lights=!1,this.setValues(t);}function $i(t,e,n){1===n&&console.error("THREE.Line: parameter THREE.LinePieces no longer supported. Use THREE.LineSegments instead."),nn.call(this),this.type="Line",this.geometry=void 0!==t?t:new In,this.material=void 0!==e?e:new Ki({color:16777215*Math.random()});}function ta(t,e){$i.call(this,t,e),this.type="LineSegments";}function ea(t,e,n,r,i,a){Ui.call(this),this.type="OrthographicCamera",this.zoom=1,this.view=null,this.left=void 0!==t?t:-1,this.right=void 0!==e?e:1,this.top=void 0!==n?n:1,this.bottom=void 0!==r?r:-1,this.near=void 0!==i?i:.1,this.far=void 0!==a?a:2e3,this.updateProjectionMatrix();}function na(){In.call(this),this.type="InstancedBufferGeometry",this.maxInstancedCount=void 0;}function ra(t,e,n,r){this.ray=new tr(t,e),this.near=n||0,this.far=r||1/0,this.params={Mesh:{},Line:{},LOD:{},Points:{threshold:1},Sprite:{}},Object.defineProperties(this.params,{PointCloud:{get:function(){return console.warn("THREE.Raycaster: params.PointCloud has been renamed to params.Points."),this.Points}}});}function ia(t,e){return t.distance-e.distance}function aa(t,e,n,r){if(!1!==t.visible&&(t.raycast(e,n),!0===r))for(var i=t.children,a=0,o=i.length;a<o;a++)aa(i[a],e,n,!0);}function oa(t,e,n,r){"number"==typeof n&&(r=n,n=!1,console.error("THREE.InstancedBufferAttribute: The constructor now expects normalized as the third argument.")),w.call(this,t,e,n),this.meshPerAttribute=r||1;}function sa(t,e,n){Array.isArray(t)&&(t=new Float32Array(t)),w.call(this,t,e,n);}Yi.prototype=Object.create(fn.prototype),Yi.prototype.constructor=Yi,Yi.prototype.isCanvasTexture=!0,Object.assign(Zi.prototype,{start:function(){this.startTime=("undefined"==typeof performance?Date:performance).now(),this.oldTime=this.startTime,this.elapsedTime=0,this.running=!0;},stop:function(){this.getElapsedTime(),this.running=!1,this.autoStart=!1;},getElapsedTime:function(){return this.getDelta(),this.elapsedTime},getDelta:function(){var t=0;if(this.autoStart&&!this.running)return this.start(),0;if(this.running){var e=("undefined"==typeof performance?Date:performance).now();t=(e-this.oldTime)/1e3,this.oldTime=e,this.elapsedTime+=t;}return t}}),Ji.prototype=Object.create(Kn.prototype),Ji.prototype.constructor=Ji,Ji.prototype.isPointsMaterial=!0,Ji.prototype.copy=function(t){return Kn.prototype.copy.call(this,t),this.color.copy(t.color),this.map=t.map,this.size=t.size,this.sizeAttenuation=t.sizeAttenuation,this.morphTargets=t.morphTargets,this},Qi.prototype=Object.assign(Object.create(nn.prototype),{constructor:Qi,isPoints:!0,raycast:function(){var t=new p,e=new tr,n=new mn;return function(r,i){var a=this,o=this.geometry,s=this.matrixWorld,u=r.params.Points.threshold;if(null===o.boundingSphere&&o.computeBoundingSphere(),n.copy(o.boundingSphere),n.applyMatrix4(s),n.radius+=u,!1!==r.ray.intersectsSphere(n)){t.getInverse(s),e.copy(r.ray).applyMatrix4(t);var l=u/((this.scale.x+this.scale.y+this.scale.z)/3),c=l*l,h=new g,f=new g;if(o.isBufferGeometry){var d=o.index,p=o.attributes.position.array;if(null!==d)for(var m=d.array,v=0,y=m.length;v<y;v++){var _=m[v];h.fromArray(p,3*_),b(h,_);}else{v=0;for(var x=p.length/3;v<x;v++)h.fromArray(p,3*v),b(h,v);}}else{var M=o.vertices;for(v=0,x=M.length;v<x;v++)b(M[v],v);}}function b(t,n){var o=e.distanceSqToPoint(t);if(o<c){e.closestPointToPoint(t,f),f.applyMatrix4(s);var u=r.ray.origin.distanceTo(f);if(u<r.near||u>r.far)return;i.push({distance:u,distanceToRay:Math.sqrt(o),point:f.clone(),index:n,face:null,object:a});}}}}(),clone:function(){return new this.constructor(this.geometry,this.material).copy(this)}}),Ki.prototype=Object.create(Kn.prototype),Ki.prototype.constructor=Ki,Ki.prototype.isLineBasicMaterial=!0,Ki.prototype.copy=function(t){return Kn.prototype.copy.call(this,t),this.color.copy(t.color),this.linewidth=t.linewidth,this.linecap=t.linecap,this.linejoin=t.linejoin,this},$i.prototype=Object.assign(Object.create(nn.prototype),{constructor:$i,isLine:!0,computeLineDistances:(Gi=new g,ki=new g,function(){var t=this.geometry;if(t.isBufferGeometry)if(null===t.index){for(var e=t.attributes.position,n=[0],r=1,i=e.count;r<i;r++)Gi.fromBufferAttribute(e,r-1),ki.fromBufferAttribute(e,r),n[r]=n[r-1],n[r]+=Gi.distanceTo(ki);t.addAttribute("lineDistance",new R(n,1));}else console.warn("THREE.Line.computeLineDistances(): Computation only possible with non-indexed BufferGeometry.");else if(t.isGeometry){var a=t.vertices;for((n=t.lineDistances)[0]=0,r=1,i=a.length;r<i;r++)n[r]=n[r-1],n[r]+=a[r-1].distanceTo(a[r]);}return this}),raycast:function(){var t=new p,e=new tr,n=new mn;return function(r,i){var a=r.linePrecision,o=this.geometry,s=this.matrixWorld;if(null===o.boundingSphere&&o.computeBoundingSphere(),n.copy(o.boundingSphere),n.applyMatrix4(s),n.radius+=a,!1!==r.ray.intersectsSphere(n)){t.getInverse(s),e.copy(r.ray).applyMatrix4(t);var u=a/((this.scale.x+this.scale.y+this.scale.z)/3),l=u*u,c=new g,h=new g,f=new g,d=new g,p=this&&this.isLineSegments?2:1;if(o.isBufferGeometry){var m=o.index,v=o.attributes.position.array;if(null!==m)for(var y=m.array,_=0,x=y.length-1;_<x;_+=p){var M=y[_],b=y[_+1];if(c.fromArray(v,3*M),h.fromArray(v,3*b),!(e.distanceSqToSegment(c,h,d,f)>l))d.applyMatrix4(this.matrixWorld),(S=r.ray.origin.distanceTo(d))<r.near||S>r.far||i.push({distance:S,point:f.clone().applyMatrix4(this.matrixWorld),index:_,face:null,faceIndex:null,object:this});}else for(_=0,x=v.length/3-1;_<x;_+=p){if(c.fromArray(v,3*_),h.fromArray(v,3*_+3),!(e.distanceSqToSegment(c,h,d,f)>l))d.applyMatrix4(this.matrixWorld),(S=r.ray.origin.distanceTo(d))<r.near||S>r.far||i.push({distance:S,point:f.clone().applyMatrix4(this.matrixWorld),index:_,face:null,faceIndex:null,object:this});}}else if(o.isGeometry){var w=o.vertices,E=w.length;for(_=0;_<E-1;_+=p){var S;if(!(e.distanceSqToSegment(w[_],w[_+1],d,f)>l))d.applyMatrix4(this.matrixWorld),(S=r.ray.origin.distanceTo(d))<r.near||S>r.far||i.push({distance:S,point:f.clone().applyMatrix4(this.matrixWorld),index:_,face:null,faceIndex:null,object:this});}}}}}(),copy:function(t){return nn.prototype.copy.call(this,t),this.geometry.copy(t.geometry),this.material.copy(t.material),this},clone:function(){return (new this.constructor).copy(this)}}),ta.prototype=Object.assign(Object.create($i.prototype),{constructor:ta,isLineSegments:!0,computeLineDistances:function(){var t=new g,e=new g;return function(){var n=this.geometry;if(n.isBufferGeometry)if(null===n.index){for(var r=n.attributes.position,i=[],a=0,o=r.count;a<o;a+=2)t.fromBufferAttribute(r,a),e.fromBufferAttribute(r,a+1),i[a]=0===a?0:i[a-1],i[a+1]=i[a]+t.distanceTo(e);n.addAttribute("lineDistance",new R(i,1));}else console.warn("THREE.LineSegments.computeLineDistances(): Computation only possible with non-indexed BufferGeometry.");else if(n.isGeometry){var s=n.vertices;for(i=n.lineDistances,a=0,o=s.length;a<o;a+=2)t.copy(s[a]),e.copy(s[a+1]),i[a]=0===a?0:i[a-1],i[a+1]=i[a]+t.distanceTo(e);}return this}}()}),ea.prototype=Object.assign(Object.create(Ui.prototype),{constructor:ea,isOrthographicCamera:!0,copy:function(t,e){return Ui.prototype.copy.call(this,t,e),this.left=t.left,this.right=t.right,this.top=t.top,this.bottom=t.bottom,this.near=t.near,this.far=t.far,this.zoom=t.zoom,this.view=null===t.view?null:Object.assign({},t.view),this},setViewOffset:function(t,e,n,r,i,a){null===this.view&&(this.view={enabled:!0,fullWidth:1,fullHeight:1,offsetX:0,offsetY:0,width:1,height:1}),this.view.enabled=!0,this.view.fullWidth=t,this.view.fullHeight=e,this.view.offsetX=n,this.view.offsetY=r,this.view.width=i,this.view.height=a,this.updateProjectionMatrix();},clearViewOffset:function(){null!==this.view&&(this.view.enabled=!1),this.updateProjectionMatrix();},updateProjectionMatrix:function(){var t=(this.right-this.left)/(2*this.zoom),e=(this.top-this.bottom)/(2*this.zoom),n=(this.right+this.left)/2,r=(this.top+this.bottom)/2,i=n-t,a=n+t,o=r+e,s=r-e;if(null!==this.view&&this.view.enabled){var u=this.zoom/(this.view.width/this.view.fullWidth),l=this.zoom/(this.view.height/this.view.fullHeight),c=(this.right-this.left)/this.view.width,h=(this.top-this.bottom)/this.view.height;a=(i+=c*(this.view.offsetX/u))+c*(this.view.width/u),s=(o-=h*(this.view.offsetY/l))-h*(this.view.height/l);}this.projectionMatrix.makeOrthographic(i,a,o,s,this.near,this.far),this.projectionMatrixInverse.getInverse(this.projectionMatrix);},toJSON:function(t){var e=nn.prototype.toJSON.call(this,t);return e.object.zoom=this.zoom,e.object.left=this.left,e.object.right=this.right,e.object.top=this.top,e.object.bottom=this.bottom,e.object.near=this.near,e.object.far=this.far,null!==this.view&&(e.object.view=Object.assign({},this.view)),e}}),na.prototype=Object.assign(Object.create(In.prototype),{constructor:na,isInstancedBufferGeometry:!0,copy:function(t){return In.prototype.copy.call(this,t),this.maxInstancedCount=t.maxInstancedCount,this},clone:function(){return (new this.constructor).copy(this)}}),Object.assign(ra.prototype,{linePrecision:1,set:function(t,e){this.ray.set(t,e);},setFromCamera:function(t,e){e&&e.isPerspectiveCamera?(this.ray.origin.setFromMatrixPosition(e.matrixWorld),this.ray.direction.set(t.x,t.y,.5).unproject(e).sub(this.ray.origin).normalize()):e&&e.isOrthographicCamera?(this.ray.origin.set(t.x,t.y,(e.near+e.far)/(e.near-e.far)).unproject(e),this.ray.direction.set(0,0,-1).transformDirection(e.matrixWorld)):console.error("THREE.Raycaster: Unsupported camera type.");},intersectObject:function(t,e,n){var r=n||[];return aa(t,this,r,e),r.sort(ia),r},intersectObjects:function(t,e,n){var r=n||[];if(!1===Array.isArray(t))return console.warn("THREE.Raycaster.intersectObjects: objects is not an Array."),r;for(var i=0,a=t.length;i<a;i++)aa(t[i],this,r,e);return r.sort(ia),r}}),oa.prototype=Object.assign(Object.create(w.prototype),{constructor:oa,isInstancedBufferAttribute:!0,copy:function(t){return w.prototype.copy.call(this,t),this.meshPerAttribute=t.meshPerAttribute,this}}),sa.prototype=Object.create(w.prototype),sa.prototype.constructor=sa;var ua=Object.freeze({__proto__:null,Float32BufferAttribute:sa,Scene:rn,WebGLRenderer:qi,CanvasTexture:Yi,Object3D:nn,Group:Oi,Clock:Zi,Points:Qi,LineSegments:ta,Mesh:rr,Texture:fn,WebGLRenderTarget:Ci,PerspectiveCamera:Bi,OrthographicCamera:ea,BufferGeometry:In,InstancedBufferGeometry:na,PlaneBufferGeometry:Bn,BoxBufferGeometry:On,Raycaster:ra,UniformsUtils:Mn,Matrix4:p,Matrix3:Qe,Line:$i,Vector4:i,Vector3:g,Vector2:v,ShaderMaterial:$n,DataTexture:dn,Color:b,Float64BufferAttribute:F,Uint32BufferAttribute:P,Int32BufferAttribute:C,Uint16BufferAttribute:L,Int16BufferAttribute:A,Uint8ClampedBufferAttribute:T,Uint8BufferAttribute:S,Int8BufferAttribute:E,BufferAttribute:w,InstancedBufferAttribute:oa,REVISION:I,MOUSE:{LEFT:0,MIDDLE:1,RIGHT:2},CullFaceNone:N,CullFaceBack:O,CullFaceFront:U,CullFaceFrontBack:3,FrontFaceDirectionCW:0,FrontFaceDirectionCCW:1,BasicShadowMap:0,PCFShadowMap:B,PCFSoftShadowMap:z,FrontSide:G,BackSide:k,DoubleSide:V,FlatShading:1,SmoothShading:2,NoColors:H,FaceColors:1,VertexColors:2,NoBlending:j,NormalBlending:W,AdditiveBlending:X,SubtractiveBlending:q,MultiplyBlending:Y,CustomBlending:Z,AddEquation:J,SubtractEquation:Q,ReverseSubtractEquation:K,MinEquation:$,MaxEquation:tt,ZeroFactor:et,OneFactor:nt,SrcColorFactor:rt,OneMinusSrcColorFactor:it,SrcAlphaFactor:at,OneMinusSrcAlphaFactor:ot,DstAlphaFactor:st,OneMinusDstAlphaFactor:ut,DstColorFactor:lt,OneMinusDstColorFactor:ct,SrcAlphaSaturateFactor:ht,NeverDepth:ft,AlwaysDepth:dt,LessDepth:pt,LessEqualDepth:mt,EqualDepth:gt,GreaterEqualDepth:vt,GreaterDepth:yt,NotEqualDepth:_t,MultiplyOperation:xt,MixOperation:Mt,AddOperation:bt,NoToneMapping:wt,LinearToneMapping:Et,ReinhardToneMapping:St,Uncharted2ToneMapping:Tt,CineonToneMapping:At,ACESFilmicToneMapping:Lt,UVMapping:300,CubeReflectionMapping:Ct,CubeRefractionMapping:Pt,EquirectangularReflectionMapping:Rt,EquirectangularRefractionMapping:Ft,SphericalReflectionMapping:Dt,CubeUVReflectionMapping:It,CubeUVRefractionMapping:Nt,RepeatWrapping:Ot,ClampToEdgeWrapping:Ut,MirroredRepeatWrapping:Bt,NearestFilter:zt,NearestMipMapNearestFilter:Gt,NearestMipMapLinearFilter:kt,LinearFilter:Vt,LinearMipMapNearestFilter:Ht,LinearMipMapLinearFilter:jt,UnsignedByteType:Wt,ByteType:Xt,ShortType:qt,UnsignedShortType:Yt,IntType:Zt,UnsignedIntType:Jt,FloatType:Qt,HalfFloatType:Kt,UnsignedShort4444Type:$t,UnsignedShort5551Type:te,UnsignedShort565Type:ee,UnsignedInt248Type:ne,AlphaFormat:re,RGBFormat:ie,RGBAFormat:ae,LuminanceFormat:oe,LuminanceAlphaFormat:se,RGBEFormat:ue,DepthFormat:le,DepthStencilFormat:ce,RedFormat:he,RGB_S3TC_DXT1_Format:fe,RGBA_S3TC_DXT1_Format:de,RGBA_S3TC_DXT3_Format:pe,RGBA_S3TC_DXT5_Format:me,RGB_PVRTC_4BPPV1_Format:ge,RGB_PVRTC_2BPPV1_Format:ve,RGBA_PVRTC_4BPPV1_Format:ye,RGBA_PVRTC_2BPPV1_Format:_e,RGB_ETC1_Format:xe,RGBA_ASTC_4x4_Format:Me,RGBA_ASTC_5x4_Format:be,RGBA_ASTC_5x5_Format:we,RGBA_ASTC_6x5_Format:Ee,RGBA_ASTC_6x6_Format:Se,RGBA_ASTC_8x5_Format:Te,RGBA_ASTC_8x6_Format:Ae,RGBA_ASTC_8x8_Format:Le,RGBA_ASTC_10x5_Format:Ce,RGBA_ASTC_10x6_Format:Pe,RGBA_ASTC_10x8_Format:Re,RGBA_ASTC_10x10_Format:Fe,RGBA_ASTC_12x10_Format:De,RGBA_ASTC_12x12_Format:Ie,LoopOnce:2200,LoopRepeat:2201,LoopPingPong:2202,InterpolateDiscrete:2300,InterpolateLinear:2301,InterpolateSmooth:2302,ZeroCurvatureEnding:2400,ZeroSlopeEnding:2401,WrapAroundEnding:2402,TrianglesDrawMode:Ne,TriangleStripDrawMode:Oe,TriangleFanDrawMode:Ue,LinearEncoding:Be,sRGBEncoding:ze,GammaEncoding:Ge,RGBEEncoding:ke,LogLuvEncoding:3003,RGBM7Encoding:Ve,RGBM16Encoding:He,RGBDEncoding:je,BasicDepthPacking:We,RGBADepthPacking:Xe,TangentSpaceNormalMap:0,ObjectSpaceNormalMap:qe}),la=n(function(t,e){e.__esModule=!0;e.default=function(t){return null!==t&&"function"!=typeof t&&isFinite(t.length)};});e(la);var ca=n(function(t,e){e.__esModule=!0;e.default=function(t,e){return !!la.default(t)&&t.indexOf(e)>-1};});e(ca);var ha=n(function(t,e){e.__esModule=!0;var n={}.toString;e.default=function(t,e){return n.call(t)==="[object "+e+"]"};});e(ha);var fa=n(function(t,e){e.__esModule=!0,e.default=function(t){return Array.isArray?Array.isArray(t):ha.default(t,"Array")};});e(fa);var da=n(function(t,e){e.__esModule=!0,e.default=function(t){var e=typeof t;return null!==t&&"object"===e||"function"===e};});e(da);var pa=n(function(t,e){e.__esModule=!0,e.default=function(t,e){if(t)if(fa.default(t))for(var n=0,r=t.length;n<r&&!1!==e(t[n],n);n++);else if(da.default(t))for(var i in t)if(t.hasOwnProperty(i)&&!1===e(t[i],i))break};});e(pa);var ma=n(function(t,e){e.__esModule=!0;e.default=function(t,e){if(!la.default(t))return t;var n=[];return pa.default(t,function(t,r){e(t,r)&&n.push(t);}),n};});e(ma);var ga=n(function(t,e){e.__esModule=!0;e.default=function(t,e){return void 0===e&&(e=[]),ma.default(t,function(t){return !ca.default(e,t)})};});e(ga);var va=n(function(t,e){e.__esModule=!0,e.default=function(t){return ha.default(t,"Function")};});e(va);var ya=n(function(t,e){e.__esModule=!0;e.default=function(t){return null==t};});e(ya);var _a=n(function(t,e){e.__esModule=!0;var n=Object.keys?function(t){return Object.keys(t)}:function(t){var e=[];return pa.default(t,function(n,r){va.default(t)&&"prototype"===r||e.push(r);}),e};e.default=n;});e(_a);var xa=n(function(t,e){e.__esModule=!0,e.default=function(t,e){var n=_a.default(e),r=n.length;if(ya.default(t))return !r;for(var i=0;i<r;i+=1){var a=n[i];if(e[a]!==t[a]||!(a in t))return !1}return !0};});e(xa);var Ma=n(function(t,e){e.__esModule=!0;e.default=function(t){return "object"==typeof t&&null!==t};});e(Ma);var ba=n(function(t,e){e.__esModule=!0;e.default=function(t){if(!Ma.default(t)||!ha.default(t,"Object"))return !1;if(null===Object.getPrototypeOf(t))return !0;for(var e=t;null!==Object.getPrototypeOf(e);)e=Object.getPrototypeOf(e);return Object.getPrototypeOf(t)===e};});e(ba);var wa=n(function(t,e){e.__esModule=!0,e.default=function(t,e){if(!fa.default(t))return null;var n;if(va.default(e)&&(n=e),ba.default(e)&&(n=function(t){return xa.default(t,e)}),n)for(var r=0;r<t.length;r+=1)if(n(t[r]))return t[r];return null};});e(wa);var Ea=n(function(t,e){e.__esModule=!0,e.default=function(t,e,n){void 0===n&&(n=0);for(var r=n;r<t.length;r++)if(e(t[r],r))return r;return -1};});e(Ea);var Sa=n(function(t,e){e.__esModule=!0;e.default=function(t,e){for(var n=null,r=0;r<t.length;r++){var i=t[r][e];if(!ya.default(i)){n=fa.default(i)?i[0]:i;break}}return n};});e(Sa);var Ta=n(function(t,e){e.__esModule=!0;e.default=function(t){if(!fa.default(t))return [];for(var e=[],n=0;n<t.length;n++)e=e.concat(t[n]);return e};}),Aa=e(Ta),La=n(function(t,e){e.__esModule=!0;var n=function(t,e){if(void 0===e&&(e=[]),fa.default(t))for(var r=0;r<t.length;r+=1)n(t[r],e);else e.push(t);return e};e.default=n;});e(La);var Ca=n(function(t,e){e.__esModule=!0;e.default=function(t){if(!(t=ma.default(t,function(t){return !isNaN(t)})).length)return {min:0,max:0};if(fa.default(t[0])){for(var e=[],n=0;n<t.length;n++)e=e.concat(t[n]);t=e;}var r=Math.max.apply(null,t);return {min:Math.min.apply(null,t),max:r}};});e(Ca);var Pa=n(function(t,e){e.__esModule=!0;var n=Array.prototype,r=n.splice,i=n.indexOf;e.default=function(t){for(var e=arguments,n=[],a=1;a<arguments.length;a++)n[a-1]=e[a];for(var o=0;o<n.length;o++)for(var s=n[o],u=-1;(u=i.call(t,s))>-1;)r.call(t,u,1);return t};});e(Pa);var Ra=n(function(t,e){e.__esModule=!0;var n=Array.prototype.splice;e.default=function(t,e){if(!la.default(t))return [];for(var r=t?e.length:0,i=r-1;r--;){var a=void 0,o=e[r];r!==i&&o===a||(a=o,n.call(t,o,1));}return t};});e(Ra);var Fa=n(function(t,e){e.__esModule=!0;e.default=function(t,e,n){if(!fa.default(t)&&!ba.default(t))return t;var r=n;return pa.default(t,function(t,n){r=e(r,t,n);}),r};});e(Fa);var Da=n(function(t,e){e.__esModule=!0;e.default=function(t,e){var n=[];if(!la.default(t))return n;for(var r=-1,i=[],a=t.length;++r<a;){var o=t[r];e(o,r,t)&&(n.push(o),i.push(r));}return Ra.default(t,i),n};});e(Da);var Ia=n(function(t,e){e.__esModule=!0,e.default=function(t){return ha.default(t,"String")};}),Na=e(Ia),Oa=n(function(t,e){e.__esModule=!0,e.default=function(t,e){var n;if(va.default(e))n=function(t,n){return e(t)-e(n)};else{var r=[];Ia.default(e)?r.push(e):fa.default(e)&&(r=e),n=function(t,e){for(var n=0;n<r.length;n+=1){var i=r[n];if(t[i]>e[i])return 1;if(t[i]<e[i])return -1}return 0};}return t.sort(n),t};});e(Oa);var Ua=n(function(t,e){e.__esModule=!0;e.default=function(t){var e=[];return pa.default(t,function(t){ca.default(e,t)||e.push(t);}),e};}),Ba=e(Ua),za=n(function(t,e){e.__esModule=!0;e.default=function(){for(var t=arguments,e=[],n=0;n<arguments.length;n++)e[n]=t[n];return Ua.default([].concat.apply([],e))};});e(za);var Ga=n(function(t,e){e.__esModule=!0,e.default=function(t,e){var n=[],r={};return t.forEach(function(t){var i=t[e];ya.default(i)||(fa.default(i)||(i=[i]),pa.default(i,function(t){r[t]||(n.push(t),r[t]=!0);}));}),n};});e(Ga);var ka=n(function(t,e){e.__esModule=!0,e.default=function(t){if(la.default(t))return t[0]};});e(ka);var Va=n(function(t,e){e.__esModule=!0,e.default=function(t){if(la.default(t))return t[t.length-1]};});e(Va);var Ha=n(function(t,e){e.__esModule=!0,e.default=function(t,e){return !(!fa.default(t)&&!Ia.default(t))&&t[0]===e};});e(Ha);var ja=n(function(t,e){e.__esModule=!0,e.default=function(t,e){return !(!fa.default(t)&&!Ia.default(t))&&t[t.length-1]===e};});e(ja);var Wa=n(function(t,e){e.__esModule=!0;e.default=function(t,e){for(var n=0;n<t.length;n++)if(!e(t[n],n))return !1;return !0};});e(Wa);var Xa=n(function(t,e){e.__esModule=!0;e.default=function(t,e){for(var n=0;n<t.length;n++)if(e(t[n],n))return !0;return !1};});e(Xa);var qa=n(function(t,e){e.__esModule=!0;var n=Object.prototype.hasOwnProperty;e.default=function(t,e){if(!e||!fa.default(t))return {};var r,i={},a=va.default(e)?e:function(t){return t[e]};return pa.default(t,function(t){r=a(t),n.call(i,r)?i[r].push(t):i[r]=[t];}),i};});e(qa);var Ya=n(function(t,e){e.__esModule=!0;e.default=function(t,e){if(!e)return {0:t};if(!va.default(e)){var n=fa.default(e)?e:e.replace(/\s+/g,"").split("*");e=function(t){for(var e="_",r=0,i=n.length;r<i;r++)e+=t[n[r]]&&t[n[r]].toString();return e};}return qa.default(t,e)};});e(Ya);var Za=n(function(t,e){e.__esModule=!0,e.default=function(t,e){if(!e)return [t];var n=Ya.default(t,e),r=[];for(var i in n)r.push(n[i]);return r};});e(Za);var Ja=n(function(t,e){e.__esModule=!0,e.default=function(t,e){return t["_wrap_"+e]};});e(Ja);var Qa=n(function(t,e){e.__esModule=!0,e.default=function(t,e){if(t["_wrap_"+e])return t["_wrap_"+e];var n=function(n){t[e](n);};return t["_wrap_"+e]=n,n};});e(Qa);var Ka=n(function(t,e){e.__esModule=!0;var n={};e.default=function(t){var e=n[t];if(!e){for(var r=t.toString(16),i=r.length;i<6;i++)r="0"+r;e="#"+r,n[t]=e;}return e};});e(Ka);var $a=n(function(t,e){e.__esModule=!0,e.default=function(t){var e=0,n=0,r=0,i=0;return fa.default(t)?1===t.length?e=n=r=i=t[0]:2===t.length?(e=r=t[0],n=i=t[1]):3===t.length?(e=t[0],n=i=t[1],r=t[2]):(e=t[0],n=t[1],r=t[2],i=t[3]):e=n=r=i=t,{r1:e,r2:n,r3:r,r4:i}};});e($a);var to=n(function(t,e){e.__esModule=!0;e.default=function(t,e,n){return t<e?e:t>n?n:t};});e(to);var eo=n(function(t,e){e.__esModule=!0;e.default=function(t,e){var n=e.toString(),r=n.indexOf(".");if(-1===r)return Math.round(t);var i=n.substr(r+1).length;return i>20&&(i=20),parseFloat(t.toFixed(i))};});e(eo);var no=n(function(t,e){e.__esModule=!0;e.default=function(t){return ha.default(t,"Number")};});e(no);var ro=n(function(t,e){e.__esModule=!0;e.default=function(t){return no.default(t)&&t%1!=0};});e(ro);var io=n(function(t,e){e.__esModule=!0;e.default=function(t){return no.default(t)&&t%2==0};});e(io);var ao=n(function(t,e){e.__esModule=!0;var n=Number.isInteger?Number.isInteger:function(t){return no.default(t)&&t%1==0};e.default=n;});e(ao);var oo=n(function(t,e){e.__esModule=!0;e.default=function(t){return no.default(t)&&t<0};});e(oo);var so=n(function(t,e){e.__esModule=!0;var n=1e-5;e.default=function(t,e,r){return void 0===r&&(r=n),Math.abs(t-e)<r};});e(so);var uo=n(function(t,e){e.__esModule=!0;e.default=function(t){return no.default(t)&&t%2!=0};});e(uo);var lo=n(function(t,e){e.__esModule=!0;e.default=function(t){return no.default(t)&&t>0};});e(lo);var co=n(function(t,e){e.__esModule=!0,e.default=function(t,e){if(fa.default(t)){var n,r,i=t[0];return n=va.default(e)?e(t[0]):t[0][e],pa.default(t,function(t){(r=va.default(e)?e(t):t[e])>n&&(i=t,n=r);}),i}};});e(co);var ho=n(function(t,e){e.__esModule=!0,e.default=function(t,e){if(fa.default(t)){var n,r,i=t[0];return n=va.default(e)?e(t[0]):t[0][e],pa.default(t,function(t){(r=va.default(e)?e(t):t[e])<n&&(i=t,n=r);}),i}};});e(ho);var fo=n(function(t,e){e.__esModule=!0;e.default=function(t,e){return (t%e+e)%e};});e(fo);var po=n(function(t,e){e.__esModule=!0;var n=180/Math.PI;e.default=function(t){return n*t};});e(po);var mo=n(function(t,e){e.__esModule=!0,e.default=parseInt;});e(mo);var go=n(function(t,e){e.__esModule=!0;var n=Math.PI/180;e.default=function(t){return n*t};});e(go);var vo=n(function(t,e){e.__esModule=!0,e.default=pa.default;});e(vo);var yo=n(function(t,e){e.__esModule=!0,e.default=function(t,e){return t.hasOwnProperty(e)};});e(yo);var _o=n(function(t,e){e.__esModule=!0,e.default=yo.default;});e(_o);var xo=n(function(t,e){e.__esModule=!0;var n=Object.values?function(t){return Object.values(t)}:function(t){var e=[];return pa.default(t,function(n,r){va.default(t)&&"prototype"===r||e.push(n);}),e};e.default=n;});e(xo);var Mo=n(function(t,e){e.__esModule=!0,e.default=function(t,e){return ca.default(xo.default(t),e)};});e(Mo);var bo=n(function(t,e){e.__esModule=!0,e.default=function(t){return ya.default(t)?"":t.toString()};});e(bo);var wo=n(function(t,e){e.__esModule=!0;e.default=function(t){return bo.default(t).toLowerCase()};});e(wo);var Eo=n(function(t,e){e.__esModule=!0;e.default=function(t){var e=bo.default(t);return e.charAt(0).toLowerCase()+e.substring(1)};});e(Eo);var So=n(function(t,e){e.__esModule=!0,e.default=function(t,e){return t&&e?t.replace(/\\?\{([^{}]+)\}/g,function(t,n){return "\\"===t.charAt(0)?t.slice(1):void 0===e[n]?"":e[n]}):t};});e(So);var To=n(function(t,e){e.__esModule=!0;e.default=function(t){return bo.default(t).toUpperCase()};});e(To);var Ao=n(function(t,e){e.__esModule=!0;e.default=function(t){var e=bo.default(t);return e.charAt(0).toUpperCase()+e.substring(1)};});e(Ao);var Lo=n(function(t,e){e.__esModule=!0;var n={}.toString;e.default=function(t){return n.call(t).replace(/^\[object /,"").replace(/]$/,"")};});e(Lo);var Co=n(function(t,e){e.__esModule=!0;e.default=function(t){return ha.default(t,"Arguments")};});e(Co);var Po=n(function(t,e){e.__esModule=!0;e.default=function(t){return ha.default(t,"Boolean")};});e(Po);var Ro=n(function(t,e){e.__esModule=!0;e.default=function(t){return ha.default(t,"Date")};});e(Ro);var Fo=n(function(t,e){e.__esModule=!0;e.default=function(t){return ha.default(t,"Error")};});e(Fo);var Do=n(function(t,e){e.__esModule=!0,e.default=function(t){return no.default(t)&&isFinite(t)};});e(Do);var Io=n(function(t,e){e.__esModule=!0;e.default=function(t){return null===t};});e(Io);var No=n(function(t,e){e.__esModule=!0;var n=Object.prototype;e.default=function(t){var e=t&&t.constructor;return t===("function"==typeof e&&e.prototype||n)};});e(No);var Oo=n(function(t,e){e.__esModule=!0;e.default=function(t){return ha.default(t,"RegExp")};});e(Oo);var Uo=n(function(t,e){e.__esModule=!0;e.default=function(t){return void 0===t};});e(Uo);var Bo=n(function(t,e){e.__esModule=!0;e.default=function(t){return t instanceof Element||t instanceof HTMLDocument};});e(Bo);var zo=n(function(t,e){e.__esModule=!0,e.default=function(t){return (window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.msRequestAnimationFrame||function(t){return setTimeout(t,16)})(t)};});e(zo);var Go=n(function(t,e){e.__esModule=!0,e.default=function(t){(window.cancelAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame||window.msCancelAnimationFrame||clearTimeout)(t);};});e(Go);var ko=n(function(t,e){function n(t,e){for(var n in e)e.hasOwnProperty(n)&&"constructor"!==n&&void 0!==e[n]&&(t[n]=e[n]);}e.__esModule=!0,e.default=function(t,e,r,i){return e&&n(t,e),r&&n(t,r),i&&n(t,i),t};});e(ko);var Vo=n(function(t,e){e.__esModule=!0;e.default=function(){for(var t=arguments,e=[],n=0;n<arguments.length;n++)e[n]=t[n];for(var r=e[0],i=1;i<e.length;i++){var a=e[i];va.default(a)&&(a=a.prototype),ko.default(r.prototype,a);}};});e(Vo);var Ho=n(function(t,e){e.__esModule=!0;var n=function(t){if("object"!=typeof t||null===t)return t;var e;if(fa.default(t)){e=[];for(var r=0,i=t.length;r<i;r++)"object"==typeof t[r]&&null!=t[r]?e[r]=n(t[r]):e[r]=t[r];}else for(var a in e={},t)"object"==typeof t[a]&&null!=t[a]?e[a]=n(t[a]):e[a]=t[a];return e};e.default=n;});e(Ho);var jo=n(function(t,e){e.__esModule=!0,e.default=function(t,e,n){var r;return function(){var i=this,a=arguments,o=n&&!r;clearTimeout(r),r=setTimeout(function(){r=null,n||t.apply(i,a);},e),o&&t.apply(i,a);}};});e(jo);var Wo=n(function(t,e){e.__esModule=!0;var n=function(){function t(){this.map={};}return t.prototype.has=function(t){return void 0!==this.map[t]},t.prototype.get=function(t,e){var n=this.map[t];return void 0===n?e:n},t.prototype.set=function(t,e){this.map[t]=e;},t.prototype.clear=function(){this.map={};},t.prototype.delete=function(t){delete this.map[t];},t.prototype.size=function(){return Object.keys(this.map).length},t}();e.default=n;});e(Wo);var Xo=n(function(t,e){e.__esModule=!0,e.default=function(t,e){if(!va.default(t))throw new TypeError("Expected a function");var n=function(){for(var r=arguments,i=[],a=0;a<arguments.length;a++)i[a]=r[a];var o=e?e.apply(this,i):i[0],s=n.cache;if(s.has(o))return s.get(o);var u=t.apply(this,i);return s.set(o,u),u};return n.cache=new Wo.default,n};});e(Xo);var qo=n(function(t,e){e.__esModule=!0;var n=5;function r(t,e,i,a){for(var o in i=i||0,a=a||n,e)if(e.hasOwnProperty(o)){var s=e[o];null!==s&&ba.default(s)?(ba.default(t[o])||(t[o]={}),i<a?r(t[o],s,i+1,a):t[o]=e[o]):fa.default(s)?(t[o]=[],t[o]=t[o].concat(s)):void 0!==s&&(t[o]=s);}}e.default=function(t){for(var e=arguments,n=[],i=1;i<arguments.length;i++)n[i-1]=e[i];for(var a=0;a<n.length;a+=1)r(t,n[a]);return t};}),Yo=e(qo),Zo=n(function(t,e){e.__esModule=!0;e.default=function(t,e,n,r){va.default(e)||(n=e,e=t,t=function(){});var i=Object.create?function(t,e){return Object.create(t,{constructor:{value:e}})}:function(t,e){function n(){}n.prototype=t;var r=new n;return r.constructor=e,r},a=i(e.prototype,t);return t.prototype=ko.default(a,t.prototype),t.superclass=i(e.prototype,e),ko.default(a,n),ko.default(t,r),t};});e(Zo);var Jo=n(function(t,e){e.__esModule=!0;e.default=function(t,e){if(!la.default(t))return -1;var n=Array.prototype.indexOf;if(n)return n.call(t,e);for(var r=-1,i=0;i<t.length;i++)if(t[i]===e){r=i;break}return r};});e(Jo);var Qo=n(function(t,e){e.__esModule=!0;var n=Object.prototype.hasOwnProperty;e.default=function(t){if(ya.default(t))return !0;if(la.default(t))return !t.length;var e=Lo.default(t);if("Map"===e||"Set"===e)return !t.size;if(No.default(t))return !Object.keys(t).length;for(var r in t)if(n.call(t,r))return !1;return !0};});e(Qo);var Ko=n(function(t,e){e.__esModule=!0;var n=function(t,e){if(t===e)return !0;if(!t||!e)return !1;if(Ia.default(t)||Ia.default(e))return !1;if(la.default(t)||la.default(e)){if(t.length!==e.length)return !1;for(var r=!0,i=0;i<t.length&&(r=n(t[i],e[i]));i++);return r}if(Ma.default(t)||Ma.default(e)){var a=Object.keys(t),o=Object.keys(e);if(a.length!==o.length)return !1;for(r=!0,i=0;i<a.length&&(r=n(t[a[i]],e[a[i]]));i++);return r}return !1};e.default=n;});e(Ko);var $o=n(function(t,e){e.__esModule=!0,e.default=function(t,e,n){return va.default(n)?!!n(t,e):Ko.default(t,e)};});e($o);var ts=n(function(t,e){e.__esModule=!0;e.default=function(t,e){if(!la.default(t))return t;var n=[];return pa.default(t,function(t,r){n.push(e(t,r));}),n};});e(ts);var es=n(function(t,e){e.__esModule=!0;var n=function(t){return t};e.default=function(t,e){void 0===e&&(e=n);var r={};return da.default(t)&&!ya.default(t)&&Object.keys(t).forEach(function(n){r[n]=e(t[n],n);}),r};});e(es);var ns=n(function(t,e){e.__esModule=!0,e.default=function(t,e,n){for(var r=0,i=Ia.default(e)?e.split("."):e;t&&r<i.length;)t=t[i[r++]];return void 0===t||r<i.length?n:t};});e(ns);var rs=n(function(t,e){e.__esModule=!0,e.default=function(t,e,n){var r=t,i=Ia.default(e)?e.split("."):e;return i.forEach(function(t,e){e<i.length-1?(da.default(r[t])||(r[t]=no.default(i[e+1])?[]:{}),r=r[t]):r[t]=n;}),t};});e(rs);var is=n(function(t,e){e.__esModule=!0;var n=Object.prototype.hasOwnProperty;e.default=function(t,e){if(null===t||!ba.default(t))return {};var r={};return pa.default(e,function(e){n.call(t,e)&&(r[e]=t[e]);}),r};});e(is);var as=n(function(t,e){e.__esModule=!0,e.default=function(t,e,n){var r,i,a,o,s=0;n||(n={});var u=function(){s=!1===n.leading?0:Date.now(),r=null,o=t.apply(i,a),r||(i=a=null);},l=function(){var l=Date.now();s||!1!==n.leading||(s=l);var c=e-(l-s);return i=this,a=arguments,c<=0||c>e?(r&&(clearTimeout(r),r=null),s=l,o=t.apply(i,a),r||(i=a=null)):r||!1===n.trailing||(r=setTimeout(u,c)),o};return l.cancel=function(){clearTimeout(r),s=0,r=i=a=null;},l};});e(as);var os=n(function(t,e){e.__esModule=!0,e.default=function(t){return la.default(t)?Array.prototype.slice.call(t):[]};});e(os);var ss=n(function(t,e){e.__esModule=!0;var n={};e.default=function(t){return n[t=t||"g"]?n[t]+=1:n[t]=1,t+n[t]};});e(ss);var us=n(function(t,e){e.__esModule=!0,e.default=function(){};});e(us);var ls=n(function(t,e){e.__esModule=!0,e.default=function(t){return t};});e(ls);var cs=n(function(t,e){e.__esModule=!0,e.default=function(t){return ya.default(t)?0:la.default(t)?t.length:Object.keys(t).length};});e(cs);var hs=n(function(t,e){e.__esModule=!0,e.contains=ca.default,e.includes=ca.default,e.difference=ga.default,e.find=wa.default,e.findIndex=Ea.default,e.firstValue=Sa.default,e.flatten=Ta.default,e.flattenDeep=La.default,e.getRange=Ca.default,e.pull=Pa.default,e.pullAt=Ra.default,e.reduce=Fa.default,e.remove=Da.default,e.sortBy=Oa.default,e.union=za.default,e.uniq=Ua.default,e.valuesOfKey=Ga.default,e.head=ka.default,e.last=Va.default,e.startsWith=Ha.default,e.endsWith=ja.default,e.filter=ma.default,e.every=Wa.default,e.some=Xa.default,e.group=Za.default,e.groupBy=qa.default,e.groupToMap=Ya.default,e.getWrapBehavior=Ja.default,e.wrapBehavior=Qa.default,e.number2color=Ka.default,e.parseRadius=$a.default,e.clamp=to.default,e.fixedBase=eo.default,e.isDecimal=ro.default,e.isEven=io.default,e.isInteger=ao.default,e.isNegative=oo.default,e.isNumberEqual=so.default,e.isOdd=uo.default,e.isPositive=lo.default,e.maxBy=co.default,e.minBy=ho.default,e.mod=fo.default,e.toDegree=po.default,e.toInteger=mo.default,e.toRadian=go.default,e.forIn=vo.default,e.has=yo.default,e.hasKey=_o.default,e.hasValue=Mo.default,e.keys=_a.default,e.isMatch=xa.default,e.values=xo.default,e.lowerCase=wo.default,e.lowerFirst=Eo.default,e.substitute=So.default,e.upperCase=To.default,e.upperFirst=Ao.default,e.getType=Lo.default,e.isArguments=Co.default,e.isArray=fa.default,e.isArrayLike=la.default,e.isBoolean=Po.default,e.isDate=Ro.default,e.isError=Fo.default,e.isFunction=va.default,e.isFinite=Do.default,e.isNil=ya.default,e.isNull=Io.default,e.isNumber=no.default,e.isObject=da.default,e.isObjectLike=Ma.default,e.isPlainObject=ba.default,e.isPrototype=No.default,e.isRegExp=Oo.default,e.isString=Ia.default,e.isType=ha.default,e.isUndefined=Uo.default,e.isElement=Bo.default,e.requestAnimationFrame=zo.default,e.clearAnimationFrame=Go.default,e.augment=Vo.default,e.clone=Ho.default,e.debounce=jo.default,e.memoize=Xo.default,e.deepMix=qo.default,e.each=pa.default,e.extend=Zo.default,e.indexOf=Jo.default,e.isEmpty=Qo.default,e.isEqual=Ko.default,e.isEqualWith=$o.default,e.map=ts.default,e.mapValues=es.default,e.mix=ko.default,e.assign=ko.default,e.get=ns.default,e.set=rs.default,e.pick=is.default,e.throttle=as.default,e.toArray=os.default,e.toString=bo.default,e.uniqueId=ss.default,e.noop=us.default,e.identity=ls.default,e.size=cs.default,e.Cache=Wo.default;}),fs=e(hs),ds=hs.contains,ps=hs.includes,ms=hs.difference,gs=hs.find,vs=hs.findIndex,ys=hs.firstValue,_s=hs.flatten,xs=hs.flattenDeep,Ms=hs.getRange,bs=hs.pull,ws=hs.pullAt,Es=hs.reduce,Ss=hs.remove,Ts=hs.sortBy,As=hs.union,Ls=hs.uniq,Cs=hs.valuesOfKey,Ps=hs.head,Rs=hs.last,Fs=hs.startsWith,Ds=hs.endsWith,Is=hs.filter,Ns=hs.every,Os=hs.some,Us=hs.group,Bs=hs.groupBy,zs=hs.groupToMap,Gs=hs.getWrapBehavior,ks=hs.wrapBehavior,Vs=hs.number2color,Hs=hs.parseRadius,js=hs.clamp,Ws=hs.fixedBase,Xs=hs.isDecimal,qs=hs.isEven,Ys=hs.isInteger,Zs=hs.isNegative,Js=hs.isNumberEqual,Qs=hs.isOdd,Ks=hs.isPositive,$s=hs.maxBy,tu=hs.minBy,eu=hs.mod,nu=hs.toDegree,ru=hs.toInteger,iu=hs.toRadian,au=hs.forIn,ou=hs.has,su=hs.hasKey,uu=hs.hasValue,lu=hs.keys,cu=hs.isMatch,hu=hs.values,fu=hs.lowerCase,du=hs.lowerFirst,pu=hs.substitute,mu=hs.upperCase,gu=hs.upperFirst,vu=hs.getType,yu=hs.isArguments,_u=hs.isArray,xu=hs.isArrayLike,Mu=hs.isBoolean,bu=hs.isDate,wu=hs.isError,Eu=hs.isFunction,Su=hs.isFinite,Tu=hs.isNil,Au=hs.isNull,Lu=hs.isNumber,Cu=hs.isObject,Pu=hs.isObjectLike,Ru=hs.isPlainObject,Fu=hs.isPrototype,Du=hs.isRegExp,Iu=hs.isString,Nu=hs.isType,Ou=hs.isUndefined,Uu=hs.isElement,Bu=hs.requestAnimationFrame,zu=hs.clearAnimationFrame,Gu=hs.augment,ku=hs.clone,Vu=hs.debounce,Hu=hs.memoize,ju=hs.deepMix,Wu=hs.each,Xu=hs.extend,qu=hs.indexOf,Yu=hs.isEmpty,Zu=hs.isEqual,Ju=hs.isEqualWith,Qu=hs.map,Ku=hs.mapValues,$u=hs.mix,tl=hs.assign,el=hs.get,nl=hs.set,rl=hs.pick,il=hs.throttle,al=hs.toArray,ol=hs.uniqueId,sl=hs.noop,ul=hs.identity,ll=hs.size,cl=hs.Cache,hl=Object.freeze({__proto__:null,default:fs,__moduleExports:hs,contains:ds,includes:ps,difference:ms,find:gs,findIndex:vs,firstValue:ys,flatten:_s,flattenDeep:xs,getRange:Ms,pull:bs,pullAt:ws,reduce:Es,remove:Ss,sortBy:Ts,union:As,uniq:Ls,valuesOfKey:Cs,head:Ps,last:Rs,startsWith:Fs,endsWith:Ds,filter:Is,every:Ns,some:Os,group:Us,groupBy:Bs,groupToMap:zs,getWrapBehavior:Gs,wrapBehavior:ks,number2color:Vs,parseRadius:Hs,clamp:js,fixedBase:Ws,isDecimal:Xs,isEven:qs,isInteger:Ys,isNegative:Zs,isNumberEqual:Js,isOdd:Qs,isPositive:Ks,maxBy:$s,minBy:tu,mod:eu,toDegree:nu,toInteger:ru,toRadian:iu,forIn:au,has:ou,hasKey:su,hasValue:uu,keys:lu,isMatch:cu,values:hu,lowerCase:fu,lowerFirst:du,substitute:pu,upperCase:mu,upperFirst:gu,getType:vu,isArguments:yu,isArray:_u,isArrayLike:xu,isBoolean:Mu,isDate:bu,isError:wu,isFunction:Eu,isFinite:Su,isNil:Tu,isNull:Au,isNumber:Lu,isObject:Cu,isObjectLike:Pu,isPlainObject:Ru,isPrototype:Fu,isRegExp:Du,isString:Iu,isType:Nu,isUndefined:Ou,isElement:Uu,requestAnimationFrame:Bu,clearAnimationFrame:zu,augment:Gu,clone:ku,debounce:Vu,memoize:Hu,deepMix:ju,each:Wu,extend:Xu,indexOf:qu,isEmpty:Yu,isEqual:Zu,isEqualWith:Ju,map:Qu,mapValues:Ku,mix:$u,assign:tl,get:el,set:nl,pick:rl,throttle:il,toArray:al,uniqueId:ol,noop:sl,identity:ul,size:ll,Cache:cl}),fl=Object.assign({},{assign:$u,merge:ju,cloneDeep:ku,isFinite:isFinite,isNaN:isNaN,snapEqual:Js,remove:bs,inArray:ds},hl);fl.Array={groupToMap:zs,group:Us,merge:fl.merge,values:Cs,getRange:Ms,firstValue:ys,remove:bs};var dl=function(t){function e(e){t.call(this);var n={visible:!0},r=this.getDefaultCfg();this._attrs=n,fl.assign(n,r,e);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){return {}},e.prototype.get=function(t){return this._attrs[t]},e.prototype.set=function(t,e){this._attrs[t]=e;},e.prototype.destroy=function(){this._attrs={},this.removeAllListeners(),this.destroyed=!0;},e}(r),pl={version:"v"+"1.4.13",scene:{mapType:"AMAP",zoom:5,center:[107.622,39.266],minZoom:3,maxZoom:18,pitch:0,hash:!1,zoomControl:!0,scaleControl:!0,attributionControl:!0},animate:!0,height:0,activeColor:"#2f54eb",colors:["rgb(103,0,31)","rgb(178,24,43)","rgb(214,96,77)","rgb(244,165,130)","rgb(253,219,199)","rgb(247,247,247)","rgb(209,229,240)","rgb(146,197,222)","rgb(67,147,195)","rgb(33,102,172)","rgb(5,48,97)"],size:1e4,shape:"circle",pattern:"",snapArray:[0,1,2,4,5,10],pointShape:{"2d":["circle","triangle","square","pentagon","hexagon","octogon","hexagram","rhombus","vesica"],"3d":["cylinder","triangleColumn","hexagonColumn","squareColumn"]},sdfHomeUrl:"https://sdf.amap.com",scales:{},textStyle:{fontSize:12,fill:"#ccc",textBaseline:"middle",fontFamily:'"-apple-system", BlinkMacSystemFont, "Segoe UI", Roboto,"Helvetica Neue", Helvetica, "PingFang SC", "Hiragino Sans GB", "Microsoft YaHei",SimSun, "sans-serif"',textAlign:"center"}},ml=function(t){var e=this.getDefaultCfg();fl.mix(this,e,t),this.init();};ml.prototype.getDefaultCfg=function(){return {type:"base",formatter:null,range:[0,1],ticks:null,values:[]}},ml.prototype.init=function(){},ml.prototype.getTicks=function(){var t=this,e=t.ticks,n=[];return fl.each(e,function(e){var r;r=fl.isObject(e)?e:{text:t.getText(e),tickValue:e,value:t.scale(e)},n.push(r);}),n},ml.prototype.getText=function(t){var e=this.formatter;return t=e?e(t):t,!fl.isNil(t)&&t.toString||(t=""),t.toString()},ml.prototype.rangeMin=function(){return this.range[0]},ml.prototype.rangeMax=function(){var t=this.range;return t[t.length-1]},ml.prototype.invert=function(t){return t},ml.prototype.translate=function(t){return t},ml.prototype.scale=function(t){return t},ml.prototype.clone=function(){var t=this,e=t.constructor,n={};return fl.each(t,function(e,r){n[r]=t[r];}),new e(n)},ml.prototype.change=function(t){return this.ticks=null,fl.mix(this,t),this.init(),this};var gl=12;function vl(t,e){var n=t.length;if(0===n)return NaN;var r=t[0];if(e<t[0])return NaN;if(e>=t[n-1])return t[n-1];for(var i=1;i<t.length&&!(e<t[i]);i++)r=t[i];return r}function yl(t,e){var n,r=t.length;if(0===r)return NaN;if(e>t[r-1])return NaN;if(e<t[0])return t[0];for(var i=1;i<t.length;i++)if(e<=t[i]){n=t[i];break}return n}var _l={snapFactorTo:function(t,e,n){if(isNaN(t))return NaN;var r=1;if(0!==t){t<0&&(r=-1);var i=function(t){var e=1;if(t===1/0||t===-1/0)throw new Error("Not support Infinity!");if(t<1){for(var n=0;t<1;)e/=10,t*=10,n++;e.toString().length>gl&&(e=parseFloat(e.toFixed(n)));}else for(;t>10;)e*=10,t/=10;return e}(t*=r);r*=i,t/=i;}var a=(t="floor"===n?_l.snapFloor(e,t):"ceil"===n?_l.snapCeiling(e,t):_l.snapTo(e,t))*r;Math.abs(r)<1&&a.toString().length>gl&&(a=t/parseInt(1/r)*(r>0?1:-1));return a},snapMultiple:function(t,e,n){return ("ceil"===n?Math.ceil(t/e):"floor"===n?Math.floor(t/e):Math.round(t/e))*e},snapTo:function(t,e){var n=vl(t,e),r=yl(t,e);if(isNaN(n)||isNaN(r)){if(t[0]>=e)return t[0];var i=t[t.length-1];if(i<=e)return i}return Math.abs(e-n)<Math.abs(r-e)?n:r},snapFloor:function(t,e){return vl(t,e)},snapCeiling:function(t,e){return yl(t,e)}},xl=5,Ml=7;var bl=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){var e=t.prototype.getDefaultCfg.call(this);return fl.mix({},e,{type:"linear",isLinear:!0,min:null,minLimit:null,max:null,maxLimit:null,nice:!1,tickCount:null,tickInterval:null,snapArray:null})},e.prototype.init=function(){if(this.ticks){var t=this.ticks,e=this.translate(t[0]),n=this.translate(t[t.length-1]);(fl.isNil(this.min)||this.min>e)&&(this.min=e),(fl.isNil(this.max)||this.max<n)&&(this.max=n);}else this.min=this.translate(this.min),this.max=this.translate(this.max),this.initTicks();},e.prototype.calculateTicks=function(){var t=this.min,e=this.max,n=this.tickCount,r=this.tickInterval;if(e<t)throw new Error("max: "+e+" should not be less than min: "+t);return function(t){var e=t.min,n=t.max,r=t.interval,i=[],a=t.minCount||xl,o=t.maxCount||Ml,s=a===o,u=fl.isNil(t.minLimit)?-1/0:t.minLimit,l=fl.isNil(t.maxLimit)?1/0:t.maxLimit,c=(a+o)/2,h=c,f=t.snapArray?t.snapArray:s?pl.snapCountArray:pl.snapArray;if(e===u&&n===l&&s&&(r=(n-e)/(h-1)),fl.isNil(e)&&(e=0),fl.isNil(n)&&(n=0),n===e&&(0===e?n=1:e>0?e=0:n=0,n-e<5&&!r&&n-e>=1&&(r=1)),fl.isNil(r)){var d=(n-e)/(c-1);r=_l.snapFactorTo(d,f,"ceil"),o!==a&&((h=parseInt((n-e)/r,10))>o&&(h=o),h<a&&(h=a),r=_l.snapFactorTo((n-e)/(h-1),f,"floor"));}if(t.interval||o!==a)n=Math.min(_l.snapMultiple(n,r,"ceil"),l),e=Math.max(_l.snapMultiple(e,r,"floor"),u),h=Math.round((n-e)/r),e=fl.fixedBase(e,r),n=fl.fixedBase(n,r);else{c=parseInt(c,10);var p,m=(n+e)/2,g=_l.snapMultiple(m,r,"ceil"),v=Math.floor((c-2)/2),y=g+v*r;y<n&&(y+=r),(p=c%2==0?g-v*r:g-(v+1)*r)>e&&(p-=r),n=fl.fixedBase(y,r),e=fl.fixedBase(p,r);}n=Math.min(n,l),e=Math.max(e,u),i.push(e);for(var _=1;_<h;_++){var x=fl.fixedBase(r*_+e,r);x<n&&i.push(x);}return i[i.length-1]<n&&i.push(n),{min:e,max:n,interval:r,count:h,ticks:i}}({min:t,max:e,minLimit:this.minLimit,maxLimit:this.maxLimit,minCount:n,maxCount:n,interval:r,snapArray:this.snapArray}).ticks},e.prototype.initTicks=function(){var t=this,e=t.calculateTicks();if(t.nice)t.ticks=e,t.min=e[0],t.max=e[e.length-1];else{var n=[];fl.each(e,function(e){e>=t.min&&e<=t.max&&n.push(e);}),n.length||(n.push(t.min),n.push(t.max)),t.ticks=n;}},e.prototype.scale=function(t){if(null==t)return NaN;var e=this.max,n=this.min;if(e===n)return 0;var r=Math.min(1,Math.max(0,(t-n)/(e-n))),i=this.rangeMin();return i+r*(this.rangeMax()-i)},e.prototype.invert=function(t){var e=(t-this.rangeMin())/(this.rangeMax()-this.rangeMin());return this.min+e*(this.max-this.min)},e}(ml),wl=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){var e=t.prototype.getDefaultCfg.call(this);return fl.mix({},e,{isIdentity:!0,type:"identity",value:null})},e.prototype.getText=function(){return this.value.toString()},e.prototype.scale=function(t){return this.value!==t&&fl.isNumber(t)?t:this.range[0]},e.prototype.invert=function(){return this.value},e}(ml),El=8,Sl=4;function Tl(t){var e,n,r={},i=[],a=t.maxCount||El,o=(e=t.data,n=[],fl.each(e,function(t){fl.isArray(t)?n=n.concat(t):n.push(t);}),n),s=o.length,u=function(t,e){var n;for(n=e;n>0&&t%n!=0;n--);if(1===n)for(n=e;n>0&&(t-1)%n!=0;n--);return n}(s-1,a-1)+1;2===u?u=a:u<a-Sl&&(u=a-Sl);var l=parseInt(s/(u-1),10),c=o.map(function(t,e){return e%l==0?o.slice(e,e+l):null}).filter(function(t){return t});o.length&&i.push(o[0]);for(var h=1;h<c.length&&h*l<s-l;h++)i.push(c[h][0]);if(o.length){var f=o[s-1];-1===i.indexOf(f)&&i.push(f);}return r.categories=o,r.ticks=i,r}var Al=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){var e=t.prototype.getDefaultCfg.call(this);return fl.mix({},e,{type:"cat",tickCount:null,isCategory:!0})},e.prototype.init=function(){var t=this.values,e=this.tickCount;if(fl.each(t,function(e,n){t[n]=e.toString();}),!this.ticks){var n=t;if(e)n=Tl({maxCount:e,data:t}).ticks;this.ticks=n;}},e.prototype.getText=function(e){return -1===this.values.indexOf(e)&&fl.isNumber(e)&&(e=this.values[Math.round(e)]),t.prototype.getText.call(this,e)},e.prototype.translate=function(t){var e=this.values.indexOf(t);return -1===e&&fl.isNumber(t)?e=t:-1===e&&(e=NaN),e},e.prototype.scale=function(t){var e=this.rangeMin(),n=this.rangeMax();return (fl.isString(t)||-1!==this.values.indexOf(t))&&(t=this.translate(t)),e+(this.values.length>1?t/(this.values.length-1):t)*(n-e)},e.prototype.invert=function(t){if(fl.isString(t))return t;var e=this.rangeMin(),n=this.rangeMax();t<e&&(t=e),t>n&&(t=n);var r=(t-e)/(n-e),i=Math.round(r*(this.values.length-1))%this.values.length;return i=i||0,this.values[i]},e}(ml),Ll=6,Cl=[1,2,4,6,8,12],Pl=6e4,Rl=36e5,Fl=864e5;function Dl(t){return new Date(t).getFullYear()}function Il(t){return new Date(t,0,1).getTime()}function Nl(t){return new Date(t).getMonth()}function Ol(t,e){return new Date(t,e,1).getTime()}function Ul(t){var e,n=t.minInterval,r=[],i=t.min,a=t.max,o=t.interval;if(a===i&&(a=i+Fl),fl.isNil(o)){var s=Fl,u=365*s;o=parseInt((a-i)/(t.maxCount||Ll),10),n&&n>o&&(o=n);var l=o/u,c=Dl(i);if(l>.51){for(var h=Math.ceil(l),f=Dl(a),d=c;d<=f+h;d+=h)r.push(Il(d));o=null;}else if(l>.0834){for(var p=Math.ceil(l/.0834),m=Nl(i),g=function(t,e){var n=Dl(t),r=Dl(e),i=Nl(t);return 12*(r-n)+(Nl(e)-i)%12}(i,a),v=0;v<=g+p;v+=p)r.push(Ol(c,v+m));o=null;}else if(o>.5*s){var y=new Date(i),_=y.getFullYear(),x=y.getMonth(i),M=y.getDate(),b=Math.ceil(o/s),w=function(t,e){return Math.ceil((e-t)/Fl)}(i,a);o=b*s;for(var E=0;E<w+b;E+=b)r.push(new Date(_,x,M+E).getTime());}else if(o>Rl){var S=new Date(i),T=S.getFullYear(),A=S.getMonth(i),L=S.getDate(),C=S.getHours(),P=_l.snapTo(Cl,Math.ceil(o/Rl)),R=function(t,e){return Math.ceil((e-t)/Rl)}(i,a);o=P*Rl;for(var F=0;F<=R+P;F+=P)r.push(new Date(T,A,L,C+F).getTime());}else if(o>Pl){var D=function(t,e){return Math.ceil((e-t)/6e4)}(i,a),I=Math.ceil(o/Pl);o=I*Pl;for(var N=0;N<=D+I;N+=I)r.push(i+N*Pl);}else{o<1e3&&(o=1e3),i=1e3*Math.floor(i/1e3);var O=Math.ceil((a-i)/1e3),U=Math.ceil(o/1e3);o=1e3*U;for(var B=0;B<O+U;B+=U)r.push(i+1e3*B);}}if(!r.length){i=1e3*Math.floor(i/1e3),e=((a=1e3*Math.ceil(a/1e3))-i)/o;for(var z=0;z<=e;z++)r.push(fl.fixedBase(o*z+i,o));}return {max:a,min:i,interval:o,ticks:r,count:r.length}}var Bl=n(function(t){!function(e){var n={},r=/d{1,4}|M{1,4}|YY(?:YY)?|S{1,3}|Do|ZZ|([HhMsDm])\1?|[aA]|"[^"]*"|'[^']*'/g,i=/\d\d?/,a=/[0-9]*['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+|[\u0600-\u06FF\/]+(\s*?[\u0600-\u06FF]+){1,2}/i,o=/\[([^]*?)\]/gm,s=function(){};function u(t,e){for(var n=[],r=0,i=t.length;r<i;r++)n.push(t[r].substr(0,e));return n}function l(t){return function(e,n,r){var i=r[t].indexOf(n.charAt(0).toUpperCase()+n.substr(1).toLowerCase());~i&&(e.month=i);}}function c(t,e){for(t=String(t),e=e||2;t.length<e;)t="0"+t;return t}var h=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],f=["January","February","March","April","May","June","July","August","September","October","November","December"],d=u(f,3),p=u(h,3);n.i18n={dayNamesShort:p,dayNames:h,monthNamesShort:d,monthNames:f,amPm:["am","pm"],DoFn:function(t){return t+["th","st","nd","rd"][t%10>3?0:(t-t%10!=10)*t%10]}};var m={D:function(t){return t.getDate()},DD:function(t){return c(t.getDate())},Do:function(t,e){return e.DoFn(t.getDate())},d:function(t){return t.getDay()},dd:function(t){return c(t.getDay())},ddd:function(t,e){return e.dayNamesShort[t.getDay()]},dddd:function(t,e){return e.dayNames[t.getDay()]},M:function(t){return t.getMonth()+1},MM:function(t){return c(t.getMonth()+1)},MMM:function(t,e){return e.monthNamesShort[t.getMonth()]},MMMM:function(t,e){return e.monthNames[t.getMonth()]},YY:function(t){return String(t.getFullYear()).substr(2)},YYYY:function(t){return c(t.getFullYear(),4)},h:function(t){return t.getHours()%12||12},hh:function(t){return c(t.getHours()%12||12)},H:function(t){return t.getHours()},HH:function(t){return c(t.getHours())},m:function(t){return t.getMinutes()},mm:function(t){return c(t.getMinutes())},s:function(t){return t.getSeconds()},ss:function(t){return c(t.getSeconds())},S:function(t){return Math.round(t.getMilliseconds()/100)},SS:function(t){return c(Math.round(t.getMilliseconds()/10),2)},SSS:function(t){return c(t.getMilliseconds(),3)},a:function(t,e){return t.getHours()<12?e.amPm[0]:e.amPm[1]},A:function(t,e){return t.getHours()<12?e.amPm[0].toUpperCase():e.amPm[1].toUpperCase()},ZZ:function(t){var e=t.getTimezoneOffset();return (e>0?"-":"+")+c(100*Math.floor(Math.abs(e)/60)+Math.abs(e)%60,4)}},g={D:[i,function(t,e){t.day=e;}],Do:[new RegExp(i.source+a.source),function(t,e){t.day=parseInt(e,10);}],M:[i,function(t,e){t.month=e-1;}],YY:[i,function(t,e){var n=+(""+(new Date).getFullYear()).substr(0,2);t.year=""+(e>68?n-1:n)+e;}],h:[i,function(t,e){t.hour=e;}],m:[i,function(t,e){t.minute=e;}],s:[i,function(t,e){t.second=e;}],YYYY:[/\d{4}/,function(t,e){t.year=e;}],S:[/\d/,function(t,e){t.millisecond=100*e;}],SS:[/\d{2}/,function(t,e){t.millisecond=10*e;}],SSS:[/\d{3}/,function(t,e){t.millisecond=e;}],d:[i,s],ddd:[a,s],MMM:[a,l("monthNamesShort")],MMMM:[a,l("monthNames")],a:[a,function(t,e,n){var r=e.toLowerCase();r===n.amPm[0]?t.isPm=!1:r===n.amPm[1]&&(t.isPm=!0);}],ZZ:[/([\+\-]\d\d:?\d\d|Z)/,function(t,e){"Z"===e&&(e="+00:00");var n,r=(e+"").match(/([\+\-]|\d\d)/gi);r&&(n=60*r[1]+parseInt(r[2],10),t.timezoneOffset="+"===r[0]?n:-n);}]};g.dd=g.d,g.dddd=g.ddd,g.DD=g.D,g.mm=g.m,g.hh=g.H=g.HH=g.h,g.MM=g.M,g.ss=g.s,g.A=g.a,n.masks={default:"ddd MMM DD YYYY HH:mm:ss",shortDate:"M/D/YY",mediumDate:"MMM D, YYYY",longDate:"MMMM D, YYYY",fullDate:"dddd, MMMM D, YYYY",shortTime:"HH:mm",mediumTime:"HH:mm:ss",longTime:"HH:mm:ss.SSS"},n.format=function(t,e,i){var a=i||n.i18n;if("number"==typeof t&&(t=new Date(t)),"[object Date]"!==Object.prototype.toString.call(t)||isNaN(t.getTime()))throw new Error("Invalid Date in fecha.format");e=n.masks[e]||e||n.masks.default;var s=[];return (e=(e=e.replace(o,function(t,e){return s.push(e),"??"})).replace(r,function(e){return e in m?m[e](t,a):e.slice(1,e.length-1)})).replace(/\?\?/g,function(){return s.shift()})},n.parse=function(t,e,i){var a=i||n.i18n;if("string"!=typeof e)throw new Error("Invalid format in fecha.parse");if(e=n.masks[e]||e,t.length>1e3)return !1;var o=!0,s={};if(e.replace(r,function(e){if(g[e]){var n=g[e],r=t.search(n[0]);~r?t.replace(n[0],function(e){return n[1](s,e,a),t=t.substr(r+e.length),e}):o=!1;}return g[e]?"":e.slice(1,e.length-1)}),!o)return !1;var u,l=new Date;return !0===s.isPm&&null!=s.hour&&12!=+s.hour?s.hour=+s.hour+12:!1===s.isPm&&12==+s.hour&&(s.hour=0),null!=s.timezoneOffset?(s.minute=+(s.minute||0)-+s.timezoneOffset,u=new Date(Date.UTC(s.year||l.getFullYear(),s.month||0,s.day||1,s.hour||0,s.minute||0,s.second||0,s.millisecond||0))):u=new Date(s.year||l.getFullYear(),s.month||0,s.day||1,s.hour||0,s.minute||0,s.second||0,s.millisecond||0),u},t.exports?t.exports=n:e.fecha=n;}(this);}),zl=function(t){return fl.isString(t)&&(t=t.indexOf("T")>0?new Date(t).getTime():new Date(t.replace(/-/gi,"/")).getTime()),fl.isDate(t)&&(t=t.getTime()),t},Gl=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){var e=t.prototype.getDefaultCfg.call(this);return fl.mix({},e,{type:"time",mask:"YYYY-MM-DD"})},e.prototype.init=function(){var e=this,n=e.values;if(n&&n.length){var r=[],i=1/0,a=i,o=0;fl.each(n,function(t){var n=e._toTimeStamp(t);if(isNaN(n))throw new TypeError("Invalid Time: "+t);i>n?(a=i,i=n):a>n&&(a=n),o<n&&(o=n),r.push(n);}),n.length>1&&(e.minTickInterval=a-i),(fl.isNil(e.min)||e._toTimeStamp(e.min)>i)&&(e.min=i),(fl.isNil(e.max)||e._toTimeStamp(e.max)<o)&&(e.max=o);}t.prototype.init.call(this);},e.prototype.calculateTicks=function(){var t=this.min,e=this.max,n=this.tickCount;return Ul({min:t,max:e,minCount:n,maxCount:n,interval:this.tickInterval,minInterval:this.minTickInterval}).ticks},e.prototype.getText=function(t){var e=this.formatter;return t=this.translate(t),t=e?e(t):Bl.format(t,this.mask)},e.prototype.scale=function(e){return fl.isString(e)&&(e=this.translate(e)),t.prototype.scale.call(this,e)},e.prototype.translate=function(t){return this._toTimeStamp(t)},e.prototype._toTimeStamp=function(t){return zl(t)},e}(bl),kl=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){var e=t.prototype.getDefaultCfg.call(this);return fl.mix({},e,{type:"timeCat",mask:"YYYY-MM-DD",tickCount:7})},e.prototype.init=function(){var t=this,e=this.values;fl.each(e,function(n,r){e[r]=t._toTimeStamp(n);}),e.sort(function(t,e){return t-e}),t.ticks||(t.ticks=this.calculateTicks(!1));},e.prototype.calculateTicks=function(t){var e,n=this,r=n.tickCount;if(r){var i=Tl({maxCount:r,data:n.values});e=i.ticks;}else e=n.values;return t&&fl.each(e,function(t,r){e[r]=Bl.format(t,n.mask);}),e},e.prototype.translate=function(t){t=this._toTimeStamp(t);var e=this.values.indexOf(t);return -1===e&&(e=fl.isNumber(t)&&t<this.values.length?t:NaN),e},e.prototype.scale=function(t){var e=this.rangeMin(),n=this.rangeMax(),r=this.translate(t);return e+(1===this.values.length?r:r>-1?r/(this.values.length-1):0)*(n-e)},e.prototype.getText=function(t){var e="",n=this.translate(t);e=n>-1?this.values[n]:t;var r=this.formatter;return e=parseInt(e,10),e=r?r(e):Bl.format(e,this.mask)},e.prototype.getTicks=function(){var t=this,e=this.ticks,n=[];return fl.each(e,function(e){var r;r=fl.isObject(e)?e:{text:fl.isString(e)?e:t.getText(e),tickValue:e,value:t.scale(e)},n.push(r);}),n},e.prototype._toTimeStamp=function(t){return zl(t)},e}(Al);function Vl(t,e){return 1===t?1:Math.log(e)/Math.log(t)}var Hl=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){var e=t.prototype.getDefaultCfg.call(this);return fl.mix({},e,{type:"log",base:2,tickCount:10,_minTick:null})},e.prototype.calculateTicks=function(){var t,e=this.base;if(this.min<0)throw new Error("The minimum value must be greater than zero!");var n=Vl(e,this.max);if(this.min>0)t=Math.floor(Vl(e,this.min));else{var r=this.values,i=this.max;fl.each(r,function(t){t>0&&t<i&&(i=t);}),i===this.max&&(i=this.max/e),i>1&&(i=1),t=Math.floor(Vl(e,i)),this._minTick=t,this.positiveMin=i;}for(var a=n-t,o=this.tickCount,s=Math.ceil(a/o),u=[],l=t;l<n+s;l+=s)u.push(Math.pow(e,l));return 0===this.min&&u.unshift(0),u},e.prototype._getScalePercent=function(t){var e=this.max,n=this.min;if(e===n)return 0;if(t<=0)return 0;var r=this.base,i=this.positiveMin;return i&&(n=1*i/r),t<i?t/i/(Vl(r,e)-Vl(r,n)):(Vl(r,t)-Vl(r,n))/(Vl(r,e)-Vl(r,n))},e.prototype.scale=function(t){var e=this._getScalePercent(t),n=this.rangeMin();return n+e*(this.rangeMax()-n)},e.prototype.invert=function(t){var e,n=this.base,r=Vl(n,this.max),i=this.rangeMin(),a=this.rangeMax()-i,o=this.positiveMin;if(o){if(0===t)return 0;var s=1/(r-(e=Vl(n,o/n)))*a;if(t<s)return t/s*o}else e=Vl(n,this.min);var u=(t-i)/a*(r-e)+e;return Math.pow(n,u)},e}(bl);function jl(t,e){var n=Math.E;return Math.pow(n,Math.log(e)/t)}var Wl=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){var e=t.prototype.getDefaultCfg.call(this);return fl.mix({},e,{type:"pow",exponent:2,tickCount:10})},e.prototype.calculateTicks=function(){var t,e=this.exponent,n=Math.ceil(jl(e,this.max));if((t=this.min>=0?Math.floor(jl(e,this.min)):0)>n){var r=n;n=t,t=r;}for(var i=n-t,a=this.tickCount,o=Math.ceil(i/a),s=[],u=t;u<n+o;u+=o)s.push(Math.pow(u,e));return s},e.prototype._getScalePercent=function(t){var e=this.max,n=this.min;if(e===n)return 0;var r=this.exponent;return (jl(r,t)-jl(r,n))/(jl(r,e)-jl(r,n))},e.prototype.scale=function(t){var e=this._getScalePercent(t),n=this.rangeMin();return n+e*(this.rangeMax()-n)},e.prototype.invert=function(t){var e=(t-this.rangeMin())/(this.rangeMax()-this.rangeMin()),n=this.exponent,r=jl(n,this.max),i=jl(n,this.min),a=e*(r-i)+i;return Math.pow(a,n)},e}(bl);ml.Linear=bl,ml.Identity=wl,ml.Cat=Al,ml.Time=Gl,ml.TimeCat=kl,ml.Log=Hl,ml.Pow=Wl;var Xl=function(t){if(ml.hasOwnProperty(t)){var e=fl.lowerFirst(t);ml[e]=function(e){return new ml[t](e)};}};for(var ql in ml)Xl(ql);var Yl=["cat","timeCat"];ml.isCategory=function(t){return Yl.indexOf(t)>=0};var Zl=/^(?:(?!0000)[0-9]{4}([-\/.]+)(?:(?:0?[1-9]|1[0-2])\1(?:0?[1-9]|1[0-9]|2[0-8])|(?:0?[13-9]|1[0-2])\1(?:29|30)|(?:0?[13578]|1[02])\1(?:31))|(?:[0-9]{2}(?:0[48]|[2468][048]|[13579][26])|(?:0[48]|[2468][048]|[13579][26])00)([-\/.]?)0?2\2(?:29))(\s+([01]|([01][0-9]|2[0-3])):([0-9]|[0-5][0-9]):([0-9]|[0-5][0-9]))?$/,Jl="linear",Ql="cat",Kl="time",$l=function(t){this.defs={},fl.assign(this,t);};$l.prototype._getDef=function(t){var e=this.defs,n=null;return (pl.scales[t]||e[t])&&(n=fl.mix({},pl.scales[t]),fl.each(e[t],function(t,e){fl.isNil(t)?delete n[e]:n[e]=t;})),n},$l.prototype._getDefaultType=function(t,e){var n=Jl,r=fl.Array.firstValue(e,t);return fl.isArray(r)&&(r=r[0]),Zl.test(r)?n=Kl:fl.isString(r)&&(n=Ql),n},$l.prototype._getScaleCfg=function(t,e,n){var r={field:e},i=fl.Array.values(n,e);if(r.values=i,!ml.isCategory(t)&&"time"!==t){var a=fl.Array.getRange(i);r.min=a.min,r.max=a.max,r.nice=!0;}return "time"===t&&(r.nice=!1),r},$l.prototype.createScale=function(t,e){var n,r=this._getDef(t);if(!e||!e.length)return n=r&&r.type?ml[r.type](r):ml.identity({value:t,field:t.toString(),values:[t]});var i=fl.Array.firstValue(e,t);if(fl.isNumber(t)||fl.isNil(i)&&!r)n=ml.identity({value:t,field:t.toString(),values:[t]});else{var a;r&&(a=r.type),a=a||this._getDefaultType(t,e);var o=this._getScaleCfg(a,t,e);r&&fl.mix(o,r),n=ml[a](o);}return n};var tc=/rgba?\(([\s.,0-9]+)\)/,ec={aliceblue:"#F0F8FF",antiquewhite:"#FAEBD7",aqua:"#00FFFF",aquamarine:"#7FFFD4",azure:"#F0FFFF",beige:"#F5F5DC",bisque:"#FFE4C4",black:"#000000",blanchedalmond:"#FFEBCD",blue:"#0000FF",blueviolet:"#8A2BE2",brown:"#A52A2A",burlywood:"#DEB887",cadetblue:"#5F9EA0",chartreuse:"#7FFF00",chocolate:"#D2691E",coral:"#FF7F50",cornflowerblue:"#6495ED",cornsilk:"#FFF8DC",crimson:"#DC143C",cyan:"#00FFFF",darkblue:"#00008B",darkcyan:"#008B8B",darkgoldenrod:"#B8860B",darkgray:"#A9A9A9",darkgreen:"#006400",darkgrey:"#A9A9A9",darkkhaki:"#BDB76B",darkmagenta:"#8B008B",darkolivegreen:"#556B2F",darkorange:"#FF8C00",darkorchid:"#9932CC",darkred:"#8B0000",darksalmon:"#E9967A",darkseagreen:"#8FBC8F",darkslateblue:"#483D8B",darkslategray:"#2F4F4F",darkslategrey:"#2F4F4F",darkturquoise:"#00CED1",darkviolet:"#9400D3",deeppink:"#FF1493",deepskyblue:"#00BFFF",dimgray:"#696969",dimgrey:"#696969",dodgerblue:"#1E90FF",firebrick:"#B22222",floralwhite:"#FFFAF0",forestgreen:"#228B22",fuchsia:"#FF00FF",gainsboro:"#DCDCDC",ghostwhite:"#F8F8FF",gold:"#FFD700",goldenrod:"#DAA520",gray:"#808080",green:"#008000",greenyellow:"#ADFF2F",grey:"#808080",honeydew:"#F0FFF0",hotpink:"#FF69B4",indianred:"#CD5C5C",indigo:"#4B0082",ivory:"#FFFFF0",khaki:"#F0E68C",lavender:"#E6E6FA",lavenderblush:"#FFF0F5",lawngreen:"#7CFC00",lemonchiffon:"#FFFACD",lightblue:"#ADD8E6",lightcoral:"#F08080",lightcyan:"#E0FFFF",lightgoldenrodyellow:"#FAFAD2",lightgray:"#D3D3D3",lightgreen:"#90EE90",lightgrey:"#D3D3D3",lightpink:"#FFB6C1",lightsalmon:"#FFA07A",lightseagreen:"#20B2AA",lightskyblue:"#87CEFA",lightslategray:"#778899",lightslategrey:"#778899",lightsteelblue:"#B0C4DE",lightyellow:"#FFFFE0",lime:"#00FF00",limegreen:"#32CD32",linen:"#FAF0E6",magenta:"#FF00FF",maroon:"#800000",mediumaquamarine:"#66CDAA",mediumblue:"#0000CD",mediumorchid:"#BA55D3",mediumpurple:"#9370DB",mediumseagreen:"#3CB371",mediumslateblue:"#7B68EE",mediumspringgreen:"#00FA9A",mediumturquoise:"#48D1CC",mediumvioletred:"#C71585",midnightblue:"#191970",mintcream:"#F5FFFA",mistyrose:"#FFE4E1",moccasin:"#FFE4B5",navajowhite:"#FFDEAD",navy:"#000080",oldlace:"#FDF5E6",olive:"#808000",olivedrab:"#6B8E23",orange:"#FFA500",orangered:"#FF4500",orchid:"#DA70D6",palegoldenrod:"#EEE8AA",palegreen:"#98FB98",paleturquoise:"#AFEEEE",palevioletred:"#DB7093",papayawhip:"#FFEFD5",peachpuff:"#FFDAB9",peru:"#CD853F",pink:"#FFC0CB",plum:"#DDA0DD",powderblue:"#B0E0E6",purple:"#800080",rebeccapurple:"#663399",red:"#FF0000",rosybrown:"#BC8F8F",royalblue:"#4169E1",saddlebrown:"#8B4513",salmon:"#FA8072",sandybrown:"#F4A460",seagreen:"#2E8B57",seashell:"#FFF5EE",sienna:"#A0522D",silver:"#C0C0C0",skyblue:"#87CEEB",slateblue:"#6A5ACD",slategray:"#708090",slategrey:"#708090",snow:"#FFFAFA",springgreen:"#00FF7F",steelblue:"#4682B4",tan:"#D2B48C",teal:"#008080",thistle:"#D8BFD8",tomato:"#FF6347",turquoise:"#40E0D0",violet:"#EE82EE",wheat:"#F5DEB3",white:"#FFFFFF",whitesmoke:"#F5F5F5",yellow:"#FFFF00",yellowgreen:"#9ACD32"};function nc(t,e,n,r){return t[r]+(e[r]-t[r])*n}function rc(t){var e=[];return 4===t.length&&(t="#"+t[1]+t[1]+t[2]+t[2]+t[3]+t[3]),e.push(parseInt(t.substr(1,2),16)),e.push(parseInt(t.substr(3,2),16)),e.push(parseInt(t.substr(5,2),16)),e}var ic={toRGB:function(t){var e=[255,255,255,255];ec[t]&&(e=rc(ec[t])).push(255);if("#"===t[0]&&(7===t.length||4===t.length))return (e=rc(t)).push(255),e;tc.test(t)&&(4===(e=tc.exec(t)[1].split(/\s*,\s*/)).length&&(e[3]*=255),3===e.length&&e.push(255));return e},color2Arr:function(t){return this.toRGB(t).map(function(t){return t/255})},colorArray2RGBA:function(t){return "rgba("+255*t[0]+","+255*t[1]+","+255*t[2]+","+t[3]+")"},color2RGBA:function(t){return this.color2Arr(t)},rgb2arr:rc,gradient:function(t){var e=[];return fl.isString(t)&&(t=t.split("-")),fl.each(t,function(t){var n=ic.toRGB(t).map(function(t){return t/255});e.push(n);}),function(t){return function(t,e){!fl.isNaN(e)&&fl.isNumber(e)||(e=0);var n=t.length-1,r=Math.floor(n*e),i=n*e-r,a=t[r],o=r===n?a:t[r+1];return [nc(a,o,i,0),nc(a,o,i,1),nc(a,o,i,2),nc(a,o,i,3)]}(e,t)}}};function ac(t,e){return fl.isString(e)?e:t.invert(t.scale(e))}var oc=function(t){this.type="base",this.name=null,this.method=null,this.values=[],this.scales=[],this.linear=null,fl.mix(this,t);};oc.prototype.get=function(t){return this[t]},oc.prototype.set=function(t,e){this[t]=e;},oc.prototype._getAttrValue=function(t,e){var n=this.values;if(t.isCategory&&!this.linear)return n[t.translate(e)%n.length];var r=t.scale(e);return this.getLinearValue(r)},oc.prototype.getLinearValue=function(t){var e=this.values,n=e.length-1,r=Math.floor(n*t),i=n*t-r,a=e[r];return a+((r===n?a:e[r+1])-a)*i},oc.prototype.callback=function(t){var e=this.scales[0];return "identity"===e.type?e.value:this._getAttrValue(e,t)},oc.prototype.getNames=function(){for(var t=this.scales,e=this.names,n=Math.min(t.length,e.length),r=[],i=0;i<n;i++)r.push(e[i]);return r},oc.prototype.getFields=function(){var t=this.scales,e=[];return fl.each(t,function(t){e.push(t.field);}),e},oc.prototype.getScale=function(t){return this.scales[this.names.indexOf(t)]},oc.prototype.mapping=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];var n=this.scales,r=this.callback,i=t;if(r){for(var a=0;a<t.length;a++)t[a]=this._toOriginParam(t[a],n[a]);i=r.apply(this,t);}return "color"!==this.type||fl.isArray(i)||(i=ic.toRGB(i).map(function(t){return t/255})),fl.isArray(i)||(i=[i]),i},oc.prototype._toOriginParam=function(t,e){var n=t;if(!e.isLinear)if(fl.isArray(t)){n=[];for(var r=0;r<t.length;r++)n.push(ac(e,t[r]));}else n=ac(e,t);return n};var sc=function(t){function e(e){t.call(this,e),this.names=["color"],this.type="color",this.gradient=null,fl.isString(this.values)&&(this.linear=!0);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getLinearValue=function(t){var e=this.gradient;if(!e){var n=this.values;e=ic.gradient(n),this.gradient=e;}return e(t)},e}(oc),uc=function(t){function e(e){t.call(this,e),this.names=["size"],this.type="size",this.gradient=null,this.domainIndex=0;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.mapping=function(){var t=arguments,e=[],n=this.scales;if(0===this.values.length){var r=this.callback.bind(this);e.push(r.apply(void 0,arguments));}else{fl.isArray(this.values[0])||(this.values=[this.values]);for(var i=0;i<n.length;i++)e.push(this._scaling(n[i],t[i]));}return this.domainIndex=0,e},e.prototype._scaling=function(t,e){if("identity"===t.type)return e;var n=t.scale(e);return this.getLinearValue(n)},e.prototype.getLinearValue=function(t){var e=this.values[this.domainIndex],n=e.length-1,r=Math.floor(n*t),i=n*t-r,a=e[r],o=a+((r===n?a:e[r+1])-a)*i;return this.domainIndex+=1,o},e}(oc),lc=function(t){function e(e){t.call(this,e),this.names=["opacity"],this.type="opacity",this.gradient=null;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(oc),cc=function(t){function e(e){t.call(this,e),this.names=["shape"],this.type="shape",this.gradient=null;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getLinearValue=function(t){var e=this.values;return e[Math.round((e.length-1)*t)]},e.prototype._getAttrValue=function(t,e){if("text"===this.values)return e;var n=this.values;if(t.isCategory&&!this.linear)return n[t.translate(e)%n.length];var r=t.scale(e);return this.getLinearValue(r)},e}(oc),hc=function(t){function e(e){t.call(this,e),this.names=["x","y"],this.type="position";}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.mapping=function(t,e){var n,r,i,a=this.scales,o=this.coord,s=a[0],u=a[1];if(fl.isNil(t)||fl.isNil(e))return [];if(fl.isArray(e)&&fl.isArray(t)){n=[],r=[];for(var l=0,c=0;l<t.length&&c<e.length;l++,c++)i=o.convertPoint({x:s.scale(t[l]),y:u.scale(e[c])}),n.push(i.x),r.push(i.y);}else if(fl.isArray(e))t=s.scale(t),r=[],fl.each(e,function(e){e=u.scale(e),i=o.convertPoint({x:t,y:e}),n&&n!==i.x?(fl.isArray(n)||(n=[n]),n.push(i.x)):n=i.x,r.push(i.y);});else if(fl.isArray(t))e=u.scale(e),n=[],fl.each(t,function(t){t=s.scale(t),i=o.convertPoint({x:t,y:e}),r&&r!==i.y?(fl.isArray(r)||(r=[r]),r.push(i.y)):r=i.y,n.push(i.x);});else{t=s.scale(t),e=u.scale(e);var h=o.convertPoint({x:t,y:e});n=h.x,r=h.y;}return [n,r]},e}(oc),fc=function(t){function e(e){t.call(this,e),this.names=["symbol"],this.type="symbol",this.gradient=null;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(oc),dc=function(t){function e(e){t.call(this,e),this.names=["filter"],this.type="filter",this.gradient=null;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(oc),pc=function(t){function e(e){t.call(this,e),this.names=["pattern"],this.type="pattern",this.gradient=null;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(oc);oc.Color=sc,oc.Size=uc,oc.Opacity=lc,oc.Shape=cc,oc.Position=hc,oc.Symbol=fc,oc.Filter=dc,oc.Pattern=pc;var mc=n(function(t,e){function n(t,e,n){void 0===n&&(n={});var r={type:"Feature"};return (0===n.id||n.id)&&(r.id=n.id),n.bbox&&(r.bbox=n.bbox),r.properties=e||{},r.geometry=t,r}function r(t,e,r){return void 0===r&&(r={}),n({type:"Point",coordinates:t},e,r)}function i(t,e,r){void 0===r&&(r={});for(var i=0,a=t;i<a.length;i++){var o=a[i];if(o.length<4)throw new Error("Each LinearRing of a Polygon must have 4 or more Positions.");for(var s=0;s<o[o.length-1].length;s++)if(o[o.length-1][s]!==o[0][s])throw new Error("First and last Position are not equivalent.")}return n({type:"Polygon",coordinates:t},e,r)}function a(t,e,r){if(void 0===r&&(r={}),t.length<2)throw new Error("coordinates must be an array of two or more positions");return n({type:"LineString",coordinates:t},e,r)}function o(t,e){void 0===e&&(e={});var n={type:"FeatureCollection"};return e.id&&(n.id=e.id),e.bbox&&(n.bbox=e.bbox),n.features=t,n}function s(t,e,r){return void 0===r&&(r={}),n({type:"MultiLineString",coordinates:t},e,r)}function u(t,e,r){return void 0===r&&(r={}),n({type:"MultiPoint",coordinates:t},e,r)}function l(t,e,r){return void 0===r&&(r={}),n({type:"MultiPolygon",coordinates:t},e,r)}function c(t,n){void 0===n&&(n="kilometers");var r=e.factors[n];if(!r)throw new Error(n+" units is invalid");return t*r}function h(t,n){void 0===n&&(n="kilometers");var r=e.factors[n];if(!r)throw new Error(n+" units is invalid");return t/r}function f(t){return 180*(t%(2*Math.PI))/Math.PI}function d(t){return !isNaN(t)&&null!==t&&!Array.isArray(t)&&!/^\s*$/.test(t)}Object.defineProperty(e,"__esModule",{value:!0}),e.earthRadius=6371008.8,e.factors={centimeters:100*e.earthRadius,centimetres:100*e.earthRadius,degrees:e.earthRadius/111325,feet:3.28084*e.earthRadius,inches:39.37*e.earthRadius,kilometers:e.earthRadius/1e3,kilometres:e.earthRadius/1e3,meters:e.earthRadius,metres:e.earthRadius,miles:e.earthRadius/1609.344,millimeters:1e3*e.earthRadius,millimetres:1e3*e.earthRadius,nauticalmiles:e.earthRadius/1852,radians:1,yards:e.earthRadius/1.0936},e.unitsFactors={centimeters:100,centimetres:100,degrees:1/111325,feet:3.28084,inches:39.37,kilometers:.001,kilometres:.001,meters:1,metres:1,miles:1/1609.344,millimeters:1e3,millimetres:1e3,nauticalmiles:1/1852,radians:1/e.earthRadius,yards:1/1.0936},e.areaFactors={acres:247105e-9,centimeters:1e4,centimetres:1e4,feet:10.763910417,inches:1550.003100006,kilometers:1e-6,kilometres:1e-6,meters:1,metres:1,miles:3.86e-7,millimeters:1e6,millimetres:1e6,yards:1.195990046},e.feature=n,e.geometry=function(t,e,n){switch(t){case"Point":return r(e).geometry;case"LineString":return a(e).geometry;case"Polygon":return i(e).geometry;case"MultiPoint":return u(e).geometry;case"MultiLineString":return s(e).geometry;case"MultiPolygon":return l(e).geometry;default:throw new Error(t+" is invalid")}},e.point=r,e.points=function(t,e,n){return void 0===n&&(n={}),o(t.map(function(t){return r(t,e)}),n)},e.polygon=i,e.polygons=function(t,e,n){return void 0===n&&(n={}),o(t.map(function(t){return i(t,e)}),n)},e.lineString=a,e.lineStrings=function(t,e,n){return void 0===n&&(n={}),o(t.map(function(t){return a(t,e)}),n)},e.featureCollection=o,e.multiLineString=s,e.multiPoint=u,e.multiPolygon=l,e.geometryCollection=function(t,e,r){return void 0===r&&(r={}),n({type:"GeometryCollection",geometries:t},e,r)},e.round=function(t,e){if(void 0===e&&(e=0),e&&!(e>=0))throw new Error("precision must be a positive number");var n=Math.pow(10,e||0);return Math.round(t*n)/n},e.radiansToLength=c,e.lengthToRadians=h,e.lengthToDegrees=function(t,e){return f(h(t,e))},e.bearingToAzimuth=function(t){var e=t%360;return e<0&&(e+=360),e},e.radiansToDegrees=f,e.degreesToRadians=function(t){return t%360*Math.PI/180},e.convertLength=function(t,e,n){if(void 0===e&&(e="kilometers"),void 0===n&&(n="kilometers"),!(t>=0))throw new Error("length must be a positive number");return c(h(t,e),n)},e.convertArea=function(t,n,r){if(void 0===n&&(n="meters"),void 0===r&&(r="kilometers"),!(t>=0))throw new Error("area must be a positive number");var i=e.areaFactors[n];if(!i)throw new Error("invalid original units");var a=e.areaFactors[r];if(!a)throw new Error("invalid final units");return t/i*a},e.isNumber=d,e.isObject=function(t){return !!t&&t.constructor===Object},e.validateBBox=function(t){if(!t)throw new Error("bbox is required");if(!Array.isArray(t))throw new Error("bbox must be an Array");if(4!==t.length&&6!==t.length)throw new Error("bbox must be an Array of 4 or 6 numbers");t.forEach(function(t){if(!d(t))throw new Error("bbox must only contain numbers")});},e.validateId=function(t){if(!t)throw new Error("id is required");if(-1===["string","number"].indexOf(typeof t))throw new Error("id must be a number or a string")},e.radians2degrees=function(){throw new Error("method has been renamed to `radiansToDegrees`")},e.degrees2radians=function(){throw new Error("method has been renamed to `degreesToRadians`")},e.distanceToDegrees=function(){throw new Error("method has been renamed to `lengthToDegrees`")},e.distanceToRadians=function(){throw new Error("method has been renamed to `lengthToRadians`")},e.radiansToDistance=function(){throw new Error("method has been renamed to `radiansToLength`")},e.bearingToAngle=function(){throw new Error("method has been renamed to `bearingToAzimuth`")},e.convertDistance=function(){throw new Error("method has been renamed to `convertLength`")};});e(mc);mc.earthRadius,mc.factors,mc.unitsFactors,mc.areaFactors,mc.feature,mc.geometry,mc.point,mc.points,mc.polygon,mc.polygons,mc.lineString,mc.lineStrings,mc.featureCollection,mc.multiLineString,mc.multiPoint,mc.multiPolygon,mc.geometryCollection,mc.round,mc.radiansToLength,mc.lengthToRadians,mc.lengthToDegrees,mc.bearingToAzimuth,mc.radiansToDegrees,mc.degreesToRadians,mc.convertLength,mc.convertArea,mc.isNumber,mc.isObject,mc.validateBBox,mc.validateId,mc.radians2degrees,mc.degrees2radians,mc.distanceToDegrees,mc.distanceToRadians,mc.radiansToDistance,mc.bearingToAngle,mc.convertDistance;var gc=n(function(t,e){function n(t,e,r){if(null!==t)for(var i,a,o,s,u,l,c,h,f=0,d=0,p=t.type,m="FeatureCollection"===p,g="Feature"===p,v=m?t.features.length:1,y=0;y<v;y++){u=(h=!!(c=m?t.features[y].geometry:g?t.geometry:t)&&"GeometryCollection"===c.type)?c.geometries.length:1;for(var _=0;_<u;_++){var x=0,M=0;if(null!==(s=h?c.geometries[_]:c)){l=s.coordinates;var b=s.type;switch(f=!r||"Polygon"!==b&&"MultiPolygon"!==b?0:1,b){case null:break;case"Point":if(!1===e(l,d,y,x,M))return !1;d++,x++;break;case"LineString":case"MultiPoint":for(i=0;i<l.length;i++){if(!1===e(l[i],d,y,x,M))return !1;d++,"MultiPoint"===b&&x++;}"LineString"===b&&x++;break;case"Polygon":case"MultiLineString":for(i=0;i<l.length;i++){for(a=0;a<l[i].length-f;a++){if(!1===e(l[i][a],d,y,x,M))return !1;d++;}"MultiLineString"===b&&x++,"Polygon"===b&&M++;}"Polygon"===b&&x++;break;case"MultiPolygon":for(i=0;i<l.length;i++){for(M=0,a=0;a<l[i].length;a++){for(o=0;o<l[i][a].length-f;o++){if(!1===e(l[i][a][o],d,y,x,M))return !1;d++;}M++;}x++;}break;case"GeometryCollection":for(i=0;i<s.geometries.length;i++)if(!1===n(s.geometries[i],e,r))return !1;break;default:throw new Error("Unknown Geometry Type")}}}}}function r(t,e){var n;switch(t.type){case"FeatureCollection":for(n=0;n<t.features.length&&!1!==e(t.features[n].properties,n);n++);break;case"Feature":e(t.properties,0);}}function i(t,e){if("Feature"===t.type)e(t,0);else if("FeatureCollection"===t.type)for(var n=0;n<t.features.length&&!1!==e(t.features[n],n);n++);}function a(t,e){var n,r,i,a,o,s,u,l,c,h,f=0,d="FeatureCollection"===t.type,p="Feature"===t.type,m=d?t.features.length:1;for(n=0;n<m;n++){for(s=d?t.features[n].geometry:p?t.geometry:t,l=d?t.features[n].properties:p?t.properties:{},c=d?t.features[n].bbox:p?t.bbox:void 0,h=d?t.features[n].id:p?t.id:void 0,o=(u=!!s&&"GeometryCollection"===s.type)?s.geometries.length:1,i=0;i<o;i++)if(null!==(a=u?s.geometries[i]:s))switch(a.type){case"Point":case"LineString":case"MultiPoint":case"Polygon":case"MultiLineString":case"MultiPolygon":if(!1===e(a,f,l,c,h))return !1;break;case"GeometryCollection":for(r=0;r<a.geometries.length;r++)if(!1===e(a.geometries[r],f,l,c,h))return !1;break;default:throw new Error("Unknown Geometry Type")}else if(!1===e(null,f,l,c,h))return !1;f++;}}function o(t,e){a(t,function(t,n,r,i,a){var o,s=null===t?null:t.type;switch(s){case null:case"Point":case"LineString":case"Polygon":return !1!==e(mc.feature(t,r,{bbox:i,id:a}),n,0)&&void 0}switch(s){case"MultiPoint":o="Point";break;case"MultiLineString":o="LineString";break;case"MultiPolygon":o="Polygon";}for(var u=0;u<t.coordinates.length;u++){var l={type:o,coordinates:t.coordinates[u]};if(!1===e(mc.feature(l,r),n,u))return !1}});}function s(t,e){o(t,function(t,r,i){var a=0;if(t.geometry){var o=t.geometry.type;if("Point"!==o&&"MultiPoint"!==o){var s,u=0,l=0,c=0;return !1!==n(t,function(n,o,h,f,d){if(void 0===s||r>u||f>l||d>c)return s=n,u=r,l=f,c=d,void(a=0);var p=mc.lineString([s,n],t.properties);if(!1===e(p,r,i,d,a))return !1;a++,s=n;})&&void 0}}});}function u(t,e){if(!t)throw new Error("geojson is required");o(t,function(t,n,r){if(null!==t.geometry){var i=t.geometry.type,a=t.geometry.coordinates;switch(i){case"LineString":if(!1===e(t,n,r,0,0))return !1;break;case"Polygon":for(var o=0;o<a.length;o++)if(!1===e(mc.lineString(a[o],t.properties),n,r,o))return !1}}});}Object.defineProperty(e,"__esModule",{value:!0}),e.coordEach=n,e.coordReduce=function(t,e,r,i){var a=r;return n(t,function(t,n,i,o,s){a=0===n&&void 0===r?t:e(a,t,n,i,o,s);},i),a},e.propEach=r,e.propReduce=function(t,e,n){var i=n;return r(t,function(t,r){i=0===r&&void 0===n?t:e(i,t,r);}),i},e.featureEach=i,e.featureReduce=function(t,e,n){var r=n;return i(t,function(t,i){r=0===i&&void 0===n?t:e(r,t,i);}),r},e.coordAll=function(t){var e=[];return n(t,function(t){e.push(t);}),e},e.geomEach=a,e.geomReduce=function(t,e,n){var r=n;return a(t,function(t,i,a,o,s){r=0===i&&void 0===n?t:e(r,t,i,a,o,s);}),r},e.flattenEach=o,e.flattenReduce=function(t,e,n){var r=n;return o(t,function(t,i,a){r=0===i&&0===a&&void 0===n?t:e(r,t,i,a);}),r},e.segmentEach=s,e.segmentReduce=function(t,e,n){var r=n,i=!1;return s(t,function(t,a,o,s,u){r=!1===i&&void 0===n?t:e(r,t,a,o,s,u),i=!0;}),r},e.lineEach=u,e.lineReduce=function(t,e,n){var r=n;return u(t,function(t,i,a,o){r=0===i&&void 0===n?t:e(r,t,i,a,o);}),r},e.findSegment=function(t,e){if(e=e||{},!mc.isObject(e))throw new Error("options is invalid");var n,r=e.featureIndex||0,i=e.multiFeatureIndex||0,a=e.geometryIndex||0,o=e.segmentIndex||0,s=e.properties;switch(t.type){case"FeatureCollection":r<0&&(r=t.features.length+r),s=s||t.features[r].properties,n=t.features[r].geometry;break;case"Feature":s=s||t.properties,n=t.geometry;break;case"Point":case"MultiPoint":return null;case"LineString":case"Polygon":case"MultiLineString":case"MultiPolygon":n=t;break;default:throw new Error("geojson is invalid")}if(null===n)return null;var u=n.coordinates;switch(n.type){case"Point":case"MultiPoint":return null;case"LineString":return o<0&&(o=u.length+o-1),mc.lineString([u[o],u[o+1]],s,e);case"Polygon":return a<0&&(a=u.length+a),o<0&&(o=u[a].length+o-1),mc.lineString([u[a][o],u[a][o+1]],s,e);case"MultiLineString":return i<0&&(i=u.length+i),o<0&&(o=u[i].length+o-1),mc.lineString([u[i][o],u[i][o+1]],s,e);case"MultiPolygon":return i<0&&(i=u.length+i),a<0&&(a=u[i].length+a),o<0&&(o=u[i][a].length-o-1),mc.lineString([u[i][a][o],u[i][a][o+1]],s,e)}throw new Error("geojson is invalid")},e.findPoint=function(t,e){if(e=e||{},!mc.isObject(e))throw new Error("options is invalid");var n,r=e.featureIndex||0,i=e.multiFeatureIndex||0,a=e.geometryIndex||0,o=e.coordIndex||0,s=e.properties;switch(t.type){case"FeatureCollection":r<0&&(r=t.features.length+r),s=s||t.features[r].properties,n=t.features[r].geometry;break;case"Feature":s=s||t.properties,n=t.geometry;break;case"Point":case"MultiPoint":return null;case"LineString":case"Polygon":case"MultiLineString":case"MultiPolygon":n=t;break;default:throw new Error("geojson is invalid")}if(null===n)return null;var u=n.coordinates;switch(n.type){case"Point":return mc.point(u,s,e);case"MultiPoint":return i<0&&(i=u.length+i),mc.point(u[i],s,e);case"LineString":return o<0&&(o=u.length+o),mc.point(u[o],s,e);case"Polygon":return a<0&&(a=u.length+a),o<0&&(o=u[a].length+o),mc.point(u[a][o],s,e);case"MultiLineString":return i<0&&(i=u.length+i),o<0&&(o=u[i].length+o),mc.point(u[i][o],s,e);case"MultiPolygon":return i<0&&(i=u.length+i),a<0&&(a=u[i].length+a),o<0&&(o=u[i][a].length-o),mc.point(u[i][a][o],s,e)}throw new Error("geojson is invalid")};});e(gc);gc.coordEach,gc.coordReduce,gc.propEach,gc.propReduce,gc.featureEach,gc.featureReduce,gc.coordAll,gc.geomEach,gc.geomReduce;var vc=gc.flattenEach,yc=(gc.flattenReduce,gc.segmentEach,gc.segmentReduce,gc.lineEach,gc.lineReduce,gc.findSegment,gc.findPoint,n(function(t,e){Object.defineProperty(e,"__esModule",{value:!0}),e.getCoord=function(t){if(!t)throw new Error("coord is required");if(!Array.isArray(t)){if("Feature"===t.type&&null!==t.geometry&&"Point"===t.geometry.type)return t.geometry.coordinates;if("Point"===t.type)return t.coordinates}if(Array.isArray(t)&&t.length>=2&&!Array.isArray(t[0])&&!Array.isArray(t[1]))return t;throw new Error("coord must be GeoJSON Point or an Array of numbers")},e.getCoords=function(t){if(Array.isArray(t))return t;if("Feature"===t.type){if(null!==t.geometry)return t.geometry.coordinates}else if(t.coordinates)return t.coordinates;throw new Error("coords must be GeoJSON Feature, Geometry Object or an Array")},e.containsNumber=function t(e){if(e.length>1&&mc.isNumber(e[0])&&mc.isNumber(e[1]))return !0;if(Array.isArray(e[0])&&e[0].length)return t(e[0]);throw new Error("coordinates must only contain numbers")},e.geojsonType=function(t,e,n){if(!e||!n)throw new Error("type and name required");if(!t||t.type!==e)throw new Error("Invalid input to "+n+": must be a "+e+", given "+t.type)},e.featureOf=function(t,e,n){if(!t)throw new Error("No feature passed");if(!n)throw new Error(".featureOf() requires a name");if(!t||"Feature"!==t.type||!t.geometry)throw new Error("Invalid input to "+n+", Feature with geometry required");if(!t.geometry||t.geometry.type!==e)throw new Error("Invalid input to "+n+": must be a "+e+", given "+t.geometry.type)},e.collectionOf=function(t,e,n){if(!t)throw new Error("No featureCollection passed");if(!n)throw new Error(".collectionOf() requires a name");if(!t||"FeatureCollection"!==t.type)throw new Error("Invalid input to "+n+", FeatureCollection required");for(var r=0,i=t.features;r<i.length;r++){var a=i[r];if(!a||"Feature"!==a.type||!a.geometry)throw new Error("Invalid input to "+n+", Feature with geometry required");if(!a.geometry||a.geometry.type!==e)throw new Error("Invalid input to "+n+": must be a "+e+", given "+a.geometry.type)}},e.getGeom=function(t){return "Feature"===t.type?t.geometry:t},e.getType=function(t,e){return "FeatureCollection"===t.type?"FeatureCollection":"GeometryCollection"===t.type?"GeometryCollection":"Feature"===t.type&&null!==t.geometry?t.geometry.type:t.type};}));e(yc);yc.getCoord;var _c=yc.getCoords;yc.containsNumber,yc.geojsonType,yc.featureOf,yc.collectionOf,yc.getGeom,yc.getType;function xc(t){for(var e=5381,n=(t=t.toString()).length;n;)e=33*e^t.charCodeAt(--n);return e>>>0}var Mc={RADIUS:6378137,FLATTENING:1/298.257223563,POLAR_RADIUS:6356752.3142};function bc(t){var e=0;if(t&&t.length>0){e+=Math.abs(wc(t[0]));for(var n=1;n<t.length;n++)e-=Math.abs(wc(t[n]));}return e}function wc(t){var e,n,r,i,a,o,s=0,u=t.length;if(u>2){for(o=0;o<u;o++)o===u-2?(r=u-2,i=u-1,a=0):o===u-1?(r=u-1,i=0,a=1):(r=o,i=o+1,a=o+2),e=t[r],n=t[i],s+=(Ec(t[a][0])-Ec(e[0]))*Math.sin(Ec(n[1]));s=s*Mc.RADIUS*Mc.RADIUS/2;}return s}function Ec(t){return t*Math.PI/180}var Sc={geometry:function t(e){var n,r=0;switch(e.type){case"Polygon":return bc(e.coordinates);case"MultiPolygon":for(n=0;n<e.coordinates.length;n++)r+=bc(e.coordinates[n]);return r;case"Point":case"MultiPoint":case"LineString":case"MultiLineString":return 0;case"GeometryCollection":for(n=0;n<e.geometries.length;n++)r+=t(e.geometries[n]);return r}},ring:wc},Tc=function t(e,n){switch(e&&e.type||null){case"FeatureCollection":return e.features=e.features.map(Ac(t,n)),e;case"GeometryCollection":return e.geometries=e.geometries.map(Ac(t,n)),e;case"Feature":return e.geometry=t(e.geometry,n),e;case"Polygon":case"MultiPolygon":return function(t,e){"Polygon"===t.type?t.coordinates=Lc(t.coordinates,e):"MultiPolygon"===t.type&&(t.coordinates=t.coordinates.map(Ac(Lc,e)));return t}(e,n);default:return e}};function Ac(t,e){return function(n){return t(n,e)}}function Lc(t,e){e=!!e,t[0]=Cc(t[0],e);for(var n=1;n<t.length;n++)t[n]=Cc(t[n],!e);return t}function Cc(t,e){return function(t){return Sc.ring(t)>=0}(t)===e?t:t.reverse()}function Pc(t,e){var n=[],r={};t.features=t.features.filter(function(t){return null!=t&&t.geometry&&t.geometry.type&&t.geometry.coordinates&&Array.isArray(t.geometry.coordinates)&&t.geometry.coordinates.length>0}),Tc(t,!0);var i=0;return vc(t,function(t,a){var o=_c(t);if(0!==o.length){var s=a+1;if(e.idField&&t.properties[e.idField]){var u=t.properties[e.idField];s=xc(u)%1000019,r[s]={index:i++,idField:u};}if("Polygon"===t.geometry.type)o.forEach(function(e){var r=Object.assign({},t.properties,{coordinates:[e],_id:s});n.push(r);});else{var l=Object.assign({},t.properties,{coordinates:o,_id:s});n.push(l);}}else i++;}),{dataArray:n,featureKeys:r}}var Rc=function(t){function e(e,n,r){t.call(this,e),this.status=n,this.url=r,this.name=this.constructor.name,this.message=e;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.toString=function(){return this.name+": "+this.message+" ("+this.status+"): "+this.url},e}(Error);var Fc=function(t,e){var n=function(t){var e=new XMLHttpRequest;for(var n in e.open("GET",t.url,!0),t.headers)e.setRequestHeader(n,t.headers[n]);return e.withCredentials="include"===t.credentials,e}(t);return n.responseType="arraybuffer",n.onerror=function(){e(new Error(n.statusText));},n.onload=function(){var r=n.response;if(0===r.byteLength&&200===n.status)return e(new Error("http status 200 returned without content."));n.status>=200&&n.status<300&&n.response?e(null,{data:r,cacheControl:n.getResponseHeader("Cache-Control"),expires:n.getResponseHeader("Expires")}):e(new Rc(n.statusText,n.status,t.url));},n.send(),n},Dc=function(t,e){return Fc(t,function(t,n){if(t)e(t);else if(n){var r=new window.Image,i=window.URL||window.webkitURL;r.onload=function(){e(null,r),i.revokeObjectURL(r.src);};var a=new window.Blob([new Uint8Array(n.data)],{type:"image/png"});r.cacheControl=n.cacheControl,r.expires=n.expires,r.src=n.data.byteLength?i.createObjectURL(a):"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=";}})};var Ic={},Nc={},Oc=34,Uc=10,Bc=13;function zc(t){return new Function("d","return {"+t.map(function(t,e){return JSON.stringify(t)+": d["+e+"]"}).join(",")+"}")}function Gc(t){var e=Object.create(null),n=[];return t.forEach(function(t){for(var r in t)r in e||n.push(e[r]=r);}),n}function kc(t,e){var n=t+"",r=n.length;return r<e?new Array(e-r+1).join(0)+n:n}function Vc(t){var e,n=t.getUTCHours(),r=t.getUTCMinutes(),i=t.getUTCSeconds(),a=t.getUTCMilliseconds();return isNaN(t)?"Invalid Date":((e=t.getUTCFullYear())<0?"-"+kc(-e,6):e>9999?"+"+kc(e,6):kc(e,4))+"-"+kc(t.getUTCMonth()+1,2)+"-"+kc(t.getUTCDate(),2)+(a?"T"+kc(n,2)+":"+kc(r,2)+":"+kc(i,2)+"."+kc(a,3)+"Z":i?"T"+kc(n,2)+":"+kc(r,2)+":"+kc(i,2)+"Z":r||n?"T"+kc(n,2)+":"+kc(r,2)+"Z":"")}function Hc(t){var e=new RegExp('["'+t+"\n\r]"),n=t.charCodeAt(0);function r(t,e){var r,i=[],a=t.length,o=0,s=0,u=a<=0,l=!1;function c(){if(u)return Nc;if(l)return l=!1,Ic;var e,r,i=o;if(t.charCodeAt(i)===Oc){for(;o++<a&&t.charCodeAt(o)!==Oc||t.charCodeAt(++o)===Oc;);return (e=o)>=a?u=!0:(r=t.charCodeAt(o++))===Uc?l=!0:r===Bc&&(l=!0,t.charCodeAt(o)===Uc&&++o),t.slice(i+1,e-1).replace(/""/g,'"')}for(;o<a;){if((r=t.charCodeAt(e=o++))===Uc)l=!0;else if(r===Bc)l=!0,t.charCodeAt(o)===Uc&&++o;else if(r!==n)continue;return t.slice(i,e)}return u=!0,t.slice(i,a)}for(t.charCodeAt(a-1)===Uc&&--a,t.charCodeAt(a-1)===Bc&&--a;(r=c())!==Nc;){for(var h=[];r!==Ic&&r!==Nc;)h.push(r),r=c();e&&null==(h=e(h,s++))||i.push(h);}return i}function i(e,n){return e.map(function(e){return n.map(function(t){return o(e[t])}).join(t)})}function a(e){return e.map(o).join(t)}function o(t){return null==t?"":t instanceof Date?Vc(t):e.test(t+="")?'"'+t.replace(/"/g,'""')+'"':t}return {parse:function(t,e){var n,i,a=r(t,function(t,r){if(n)return n(t,r-1);i=t,n=e?function(t,e){var n=zc(t);return function(r,i){return e(n(r),i,t)}}(t,e):zc(t);});return a.columns=i||[],a},parseRows:r,format:function(e,n){return null==n&&(n=Gc(e)),[n.map(o).join(t)].concat(i(e,n)).join("\n")},formatBody:function(t,e){return null==e&&(e=Gc(t)),i(t,e).join("\n")},formatRows:function(t){return t.map(a).join("\n")}}}var jc=Hc(",").parse;Hc("\t");var Wc=function(t,e,n,r,i){var a,o,s=8*i-r-1,u=(1<<s)-1,l=u>>1,c=-7,h=n?i-1:0,f=n?-1:1,d=t[e+h];for(h+=f,a=d&(1<<-c)-1,d>>=-c,c+=s;c>0;a=256*a+t[e+h],h+=f,c-=8);for(o=a&(1<<-c)-1,a>>=-c,c+=r;c>0;o=256*o+t[e+h],h+=f,c-=8);if(0===a)a=1-l;else{if(a===u)return o?NaN:1/0*(d?-1:1);o+=Math.pow(2,r),a-=l;}return (d?-1:1)*o*Math.pow(2,a-r)},Xc=function(t,e,n,r,i,a){var o,s,u,l=8*a-i-1,c=(1<<l)-1,h=c>>1,f=23===i?Math.pow(2,-24)-Math.pow(2,-77):0,d=r?0:a-1,p=r?1:-1,m=e<0||0===e&&1/e<0?1:0;for(e=Math.abs(e),isNaN(e)||e===1/0?(s=isNaN(e)?1:0,o=c):(o=Math.floor(Math.log(e)/Math.LN2),e*(u=Math.pow(2,-o))<1&&(o--,u*=2),(e+=o+h>=1?f/u:f*Math.pow(2,1-h))*u>=2&&(o++,u/=2),o+h>=c?(s=0,o=c):o+h>=1?(s=(e*u-1)*Math.pow(2,i),o+=h):(s=e*Math.pow(2,h-1)*Math.pow(2,i),o=0));i>=8;t[n+d]=255&s,d+=p,s/=256,i-=8);for(o=o<<i|s,l+=i;l>0;t[n+d]=255&o,d+=p,o/=256,l-=8);t[n+d-p]|=128*m;},qc=Yc;function Yc(t){this.buf=ArrayBuffer.isView&&ArrayBuffer.isView(t)?t:new Uint8Array(t||0),this.pos=0,this.type=0,this.length=this.buf.length;}Yc.Varint=0,Yc.Fixed64=1,Yc.Bytes=2,Yc.Fixed32=5;var Zc="undefined"==typeof TextDecoder?null:new TextDecoder("utf8");function Jc(t){return t.type===Yc.Bytes?t.readVarint()+t.pos:t.pos+1}function Qc(t,e,n){return n?4294967296*e+(t>>>0):4294967296*(e>>>0)+(t>>>0)}function Kc(t,e,n){var r=e<=16383?1:e<=2097151?2:e<=268435455?3:Math.floor(Math.log(e)/(7*Math.LN2));n.realloc(r);for(var i=n.pos-1;i>=t;i--)n.buf[i+r]=n.buf[i];}function $c(t,e){for(var n=0;n<t.length;n++)e.writeVarint(t[n]);}function th(t,e){for(var n=0;n<t.length;n++)e.writeSVarint(t[n]);}function eh(t,e){for(var n=0;n<t.length;n++)e.writeFloat(t[n]);}function nh(t,e){for(var n=0;n<t.length;n++)e.writeDouble(t[n]);}function rh(t,e){for(var n=0;n<t.length;n++)e.writeBoolean(t[n]);}function ih(t,e){for(var n=0;n<t.length;n++)e.writeFixed32(t[n]);}function ah(t,e){for(var n=0;n<t.length;n++)e.writeSFixed32(t[n]);}function oh(t,e){for(var n=0;n<t.length;n++)e.writeFixed64(t[n]);}function sh(t,e){for(var n=0;n<t.length;n++)e.writeSFixed64(t[n]);}function uh(t,e){return (t[e]|t[e+1]<<8|t[e+2]<<16)+16777216*t[e+3]}function lh(t,e,n){t[n]=e,t[n+1]=e>>>8,t[n+2]=e>>>16,t[n+3]=e>>>24;}function ch(t,e){return (t[e]|t[e+1]<<8|t[e+2]<<16)+(t[e+3]<<24)}Yc.prototype={destroy:function(){this.buf=null;},readFields:function(t,e,n){for(n=n||this.length;this.pos<n;){var r=this.readVarint(),i=r>>3,a=this.pos;this.type=7&r,t(i,e,this),this.pos===a&&this.skip(r);}return e},readMessage:function(t,e){return this.readFields(t,e,this.readVarint()+this.pos)},readFixed32:function(){var t=uh(this.buf,this.pos);return this.pos+=4,t},readSFixed32:function(){var t=ch(this.buf,this.pos);return this.pos+=4,t},readFixed64:function(){var t=uh(this.buf,this.pos)+4294967296*uh(this.buf,this.pos+4);return this.pos+=8,t},readSFixed64:function(){var t=uh(this.buf,this.pos)+4294967296*ch(this.buf,this.pos+4);return this.pos+=8,t},readFloat:function(){var t=Wc(this.buf,this.pos,!0,23,4);return this.pos+=4,t},readDouble:function(){var t=Wc(this.buf,this.pos,!0,52,8);return this.pos+=8,t},readVarint:function(t){var e,n,r=this.buf;return e=127&(n=r[this.pos++]),n<128?e:(e|=(127&(n=r[this.pos++]))<<7,n<128?e:(e|=(127&(n=r[this.pos++]))<<14,n<128?e:(e|=(127&(n=r[this.pos++]))<<21,n<128?e:function(t,e,n){var r,i,a=n.buf;if(i=a[n.pos++],r=(112&i)>>4,i<128)return Qc(t,r,e);if(i=a[n.pos++],r|=(127&i)<<3,i<128)return Qc(t,r,e);if(i=a[n.pos++],r|=(127&i)<<10,i<128)return Qc(t,r,e);if(i=a[n.pos++],r|=(127&i)<<17,i<128)return Qc(t,r,e);if(i=a[n.pos++],r|=(127&i)<<24,i<128)return Qc(t,r,e);if(i=a[n.pos++],r|=(1&i)<<31,i<128)return Qc(t,r,e);throw new Error("Expected varint not more than 10 bytes")}(e|=(15&(n=r[this.pos]))<<28,t,this))))},readVarint64:function(){return this.readVarint(!0)},readSVarint:function(){var t=this.readVarint();return t%2==1?(t+1)/-2:t/2},readBoolean:function(){return Boolean(this.readVarint())},readString:function(){var t=this.readVarint()+this.pos,e=this.pos;return this.pos=t,t-e>=12&&Zc?function(t,e,n){return Zc.decode(t.subarray(e,n))}(this.buf,e,t):function(t,e,n){var r="",i=e;for(;i<n;){var a,o,s,u=t[i],l=null,c=u>239?4:u>223?3:u>191?2:1;if(i+c>n)break;1===c?u<128&&(l=u):2===c?128==(192&(a=t[i+1]))&&(l=(31&u)<<6|63&a)<=127&&(l=null):3===c?(a=t[i+1],o=t[i+2],128==(192&a)&&128==(192&o)&&((l=(15&u)<<12|(63&a)<<6|63&o)<=2047||l>=55296&&l<=57343)&&(l=null)):4===c&&(a=t[i+1],o=t[i+2],s=t[i+3],128==(192&a)&&128==(192&o)&&128==(192&s)&&((l=(15&u)<<18|(63&a)<<12|(63&o)<<6|63&s)<=65535||l>=1114112)&&(l=null)),null===l?(l=65533,c=1):l>65535&&(l-=65536,r+=String.fromCharCode(l>>>10&1023|55296),l=56320|1023&l),r+=String.fromCharCode(l),i+=c;}return r}(this.buf,e,t)},readBytes:function(){var t=this.readVarint()+this.pos,e=this.buf.subarray(this.pos,t);return this.pos=t,e},readPackedVarint:function(t,e){if(this.type!==Yc.Bytes)return t.push(this.readVarint(e));var n=Jc(this);for(t=t||[];this.pos<n;)t.push(this.readVarint(e));return t},readPackedSVarint:function(t){if(this.type!==Yc.Bytes)return t.push(this.readSVarint());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readSVarint());return t},readPackedBoolean:function(t){if(this.type!==Yc.Bytes)return t.push(this.readBoolean());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readBoolean());return t},readPackedFloat:function(t){if(this.type!==Yc.Bytes)return t.push(this.readFloat());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readFloat());return t},readPackedDouble:function(t){if(this.type!==Yc.Bytes)return t.push(this.readDouble());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readDouble());return t},readPackedFixed32:function(t){if(this.type!==Yc.Bytes)return t.push(this.readFixed32());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readFixed32());return t},readPackedSFixed32:function(t){if(this.type!==Yc.Bytes)return t.push(this.readSFixed32());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readSFixed32());return t},readPackedFixed64:function(t){if(this.type!==Yc.Bytes)return t.push(this.readFixed64());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readFixed64());return t},readPackedSFixed64:function(t){if(this.type!==Yc.Bytes)return t.push(this.readSFixed64());var e=Jc(this);for(t=t||[];this.pos<e;)t.push(this.readSFixed64());return t},skip:function(t){var e=7&t;if(e===Yc.Varint)for(;this.buf[this.pos++]>127;);else if(e===Yc.Bytes)this.pos=this.readVarint()+this.pos;else if(e===Yc.Fixed32)this.pos+=4;else{if(e!==Yc.Fixed64)throw new Error("Unimplemented type: "+e);this.pos+=8;}},writeTag:function(t,e){this.writeVarint(t<<3|e);},realloc:function(t){for(var e=this.length||16;e<this.pos+t;)e*=2;if(e!==this.length){var n=new Uint8Array(e);n.set(this.buf),this.buf=n,this.length=e;}},finish:function(){return this.length=this.pos,this.pos=0,this.buf.subarray(0,this.length)},writeFixed32:function(t){this.realloc(4),lh(this.buf,t,this.pos),this.pos+=4;},writeSFixed32:function(t){this.realloc(4),lh(this.buf,t,this.pos),this.pos+=4;},writeFixed64:function(t){this.realloc(8),lh(this.buf,-1&t,this.pos),lh(this.buf,Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8;},writeSFixed64:function(t){this.realloc(8),lh(this.buf,-1&t,this.pos),lh(this.buf,Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8;},writeVarint:function(t){(t=+t||0)>268435455||t<0?function(t,e){var n,r;t>=0?(n=t%4294967296|0,r=t/4294967296|0):(r=~(-t/4294967296),4294967295^(n=~(-t%4294967296))?n=n+1|0:(n=0,r=r+1|0));if(t>=0x10000000000000000||t<-0x10000000000000000)throw new Error("Given varint doesn't fit into 10 bytes");e.realloc(10),function(t,e,n){n.buf[n.pos++]=127&t|128,t>>>=7,n.buf[n.pos++]=127&t|128,t>>>=7,n.buf[n.pos++]=127&t|128,t>>>=7,n.buf[n.pos++]=127&t|128,t>>>=7,n.buf[n.pos]=127&t;}(n,0,e),function(t,e){var n=(7&t)<<4;if(e.buf[e.pos++]|=n|((t>>>=3)?128:0),!t)return;if(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),!t)return;if(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),!t)return;if(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),!t)return;if(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),!t)return;e.buf[e.pos++]=127&t;}(r,e);}(t,this):(this.realloc(4),this.buf[this.pos++]=127&t|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=t>>>7&127))));},writeSVarint:function(t){this.writeVarint(t<0?2*-t-1:2*t);},writeBoolean:function(t){this.writeVarint(Boolean(t));},writeString:function(t){t=String(t),this.realloc(4*t.length),this.pos++;var e=this.pos;this.pos=function(t,e,n){for(var r,i,a=0;a<e.length;a++){if((r=e.charCodeAt(a))>55295&&r<57344){if(!i){r>56319||a+1===e.length?(t[n++]=239,t[n++]=191,t[n++]=189):i=r;continue}if(r<56320){t[n++]=239,t[n++]=191,t[n++]=189,i=r;continue}r=i-55296<<10|r-56320|65536,i=null;}else i&&(t[n++]=239,t[n++]=191,t[n++]=189,i=null);r<128?t[n++]=r:(r<2048?t[n++]=r>>6|192:(r<65536?t[n++]=r>>12|224:(t[n++]=r>>18|240,t[n++]=r>>12&63|128),t[n++]=r>>6&63|128),t[n++]=63&r|128);}return n}(this.buf,t,this.pos);var n=this.pos-e;n>=128&&Kc(e,n,this),this.pos=e-1,this.writeVarint(n),this.pos+=n;},writeFloat:function(t){this.realloc(4),Xc(this.buf,t,this.pos,!0,23,4),this.pos+=4;},writeDouble:function(t){this.realloc(8),Xc(this.buf,t,this.pos,!0,52,8),this.pos+=8;},writeBytes:function(t){var e=t.length;this.writeVarint(e),this.realloc(e);for(var n=0;n<e;n++)this.buf[this.pos++]=t[n];},writeRawMessage:function(t,e){this.pos++;var n=this.pos;t(e,this);var r=this.pos-n;r>=128&&Kc(n,r,this),this.pos=n-1,this.writeVarint(r),this.pos+=r;},writeMessage:function(t,e,n){this.writeTag(t,Yc.Bytes),this.writeRawMessage(e,n);},writePackedVarint:function(t,e){e.length&&this.writeMessage(t,$c,e);},writePackedSVarint:function(t,e){e.length&&this.writeMessage(t,th,e);},writePackedBoolean:function(t,e){e.length&&this.writeMessage(t,rh,e);},writePackedFloat:function(t,e){e.length&&this.writeMessage(t,eh,e);},writePackedDouble:function(t,e){e.length&&this.writeMessage(t,nh,e);},writePackedFixed32:function(t,e){e.length&&this.writeMessage(t,ih,e);},writePackedSFixed32:function(t,e){e.length&&this.writeMessage(t,ah,e);},writePackedFixed64:function(t,e){e.length&&this.writeMessage(t,oh,e);},writePackedSFixed64:function(t,e){e.length&&this.writeMessage(t,sh,e);},writeBytesField:function(t,e){this.writeTag(t,Yc.Bytes),this.writeBytes(e);},writeFixed32Field:function(t,e){this.writeTag(t,Yc.Fixed32),this.writeFixed32(e);},writeSFixed32Field:function(t,e){this.writeTag(t,Yc.Fixed32),this.writeSFixed32(e);},writeFixed64Field:function(t,e){this.writeTag(t,Yc.Fixed64),this.writeFixed64(e);},writeSFixed64Field:function(t,e){this.writeTag(t,Yc.Fixed64),this.writeSFixed64(e);},writeVarintField:function(t,e){this.writeTag(t,Yc.Varint),this.writeVarint(e);},writeSVarintField:function(t,e){this.writeTag(t,Yc.Varint),this.writeSVarint(e);},writeStringField:function(t,e){this.writeTag(t,Yc.Bytes),this.writeString(e);},writeFloatField:function(t,e){this.writeTag(t,Yc.Fixed32),this.writeFloat(e);},writeDoubleField:function(t,e){this.writeTag(t,Yc.Fixed64),this.writeDouble(e);},writeBooleanField:function(t,e){this.writeVarintField(t,Boolean(e));}};var hh=fh;function fh(t,e){this.x=t,this.y=e;}fh.prototype={clone:function(){return new fh(this.x,this.y)},add:function(t){return this.clone()._add(t)},sub:function(t){return this.clone()._sub(t)},multByPoint:function(t){return this.clone()._multByPoint(t)},divByPoint:function(t){return this.clone()._divByPoint(t)},mult:function(t){return this.clone()._mult(t)},div:function(t){return this.clone()._div(t)},rotate:function(t){return this.clone()._rotate(t)},rotateAround:function(t,e){return this.clone()._rotateAround(t,e)},matMult:function(t){return this.clone()._matMult(t)},unit:function(){return this.clone()._unit()},perp:function(){return this.clone()._perp()},round:function(){return this.clone()._round()},mag:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},equals:function(t){return this.x===t.x&&this.y===t.y},dist:function(t){return Math.sqrt(this.distSqr(t))},distSqr:function(t){var e=t.x-this.x,n=t.y-this.y;return e*e+n*n},angle:function(){return Math.atan2(this.y,this.x)},angleTo:function(t){return Math.atan2(this.y-t.y,this.x-t.x)},angleWith:function(t){return this.angleWithSep(t.x,t.y)},angleWithSep:function(t,e){return Math.atan2(this.x*e-this.y*t,this.x*t+this.y*e)},_matMult:function(t){var e=t[0]*this.x+t[1]*this.y,n=t[2]*this.x+t[3]*this.y;return this.x=e,this.y=n,this},_add:function(t){return this.x+=t.x,this.y+=t.y,this},_sub:function(t){return this.x-=t.x,this.y-=t.y,this},_mult:function(t){return this.x*=t,this.y*=t,this},_div:function(t){return this.x/=t,this.y/=t,this},_multByPoint:function(t){return this.x*=t.x,this.y*=t.y,this},_divByPoint:function(t){return this.x/=t.x,this.y/=t.y,this},_unit:function(){return this._div(this.mag()),this},_perp:function(){var t=this.y;return this.y=this.x,this.x=-t,this},_rotate:function(t){var e=Math.cos(t),n=Math.sin(t),r=e*this.x-n*this.y,i=n*this.x+e*this.y;return this.x=r,this.y=i,this},_rotateAround:function(t,e){var n=Math.cos(t),r=Math.sin(t),i=e.x+n*(this.x-e.x)-r*(this.y-e.y),a=e.y+r*(this.x-e.x)+n*(this.y-e.y);return this.x=i,this.y=a,this},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}},fh.convert=function(t){return t instanceof fh?t:Array.isArray(t)?new fh(t[0],t[1]):t};var dh=ph;function ph(t,e,n,r,i){this.properties={},this.extent=n,this.type=0,this._pbf=t,this._geometry=-1,this._keys=r,this._values=i,t.readFields(mh,this,e);}function mh(t,e,n){1==t?e.id=n.readVarint():2==t?function(t,e){var n=t.readVarint()+t.pos;for(;t.pos<n;){var r=e._keys[t.readVarint()],i=e._values[t.readVarint()];e.properties[r]=i;}}(n,e):3==t?e.type=n.readVarint():4==t&&(e._geometry=n.pos);}function gh(t){for(var e,n,r=0,i=0,a=t.length,o=a-1;i<a;o=i++)e=t[i],r+=((n=t[o]).x-e.x)*(e.y+n.y);return r}ph.types=["Unknown","Point","LineString","Polygon"],ph.prototype.loadGeometry=function(){var t=this._pbf;t.pos=this._geometry;for(var e,n=t.readVarint()+t.pos,r=1,i=0,a=0,o=0,s=[];t.pos<n;){if(i<=0){var u=t.readVarint();r=7&u,i=u>>3;}if(i--,1===r||2===r)a+=t.readSVarint(),o+=t.readSVarint(),1===r&&(e&&s.push(e),e=[]),e.push(new hh(a,o));else{if(7!==r)throw new Error("unknown command "+r);e&&e.push(e[0].clone());}}return e&&s.push(e),s},ph.prototype.bbox=function(){var t=this._pbf;t.pos=this._geometry;for(var e=t.readVarint()+t.pos,n=1,r=0,i=0,a=0,o=1/0,s=-1/0,u=1/0,l=-1/0;t.pos<e;){if(r<=0){var c=t.readVarint();n=7&c,r=c>>3;}if(r--,1===n||2===n)(i+=t.readSVarint())<o&&(o=i),i>s&&(s=i),(a+=t.readSVarint())<u&&(u=a),a>l&&(l=a);else if(7!==n)throw new Error("unknown command "+n)}return [o,u,s,l]},ph.prototype.toGeoJSON=function(t,e,n){var r,i,a=this.extent*Math.pow(2,n),o=this.extent*t,s=this.extent*e,u=this.loadGeometry(),l=ph.types[this.type];function c(t){for(var e=0;e<t.length;e++){var n=t[e],r=180-360*(n.y+s)/a;t[e]=[360*(n.x+o)/a-180,360/Math.PI*Math.atan(Math.exp(r*Math.PI/180))-90];}}switch(this.type){case 1:var h=[];for(r=0;r<u.length;r++)h[r]=u[r][0];c(u=h);break;case 2:for(r=0;r<u.length;r++)c(u[r]);break;case 3:for(u=function(t){var e=t.length;if(e<=1)return [t];for(var n,r,i=[],a=0;a<e;a++){var o=gh(t[a]);0!==o&&(void 0===r&&(r=o<0),r===o<0?(n&&i.push(n),n=[t[a]]):n.push(t[a]));}n&&i.push(n);return i}(u),r=0;r<u.length;r++)for(i=0;i<u[r].length;i++)c(u[r][i]);}1===u.length?u=u[0]:l="Multi"+l;var f={type:"Feature",geometry:{type:l,coordinates:u},properties:this.properties};return "id"in this&&(f.id=this.id),f};var vh=yh;function yh(t,e){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=t,this._keys=[],this._values=[],this._features=[],t.readFields(_h,this,e),this.length=this._features.length;}function _h(t,e,n){15===t?e.version=n.readVarint():1===t?e.name=n.readString():5===t?e.extent=n.readVarint():2===t?e._features.push(n.pos):3===t?e._keys.push(n.readString()):4===t&&e._values.push(function(t){var e=null,n=t.readVarint()+t.pos;for(;t.pos<n;){var r=t.readVarint()>>3;e=1===r?t.readString():2===r?t.readFloat():3===r?t.readDouble():4===r?t.readVarint64():5===r?t.readVarint():6===r?t.readSVarint():7===r?t.readBoolean():null;}return e}(n));}function xh(t,e,n){if(3===t){var r=new vh(n,n.readVarint()+n.pos);r.length&&(e[r.name]=r);}}yh.prototype.feature=function(t){if(t<0||t>=this._features.length)throw new Error("feature index out of bounds");this._pbf.pos=this._features[t];var e=this._pbf.readVarint()+this._pbf.pos;return new dh(this._pbf,e,this.extent,this._keys,this._values)};var Mh=function(t,e){this.layers=t.readFields(xh,{},e);};var bh=4096;function wh(t){for(var e=0,n=0,r=t.length,i=r-1,a=void 0,o=void 0;n<r;i=n++)a=t[n],e+=((o=t[i]).x-a.x)*(a.y+o.y);return e}function Eh(t){var e=t.length;if(e<=1)return [t];for(var n,r,i=[],a=0;a<e;a++){var o=wh(t[a]);0!==o&&(void 0===r&&(r=o<0),r===o<0?(n&&i.push(n),n=[t[a]]):n.push(t[a]));}return n&&i.push(n),i}var Sh={},Th={},Ah=function(t,e){Th[t]=e;},Lh=function(t){return Sh[t]},Ch=function(t,e){Sh[t]=e;};function Ph(t){if(0===t.length)return 0;for(var e,n=t[0],r=0,i=1;i<t.length;i++)e=n+t[i],Math.abs(n)>=Math.abs(t[i])?r+=n-e+t[i]:r+=t[i]-e+n,n=e;return n+r}var Rh=Object.freeze({__proto__:null,sum:Ph,max:function(t){if(0===t.length)throw new Error("max requires at least one data point");for(var e=t[0],n=1;n<t.length;n++)t[n]>e&&(e=t[n]);return e},min:function(t){if(0===t.length)throw new Error("min requires at least one data point");for(var e=t[0],n=1;n<t.length;n++)t[n]<e&&(e=t[n]);return e},mean:function(t){if(0===t.length)throw new Error("mean requires at least one data point");return Ph(t)/t.length}}),Fh=6378e3;var Dh=Math.PI/3,Ih=[0,Dh,2*Dh,3*Dh,4*Dh,5*Dh];function Nh(t){return t[0]}function Oh(t){return t[1]}var Uh=6378e3;Ah("geojson",Pc),Ah("image",function(t,e){var n=e.extent;return {images:new Promise(function(e){!function(t,e){var n=t,r=[];if("string"==typeof n)Dc({url:n},function(t,n){e(r=n);});else{var i=n.length,a=0;n.forEach(function(t){Dc({url:t},function(t,n){a++,r.push(n),a===i&&e(r);});});}}(t,function(t){e(t);});}),_id:1,dataArray:[{coordinates:[[n[0],n[1]],[n[2],n[3]]]}]}}),Ah("csv",function(t,e){var n=e.x,r=e.y,i=e.x1,a=e.y1,o=jc(t),s=[];return o.forEach(function(t,e){var o=[];n&&r&&(o=[1*t[n],1*t[r]]),i&&a&&(o=[[1*t[n],1*t[r]],[1*t[i],1*t[a]]]),t._id=e+1;var u=Object.assign({},t,{coordinates:o});s.push(u);}),{dataArray:s}}),Ah("json",function(t,e){var n=e.x,r=e.y,i=e.x1,a=e.y1,o=e.coordinates,s=[];return t.slice(0).forEach(function(t,e){var u=[];if(n&&r&&(u=[t[n],t[r]]),i&&a&&(u=[[t[n],t[r]],[t[i],t[a]]]),o){var l="Polygon";Array.isArray(o[0])||(l="Point"),Array.isArray(o[0])&&!Array.isArray(o[0][0])&&(l="LineString");var c={type:l,coordinates:[].concat(t[o])};Tc(c,!0),u=c.coordinates;}t._id=e+1;var h=Object.assign({},t,{coordinates:u});s.push(h);}),{dataArray:s}}),Ah("raster",function(t,e){var n=e.extent,r=e.width,i=e.height,a=e.min,o=e.max;return {_id:1,dataArray:[{data:Array.from(t),width:r,height:i,min:a,max:o,coordinates:[[n[0],n[1]],[n[2],n[3]]]}]}}),Ah("mvt",function(t,e){var n=new Mh(new qc(t)),r=e.sourceLayer,i=[],a=n.layers[r];if(void 0===a)return null;for(var o=0;o<a.length;o++){var s=a.feature(o).toGeoJSON(e.tile[0],e.tile[1],e.tile[2]);i.push(s);}var u={type:"FeatureCollection",features:i};return 0===i.length?null:Pc(u,e)}),Ah("vector",function(t,e){for(var n=e.tile,r=[],i=new Int32Array(t.length),a=bh*n[0],o=bh*n[1],s=0;s<t.length;s++){var u=t.feature(s),l=u.loadGeometry(),c=u.properties,h=s+1;(u.id||e.idField&&c[e.idField])&&(h=xc(u.id||c[e.idField])%1000019,i[s]=h);for(var f=Eh(l),d=0;d<f.length;d++){var p=f[d].map(function(t){return t.map(function(t){return [(a+t.x<<20-n[2]-4)-215440491,-((o+t.y<<20-n[2]-4)-106744817),0]})});r.push(Object.assign({},c,{_id:h,coordinates:p}));}}return {dataArray:r,featureKeys:i}}),Ch("grid",function(t,e){var n=t.dataArray,r=e.size;void 0===r&&(r=10);var i=function(t,e){for(var n=0;n<t.length;n++){var r=t[n];r.coordinates[1];}var i=function(t,e){var n,r=t/Fh*(180/Math.PI),i=(n=e,t/Fh*(180/Math.PI)/Math.cos(n*Math.PI/180));return {yOffset:r,xOffset:i}}(e,34.54083);if(i.xOffset<=0||i.yOffset<=0)return {gridHash:{},gridOffset:i};for(var a={},o=0;o<t.length;o++){var s=t[o],u=s.coordinates[1],l=s.coordinates[0];if(Number.isFinite(u)&&Number.isFinite(l)){var c=Math.floor((u+90)/i.yOffset),h=Math.floor((l+180)/i.xOffset),f=c+"-"+h;a[f]=a[f]||{count:0,points:[]},a[f].count+=1,a[f].points.push(s);}}return {gridHash:a,gridOffset:i}}(n,r),a=i.gridHash,o=i.gridOffset,s=function(t,e,n){return Object.keys(t).reduce(function(r,i,a){var o,s,u=i.split("-"),l=parseInt(u[0],10),c=parseInt(u[1],10),h={};if(n.field&&n.method){var f=(o=t[i].points,s=n.field,o.map(function(t){return t[s]}));h[n.method]=Rh[n.method](f);}return Object.assign(h,{_id:a+1,coordinates:[e.xOffset*c-180,e.yOffset*l-90],count:t[i].count}),r.push(h),r},[])}(a,o,e);return {yOffset:o.xOffset/360*(256<<20)/2,xOffset:o.xOffset/360*(256<<20)/2,radius:o.xOffset/360*(256<<20)/2,dataArray:s}}),Ch("hexagon",function(t,e){var n=t.dataArray,r=e.size;void 0===r&&(r=10);var i=r/(2*Math.PI*Uh)*(256<<20)/2,a=n.map(function(t){var e=function(t){var e=Math.max(Math.min(85.0511287798,t[1]),-85.0511287798),n=Math.PI/180,r=t[0]*n,i=e*n;return i=Math.log(Math.tan(Math.PI/4+i/2)),r=(256<<20)*(.5/Math.PI*r+.5)-215440491,i=(256<<20)*(-.5/Math.PI*i+(n=.5))-106744817,{x:parseInt(r),y:parseInt(i)}}(t.coordinates),n=e.x,r=e.y;return Object.assign({},t,{coordinates:[n,r]})}),o=function(){var t,e,n,r=0,i=0,a=1,o=1,s=Nh,u=Oh;function l(t){var r,i={},a=[],o=t.length;for(r=0;r<o;++r)if(!isNaN(c=+s.call(null,l=t[r],r,t))&&!isNaN(h=+u.call(null,l,r,t))){var l,c,h,f=Math.round(h/=n),d=Math.round(c=c/e-(1&f)/2),p=h-f;if(3*Math.abs(p)>1){var m=c-d,g=d+(c<d?-1:1)/2,v=f+(h<f?-1:1),y=c-g,_=h-v;m*m+p*p>y*y+_*_&&(d=g+(1&f?1:-1)/2,f=v);}var x=d+"-"+f,M=i[x];M?M.push(l):(a.push(M=i[x]=[l]),M.x=(d+(1&f)/2)*e,M.y=f*n);}return a}function c(t){var e=0,n=0;return Ih.map(function(r){var i=Math.sin(r)*t,a=-Math.cos(r)*t,o=i-e,s=a-n;return e=i,n=a,[o,s]})}return l.hexagon=function(e){return "m"+c(null==e?t:+e).join("l")+"z"},l.centers=function(){for(var s=[],u=Math.round(i/n),l=Math.round(r/e),c=u*n;c<o+t;c+=n,++u)for(var h=l*e+(1&u)*e/2;h<a+e/2;h+=e)s.push([h,c]);return s},l.mesh=function(){var e=c(t).slice(0,4).join("l");return l.centers().map(function(t){return "M"+t+"m"+e}).join("")},l.x=function(t){return arguments.length?(s=t,l):s},l.y=function(t){return arguments.length?(u=t,l):u},l.radius=function(r){return arguments.length?(e=2*(t=+r)*Math.sin(Dh),n=1.5*t,l):t},l.size=function(t){return arguments.length?(r=i=0,a=+t[0],o=+t[1],l):[a-r,o-i]},l.extent=function(t){return arguments.length?(r=+t[0][0],i=+t[0][1],a=+t[1][0],o=+t[1][1],l):[[r,i],[a,o]]},l.radius(1)}().radius(i).x(function(t){return t.coordinates[0]}).y(function(t){return t.coordinates[1]})(a),s={radius:i};return s.dataArray=o.map(function(t,n){if(e.field&&e.method){var r=(i=t,a=e.field,i.map(function(t){return t[a]}));t[e.method]=Rh[e.method](r);}var i,a,o,s,u,l,c,h,f={};return f[e.method]=t[e.method],Object.assign({},f,{count:t.length,coordinates:(o=[t.x,t.y],s=.5/Math.PI,u=-.5/Math.PI,l=.5,c=o[0],h=o[1],c=((c+215440491)/(256<<20)-.5)/s,h=((h+106744817)/(256<<20)-l)/u,h=2*(Math.atan(Math.pow(Math.E,h))-Math.PI/4),[c/(l=Math.PI/180),h/l]),_id:n+1})}),s}),Ch("map",function(t,e){var n=e.callback;return n&&(t.dataArray=t.dataArray.map(n)),t});var Bh=n(function(t,e){t.exports=function(){function t(n,r,i,a,o,s){if(!(o-a<=i)){var u=a+o>>1;!function t(n,r,i,a,o,s){for(;o>a;){if(o-a>600){var u=o-a+1,l=i-a+1,c=Math.log(u),h=.5*Math.exp(2*c/3),f=.5*Math.sqrt(c*h*(u-h)/u)*(l-u/2<0?-1:1),d=Math.max(a,Math.floor(i-l*h/u+f)),p=Math.min(o,Math.floor(i+(u-l)*h/u+f));t(n,r,i,d,p,s);}var m=r[2*i+s],g=a,v=o;for(e(n,r,a,i),r[2*o+s]>m&&e(n,r,a,o);g<v;){for(e(n,r,g,v),g++,v--;r[2*g+s]<m;)g++;for(;r[2*v+s]>m;)v--;}r[2*a+s]===m?e(n,r,a,v):e(n,r,++v,o),v<=i&&(a=v+1),i<=v&&(o=v-1);}}(n,r,u,a,o,s%2),t(n,r,i,a,u-1,s+1),t(n,r,i,u+1,o,s+1);}}function e(t,e,r,i){n(t,r,i),n(e,2*r,2*i),n(e,2*r+1,2*i+1);}function n(t,e,n){var r=t[e];t[e]=t[n],t[n]=r;}function r(t,e,n,r){var i=t-n,a=e-r;return i*i+a*a}var i=function(t){return t[0]},a=function(t){return t[1]},o=function(e,n,r,o,s){void 0===n&&(n=i),void 0===r&&(r=a),void 0===o&&(o=64),void 0===s&&(s=Float64Array),this.nodeSize=o,this.points=e;for(var u=e.length<65536?Uint16Array:Uint32Array,l=this.ids=new u(e.length),c=this.coords=new s(2*e.length),h=0;h<e.length;h++)l[h]=h,c[2*h]=n(e[h]),c[2*h+1]=r(e[h]);t(l,c,o,0,l.length-1,0);};o.prototype.range=function(t,e,n,r){return function(t,e,n,r,i,a,o){for(var s,u,l=[0,t.length-1,0],c=[];l.length;){var h=l.pop(),f=l.pop(),d=l.pop();if(f-d<=o)for(var p=d;p<=f;p++)s=e[2*p],u=e[2*p+1],s>=n&&s<=i&&u>=r&&u<=a&&c.push(t[p]);else{var m=Math.floor((d+f)/2);s=e[2*m],u=e[2*m+1],s>=n&&s<=i&&u>=r&&u<=a&&c.push(t[m]);var g=(h+1)%2;(0===h?n<=s:r<=u)&&(l.push(d),l.push(m-1),l.push(g)),(0===h?i>=s:a>=u)&&(l.push(m+1),l.push(f),l.push(g));}}return c}(this.ids,this.coords,t,e,n,r,this.nodeSize)},o.prototype.within=function(t,e,n){return function(t,e,n,i,a,o){for(var s=[0,t.length-1,0],u=[],l=a*a;s.length;){var c=s.pop(),h=s.pop(),f=s.pop();if(h-f<=o)for(var d=f;d<=h;d++)r(e[2*d],e[2*d+1],n,i)<=l&&u.push(t[d]);else{var p=Math.floor((f+h)/2),m=e[2*p],g=e[2*p+1];r(m,g,n,i)<=l&&u.push(t[p]);var v=(c+1)%2;(0===c?n-a<=m:i-a<=g)&&(s.push(f),s.push(p-1),s.push(v)),(0===c?n+a>=m:i+a>=g)&&(s.push(p+1),s.push(h),s.push(v));}}return u}(this.ids,this.coords,t,e,n,this.nodeSize)};var s={minZoom:0,maxZoom:16,radius:40,extent:512,nodeSize:64,log:!1,reduce:null,map:function(t){return t}},u=function(t){this.options=m(Object.create(s),t),this.trees=new Array(this.options.maxZoom+1);};function l(t,e,n,r,i){return {x:t,y:e,zoom:1/0,id:n,parentId:-1,numPoints:r,properties:i}}function c(t,e){var n=t.geometry.coordinates,r=n[0],i=n[1];return {x:d(r),y:p(i),zoom:1/0,index:e,parentId:-1}}function h(t){return {type:"Feature",id:t.id,properties:f(t),geometry:{type:"Point",coordinates:[(r=t.x,360*(r-.5)),(e=t.y,n=(180-360*e)*Math.PI/180,360*Math.atan(Math.exp(n))/Math.PI-90)]}};var e,n,r;}function f(t){var e=t.numPoints,n=e>=1e4?Math.round(e/1e3)+"k":e>=1e3?Math.round(e/100)/10+"k":e;return m(m({},t.properties),{cluster:!0,cluster_id:t.id,point_count:e,point_count_abbreviated:n})}function d(t){return t/360+.5}function p(t){var e=Math.sin(t*Math.PI/180),n=.5-.25*Math.log((1+e)/(1-e))/Math.PI;return n<0?0:n>1?1:n}function m(t,e){for(var n in e)t[n]=e[n];return t}function g(t){return t.x}function v(t){return t.y}return u.prototype.load=function(t){var e=this.options,n=e.log,r=e.minZoom,i=e.maxZoom,a=e.nodeSize;n&&console.time("total time");var s="prepare "+t.length+" points";n&&console.time(s),this.points=t;for(var u=[],l=0;l<t.length;l++)t[l].geometry&&u.push(c(t[l],l));this.trees[i+1]=new o(u,g,v,a,Float32Array),n&&console.timeEnd(s);for(var h=i;h>=r;h--){var f=+Date.now();u=this._cluster(u,h),this.trees[h]=new o(u,g,v,a,Float32Array),n&&console.log("z%d: %d clusters in %dms",h,u.length,+Date.now()-f);}return n&&console.timeEnd("total time"),this},u.prototype.getClusters=function(t,e){var n=((t[0]+180)%360+360)%360-180,r=Math.max(-90,Math.min(90,t[1])),i=180===t[2]?180:((t[2]+180)%360+360)%360-180,a=Math.max(-90,Math.min(90,t[3]));if(t[2]-t[0]>=360)n=-180,i=180;else if(n>i){var o=this.getClusters([n,r,180,a],e),s=this.getClusters([-180,r,i,a],e);return o.concat(s)}for(var u=this.trees[this._limitZoom(e)],l=[],c=0,f=u.range(d(n),p(a),d(i),p(r));c<f.length;c+=1){var m=f[c],g=u.points[m];l.push(g.numPoints?h(g):this.points[g.index]);}return l},u.prototype.getChildren=function(t){var e=t>>5,n=t%32,r="No cluster with the specified id.",i=this.trees[n];if(!i)throw new Error(r);var a=i.points[e];if(!a)throw new Error(r);for(var o=this.options.radius/(this.options.extent*Math.pow(2,n-1)),s=[],u=0,l=i.within(a.x,a.y,o);u<l.length;u+=1){var c=l[u],f=i.points[c];f.parentId===t&&s.push(f.numPoints?h(f):this.points[f.index]);}if(0===s.length)throw new Error(r);return s},u.prototype.getLeaves=function(t,e,n){e=e||10,n=n||0;var r=[];return this._appendLeaves(r,t,e,n,0),r},u.prototype.getTile=function(t,e,n){var r=this.trees[this._limitZoom(t)],i=Math.pow(2,t),a=this.options,o=a.extent,s=a.radius/o,u=(n-s)/i,l=(n+1+s)/i,c={features:[]};return this._addTileFeatures(r.range((e-s)/i,u,(e+1+s)/i,l),r.points,e,n,i,c),0===e&&this._addTileFeatures(r.range(1-s/i,u,1,l),r.points,i,n,i,c),e===i-1&&this._addTileFeatures(r.range(0,u,s/i,l),r.points,-1,n,i,c),c.features.length?c:null},u.prototype.getClusterExpansionZoom=function(t){for(var e=t%32-1;e<=this.options.maxZoom;){var n=this.getChildren(t);if(e++,1!==n.length)break;t=n[0].properties.cluster_id;}return e},u.prototype._appendLeaves=function(t,e,n,r,i){for(var a=0,o=this.getChildren(e);a<o.length;a+=1){var s=o[a],u=s.properties;if(u&&u.cluster?i+u.point_count<=r?i+=u.point_count:i=this._appendLeaves(t,u.cluster_id,n,r,i):i<r?i++:t.push(s),t.length===n)break}return i},u.prototype._addTileFeatures=function(t,e,n,r,i,a){for(var o=0,s=t;o<s.length;o+=1){var u=e[s[o]],l={type:1,geometry:[[Math.round(this.options.extent*(u.x*i-n)),Math.round(this.options.extent*(u.y*i-r))]],tags:u.numPoints?f(u):this.points[u.index].properties},c=u.numPoints?u.id:this.points[u.index].id;void 0!==c&&(l.id=c),a.features.push(l);}},u.prototype._limitZoom=function(t){return Math.max(this.options.minZoom,Math.min(t,this.options.maxZoom+1))},u.prototype._cluster=function(t,e){for(var n=[],r=this.options,i=r.radius,a=r.extent,o=r.reduce,s=i/(a*Math.pow(2,e)),u=0;u<t.length;u++){var c=t[u];if(!(c.zoom<=e)){c.zoom=e;for(var h=this.trees[e+1],f=h.within(c.x,c.y,s),d=c.numPoints||1,p=c.x*d,m=c.y*d,g=o&&d>1?this._map(c,!0):null,v=(u<<5)+(e+1),y=0,_=f;y<_.length;y+=1){var x=_[y],M=h.points[x];if(!(M.zoom<=e)){M.zoom=e;var b=M.numPoints||1;p+=M.x*b,m+=M.y*b,d+=b,M.parentId=v,o&&(g||(g=this._map(c,!0)),o(g,this._map(M)));}}1===d?n.push(c):(c.parentId=v,n.push(l(p/d,m/d,v,d,g)));}}return n},u.prototype._map=function(t,e){if(t.numPoints)return e?m({},t.properties):t.properties;var n=this.points[t.index].properties,r=this.options.map(n);return e&&r===n?m({},r):r},u}();});function zh(t){return t.map(function(t,e){return Object.assign({},{coordinates:t.geometry.coordinates,_id:e+1},t.properties)})}function Gh(t){var e=[1/0,1/0,-1/0,-1/0];return t.forEach(function(t){var n=t.coordinates;!function t(e,n){Array.isArray(n[0])?n.forEach(function(n){t(e,n);}):(e[0]>n[0]&&(e[0]=n[0]),e[1]>n[1]&&(e[1]=n[1]),e[2]<n[0]&&(e[2]=n[0]),e[3]<n[1]&&(e[3]=n[1]));return e}(e,n);}),e}function kh(t,e){return function t(e,n){if(Array.isArray(e[0]))return e.map(function(e){return t(e,n)});return n(e)}(t,e)}var Vh=512/(6378137*Math.PI)/2,Hh=function(t){function e(e){var n=this;t.call(this,e),this.container=this.get("container"),this.initMap(),this.addOverLayer(),setTimeout(function(){n.emit("mapLoad");},10);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){return fl.assign(pl.scene,{resizeEnable:!0,viewMode:"3D"})},e.project=function(t){var e=Math.PI/180;return {x:-6378137*t[0]*e*Vh,y:-6378137*Math.log(Math.tan(.25*Math.PI+.5*t[1]*e))*Vh}},e.prototype.initMap=function(){mapboxgl.accessToken="pk.eyJ1IjoibHp4dWUiLCJhIjoiYnhfTURyRSJ9.Ugm314vAKPHBzcPmY1p4KQ",this.map=new mapboxgl.Map(this._attrs);},e.prototype.asyncCamera=function(t){var e=this;this.engine=t;var n=t._camera,r=t.world,i=t._picking.world;n.matrixAutoUpdate=!1,r.position.x=r.position.y=256,r.matrixAutoUpdate=!1,i.position.x=i.position.y=256,i.matrixAutoUpdate=!1,this.updateCamera(),this.map.on("move",function(){e.updateCamera();});},e.prototype.updateCamera=function(){var t=this.engine,e=t.world,n=t._picking.world,r=t._camera,i=.6435011087932844,a=.5/Math.tan(i/2)*this.map.transform.height*.01,o=Math.PI/2+this.map.transform._pitch,s=Math.sin(.3217505543966422)*a/Math.sin(Math.PI-o-.3217505543966422),u=1.1*(Math.cos(Math.PI/2-this.map.transform._pitch)*s+a);this.pitch>50&&(u=1e3);var l=this.map.transform.point,c=l.x,h=l.y;r.projectionMatrix=this.makePerspectiveMatrix(i,this.map.transform.width/this.map.transform.height,1,u);var f=new p,d=(new p).makeTranslation(0,0,a),m=(new p).makeRotationX(this.map.transform._pitch),g=(new p).makeRotationZ(this.map.transform.angle),v=(new p).makeTranslation(.01*c,.01*-h,0);f.premultiply(d).premultiply(m).premultiply(g).premultiply(v),r.matrixWorld.copy(f);var y=.01*this.map.transform.scale,_=new p,x=new p,M=new p,b=new p;_.makeScale(y,y,1),x.makeTranslation(256,-256,0),M.makeTranslation(-this.map.transform.x,this.map.transform.y,0),b.makeRotationZ(Math.PI),e.matrix=new p,e.matrix.premultiply(b).premultiply(x).premultiply(_),n.matrix=new p,n.matrix.premultiply(b).premultiply(x).premultiply(_);},e.prototype.makePerspectiveMatrix=function(t,e,n,r){var i=new p,a=1/Math.tan(t/2),o=1/(n-r),s=[a/e,0,0,0,0,a,0,0,0,0,(r+n)*o,-1,0,0,2*r*n*o,0];return i.elements=s,i},e.prototype.projectFlat=function(t){return this.map.lngLatToGeodeticCoord(t)},e.prototype.getCenter=function(){return this.map.getCenter()},e.prototype.getCenterFlat=function(){return this.projectFlat(this.getCenter())},e.prototype.addOverLayer=function(){var t=document.getElementById(this.container);this.canvasContainer=t,this.renderDom=document.createElement("div"),this.renderDom.style.cssText+="position: absolute;top: 0; z-index:10;height: 100%;width: 100%;pointer-events: none;",this.renderDom.id="l7_canvaslayer",t.appendChild(this.renderDom);},e.prototype.mixMap=function(t){var e=this.map;t.getZoom=function(){return e.getZoom()},t.getCenter=function(){return e.getCenter()},t.getPitch=function(){return e.getPitch()},t.containerToLngLat=function(t){return e.unproject(t)};},e}(dl),jh="amap://styles/ba3e9759545cd618392ef073c0dfda8c?isPublic=true",Wh="amap://styles/a80c558f91b29cf56fa47f895fb1773c?isPublic=true",Xh="amap://styles/07c17002b38775b32a7a76c66cf90e99?isPublic=true",qh=Math.PI/180,Yh=0,Zh={amap:function(t){function e(e,n){t.call(this,n),this.container=e,this.initMap();}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){return fl.assign(pl.scene,{resizeEnable:!0,viewMode:"3D"})},e.project=function(t){var e=Math.max(Math.min(85.0511287798,t[1]),-85.0511287798),n=Math.PI/180,r=t[0]*n,i=e*n;i=Math.log(Math.tan(Math.PI/4+i/2));return {x:r=(256<<20)*(.5/Math.PI*r+.5)-215440491,y:i=-((256<<20)*(-.5/Math.PI*i+(n=.5))-106744817)}},e.prototype.initMap=function(){var t=this;window.forceWebGL=!0;var e=this.get("mapStyle");if(e)switch(e){case"dark":this.set("mapStyle",jh);break;case"light":this.set("mapStyle",Wh);break;case"blank":this.set("mapStyle",Xh);break;default:this.set("mapStyle",e);}this.set("zooms",[this.get("minZoom"),this.get("maxZoom")]);var n=this.get("map");n instanceof AMap.Map?(this.map=n,this.container=n.getContainer(),e&&this.setMapStyle(e),this.addOverLayer(),setTimeout(function(){t.emit("mapLoad");},100)):(this.map=new AMap.Map(this.container,this._attrs),this.map.on("complete",function(){"blank"===e&&t.map.setLayers([]),t.addOverLayer(),t.emit("mapLoad");}));},e.prototype.asyncCamera=function(t){this._engine=t,this.map.on("camerachange",this.updateCamera.bind(this)),this.updateCamera();},e.prototype.updateCamera=function(){var t=this._engine._camera,e=this.map.getCameraState();if(!e||!e.fov)throw new Error("浏览器不支持");var n=e.fov,r=e.near,i=e.far,a=e.height,o=e.pitch,s=e.rotation,u=e.aspect;o*=qh,s*=qh,t.fov=180*n/Math.PI,t.aspect=u,t.near=r,t.far=i,t.updateProjectionMatrix(),t.position.z=a*Math.cos(o),t.position.x=a*Math.sin(o)*Math.sin(s),t.position.y=-a*Math.sin(o)*Math.cos(s),t.up.x=-Math.cos(o)*Math.sin(s),t.up.y=Math.cos(o)*Math.cos(s),t.up.z=Math.sin(o),t.lookAt(0,0,0),t.position.x+=e.position.x,t.position.y+=-e.position.y;},e.prototype.projectFlat=function(t){return this.map.lngLatToGeodeticCoord(t)},e.prototype.getCenter=function(){return this.map.getCenter()},e.prototype.getCenterFlat=function(){return this.projectFlat(this.getCenter())},e.prototype.addOverLayer=function(){if(this.amapContainer=this.map.getContainer().getElementsByClassName("amap-maps")[0],!this.amapContainer)throw new Error("确保高德地图实例化完成再创建初始化L7 scene");this.renderDom=document.createElement("div"),this.renderDom.style.cssText+="position: absolute;top: 0;height: 100%;width: 100%;pointer-events: none;",this.renderDom.id="l7_canvaslayer"+Yh++,this.amapContainer.appendChild(this.renderDom),this.l7_marker_Container=document.createElement("div"),this.l7_marker_Container.className="l7_marker",this.amapContainer.appendChild(this.l7_marker_Container);},e.prototype.setMapStyle=function(t){var e=this.map;switch(t){case"dark":this.set("mapStyle",jh);break;case"light":this.set("mapStyle",Wh);break;case"blank":this.set("mapStyle",Xh);break;default:this.set("mapStyle",t);}e.setMapStyle(this.get("mapStyle")),"blank"===t&&e.setLayers([]);},e.prototype.mixMap=function(t){var n=this,r=this.map;t.project=e.project,t.getZoom=function(){return r.getZoom()},t.getCenter=function(){return r.getCenter()},t.getSize=function(){return r.getSize()},t.setCenter=function(t){var e=new AMap.LngLat(t[0],t[1]);return r.setCenter(e)},t.getPitch=function(){return r.getPitch()},t.getRotation=function(){return r.getRotation()},t.getStatus=function(){return r.getStatus()},t.getScale=function(){return r.getScale()},t.setZoom=function(t){return r.setZoom(t)},t.getBounds=function(){return r.getBounds()},t.setMapStyle=function(t){return n.setMapStyle(t)},t.setZoomAndCenter=function(t,e){var n=new AMap.LngLat(e[0],e[1]);return r.setZoomAndCenter(t,n)},t.setFeature=function(t){return r.setFeature(t)},t.setBounds=function(t){return r.setBounds(new AMap.Bounds([t[0],t[1]],[t[2],t[3]]))},t.setRotation=function(t){return r.setRotation(t)},t.setStatus=function(t){return r.setStatus(t)},t.zoomIn=function(){return r.zoomIn()},t.zoomOut=function(){return r.zoomOut()},t.panTo=function(t){return r.panTo(new AMap.LngLat(t[0],t[1]))},t.panBy=function(t,e){return r.panBy(t,e)},t.setPitch=function(t){return r.setPitch(t)},t.pixelToLngLat=function(t){var e=new AMap.Pixel(t[0],t[1]);return r.pixelToLngLat(e)},t.lngLatToPixel=function(t){return r.lnglatToPixel(new AMap.LngLat(t[0],t[1]))},t.fitBounds=function(t){return r.setBounds(new AMap.Bounds([t[0],t[1]],[t[2],t[3]]))},t.containerToLngLat=function(t){var e=new AMap.Pixel(t.x,t.y);return r.containerToLngLat(e)},t.lngLatToContainer=function(t){var e=new AMap.LngLat(t[0],t[1]);return r.lngLatToContainer(e)},t.lngLatToGeodeticCoord=function(t){var e=new AMap.LngLat(t[0],t[1]);return r.lngLatToGeodeticCoord(e)};},e}(dl),mapbox:Hh},Jh=function(t){return Zh[t.toLowerCase()]},Qh=function(t){function e(e){t.call(this,e);var n=this.get("transforms");this._transforms=n||[];var r=this.get("mapType")||"AMap";this.projectFlat=Jh(r).project,this._init();}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultCfg=function(){return {data:null,parser:{},transforms:[],options:{}}},e.prototype._init=function(){this._excuteParser(),(this.get("isCluster")||!1)&&this._executeCluster(),this._executeTrans(),this.get("projected")||this._projectCoords();},e.prototype.setData=function(t,e){void 0===e&&(e={}),Object.assign(this._attrs,e);var n=this.get("transforms");this._transforms=n||[],this.set("data",t),this._init(),this.emit("SourceUpdate");},e.prototype.updateTransfrom=function(t){var e=t.transforms;this._transforms=e,this.data=ku(this.originData),this._executeTrans(),this._projectCoords();},e.prototype._excuteParser=function(){var t=this.get("parser"),e=t.type;void 0===e&&(e="geojson");var n=this.get("data");this.originData=function(t){return Th[t]}(e)(n,t),this.data=this.originData,null===this.data||this.get("projected")||(this.data.extent=Gh(this.data.dataArray));},e.prototype._executeTrans=function(){var t=this,e=this._transforms;e.forEach(function(e){var n=e.type,r=Lh(n)(t.data,e);Object.assign(t.data,r);}),this._transforms=e;},e.prototype.transform=function(t){var e=Lh(t.type)(this.data,t);Object.assign(this.data,e);},e.prototype._executeCluster=function(){var t=this.get("Cluster")||{},e=this.get("zoom");t.zoom=Math.floor(e),this.set("cluster",t);var n=function(t,e){var n=e.radius;void 0===n&&(n=80);var r=e.maxZoom;void 0===r&&(r=18);var i=e.minZoom;void 0===i&&(i=0);var a=e.field,o=e.zoom;if(void 0===o&&(o=2),t.pointIndex){var s=t.pointIndex.getClusters(t.extent,o);return t.dataArray=zh(s),t}var u=new Bh({radius:n,minZoom:i,maxZoom:r,map:function(t){return {sum:t[a]}},reduce:function(t,e){t.sum+=e.sum;}}),l={type:"FeatureCollection"};l.features=t.dataArray.map(function(t){var e;return {type:"Feature",properties:(e={},e[a]=t[a],e),geometry:{type:"Point",coordinates:t.coordinates}}}),u.load(l.features);var c=u.getClusters(t.extent,o).map(function(t,e){return Object.assign({},{coordinates:t.geometry.coordinates,_id:e+1},t.properties)});return t.dataArray=c,{data:t,pointIndex:u}}(this.data,t);this.data=n.data,this.pointIndex=n.pointIndex;},e.prototype.updateCusterData=function(t,e){var n=this.pointIndex.getClusters(e,t);this.data.dataArray=zh(n);var r=this.get("Cluster")||{};r.zoom=Math.floor(t),r.bbox=e,this.set("cluster",r),this._projectCoords(),this.emit("SourceUpdate");},e.prototype._projectCoords=function(){var t=this;null!==this.data&&this.data.dataArray.forEach(function(e){e.coordinates=kh(e.coordinates,t._coorConvert.bind(t));});},e.prototype._getCoord=function(t){return t.geometry?t=t.geometry.coordinates:t.coordinates&&(t=t.coordinates),t},e.prototype._coordProject=function(t){var e=this;return Array.isArray(t[0][0])?t.map(function(t){return e._coordProject(t)}):Array.isArray(t[0])?t.map(function(t){return e._coorConvert(t)}):this._coorConvert(t)},e.prototype._coorConvert=function(t){var e=this.projectFlat(t);return [e.x,e.y,t[2]||0]},e.prototype.getSelectFeature=function(t){var e=this.get("data"),n=this.get("isCluster")||!1;return e.features&&!n?e.features[t-1]:this.data.dataArray[t-1]},e.prototype.getSeletFeatureIndex=function(t){if(!this.get("data").features)return t-1;for(var e=0,n=0;n<this.data.dataArray.length;n++){if(this.data.dataArray[n]._id===t)break;e++;}return e},e.prototype.destroy=function(){this.data=null,this.originData=null;},e}(dl),Kh=function(t){function e(e){t.call(this,e),this.attributes={},this.verticesCount=0,this.indexCount=0,this.indexArray=new Int32Array(0),this._init();}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._init=function(){this._calculateFeatures(),this._initAttributes(),this._buildFeatures();},e.prototype._initAttributes=function(){this.attributes.positions=new Float32Array(3*this.verticesCount),this.attributes.colors=new Float32Array(4*this.verticesCount),this.attributes.pickingIds=new Float32Array(this.verticesCount),this.attributes.sizes=new Float32Array(this.verticesCount),this.attributes.pickingIds=new Float32Array(this.verticesCount),this.get("uv")&&(this.attributes.uv=new Float32Array(2*this.verticesCount)),this.indexArray=new Int32Array(this.indexCount);},e.prototype.addFeature=function(){},e.prototype.upload=function(){},e.prototype.destroy=function(){},e.prototype.resize=function(){},e.prototype.checkIsClosed=function(t){var e=t[0][0],n=t[0][t[0].length-1];return e[0]===n[0]&&e[1]===n[1]},e.prototype.concat=function(t,e){for(var n=0,r=0,i=e;r<i.length;r+=1){n+=i[r].length;}for(var a=0,o=new t(new ArrayBuffer(n*t.BYTES_PER_ELEMENT)),s=0,u=e;s<u.length;s+=1){var l=u[s];o.set(l,a),a+=l.length;}return o},e.prototype._encodeArray=function(t,e){for(var n=t.color,r=t.id,i=t.pattern,a=t.size,o=t.bufferInfo.verticesOffset,s=this.get("imagePos"),u=o,l=0;l<e;l++){if(t.hasOwnProperty("color")&&(this.attributes.colors[4*u+4*l]=n[0],this.attributes.colors[4*u+4*l+1]=n[1],this.attributes.colors[4*u+4*l+2]=n[2],this.attributes.colors[4*u+4*l+3]=n[3]),t.hasOwnProperty("id")&&(this.attributes.pickingIds[u+l]=r),t.hasOwnProperty("size")){var c=a;Array.isArray(a)&&2===a.length&&(c=[a[0]]),Array.isArray(a)||(c=[a]),this.attributes.sizes.set(c,(u+l)*c.length);}if(t.hasOwnProperty("pattern")){var h=s[i]||{x:0,y:0};this.attributes.patterns[2*u+2*l]=h.x,this.attributes.patterns[2*u+2*l+1]=h.y;}}},e.prototype._calculateWall=function(t){var e=t.size,n=t.bufferInfo,r=n.vertices,i=n.indexOffset,a=n.verticesOffset,o=n.faceNum;this._encodeArray(t,4*o);for(var s=0;s<o;s++){var u=r.slice(3*s,3*s+3),l=r.slice(3*s+3,3*s+6);this._calculateExtrudeFace(u,l,a+4*s,i+6*s,e),t.bufferInfo.verticesOffset+=4,t.bufferInfo.indexOffset+=6;}},e.prototype._calculateExtrudeFace=function(t,e,n,r,i){this.attributes.positions.set([t[0],t[1],i,e[0],e[1],i,t[0],t[1],0,e[0],e[1],0],3*n);var a=[1,2,0,3,2,1].map(function(t){return t+n});this.get("uv")&&this.attributes.uv.set([.1,0,0,0,.1,i/2e3,0,i/2e3],2*n),this.indexArray.set(a,r);},e}(dl),$h=ef,tf=ef;function ef(t,e,n){n=n||2;var r,i,a,o,s,u,l,c=e&&e.length,h=c?e[0]*n:t.length,f=nf(t,0,h,n,!0),d=[];if(!f||f.next===f.prev)return d;if(c&&(f=function(t,e,n,r){var i,a,o,s,u,l=[];for(i=0,a=e.length;i<a;i++)o=e[i]*r,s=i<a-1?e[i+1]*r:t.length,(u=nf(t,o,s,r,!1))===u.next&&(u.steiner=!0),l.push(pf(u));for(l.sort(cf),i=0;i<l.length;i++)hf(l[i],n),n=rf(n,n.next);return n}(t,e,f,n)),t.length>80*n){r=a=t[0],i=o=t[1];for(var p=n;p<h;p+=n)(s=t[p])<r&&(r=s),(u=t[p+1])<i&&(i=u),s>a&&(a=s),u>o&&(o=u);l=0!==(l=Math.max(a-r,o-i))?1/l:0;}return af(f,d,n,r,i,l),d}function nf(t,e,n,r,i){var a,o;if(i===Af(t,e,n,r)>0)for(a=e;a<n;a+=r)o=Ef(a,t[a],t[a+1],o);else for(a=n-r;a>=e;a-=r)o=Ef(a,t[a],t[a+1],o);return o&&yf(o,o.next)&&(Sf(o),o=o.next),o}function rf(t,e){if(!t)return t;e||(e=t);var n,r=t;do{if(n=!1,r.steiner||!yf(r,r.next)&&0!==vf(r.prev,r,r.next))r=r.next;else{if(Sf(r),(r=e=r.prev)===r.next)break;n=!0;}}while(n||r!==e);return e}function af(t,e,n,r,i,a,o){if(t){!o&&a&&function(t,e,n,r){var i=t;do{null===i.z&&(i.z=df(i.x,i.y,e,n,r)),i.prevZ=i.prev,i.nextZ=i.next,i=i.next;}while(i!==t);i.prevZ.nextZ=null,i.prevZ=null,function(t){var e,n,r,i,a,o,s,u,l=1;do{for(n=t,t=null,a=null,o=0;n;){for(o++,r=n,s=0,e=0;e<l&&(s++,r=r.nextZ);e++);for(u=l;s>0||u>0&&r;)0!==s&&(0===u||!r||n.z<=r.z)?(i=n,n=n.nextZ,s--):(i=r,r=r.nextZ,u--),a?a.nextZ=i:t=i,i.prevZ=a,a=i;n=r;}a.nextZ=null,l*=2;}while(o>1)}(i);}(t,r,i,a);for(var s,u,l=t;t.prev!==t.next;)if(s=t.prev,u=t.next,a?sf(t,r,i,a):of(t))e.push(s.i/n),e.push(t.i/n),e.push(u.i/n),Sf(t),t=u.next,l=u.next;else if((t=u)===l){o?1===o?af(t=uf(rf(t),e,n),e,n,r,i,a,2):2===o&&lf(t,e,n,r,i,a):af(rf(t),e,n,r,i,a,1);break}}}function of(t){var e=t.prev,n=t,r=t.next;if(vf(e,n,r)>=0)return !1;for(var i=t.next.next;i!==t.prev;){if(mf(e.x,e.y,n.x,n.y,r.x,r.y,i.x,i.y)&&vf(i.prev,i,i.next)>=0)return !1;i=i.next;}return !0}function sf(t,e,n,r){var i=t.prev,a=t,o=t.next;if(vf(i,a,o)>=0)return !1;for(var s=i.x<a.x?i.x<o.x?i.x:o.x:a.x<o.x?a.x:o.x,u=i.y<a.y?i.y<o.y?i.y:o.y:a.y<o.y?a.y:o.y,l=i.x>a.x?i.x>o.x?i.x:o.x:a.x>o.x?a.x:o.x,c=i.y>a.y?i.y>o.y?i.y:o.y:a.y>o.y?a.y:o.y,h=df(s,u,e,n,r),f=df(l,c,e,n,r),d=t.prevZ,p=t.nextZ;d&&d.z>=h&&p&&p.z<=f;){if(d!==t.prev&&d!==t.next&&mf(i.x,i.y,a.x,a.y,o.x,o.y,d.x,d.y)&&vf(d.prev,d,d.next)>=0)return !1;if(d=d.prevZ,p!==t.prev&&p!==t.next&&mf(i.x,i.y,a.x,a.y,o.x,o.y,p.x,p.y)&&vf(p.prev,p,p.next)>=0)return !1;p=p.nextZ;}for(;d&&d.z>=h;){if(d!==t.prev&&d!==t.next&&mf(i.x,i.y,a.x,a.y,o.x,o.y,d.x,d.y)&&vf(d.prev,d,d.next)>=0)return !1;d=d.prevZ;}for(;p&&p.z<=f;){if(p!==t.prev&&p!==t.next&&mf(i.x,i.y,a.x,a.y,o.x,o.y,p.x,p.y)&&vf(p.prev,p,p.next)>=0)return !1;p=p.nextZ;}return !0}function uf(t,e,n){var r=t;do{var i=r.prev,a=r.next.next;!yf(i,a)&&_f(i,r,r.next,a)&&bf(i,a)&&bf(a,i)&&(e.push(i.i/n),e.push(r.i/n),e.push(a.i/n),Sf(r),Sf(r.next),r=t=a),r=r.next;}while(r!==t);return rf(r)}function lf(t,e,n,r,i,a){var o=t;do{for(var s=o.next.next;s!==o.prev;){if(o.i!==s.i&&gf(o,s)){var u=wf(o,s);return o=rf(o,o.next),u=rf(u,u.next),af(o,e,n,r,i,a),void af(u,e,n,r,i,a)}s=s.next;}o=o.next;}while(o!==t)}function cf(t,e){return t.x-e.x}function hf(t,e){if(e=function(t,e){var n,r=e,i=t.x,a=t.y,o=-1/0;do{if(a<=r.y&&a>=r.next.y&&r.next.y!==r.y){var s=r.x+(a-r.y)*(r.next.x-r.x)/(r.next.y-r.y);if(s<=i&&s>o){if(o=s,s===i){if(a===r.y)return r;if(a===r.next.y)return r.next}n=r.x<r.next.x?r:r.next;}}r=r.next;}while(r!==e);if(!n)return null;if(i===o)return n;var u,l=n,c=n.x,h=n.y,f=1/0;r=n;do{i>=r.x&&r.x>=c&&i!==r.x&&mf(a<h?i:o,a,c,h,a<h?o:i,a,r.x,r.y)&&(u=Math.abs(a-r.y)/(i-r.x),bf(r,t)&&(u<f||u===f&&(r.x>n.x||r.x===n.x&&ff(n,r)))&&(n=r,f=u)),r=r.next;}while(r!==l);return n}(t,e)){var n=wf(e,t);rf(n,n.next);}}function ff(t,e){return vf(t.prev,t,e.prev)<0&&vf(e.next,t,t.next)<0}function df(t,e,n,r,i){return (t=1431655765&((t=858993459&((t=252645135&((t=16711935&((t=32767*(t-n)*i)|t<<8))|t<<4))|t<<2))|t<<1))|(e=1431655765&((e=858993459&((e=252645135&((e=16711935&((e=32767*(e-r)*i)|e<<8))|e<<4))|e<<2))|e<<1))<<1}function pf(t){var e=t,n=t;do{(e.x<n.x||e.x===n.x&&e.y<n.y)&&(n=e),e=e.next;}while(e!==t);return n}function mf(t,e,n,r,i,a,o,s){return (i-o)*(e-s)-(t-o)*(a-s)>=0&&(t-o)*(r-s)-(n-o)*(e-s)>=0&&(n-o)*(a-s)-(i-o)*(r-s)>=0}function gf(t,e){return t.next.i!==e.i&&t.prev.i!==e.i&&!function(t,e){var n=t;do{if(n.i!==t.i&&n.next.i!==t.i&&n.i!==e.i&&n.next.i!==e.i&&_f(n,n.next,t,e))return !0;n=n.next;}while(n!==t);return !1}(t,e)&&(bf(t,e)&&bf(e,t)&&function(t,e){var n=t,r=!1,i=(t.x+e.x)/2,a=(t.y+e.y)/2;do{n.y>a!=n.next.y>a&&n.next.y!==n.y&&i<(n.next.x-n.x)*(a-n.y)/(n.next.y-n.y)+n.x&&(r=!r),n=n.next;}while(n!==t);return r}(t,e)&&(vf(t.prev,t,e.prev)||vf(t,e.prev,e))||yf(t,e)&&vf(t.prev,t,t.next)>0&&vf(e.prev,e,e.next)>0)}function vf(t,e,n){return (e.y-t.y)*(n.x-e.x)-(e.x-t.x)*(n.y-e.y)}function yf(t,e){return t.x===e.x&&t.y===e.y}function _f(t,e,n,r){var i=Mf(vf(t,e,n)),a=Mf(vf(t,e,r)),o=Mf(vf(n,r,t)),s=Mf(vf(n,r,e));return i!==a&&o!==s||(!(0!==i||!xf(t,n,e))||(!(0!==a||!xf(t,r,e))||(!(0!==o||!xf(n,t,r))||!(0!==s||!xf(n,e,r)))))}function xf(t,e,n){return e.x<=Math.max(t.x,n.x)&&e.x>=Math.min(t.x,n.x)&&e.y<=Math.max(t.y,n.y)&&e.y>=Math.min(t.y,n.y)}function Mf(t){return t>0?1:t<0?-1:0}function bf(t,e){return vf(t.prev,t,t.next)<0?vf(t,e,t.next)>=0&&vf(t,t.prev,e)>=0:vf(t,e,t.prev)<0||vf(t,t.next,e)<0}function wf(t,e){var n=new Tf(t.i,t.x,t.y),r=new Tf(e.i,e.x,e.y),i=t.next,a=e.prev;return t.next=e,e.prev=t,n.next=i,i.prev=n,r.next=n,n.prev=r,a.next=r,r.prev=a,r}function Ef(t,e,n,r){var i=new Tf(t,e,n);return r?(i.next=r.next,i.prev=r,r.next.prev=i,r.next=i):(i.prev=i,i.next=i),i}function Sf(t){t.next.prev=t.prev,t.prev.next=t.next,t.prevZ&&(t.prevZ.nextZ=t.nextZ),t.nextZ&&(t.nextZ.prevZ=t.prevZ);}function Tf(t,e,n){this.i=t,this.x=e,this.y=n,this.prev=null,this.next=null,this.z=null,this.prevZ=null,this.nextZ=null,this.steiner=!1;}function Af(t,e,n,r){for(var i=0,a=e,o=n-r;a<n;a+=r)i+=(t[o]-t[a])*(t[a+1]+t[o+1]),o=a;return i}ef.deviation=function(t,e,n,r){var i=e&&e.length,a=i?e[0]*n:t.length,o=Math.abs(Af(t,0,a,n));if(i)for(var s=0,u=e.length;s<u;s++){var l=e[s]*n,c=s<u-1?e[s+1]*n:t.length;o-=Math.abs(Af(t,l,c,n));}var h=0;for(s=0;s<r.length;s+=3){var f=r[s]*n,d=r[s+1]*n,p=r[s+2]*n;h+=Math.abs((t[f]-t[p])*(t[d+1]-t[f+1])-(t[f]-t[d])*(t[p+1]-t[f+1]));}return 0===o&&0===h?0:Math.abs((h-o)/o)},ef.flatten=function(t){for(var e=t[0][0].length,n={vertices:[],holes:[],dimensions:e},r=0,i=0;i<t.length;i++){for(var a=0;a<t[i].length;a++)for(var o=0;o<e;o++)n.vertices.push(t[i][a][o]);i>0&&(r+=t[i-1].length,n.holes.push(r));}return n},$h.default=tf;var Lf=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this;this.get("layerData").forEach(function(e){t._calculateFill(e),delete e.bufferInfo;});},e.prototype._calculateFill=function(t){var e=t.bufferInfo,n=e.indexArray,r=e.vertices,i=e.indexOffset,a=e.verticesOffset,o=r.length/3;this._encodeArray(t,r.length/3);for(var s=0;s<o;s++)this.attributes.positions.set([r[3*s],r[3*s+1],0],3*(a+s)),this.get("uv")&&this.attributes.uv.set([0,0,1,1,1,0,0,1,1,1,0,0],3*(a+s));t.bufferInfo.verticesOffset+=o,this.indexArray.set(n,i),t.bufferInfo.indexOffset+=n.length;},e.prototype._calculateFeatures=function(){var t=this;this.get("layerData").forEach(function(e){var n=e.coordinates,r={},i=$h.flatten(n),a=i.vertices,o=i.dimensions,s=i.holes,u=$h(a,s,o).map(function(e){return t.verticesCount+e});r.vertices=a,r.indexArray=u,r.verticesOffset=t.verticesCount+0,r.indexOffset=t.indexCount+0,t.indexCount+=u.length,t.verticesCount+=a.length/3,e.bufferInfo=r;});},e}(Kh),Cf=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this,e=this.get("layerData"),n=0,r=0,i=0;e.forEach(function(e){e.coordinates.forEach(function(a){var o=a.length;e.bufferInfo={verticesOffset:n},t._encodeArray(e,o);for(var s=0;s<o;s++)t.attributes.positions[3*n]=a[s][0],t.attributes.positions[3*n+1]=a[s][1],t.attributes.positions[3*n+2]=a[s][2],t.indexArray[2*r]=s+i,t.indexArray[2*r+1]=s+i+1,s===o-1&&(t.indexArray[2*r+1]=n-o+1),n++,r++;i+=o;});});},e.prototype._calculateBufferLength=function(){var t=this;this.get("layerData").forEach(function(e){e.coordinates.forEach(function(e){t.verticesCount+=e.length,t.indexCount+=2*e.length-2;});});},e.prototype._calculateFeatures=function(){var t=this;this.get("layerData").forEach(function(e){e.coordinates.forEach(function(e){t.verticesCount+=e.length,t.indexCount+=2*e.length;});});},e.prototype._calculateLine=function(t){var e=this,n=t.bufferInfo,r=n.indexOffset,i=n.verticesOffset;t.coordinates.forEach(function(n){var a=n.length;e._encodeArray(t,a);for(var o=0;o<a;o++)e.attributes.positions[3*(i+o)]=n[o][0],e.attributes.positions[3*(i+o)+1]=n[o][1],e.attributes.positions[3*(i+o)+2]=n[o][2],e.indexArray[2*(r+o)]=o+2*i,e.indexArray[2*(r+o)+1]=o+2*i+1,o===a-1&&(e.indexArray[2*(r+o)+1]=i+1);i+=a,r+=a;});},e}(Kh),Pf=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this;this.get("layerData").forEach(function(e){t._calculateTop(e),t._calculateWall(e),delete e.bufferInfo;});},e.prototype._calculateFeatures=function(){var t=this;this.get("layerData").forEach(function(e){var n=e.coordinates,r={},i=$h.flatten(n),a=t.checkIsClosed(n[0])?n[0].length-1:n[0].length,o=i.vertices,s=i.dimensions,u=i.holes,l=$h(o,u,s).map(function(e){return t.verticesCount+e});r.vertices=o,r.indexArray=l,r.verticesOffset=t.verticesCount+0,r.indexOffset=t.indexCount+0,r.faceNum=a,t.indexCount+=l.length+6*a,t.verticesCount+=o.length/3+4*a,e.bufferInfo=r;});},e.prototype._calculateTop=function(t){var e=t.size,n=t.bufferInfo,r=n.indexArray,i=n.vertices,a=n.indexOffset,o=n.verticesOffset,s=i.length/3;this._encodeArray(t,i.length/3);for(var u=0;u<s;u++)this.attributes.positions.set([i[3*u],i[3*u+1],e],3*(o+u)),this.get("uv")&&this.attributes.uv.set([-1,-1],2*(o+u));t.bufferInfo.verticesOffset+=s,this.indexArray.set(r,a),t.bufferInfo.indexOffset+=r.length;},e}(Kh);function Rf(t){var e=$h.flatten(t),n=$h(e.vertices,e.holes,e.dimensions);return {positions:e.vertices,indexArray:n}}function Ff(t){var e=t[0][0],n=t[0][t[0].length-1];e[0]===n[0]&&e[1]===n[1]&&(t[0]=t[0].slice(0,t[0].length-1));for(var r=t[0].length,i=$h.flatten(t),a=[],o=[],s=[],u=0;u<i.vertices.length/3;u++)i.vertices[3*u+2]=1,s.push(0,0,1);a.push.apply(a,i.vertices);var l=$h(i.vertices,i.holes,i.dimensions);o.push.apply(o,l);for(var c=function(t){var e=i.vertices.slice(3*t,3*t+3),n=i.vertices.slice(3*t+3,3*t+6);0===n.length&&(n=i.vertices.slice(0,3));var r=a.length/3;a.push(e[0],e[1],1,n[0],n[1],1,e[0],e[1],0,n[0],n[1],0);var u=function(t,e,n){var r=new g,i=new g,a=new g,o=new g,s=new g;r.set.apply(r,t),i.set.apply(i,e),a.set.apply(a,n),o.subVectors(a,i),s.subVectors(r,i),o.cross(s),o.normalize();var u=o.x,l=o.y,c=o.z;return [u,l,c]}([n[0],n[1],1],[e[0],e[1],0],[e[0],e[1],1]);s.push.apply(s,u.concat(u,u,u)),o.push.apply(o,[1,2,0,3,2,1].map(function(t){return t+r}));},h=0;h<r;h++)c(h);return {positions:a,indexArray:o,normals:s}}function Df(){return Uf(30)}function If(){return Uf(4)}function Nf(){return Uf(3)}function Of(){return Uf(6,1)}function Uf(t,e){void 0===e&&(e=0);for(var n=2*Math.PI/t,r=[],i=0;i<t;i++)r.push(n*i+e*Math.PI/12);var a=r.map(function(t){return [Math.sin(t+Math.PI/4),Math.cos(t+Math.PI/4),0]});return a.push(a[0]),a}var Bf=Object.freeze({__proto__:null,circle:Df,square:If,triangle:Nf,hexagon:Of,cylinder:Df,triangleColumn:Nf,hexagonColumn:Of,squareColumn:If,polygonPath:Uf}),zf=pl.pointShape,Gf=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this,e=this.get("layerData");this._offset=0,this._indexOffset=0,e.forEach(function(e){t._calculateFill(e);});},e.prototype._initAttributes=function(){t.prototype._initAttributes.call(this),this.attributes.miters=new Float32Array(2*this.verticesCount),this.attributes.sizes=new Float32Array(this.verticesCount),this.attributes.shapes=new Float32Array(this.verticesCount);},e.prototype._calculateFeatures=function(){var t=this.get("layerData");this.verticesCount=4*t.length,this.indexCount=6*t.length;},e.prototype._calcultateGeometry=function(){var t=this.get("shapeType"),e=this.getShapeFunction(t)([this._getPoints(6)]);this.instanceGeometry=e;},e.prototype._calculateFill=function(t){var e=this;t.bufferInfo={verticesOffset:this._offset};var n=t.coordinates,r=t.shape,i=zf["2d"].indexOf(r)||0,a=n;1===n.length&&(a=n[0][0]),t.bufferInfo={verticesOffset:this._offset},this._encodeArray(t,4),this.attributes.shapes.set([i,i,i,i],this._offset),this.attributes.miters.set([-1,-1,1,-1,1,1,-1,1],2*this._offset);var o=[0,1,2,0,2,3].map(function(t){return t+e._offset});this.indexArray.set(o,1.5*this._offset);for(var s=[],u=0;u<4;u++)s.push.apply(s,a);this.attributes.positions.set(s,3*this._offset),this._offset+=4;},e.prototype._getPoints=function(t){return Uf(t,1)},e.prototype.getShape=function(t){var e=pl.pointShape;if(this.geometryMap[t])return this.geometryMap[t];var n=null;return n=-1!==e["3d"].indexOf(t)?Ff([Bf[t]()]):(e["2d"].indexOf(t),Rf([Bf[t]()])),this.geometryMap[t]=n,n},e}(Kh),kf=function(t,e,n){return t[0]=e[0]+n[0],t[1]=e[1]+n[1],t};var Vf=function(t,e,n){return t[0]=e,t[1]=n,t};var Hf=function(t,e){var n=e[0],r=e[1],i=n*n+r*r;i>0&&(i=1/Math.sqrt(i),t[0]=e[0]*i,t[1]=e[1]*i);return t};var jf=function(t,e,n){return t[0]=e[0]-n[0],t[1]=e[1]-n[1],t};var Wf=function(t,e){return t[0]*e[0]+t[1]*e[1]};var Xf=[0,0],qf=function(t,e,n,r,i){return kf(t,n,r),Hf(t,t),Vf(e,-t[1],t[0]),Vf(Xf,-n[1],n[0]),i/Wf(e,Xf)},Yf=function(t,e){return Vf(t,-e[1],e[0]),t},Zf=function(t,e,n){return jf(t,e,n),Hf(t,t),t},Jf=1e-6,Qf=function(){var t=new Float32Array(2);return t[0]=0,t[1]=0,t};var Kf=function(t){var e=new Float32Array(2);return e[0]=t[0],e[1]=t[1],e};var $f=function(t,e){var n=new Float32Array(2);return n[0]=t,n[1]=e,n};var td=function(t,e){return t[0]=e[0],t[1]=e[1],t};var ed=function(t,e){var n=t[0],r=t[1],i=e[0],a=e[1];return Math.abs(n-i)<=Jf*Math.max(1,Math.abs(n),Math.abs(i))&&Math.abs(r-a)<=Jf*Math.max(1,Math.abs(r),Math.abs(a))};var nd=function(t,e){return t[0]===e[0]&&t[1]===e[1]};var rd=jf,id=function(t,e,n){return t[0]=e[0]*n[0],t[1]=e[1]*n[1],t};var ad=id,od=function(t,e,n){return t[0]=e[0]/n[0],t[1]=e[1]/n[1],t};var sd=od,ud=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t};var ld=function(t,e,n){return t[0]=Math.min(e[0],n[0]),t[1]=Math.min(e[1],n[1]),t};var cd=function(t,e,n){return t[0]=Math.max(e[0],n[0]),t[1]=Math.max(e[1],n[1]),t};var hd=function(t,e,n){var r=Math.cos(n),i=Math.sin(n),a=e[0],o=e[1];return t[0]=a*r-o*i,t[1]=a*i+o*r,t};var fd=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t};var dd=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t};var pd=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t};var md=function(t,e,n){return t[0]=e[0]*n,t[1]=e[1]*n,t};var gd=function(t,e,n,r){return t[0]=e[0]+n[0]*r,t[1]=e[1]+n[1]*r,t};var vd=function(t,e){var n=e[0]-t[0],r=e[1]-t[1];return Math.sqrt(n*n+r*r)};var yd=vd,_d=function(t,e){var n=e[0]-t[0],r=e[1]-t[1];return n*n+r*r};var xd=_d,Md=function(t){var e=t[0],n=t[1];return Math.sqrt(e*e+n*n)};var bd=Md,wd=function(t){var e=t[0],n=t[1];return e*e+n*n};var Ed=wd,Sd=function(t,e){return t[0]=-e[0],t[1]=-e[1],t};var Td=function(t,e,n){var r=e[0]*n[1]-e[1]*n[0];return t[0]=t[1]=0,t[2]=r,t};var Ad=function(t,e,n,r){var i=e[0],a=e[1];return t[0]=i+r*(n[0]-i),t[1]=a+r*(n[1]-a),t};var Ld=function(t,e){e=e||1;var n=2*Math.random()*Math.PI;return t[0]=Math.cos(n)*e,t[1]=Math.sin(n)*e,t};var Cd=function(t,e,n){var r=e[0],i=e[1];return t[0]=n[0]*r+n[2]*i,t[1]=n[1]*r+n[3]*i,t};var Pd=function(t,e,n){var r=e[0],i=e[1];return t[0]=n[0]*r+n[2]*i+n[4],t[1]=n[1]*r+n[3]*i+n[5],t};var Rd=function(t,e,n){var r=e[0],i=e[1];return t[0]=n[0]*r+n[3]*i+n[6],t[1]=n[1]*r+n[4]*i+n[7],t};var Fd=function(t,e,n){var r=e[0],i=e[1];return t[0]=n[0]*r+n[4]*i+n[12],t[1]=n[1]*r+n[5]*i+n[13],t};var Dd=function(t,e,n,r,i,a){var o,s;e||(e=2);n||(n=0);s=r?Math.min(r*e+n,t.length):t.length;for(o=n;o<s;o+=e)Id[0]=t[o],Id[1]=t[o+1],i(Id,Id,a),t[o]=Id[0],t[o+1]=Id[1];return t},Id=Qf();var Nd={EPSILON:Jf,create:Qf,clone:Kf,fromValues:$f,copy:td,set:Vf,equals:ed,exactEquals:nd,add:kf,subtract:jf,sub:rd,multiply:id,mul:ad,divide:od,div:sd,inverse:ud,min:ld,max:cd,rotate:hd,floor:fd,ceil:dd,round:pd,scale:md,scaleAndAdd:gd,distance:vd,dist:yd,squaredDistance:_d,sqrDist:xd,length:Md,len:bd,squaredLength:wd,sqrLen:Ed,negate:Sd,normalize:Hf,dot:Wf,cross:Td,lerp:Ad,random:Ld,transformMat2:Cd,transformMat2d:Pd,transformMat3:Rd,transformMat4:Fd,forEach:Dd,limit:function(t,e,n){var r=e[0]*e[0]+e[1]*e[1];if(r>n*n){var i=Math.sqrt(r);t[0]=e[0]/i*n,t[1]=e[1]/i*n;}else t[0]=e[0],t[1]=e[1];return t}},Od=Nd.create,Ud=Nd.copy,Bd=Nd.dot;function zd(t,e,n,r,i,a){Gd(e,n,i,-a),Gd(e,n,i,a),t.push.apply(t,r),t.push.apply(t,r);}function Gd(t,e,n,r){t.push(n[0],n[1],0),e.push(r);}function kd(t,e){return t[0]===e[0]&&t[1]===e[1]}function Vd(t,e,n){var r=[0,0],i=[0,0],a=[0,0],o=[0,0],s=!1,u=null,l=Od(),c=n||0,h=[],f=[],d=[],p=[],m=[0,0];e&&(t=t.slice()).push(t[0]);for(var g,v,y,_,x,M=t.length,b=1;b<M;b++){var w=c,E=t[b-1],S=t[b],T=b<t.length-1?t[b+1]:null;if(!kd(E,S)){if(T)for(var A=b+1;T&&kd(S,T);)T=A<t.length-1?t[++A]:null;var L=(g=S,y=void 0,_=void 0,x=void 0,y=(v=E)[0]-g[0],_=v[1]-g[1],x=v[2]-g[2],Math.sqrt(y*y+_*_+x*x))+m[m.length-1];if(Zf(r,S,E),u||Yf(u=[0,0],r),s||(s=!0,zd(f,h,p,E,u,1)),d.push(w+0,w+2,w+1),T){Zf(i,T,S);var C=qf(a,o,r,i,1),P=Bd(a,u)<0?-1:1,R=Math.abs(C)>3;if(Math.abs(C)>1e3){zd(f,h,p,S,u,1),d.push(w+1,w+2,w+3),d.push(w+2,w+4,w+3),Yf(l,i),Ud(u,l),zd(f,h,p,S,u,1),m.push(L,L,L,L),c+=4;continue}R?(C=3,zd(f,h,p,S,u,1),d.push(w+1,w+2,w+3),d.push.apply(d,1===P?[w+2,w+4,w+5]:[w+4,w+5,w+3]),Yf(l,i),Ud(u,l),zd(f,h,p,S,u,1),m.push(L,L,L,L),c+=4):(zd(f,h,p,S,u,1),d.push(w+1,w+2,w+3),Gd(h,p,o,C*-P),f.push.apply(f,S),d.push(w+2,w+4,w+3),d.push(w+4,w+5,w+6),Yf(l,i),Ud(u,l),zd(f,h,p,S,u,1),m.push(L,L,L,L,L),c+=5);}else Yf(u,r),zd(f,h,p,S,u,1),m.push(L,L),d.push(w+1,w+2,w+3),c+=2;}}return {normals:h,attrIndex:d,attrPos:f,attrDistance:m,miters:p}}var Hd=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this,e=this.get("layerData");e.forEach(function(e){t._calculateLine(e),delete e.bufferInfo;}),this.hasPattern=e.some(function(t){return t.pattern});},e.prototype._initAttributes=function(){t.prototype._initAttributes.call(this),this.attributes.dashArray=new Float32Array(this.verticesCount),this.attributes.attrDistance=new Float32Array(this.verticesCount),this.attributes.totalDistances=new Float32Array(this.verticesCount),this.attributes.patterns=new Float32Array(2*this.verticesCount),this.attributes.miters=new Float32Array(this.verticesCount),this.attributes.normals=new Float32Array(3*this.verticesCount);},e.prototype._calculateFeatures=function(){var t=this;this.get("layerData").forEach(function(e){var n={},r=e.coordinates;Array.isArray(r[0][0])&&(r=r[0]);var i=Vd(r,!1,t.verticesCount),a=i.normals,o=i.attrIndex,s=i.attrPos,u=i.attrDistance,l=i.miters;n.normals=a,n.arrayIndex=o,n.positions=s,n.attrDistance=u,n.miters=l,n.verticesOffset=t.verticesCount,n.indexOffset=t.indexCount,t.verticesCount+=s.length/3,t.indexCount+=o.length,e.bufferInfo=n;});},e.prototype._calculateLine=function(t){var e=t.bufferInfo,n=e.normals,r=e.arrayIndex,i=e.positions,a=e.attrDistance,o=e.miters,s=e.verticesOffset,u=e.indexOffset,l=this.get("style").dashArray;void 0===l&&(l=200),this._encodeArray(t,i.length/3);var c=a[a.length-1],h=Array(i.length/3).fill(c),f=l/c,d=Array(i.length/3).fill(f);this.attributes.positions.set(i,3*s),this.indexArray.set(r,u),this.attributes.miters.set(o,s),this.attributes.normals.set(n,3*s),this.attributes.attrDistance.set(a,s),this.attributes.totalDistances.set(h,s),this.attributes.dashArray.set(d,s);},e}(Kh),jd=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this,e=this.get("layerData");e.forEach(function(e,n){t._calculateArc(e,n);}),this.hasPattern=e.some(function(t){return t.pattern});},e.prototype._initAttributes=function(){t.prototype._initAttributes.call(this),this.attributes.instanceArray=new Float32Array(4*this.verticesCount);},e.prototype._calculateArc=function(t,e){var n=this,r=this.get("style").segNum;void 0===r&&(r=30);for(var i=t.coordinates,a=function(t){if(n.attributes.positions.set([t,1,t,t,-1,t],e*r*6+6*t),n.attributes.instanceArray.set([i[0][0],i[0][1],i[1][0],i[1][1],i[0][0],i[0][1],i[1][0],i[1][1]],e*r*8+8*t),t!==r-1){var a=[0,1,2,1,3,2].map(function(n){return e*r*2+2*t+n});n.indexArray.set(a,e*r*6+6*t-6*e);}},o=0;o<r;o++)a(o);t.bufferInfo={verticesOffset:e*r*2},this._encodeArray(t,2*r);},e.prototype._calculateFeatures=function(){var t=this.get("layerData"),e=this.get("segNum")||30;this.verticesCount=t.length*e*2,this.indexCount=3*this.verticesCount-6*t.length;},e}(Kh),Wd=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this,e=this.get("layerData");this._offset=0,e.forEach(function(e){t._calculateFill(e);});},e.prototype._calculateFeatures=function(){var t=this.get("shapeType"),e=this.getShape(t),n=this.get("layerData");this.verticesCount=n.length,this.indexCount=0,this.instanceGeometry=e;},e.prototype._calculateFill=function(t){t.bufferInfo={verticesOffset:this._offset};var e=t.coordinates;this._encodeArray(t,1),this.attributes.positions.set(e,3*this._offset),this._offset++;},e.prototype.getShape=function(t){var e=pl.pointShape;return -1!==e["3d"].indexOf(t)?Ff([Bf[t]()]):(e["2d"].indexOf(t),Rf([Bf[t]()]))},e}(Kh),Xd=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._buildFeatures=function(){var t=this,e=this.get("layerData");this._offset=0,this._indexOffset=0,e.forEach(function(e){t._calculateFill(e);});},e.prototype._initAttributes=function(){t.prototype._initAttributes.call(this),this.attributes.miters=new Float32Array(3*this.verticesCount),this.attributes.normals=new Float32Array(3*this.verticesCount),this.attributes.sizes=new Float32Array(3*this.verticesCount);},e.prototype._calculateFeatures=function(){var t=this,e=this.get("layerData");this.geometryMap={},e.forEach(function(e){var n=e.shape,r=t.getShape(n),i=r.positions,a=r.indexArray;t.verticesCount+=i.length/3,t.indexCount+=a.length;});},e.prototype._calcultateGeometry=function(){var t=this.get("shapeType"),e=this.getShapeFunction(t)([this._getPoints(6)]);this.instanceGeometry=e;},e.prototype._calculateFill=function(t){var e=this;t.bufferInfo={verticesOffset:this._offset};var n=t.coordinates,r=t.shape,i=this.getShape(r),a=i.positions.length/3;this._encodeArray(t,a),this.attributes.miters.set(i.positions,3*this._offset);var o=i.indexArray.map(function(t){return t+e._offset});this.indexArray.set(o,this._indexOffset),i.normals&&this.attributes.normals.set(i.normals,3*this._offset);for(var s=[],u=0;u<a;u++)s.push.apply(s,n);this.attributes.positions.set(s,3*this._offset),this._offset+=a,this._indexOffset+=o.length;},e.prototype._getPoints=function(t){return Uf(t,1)},e.prototype.getShape=function(t){var e=pl.pointShape;if(this.geometryMap[t])return this.geometryMap[t];var n=null;return n=-1!==e["3d"].indexOf(t)?Ff([Bf[t]()]):(e["2d"].indexOf(t),Rf([Bf[t]()])),this.geometryMap[t]=n,n},e}(Kh),qd={},Yd=function(t,e){return qd[t.toLowerCase()]&&qd[t.toLowerCase()][e.toLowerCase()]},Zd=function(t,e,n){if(Yd(t,e))throw new Error("Render shapeType '"+e+"' existed.");qd[t.toLowerCase()]||(qd[t.toLowerCase()]={}),qd[t.toLowerCase()][e.toLowerCase()]=n;};function Jd(t,e){if(null==t||"boolean"==typeof t||"number"==typeof t||"string"==typeof t||t instanceof Boolean||t instanceof Number||t instanceof String||t instanceof Date||t instanceof RegExp)return t;if(t instanceof ArrayBuffer)return e&&e.push(t),t;if(ArrayBuffer.isView(t)){var n=t;return e&&e.push(n.buffer),n}if(t instanceof ImageData)return e&&e.push(t.data.buffer),t;if(Array.isArray(t)){for(var r=[],i=0,a=t;i<a.length;i+=1){var o=a[i];r.push(Jd(o,e));}return r}if("object"==typeof t){var s={};for(var u in t)if(t.hasOwnProperty(u)){var l=t[u];s[u]=Jd(l,e);}return s}}function Qd(t,e){t.forEach(function(t){e[t]&&(e[t]=e[t].bind(e));});}Zd("point","fill",Gf),Zd("polygon","fill",Lf),Zd("polygon","extrude",Pf),Zd("polygon","line",Cf),Zd("line","line",Hd),Zd("line","arc",jd),Zd("line","greatCircle",jd),Zd("heatmap","shape",Wd),Zd("point","shape",Wd),Zd("shape","extrude",Xd);var Kd=function(t,e,n){this.target=t,this.parent=e,this.mapId=n,this.callbacks={},this.callbackID=0,Qd(["receive"],this),this.target.addEventListener("message",this.receive,!1);};Kd.prototype.send=function(t,e,n,r){var i=this,a=n?this.mapId+"_"+this.callbackID++:null;n&&(this.callbacks[a]=n);if(this.target.postMessage({targetMapId:r,sourceMapId:this.mapId,type:t,id:String(a),data:e},[]),n)return {cancel:function(){return i.target.postMessage({targetMapId:r,sourceMapId:i.mapId,type:"<cancel>",id:String(a)})}}},Kd.prototype.receive=function(t){var e,n=this,r=t.data,i=r.id,a=function(t,e){delete n.callbacks[i];var r=[];n.target.postMessage({sourceMapId:n.mapId,type:"<response>",id:String(i),error:t?JSON.stringify(t):null,data:Jd(e,r)},r);};if("<response>"===r.type||"<cancel>"===r.type)e=this.callbacks[r.id],delete this.callbacks[r.id],e&&r.error?e(r.error):e&&e(null,r.data);else if(void 0!==r.id&&this.parent[r.type])this.parent[r.type](r.sourceMapId,r.data,a);else if(void 0!==r.id&&this.parent.getWorkerSource){var o=r.type.split("."),s=r.data;this.parent.getWorkerSource(r.sourceMapId,o[0],s.source)[o[1]](s,a);}else this.parent[r.type](r.data);},Kd.prototype.remove=function(){this.target.removeEventListener("message",this.receive,!1);},t.Actor=Kd,t.AdditiveBlending=X,t.AlphaFormat=re,t.Attr=oc,t.Base=dl,t.BufferGeometry=In,t.CanvasTexture=Yi,t.ClampToEdgeWrapping=Ut,t.Clock=Zi,t.Color=b,t.ColorUtil=ic,t.DataTexture=dn,t.DoubleSide=V,t.EventEmitter=r,t.Float32BufferAttribute=sa,t.FloatType=Qt,t.Global=pl,t.Group=Oi,t.InstancedBufferAttribute=oa,t.InstancedBufferGeometry=na,t.LineSegments=ta,t.LinearFilter=Vt,t.LinearMipMapLinearFilter=jt,t.LuminanceFormat=oe,t.Matrix4=p,t.Mesh=rr,t.NearestFilter=zt,t.NormalBlending=W,t.Object3D=nn,t.OrthographicCamera=ea,t.PBF=qc,t.PerspectiveCamera=Bi,t.PlaneBufferGeometry=Bn,t.Points=Qi,t.RGBAFormat=ae,t.ScaleController=$l,t.Scene=rn,t.ShaderMaterial=$n,t.Source=Qh,t.THREE=ua,t.Texture=fn,t.Uint32BufferAttribute=P,t.UniformsUtils=Mn,t.UnsignedByteType=Wt,t.Util=fl,t.Vector4=i,t.VectorTile=Mh,t.WebGLRenderTarget=Ci,t.WebGLRenderer=qi,t.bindAll=Qd,t.createCommonjsModule=n,t.flatten=Aa,t.getArrayBuffer=Fc,t.getBuffer=Yd,t.getImage=Dc,t.getMap=Jh,t.getNormals=Vd,t.isString=Na,t.lib=hs,t.lib_29=ks,t.lib_3=ms,t.lib_51=lu,t.lib_73=Ru,t.lib_87=Wu,t.lib_91=Zu,t.merge=Yo,t.polygonPath=Bf,t.registerParser=Ah,t.registerTransform=Ch,t.uniq=Ba,t.unwrapExports=e;});

define(["./shared"],function(t){"use strict";var e=function(e){function r(t,r){e.call(this,r),this.source=t,this._init();}return e&&(r.__proto__=e),r.prototype=Object.create(e&&e.prototype),r.prototype.constructor=r,r.prototype._init=function(){this._initControllers(),this._initTileAttrs(),this._mapping();},r.prototype.update=function(){this.set("scales",{}),this._initTileAttrs(),this._updateMaping();},r.prototype._initControllers=function(){var e=this.get("scaleOptions"),r=new t.ScaleController({defs:Object.assign({},e)});this.set("scaleController",r);},r.prototype._createScale=function(t){var e=this.get("scales");this._initControllers();var r=e[t];return r||(r=this.createScale(t),e[t]=r),r},r.prototype.createScale=function(t){var e=this.source.data.dataArray,r=this.get("scales"),o=r[t],a=this.get("scaleController");return o||(o=a.createScale(t,e),r[t]=o),o},r.prototype._getAttrValues=function(t,e){for(var r=t.scales,o=[],a=0;a<r.length;a++){var i=r[a],s=i.field;"identity"===i.type?o.push(i.value):o.push(e[s]);}var n=o.indexOf("zoom");return -1!==n&&(o[n]=t.zoom),t.mapping.apply(t,o)},r.prototype._mapping=function(){for(var e=this.get("attrs"),r=[],o=this.source.data.dataArray,a=0;a<o.length;a++){var i=o[a],s={};for(var n in s.id=o[a]._id,e)if(e.hasOwnProperty(n)){var l=e[n],c=l.names,p=this._getAttrValues(l,i);if(c.length>1)for(var u=0;u<p.length;u++){var h=p[u];s[c[u]]=t.Util.isArray(h)&&1===h.length?h[0]:h;}else s[c[0]]=1===p.length?p[0]:p;}s.coordinates=i.coordinates,r.push(s);}e.hasOwnProperty("filter")&&r.forEach(function(t){!1===t.filter&&(t.color[3]=0,t.id=-t.id);}),this.layerData=r;},r.prototype._updateMaping=function(){for(var e=this.get("attrs"),r=this.source.data.dataArray,o=this.layerData,a=0;a<r.length;a++){var i=r[a];for(var s in e)if(e.hasOwnProperty(s)&&e[s].neadUpdate){var n=e[s],l=n.names,c=this._getAttrValues(n,i);if(l.length>1)for(var p=0;p<c.length;p++){var u=c[p],h=l[p];o[a][h]=t.Util.isArray(u)&&1===u.length?u[0]:u;}else o[a][l[0]]=1===c.length?c[0]:c;n.neadUpdate=!0;}}},r.prototype._initTileAttrs=function(){var t=this.get("attrOptions");for(var e in t)t.hasOwnProperty(e)&&this._updateTileAttr(e);},r.prototype._updateTileAttr=function(e){var r=this.get("attrs"),o=this.get("attrOptions")[e];o.neadUpdate=!0;for(var a=t.Util.upperFirst(e),i=this._parseFields(o.field),s=[],n=0;n<i.length;n++){var l=i[n],c=this._createScale(l);"color"===e&&t.Util.isNil(o.values)&&(o.values=t.Global.colors),s.push(c);}o.scales=s;var p=new t.Attr[a](o);r[e]=p;},r.prototype._parseFields=function(e){return t.Util.isArray(e)?e:t.Util.isString(e)?e.split("*"):[e]},r}(t.Base),r=t.Global.pointShape,o=function(t){this.tileID=t.id,this.source=t.sourceID,this.params=t;};function a(e,r){var o=t.getArrayBuffer({url:e.url},function(e,o){e?r(e):o&&r(null,{vectorTile:new t.VectorTile(new t.PBF(o.data)),rawData:o.data});});return function(){o.abort(),r();}}o.prototype.parse=function(r,o,a,i){this.status="parsing",this.data=r;var s=this._layerStyleGroupBySourceID(o)[this.source],n=this.tileID.split("_"),l={};for(var c in s){if(void 0===r.layers[c])return null;var p=s[c][0];p.sourceOption.parser.type="vector",p.sourceOption.parser.tile=n;for(var u=new t.Source(Object.assign({},p.sourceOption,{mapType:p.mapType,projected:!0,data:r.layers[c]})),h=0;h<s[c].length;h++){var d=s[c][h],y=new e(u,d);"point"===d.type&&(d.shape=this._getPointShape(y));var f=new(t.getBuffer(d.type,d.shape))({layerData:y.layerData,shape:d.shape,style:d});l[d.layerId]={buffer:{attributes:f.attributes,indexArray:f.indexArray},shape:d.shape,layerId:d.layerId,sourcelayer:c,tileId:this.tileID,featureKey:u.data.featureKeys.slice(0)};}}this.status="done",i(null,Object.assign({},l));},o.prototype._layerStyleGroupBySourceID=function(t){var e={};for(var r in t){var o=t[r].sourceOption.id,a=t[r].sourceOption.parser.sourceLayer;e[o]||(e[o]={}),e[o][a]||(e[o][a]=[]),e[o][a].push(t[r]);}return e},o.prototype._getPointShape=function(t){var e=null;if(!t.layerData[0].hasOwnProperty("shape"))return "normal";for(var o=0;o<t.layerData.length&&void 0===(e=t.layerData[o].shape);o++);return -1!==r["2d"].indexOf(e)?"fill":-1!==r["3d"].indexOf(e)?"extrude":"text"};var i=function(t,e,r){this.actor=t,this.layerStyle=e,this.loadVectorData=r||a,this.loaded={},this.loading={};};i.prototype.loadTile=function(t,e){var r=this,a=t.id;this.loading||(this.loading={});var i=this.loading[a]=new o(t);i.abort=this.loadVectorData(t,function(t,o){if(t||!o)return i.status="done",r.loaded[a]=i,e(t);i.vectorTile=o.vectorTile;var s=o.rawData;i.parse(o.vectorTile,r.layerStyle,r.actor,function(t,r){if(t||!r)return e(t);e(null,{buffer:r,rawTileData:s.slice(0)});}),r.loaded=r.loaded||{},r.loaded[a]=i;});},i.prototype.abortTile=function(t,e){var r=this.loading,o=t.id;r&&r[o]&&r[o].abort&&(r[o].abort(),delete r[o]),e();},i.prototype.reloadTile=function(t,e){var r=this.loaded,o=t.id,a=this;if(r&&r[o]){var i=r[o],s=function(t,r){var o=i.reloadCallback;o&&(delete i.reloadCallback,i.parse(i.vectorTile,a.layerStyle,a.actor,o)),e(t,r);};"parsing"===i.status?i.reloadCallback=s:"done"===i.status&&(i.vectorTile?i.parse(i.vectorTile,this.layerIndex,this.actor,s):s());}},i.prototype.removeTile=function(t,e){var r=this.loaded,o=t.id;r&&r[o]&&delete r[o],e();},i.prototype.unloadTile=function(){},i.prototype.hasTransition=function(){};var s=function(e){var r=this;this.self=e,this.actor=new t.Actor(e,this),this.workerSourceTypes={vector:i},this.workerSources={},this.self.registerWorkerSource=function(t,e){if(r.workerSourceTypes[t])throw new Error('Worker source with name "'+t+'" already registered.');r.workerSourceTypes[t]=e;},this.layerStyles={};};return s.prototype.loadTile=function(t,e,r){this.getWorkerSource(t,e.type,e.sourceID).loadTile(e,r);},s.prototype.abortTile=function(t,e,r){this.getWorkerSource(t,e.type,e.sourceID).abortTile(e,r);},s.prototype.removeTile=function(t,e,r){this.getWorkerSource(t,e.type,e.sourceID).removeTile(e,r);},s.prototype.setLayers=function(t,e,r){if(this.layerStyles[t]=e,this.workerSources[t])for(var o in this.workerSources[t].vector)this.workerSources[t].vector[o].layerStyle=e;r();},s.prototype.getWorkerSource=function(t,e,r){var o=this;if(this.workerSources[t]||(this.workerSources[t]={}),this.workerSources[t][e]||(this.workerSources[t][e]={}),!this.workerSources[t][e][r]){var a={send:function(e,r,a){o.actor.send(e,r,a,t);}};this.workerSources[t][e][r]=new this.workerSourceTypes[e](a,this.layerStyles[t]);}return this.workerSources[t][e][r]},self.worker=new s(self),s});

define(["./shared"],function(t){"use strict";!function(t,e){void 0===e&&(e={});var i=e.insertAt;if(t&&"undefined"!=typeof document){var o=document.head||document.getElementsByTagName("head")[0],r=document.createElement("style");r.type="text/css","top"===i&&o.firstChild?o.insertBefore(r,o.firstChild):o.appendChild(r),r.styleSheet?r.styleSheet.cssText=t:r.appendChild(document.createTextNode(t));}}('.l7-marker {\n\tposition: absolute !important;\n\ttop: 0;\n\tleft: 0;\n\tz-index: 5;\n}\n.l7-popup-anchor-top,\n.l7-popup-anchor-top-left,\n.l7-popup-anchor-top-right {\n    -webkit-flex-direction: column;\n    flex-direction: column;\n}\n\n.l7-popup-anchor-bottom,\n.l7-popup-anchor-bottom-left,\n.l7-popup-anchor-bottom-right {\n    -webkit-flex-direction: column-reverse;\n    flex-direction: column-reverse;\n}\n\n.l7-popup-anchor-left {\n    -webkit-flex-direction: row;\n    flex-direction: row;\n}\n\n.l7-popup-anchor-right {\n    -webkit-flex-direction: row-reverse;\n    flex-direction: row-reverse;\n}\n.l7-popup {\n  position: absolute;\n  top: 0;\n  left: 0;\n  display: -webkit-flex;\n  display: flex;\n  will-change: transform;\n  pointer-events: none;\n  z-index: 5;\n}\n.l7-popup-tip {\n  width: 0;\n  height: 0;\n  border: 10px solid transparent;\n  z-index: 1;\n}\n.l7-popup-anchor-top .l7-popup-tip {\n\t-webkit-align-self: center;\n\talign-self: center;\n\tborder-top: none;\n\tborder-bottom-color: #fff;\n}\n\n.l7-popup-anchor-top-left .l7-popup-tip {\n\t-webkit-align-self: flex-start;\n\talign-self: flex-start;\n\tborder-top: none;\n\tborder-left: none;\n\tborder-bottom-color: #fff;\n}\n\n.l7-popup-anchor-top-right .l7-popup-tip {\n\t-webkit-align-self: flex-end;\n\talign-self: flex-end;\n\tborder-top: none;\n\tborder-right: none;\n\tborder-bottom-color: #fff;\n}\n\n.l7-popup-anchor-bottom .l7-popup-tip {\n\t-webkit-align-self: center;\n\talign-self: center;\n\tborder-bottom: none;\n\tborder-top-color: #fff;\n}\n\n.l7-popup-anchor-bottom-left .l7-popup-tip {\n\t-webkit-align-self: flex-start;\n\talign-self: flex-start;\n\tborder-bottom: none;\n\tborder-left: none;\n\tborder-top-color: #fff;\n}\n\n.l7-popup-anchor-bottom-right .l7-popup-tip {\n\t-webkit-align-self: flex-end;\n\talign-self: flex-end;\n\tborder-bottom: none;\n\tborder-right: none;\n\tborder-top-color: #fff;\n}\n\n.l7-popup-anchor-left .l7-popup-tip {\n\t-webkit-align-self: center;\n\talign-self: center;\n\tborder-left: none;\n\tborder-right-color: #fff;\n}\n\n.l7-popup-anchor-right .l7-popup-tip {\n\t-webkit-align-self: center;\n\talign-self: center;\n\tborder-right: none;\n\tborder-left-color: #fff;\n}\n\n.l7-popup-close-button {\n\tposition: absolute;\n\tright: 0;\n\ttop: 0;\n\tborder: 0;\n\tpadding: 0;\n\tfont-size: 25px;\n\tline-height: 20px;\n\tborder-radius: 0 3px 0 0;\n\tcursor: pointer;\n\tbackground-color: transparent;\n}\n\n.l7-popup-close-button:hover {\n\tbackground-color: rgba(0, 0, 0, 0.05);\n}\n\n.l7-popup-content {\n\tposition: relative;\n\tbackground: #fff;\n\tborder-radius: 3px;\n\tbox-shadow: 0 1px 2px rgba(0, 0, 0, 0.1);\n\tpadding: 10px 10px 15px;\n\tpointer-events: auto;\n}\n\n.l7-popup-anchor-top-left .l7-popup-content {\n\tborder-top-left-radius: 0;\n}\n\n.l7-popup-anchor-top-right .l7-popup-content {\n\tborder-top-right-radius: 0;\n}\n\n.l7-popup-anchor-bottom-left .l7-popup-content {\n\tborder-bottom-left-radius: 0;\n}\n\n.l7-popup-anchor-bottom-right .l7-popup-content {\n\tborder-bottom-right-radius: 0;\n}\n\n.l7-popup-track-pointer {\n\tdisplay: none;\n}\n\n.l7-popup-track-pointer * {\n\tpointer-events: none;\n\tuser-select: none;\n}\n\n.l7-map:hover .l7-popup-track-pointer {\n\tdisplay: flex;\n}\n\n.l7-map:active .l7-popup-track-pointer {\n\tdisplay: none;\n}\n\n.l7-popup-close-button {\n  position: absolute;\n  right: 0;\n  top: 0;\n  border: 0;\n  border-radius: 0 3px 0 0;\n  cursor: pointer;\n  background-color: transparent;\n}\n\n.l7-popup-close-button:hover {\n  background-color: rgba(0, 0, 0, 0.05);\n}\n\n.l7-popup-content {\n  position: relative;\n  background: #fff;\n  border-radius: 3px;\n  box-shadow: 0 1px 2px rgba(0, 0, 0, 0.1);\n  padding: 10px 10px 15px;\n  pointer-events: auto;\n}\n\n/* general toolbar styles */\n\n.l7-bar {\n\tbox-shadow: 0 1px 5px rgba(0,0,0,0.65);\n\tborder-radius: 4px;\n\t}\n.l7-bar a,\n.l7-bar a:hover {\n\tbackground-color: #fff;\n\tborder-bottom: 1px solid #ccc;\n\twidth: 26px;\n\theight: 26px;\n\tline-height: 26px;\n\tdisplay: block;\n\ttext-align: center;\n\ttext-decoration: none;\n\tcolor: black;\n\t}\n.l7-bar a,\n.l7-control-layers-toggle {\n\tbackground-position: 50% 50%;\n\tbackground-repeat: no-repeat;\n\tdisplay: block;\n\t}\n.l7-bar a:hover {\n\tbackground-color: #f4f4f4;\n\t}\n.l7-bar a:first-child {\n\tborder-top-left-radius: 4px;\n\tborder-top-right-radius: 4px;\n\t}\n.l7-bar a:last-child {\n\tborder-bottom-left-radius: 4px;\n\tborder-bottom-right-radius: 4px;\n\tborder-bottom: none;\n\t}\n.l7-bar a.l7-disabled {\n\tcursor: default;\n\tbackground-color: #f4f4f4;\n\tcolor: #bbb;\n\t}\n\n\n/* control positioning */\n\n.l7-control-container {\n\tfont: 12px/1.5 "Helvetica Neue", Arial, Helvetica, sans-serif;\n}\n.l7-control-hide {\n\tdisplay: none;\n}\n.l7-control {\n\tposition: relative;\n\tz-index: 800;\n\tpointer-events: visiblePainted; /* IE 9-10 doesn\'t have auto */\n\tpointer-events: auto;\n\t}\n.l7-top,\n.l7-bottom {\n\tposition: absolute;\n\tz-index: 1000;\n\tpointer-events: none;\n\t}\n.l7-top {\n\ttop: 0;\n\t}\n.l7-right {\n\tright: 0;\n\t}\n.l7-bottom {\n\tbottom: 0;\n\t}\n.l7-left {\n\tleft: 0;\n\t}\n.l7-control {\n\tfloat: left;\n\tclear: both;\n\t}\n.l7-right .l7-control {\n\tfloat: right;\n\t}\n.l7-top .l7-control {\n\tmargin-top: 10px;\n\t}\n.l7-bottom .l7-control {\n\tmargin-bottom: 10px;\n\t}\n.l7-left .l7-control {\n\tmargin-left: 10px;\n\t}\n.l7-right .l7-control {\n\tmargin-right: 10px;\n  }\n  \n  /* attribution and scale controls */\n\n.l7-control-container .l7-control-attribution {\n\tbackground: #fff;\n\tbackground: rgba(255, 255, 255, 0.7);\n\tmargin: 0;\n\t}\n.l7-control-attribution,\n.l7-control-scale-line {\n\tpadding: 0 5px;\n\tcolor: #333;\n\t}\n.l7-control-attribution a {\n\ttext-decoration: none;\n\t}\n.l7-control-attribution a:hover {\n\ttext-decoration: underline;\n\t}\n.l7-container .l7-control-attribution,\n.l7-container .l7-control-scale {\n\tfont-size: 11px;\n\t}\n.l7-left .l7-control-scale {\n\tmargin-left: 5px;\n\t}\n.l7-bottom .l7-control-scale {\n\tmargin-bottom: 5px;\n\t}\n.l7-control-scale-line {\n\tborder: 2px solid #777;\n\tborder-top: none;\n\tline-height: 1.1;\n\tpadding: 2px 5px 1px;\n\tfont-size: 11px;\n\twhite-space: nowrap;\n\toverflow: hidden;\n\t-moz-box-sizing: border-box;\n\t     box-sizing: border-box;\n\n\tbackground: #fff;\n\tbackground: rgba(255, 255, 255, 0.5);\n\t}\n.l7-control-scale-line:not(:first-child) {\n\tborder-top: 2px solid #777;\n\tborder-bottom: none;\n\tmargin-top: -2px;\n\t}\n.l7-control-scale-line:not(:first-child):not(:last-child) {\n\tborder-bottom: 2px solid #777;\n\t}\n\n.l7-touch .l7-control-attribution,\n.l7-touch .l7-control-layers,\n.l7-touch .l7-bar {\n\tbox-shadow: none;\n\t}\n.l7-touch .l7-control-layers,\n.l7-touch .l7-bar {\n\tborder: 2px solid rgba(0,0,0,0.2);\n\tbackground-clip: padding-box;\n\t}\n\n\n\t/* layers control */\n\n.l7-control-layers {\n\tbox-shadow: 0 1px 5px rgba(0,0,0,0.4);\n\tbackground: #fff;\n\tborder-radius: 5px;\n\t}\n.l7-control-layers-toggle {\n\tbackground-image: url("data:image/svg+xml,%3C%3Fxml version%3D%221.0%22 standalone%3D%22no%22%3F%3E%3C!DOCTYPE svg PUBLIC %22-%2F%2FW3C%2F%2FDTD SVG 1.1%2F%2FEN%22 %22http%3A%2F%2Fwww.w3.org%2FGraphics%2FSVG%2F1.1%2FDTD%2Fsvg11.dtd%22%3E%3Csvg t%3D%221566292427369%22 class%3D%22icon%22 viewBox%3D%220 0 1024 1024%22 version%3D%221.1%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22 p-id%3D%228341%22 width%3D%2232%22 height%3D%2232%22 xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%3E%3Cdefs%3E%3Cstyle type%3D%22text%2Fcss%22%3E%3C%2Fstyle%3E%3C%2Fdefs%3E%3Cpath d%3D%22M256 341.333333l256 128 256-128-256-128-256 128z m276.864-208.384l341.034667 173.909334c20.736 10.581333 28.202667 34.56 16.682666 53.632a41.386667 41.386667 0 0 1-16.64 15.317333l-341.077333 173.909333a46.336 46.336 0 0 1-41.728 0L150.101333 375.808c-20.736-10.581333-28.202667-34.56-16.682666-53.632a41.386667 41.386667 0 0 1 16.64-15.317333l341.077333-173.909334c12.970667-6.613333 28.757333-6.613333 41.728 0z m0 587.349334a45.653333 45.653333 0 0 1-41.728 0l-341.034667-176.938667c-20.736-10.752-28.202667-35.157333-16.682666-54.528a41.642667 41.642667 0 0 1 16.64-15.573333 34.901333 34.901333 0 0 1 32.213333 0l308.906667 160.213333c12.928 6.741333 28.714667 6.741333 41.685333 0l308.864-160.213333a34.901333 34.901333 0 0 1 32.170667 0c20.736 10.752 28.202667 35.157333 16.682666 54.528a41.642667 41.642667 0 0 1-16.64 15.573333l-341.077333 176.938667z m0 170.666666a45.653333 45.653333 0 0 1-41.728 0l-341.034667-176.938666c-20.736-10.752-28.202667-35.157333-16.682666-54.528a41.642667 41.642667 0 0 1 16.64-15.573334 34.901333 34.901333 0 0 1 32.213333 0l308.906667 160.213334c12.928 6.741333 28.714667 6.741333 41.685333 0l308.864-160.213334a34.901333 34.901333 0 0 1 32.170667 0c20.736 10.752 28.202667 35.157333 16.682666 54.528a41.642667 41.642667 0 0 1-16.64 15.573334l-341.077333 176.938666z%22 fill%3D%22%23000000%22 p-id%3D%228342%22%3E%3C%2Fpath%3E%3C%2Fsvg%3E");\n\twidth: 36px;\n\theight: 36px;\n\t}\n.l7-retina .l7-control-layers-toggle {\n\tbackground-image: url("data:image/svg+xml,%3C%3Fxml version%3D%221.0%22 standalone%3D%22no%22%3F%3E%3C!DOCTYPE svg PUBLIC %22-%2F%2FW3C%2F%2FDTD SVG 1.1%2F%2FEN%22 %22http%3A%2F%2Fwww.w3.org%2FGraphics%2FSVG%2F1.1%2FDTD%2Fsvg11.dtd%22%3E%3Csvg t%3D%221566292427369%22 class%3D%22icon%22 viewBox%3D%220 0 1024 1024%22 version%3D%221.1%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22 p-id%3D%228341%22 width%3D%2232%22 height%3D%2232%22 xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%3E%3Cdefs%3E%3Cstyle type%3D%22text%2Fcss%22%3E%3C%2Fstyle%3E%3C%2Fdefs%3E%3Cpath d%3D%22M256 341.333333l256 128 256-128-256-128-256 128z m276.864-208.384l341.034667 173.909334c20.736 10.581333 28.202667 34.56 16.682666 53.632a41.386667 41.386667 0 0 1-16.64 15.317333l-341.077333 173.909333a46.336 46.336 0 0 1-41.728 0L150.101333 375.808c-20.736-10.581333-28.202667-34.56-16.682666-53.632a41.386667 41.386667 0 0 1 16.64-15.317333l341.077333-173.909334c12.970667-6.613333 28.757333-6.613333 41.728 0z m0 587.349334a45.653333 45.653333 0 0 1-41.728 0l-341.034667-176.938667c-20.736-10.752-28.202667-35.157333-16.682666-54.528a41.642667 41.642667 0 0 1 16.64-15.573333 34.901333 34.901333 0 0 1 32.213333 0l308.906667 160.213333c12.928 6.741333 28.714667 6.741333 41.685333 0l308.864-160.213333a34.901333 34.901333 0 0 1 32.170667 0c20.736 10.752 28.202667 35.157333 16.682666 54.528a41.642667 41.642667 0 0 1-16.64 15.573333l-341.077333 176.938667z m0 170.666666a45.653333 45.653333 0 0 1-41.728 0l-341.034667-176.938666c-20.736-10.752-28.202667-35.157333-16.682666-54.528a41.642667 41.642667 0 0 1 16.64-15.573334 34.901333 34.901333 0 0 1 32.213333 0l308.906667 160.213334c12.928 6.741333 28.714667 6.741333 41.685333 0l308.864-160.213334a34.901333 34.901333 0 0 1 32.170667 0c20.736 10.752 28.202667 35.157333 16.682666 54.528a41.642667 41.642667 0 0 1-16.64 15.573334l-341.077333 176.938666z%22 fill%3D%22%23000000%22 p-id%3D%228342%22%3E%3C%2Fpath%3E%3C%2Fsvg%3E");\n\tbackground-size: 26px 26px;\n\t}\n.l7-touch .l7-control-layers-toggle {\n\twidth: 44px;\n\theight: 44px;\n\t}\n.l7-control-layers .l7-control-layers-list,\n.l7-control-layers-expanded .l7-control-layers-toggle {\n\tdisplay: none;\n\t}\n.l7-control-layers-expanded .l7-control-layers-list {\n\tdisplay: block;\n\tposition: relative;\n\t}\n.l7-control-layers-expanded {\n\tpadding: 6px 10px 6px 6px;\n\tcolor: #333;\n\tbackground: #fff;\n\t}\n.l7-control-layers-scrollbar {\n\toverflow-y: scroll;\n\toverflow-x: hidden;\n\tpadding-right: 5px;\n\t}\n.l7-control-layers-selector {\n\tmargin-top: 2px;\n\tposition: relative;\n\ttop: 1px;\n\t}\n.l7-control-layers label {\n\tdisplay: block;\n\t}\n.l7-control-layers-separator {\n\theight: 0;\n\tborder-top: 1px solid #ddd;\n\tmargin: 5px -10px 5px -6px;\n\t}\n\n');var e=function(e){this.container=e;var i=new t.PerspectiveCamera(45,1,1,2e6);this.camera=i,this.updateSize();};e.prototype.updateSize=function(){var t=this.container;this.camera.aspect=t.clientWidth/t.clientHeight,this.camera.updateProjectionMatrix();};var i=function(t){this.container=t,this.initRender(),this.updateSize();};function o(t){if(t){if(t.children)for(var e=0;e<t.children.length;e++){o(t.children[e]);}t.geometry&&(t.geometry.dispose(),t.geometry=null),t.material&&(t.material.map&&(t.material.map.dispose(),t.material.map=null),t.material.dispose(),t.material=null);}}function r(t,e){if(t){if(t.children)for(var i=0;i<t.children.length;i++){r(t.children[i],e);}t.material&&t.material.updateUninform(e);}}i.prototype.initRender=function(){this.renderer=new t.WebGLRenderer({antialias:!0,alpha:!0,autoClear:!1}),this.renderer.setClearColor(16711680,0),this.pixelRatio=window.devicePixelRatio,this.renderer.setPixelRatio(this.pixelRatio),this.renderer.gammaInput=!0,this.renderer.gammaOutput=!0,this.renderer.shadowMap.enabled=!1,this.container.appendChild(this.renderer.domElement);},i.prototype.updateSize=function(){this.renderer.setSize(this.container.clientWidth,this.container.clientHeight);};var n=1,a=function(e,i,o){this._world=e,this._renderer=i,this._camera=o,this._pickingScene=new t.Scene,this.world=new t.Group,this._pickingScene.add(this.world);var r=this._renderer.getSize();this._width=r.width,this._height=r.height;var n={minFilter:t.LinearFilter,magFilter:t.LinearFilter,format:t.RGBAFormat,stencilBuffer:!1,depthBuffer:!0};this.pixelBuffer=new Uint8Array(4),this._pickingTexture=new t.WebGLRenderTarget(1,1,n),this._nextId=1,this._initEvents();};a.prototype._initEvents=function(){this._resizeHandler=this._resizeTexture.bind(this);},a.prototype.resize=function(){this._resizeTexture();},a.prototype.pickdata=function(t){var e={x:t.offsetX,y:t.offsetY,type:t.type,_parent:t};if("touch"===t.type.substr(0,5)){if(0===t.touches.length)return;var i=t.touches[0];e={x:i.clientX,y:i.clientY,type:t.type,_parent:i};}var o={x:0,y:0};o.x=e.x/this._width*2-1,o.y=-e.y/this._height*2+1,this._pickAllObject(e,o);},a.prototype._resizeTexture=function(){var t=this._renderer.getSize();this._width=t.width,this._height=t.height,this._pickingTexture.setSize(1,1),this._needUpdate=!0;},a.prototype._update=function(t){var e=this._pickingTexture;this._camera.setViewOffset(this._width,this._height,t.x,t.y,1,1),this._renderer.render(this._pickingScene,this._camera,e),this._camera.clearViewOffset(),this._renderer.readRenderTargetPixels(e,0,0,1,1,this.pixelBuffer);},a.prototype._filterObject=function(t){this.world.children.forEach(function(e,i){e.visible=i===t;});},a.prototype._layerIsVisable=function(t){for(var e=this._world.getLayers(),i=!1,o=0;o<e.length;o++){var r=e[o];if(t.name===r.layerId){i=r.get("visible");break}}return i},a.prototype._layerisListened=function(t,e){for(var i=this._world.getLayers(),o=!1,r=0;r<i.length;r++){var n=i[r];if(t.name===n.layerId){if("mouseup"===e||"mousedown"===e){o=n.getListeners(e).length>0||n.getListeners("click").length>0;break}o=n.getListeners(e).length>0;break}}return o},a.prototype._pickAllObject=function(t,e){var i=this;this.world.children.forEach(function(o,r){if(i._layerIsVisable(o)&&i._layerisListened(o,t.type)){i._filterObject(r);var n=i._pick(t,e,o.name);n.type=t.type,n._parent=t._parent,i._world.emit("pick-"+o.name,n);}});},a.prototype._pick=function(t,e,i){this._update(t);var o=255*this.pixelBuffer[2]*255+255*this.pixelBuffer[1]+this.pixelBuffer[0];return 16646655!==o&&0!==this.pixelBuffer[3]||(o=-999),{layerId:i,featureId:o,point2d:{x:t.x,y:t.y}}},a.prototype.add=function(t){this.world.add(t),this._needUpdate=!0;},a.prototype.remove=function(t){this.world.remove(t),this._needUpdate=!0;},a.prototype.getNextId=function(){return n++},a.prototype.destroy=function(){window.removeEventListener("resize",this._resizeHandler,!1),o(this._pickingScene),this._pickingScene=null,this._pickingTexture=null,this._pixelBuffer=null,this._world=null,this._renderer=null,this._camera=null;};var s=function(r){function n(o,n){r.call(this),this._scene=new t.Scene,this.camera=new e(o),this._camera=this.camera.camera,this.container=o,this._render=new i(o),this._renderer=this._render.renderer,this._world=n,this.world=new t.Group,this._scene.add(this.world),this._picking=function(t,e,i,o){return new a(t,e,i,o)}(this._world,this._renderer,this._camera),this.clock=new t.Clock,this.composerLayers=[];}return r&&(n.__proto__=r),n.prototype=Object.create(r&&r.prototype),n.prototype.constructor=n,n.prototype._initPostProcessing=function(){this.composerLayers.forEach(function(t){t.visible&&t.render();});},n.prototype.update=function(){var t=this;this.redraw(),setTimeout(function(){t.redraw();},50);},n.prototype.redraw=function(){this._renderer.clear(),this._renderer.render(this._scene,this._camera),this._initPostProcessing();},n.prototype.destroy=function(){o(this._scene),this.composerLayers.forEach(function(t){t.distory();}),o(this.composerLayers),this._picking.destroy(),this._picking=null,this._world=null,this.clock=null,this._camera=null,this._renderer=null;},n.prototype.renderScene=function(t){this._renderer.render(t,this._camera);},n.prototype.run=function(){this.update(),this.engineID=requestAnimationFrame(this.run.bind(this));},n.prototype.stop=function(){cancelAnimationFrame(this.engineID);},n.prototype.resize=function(){var t=this;this._render.updateSize(),this.camera.updateSize(),this._picking.resize();var e=window.devicePixelRatio;this.composerLayers.forEach(function(i){i.setSize(t.container.clientWidth*e,t.container.clientHeight*e);}),this.update();},n}(t.EventEmitter),l={},c=function(t,e){if(function(t){return l[t.toLowerCase()]}(t))throw new Error("Layer type '"+t+"' existed.");l[t]=e;},u=function(e){t.Util.assign(this,e),this.mesh||(this.mesh=this.layer),this._init();};u.prototype._init=function(){this._initControllers(),this._initAttrs(),this._mapping();},u.prototype.update=function(){this.mesh.set("scales",{}),this._initAttrs(),this._updateMaping();},u.prototype.reMapping=function(){this.mesh.set("scales",{}),this._initAttrs(),this._mapping();},u.prototype._initControllers=function(){var e=this.layer.get("scaleOptions"),i=new t.ScaleController({defs:Object.assign({},e)});this.mesh.set("scaleController",i);},u.prototype._createScale=function(t){var e=this.mesh.get("scales");this._initControllers();var i=e[t];return i||(i=this.createScale(t),e[t]=i),i},u.prototype.createScale=function(t){var e=this.mesh.layerSource.data.dataArray,i=this.mesh.get("scales"),o=i[t],r=this.mesh.get("scaleController");return o||(o=r.createScale(t,e),i[t]=o),o},u.prototype._getAttrValues=function(t,e){for(var i=t.scales,o=[],r=0;r<i.length;r++){var n=i[r],a=n.field;"identity"===n.type?o.push(n.value):o.push(e[a]);}var s=o.indexOf("zoom");return -1!==s&&(o[s]=t.zoom),t.mapping.apply(t,o)},u.prototype._mapping=function(){for(var e=this.mesh.get("attrs"),i=[],o=this.mesh.layerSource.data.dataArray,r=0;r<o.length;r++){var n=o[r],a={};if(a.id=o[r]._id,e.hasOwnProperty("filter")){var s=e.filter;if(!this._getAttrValues(s,n)[0])continue}for(var l in e)if(e.hasOwnProperty(l)){var c=e[l],u=c.names,h=this._getAttrValues(c,n);if(u.length>1)for(var p=0;p<h.length;p++){var f=h[p];a[u[p]]=t.Util.isArray(f)&&1===f.length?f[0]:f;}else a[u[0]]=1===h.length?h[0]:h;}a.coordinates=n.coordinates,i.push(a);}this.mesh.layerData=i;},u.prototype._updateMaping=function(){for(var e=this.mesh.get("attrs"),i=this.mesh.layerSource.data.dataArray,o=this.mesh.layerData,r=0;r<i.length;r++){var n=i[r];for(var a in e)if(e.hasOwnProperty(a)&&e[a].neadUpdate){var s=e[a],l=s.names,c=this._getAttrValues(s,n);if(l.length>1)for(var u=0;u<c.length;u++){var h=c[u],p=l[u];o[r][p]=t.Util.isArray(h)&&1===h.length?h[0]:h;}else o[r][l[0]]=1===c.length?c[0]:c;}}},u.prototype._initAttrs=function(){var t=this.layer.get("attrOptions");for(var e in t)t.hasOwnProperty(e)&&this._updateTileAttr(e);},u.prototype._updateTileAttr=function(e){for(var i=this.mesh.get("attrs"),o=this.layer.get("attrOptions")[e],r=t.Util.upperFirst(e),n=this._parseFields(o.field),a=[],s=0;s<n.length;s++){var l=n[s],c=this._createScale(l);"color"===e&&t.Util.isNil(o.values)&&(o.values=t.Global.colors),a.push(c);}var u=new t.Attr[r](Object.assign({},o,{scales:a}));i[e]=u;},u.prototype._parseFields=function(e){return t.Util.isArray(e)?e:t.Util.isString(e)?e.split("*"):[e]},u.prototype.getLegendCfg=function(e,i){var o=this;if(void 0===i&&(i="color"),"heatmap"===this.layer.type&&"heatmap"===this.layer.shapeType)return this.get("styleOptions").rampColors;var r=this.layer.get("scales")[e],n=this.layer.get("attrs")[i],a={};if(r){var s=r.ticks;a.value=s,a.type=r.type;var l=s.map(function(r){var a,s=o._getAttrValues(n,((a={})[e]=r,a));return "color"===i?t.ColorUtil.colorArray2RGBA(s):s});a[i]=l;}return a};var h=function(e){t.Util.assign(this,e),this.pickObject3D=new t.Object3D,this.addToPicking(this.pickObject3D);};h.prototype.getPickingId=function(){return this.layer.scene._engine._picking.getNextId()},h.prototype.addToPicking=function(t){t.name=this.layer.layerId,this.layer.scene._engine._picking.add(t);},h.prototype.removePickingObject=function(t){this.layer.scene._engine._picking.remove(t);},h.prototype.removePickingMesh=function(t){this.pickObject3D.remove(t),o(t);},h.prototype.removePickMeshByName=function(t){for(var e=0;e<this.pickObject3D.children.length;e++)this.pickObject3D.children[e].name===t&&this.removePickingMesh(this.pickObject3D.children[e]);},h.prototype.removeAllMesh=function(){var t=this;this.pickObject3D.children.forEach(function(e){t.pickObject3D.remove(e),o(e);});},h.prototype.addPickMesh=function(e){var i=this,o=e.material.clone();o.defines.PICK=!0;var n=new t.THREE[e.type](e.geometry,o);n.name=e.name,n.onBeforeRender=function(){var t=i.layer.scene.getZoom();r(n,{u_zoom:t});},this.pickObject3D.add(n);};var p=["start","process","end","reset"],f=function(t){var e=this._getDefaultCfg();Object.assign(this,e,t),this._eventHandlers=[],this._bindEvents();};f.prototype._getDefaultCfg=function(){return {startEvent:"mousedown",processEvent:"mousemove",endEvent:"mouseup",resetEvent:"dblclick"}},f.prototype._start=function(t){this.preStart(t),this.start(t),this.afterStart(t);},f.prototype.preStart=function(){},f.prototype.start=function(){},f.prototype.afterStart=function(){},f.prototype._process=function(t){this.preProcess(t),this.process(t),this.afterProcess(t);},f.prototype.preProcess=function(){},f.prototype.process=function(){},f.prototype.afterProcess=function(){},f.prototype._end=function(t){this.preEnd(t),this.end(t),this.afterEnd(t);},f.prototype.preEnd=function(){},f.prototype.end=function(){},f.prototype.afterEnd=function(){},f.prototype._reset=function(){this.preReset(),this.reset(),this.afterReset();},f.prototype.preReset=function(){},f.prototype.reset=function(){},f.prototype.afterReset=function(){},f.prototype._bindEvents=function(){var e=this;t.lib_87(p,function(i){var o=e[i+"Event"],r=t.lib_29(e,"_"+i);e.layer.on(o,r),e._eventHandlers.push({type:o,handler:r});});},f.prototype._unbindEvents=function(){var e=this,i=this._eventHandlers;t.lib_87(i,function(t){e.layer.off(t.type,t.handler);});},f.prototype.destory=function(){this._unbindEvents(),this._reset();};var d=function(t){function e(e){t.call(this,Object.assign({},{processEvent:"mousemove",resetEvent:"mouseleave"},e));}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.process=function(t){this.layer._addActiveFeature(t),this.layer.scene._engine.update();},e.prototype.reset=function(){this.layer._resetStyle(),this.layer.scene._engine.update();},e}(f),_=function(t){function e(e){t.call(this,Object.assign({},{processEvent:"click"},e));}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.process=function(t){this.layer._addActiveFeature(t),this.layer.scene._engine.update();},e}(f);function v(t,e){var i=0;return function(){for(var o=[],r=arguments.length;r--;)o[r]=arguments[r];var n=(new Date).getTime();if(!(n-i<e))return i=n,t.apply(void 0,o)}}var g=function(t){function e(e){t.call(this,Object.assign({},{endEvent:"camerachange"},e)),window.addEventListener("hashchange",this._onHashChange.bind(this),!1),this._updateHash=v(this._updateHashUnthrottled.bind(this),300);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.end=function(){this._updateHash();},e.prototype.reset=function(){},e.prototype._getHashString=function(){var t=this.layer.getCenter(),e=Math.round(100*this.layer.getZoom())/100,i=Math.ceil((e*Math.LN2+Math.log(512/360/.5))/Math.LN10),o=Math.pow(10,i),r=Math.round(t.lng*o)/o,n=Math.round(t.lat*o)/o,a=this.layer.getRotation(),s=this.layer.getPitch(),l="";return l+="#"+e+"/"+n+"/"+r,(a||s)&&(l+="/"+Math.round(10*a)/10),s&&(l+="/"+Math.round(s)),l},e.prototype._onHashChange=function(){var t=window.location.hash.replace("#","").split("/");return t.length>=3&&(this.layer.setStatus({center:[+t[2],+t[1]],zoom:+t[0],bearing:+(t[3]||0),pitch:+(t[4]||0)}),!0)},e.prototype._updateHashUnthrottled=function(){var t=this._getHashString();window.history.replaceState(window.history.state,"",t);},e.prototype.destory=function(){return window.removeEventListener("hashchange",this._onHashChange,!1),this.layer.off("camerachange",this._updateHash),clearTimeout(this._updateHash()),this},e}(f),y={},m=function(t){return y[t]},b=function(t,e){if(m(t))throw new Error("Interaction type '"+t+"' existed.");y[t]=e;};b("active",d),b("select",_),b("hash",g);var x=function(e){t.Util.assign(this,e);};x.prototype.clearAllInteractions=function(){var e=this.layer.get("interactions");return t.Util.each(e,function(t,i){t.destory(),delete e[i];}),this},x.prototype.clearInteraction=function(t){var e=this.layer.get("interactions");return e[t]&&(e[t].destory(),delete e[t]),this},x.prototype.addInteraction=function(t,e){void 0===e&&(e={}),e.layer=this.layer;var i=new(m(t))(e);return this._setInteraction(t,i),this},x.prototype._setInteraction=function(t,e){var i=this.layer.get("interactions");i[t]&&i[t].destory(),i[t]=e;};var w=function(e){t.Util.assign(this,e),this._init(),this.startPoint={x:-1,y:-1},this._selectedId=null;};w.prototype._init=function(){var t=this;this.layer.scene.on("pick-"+this.layer.layerId,function(e){var i=e.featureId,o=e.point2d,r=e.type;if("click"!==r){"mousedown"===r&&(t.startPoint=o),"mouseup"===r&&(t.endPoint=o,t.startPoint.x-t.endPoint.x==0&&t.startPoint.y-t.endPoint.y==0&&(r="click"));var n=t.layer.scene.containerToLngLat(o)||{},a=null,s=null;if(-999!==i){var l=t.layer.getSelectFeature(i,n);a=l.feature,s=l.style;}var c={featureId:i,feature:a,style:s,pixel:o,type:r,lnglat:{lng:n.lng,lat:n.lat}};i>=0&&("touch"===r.substr(0,5)&&(r="click",t.layer.emit("mousemove",c)),t.layer.emit(r,c),t._selectedId=i),i<0&&null!=t._selectedId&&(t.layer.emit("mouseleave",c),t._selectedId=null),i<0&&(t.layer.emit("unpick",c),t.layer.emit("un"+r,c)),t.layer._activeIds=i;}});},w.prototype._initMapEvent=function(){};var C=function(e){t.Util.assign(this,e),this.mesh||(this.mesh=this.layer);};C.prototype._updateColorAttributes=function(){for(var t=this,e=this.mesh.layerData,i={},o=0;o<e.length;o++){var r=e[o];i[r.id]=r.color;}this.layer._activeIds=null;var n=this.mesh.mesh.geometry.attributes.a_color,a=this.mesh.mesh.geometry.attributes.pickingId;a.array.forEach(function(o,r){var s=Math.abs(o),l=null,c=null;t.mesh.layerSource.data.featureKeys?(s=t.mesh.layerSource.data.featureKeys[s].index,l=e[s],c=i[l.id]):(l=e[s-1],c=i[s]),l.hasOwnProperty("filter")&&!1===l.filter?(n.array[4*r+0]=0,n.array[4*r+1]=0,n.array[4*r+2]=0,n.array[4*r+3]=0,a.array[r]=-o):(n.array[4*r+0]=c[0],n.array[4*r+1]=c[1],n.array[4*r+2]=c[2],n.array[4*r+3]=c[3],a.array[r]=o);}),n.needsUpdate=!0,a.needsUpdate=!0;},C.prototype._updateStyle=function(t){var e={};for(var i in t)e["u_"+i]=t[i];r(this.mesh._object3D,e);};t.ScaleController;var M=u,A=h,T=x,L=w,k=C;function S(e,i){if(!t.lib_73(e))throw new Error("First parameter to diff() is not an object");if(!t.lib_73(i))throw new Error("Second parameter to diff() is not an object");var o=[],r=t.lib_51(e),n=t.lib_51(i);return t.lib_87(t.lib_3(r,n),function(t){o.push({type:"remove",key:t,value:e[t]});}),t.lib_87(t.lib_3(n,r),function(t){o.push({type:"add",key:t,value:i[t]});}),t.lib_87(function(t,e){return t.filter(function(t){return e.indexOf(t)>-1})}(r,n),function(r){t.lib_91(e[r],i[r])||o.push({type:"update",key:r,value:i[r]});}),o}var I=1;function E(e){return t.Util.isArray(e)?e:t.Util.isString(e)?e.split("*"):[e]}var O=function(e){function i(i,o){e.call(this,o),this.scene=i,this.map=i.map,this._object3D=new t.Object3D,this._pickObject3D=new t.Object3D,this._object3D.visible=this.get("visible"),this._object3D.renderOrder=this.get("zIndex")||0,this._mapEventHandlers=[];var r=this._getUniqueId();this.set("layerId",r),this.set("mapType",this.scene.mapType),this.layerId=r,this._activeIds=null,i._engine.world.add(this._object3D),this.layerMesh=null,this.layerLineMesh=null;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getDefaultCfg=function(){return {visible:!0,zIndex:0,type:"",minZoom:0,maxZoom:22,rotation:0,option:{},attrOptions:{},scaleOptions:{},preScaleOptions:null,scales:{},attrs:{},styleOptions:{stroke:[1,1,1,1],strokeWidth:1,opacity:1,strokeOpacity:1,texture:!1},destroyed:!1,selectedOptions:null,activedOptions:{fill:[1,0,0,1]},interactions:{},animateOptions:{enable:!1}}},i.prototype.add=function(t){var e=this;if("composer"===t.type)return this._object3D=t,void this.scene._engine.composerLayers.push(t);this.layerMesh=t,this._visibleWithZoom();var i=this.scene._engine.clock.getElapsedTime();t.onBeforeRender=function(){var t=e.scene.getZoom();r(e._object3D,{u_time:e.scene._engine.clock.getElapsedTime()-i,u_zoom:t}),e.preRender();},t.onAfterRender=function(){e.afterRender();},this._object3D.add(t),this.get("pickingController").addPickMesh(t);},i.prototype.remove=function(t){"composer"!==t.type?this._object3D.remove(t):this.scene._engine.composerLayers=this.scene._engine.composerLayers.filter(function(e){return e!==t});},i.prototype._getUniqueId=function(){return I++},i.prototype._visible=function(t){this.set("visible",t),this._object3D.visible=this.get("visible");},i.prototype.source=function(e,i){var o=this;return void 0===i&&(i={}),this.scene.getTileSource(e)?(this.set("layerType","tile"),this.set("sourceOption",Object.assign({},{id:e},i)),this.scene.style.addLayer(this),this.tiles=new t.Object3D,this._object3D.add(this.tiles),this):e instanceof t.Source?(this.layerSource=e,this.layerSource.on("SourceUpdate",function(){o.repaint();}),this):(i.data=e,i.mapType=this.scene.mapType,i.zoom=this.scene.getZoom(),this.layerSource=new t.Source(i),this)},i.prototype.color=function(e,i){return this._createAttrOption("color",e,i,t.Global.colors),this},i.prototype.size=function(e,i){var o=E(e);return -1!==o.indexOf("zoom")&&(this._zoomScale=!0),t.Util.isArray(o)&&!i&&(i=o),this._createAttrOption("size",e,i,t.Global.size),this},i.prototype.scale=function(e,i){var o=this.get("scaleOptions");return t.Util.isObject(e)?t.Util.mix(o,e):o[e]=i,this},i.prototype.shape=function(e,i){return 2===e.split(":").length&&(this.shapeType=e.split(":")[0],e=e.split(":")[1]),"text"===i&&(this.shapeType=i),this._createAttrOption("shape",e,i,t.Global.shape),this},i.prototype.pattern=function(e,i){return this._createAttrOption("pattern",e,i,t.Global.pattern),this},i.prototype.active=function(e,i){return !1===e?this.set("allowActive",!1):t.Util.isObject(e)&&e.fill?(this.set("allowActive",!0),e.fill&&(e.fill=t.ColorUtil.color2RGBA(e.fill)),this.set("activedOptions",e)):(this.set("allowActive",!0),this.set("activedOptions",i||{fill:t.ColorUtil.color2RGBA(t.Global.activeColor)})),this},i.prototype.style=function(e,i){var o,r=["fill","stroke","strokeColor","color","baseColor","brightColor","windowColor"],n=this.get("styleOptions");for(var a in n||(n={},this.set("styleOptions",n)),t.Util.isObject(e)&&(i=e,e=null),e&&(o=E(e)),n.fields=o,t.Util.assign(n,i),i)-1!==r.indexOf(a)&&"none"!==n[a]&&(n[a]=t.ColorUtil.color2RGBA(n[a]));return this.set("styleOptions",n),this},i.prototype.filter=function(t,e){return this._createAttrOption("filter",t,e,!0),this},i.prototype.animate=function(e,i){var o,r=this.get("animateOptions");return r||(r={},this.set("animateOptions",r)),t.Util.isObject(e)&&(i=e,e=null),e&&(o=E(e)),r.fields=o,t.Util.assign(r,i),this.set("animateOptions",r),this},i.prototype.fitBounds=function(){var t=this.layerSource.data.extent;this.scene.fitBounds(t);},i.prototype.hide=function(){return this._visible(!1),this.scene._engine.update(),this},i.prototype.show=function(){return this._visible(!0),this.scene._engine.update(),this},i.prototype.setData=function(t,e){this.layerSource.setData(t,e),this.repaint(),this.scene._engine.update();},i.prototype._createScale=function(t){var e=this.get("scales"),i=e[t];return i||(i=this.createScale(t),e[t]=i),i},i.prototype._setAttrOptions=function(t,e){var i=this.get("attrOptions");"size"===t&&this._zoomScale&&(e.zoom=this.map.getZoom()),i[t]=e;},i.prototype._createAttrOption=function(e,i,o,r){var n={};n.field=i,o?t.Util.isFunction(o)?n.callback=o:n.values=o:"color"!==e&&(n.values=r),this._setAttrOptions(e,n);},i.prototype._initControllers=function(){var t=new A({layer:this}),e=new T({layer:this}),i=new L({layer:this});this.set("pickingController",t),this.set("interacionController",e),this.set("eventController",i);},i.prototype._mapping=function(){var t=new M({layer:this});this.set("mappingController",t);},i.prototype.render=function(){return "tile"===this.get("layerType")?(this._initControllers(),this._initInteraction(),this.scene.style.update(this._attrs),this):(this._updateDraw(),this.scene._engine.update(),this)},i.prototype.repaint=function(){this.set("scales",{}),this._mapping(),0!==this.layerData.length?this.redraw():this.clearDraw();},i.prototype.init=function(){this._initControllers(),this._mapping();},i.prototype._initInteraction=function(){this.get("allowActive")&&this.get("interacionController").addInteraction("active");},i.prototype._initMapEvent=function(){var e=this;t.Util.each(["zoomchange","dragend","camerachange","resize"],function(i){var o=t.Util.wrapBehavior(e,""+i);e.map.on(""+i,o),e._mapEventHandlers.push({type:i,handler:o});});},i.prototype.clearMapEvent=function(){var e=this,i=this._mapEventHandlers;t.Util.each(i,function(t){e.map.off(t.type,t.handler);});},i.prototype.zoomchange=function(t){this._visibleWithZoom(t);},i.prototype.dragend=function(){},i.prototype.resize=function(){this.scene._engine.update();},i.prototype.camerachange=function(t){this.emit("camerachange",t);},i.prototype.setActive=function(e,i){this._activeIds=e,i||(i=t.Global.activeColor),Array.isArray(i)||(i=t.ColorUtil.color2RGBA(i)),r(this._object3D,{u_activeColor:i,u_activeId:e}),this.scene._engine.update();},i.prototype._addActiveFeature=function(t){var e=t.featureId;this._activeIds=e,r(this._object3D,{u_activeId:e});},i.prototype._setPreOption=function(){var e=this.get("attrOptions"),i=this.get("styleOptions");this.set("preAttrOptions",t.Util.clone(e)),this.set("preStyleOption",t.Util.clone(i));},i.prototype._updateDraw=function(){var e=this.get("preAttrOptions"),i=this.get("attrOptions"),o=this.get("preStyleOption"),r=this.get("styleOptions");if(void 0!==e||void 0!==o){if(t.Util.isEqual(e.filter,i.filter)&&t.Util.isEqual(e.color,i.color)&&t.Util.isEqual(e.size,i.size)&&t.Util.isEqual(e.shape,i.shape)||this.repaint(),!t.Util.isEqual(o,r)){var n={};t.Util.each(S(o,r),function(t){var e=t.type,i=t.key,o=t.value;"remove"!==e&&(n[i]=o);}),this._updateStyle(n);}this._setPreOption();}else{if(this._setPreOption(),this.init(),this._initInteraction(),this._initMapEvent(),0===this.layerData.length)return;this.draw();}},i.prototype._updateSize=function(t){var e=this,i=this.get("attrOptions").size,o=E(i.field),r=this.layerSource.data.dataArray;if(this.zoomSizeCache||(this.zoomSizeCache={}),!this.zoomSizeCache[t]){this.zoomSizeCache[t]=[];for(var n=function(n){var a=o.map(function(t){return r[n][t]}),s=o.indexOf("zoom");-1!==s&&(a[s]=t),e.zoomSizeCache[t].push(i.callback.apply(i,a));},a=0;a<r.length;a++)n(a);}this.emit("sizeUpdated",this.zoomSizeCache[t]);},i.prototype._updateStyle=function(t){var e={};for(var i in t)e["u_"+i]=t[i];r(this._object3D,e),t.hasOwnProperty("textAllowOverlap")&&(this.repaint(),this.scene._engine.update()),t.hasOwnProperty("blending")&&this.layerMesh&&this.layerMesh.material.setBending(t.blending);},i.prototype._scaleByZoom=function(){var t=this;this._zoomScale&&this.map.on("zoomend",function(){var e=t.map.getZoom();t._updateSize(Math.floor(e));});},i.prototype.getSelectFeature=function(t,e){return "tile"===this.get("layerType")?{feature:this.getSourceCache(this.get("sourceOption").id).getSelectFeature(t,this.layerId,e)}:{feature:this.layerSource&&this.layerSource.getSelectFeature(t)||{},style:this.layerData[t-1]}},i.prototype._updateFilter=function(){this.get("mappingController").reMapping();},i.prototype._visibleWithZoom=function(){if(null!==this._object3D){var t=this.scene.getZoom(),e=this.get("minZoom"),i=this.get("maxZoom"),o=0;"point"===this.type?o=5:"polyline"===this.type||"line"===this.type?o=2:"polygon"===this.type&&(o=1),"text"===this.type&&(o=10),this._object3D.position&&(this._object3D.position.z=o*Math.pow(2,20-t)),t<e||t>=i?this._object3D.visible=!1:this.get("visible")&&(this._object3D.visible=!0);}},i.prototype.clearDraw=function(){var t=this;if(this._object3D.children&&this._object3D.children.forEach(function(e){t._object3D.remove(e);}),"composer"===this._object3D.type){var e=this.scene._engine.composerLayers.indexOf(this._object3D);this.scene._engine.composerLayers.splice(e,1);}this.updateGeometryHander&&this.off("camerachange",this.updateGeometryHander),this.get("pickingController").removeAllMesh(),this.scene._engine.update();},i.prototype.redraw=function(){this.clearDraw(),this.draw();},i.prototype._resetStyle=function(){this._activeIds=null,r(this._object3D,{u_activeId:0});},i.prototype.destroy=function(){if(this.removeAllListeners(),this.get("interacionController").clearAllInteractions(),this.clearMapEvent(),"composer"!==this._object3D.type){if(this._object3D&&this._object3D.children)for(var t,e=0;e<this._object3D.children.length;e++)(t=this._object3D.children[e])&&(this.remove(t),t.geometry&&(t.geometry=null),t.material&&(t.material.map&&(t.material.map.dispose(),t.material.map=null),t.material.dispose(),t.material=null),t=null);this.layerMesh&&(this.layerMesh.geometry=null,this.layerMesh.material=null),this._pickingMesh&&(this._pickingMesh.children[0].geometry=null,this._pickingMesh.children[0].material.dispose(),this._pickingMesh.children[0].material=null),this._buffer=null,this._object3D=null,this.scene._engine._scene.remove(this._object3D),this.layerData.length=0,this.layerSource=null,this.scene._engine._picking.remove(this._pickingMesh),this.destroyed=!0;}else this.remove(this._object3D);},i.prototype.getLegendCfg=function(t,e){return void 0===e&&(e="color"),this.get("mappingController").getLegendCfg(t,e)},i.prototype.preRender=function(){},i.prototype.afterRender=function(){},i.prototype.getSourceCache=function(t){return this.scene.style.getSource(t)},i.prototype.setHeight=function(t){this._object3D.children.forEach(function(e){e.position.z=t;}),this.scene._engine.update();},i}(t.Base),P={},D=function(t,e){return P[t.toLowerCase()]&&P[t.toLowerCase()][e.toLowerCase()]},z=function(t,e,i){if(D(t,e))throw new Error("Render shapeType '"+e+"' existed.");P[t.toLowerCase()]||(P[t.toLowerCase()]={}),P[t.toLowerCase()][e.toLowerCase()]=i;},F=function(e){function i(){e.apply(this,arguments);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.setUniformsValue=function(t,e){this.uniforms[t]&&(this.uniforms[t].value=e,this.uniforms.needsUpdate=!0);},i.prototype.setDefinesvalue=function(t,e){this.defines[t]=e,this.needsUpdate=!0;},i.prototype.setUniform=function(t){var e={};for(var i in t)"u_"===i.substr(0,2)&&(e[i]={value:t[i]});return e},i.prototype.updateUninform=function(t){for(var e in t)"u_"===e.substr(0,2)&&this.setUniformsValue(e,t[e]);},i.prototype.setBending=function(e){this.blending=t.THREE[i.blendingEnum[e]]||t.NormalBlending;},i}(t.ShaderMaterial);F.blendingEnum={normal:"NormalBlending",additive:"AdditiveBlending",subtractive:"SubtractiveBlending"};var j={VS:"vs",FS:"fs"},B={},R={},N=/precision\s+(high|low|medium)p\s+float/,U="#ifdef GL_FRAGMENT_PRECISION_HIGH\n precision highp float;\n #else\n precision mediump float;\n#endif\n",H="attribute float pickingId;\n  #ifdef PICK \n varying vec4 worldId; \n #endif \n",W="#ifdef PICK \n varying vec4 worldId; \n #endif \n",G='#pragma include "pick_color"\n',V=/#pragma include (["^+"]?["\ "[a-zA-Z_0-9](.*)"]*?)/g,q=/uniform\s+(bool|float|int|vec2|vec3|vec4|ivec2|ivec3|ivec4|mat2|mat3|mat4|sampler2D|samplerCube)\s+([\s\S]*?);/g;function Z(t,e,i){return {content:t.replace(V,function(t,o){var r=o.split(" ")[0].replace(/"/g,"");if(e.indexOf(r)>-1)return "";var n=R[r][i];return e.push(r),Z(n,e,i).content}),includeList:e}}function K(t){var e={};return {content:t=t.replace(q,function(t,i,o){var r=o.split(":"),n=r[0].trim(),a="";switch(r.length>1&&(a=r[1].trim()),i){case"bool":a="true"===a;break;case"float":case"int":a=Number(a);break;case"vec2":case"vec3":case"vec4":case"ivec2":case"ivec3":case"ivec4":case"mat2":case"mat3":case"mat4":a=a?a.replace("[","").replace("]","").split(",").reduce(function(t,e){return t.push(Number(e.trim())),t},[]):new Array(function(t){var e=0;switch(t){case"vec2":case"ivec2":e=2;break;case"vec3":case"ivec3":e=3;break;case"vec4":case"ivec4":case"mat2":e=4;break;case"mat3":e=9;break;case"mat4":e=16;}return e}(i)).fill(0);}return e[n]=a,"uniform "+i+" "+n+";\n"}),uniforms:e}}function Y(t,e){var i,o=e.vs,r=e.fs,n=e.uniforms,a=K(o),s=a.content,l=a.uniforms,c=K(r),u=c.content,h=c.uniforms;R[t]=((i={})[j.VS]=s,i[j.FS]=u,i.uniforms=Object.assign({},l,h,n),i);}function X(e){var i;if(B[e])return B[e];var o=R[e][j.VS],r=R[e][j.FS];r=W+r;var n=Z(o=H+G+o,[],j.VS),a=n.content,s=n.includeList,l=Z(r,[],j.FS),c=l.content,u=l.includeList,h=t.uniq(s.concat(u).concat(e)).reduce(function(t,e){return Object.assign({},t,R[e].uniforms)},{});return N.test(c)||(c=U+c),B[e]=((i={})[j.VS]=a.trim(),i[j.FS]=c.trim(),i.uniforms=h,i),B[e]}function Q(t){return Object.keys(t).reduce(function(e,i){return e[i]={value:t[i]},e},{})}var $={type:"directional",direction:[0,-10.5,1],ambient:[.2,.2,.2],diffuse:[.6,.6,.6],specular:[.1,.1,.1]},J={direction:[0,0,0],ambient:[0,0,0],diffuse:[0,0,0],specular:[0,0,0]},tt={position:[0,0,0],direction:[0,0,0],ambient:[0,0,0],diffuse:[0,0,0],specular:[0,0,0],constant:1,linear:0,quadratic:0,angle:14,exponent:40,blur:5},et=["ambient","diffuse","specular"];function it(e){var i={u_directional_lights:new Array(3).fill(Object.assign({},J)),u_num_of_directional_lights:0,u_spot_lights:new Array(3).fill(Object.assign({},tt)),u_num_of_spot_lights:0};return e&&e.length||(e=[$]),e.forEach(function(e,o){var r=e.type,n=function(t,e){var i={};for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&-1===e.indexOf(o)&&(i[o]=t[o]);return i}(e,["type"]),a="u_"+r+"_lights",s="u_num_of_"+r+"_lights";Object.keys(n).forEach(function(e){t.isString(n[e])&&et.indexOf(e)>-1&&(n[e]=t.ColorUtil.color2RGBA(n[e]).slice(0,3));}),i[a][o]=Object.assign({},i[a][o],n),i[s]++;}),i}var ot=function(e){function i(i,o,r){e.call(this,r);var n=X("polygon"),a=n.vs,s=n.fs,l=n.uniforms;this.uniforms=Q(t.merge(l,i)),this.type="PolygonMaterial",this.defines=o,this.vertexShader=a,this.fragmentShader=s,this.transparent=!0;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i}(F);function rt(e,i,o){var r=i.get("styleOptions"),n=i.get("activedOptions"),a=Object.assign({},r,{activeColor:n.fill}),s=a.opacity,l=a.activeColor,c=a.lights;o||(o=new(t.getBuffer(i.type,i.shape))({layerData:e}));var u=o.attributes,h=o.indexArray,p=new t.BufferGeometry;h&&p.setIndex(new t.Uint32BufferAttribute(h,1)),p.addAttribute("position",new t.Float32BufferAttribute(u.positions,3)),p.addAttribute("a_color",new t.Float32BufferAttribute(u.colors,4)),p.addAttribute("pickingId",new t.Float32BufferAttribute(u.pickingIds,1)),p.computeVertexNormals();var f=new ot(Object.assign({},{u_opacity:s,u_activeColor:l},it(c)),{SHAPE:!1,LIGHTING:!0}),d=new t.Mesh(p,f);return delete u.vertices,delete u.colors,delete u.pickingIds,delete u.normals,d}function nt(e){var i=X("line"),o=i.vs,r=i.fs;return new F({uniforms:{u_opacity:{value:e.u_opacity||1},u_time:{value:e.u_time||0},u_zoom:{value:e.u_zoom||10},u_activeId:{value:e.activeId||0},u_activeColor:{value:e.activeColor||[1,0,0,1]}},vertexShader:o,fragmentShader:r,transparent:!0,blending:t.THREE[F.blendingEnum[e.blending]]})}function at(e){var i="arcline";"greatCircle"===e.shapeType&&(i="greatcircle");var o=X(i),r=o.vs,n=o.fs,a=o.uniforms;return new F({uniforms:Q(t.merge(a,{u_opacity:e.u_opacity,segmentNumber:30,u_time:0,u_zoom:e.u_zoom,u_activeId:e.activeId,u_activeColor:e.activeColor})),vertexShader:r,fragmentShader:n,transparent:!0,side:t.DoubleSide,blending:t.THREE[F.blendingEnum[e.blending]]})}function st(e,i){var o=X("meshline"),r=o.vs,n=o.fs,a=o.uniforms;return new F({uniforms:Q(t.merge(a,e,{u_activeId:e.activeId,u_activeColor:e.activeColor})),defines:i,vertexShader:r,fragmentShader:n,transparent:!0,blending:t.THREE[F.blendingEnum[e.blending]]})}function lt(e,i,o){var r=i.get("styleOptions"),n=i.map.getCameraState(),a=n.near,s=n.far;(i.scene.startAnimate(),o)||(o=new(t.getBuffer(i.type,"extrude"))({layerData:e,uv:!0}));var l=o.attributes,c=o.indexArray,u=r.opacity,h=r.baseColor,p=r.brightColor,f=r.windowColor,d=r.lights,_=new t.BufferGeometry;c&&_.setIndex(new t.Uint32BufferAttribute(c,1)),_.addAttribute("position",new t.Float32BufferAttribute(l.positions,3)),_.addAttribute("a_color",new t.Float32BufferAttribute(l.colors,4)),_.addAttribute("pickingId",new t.Float32BufferAttribute(l.pickingIds,1)),_.addAttribute("faceUv",new t.Float32BufferAttribute(l.uv,2)),_.computeVertexNormals();var v=new ot(Object.assign({},{u_opacity:u,u_baseColor:h,u_brightColor:p,u_windowColor:f,u_near:a,u_far:s},it(d)),{SHAPE:!1,LIGHTING:!0,ANIMATE:!0});return new t.Mesh(_,v)}function ct(e,i){var o=i.get("styleOptions"),r=i.get("activedOptions"),n=new(t.getBuffer("shape","extrude"))({layerData:e,shapeType:i.shapeType}),a=n.attributes,s=n.indexArray,l=new t.BufferGeometry;l.setIndex(new t.Uint32BufferAttribute(s,1)),l.addAttribute("position",new t.Float32BufferAttribute(a.positions,3)),l.addAttribute("a_color",new t.Float32BufferAttribute(a.colors,4)),l.addAttribute("pickingId",new t.Float32BufferAttribute(a.pickingIds,1)),l.addAttribute("normal",new t.Float32BufferAttribute(a.normals,3)),l.addAttribute("a_shape",new t.Float32BufferAttribute(a.miters,3)),l.addAttribute("a_size",new t.Float32BufferAttribute(a.sizes,3));var c=new ot(Object.assign({},{u_opacity:o.opacity,u_activeColor:r.fill,u_zoom:i.scene.getZoom()},it(o.lights)),{SHAPE:!0,LIGHTING:!0});return c.setDefinesvalue("SHAPE",!0),c.setBending(o.blending||"normal"),new t.Mesh(l,c)}function ut(e){var i=X("text"),o=i.vs,r=i.fs,n=i.uniforms;return new F({defines:{SDF_PX:"8.0",EDGE_GAMMA:.105/window.devicePixelRatio},uniforms:Q(t.merge(n,e)),vertexShader:o,fragmentShader:r,transparent:!0})}function ht(t,e,i,o,r,n,a){var s=t.split("\n"),l=[],c={positionedGlyphs:l,top:a[1],bottom:a[1],left:a[0],right:a[0],lineCount:s.length,text:t};return function(t,e,i,o,r,n,a){var s=0,l=-8,c=0,u=t.positionedGlyphs,h="right"===n?1:"left"===n?0:.5,p=u.length;i.forEach(function(t){if(t.split("").forEach(function(t){var i=e[t];i&&(u.push({glyph:t,x:s,y:l+0,vertical:!1,scale:1,metrics:i}),s+=i.advance+a);}),u.length!==p){var i=s-a;c=Math.max(i,c),function(t,e,i,o,r){if(r){var n=t[o],a=n.glyph;if(a)for(var s=e[a].advance*n.scale,l=(t[o].x+s)*r,c=i;c<=o;c++)t[c].x-=l;}}(u,e,p,u.length-1,h);}s=0,l+=o;});var f=function(t){var e=.5,i=.5;switch(t){case"right":case"top-right":case"bottom-right":e=1;break;case"left":case"top-left":case"bottom-left":e=0;break;default:e=.5;}switch(t){case"bottom":case"bottom-right":case"bottom-left":i=1;break;case"top":case"top-right":case"top-left":i=0;break;default:i=.5;}return {horizontalAlign:e,verticalAlign:i}}(r),d=f.horizontalAlign,_=f.verticalAlign;!function(t,e,i,o,r,n,a){for(var s=(e-i)*r,l=(-o*a+.5)*n,c=0;c<t.length;c++)t[c].x+=s,t[c].y+=l;}(u,h,d,_,c,o,i.length);var v=l- -8;t.top+=-_*v,t.bottom=t.top+v,t.left+=-d*c,t.right=t.left+c;}(c,e,s,i,o,r,n),!!l.length&&c}function pt(t,e,i,o,r,n){var a=i.fontWeight,s=i.fontFamily,l=[];return e.forEach(function(t){var e=t.shape||"";e=e.toString();for(var i=0;i<e.length;i++)-1===l.indexOf(e[i])&&l.push(e[i]);}),o.setProps({characterSet:l,fontFamily:s,fontWeight:a}),function(t,e,i,o,r,n){var a=i.spacing;void 0===a&&(a=2);var s=i.textAnchor;void 0===s&&(s="center");var l=i.textOffset;void 0===l&&(l=[0,0]);var c=i.padding;void 0===c&&(c=[4,4]);var u=i.textAllowOverlap,h=o.texture,p=o.fontAtlas,f=o.mapping,d={fontAtlas:p,texture:h,positions:[],colors:[],pickingIds:[],textUVs:[],textOffsets:[],textSizes:[],index:[]},_=0;return t.forEach(function(e,i){var o=e.size,h=e.coordinates,p=o/24,v=ht(""+(t[i].shape||""),f,24,s,"center",a,l);if(v){var g=r.placeCollisionBox({x1:v.left*p-c[0],x2:v.right*p+c[0],y1:v.top*p-c[1],y2:v.bottom*p+c[1],anchorPointX:h[0],anchorPointY:h[1]},n).box;if(u||g&&g.length){r.insertCollisionBox(g,0);var y=function(t,e,i){for(var o=t.positionedGlyphs,r=[],n=0;n<o.length;n++){var a=o[n],s=a.metrics,l=s.advance*a.scale/2,c=i?[a.x+l,a.y]:[0,0],u=i?[0,0]:[a.x+l+e[0],a.y+e[1]],h=-4*a.scale-l+u[0],p=-4*a.scale+u[1],f=h+s.width*a.scale,d=p+s.height*a.scale,_={x:h,y:p},v={x:f,y:p},g={x:h,y:d},y={x:f,y:d};r.push({tl:_,tr:v,bl:g,br:y,tex:s,glyphOffset:c});}return r}(v,l,!1);_=function(t,e,i,o){var r=t.id,n=t.size,a=t.color,s=t.coordinates;return i.forEach(function(t){var i;e.pickingIds.push(r,r,r,r),(i=e.colors).push.apply(i,a.concat(a,a,a)),e.positions.push(s[0],s[1],s[0],s[1],s[0],s[1],s[0],s[1]),e.textUVs.push(t.tex.x,t.tex.y+t.tex.height,t.tex.x+t.tex.width,t.tex.y+t.tex.height,t.tex.x+t.tex.width,t.tex.y,t.tex.x,t.tex.y),e.textOffsets.push(t.tl.x,t.tl.y,t.tr.x,t.tr.y,t.br.x,t.br.y,t.bl.x,t.bl.y),e.textSizes.push(n,n,n,n),e.index.push(0+o,1+o,2+o,2+o,3+o,0+o),o+=4;}),o}(e,d,y,_);}}}),d}(t,0,i,o,r,n)}lt.prototype.updateStyle=function(t){this.fillPolygonMesh.material.updateUninform({u_opacity:t.opacity,u_baseColor:t.baseColor,u_brightColor:t.brightColor,u_windowColor:t.windowColor});};var ft=function(t,e,i){var o=this.boxCells=[];this.xCellCount=Math.ceil(t/i),this.yCellCount=Math.ceil(e/i);for(var r=0;r<this.xCellCount*this.yCellCount;r++)o.push([]);this.boxKeys=[],this.bboxes=[],this.width=t,this.height=e,this.xScale=this.xCellCount/t,this.yScale=this.yCellCount/e,this.boxUid=0;};ft.prototype.insert=function(t,e,i,o,r){this._forEachCell(e,i,o,r,this._insertBoxCell,this.boxUid++),this.boxKeys.push(t),this.bboxes.push(e),this.bboxes.push(i),this.bboxes.push(o),this.bboxes.push(r);},ft.prototype._insertBoxCell=function(t,e,i,o,r,n){this.boxCells[r].push(n);},ft.prototype._query=function(t,e,i,o,r,n){if(i<0||t>this.width||o<0||e>this.height)return !r&&[];var a=[];if(t<=0&&e<=0&&this.width<=i&&this.height<=o){if(r)return !0;for(var s=0;s<this.boxKeys.length;s++)a.push({key:this.boxKeys[s],x1:this.bboxes[4*s],y1:this.bboxes[4*s+1],x2:this.bboxes[4*s+2],y2:this.bboxes[4*s+3]});return n?a.filter(n):a}var l={hitTest:r,seenUids:{box:{},circle:{}}};return this._forEachCell(t,e,i,o,this._queryCell,a,l,n),r?a.length>0:a},ft.prototype.query=function(t,e,i,o,r){return this._query(t,e,i,o,!1,r)},ft.prototype.hitTest=function(t,e,i,o,r){return this._query(t,e,i,o,!0,r)},ft.prototype._queryCell=function(t,e,i,o,r,n,a,s){var l=a.seenUids,c=this.boxCells[r];if(null!==c)for(var u=this.bboxes,h=0,p=c;h<p.length;h+=1){var f=p[h];if(!l.box[f]){l.box[f]=!0;var d=4*f;if(t<=u[d+2]&&e<=u[d+3]&&i>=u[d+0]&&o>=u[d+1]&&(!s||s(this.boxKeys[f]))){if(a.hitTest)return n.push(!0),!0;n.push({key:this.boxKeys[f],x1:u[d],y1:u[d+1],x2:u[d+2],y2:u[d+3]});}}}return !1},ft.prototype._forEachCell=function(t,e,i,o,r,n,a,s){for(var l=this._convertToXCellCoord(t),c=this._convertToYCellCoord(e),u=this._convertToXCellCoord(i),h=this._convertToYCellCoord(o),p=l;p<=u;p++)for(var f=c;f<=h;f++){var d=this.xCellCount*f+p;if(r.call(this,t,e,i,o,d,n,a,s))return}},ft.prototype._convertToXCellCoord=function(t){return Math.max(0,Math.min(this.xCellCount-1,Math.floor(t*this.xScale)))},ft.prototype._convertToYCellCoord=function(t){return Math.max(0,Math.min(this.yCellCount-1,Math.floor(t*this.yScale)))};var dt=function(t,e){this.width=t,this.height=e,this.grid=new ft(t+200,e+200,25),this.screenRightBoundary=t+100,this.screenBottomBoundary=e+100,this.gridRightBoundary=t+200,this.gridBottomBoundary=e+200;};dt.prototype.placeCollisionBox=function(t,e){var i=this.project(e,t.anchorPointX,t.anchorPointY),o=t.x1+i.x,r=t.y1+i.y,n=t.x2+i.x,a=t.y2+i.y;return !this.isInsideGrid(o,r,n,a)||this.grid.hitTest(o,r,n,a)?{box:[]}:{box:[o,r,n,a]}},dt.prototype.insertCollisionBox=function(t,e){var i={featureIndex:e};this.grid.insert(i,t[0],t[1],t[2],t[3]);},dt.prototype.project=function(e,i,o){var r=new t.Vector4(i,o,0,1).applyMatrix4(e);return {x:(r.x/r.w+1)/2*this.width+100,y:(-r.y/r.w+1)/2*this.height+100}},dt.prototype.isInsideGrid=function(t,e,i,o){return i>=0&&t<this.gridRightBoundary&&o>=0&&e<this.gridBottomBoundary};var _t={fontWeight:500,textAnchor:"center",textOffset:[0,0],spacing:2,padding:[4,4],stroke:"white",strokeWidth:2,strokeOpacity:1,textAllowOverlap:!1};function vt(e,i){var o=Object.assign({},_t,i.get("styleOptions"));i.set("styleOptions",o);var r=i.get("activedOptions"),n=o.strokeWidth,a=o.stroke,s=o.opacity,l=o.textAllowOverlap,c=i.scene.getSize(),u=c.width,h=c.height,p=gt(e,i),f=p.geometry,d=p.texture,_=p.fontAtlas;i.updateGeometryHander=function(){var t=gt(e,i).geometry;i.layerMesh.geometry=t,i.layerMesh.geometry.needsUpdate=!0;},l?i.off("camerachange",i.updateGeometryHander):i.on("camerachange",i.updateGeometryHander);var v=new ut({name:i.layerId,u_sdf_map:d,u_stroke:a,u_strokeWidth:n,u_halo_blur:.5,u_opacity:s,u_sdf_map_size:[_.width,_.height],u_viewport_size:[u,h],u_activeColor:r.fill}),g=new t.Mesh(f,v);return g.frustumCulled=!1,g}function gt(e,i){var o=i.get("styleOptions"),r=o.fontFamily,n=o.fontWeight,a=o.spacing,s=o.textAnchor,l=o.textOffset,c=o.padding,u=o.textAllowOverlap,h=i.scene.getSize(),p=h.width,f=h.height,d=new dt(p,f),_=i.scene._engine._camera,v=_.projectionMatrix,g=_.matrixWorldInverse,y=(new t.Matrix4).copy(v).multiply(g),m=new pt(e,e,{fontFamily:r,fontWeight:n,spacing:a,textAnchor:s,textOffset:l,padding:c,textAllowOverlap:u},i.scene.fontAtlasManager,d,y),b=m.index,x=m.positions,w=m.pickingIds,C=m.texture,M=m.colors,A=m.textUVs,T=m.textOffsets,L=m.textSizes,k=m.fontAtlas,S=new t.BufferGeometry;return S.setIndex(b),S.addAttribute("a_pos",new t.Float32BufferAttribute(x,2)),S.addAttribute("pickingId",new t.Float32BufferAttribute(w,1)),S.addAttribute("a_color",new t.Float32BufferAttribute(M,4)),S.addAttribute("a_tex",new t.Float32BufferAttribute(A,2)),S.addAttribute("a_offset",new t.Float32BufferAttribute(T,2)),S.addAttribute("a_size",new t.Float32BufferAttribute(L,1)),{geometry:S,texture:C,fontAtlas:k}}function yt(e,i,o){var r=i.get("styleOptions"),n=i.get("activedOptions");o||(o=new(t.getBuffer(i.type,i.shapeType))({layerData:e,shapeType:i.shapeType,style:r}));var a=o.attributes,s=o.indexArray,l=new t.BufferGeometry;l.setIndex(new t.Uint32BufferAttribute(s,1)),l.addAttribute("position",new t.Float32BufferAttribute(a.positions,3)),l.addAttribute("pickingId",new t.Float32BufferAttribute(a.pickingIds,1)),l.addAttribute("a_color",new t.Float32BufferAttribute(a.colors,4)),l.addAttribute("a_instance",new t.Float32BufferAttribute(a.instanceArray,4)),l.addAttribute("a_size",new t.Float32BufferAttribute(a.sizes,1));var c=new at({u_opacity:r.opacity,u_zoom:i.scene.getZoom(),activeColor:n.fill,shapeType:i.shapeType,blending:r.blending||"additive"},{SHAPE:!1}),u=i.get("animateOptions");if(u.enable){i.scene.startAnimate();var h=u.duration;void 0===h&&(h=2);var p=u.interval;void 0===p&&(p=.5);var f=u.trailLength;void 0===f&&(f=.5);var d=u.repeat;void 0===d&&(d=1/0),i.animateDuration=i.scene._engine.clock.getElapsedTime()+h*d,c.updateUninform({u_duration:h,u_interval:p,u_trailLength:f}),c.setDefinesvalue("ANIMATE",!0);}var _=new t.Mesh(l,c);return _.frustumCulled=!1,_}function mt(e,i,o,r,n){void 0===r&&(r=200),Array.isArray(e[0][0])&&(e=e[0]);var a=[],s=[],l=[],c=[],u=[],h=[],p=[],f=t.getNormals(e,!1,o),d=f.normals,_=f.attrIndex,v=f.attrPos,g=f.attrDistance,y=[],m=[],b=i.size,x=i.color,w=i.id;!Array.isArray(b)&&(b=[b]);var C=g[g.length-1];v.forEach(function(t){u.push.apply(u,x),s.push(w),y.push(b[0]),t[2]=b[1]||0,a.push.apply(a,t),p.push(n.x,n.y),m.push(C);});var M=r/C;return d.forEach(function(t){var e=t[0],i=t[1];l.push(e[0],e[1],0),c.push(i),h.push(M);}),{positions:a,normal:l,indexArray:t.flatten(_),miter:c,colors:u,sizes:y,pickingIds:s,attrDistance:g,dashArray:h,textureCoordArray:p,totalDistances:m}}var bt=t.Global.pointShape;var xt=function(t){function e(e,i,o){t.call(this,o);var r=this.getDefaultParameters(),n=r.uniforms,a=r.defines,s=X("point"),l=s.vs,c=s.fs;this.uniforms=Object.assign(n,this.setUniform(e)),this.defines=Object.assign(a,i),this.type="PointMaterial",this.vertexShader=l,this.fragmentShader=c,this.transparent=!0,this.uniforms.u_texture&&(this.defines.TEXCOORD_0=!0);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultParameters=function(){return {uniforms:{u_opacity:{value:1},u_stroke:{value:[1,1,1,1]},u_strokeWidth:{value:1},u_activeId:{value:0}},defines:{SHAPE:!1,TEXCOORD_0:!1}}},e}(F);var wt=function(e){function i(i,o,r){e.call(this,r);var n=this.getDefaultParameters(),a=n.uniforms,s=n.defines,l=X("pointnormal"),c=l.vs,u=l.fs;this.uniforms=Object.assign(a,this.setUniform(i)),this.defines=Object.assign(s,o),this.type="PointMaterial",this.vertexShader=c,this.fragmentShader=u,this.transparent=!0,i&&(this.blending=t.THREE[e.blendingEnum[i.blending]]);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getDefaultParameters=function(){return {uniforms:{u_opacity:{value:1},u_stroke:{value:[1,1,1,1]},u_strokeWidth:{value:1},u_activeId:{value:0}},defines:{SHAPE:!1,TEXCOORD_0:!1}}},i}(F);var Ct=function(t){function e(e,i,o){t.call(this,o);var r=this.getDefaultParameters().uniforms,n=X("pointline"),a=n.vs,s=n.fs;this.uniforms=Object.assign(r,this.setUniform(e)),this.type="PointLineMaterial",this.vertexShader=a,this.fragmentShader=s,this.transparent=!0;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultParameters=function(){return {uniforms:{u_strokeOpacity:{value:1},u_stroke:{value:[1,1,1,1]},u_strokeWidth:{value:1},u_zoom:{value:10},u_activeId:{value:0},u_activeColor:{value:[1,0,0,1]}}}},e}(F);var Mt=function(e){function i(i,o,r){void 0===o&&(o={}),e.call(this,r);var n=X("circle"),a=n.vs,s=n.fs,l=n.uniforms;this.uniforms=Q(t.merge(l,i)),this.defines=o,this.type="CircleMaterial",this.vertexShader=a,this.fragmentShader=s,this.transparent=!0;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i}(F);var At=function(e){function i(i,o,r){e.call(this,r);var n=this.getDefaultParameters().defines,a=X("hexagon"),s=a.vs,l=a.fs,c=a.uniforms;this.uniforms=Q(t.merge(c,i)),this.type="hexagonMaterial",this.defines=Object.assign(n,o),this.vertexShader=s,this.fragmentShader=l,this.transparent=!0;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getDefaultParameters=function(){return {uniforms:{u_opacity:{value:1},u_time:{value:0},u_radius:{value:.01},u_angle:{value:.01},u_coverage:{value:.8},u_activeId:{value:0},u_activeColor:{value:[1,0,0,1]}},defines:{}}},i}(F);var Tt=function(e){function i(i,o,r){e.call(this,r);var n=this.getDefaultParameters().defines,a=X("grid"),s=a.vs,l=a.fs,c=a.uniforms;this.uniforms=Q(t.merge(c,i)),this.type="GridMaterial",this.defines=Object.assign(n,o),this.vertexShader=s,this.fragmentShader=l,this.transparent=!0;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getDefaultParameters=function(){return {uniforms:{u_opacity:{value:1},u_time:{value:0},u_xOffset:{value:.01},u_yOffset:{value:.01},u_coverage:{value:.8},u_activeId:{value:0},u_activeColor:{value:[1,0,0,1]}},defines:{}}},i}(F);function Lt(e,i,o){var r=i.get("styleOptions"),n=r.opacity,a=r.coverage,s=r.lights,l=i.get("activedOptions"),c=o.data,u=c.xOffset,h=c.yOffset,p=new(t.getBuffer(i.type,i.shapeType))({layerData:e,shapeType:i.shapeType}),f=p.attributes,d=p.indexArray,_=new t.BufferGeometry;_.setIndex(new t.Uint32BufferAttribute(d,1)),_.addAttribute("position",new t.Float32BufferAttribute(f.positions,3)),_.addAttribute("miter",new t.Float32BufferAttribute(f.miters,3)),_.addAttribute("a_color",new t.Float32BufferAttribute(f.colors,4)),_.addAttribute("pickingId",new t.Float32BufferAttribute(f.pickingIds,1)),_.addAttribute("normal",new t.Float32BufferAttribute(f.normals,3));var v=new Tt(Object.assign({},{u_opacity:n,u_xOffset:u,u_yOffset:h,u_coverage:a,u_activeColor:l.fill},it(s)),{SHAPE:!1,LIGHTING:"square"!==i.shapeType});return new t.Mesh(_,v)}var kt={viridis:new Uint8Array([68,1,84,255,68,2,86,255,69,4,87,255,69,5,89,255,70,7,90,255,70,8,92,255,70,10,93,255,70,11,94,255,71,13,96,255,71,14,97,255,71,16,99,255,71,17,100,255,71,19,101,255,72,20,103,255,72,22,104,255,72,23,105,255,72,24,106,255,72,26,108,255,72,27,109,255,72,28,110,255,72,29,111,255,72,31,112,255,72,32,113,255,72,33,115,255,72,35,116,255,72,36,117,255,72,37,118,255,72,38,119,255,72,40,120,255,72,41,121,255,71,42,122,255,71,44,122,255,71,45,123,255,71,46,124,255,71,47,125,255,70,48,126,255,70,50,126,255,70,51,127,255,70,52,128,255,69,53,129,255,69,55,129,255,69,56,130,255,68,57,131,255,68,58,131,255,68,59,132,255,67,61,132,255,67,62,133,255,66,63,133,255,66,64,134,255,66,65,134,255,65,66,135,255,65,68,135,255,64,69,136,255,64,70,136,255,63,71,136,255,63,72,137,255,62,73,137,255,62,74,137,255,62,76,138,255,61,77,138,255,61,78,138,255,60,79,138,255,60,80,139,255,59,81,139,255,59,82,139,255,58,83,139,255,58,84,140,255,57,85,140,255,57,86,140,255,56,88,140,255,56,89,140,255,55,90,140,255,55,91,141,255,54,92,141,255,54,93,141,255,53,94,141,255,53,95,141,255,52,96,141,255,52,97,141,255,51,98,141,255,51,99,141,255,50,100,142,255,50,101,142,255,49,102,142,255,49,103,142,255,49,104,142,255,48,105,142,255,48,106,142,255,47,107,142,255,47,108,142,255,46,109,142,255,46,110,142,255,46,111,142,255,45,112,142,255,45,113,142,255,44,113,142,255,44,114,142,255,44,115,142,255,43,116,142,255,43,117,142,255,42,118,142,255,42,119,142,255,42,120,142,255,41,121,142,255,41,122,142,255,41,123,142,255,40,124,142,255,40,125,142,255,39,126,142,255,39,127,142,255,39,128,142,255,38,129,142,255,38,130,142,255,38,130,142,255,37,131,142,255,37,132,142,255,37,133,142,255,36,134,142,255,36,135,142,255,35,136,142,255,35,137,142,255,35,138,141,255,34,139,141,255,34,140,141,255,34,141,141,255,33,142,141,255,33,143,141,255,33,144,141,255,33,145,140,255,32,146,140,255,32,146,140,255,32,147,140,255,31,148,140,255,31,149,139,255,31,150,139,255,31,151,139,255,31,152,139,255,31,153,138,255,31,154,138,255,30,155,138,255,30,156,137,255,30,157,137,255,31,158,137,255,31,159,136,255,31,160,136,255,31,161,136,255,31,161,135,255,31,162,135,255,32,163,134,255,32,164,134,255,33,165,133,255,33,166,133,255,34,167,133,255,34,168,132,255,35,169,131,255,36,170,131,255,37,171,130,255,37,172,130,255,38,173,129,255,39,173,129,255,40,174,128,255,41,175,127,255,42,176,127,255,44,177,126,255,45,178,125,255,46,179,124,255,47,180,124,255,49,181,123,255,50,182,122,255,52,182,121,255,53,183,121,255,55,184,120,255,56,185,119,255,58,186,118,255,59,187,117,255,61,188,116,255,63,188,115,255,64,189,114,255,66,190,113,255,68,191,112,255,70,192,111,255,72,193,110,255,74,193,109,255,76,194,108,255,78,195,107,255,80,196,106,255,82,197,105,255,84,197,104,255,86,198,103,255,88,199,101,255,90,200,100,255,92,200,99,255,94,201,98,255,96,202,96,255,99,203,95,255,101,203,94,255,103,204,92,255,105,205,91,255,108,205,90,255,110,206,88,255,112,207,87,255,115,208,86,255,117,208,84,255,119,209,83,255,122,209,81,255,124,210,80,255,127,211,78,255,129,211,77,255,132,212,75,255,134,213,73,255,137,213,72,255,139,214,70,255,142,214,69,255,144,215,67,255,147,215,65,255,149,216,64,255,152,216,62,255,155,217,60,255,157,217,59,255,160,218,57,255,162,218,55,255,165,219,54,255,168,219,52,255,170,220,50,255,173,220,48,255,176,221,47,255,178,221,45,255,181,222,43,255,184,222,41,255,186,222,40,255,189,223,38,255,192,223,37,255,194,223,35,255,197,224,33,255,200,224,32,255,202,225,31,255,205,225,29,255,208,225,28,255,210,226,27,255,213,226,26,255,216,226,25,255,218,227,25,255,221,227,24,255,223,227,24,255,226,228,24,255,229,228,25,255,231,228,25,255,234,229,26,255,236,229,27,255,239,229,28,255,241,229,29,255,244,230,30,255,246,230,32,255,248,230,33,255,251,231,35,255,253,231,37,255]),inferno:new Uint8Array([0,0,4,255,1,0,5,255,1,1,6,255,1,1,8,255,2,1,10,255,2,2,12,255,2,2,14,255,3,2,16,255,4,3,18,255,4,3,20,255,5,4,23,255,6,4,25,255,7,5,27,255,8,5,29,255,9,6,31,255,10,7,34,255,11,7,36,255,12,8,38,255,13,8,41,255,14,9,43,255,16,9,45,255,17,10,48,255,18,10,50,255,20,11,52,255,21,11,55,255,22,11,57,255,24,12,60,255,25,12,62,255,27,12,65,255,28,12,67,255,30,12,69,255,31,12,72,255,33,12,74,255,35,12,76,255,36,12,79,255,38,12,81,255,40,11,83,255,41,11,85,255,43,11,87,255,45,11,89,255,47,10,91,255,49,10,92,255,50,10,94,255,52,10,95,255,54,9,97,255,56,9,98,255,57,9,99,255,59,9,100,255,61,9,101,255,62,9,102,255,64,10,103,255,66,10,104,255,68,10,104,255,69,10,105,255,71,11,106,255,73,11,106,255,74,12,107,255,76,12,107,255,77,13,108,255,79,13,108,255,81,14,108,255,82,14,109,255,84,15,109,255,85,15,109,255,87,16,110,255,89,16,110,255,90,17,110,255,92,18,110,255,93,18,110,255,95,19,110,255,97,19,110,255,98,20,110,255,100,21,110,255,101,21,110,255,103,22,110,255,105,22,110,255,106,23,110,255,108,24,110,255,109,24,110,255,111,25,110,255,113,25,110,255,114,26,110,255,116,26,110,255,117,27,110,255,119,28,109,255,120,28,109,255,122,29,109,255,124,29,109,255,125,30,109,255,127,30,108,255,128,31,108,255,130,32,108,255,132,32,107,255,133,33,107,255,135,33,107,255,136,34,106,255,138,34,106,255,140,35,105,255,141,35,105,255,143,36,105,255,144,37,104,255,146,37,104,255,147,38,103,255,149,38,103,255,151,39,102,255,152,39,102,255,154,40,101,255,155,41,100,255,157,41,100,255,159,42,99,255,160,42,99,255,162,43,98,255,163,44,97,255,165,44,96,255,166,45,96,255,168,46,95,255,169,46,94,255,171,47,94,255,173,48,93,255,174,48,92,255,176,49,91,255,177,50,90,255,179,50,90,255,180,51,89,255,182,52,88,255,183,53,87,255,185,53,86,255,186,54,85,255,188,55,84,255,189,56,83,255,191,57,82,255,192,58,81,255,193,58,80,255,195,59,79,255,196,60,78,255,198,61,77,255,199,62,76,255,200,63,75,255,202,64,74,255,203,65,73,255,204,66,72,255,206,67,71,255,207,68,70,255,208,69,69,255,210,70,68,255,211,71,67,255,212,72,66,255,213,74,65,255,215,75,63,255,216,76,62,255,217,77,61,255,218,78,60,255,219,80,59,255,221,81,58,255,222,82,56,255,223,83,55,255,224,85,54,255,225,86,53,255,226,87,52,255,227,89,51,255,228,90,49,255,229,92,48,255,230,93,47,255,231,94,46,255,232,96,45,255,233,97,43,255,234,99,42,255,235,100,41,255,235,102,40,255,236,103,38,255,237,105,37,255,238,106,36,255,239,108,35,255,239,110,33,255,240,111,32,255,241,113,31,255,241,115,29,255,242,116,28,255,243,118,27,255,243,120,25,255,244,121,24,255,245,123,23,255,245,125,21,255,246,126,20,255,246,128,19,255,247,130,18,255,247,132,16,255,248,133,15,255,248,135,14,255,248,137,12,255,249,139,11,255,249,140,10,255,249,142,9,255,250,144,8,255,250,146,7,255,250,148,7,255,251,150,6,255,251,151,6,255,251,153,6,255,251,155,6,255,251,157,7,255,252,159,7,255,252,161,8,255,252,163,9,255,252,165,10,255,252,166,12,255,252,168,13,255,252,170,15,255,252,172,17,255,252,174,18,255,252,176,20,255,252,178,22,255,252,180,24,255,251,182,26,255,251,184,29,255,251,186,31,255,251,188,33,255,251,190,35,255,250,192,38,255,250,194,40,255,250,196,42,255,250,198,45,255,249,199,47,255,249,201,50,255,249,203,53,255,248,205,55,255,248,207,58,255,247,209,61,255,247,211,64,255,246,213,67,255,246,215,70,255,245,217,73,255,245,219,76,255,244,221,79,255,244,223,83,255,244,225,86,255,243,227,90,255,243,229,93,255,242,230,97,255,242,232,101,255,242,234,105,255,241,236,109,255,241,237,113,255,241,239,117,255,241,241,121,255,242,242,125,255,242,244,130,255,243,245,134,255,243,246,138,255,244,248,142,255,245,249,146,255,246,250,150,255,248,251,154,255,249,252,157,255,250,253,161,255,252,255,164,255]),rainbow:{colors:["#96005A","#0000C8","#0019FF","#0098FF","#2CFF96","#97FF00","#FFEA00","#FF6F00","#FF0000"],positions:[0,.125,.25,.375,.5,.625,.75,.875,1]},jet:{colors:["#000083","#003CAA","#05FFFF","#FFFF00","#FA0000","#800000"],positions:[0,.125,.375,.625,.875,1]},hsv:{colors:["#ff0000","#fdff02","#f7ff02","#00fc04","#00fc0a","#01f9ff","#0200fd","#0800fd","#ff00fb","#ff00f5","#ff0006"],positions:[0,.169,.173,.337,.341,.506,.671,.675,.839,.843,1]},hot:{colors:["#000000","#e60000","#ffd200","#ffffff"],positions:[0,.3,.6,1]},cool:{colors:["#00ffff","#ff00ff"],positions:[0,1]},spring:{colors:["#ff00ff","#ffff00"],positions:[0,1]},summer:{colors:["#008066","#ffff66"],positions:[0,1]},autumn:{colors:["#ff0000","#ffff00"],positions:[0,1]},winter:{colors:["#0000ff","#00ff80"],positions:[0,1]},bone:{colors:["#000000","#545474","#a9c8c8","#ffffff"],positions:[0,.376,.753,1]},copper:{colors:["#000000","#ffa066","#ffc77f"],positions:[0,.804,1]},greys:{colors:["#000000","#ffffff"],positions:[0,1]},yignbu:{colors:["#081d58","#253494","#225ea8","#1d91c0","#41b6c4","#7fcdbb","#c7e9b4","#edf8d9","#ffffd9"],positions:[0,.125,.25,.375,.5,.625,.75,.875,1]},greens:{colors:["#00441b","#006d2c","#238b45","#41ab5d","#74c476","#a1d99b","#c7e9c0","#e5f5e0","#f7fcf5"],positions:[0,.125,.25,.375,.5,.625,.75,.875,1]},wind:{colors:["#3288bd","#66c2a5","#abdda4","#e6f598","#fee08b","#fdae61","#f46d43","#d53e4f"],positions:[0,.1,.2,.6,.7,.8,.9,1]},yiorrd:{colors:["#800026","#bd0026","#e31a1c","#fc4e2a","#fd8d3c","#feb24c","#fed976","#ffeda0","#ffffcc"],positions:[0,.125,.25,.375,.5,.625,.75,.875,1]},bluered:{colors:["#0000ff","#ff0000"],positions:[0,1]},rdbu:{colors:["#050aac","#6a89f7","#bebebe","#dcaa84","#e6915a","#b20a1c"],positions:[0,.35,.5,.6,.7,1]},picnic:{colors:["#0000ff","#3399ff","#66ccff","#99ccff","#ccccff","#ffffff","#ffccff","#ff99ff","#ff66cc","#ff6666","#ff0000"],positions:[0,.1,.2,.3,.4,.5,.6,.7,.8,.9,1]},portland:{colors:["#0c3383","#0a88ba","#f2d338","#f28f38","#d91e1e"],positions:[0,.25,.5,.75,1]},blackbody:{colors:["#000000","#e60000","#e6d200","#ffffff","#a0c8ff"],positions:[0,.2,.4,.7,1]},earth:{colors:["#000082","#00b4b4","#28d228","#e6e632","#784614","#ffffff"],positions:[0,.1,.2,.4,.6,1]},electric:{colors:["#000000","#1e0064","#780064","#a05a00","#e6c800","#fffadc"],positions:[0,.15,.4,.6,.8,1]},magma:new Uint8Array([0,0,4,255,1,0,5,255,1,1,6,255,1,1,8,255,2,1,9,255,2,2,11,255,2,2,13,255,3,3,15,255,3,3,18,255,4,4,20,255,5,4,22,255,6,5,24,255,6,5,26,255,7,6,28,255,8,7,30,255,9,7,32,255,10,8,34,255,11,9,36,255,12,9,38,255,13,10,41,255,14,11,43,255,16,11,45,255,17,12,47,255,18,13,49,255,19,13,52,255,20,14,54,255,21,14,56,255,22,15,59,255,24,15,61,255,25,16,63,255,26,16,66,255,28,16,68,255,29,17,71,255,30,17,73,255,32,17,75,255,33,17,78,255,34,17,80,255,36,18,83,255,37,18,85,255,39,18,88,255,41,17,90,255,42,17,92,255,44,17,95,255,45,17,97,255,47,17,99,255,49,17,101,255,51,16,103,255,52,16,105,255,54,16,107,255,56,16,108,255,57,15,110,255,59,15,112,255,61,15,113,255,63,15,114,255,64,15,116,255,66,15,117,255,68,15,118,255,69,16,119,255,71,16,120,255,73,16,120,255,74,16,121,255,76,17,122,255,78,17,123,255,79,18,123,255,81,18,124,255,82,19,124,255,84,19,125,255,86,20,125,255,87,21,126,255,89,21,126,255,90,22,126,255,92,22,127,255,93,23,127,255,95,24,127,255,96,24,128,255,98,25,128,255,100,26,128,255,101,26,128,255,103,27,128,255,104,28,129,255,106,28,129,255,107,29,129,255,109,29,129,255,110,30,129,255,112,31,129,255,114,31,129,255,115,32,129,255,117,33,129,255,118,33,129,255,120,34,129,255,121,34,130,255,123,35,130,255,124,35,130,255,126,36,130,255,128,37,130,255,129,37,129,255,131,38,129,255,132,38,129,255,134,39,129,255,136,39,129,255,137,40,129,255,139,41,129,255,140,41,129,255,142,42,129,255,144,42,129,255,145,43,129,255,147,43,128,255,148,44,128,255,150,44,128,255,152,45,128,255,153,45,128,255,155,46,127,255,156,46,127,255,158,47,127,255,160,47,127,255,161,48,126,255,163,48,126,255,165,49,126,255,166,49,125,255,168,50,125,255,170,51,125,255,171,51,124,255,173,52,124,255,174,52,123,255,176,53,123,255,178,53,123,255,179,54,122,255,181,54,122,255,183,55,121,255,184,55,121,255,186,56,120,255,188,57,120,255,189,57,119,255,191,58,119,255,192,58,118,255,194,59,117,255,196,60,117,255,197,60,116,255,199,61,115,255,200,62,115,255,202,62,114,255,204,63,113,255,205,64,113,255,207,64,112,255,208,65,111,255,210,66,111,255,211,67,110,255,213,68,109,255,214,69,108,255,216,69,108,255,217,70,107,255,219,71,106,255,220,72,105,255,222,73,104,255,223,74,104,255,224,76,103,255,226,77,102,255,227,78,101,255,228,79,100,255,229,80,100,255,231,82,99,255,232,83,98,255,233,84,98,255,234,86,97,255,235,87,96,255,236,88,96,255,237,90,95,255,238,91,94,255,239,93,94,255,240,95,94,255,241,96,93,255,242,98,93,255,242,100,92,255,243,101,92,255,244,103,92,255,244,105,92,255,245,107,92,255,246,108,92,255,246,110,92,255,247,112,92,255,247,114,92,255,248,116,92,255,248,118,92,255,249,120,93,255,249,121,93,255,249,123,93,255,250,125,94,255,250,127,94,255,250,129,95,255,251,131,95,255,251,133,96,255,251,135,97,255,252,137,97,255,252,138,98,255,252,140,99,255,252,142,100,255,252,144,101,255,253,146,102,255,253,148,103,255,253,150,104,255,253,152,105,255,253,154,106,255,253,155,107,255,254,157,108,255,254,159,109,255,254,161,110,255,254,163,111,255,254,165,113,255,254,167,114,255,254,169,115,255,254,170,116,255,254,172,118,255,254,174,119,255,254,176,120,255,254,178,122,255,254,180,123,255,254,182,124,255,254,183,126,255,254,185,127,255,254,187,129,255,254,189,130,255,254,191,132,255,254,193,133,255,254,194,135,255,254,196,136,255,254,198,138,255,254,200,140,255,254,202,141,255,254,204,143,255,254,205,144,255,254,207,146,255,254,209,148,255,254,211,149,255,254,213,151,255,254,215,153,255,254,216,154,255,253,218,156,255,253,220,158,255,253,222,160,255,253,224,161,255,253,226,163,255,253,227,165,255,253,229,167,255,253,231,169,255,253,233,170,255,253,235,172,255,252,236,174,255,252,238,176,255,252,240,178,255,252,242,180,255,252,244,182,255,252,246,184,255,252,247,185,255,252,249,187,255,252,251,189,255,252,253,191,255]),plasma:new Uint8Array([13,8,135,255,16,7,136,255,19,7,137,255,22,7,138,255,25,6,140,255,27,6,141,255,29,6,142,255,32,6,143,255,34,6,144,255,36,6,145,255,38,5,145,255,40,5,146,255,42,5,147,255,44,5,148,255,46,5,149,255,47,5,150,255,49,5,151,255,51,5,151,255,53,4,152,255,55,4,153,255,56,4,154,255,58,4,154,255,60,4,155,255,62,4,156,255,63,4,156,255,65,4,157,255,67,3,158,255,68,3,158,255,70,3,159,255,72,3,159,255,73,3,160,255,75,3,161,255,76,2,161,255,78,2,162,255,80,2,162,255,81,2,163,255,83,2,163,255,85,2,164,255,86,1,164,255,88,1,164,255,89,1,165,255,91,1,165,255,92,1,166,255,94,1,166,255,96,1,166,255,97,0,167,255,99,0,167,255,100,0,167,255,102,0,167,255,103,0,168,255,105,0,168,255,106,0,168,255,108,0,168,255,110,0,168,255,111,0,168,255,113,0,168,255,114,1,168,255,116,1,168,255,117,1,168,255,119,1,168,255,120,1,168,255,122,2,168,255,123,2,168,255,125,3,168,255,126,3,168,255,128,4,168,255,129,4,167,255,131,5,167,255,132,5,167,255,134,6,166,255,135,7,166,255,136,8,166,255,138,9,165,255,139,10,165,255,141,11,165,255,142,12,164,255,143,13,164,255,145,14,163,255,146,15,163,255,148,16,162,255,149,17,161,255,150,19,161,255,152,20,160,255,153,21,159,255,154,22,159,255,156,23,158,255,157,24,157,255,158,25,157,255,160,26,156,255,161,27,155,255,162,29,154,255,163,30,154,255,165,31,153,255,166,32,152,255,167,33,151,255,168,34,150,255,170,35,149,255,171,36,148,255,172,38,148,255,173,39,147,255,174,40,146,255,176,41,145,255,177,42,144,255,178,43,143,255,179,44,142,255,180,46,141,255,181,47,140,255,182,48,139,255,183,49,138,255,184,50,137,255,186,51,136,255,187,52,136,255,188,53,135,255,189,55,134,255,190,56,133,255,191,57,132,255,192,58,131,255,193,59,130,255,194,60,129,255,195,61,128,255,196,62,127,255,197,64,126,255,198,65,125,255,199,66,124,255,200,67,123,255,201,68,122,255,202,69,122,255,203,70,121,255,204,71,120,255,204,73,119,255,205,74,118,255,206,75,117,255,207,76,116,255,208,77,115,255,209,78,114,255,210,79,113,255,211,81,113,255,212,82,112,255,213,83,111,255,213,84,110,255,214,85,109,255,215,86,108,255,216,87,107,255,217,88,106,255,218,90,106,255,218,91,105,255,219,92,104,255,220,93,103,255,221,94,102,255,222,95,101,255,222,97,100,255,223,98,99,255,224,99,99,255,225,100,98,255,226,101,97,255,226,102,96,255,227,104,95,255,228,105,94,255,229,106,93,255,229,107,93,255,230,108,92,255,231,110,91,255,231,111,90,255,232,112,89,255,233,113,88,255,233,114,87,255,234,116,87,255,235,117,86,255,235,118,85,255,236,119,84,255,237,121,83,255,237,122,82,255,238,123,81,255,239,124,81,255,239,126,80,255,240,127,79,255,240,128,78,255,241,129,77,255,241,131,76,255,242,132,75,255,243,133,75,255,243,135,74,255,244,136,73,255,244,137,72,255,245,139,71,255,245,140,70,255,246,141,69,255,246,143,68,255,247,144,68,255,247,145,67,255,247,147,66,255,248,148,65,255,248,149,64,255,249,151,63,255,249,152,62,255,249,154,62,255,250,155,61,255,250,156,60,255,250,158,59,255,251,159,58,255,251,161,57,255,251,162,56,255,252,163,56,255,252,165,55,255,252,166,54,255,252,168,53,255,252,169,52,255,253,171,51,255,253,172,51,255,253,174,50,255,253,175,49,255,253,177,48,255,253,178,47,255,253,180,47,255,253,181,46,255,254,183,45,255,254,184,44,255,254,186,44,255,254,187,43,255,254,189,42,255,254,190,42,255,254,192,41,255,253,194,41,255,253,195,40,255,253,197,39,255,253,198,39,255,253,200,39,255,253,202,38,255,253,203,38,255,252,205,37,255,252,206,37,255,252,208,37,255,252,210,37,255,251,211,36,255,251,213,36,255,251,215,36,255,250,216,36,255,250,218,36,255,249,220,36,255,249,221,37,255,248,223,37,255,248,225,37,255,247,226,37,255,247,228,37,255,246,230,38,255,246,232,38,255,245,233,38,255,245,235,39,255,244,237,39,255,243,238,39,255,243,240,39,255,242,242,39,255,241,244,38,255,241,245,37,255,240,247,36,255,240,249,33,255])},St=function(t){function e(e){t.call(this,e),this.init();}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.init=function(){var t=this,e=this.get("data"),i=[],o=[],r=[];e.forEach(function(e){var n=e.coordinates,a=e.size,s=t._addDir(-1,1),l=t._addDir(1,1),c=t._addDir(-1,-1),u=t._addDir(1,-1);i.push.apply(i,n.concat(n,n,n,n,n)),o.push.apply(o,s.concat(c,u,l,s,u)),r.push(a,a,a,a,a,a);}),this.attributes={vertices:i,dirs:o,weights:r};},e.prototype._addVertex=function(t,e,i){return [2*t[0]+(e+1)/2,2*t[1]+(i+1)/2,t[2]]},e.prototype._addDir=function(t,e){return [(t+1)/2,(e+1)/2]},e}(t.Base);function It(e){var i,o,r=function(t){var e=t,i=document.createElement("canvas"),o=i.getContext("2d");i.width=1,i.height=256;var r=o.createLinearGradient(0,0,0,256),n=null;"string"==typeof e&&(e=kt[t]);if("[object Object]"===Object.prototype.toString.call(e)){for(var a=e.positions[0],s=e.positions[e.positions.length-1],l=0;l<e.colors.length;++l){var c=(e.positions[l]-a)/(s-a);r.addColorStop(c,e.colors[l]);}o.fillStyle=r,o.fillRect(0,0,1,256),n=new Uint8ClampedArray(o.getImageData(0,0,1,256).data);}"[object Uint8Array]"===Object.prototype.toString.call(e)&&(n=o.createImageData(1,256));return new ImageData(n,1,256)}(e);return i=r,(o=new t.Texture(i)).wrapS=t.ClampToEdgeWrapping,o.wrapT=t.ClampToEdgeWrapping,o.magFilter=t.NearestFilter,o.minFilter=t.NearestFilter,o.format=t.RGBAFormat,o.type=t.UnsignedByteType,o.needsUpdate=!0,o}var Et=function(t){function e(e,i,o){void 0===i&&(i={}),t.call(this,o);var r=this.getDefaultParameters(),n=r.uniforms,a=r.defines,s=X("heatmap_color"),l=s.vs,c=s.fs;this.uniforms=Object.assign(n,this.setUniform(e)),this.type="HeatmapColorizeMaterial",this.defines=Object.assign(a,i),this.vertexShader=l,this.fragmentShader=c,this.transparent=!0;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultParameters=function(){return {uniforms:{u_intensity:{value:1},u_texture:{value:null},u_rampColors:{value:0},u_opacity:{value:1}},defines:{}}},e}(F),Ot=function(e){function i(i,o,r){void 0===o&&(o={}),e.call(this,r);var n=this.getDefaultParameters(),a=n.uniforms,s=n.defines,l=X("heatmap_intensity"),c=l.vs,u=l.fs;this.uniforms=Object.assign(a,this.setUniform(i)),this.type="heatmap_intensity",this.defines=Object.assign(s,o),this.vertexShader=c,this.blending=t.AdditiveBlending,this.fragmentShader=u,this.depthTest=!1,this.transparent=!0;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getDefaultParameters=function(){return {uniforms:{u_intensity:{value:10},u_zoom:{value:4},u_radius:{value:10}},defines:{}}},i}(F),Pt=function(e,i,o,r,n){this.scene=e,this.camera=i,this.overrideMaterial=o,this.clearColor=r,this.clearAlpha=void 0!==n?n:1,this.oldClearColor=new t.Color,this.oldClearAlpha=1,this.enabled=!0,this.clear=!1,this.needsSwap=!1;};Pt.prototype={render:function(t,e,i,o){this.scene.overrideMaterial=this.overrideMaterial,this.clearColor&&(this.oldClearColor.copy(t.getClearColor()),this.oldClearAlpha=t.getClearAlpha(),t.setClearColor(this.clearColor,this.clearAlpha)),t.render(this.scene,this.camera,i,this.clear),this.clearColor&&t.setClearColor(this.oldClearColor,this.oldClearAlpha),this.scene.overrideMaterial=null;}};var Dt=function(e,i){this.textureID=void 0!==i?i:"tDiffuse",e instanceof t.ShaderMaterial?(this.uniforms=e.uniforms,this.material=e):e&&(this.uniforms=t.UniformsUtils.clone(e.uniforms),this.material=new t.ShaderMaterial({defines:e.defines||{},uniforms:this.uniforms,vertexShader:e.vertexShader,fragmentShader:e.fragmentShader})),this.renderToScreen=!1,this.enabled=!0,this.needsSwap=!0,this.clear=!0,this.camera=new t.OrthographicCamera(-1,1,1,-1,0,1),this.scene=new t.Scene,this.quad=new t.Mesh(new t.PlaneBufferGeometry(2,2),null),this.scene.add(this.quad);};Dt.prototype={render:function(t,e,i,o){this.uniforms[this.textureID]&&(this.uniforms[this.textureID].value=i.texture),t.autoClear=!1,this.quad.material=this.material,this.renderToScreen?t.render(this.scene,this.camera):t.render(this.scene,this.camera,e,this.clear),t.autoClear=!0;}};var zt={uniforms:{tDiffuse:{type:"t",value:null},opacity:{type:"f",value:1}},vertexShader:["varying vec2 vUv;","void main() {","vUv = uv;","gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );","}"].join("\n"),fragmentShader:["uniform float opacity;","uniform sampler2D tDiffuse;","varying vec2 vUv;","void main() {","vec4 texel = texture2D( tDiffuse, vUv );","gl_FragColor = opacity * texel;","}"].join("\n")},Ft=function(t,e){this.scene=t,this.camera=e,this.enabled=!0,this.clear=!0,this.needsSwap=!1,this.inverse=!1;};Ft.prototype={render:function(t,e,i,o){var r,n,a=t.context;a.colorMask(!1,!1,!1,!1),a.depthMask(!1),this.inverse?(r=0,n=1):(r=1,n=0),a.enable(a.STENCIL_TEST),a.stencilOp(a.REPLACE,a.REPLACE,a.REPLACE),a.stencilFunc(a.ALWAYS,r,4294967295),a.clearStencil(n),t.render(this.scene,this.camera,i,this.clear),t.render(this.scene,this.camera,e,this.clear),a.colorMask(!0,!0,!0,!0),a.depthMask(!0),a.stencilFunc(a.EQUAL,1,4294967295),a.stencilOp(a.KEEP,a.KEEP,a.KEEP);}};var jt=function(){this.enabled=!0;};jt.prototype={render:function(t,e,i,o){var r=t.context;r.disable(r.STENCIL_TEST);}};var Bt=function(e,i){if(this.renderer=e,void 0===i){var o=e.getPixelRatio(),r=Math.floor(e.context.canvas.width/o)||1,n=Math.floor(e.context.canvas.height/o)||1,a={minFilter:t.LinearFilter,magFilter:t.LinearFilter,format:t.RGBAFormat,stencilBuffer:!1};i=new t.WebGLRenderTarget(r,n,a);}this.renderTarget1=i,this.renderTarget2=i.clone(),this.writeBuffer=this.renderTarget1,this.readBuffer=this.renderTarget2,this.passes=[],void 0===zt&&console.error("EffectComposer relies on THREE.CopyShader"),this.copyPass=new Dt(zt);};function Rt(t){return new Bt(t)}function Nt(e,i){var o=new t.Scene,r=i.get("styleOptions"),n=e,a=i.scene._engine._camera,s=new St({data:n}).attributes,l=new t.BufferGeometry;l.addAttribute("position",new t.Float32BufferAttribute(s.vertices,3)),l.addAttribute("a_dir",new t.Float32BufferAttribute(s.dirs,2)),l.addAttribute("a_weight",new t.Float32BufferAttribute(s.weights,1));var c=new Ot({u_intensity:r.intensity,u_radius:r.radius,u_zoom:i.scene.getZoom()},{}),u=new t.Mesh(l,c);return o.add(u),o.onBeforeRender=function(){var t=i.scene.getZoom();u.material.setUniformsValue("u_zoom",t);},new Pt(o,a)}function Ut(t){var e=t.get("styleOptions"),i=new Et({u_rampColors:t.rampColors,u_opacity:e.opacity||1},{});return new Dt(i,"u_texture")}function Ht(t){var e=X("image"),i=e.vs,o=e.fs;return new F({uniforms:{u_opacity:{value:t.u_opacity},u_texture:{value:t.u_texture}},vertexShader:i,fragmentShader:o,transparent:!0,depthTest:!1})}function Wt(e,i){var o=new t.BufferGeometry;o.addAttribute("position",new t.Float32BufferAttribute(e.vertices,3)),o.addAttribute("uv",new t.Float32BufferAttribute(e.uvs,2));var r=i.opacity,n=new Ht({u_texture:e.texture,u_opacity:r});return new t.Mesh(o,n)}Bt.prototype={swapBuffers:function(){var t=this.readBuffer;this.readBuffer=this.writeBuffer,this.writeBuffer=t;},visible:!0,type:"composer",addPass:function(t){this.passes.push(t);},insertPass:function(t,e){this.passes.splice(e,0,t);},render:function(t){this.writeBuffer=this.renderTarget1,this.readBuffer=this.renderTarget2;var e,i,o=!1,r=this.passes.length;for(i=0;i<r;i++)if((e=this.passes[i]).enabled){if(e.render(this.renderer,this.writeBuffer,this.readBuffer,t,o),e.needsSwap){if(o){var n=this.renderer.context;n.stencilFunc(n.NOTEQUAL,1,4294967295),this.copyPass.render(this.renderer,this.writeBuffer,this.readBuffer,t),n.stencilFunc(n.EQUAL,1,4294967295);}this.swapBuffers();}e instanceof Ft?o=!0:e instanceof jt&&(o=!1);}},reset:function(t){if(void 0===t){t=this.renderTarget1.clone();var e=this.renderer.getPixelRatio();t.setSize(Math.floor(this.renderer.context.canvas.width/e),Math.floor(this.renderer.context.canvas.height/e));}this.renderTarget1.dispose(),this.renderTarget1=t,this.renderTarget2.dispose(),this.renderTarget2=t.clone(),this.writeBuffer=this.renderTarget1,this.readBuffer=this.renderTarget2;},setSize:function(t,e){this.renderTarget1.setSize(t,e),this.renderTarget2.setSize(t,e);},destory:function(){this.renderTarget1.dispose(),this.renderTarget2.dispose();}},z("polygon","fill",rt),z("polygon","extrude",rt),z("polygon","line",function(e,i,o){var r=i.get("styleOptions"),n=i.get("activedOptions"),a=Object.assign({},r,{activeColor:n.fill}).opacity;o||(o=new(t.getBuffer(i.type,i.shape))({layerData:e}));var s=o.attributes,l=o.indexArray,c=new t.BufferGeometry;l&&c.setIndex(new t.Uint32BufferAttribute(l,1)),c.addAttribute("position",new t.Float32BufferAttribute(s.positions,3)),c.addAttribute("a_color",new t.Float32BufferAttribute(s.colors,4)),c.addAttribute("pickingId",new t.Float32BufferAttribute(s.pickingIds,1));var u=new nt({u_opacity:a},{SHAPE:!1});return new t.LineSegments(c,u)}),z("polygon","animate",lt),z("line","line",function(e,i,o){var r=i.get("styleOptions"),n=i.get("animateOptions"),a=i.get("activedOptions");o||(o=new(t.getBuffer(i.type,i.shapeType))({layerData:e,shapeType:"line",style:r,imagePos:i.scene.image.imagePos}));var s=o.attributes,l=o.indexArray,c=o.hasPattern,u=new t.BufferGeometry;u.setIndex(new t.Uint32BufferAttribute(l,1)),u.addAttribute("pickingId",new t.Float32BufferAttribute(s.pickingIds,1)),u.addAttribute("position",new t.Float32BufferAttribute(s.positions,3)),u.addAttribute("a_color",new t.Float32BufferAttribute(s.colors,4)),u.addAttribute("a_size",new t.Float32BufferAttribute(s.sizes,1)),u.addAttribute("normal",new t.Float32BufferAttribute(s.normals,3)),u.addAttribute("a_miter",new t.Float32BufferAttribute(s.miters,1)),u.addAttribute("a_distance",new t.Float32BufferAttribute(s.attrDistance,1)),u.addAttribute("a_dash_array",new t.Float32BufferAttribute(s.dashArray,1)),u.addAttribute("a_texture_coord",new t.Float32BufferAttribute(s.patterns,2)),u.addAttribute("a_total_distance",new t.Float32BufferAttribute(s.totalDistances,1));var h=new st({u_opacity:r.opacity,u_zoom:i.scene.getZoom(),u_time:0,u_dash_offset:r.dashOffset,u_dash_ratio:r.dashRatio,activeColor:a.fill,u_pattern_spacing:r.patternSpacing||0,u_texture:c?i.scene.image.texture:null,blending:r.blending||"normal"},{SHAPE:!1,ANIMATE:!1,DASHLINE:"dash"===r.lineType,TEXTURE:c}),p=new t.Mesh(u,h);if(n.enable){i.scene.startAnimate();var f=n.duration;void 0===f&&(f=2);var d=n.interval;void 0===d&&(d=.5);var _=n.trailLength;void 0===_&&(_=.5);var v=n.repeat;void 0===v&&(v=1/0),i.animateDuration=i.scene._engine.clock.getElapsedTime()+f*v,h.updateUninform({u_duration:f,u_interval:d,u_trailLength:_}),h.setDefinesvalue("ANIMATE",!0);}return p}),z("line","arc",yt),z("line","greatCircle",yt),z("point","image",function(e,i){var o=new t.BufferGeometry,r=i.get("styleOptions"),n=i.get("activedOptions"),a=r.strokeWidth,s=r.stroke,l=r.opacity,c=i.scene.image.texture,u=function(t,e){var i={vertices:[],colors:[],sizes:[],shapes:[],pickingIds:[],uv:[]};return t.forEach(function(t){var o,r,n=t.color;void 0===n&&(n=[0,0,0,0]);var a=t.size,s=t.id,l=t.shape,c=t.coordinates,u=e.imagePos[l],h=u.x,p=u.y;(o=i.vertices).push.apply(o,c),(r=i.colors).push.apply(r,n),i.pickingIds.push(s),i.sizes.push(a*window.devicePixelRatio),i.uv.push(h,p),i.shapes.push(l);}),i}(e,{imagePos:i.scene.image.imagePos});o.addAttribute("position",new t.Float32BufferAttribute(u.vertices,3)),o.addAttribute("a_color",new t.Float32BufferAttribute(u.colors,4)),o.addAttribute("pickingId",new t.Float32BufferAttribute(u.pickingIds,1)),o.addAttribute("uv",new t.Float32BufferAttribute(u.uv,2)),o.addAttribute("a_size",new t.Float32BufferAttribute(u.sizes,1));var h=new xt({u_opacity:l,u_strokeWidth:a,u_stroke:s,u_activeColor:n.fill,u_texture:c},{SHAPE:!1,TEXCOORD_0:!0});return h.depthTest=!1,h.setBending(r.blending||"normal"),new t.Points(o,h)}),z("point","normal",function(e,i){var o=new t.BufferGeometry,r=i.get("styleOptions"),n=i.get("activedOptions"),a=r.opacity,s=function(t){var e={vertices:[],colors:[],sizes:[],pickingIds:[]};return t.forEach(function(t){var i,o,r=t.color,n=t.size,a=t.id,s=t.coordinates;(i=e.vertices).push.apply(i,s),(o=e.colors).push.apply(o,r),e.pickingIds.push(a),e.sizes.push(n);}),e}(e);o.addAttribute("position",new t.Float32BufferAttribute(s.vertices,3)),o.addAttribute("a_color",new t.Float32BufferAttribute(s.colors,4)),o.addAttribute("pickingId",new t.Float32BufferAttribute(s.pickingIds,1)),o.addAttribute("a_size",new t.Float32BufferAttribute(s.sizes,1));var l=new wt({u_opacity:a,u_activeColor:n.fill},{},r),c=new t.Points(o,l);return l.setBending("additive"),c}),z("point","stroke",function(e,i){var o=i.get("styleOptions"),r=i.get("activedOptions"),n=o.strokeWidth,a=o.stroke,s=o.strokeOpacity,l=function(e,i){var o={shapes:[],normal:[],miter:[],indexArray:[],sizes:[],positions:[],pickingIds:[],colors:[]},r=i.stroke,n=i.strokeWidth;return e.forEach(function(e){var i=e.size,a=e.shape,s=e.id,l=e.coordinates,c=t.polygonPath[a](),u=o.miter.length,h=null;if(-1!==bt["2d"].indexOf(a))t.Util.isArray(i)||(i=[i,i,0]),h=mt([c],{size:[n,0],color:r,id:s},u);else{if(-1===bt["3d"].indexOf(a))throw new Error("Invalid shape type: "+a);t.Util.isArray(i)||(i=[i,i,i]),h=mt([function(t){var e=[];t[0].forEach(function(t){e.push([t[0],t[1],0]);}),t[0].forEach(function(t){e.push([t[0],t[1],1]);});for(var i=[],o=t[0].length,r=o-1,n=0;n<r;n++)i.push(n,n+1),i.push(n+o,n+1+o),i.push(n,n+o);i.push(r,0),i.push(r,r+o),i.push(r+o,o);var a=[];return i.forEach(function(t){a.push(e[t]);}),a}([c])],{size:[n,0],color:r,id:s},u);}!function(t,e,i,o){var r,n,a,s,l,c;(r=o.shapes).push.apply(r,t.positions),(n=o.normal).push.apply(n,t.normal),(a=o.miter).push.apply(a,t.miter),(s=o.pickingIds).push.apply(s,t.pickingIds),(l=o.indexArray).push.apply(l,t.indexArray),(c=o.colors).push.apply(c,t.colors),t.miter.forEach(function(){var t,r;(t=o.positions).push.apply(t,e),(r=o.sizes).push.apply(r,i);});}(h,l,i,o);}),o}(e,o),c=new t.BufferGeometry;c.setIndex(l.indexArray),c.addAttribute("position",new t.Float32BufferAttribute(l.positions,3)),c.addAttribute("a_shape",new t.Float32BufferAttribute(l.shapes,3)),c.addAttribute("a_size",new t.Float32BufferAttribute(l.sizes,3)),c.addAttribute("normal",new t.Float32BufferAttribute(l.normal,3)),c.addAttribute("a_miter",new t.Float32BufferAttribute(l.miter,1)),c.addAttribute("pickingId",new t.Float32BufferAttribute(l.pickingIds,1)),c.addAttribute("a_color",new t.Float32BufferAttribute(l.colors,4));var u=new Ct({u_strokeOpacity:s,u_stroke:a,u_strokeWidth:n,u_activeColor:r.fill});return new t.Mesh(c,u)}),z("point","text",vt),z("point","fill",function(e,i,o){var r=i.get("styleOptions"),n=i.get("activedOptions");o||(o=new(t.getBuffer(i.type,i.shapeType))({layerData:e}));var a=o.attributes,s=o.indexArray,l=new t.BufferGeometry;o.indexArray&&l.setIndex(new t.Uint32BufferAttribute(s,1)),l.addAttribute("position",new t.Float32BufferAttribute(a.positions,3)),l.addAttribute("a_color",new t.Float32BufferAttribute(a.colors,4)),l.addAttribute("pickingId",new t.Float32BufferAttribute(a.pickingIds,1)),l.addAttribute("miter",new t.Float32BufferAttribute(a.miters,2)),l.addAttribute("a_size",new t.Float32BufferAttribute(a.sizes,1)),l.addAttribute("a_shape",new t.Float32BufferAttribute(a.shapes,1));var c=new Mt({u_opacity:r.opacity,u_activeColor:n.fill,u_zoom:i.scene.getZoom(),u_stroke:r.stroke,u_strokeWidth:r.strokeWidth,u_strokeOpacity:r.strokeOpacity});return c.depthTest=!1,c.setBending(r.blending||"normal"),new t.Mesh(l,c)}),z("point","shape",ct),z("point","extrude",ct),z("heatmap","square",Lt),z("heatmap","squareColumn",Lt),z("heatmap","heatmap",function(t,e){var i=e.get("styleOptions").rampColors;e.rampColors=It(i);var o=new Nt(t,e),r=new Ut(e);r.renderToScreen=!0;var n=new Rt(e.scene._engine._renderer);return n.id=e.layerId,n.addPass(o),n.addPass(r),e.scene._engine.update(),e._updateStyle=function(t){t.rampColors&&(t.rampColors=It(t.rampColors));var e={};for(var i in t)e["u_"+i]=t[i];o.scene.children[0].material.updateUninform(e),r.scene.children[0].material.updateUninform(e);},n}),z("heatmap","shape",function(e,i,o){var r=i.get("styleOptions"),n=i.get("activedOptions").fill,a=o.data.radius,s=r.opacity,l=r.angle;void 0===l&&(l=0);var c=r.coverage,u=r.lights,h=new(t.getBuffer(i.type,"shape"))({layerData:e,shapeType:i.shapeType}),p=h.attributes,f=h.instanceGeometry,d=new t.InstancedBufferGeometry;d.setIndex(f.indexArray),d.addAttribute("miter",new t.Float32BufferAttribute(f.positions,3)),f.normals&&d.addAttribute("normal",new t.Float32BufferAttribute(f.normals,3)),d.addAttribute("position",new t.InstancedBufferAttribute(new Float32Array(p.positions),3)),d.addAttribute("a_color",new t.InstancedBufferAttribute(new Float32Array(p.colors),4)),d.addAttribute("pickingId",new t.InstancedBufferAttribute(new Float32Array(p.pickingIds),1)),d.addAttribute("a_size",new t.InstancedBufferAttribute(new Float32Array(p.sizes),1));var _=new At(Object.assign({},{u_opacity:s,u_radius:a,u_angle:l/180*Math.PI,u_coverage:c,u_activeColor:n},it(u)),{SHAPE:!1,LIGHTING:!!f.normals});return new t.Mesh(d,_)}),z("image","image",Wt),z("text","text",vt);var Gt=function(t){function e(e,i){t.call(this,e,i),this.set("type","polygon");}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.shape=function(t){return this.shape=t,this.set("shape",t),this.set("shapeType","polygon"),this},e.prototype.draw=function(){this.type="polygon",this.get("animateOptions").enable&&(this.shape="animate"),this.add(D(this.type,this.shape)(this.layerData,this));},e.prototype.update=function(){this.updateFilter(this.layerMesh);},e}(O);Gt.type="polygon";var Vt=t.Global.pointShape,qt=function(t){function e(e,i){t.call(this,e,i),this.set("type","point");}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.draw=function(){this.type="point",this.shapeType=this._getShape();var t=D(this.type,this.shapeType)(this.layerData,this);this.add(t);},e.prototype._getShape=function(){var t=null;if(!this.layerData[0].hasOwnProperty("shape"))return "normal";for(var e=0;e<this.layerData.length&&void 0===(t=this.layerData[e].shape);e++);return -1!==Vt["2d"].indexOf(t)?"fill":-1!==Vt["3d"].indexOf(t)?"extrude":-1!==this.scene.image.imagesIds.indexOf(t)?"image":"text"},e.prototype.zoomchange=function(e){var i=this;t.prototype.zoomchange.call(this,e),requestAnimationFrame(function(){i._updateData();});},e.prototype.dragend=function(e){var i=this;t.prototype.dragend.call(this,e),requestAnimationFrame(function(){i._updateData();});},e.prototype.resize=function(){t.prototype.resize.call(this),"text"===this.shapeType&&this.repaint();},e.prototype._updateData=function(){if(this.layerSource.get("isCluster")){var t=this.scene.getBounds().toBounds(),e=t.getSouthWest(),i=t.getNorthEast(),o=this.scene.getZoom(),r=Math.max(i.lng-e.lng,i.lat-e.lat)/2,n=[e.lng,e.lat,i.lng,i.lat],a=this.layerSource.get("cluster"),s=a.bbox,l=a.zoom;if(!(s&&s[0]<n[0]&&s[1]<n[1]&&s[2]>n[2]&&s[3]<n[3]&&Math.abs(o-l)<.5)){var c=[e.lng-r,e.lat-r,i.lng+r,i.lat+r];this.layerSource.updateCusterData(Math.floor(o-1),c),this.repaint();}}},e}(O);qt.type="point";var Zt=function(t){function e(e,i){t.call(this,e,i),this.set("type","line");}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.shape=function(e,i){return t.prototype.shape.call(this,e,i),this.shapeType=e,this.set("shape",e),this},e.prototype.preRender=function(){this.animateDuration>0&&this.animateDuration<this.scene._engine.clock.getElapsedTime()&&(this.layerMesh.material.setDefinesvalue("ANIMATE",!1),this.scene.stopAnimate(),this.emit("animateEnd"),this.animateDuration=1/0);},e.prototype.draw=function(){this.type="line",this.add(D("line",this.shapeType||"line")(this.layerData,this));},e}(O);Zt.type="line";var Kt=function(e){function i(t){e.call(this,t),this.init();}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.init=function(){var e=this,i=this.get("layerData"),o=i[0].coordinates,r=i[0].images,n=o[0].concat([o[1][0]],[o[0][1]],[0],o[1],o[0],o[1],[o[0][0]],[o[1][1]],[0]),a=r;if(t.Util.isArray(r)){a=r[0];var s=r.map(function(t){return e._getTexture(t)});this.u_rasters=s;}var l=new t.Texture(a);l.magFilter=t.LinearFilter,l.minFilter=t.LinearMipMapLinearFilter,l.needsUpdate=!0;var c={vertices:new Float32Array(n),uvs:new Float32Array([0,1,1,1,1,0,0,1,1,0,0,0])};this.attributes=c,this.texture=l;},i.prototype._getTexture=function(e){var i=new t.Texture(e);i.magFilter=t.LinearFilter,i.minFilter=t.LinearFilter;},i}(t.Base),Yt=function(e){function i(){e.apply(this,arguments);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.draw=function(){var e=this;this.type="image";var i=this.layerSource,o=this.get("styleOptions").opacity;return i.originData.images.then(function(i){e.layerData[0].images=i;var r=new Kt({layerData:e.layerData});e.initGeometry(r.attributes);var n=new Ht({u_texture:r.texture,u_opacity:o}),a=new t.Mesh(e.geometry,n);e.add(a),e.scene._engine.update();}),this},i.prototype.initGeometry=function(e){this.geometry=new t.BufferGeometry,this.geometry.addAttribute("position",new t.Float32BufferAttribute(e.vertices,3)),this.geometry.addAttribute("uv",new t.Float32BufferAttribute(e.uvs,2));},i}(O);function Xt(t){var e=X("raster"),i=e.vs,o=e.fs;return new F({uniforms:{u_opacity:{value:t.u_opacity},u_texture:{value:t.u_texture},u_colorTexture:{value:t.u_colorTexture},u_min:{value:t.u_min},u_max:{value:t.u_max},u_extent:{value:t.u_extent},u_dimension:{value:t.u_dimension}},vertexShader:i,fragmentShader:o,transparent:!1})}var Qt=function(e){function i(t){e.call(this,t),this.init();}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.init=function(){var e=this.get("layerData").dataArray[0],i=e.coordinates,o=e.width,r=e.data,n=e.height,a=i[0].concat([i[1][0]],[i[0][1]],[0],i[1],i[0],i[1],[i[0][0]],[i[1][1]],[0]),s=this.get("size"),l=new t.DataTexture(new Float32Array(r),o,n,t.LuminanceFormat,t.FloatType);l.needsUpdate=!0;var c=this.get("rampColors"),u=this.getColorRamp(c),h=this._getTexture(u);this.position=a,this.uv=[0,1,1,1,1,0,0,1,1,0,0,0],this.u_raster=l,this.u_extent=[i[0][0],i[0][1],i[1][0],i[1][1]],this.u_colorTexture=h;var p=this._buildTriangles(o,n,s,this.u_extent),f={vertices:new Float32Array(p.vertices),uvs:new Float32Array(p.uvs),indices:p.indices,dimension:p.dimension};this.attributes=f;},i.prototype.getColorRamp=function(t){var e=t,i=document.createElement("canvas"),o=i.getContext("2d");i.width=256,i.height=1;var r=o.createLinearGradient(0,0,256,0),n=null;if("string"==typeof e&&(e=kt[t]),"[object Object]"===Object.prototype.toString.call(e)){for(var a=e.positions[0],s=e.positions[e.positions.length-1],l=0;l<e.colors.length;++l){var c=(e.positions[l]-a)/(s-a);r.addColorStop(c,e.colors[l]);}o.fillStyle=r,o.fillRect(0,0,256,1),n=new Uint8ClampedArray(o.getImageData(0,0,256,1).data);}return "[object Uint8Array]"===Object.prototype.toString.call(e)&&(n=o.createImageData(256,1)),new ImageData(n,16,16)},i.prototype._getTexture=function(e){var i=new t.Texture(e);return i.magFilter=t.LinearFilter,i.minFilter=t.LinearFilter,i.format=t.RGBAFormat,i.type=t.UnsignedByteType,i.generateMipmaps=!0,i.needsUpdate=!0,i},i.prototype._buildTriangles=function(t,e,i,o){void 0===i&&(i=2);for(var r=[],n=[],a=[],s=Math.floor(t/i),l=Math.floor(e/i),c=s+1,u=l+1,h=(o[2]-o[0])/c,p=(o[3]-o[1])/u,f=0;f<u;f++)for(var d=f*i,_=0;_<c;_++){var v=_*i;n.push(o[0]+v*h,(e-d)*p+o[1],0),a.push(_/s),a.push(f/l);}for(var g=0;g<l;g++)for(var y=0;y<s;y++){var m=y+c*g,b=y+c*(g+1),x=y+1+c*(g+1),w=y+1+c*g;r.push(m,b,w),r.push(b,x,w);}return {uvs:a,indices:r,vertices:n,dimension:[s,l]}},i}(t.Base),$t=function(e){function i(){e.apply(this,arguments);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.draw=function(){this.type="raster";var e=this.layerSource,i=this.get("styleOptions"),o=new Qt({layerData:e.data,rampColors:i.rampColors});this.initGeometry(o.attributes);var r=e.data.dataArray[0],n=new Xt({u_texture:o.u_raster,u_colorTexture:o.u_colorTexture,u_opacity:1,u_extent:o.u_extent,u_min:r.min,u_max:r.max,u_dimension:o.attributes.dimension}),a=new t.Mesh(this.geometry,n);return this.add(a),this},i.prototype.animateFunc=function(){var t=this,e=this.get("animateOptions");this.material.setValue("u_bands",this.animateData.index%3),this.material.setValue("u_texture",this.animateData.rasters[Math.floor(this.animateData.index/3)%8]),this.animateData.index++,e&&e(this.animateData.index),setTimeout(function(){t.animateId=requestAnimationFrame(t.animateFunc.bind(t));},500);},i.prototype.cancelAnimate=function(){window.cancelAnimationFrame(this.animateId);},i.prototype.initGeometry=function(e){this.geometry=new t.BufferGeometry,this.geometry.setIndex(e.indices),this.geometry.addAttribute("position",new t.Float32BufferAttribute(e.vertices,3)),this.geometry.addAttribute("uv",new t.Float32BufferAttribute(e.uvs,2));},i}(O),Jt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.shape=function(t){return this.shapeType=t,this},e.prototype.draw=function(){this.type="heatmap",this.shapeType||(this.shapeType="heatmap");var t="heatmap"===this.shapeType?"heatmap":"shape";this.add(D("heatmap",t)(this.layerData,this,this.layerSource));},e}(O),te=function(t,e){void 0===t&&(t=50),void 0===e&&(e=function(){}),this.limit=t,this.destroy=e,this._order=[],this.clear();};te.prototype.clear=function(){var t=this;this._order.forEach(function(e){t.delete(e);}),this._cache={},this._order=[];},te.prototype.get=function(t){var e=this._cache[t];return e&&(this._deleteOrder(t),this._appendOrder(t)),e},te.prototype.set=function(t,e){this._cache[t]?(this.delete(t),this._cache[t]=e,this._appendOrder(t)):(Object.keys(this._cache).length===this.limit&&this.delete(this._order[0]),this._cache[t]=e,this._appendOrder(t));},te.prototype.delete=function(t){var e=this._cache[t];e&&(this._deleteCache(t),this._deleteOrder(t),this.destroy(e,t));},te.prototype._deleteCache=function(t){delete this._cache[t];},te.prototype._deleteOrder=function(t){var e=this._order.findIndex(function(e){return e===t});e>=0&&this._order.splice(e,1);},te.prototype._appendOrder=function(t){this._order.push(t);};var ee=function(t,e){void 0===t&&(t=50),this._cache=new te(t,e);};ee.prototype.getTile=function(t){return this._cache.get(t)},ee.prototype.setTile=function(t,e){this._cache.set(e,t);},ee.prototype.removeTile=function(t){return this._cache.delete(t)},ee.prototype.destory=function(){this._cache.clear();};var ie=/\{([zxy])\}/g,oe=function(e){function i(t,i){e.call(this,i),this.cfg=i,this.urlTemplate=t,this._tileDataCache=new ee(50,this.tileDestroy),this.type="tile";}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getTileData=function(t,e,i){var o=this,r=[t,e,i].join("_"),n=this._tileDataCache.getTile(r);if(!n){var a=new Promise(function(r){n?setTimeout(function(){r(n);},0):o._requestTileData(t,e,i,r);});return n={loading:!0,data:a},this._tileDataCache.setTile(n,r),n}return n},i.prototype._init=function(){var t=this.get("parser");this.set("minSourceZoom",t&&t.minZoom||0),this.set("maxSourceZoom",t&&t.maxZoom||18);},i.prototype._generateSource=function(t,i,o,r){return this.cfg.parser.tile=[t,i,o],new e(Object.assign({},this.cfg,{mapType:this.get("mapType"),data:r,tile:[t,i,o]}))},i.prototype._requestTileData=function(e,i,o,r){var n=this,a={x:e,y:i,z:o},s=this._getTileURL(a),l=[e,i,o].join("_");this.xhrRequest=t.getArrayBuffer({url:s},function(t,a){if(t)return n._noData=!0,void n._tileDataCache.setTile({loaded:!0,data:{data:null}},l);var s=n._generateSource(e,i,o,a.data);n._tileDataCache.setTile({loaded:!0,data:s},l),r(s);});},i.prototype.getRequestUrl=function(t,e,i){var o={x:t,y:e,z:i};return this._getTileURL(o)},i.prototype._getTileURL=function(t){return t.s||(t.s=String.fromCharCode(97+Math.floor(3*Math.random()))),ie.lastIndex=0,this.urlTemplate.replace(ie,function(e,i){return t[i]})},i.prototype.tileDestroy=function(t){t&&t.data&&!t.loading&&t.data.data&&t.data.data.dataArray&&t.data.destroy();},i}(t.Source),re=function(t,e){void 0===t&&(t=50),this._cache=new te(t,e);};re.prototype.getTile=function(t){return this._cache.get(t)},re.prototype.setTile=function(t,e){this._cache.set(e,t);},re.prototype.destory=function(){this._cache.clear();},re.prototype.setNeedUpdate=function(){var t=this;this._cache._order.forEach(function(e){t._cache.get(e).needUpdate=!0;});};var ne=function(t,e){return (ne=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e;}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i]);})(t,e)};var ae=function(){return (ae=Object.assign||function(t){for(var e,i=arguments,o=1,r=arguments.length;o<r;o++)for(var n in e=i[o])Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t}).apply(this,arguments)};function se(t){var e="function"==typeof Symbol&&t[Symbol.iterator],i=0;return e?e.call(t):{next:function(){return t&&i>=t.length&&(t=void 0),{value:t&&t[i++],done:!t}}}}function le(t,e){var i="function"==typeof Symbol&&t[Symbol.iterator];if(!i)return t;var o,r,n=i.call(t),a=[];try{for(;(void 0===e||e-- >0)&&!(o=n.next()).done;)a.push(o.value);}catch(t){r={error:t};}finally{try{o&&!o.done&&(i=n.return)&&i.call(n);}finally{if(r)throw r.error}}return a}function ce(t){return this instanceof ce?(this.v=t,this):new ce(t)}var ue=Object.freeze({__proto__:null,__extends:function(t,e){function i(){this.constructor=t;}ne(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i);},get __assign(){return ae},__rest:function(t,e){var i={};for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&e.indexOf(o)<0&&(i[o]=t[o]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols){var r=0;for(o=Object.getOwnPropertySymbols(t);r<o.length;r++)e.indexOf(o[r])<0&&Object.prototype.propertyIsEnumerable.call(t,o[r])&&(i[o[r]]=t[o[r]]);}return i},__decorate:function(t,e,i,o){var r,n=arguments.length,a=n<3?e:null===o?o=Object.getOwnPropertyDescriptor(e,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(t,e,i,o);else for(var s=t.length-1;s>=0;s--)(r=t[s])&&(a=(n<3?r(a):n>3?r(e,i,a):r(e,i))||a);return n>3&&a&&Object.defineProperty(e,i,a),a},__param:function(t,e){return function(i,o){e(i,o,t);}},__metadata:function(t,e){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(t,e)},__awaiter:function(t,e,i,o){return new(i||(i=Promise))(function(r,n){function a(t){try{l(o.next(t));}catch(t){n(t);}}function s(t){try{l(o.throw(t));}catch(t){n(t);}}function l(t){t.done?r(t.value):new i(function(e){e(t.value);}).then(a,s);}l((o=o.apply(t,e||[])).next());})},__generator:function(t,e){var i,o,r,n,a={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return n={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(n[Symbol.iterator]=function(){return this}),n;function s(n){return function(s){return function(n){if(i)throw new TypeError("Generator is already executing.");for(;a;)try{if(i=1,o&&(r=2&n[0]?o.return:n[0]?o.throw||((r=o.return)&&r.call(o),0):o.next)&&!(r=r.call(o,n[1])).done)return r;switch(o=0,r&&(n=[2&n[0],r.value]),n[0]){case 0:case 1:r=n;break;case 4:return a.label++,{value:n[1],done:!1};case 5:a.label++,o=n[1],n=[0];continue;case 7:n=a.ops.pop(),a.trys.pop();continue;default:if(!(r=(r=a.trys).length>0&&r[r.length-1])&&(6===n[0]||2===n[0])){a=0;continue}if(3===n[0]&&(!r||n[1]>r[0]&&n[1]<r[3])){a.label=n[1];break}if(6===n[0]&&a.label<r[1]){a.label=r[1],r=n;break}if(r&&a.label<r[2]){a.label=r[2],a.ops.push(n);break}r[2]&&a.ops.pop(),a.trys.pop();continue}n=e.call(t,a);}catch(t){n=[6,t],o=0;}finally{i=r=0;}if(5&n[0])throw n[1];return {value:n[0]?n[1]:void 0,done:!0}}([n,s])}}},__exportStar:function(t,e){for(var i in t)e.hasOwnProperty(i)||(e[i]=t[i]);},__values:se,__read:le,__spread:function(){for(var t=arguments,e=[],i=0;i<arguments.length;i++)e=e.concat(le(t[i]));return e},__spreadArrays:function(){for(var t=arguments,e=0,i=0,o=arguments.length;i<o;i++)e+=t[i].length;var r=Array(e),n=0;for(i=0;i<o;i++)for(var a=arguments[i],s=0,l=a.length;s<l;s++,n++)r[n]=a[s];return r},__await:ce,__asyncGenerator:function(t,e,i){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var o,r=i.apply(t,e||[]),n=[];return o={},a("next"),a("throw"),a("return"),o[Symbol.asyncIterator]=function(){return this},o;function a(t){r[t]&&(o[t]=function(e){return new Promise(function(i,o){n.push([t,e,i,o])>1||s(t,e);})});}function s(t,e){try{(i=r[t](e)).value instanceof ce?Promise.resolve(i.value.v).then(l,c):u(n[0][2],i);}catch(t){u(n[0][3],t);}var i;}function l(t){s("next",t);}function c(t){s("throw",t);}function u(t,e){t(e),n.shift(),n.length&&s(n[0][0],n[0][1]);}},__asyncDelegator:function(t){var e,i;return e={},o("next"),o("throw",function(t){throw t}),o("return"),e[Symbol.iterator]=function(){return this},e;function o(o,r){e[o]=t[o]?function(e){return (i=!i)?{value:ce(t[o](e)),done:"return"===o}:r?r(e):e}:r;}},__asyncValues:function(t){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e,i=t[Symbol.asyncIterator];return i?i.call(t):(t=se(t),e={},o("next"),o("throw"),o("return"),e[Symbol.asyncIterator]=function(){return this},e);function o(i){e[i]=t[i]&&function(e){return new Promise(function(o,r){!function(t,e,i,o){Promise.resolve(o).then(function(e){t({value:e,done:i});},e);}(o,r,(e=t[i](e)).done,e.value);})};}},__makeTemplateObject:function(t,e){return Object.defineProperty?Object.defineProperty(t,"raw",{value:e}):t.raw=e,t},__importStar:function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e},__importDefault:function(t){return t&&t.__esModule?t:{default:t}}}),he=t.createCommonjsModule(function(t,e){Object.defineProperty(e,"__esModule",{value:!0}),e.setMatrixArrayType=function(t){e.ARRAY_TYPE=t;},e.toRadian=function(t){return t*o},e.equals=function(t,e){return Math.abs(t-e)<=i*Math.max(1,Math.abs(t),Math.abs(e))};var i=e.EPSILON=1e-6;e.ARRAY_TYPE="undefined"!=typeof Float32Array?Float32Array:Array,e.RANDOM=Math.random;var o=Math.PI/180;});t.unwrapExports(he);he.setMatrixArrayType,he.toRadian,he.equals,he.EPSILON,he.ARRAY_TYPE,he.RANDOM;var pe=t.createCommonjsModule(function(t,e){Object.defineProperty(e,"__esModule",{value:!0}),e.sub=e.mul=void 0,e.create=function(){var t=new i.ARRAY_TYPE(9);i.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0);return t[0]=1,t[4]=1,t[8]=1,t},e.fromMat4=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[4],t[4]=e[5],t[5]=e[6],t[6]=e[8],t[7]=e[9],t[8]=e[10],t},e.clone=function(t){var e=new i.ARRAY_TYPE(9);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e},e.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[4]=e[4],t[5]=e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},e.fromValues=function(t,e,o,r,n,a,s,l,c){var u=new i.ARRAY_TYPE(9);return u[0]=t,u[1]=e,u[2]=o,u[3]=r,u[4]=n,u[5]=a,u[6]=s,u[7]=l,u[8]=c,u},e.set=function(t,e,i,o,r,n,a,s,l,c){return t[0]=e,t[1]=i,t[2]=o,t[3]=r,t[4]=n,t[5]=a,t[6]=s,t[7]=l,t[8]=c,t},e.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},e.transpose=function(t,e){if(t===e){var i=e[1],o=e[2],r=e[5];t[1]=e[3],t[2]=e[6],t[3]=i,t[5]=e[7],t[6]=o,t[7]=r;}else t[0]=e[0],t[1]=e[3],t[2]=e[6],t[3]=e[1],t[4]=e[4],t[5]=e[7],t[6]=e[2],t[7]=e[5],t[8]=e[8];return t},e.invert=function(t,e){var i=e[0],o=e[1],r=e[2],n=e[3],a=e[4],s=e[5],l=e[6],c=e[7],u=e[8],h=u*a-s*c,p=-u*n+s*l,f=c*n-a*l,d=i*h+o*p+r*f;if(!d)return null;return d=1/d,t[0]=h*d,t[1]=(-u*o+r*c)*d,t[2]=(s*o-r*a)*d,t[3]=p*d,t[4]=(u*i-r*l)*d,t[5]=(-s*i+r*n)*d,t[6]=f*d,t[7]=(-c*i+o*l)*d,t[8]=(a*i-o*n)*d,t},e.adjoint=function(t,e){var i=e[0],o=e[1],r=e[2],n=e[3],a=e[4],s=e[5],l=e[6],c=e[7],u=e[8];return t[0]=a*u-s*c,t[1]=r*c-o*u,t[2]=o*s-r*a,t[3]=s*l-n*u,t[4]=i*u-r*l,t[5]=r*n-i*s,t[6]=n*c-a*l,t[7]=o*l-i*c,t[8]=i*a-o*n,t},e.determinant=function(t){var e=t[0],i=t[1],o=t[2],r=t[3],n=t[4],a=t[5],s=t[6],l=t[7],c=t[8];return e*(c*n-a*l)+i*(-c*r+a*s)+o*(l*r-n*s)},e.multiply=o,e.translate=function(t,e,i){var o=e[0],r=e[1],n=e[2],a=e[3],s=e[4],l=e[5],c=e[6],u=e[7],h=e[8],p=i[0],f=i[1];return t[0]=o,t[1]=r,t[2]=n,t[3]=a,t[4]=s,t[5]=l,t[6]=p*o+f*a+c,t[7]=p*r+f*s+u,t[8]=p*n+f*l+h,t},e.rotate=function(t,e,i){var o=e[0],r=e[1],n=e[2],a=e[3],s=e[4],l=e[5],c=e[6],u=e[7],h=e[8],p=Math.sin(i),f=Math.cos(i);return t[0]=f*o+p*a,t[1]=f*r+p*s,t[2]=f*n+p*l,t[3]=f*a-p*o,t[4]=f*s-p*r,t[5]=f*l-p*n,t[6]=c,t[7]=u,t[8]=h,t},e.scale=function(t,e,i){var o=i[0],r=i[1];return t[0]=o*e[0],t[1]=o*e[1],t[2]=o*e[2],t[3]=r*e[3],t[4]=r*e[4],t[5]=r*e[5],t[6]=e[6],t[7]=e[7],t[8]=e[8],t},e.fromTranslation=function(t,e){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=e[0],t[7]=e[1],t[8]=1,t},e.fromRotation=function(t,e){var i=Math.sin(e),o=Math.cos(e);return t[0]=o,t[1]=i,t[2]=0,t[3]=-i,t[4]=o,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},e.fromScaling=function(t,e){return t[0]=e[0],t[1]=0,t[2]=0,t[3]=0,t[4]=e[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},e.fromMat2d=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=0,t[3]=e[2],t[4]=e[3],t[5]=0,t[6]=e[4],t[7]=e[5],t[8]=1,t},e.fromQuat=function(t,e){var i=e[0],o=e[1],r=e[2],n=e[3],a=i+i,s=o+o,l=r+r,c=i*a,u=o*a,h=o*s,p=r*a,f=r*s,d=r*l,_=n*a,v=n*s,g=n*l;return t[0]=1-h-d,t[3]=u-g,t[6]=p+v,t[1]=u+g,t[4]=1-c-d,t[7]=f-_,t[2]=p-v,t[5]=f+_,t[8]=1-c-h,t},e.normalFromMat4=function(t,e){var i=e[0],o=e[1],r=e[2],n=e[3],a=e[4],s=e[5],l=e[6],c=e[7],u=e[8],h=e[9],p=e[10],f=e[11],d=e[12],_=e[13],v=e[14],g=e[15],y=i*s-o*a,m=i*l-r*a,b=i*c-n*a,x=o*l-r*s,w=o*c-n*s,C=r*c-n*l,M=u*_-h*d,A=u*v-p*d,T=u*g-f*d,L=h*v-p*_,k=h*g-f*_,S=p*g-f*v,I=y*S-m*k+b*L+x*T-w*A+C*M;if(!I)return null;return I=1/I,t[0]=(s*S-l*k+c*L)*I,t[1]=(l*T-a*S-c*A)*I,t[2]=(a*k-s*T+c*M)*I,t[3]=(r*k-o*S-n*L)*I,t[4]=(i*S-r*T+n*A)*I,t[5]=(o*T-i*k-n*M)*I,t[6]=(_*C-v*w+g*x)*I,t[7]=(v*b-d*C-g*m)*I,t[8]=(d*w-_*b+g*y)*I,t},e.projection=function(t,e,i){return t[0]=2/e,t[1]=0,t[2]=0,t[3]=0,t[4]=-2/i,t[5]=0,t[6]=-1,t[7]=1,t[8]=1,t},e.str=function(t){return "mat3("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+")"},e.frob=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2)+Math.pow(t[2],2)+Math.pow(t[3],2)+Math.pow(t[4],2)+Math.pow(t[5],2)+Math.pow(t[6],2)+Math.pow(t[7],2)+Math.pow(t[8],2))},e.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t[3]=e[3]+i[3],t[4]=e[4]+i[4],t[5]=e[5]+i[5],t[6]=e[6]+i[6],t[7]=e[7]+i[7],t[8]=e[8]+i[8],t},e.subtract=r,e.multiplyScalar=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t[4]=e[4]*i,t[5]=e[5]*i,t[6]=e[6]*i,t[7]=e[7]*i,t[8]=e[8]*i,t},e.multiplyScalarAndAdd=function(t,e,i,o){return t[0]=e[0]+i[0]*o,t[1]=e[1]+i[1]*o,t[2]=e[2]+i[2]*o,t[3]=e[3]+i[3]*o,t[4]=e[4]+i[4]*o,t[5]=e[5]+i[5]*o,t[6]=e[6]+i[6]*o,t[7]=e[7]+i[7]*o,t[8]=e[8]+i[8]*o,t},e.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]&&t[3]===e[3]&&t[4]===e[4]&&t[5]===e[5]&&t[6]===e[6]&&t[7]===e[7]&&t[8]===e[8]},e.equals=function(t,e){var o=t[0],r=t[1],n=t[2],a=t[3],s=t[4],l=t[5],c=t[6],u=t[7],h=t[8],p=e[0],f=e[1],d=e[2],_=e[3],v=e[4],g=e[5],y=e[6],m=e[7],b=e[8];return Math.abs(o-p)<=i.EPSILON*Math.max(1,Math.abs(o),Math.abs(p))&&Math.abs(r-f)<=i.EPSILON*Math.max(1,Math.abs(r),Math.abs(f))&&Math.abs(n-d)<=i.EPSILON*Math.max(1,Math.abs(n),Math.abs(d))&&Math.abs(a-_)<=i.EPSILON*Math.max(1,Math.abs(a),Math.abs(_))&&Math.abs(s-v)<=i.EPSILON*Math.max(1,Math.abs(s),Math.abs(v))&&Math.abs(l-g)<=i.EPSILON*Math.max(1,Math.abs(l),Math.abs(g))&&Math.abs(c-y)<=i.EPSILON*Math.max(1,Math.abs(c),Math.abs(y))&&Math.abs(u-m)<=i.EPSILON*Math.max(1,Math.abs(u),Math.abs(m))&&Math.abs(h-b)<=i.EPSILON*Math.max(1,Math.abs(h),Math.abs(b))};var i=function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e}(he);function o(t,e,i){var o=e[0],r=e[1],n=e[2],a=e[3],s=e[4],l=e[5],c=e[6],u=e[7],h=e[8],p=i[0],f=i[1],d=i[2],_=i[3],v=i[4],g=i[5],y=i[6],m=i[7],b=i[8];return t[0]=p*o+f*a+d*c,t[1]=p*r+f*s+d*u,t[2]=p*n+f*l+d*h,t[3]=_*o+v*a+g*c,t[4]=_*r+v*s+g*u,t[5]=_*n+v*l+g*h,t[6]=y*o+m*a+b*c,t[7]=y*r+m*s+b*u,t[8]=y*n+m*l+b*h,t}function r(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t[3]=e[3]-i[3],t[4]=e[4]-i[4],t[5]=e[5]-i[5],t[6]=e[6]-i[6],t[7]=e[7]-i[7],t[8]=e[8]-i[8],t}e.mul=o,e.sub=r;});t.unwrapExports(pe);pe.sub,pe.mul,pe.create,pe.fromMat4,pe.clone,pe.copy,pe.fromValues,pe.set,pe.identity,pe.transpose,pe.invert,pe.adjoint,pe.determinant,pe.multiply,pe.translate,pe.rotate,pe.scale,pe.fromTranslation,pe.fromRotation,pe.fromScaling,pe.fromMat2d,pe.fromQuat,pe.normalFromMat4,pe.projection,pe.str,pe.frob,pe.add,pe.subtract,pe.multiplyScalar,pe.multiplyScalarAndAdd,pe.exactEquals,pe.equals;var fe=t.createCommonjsModule(function(t,e){e.__esModule=!0,pe.translate=function(t,e,i){var o=Array(9);return pe.fromTranslation(o,i),pe.multiply(t,o,e)},pe.rotate=function(t,e,i){var o=Array(9);return pe.fromRotation(o,i),pe.multiply(t,o,e)},pe.scale=function(t,e,i){var o=Array(9);return pe.fromScaling(o,i),pe.multiply(t,o,e)},pe.transform=function(t,e){for(var i=[].concat(t),o=0,r=e.length;o<r;o+=1){var n=e[o];switch(n[0]){case"t":pe.translate(i,i,[n[1],n[2]]);break;case"s":pe.scale(i,i,[n[1],n[2]]);break;case"r":pe.rotate(i,i,n[1]);}}return i},e.default=pe;});t.unwrapExports(fe);var de=t.createCommonjsModule(function(t,e){Object.defineProperty(e,"__esModule",{value:!0}),e.forEach=e.sqrLen=e.len=e.sqrDist=e.dist=e.div=e.mul=e.sub=void 0,e.create=o,e.clone=function(t){var e=new i.ARRAY_TYPE(3);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},e.length=r,e.fromValues=n,e.copy=function(t,e){return t[0]=e[0],t[1]=e[1],t[2]=e[2],t},e.set=function(t,e,i,o){return t[0]=e,t[1]=i,t[2]=o,t},e.add=function(t,e,i){return t[0]=e[0]+i[0],t[1]=e[1]+i[1],t[2]=e[2]+i[2],t},e.subtract=a,e.multiply=s,e.divide=l,e.ceil=function(t,e){return t[0]=Math.ceil(e[0]),t[1]=Math.ceil(e[1]),t[2]=Math.ceil(e[2]),t},e.floor=function(t,e){return t[0]=Math.floor(e[0]),t[1]=Math.floor(e[1]),t[2]=Math.floor(e[2]),t},e.min=function(t,e,i){return t[0]=Math.min(e[0],i[0]),t[1]=Math.min(e[1],i[1]),t[2]=Math.min(e[2],i[2]),t},e.max=function(t,e,i){return t[0]=Math.max(e[0],i[0]),t[1]=Math.max(e[1],i[1]),t[2]=Math.max(e[2],i[2]),t},e.round=function(t,e){return t[0]=Math.round(e[0]),t[1]=Math.round(e[1]),t[2]=Math.round(e[2]),t},e.scale=function(t,e,i){return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t},e.scaleAndAdd=function(t,e,i,o){return t[0]=e[0]+i[0]*o,t[1]=e[1]+i[1]*o,t[2]=e[2]+i[2]*o,t},e.distance=c,e.squaredDistance=u,e.squaredLength=h,e.negate=function(t,e){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t},e.inverse=function(t,e){return t[0]=1/e[0],t[1]=1/e[1],t[2]=1/e[2],t},e.normalize=p,e.dot=f,e.cross=function(t,e,i){var o=e[0],r=e[1],n=e[2],a=i[0],s=i[1],l=i[2];return t[0]=r*l-n*s,t[1]=n*a-o*l,t[2]=o*s-r*a,t},e.lerp=function(t,e,i,o){var r=e[0],n=e[1],a=e[2];return t[0]=r+o*(i[0]-r),t[1]=n+o*(i[1]-n),t[2]=a+o*(i[2]-a),t},e.hermite=function(t,e,i,o,r,n){var a=n*n,s=a*(2*n-3)+1,l=a*(n-2)+n,c=a*(n-1),u=a*(3-2*n);return t[0]=e[0]*s+i[0]*l+o[0]*c+r[0]*u,t[1]=e[1]*s+i[1]*l+o[1]*c+r[1]*u,t[2]=e[2]*s+i[2]*l+o[2]*c+r[2]*u,t},e.bezier=function(t,e,i,o,r,n){var a=1-n,s=a*a,l=n*n,c=s*a,u=3*n*s,h=3*l*a,p=l*n;return t[0]=e[0]*c+i[0]*u+o[0]*h+r[0]*p,t[1]=e[1]*c+i[1]*u+o[1]*h+r[1]*p,t[2]=e[2]*c+i[2]*u+o[2]*h+r[2]*p,t},e.random=function(t,e){e=e||1;var o=2*i.RANDOM()*Math.PI,r=2*i.RANDOM()-1,n=Math.sqrt(1-r*r)*e;return t[0]=Math.cos(o)*n,t[1]=Math.sin(o)*n,t[2]=r*e,t},e.transformMat4=function(t,e,i){var o=e[0],r=e[1],n=e[2],a=i[3]*o+i[7]*r+i[11]*n+i[15];return a=a||1,t[0]=(i[0]*o+i[4]*r+i[8]*n+i[12])/a,t[1]=(i[1]*o+i[5]*r+i[9]*n+i[13])/a,t[2]=(i[2]*o+i[6]*r+i[10]*n+i[14])/a,t},e.transformMat3=function(t,e,i){var o=e[0],r=e[1],n=e[2];return t[0]=o*i[0]+r*i[3]+n*i[6],t[1]=o*i[1]+r*i[4]+n*i[7],t[2]=o*i[2]+r*i[5]+n*i[8],t},e.transformQuat=function(t,e,i){var o=i[0],r=i[1],n=i[2],a=i[3],s=e[0],l=e[1],c=e[2],u=r*c-n*l,h=n*s-o*c,p=o*l-r*s,f=r*p-n*h,d=n*u-o*p,_=o*h-r*u,v=2*a;return u*=v,h*=v,p*=v,f*=2,d*=2,_*=2,t[0]=s+u+f,t[1]=l+h+d,t[2]=c+p+_,t},e.rotateX=function(t,e,i,o){var r=[],n=[];return r[0]=e[0]-i[0],r[1]=e[1]-i[1],r[2]=e[2]-i[2],n[0]=r[0],n[1]=r[1]*Math.cos(o)-r[2]*Math.sin(o),n[2]=r[1]*Math.sin(o)+r[2]*Math.cos(o),t[0]=n[0]+i[0],t[1]=n[1]+i[1],t[2]=n[2]+i[2],t},e.rotateY=function(t,e,i,o){var r=[],n=[];return r[0]=e[0]-i[0],r[1]=e[1]-i[1],r[2]=e[2]-i[2],n[0]=r[2]*Math.sin(o)+r[0]*Math.cos(o),n[1]=r[1],n[2]=r[2]*Math.cos(o)-r[0]*Math.sin(o),t[0]=n[0]+i[0],t[1]=n[1]+i[1],t[2]=n[2]+i[2],t},e.rotateZ=function(t,e,i,o){var r=[],n=[];return r[0]=e[0]-i[0],r[1]=e[1]-i[1],r[2]=e[2]-i[2],n[0]=r[0]*Math.cos(o)-r[1]*Math.sin(o),n[1]=r[0]*Math.sin(o)+r[1]*Math.cos(o),n[2]=r[2],t[0]=n[0]+i[0],t[1]=n[1]+i[1],t[2]=n[2]+i[2],t},e.angle=function(t,e){var i=n(t[0],t[1],t[2]),o=n(e[0],e[1],e[2]);p(i,i),p(o,o);var r=f(i,o);return r>1?0:r<-1?Math.PI:Math.acos(r)},e.str=function(t){return "vec3("+t[0]+", "+t[1]+", "+t[2]+")"},e.exactEquals=function(t,e){return t[0]===e[0]&&t[1]===e[1]&&t[2]===e[2]},e.equals=function(t,e){var o=t[0],r=t[1],n=t[2],a=e[0],s=e[1],l=e[2];return Math.abs(o-a)<=i.EPSILON*Math.max(1,Math.abs(o),Math.abs(a))&&Math.abs(r-s)<=i.EPSILON*Math.max(1,Math.abs(r),Math.abs(s))&&Math.abs(n-l)<=i.EPSILON*Math.max(1,Math.abs(n),Math.abs(l))};var i=function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e}(he);function o(){var t=new i.ARRAY_TYPE(3);return i.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function r(t){var e=t[0],i=t[1],o=t[2];return Math.sqrt(e*e+i*i+o*o)}function n(t,e,o){var r=new i.ARRAY_TYPE(3);return r[0]=t,r[1]=e,r[2]=o,r}function a(t,e,i){return t[0]=e[0]-i[0],t[1]=e[1]-i[1],t[2]=e[2]-i[2],t}function s(t,e,i){return t[0]=e[0]*i[0],t[1]=e[1]*i[1],t[2]=e[2]*i[2],t}function l(t,e,i){return t[0]=e[0]/i[0],t[1]=e[1]/i[1],t[2]=e[2]/i[2],t}function c(t,e){var i=e[0]-t[0],o=e[1]-t[1],r=e[2]-t[2];return Math.sqrt(i*i+o*o+r*r)}function u(t,e){var i=e[0]-t[0],o=e[1]-t[1],r=e[2]-t[2];return i*i+o*o+r*r}function h(t){var e=t[0],i=t[1],o=t[2];return e*e+i*i+o*o}function p(t,e){var i=e[0],o=e[1],r=e[2],n=i*i+o*o+r*r;return n>0&&(n=1/Math.sqrt(n),t[0]=e[0]*n,t[1]=e[1]*n,t[2]=e[2]*n),t}function f(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]}var d;e.sub=a,e.mul=s,e.div=l,e.dist=c,e.sqrDist=u,e.len=r,e.sqrLen=h,e.forEach=(d=o(),function(t,e,i,o,r,n){var a=void 0,s=void 0;for(e||(e=3),i||(i=0),s=o?Math.min(o*e+i,t.length):t.length,a=i;a<s;a+=e)d[0]=t[a],d[1]=t[a+1],d[2]=t[a+2],r(d,d,n),t[a]=d[0],t[a+1]=d[1],t[a+2]=d[2];return t});});t.unwrapExports(de);de.forEach,de.sqrLen,de.len,de.sqrDist,de.dist,de.div,de.mul,de.sub,de.create,de.clone,de.length,de.fromValues,de.copy,de.set,de.add,de.subtract,de.multiply,de.divide,de.ceil,de.floor,de.min,de.max,de.round,de.scale,de.scaleAndAdd,de.distance,de.squaredDistance,de.squaredLength,de.negate,de.inverse,de.normalize,de.dot,de.cross,de.lerp,de.hermite,de.bezier,de.random,de.transformMat4,de.transformMat3,de.transformQuat,de.rotateX,de.rotateY,de.rotateZ,de.angle,de.str,de.exactEquals,de.equals;var _e=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=function(){function t(t){void 0===t&&(t={}),this.matrix=[1,0,0,0,1,0,0,0,1],this.isTransposed=!1,Object.assign(this,t),this.init();}return t.prototype.init=function(){var t=this.start,e=this.end,i={x:(t.x+e.x)/2,y:(t.y+e.y)/2};this.center=i,this.width=Math.abs(e.x-t.x),this.height=Math.abs(e.y-t.y);},t.prototype._swapDim=function(t){var e=this[t];if(e){var i=e.start;e.start=e.end,e.end=i;}},t.prototype.getCenter=function(){return this.center},t.prototype.getWidth=function(){return this.width},t.prototype.getHeight=function(){return this.height},t.prototype.convertDim=function(t,e){var i=this[e],o=i.start;return o+t*(i.end-o)},t.prototype.invertDim=function(t,e){var i=this[e],o=i.start;return (t-o)/(i.end-o)},t.prototype.convertPoint=function(t){return t},t.prototype.invertPoint=function(t){return t},t.prototype.applyMatrix=function(t,e,i){void 0===i&&(i=0);var o=this.matrix,r=[t,e,i];return de.transformMat3(r,r,o),r},t.prototype.invertMatrix=function(t,e,i){void 0===i&&(i=0);var o=this.matrix,r=fe.default.invert([],o),n=[t,e,i];return de.transformMat3(n,n,r),n},t.prototype.convert=function(t){var e=this.convertPoint(t),i=e.x,o=e.y,r=this.applyMatrix(i,o,1);return {x:r[0],y:r[1]}},t.prototype.invert=function(t){var e=this.invertMatrix(t.x,t.y,1);return this.invertPoint({x:e[0],y:e[1]})},t.prototype.rotate=function(t){var e=this.matrix,i=this.center;return fe.default.translate(e,e,[-i.x,-i.y]),fe.default.rotate(e,e,t),fe.default.translate(e,e,[i.x,i.y]),this},t.prototype.reflect=function(t){switch(t){case"x":this._swapDim("x");break;case"y":this._swapDim("y");break;default:this._swapDim("y");}return this},t.prototype.scale=function(t,e){var i=this.matrix,o=this.center;return fe.default.translate(i,i,[-o.x,-o.y]),fe.default.scale(i,i,[t,e]),fe.default.translate(i,i,[o.x,o.y]),this},t.prototype.translate=function(t,e){var i=this.matrix;return fe.default.translate(i,i,[t,e]),this},t.prototype.transpose=function(){return this.isTransposed=!this.isTransposed,this},t}();e.default=i;});t.unwrapExports(_e);var ve=t.createCommonjsModule(function(t,e){e.__esModule=!0;e.trunc=function(t){return t>0?Math.floor(t):Math.ceil(t)},e.formatNum=function(t,e){var i=Math.pow(10,void 0===e?6:e);return Math.round(t*i)/i},e.wrapNum=function(t,e,i){var o=e[1],r=e[0],n=o-r;return t===o&&i?t:((t-r)%n+n)%n+r};});t.unwrapExports(ve);ve.trunc,ve.formatNum;var ge=ve.wrapNum,ye=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=function(){function t(t,e,i){this.x=i?Math.round(t):t,this.y=i?Math.round(e):e;}return t.prototype.clone=function(){return new t(this.x,this.y)},t.prototype.add=function(t,e,i){return this.clone()._add(o(t,e,i))},t.prototype._add=function(t){return this.x+=t.x,this.y+=t.y,this},t.prototype.subtract=function(t,e,i){return this.clone()._subtract(o(t,e,i))},t.prototype._subtract=function(t){return this.x-=t.x,this.y-=t.y,this},t.prototype.divideBy=function(t){return this.clone()._divideBy(t)},t.prototype._divideBy=function(t){return this.x/=t,this.y/=t,this},t.prototype.multiplyBy=function(t){return this.clone()._multiplyBy(t)},t.prototype._multiplyBy=function(t){return this.x*=t,this.y*=t,this},t.prototype.scaleBy=function(e){return new t(this.x*e.x,this.y*e.y)},t.prototype.unscaleBy=function(e){return new t(this.x/e.x,this.y/e.y)},t.prototype.round=function(){return this.clone()._round()},t.prototype._round=function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this},t.prototype.floor=function(){return this.clone()._floor()},t.prototype._floor=function(){return this.x=Math.floor(this.x),this.y=Math.floor(this.y),this},t.prototype.ceil=function(){return this.clone()._ceil()},t.prototype._ceil=function(){return this.x=Math.ceil(this.x),this.y=Math.ceil(this.y),this},t.prototype.trunc=function(){return this.clone()._trunc()},t.prototype._trunc=function(){return this.x=ve.trunc(this.x),this.y=ve.trunc(this.y),this},t.prototype.distanceTo=function(t){var e=o(t),i=e.x-this.x,r=e.y-this.y;return Math.sqrt(i*i+r*r)},t.prototype.equals=function(t,e){var i=o(t);return Math.max(Math.abs(this.x-i.x),Math.abs(this.y-i.y))<=(void 0===e?1e-9:e)},t.prototype.contains=function(t){var e=o(t);return Math.abs(e.x)<=Math.abs(this.x)&&Math.abs(e.y)<=Math.abs(this.y)},t.prototype.toString=function(){return "Point("+ve.formatNum(this.x)+", "+ve.formatNum(this.y)+")"},t}();function o(t,e,o){return t instanceof i?t:Array.isArray(t)?new i(t[0],t[1]):null==t?t:"object"==typeof t&&"x"in t&&"y"in t?new i(t.x,t.y):new i(t,e,o)}e.Point=i,e.toPoint=o;});t.unwrapExports(ye);ye.Point,ye.toPoint;var me=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=function(){function t(t,e){if(t){var i=e?[t,e]:t;if(Array.isArray(i))for(var o=0,r=i.length;o<r;o+=1)this.extend(i[o]);}}return t.prototype.extend=function(t){var e=ye.toPoint(t);return this.min||this.max?(this.min.x=Math.min(e.x,this.min.x),this.max.x=Math.max(e.x,this.max.x),this.min.y=Math.min(e.y,this.min.y),this.max.y=Math.max(e.y,this.max.y)):(this.min=e.clone(),this.max=e.clone()),this},t.prototype.getCenter=function(t){return new ye.Point((this.min.x+this.max.x)/2,(this.min.y+this.max.y)/2,t)},t.prototype.getBottomLeft=function(){return new ye.Point(this.min.x,this.max.y)},t.prototype.getTopRight=function(){return new ye.Point(this.max.x,this.min.y)},t.prototype.getBottomRight=function(){return this.max},t.prototype.getTopLeft=function(){return this.min},t.prototype.getSize=function(){return this.max.subtract(this.min)},t.prototype.contains=function(e){var i,r,n=e;return (n=n instanceof ye.Point||"number"==typeof n[0]?ye.toPoint(n):o(n))instanceof t?(i=n.min,r=n.max):i=r=e,i.x>=this.min.x&&r.x<=this.max.x&&i.y>=this.min.y&&r.y<=this.max.y},t.prototype.intersect=function(t){var e=o(t),i=this.min,r=this.max,n=e.min,a=e.max,s=a.x>=i.x&&n.x<=r.x,l=a.y>=i.y&&n.y<=r.y;return s&&l},t.prototype.overlaps=function(t){var e=o(t),i=this.min,r=this.max,n=e.min,a=e.max,s=a.x>i.x&&n.x<r.x,l=a.y>i.y&&n.y<r.y;return s&&l},t.prototype.isValid=function(){return !(!this.min||!this.max)},t}();function o(t,e){return !t||t instanceof i?t:new i(t,e)}e.Bounds=i,e.toBounds=o;});t.unwrapExports(me);me.Bounds,me.toBounds;var be=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=function(){function t(t,e){if(t){var i=e?[t,e]:t;if(Array.isArray(i))for(var o=0,r=i.length;o<r;o+=1)this.extend(i[o]);}}return t.prototype.extend=function(e){var i,r,n=this.southWest,a=this.northEast;if(e instanceof xe.LngLat)i=e,r=e;else{if(!(e instanceof t))return e&&Array.isArray(e)?Array.isArray(e[0])?this.extend(o(e)):this.extend(xe.toLngLat(e)):this;if(i=e.southWest,r=e.northEast,!i||!r)return this}return n||a?(n.lat=Math.min(i.lat,n.lat),n.lng=Math.min(i.lng,n.lng),a.lat=Math.max(r.lat,a.lat),a.lng=Math.max(r.lng,a.lng)):(this.southWest=new xe.LngLat(i.lng,i.lat),this.northEast=new xe.LngLat(r.lng,r.lat)),this},t.prototype.pad=function(e){var i=this.southWest,o=this.northEast,r=Math.abs(i.lat-o.lat)*e,n=Math.abs(i.lng-o.lng)*e;return new t(new xe.LngLat(i.lng-n,i.lat-r),new xe.LngLat(o.lng+n,o.lat+r))},t.prototype.getCenter=function(){return new xe.LngLat((this.southWest.lng+this.northEast.lng)/2,(this.southWest.lat+this.northEast.lat)/2)},t.prototype.getSouthWest=function(){return this.southWest},t.prototype.getNorthEast=function(){return this.northEast},t.prototype.getNorthWest=function(){return new xe.LngLat(this.getWest(),this.getNorth())},t.prototype.getSouthEast=function(){return new xe.LngLat(this.getEast(),this.getSouth())},t.prototype.getWest=function(){return this.southWest.lng},t.prototype.getSouth=function(){return this.southWest.lat},t.prototype.getNorth=function(){return this.northEast.lat},t.prototype.getEast=function(){return this.northEast.lng},t.prototype.contains=function(e){var i=e;i=Array.isArray(i)&&"number"==typeof i[0]||i instanceof xe.LngLat||"lat"in i?xe.toLngLat(i):o(i);var r,n,a=this.southWest,s=this.northEast;return i instanceof t?(r=i.getSouthWest(),n=i.getNorthEast()):r=n=i,r.lat>=a.lat&&n.lat<=s.lat&&r.lng>=a.lng&&n.lng<=s.lng},t.prototype.intersects=function(t){var e=o(t),i=this.southWest,r=this.northEast,n=e.getSouthWest(),a=e.getNorthEast(),s=a.lat>=i.lat&&n.lat<=r.lat,l=a.lng>=i.lng&&n.lng<=r.lng;return s&&l},t.prototype.overlaps=function(t){var e=o(t),i=this.southWest,r=this.northEast,n=e.getSouthWest(),a=e.getNorthEast(),s=a.lat>i.lat&&n.lat<r.lat,l=a.lng>i.lng&&n.lng<r.lng;return s&&l},t.prototype.toBBoxString=function(){return [this.getWest(),this.getSouth(),this.getEast(),this.getNorth()].join(",")},t.prototype.equals=function(t,e){if(!t)return !1;var i=o(t);return this.southWest.equals(i.getSouthWest(),e)&&this.northEast.equals(i.getNorthEast(),e)},t.prototype.isValid=function(){return !(!this.southWest||!this.northEast)},t}();function o(t,e){return t instanceof i?t:void 0!==e?new i(t,e):new i(t)}e.LngLatBounds=i,e.toLngLatBounds=o;});t.unwrapExports(be);be.LngLatBounds,be.toLngLatBounds;var xe=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=function(){function t(t,e,i){if(isNaN(e)||isNaN(t))throw new Error("无效的经纬度参数: ("+t+",' "+e);this.lat=+e,this.lng=+t,void 0!==i&&(this.alt=+i);}return t.prototype.equals=function(t,e){if(!t)return !1;var i=o(t);return void 0!==i&&Math.max(Math.abs(this.lat-i.lat),Math.abs(this.lng-i.lng))<=(void 0===e?1e-9:e)},t.prototype.toString=function(t){return "LngLat("+ve.formatNum(this.lng,t)+", "+ve.formatNum(this.lat,t)+")"},t.prototype.distanceTo=function(t){return Te.earth.distance(this,o(t))},t.prototype.wrap=function(){return Te.earth.wrapLngLat(this)},t.prototype.toBounds=function(t){var e=180*t/40075017,i=e/Math.cos(Math.PI/180*this.lat);return be.toLngLatBounds([this.lng-i,this.lat-e],[this.lng+i,this.lat+e])},t.prototype.clone=function(){return new t(this.lng,this.lat,this.alt)},t}();function o(t,e,o){if(t instanceof i)return t;if(Array.isArray(t)&&"object"!=typeof t[0]){if(3===t.length)return new i(t[0],t[1],t[2]);if(2===t.length)return new i(t[0],t[1])}if(null==t)throw new Error("无效的经纬度参数: ("+t+", "+e+")");if("object"==typeof t&&"lat"in t)return new i(t.lng,"lng"in t?t.lat:0,t.alt);if(void 0===e)throw new Error("无效的经纬度参数: ("+t+", "+e+")");return new i(Number(t),e,o)}e.LngLat=i,e.toLngLat=o;});t.unwrapExports(xe);xe.LngLat;var we=xe.toLngLat,Ce=t.createCommonjsModule(function(t,e){var i;e.__esModule=!0,e.sphericalMercator={R:6378137,MAX_LATITUDE:85.0511287798,project:function(t){var e=Math.PI/180,i=this.MAX_LATITUDE,o=Math.max(Math.min(i,t.lat),-i),r=Math.sin(o*e);return new ye.Point(this.R*t.lng*e,this.R*Math.log((1+r)/(1-r))/2)},unproject:function(t){var e=180/Math.PI;return new xe.LngLat(t.x*e/this.R,(2*Math.atan(Math.exp(t.y/this.R))-Math.PI/2)*e)},bounds:(i=6378137*Math.PI,new me.Bounds([-i,-i],[i,i]))};});t.unwrapExports(Ce);Ce.sphericalMercator;var Me=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=function(){function t(t,e,i,o){if(Array.isArray(t))return this.a=t[0],this.b=t[1],this.c=t[2],void(this.d=t[3]);this.a=t,this.b=e,this.c=i,this.d=o;}return t.prototype.transform=function(t,e){return this._transform(t.clone(),e)},t.prototype._transform=function(t,e){var i=e||1;return t.x=i*(this.a*t.x+this.b),t.y=i*(this.c*t.y+this.d),t},t.prototype.untransform=function(t,e){var i=e||1;return new ye.Point((t.x/i-this.b)/this.a,(t.y/i-this.d)/this.c)},t}();e.Transformation=i;});t.unwrapExports(Me);Me.Transformation;var Ae=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=.5/(Math.PI*Ce.sphericalMercator.R),o=new Me.Transformation(i,.5,-i,.5);e.CRS={wrapLng:[-180,180],wrapLat:null,projection:Ce.sphericalMercator,transformation:o,lngLatToPoint:function(t,e){var i=this.projection.project(t),o=this.scale(e);return this.transformation.transform(i,o)},pointToLngLat:function(t,e){var i=this.scale(e),o=this.transformation.untransform(t,i);return this.projection.unproject(o)},project:function(t){return this.projection.project(t)},unproject:function(t){return this.projection.unproject(t)},zoom:function(t){return Math.log(t/256)/Math.LN2},scale:function(t){return 256*Math.pow(2,t)},getProjectedBounds:function(t){if(this.infinite)return new me.Bounds([[1/0,1/0],[1/0,1/0]]);var e=this.projection.bounds,i=this.scale(t),o=this.transformation.transform(e.min,i),r=this.transformation.transform(e.max,i);return new me.Bounds(o,r)},infinite:!1,wrapLngLat:function(t){var e=Array.isArray(this.wrapLng)?ve.wrapNum(t.lng,this.wrapLng,!0):t.lng,i=Array.isArray(this.wrapLat)?ve.wrapNum(t.lat,this.wrapLat,!0):t.lat,o=t.alt;return new xe.LngLat(e,i,o)},wrapLngLatBounds:function(t){var e=t.getCenter(),i=this.wrapLngLat(e),o=e.lat-i.lat,r=e.lng-i.lng;if(0===o&&0===r)return t;var n=t.getSouthWest(),a=t.getNorthEast(),s=new xe.LngLat(n.lng-r,n.lat-o),l=new xe.LngLat(a.lng-r,a.lat-o);return new be.LngLatBounds(s,l)}};});t.unwrapExports(Ae);Ae.CRS;var Te=t.createCommonjsModule(function(e,i){i.__esModule=!0,i.earth=t.lib.mix({},Ae.CRS,{wrapLng:[-180,180],R:6371e3,distance:function(t,e){var i=Math.PI/180,o=t.lat*i,r=e.lat*i,n=Math.sin((e.lat-t.lat)*i/2),a=Math.sin((e.lng-t.lng)*i/2),s=n*n+Math.cos(o)*Math.cos(r)*a*a,l=2*Math.atan2(Math.sqrt(s),Math.sqrt(1-s));return this.R*l}});});t.unwrapExports(Te);Te.earth;var Le=t.createCommonjsModule(function(e,i){i.__esModule=!0;var o=.5/(Math.PI*Ce.sphericalMercator.R),r=new Me.Transformation(o,.5,-o,.5);i.epsg3857=t.lib.mix({},Te.earth,{code:"EPSG:3857",projection:Ce.sphericalMercator,transformation:r}),i.epsg900913=t.lib.mix({},i.epsg3857,{code:"EPSG:900913"});});t.unwrapExports(Le);var ke=Le.epsg3857,Se=(Le.epsg900913,t.createCommonjsModule(function(t,e){e.__esModule=!0,e.lngLatProjection={project:function(t){return new ye.Point(t.lng,t.lat)},unproject:function(t){return new xe.LngLat(t.x,t.y)},bounds:new me.Bounds([-180,-90],[180,90])};}));t.unwrapExports(Se);Se.lngLatProjection;var Ie=t.createCommonjsModule(function(e,i){i.__esModule=!0;var o=new Me.Transformation(1/180,1,-1/180,.5);i.epsg4326=t.lib.mix({},Te.earth,{code:"EPSG:4326",projection:Se.lngLatProjection,transformation:o});});t.unwrapExports(Ie);Ie.epsg4326;var Ee=t.createCommonjsModule(function(e,i){i.__esModule=!0;var o=new Me.Transformation(1,0,-1,0);i.simple=t.lib.mix({},Ae.CRS,{projection:Se.lngLatProjection,transformation:o,scale:function(t){return Math.pow(2,t)},zoom:function(t){return Math.log(t)/Math.LN2},distance:function(t,e){var i=e.lng-t.lng,o=e.lat-t.lat;return Math.sqrt(i*i+o*o)},infinite:!0});});t.unwrapExports(Ee);Ee.simple;var Oe=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i={epsg3857:Le.epsg3857,epsg4326:Ie.epsg4326,simple:Ee.simple,earth:Te.earth,epsg900913:Le.epsg900913};e.getCRS=function(t){return i[t.toLowerCase()]};});t.unwrapExports(Oe);Oe.getCRS;var Pe=t.createCommonjsModule(function(t,e){e.__esModule=!0;var i=function(t){function e(e){var i=t.call(this,ue.__assign({projection:"EPSG3857",zoom:7,mapCenter:[116.400146,39.926588]},e))||this;return i.type="geo",i.isGeo=!0,e.center?i.center=e.center:i.center=i.mapCenter,i._init(),i}return ue.__extends(e,t),e.prototype._init=function(){var t=this.start,e=this.end;this.center=xe.toLngLat(this.center),this.width=Math.abs(e.x-t.x),this.height=Math.abs(e.y-t.y),this.crs=Oe.getCRS(this.projection);},e.prototype.getZoom=function(){return this.zoom},e.prototype.setZoom=function(t){this.zoom=t;},e.prototype.setCenter=function(t){this.center=xe.toLngLat(t);},e.prototype.getCenter=function(){return this.center},e.prototype.convertPoint=function(t){var e=[t.x,t.y],i=this.project(xe.toLngLat(e),this.zoom).round(),o=this.getPixelOrigin(),r=i.subtract(o);return {x:r.x,y:r.y}},e.prototype.invertPoint=function(t){var e=ye.toPoint(t),i=this.getPixelOrigin(),o=e.add(i),r=this.unproject(o,this.zoom);return {x:r.lng,y:r.lat}},e.prototype.layerPointToLatLng=function(t){var e=this.getPixelOrigin(),i=t.add(e);return this.unproject(i,this.zoom)},e.prototype.latLngToLayerPoint=function(t){var e=this.project(xe.toLngLat(t),this.zoom).round(),i=this.getPixelOrigin();return e.subtract(i)},e.prototype.getPixelOrigin=function(){var t=this.width/2,e=this.height/2;return this.crs.lngLatToPoint(xe.toLngLat(this.center),this.zoom).subtract({y:e,x:t})},e.prototype.project=function(t,e){var i=void 0===e?this.zoom:e;return this.crs.lngLatToPoint(xe.toLngLat(t),i)},e.prototype.unproject=function(t,e){var i=void 0===e?this.zoom:e;return this.crs.pointToLngLat(ye.toPoint(t),i)},e.prototype.distance=function(t,e){return this.crs.distance(xe.toLngLat(t),xe.toLngLat(e))},e}(_e.default);e.default=i;});t.unwrapExports(Pe);var De=t.createCommonjsModule(function(t,e){e.__esModule=!0,e.GeoCoordinates=Pe,e.Bounds=me.Bounds,e.toBounds=me.toBounds,e.LngLat=xe.LngLat,e.toLngLat=xe.toLngLat,e.LngLatBounds=be.LngLatBounds,e.toLngLatBounds=be.toLngLatBounds,e.Point=ye.Point,e.toPoint=ye.toPoint;});t.unwrapExports(De);De.GeoCoordinates;var ze=De.Bounds,Fe=De.toBounds,je=(De.LngLat,De.toLngLat),Be=(De.LngLatBounds,De.toLngLatBounds),Re=De.Point,Ne=(De.toPoint,t.Global.pointShape),Ue=function(e){function i(i,o){e.call(this,i,Object.assign({},o,{minSourceZoom:0,maxSOurceZoom:18,keepBuffer:2})),this._tileCache=new re(50,this._destroyTile),this._crs=ke,this._tiles=new t.Object3D,this._tiles.frustumCulled=!1,this._tileKeys=[],this.tileList={},this.type=this.get("layerType"),this.workerPool=this.scene.workerPool;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.shape=function(t,i){return "point"===this.get("layerType")?e.prototype.shape.call(this,t,i):(this.shape=t,this)},i.prototype.source=function(t,e){return void 0===e&&(e={}),t instanceof oe?(t.set("mapType",this.scene.mapType),this.tileSource=t):(e.mapType=this.scene.mapType,this.tileSource=new oe(t,e),this.sourceCfg=Object.assign({},e,{url:t})),this},i.prototype._initControllers=function(){var t=new A({layer:this}),e=new T({layer:this});this.set("pickingController",t),this.set("interacionController",e);},i.prototype.render=function(){return this._visibleWithZoom(),this._updateDraw(),this.scene._engine.update(),this},i.prototype.draw=function(){this._object3D.add(this._tiles),this._calculateLOD();},i.prototype.drawTile=function(){},i.prototype.zoomchange=function(t){var i=this;e.prototype.zoomchange.call(this,t),this._visibleWithZoom(),requestAnimationFrame(function(){i._calculateLOD();}),this._calculateLOD();},i.prototype.dragend=function(t){var i=this;e.prototype.dragend.call(this,t),requestAnimationFrame(function(){i._calculateLOD();});},i.prototype._calculateLOD=function(){var t=this,e=Math.floor(this.scene.getZoom())-1,i=this.get("minZoom"),o=this.get("maxZoom"),r=this.tileSource.get("minSourceZoom"),n=this.tileSource.get("maxSourceZoom"),a=this.scene.getZoom();if(this.tileZoom=e>n?n:e,a<i||a>=o||a<r)return this._removeTiles(),void(this._object3D.visible=!1);this.get("visible")&&(this._object3D.visible=!0),this.show(),this.updateTileList=[];var s=this.scene.getCenter(),l=this._crs.lngLatToPoint(je(s.lng,s.lat),this.tileZoom).divideBy(256).floor(),c=this._getPixelBounds(),u=this._pxBoundsToTileRange(c),h=this.get("keepBuffer");if(this.noPruneRange=new ze(u.getBottomLeft().subtract([h,-h]),u.getTopRight().add([h,-h])),!(isFinite(u.min.x)&&isFinite(u.min.y)&&isFinite(u.max.x)&&isFinite(u.max.y)))throw new Error("Attempted to load an infinite number of tiles");for(var p=u.min.y;p<=u.max.y;p++)for(var f=u.min.x;f<=u.max.x;f++){var d=[f,p,this.tileZoom],_=this.tileList[d.join("_")];_?_.current=!0:(this.tileList[d.join("_")]={current:!0,coords:d},this.updateTileList.push(d));}this.updateTileList.sort(function(t,e){var i=t,o=e;return Math.pow(1*i[0]-l.x,2)+Math.pow(1*i[1]-l.y,2)-(Math.pow(1*o[0]-l.x,2)+Math.pow(1*o[1]-l.y,2))}),this._pruneTiles(),this.updateTileList.forEach(function(e){var i=e.join("_");t.tileList[i].current&&t._requestTile(i,t);});},i.prototype._getShape=function(t){var e=null;if(!t[0].hasOwnProperty("shape"))return "normal";for(var i=0;i<t.length&&void 0===(e=t[i].shape);i++);return -1!==Ne["2d"].indexOf(e)?"circle":-1!==Ne["3d"].indexOf(e)?"fill":-1!==this.scene.image.imagesIds.indexOf(e)?"image":"text"},i.prototype._updateTileList=function(t,e,i){var o=[t,e,i].join("_"),r=this.tileList[o];r?r.current=!0:(this.tileList[o]={current:!0,active:!1,coords:o.split("_")},this.updateTileList.push(o));},i.prototype._requestTile=function(t,e){var i=this,o=this.tileList[t];if(o){var r=this._tileCache.getTile(t);if(r){if("composer"===r.getMesh().type)return this.scene._engine.composerLayers.push(r.getMesh()),this.scene._engine.update(),void this._pruneTiles();r.needUpdate&&(r.updateColor(),r.needUpdate=!1),this._tiles.add(r.getMesh()),o.active=!0,this._addPickTile(r.getMesh()),this._tileKeys.push(t),this.scene._engine.update(),this._pruneTiles();}else(r=this._createTile(t,e)).on("tileLoaded",function(){o.active=!0;var e=r.getMesh();if(e.name=t,i._tileCache.setTile(r,t),i._tileKeys.push(t),"composer"===e.type)return i.scene._engine.composerLayers.push(e),i.scene._engine.update(),void i._pruneTiles();0!==e.children.length&&(i._tiles.add(r.getMesh()),i._addPickTile(r.getMesh())),i.scene._engine.update(),i._pruneTiles();});}},i.prototype._addPickTile=function(t){if("image"!==this.type){var e=this.get("pickingController"),i=t.children[0];i.name=t.name,e.addPickMesh(i);}},i.prototype.getSelectFeature=function(t,e){var i=this.tileZoom,o=this._crs.lngLatToPoint(je(e.lng,e.lat),i).divideBy(256).floor(),r=[o.x,o.y,i].join("_"),n=this._tileCache.getTile(r);return {feature:n?n.getSelectFeature(t):null}},i.prototype._pruneTiles=function(){var t,e=this.tileZoom;for(var i in this.tileList){var o=this.tileList[i].coords;o[2]===e&&this.noPruneRange.contains(new Re(o[0],o[1]))||(this.tileList[i].current=!1);}for(var r in this.tileList)(t=this.tileList[r]).retain=t.current;for(var n in this.tileList)if((t=this.tileList[n]).current&&!t.active){var a=n.split("_").map(function(t){return 1*t}),s=a[0],l=a[1],c=a[2];this._retainParent(s,l,c,c-5)||this._retainChildren(s,l,c,c+2);}this._removeOutTiles();},i.prototype._retainParent=function(t,e,i,o){var r=Math.floor(t/2),n=Math.floor(e/2),a=i-1,s=this.tileList[[r,n,a].join("_")];return s&&s.active?(s.retain=!0,!0):(s&&s.loaded&&(s.retain=!0),a>o&&this._retainParent(r,n,a,o))},i.prototype._retainChildren=function(t,e,i,o){for(var r=2*t;r<2*t+2;r++)for(var n=2*e;n<2*e+2;n++){var a=[r,n,i+1].join("_"),s=this.tileList[a];s&&s.active?s.retain=!0:(s&&s.loaded&&(s.retain=!0),i+1<o&&this._retainChildren(r,n,i+1,o));}},i.prototype._removeOutTiles=function(){var t=this;for(var e in this.tileList)if(!this.tileList[e].retain){var i=this._tileCache.getTile(e);if(i){i._abortRequest();var o=this.get("pickingController");o&&o.removePickMeshByName(i.getMesh().name),this._tiles.remove(i.getMesh());}i&&"composer"===i.getMesh().type&&(this.scene._engine.composerLayers=this.scene._engine.composerLayers.filter(function(t){return t.name!==i.getMesh().name})),delete this.tileList[e];}this._tiles.children.length>Object.keys(this.tileList).length&&this._tiles.children.forEach(function(e){var i=e.name;t.tileList[i]||t._tiles.remove(e);}),this.scene._engine.update();},i.prototype._removeTiles=function(){if(this.hide(),this._tiles&&this._tiles.children){for(var t=this._tiles.children.length-1;t>=0;t--)this._tiles.remove(this._tiles.children[t]);this.tileList=[],this._tileKeys=[],this._tileCache.destory(),this.get("pickingController").removeAllMesh();}},i.prototype._getPixelBounds=function(){var t,e,i=this.scene.getBounds().toBounds(),o=i.getNorthEast(),r=i.getSouthWest(),n=this.tileZoom,a=this.scene.getCenter(),s=this._crs.lngLatToPoint(je(o.lng,o.lat),n),l=this._crs.lngLatToPoint(je(r.lng,r.lat),n),c=this._crs.lngLatToPoint(je(a.lng,a.lat),n),u=c.y-s.y,h=l.y-c.y;if(a.lng-o.lng>0||a.lng-r.lng<0){var p=256*Math.pow(2,n)/360*(180-o.lng)+256*Math.pow(2,n)/360*(r.lng+180);a.lng-o.lng>0?e=p-(t=256*Math.pow(2,n)/360*(a.lng-o.lng)):t=p-(e=256*Math.pow(2,n)/360*(r.lng-a.lng));}else t=256*Math.pow(2,n)/360*(a.lng-r.lng),e=256*Math.pow(2,n)/360*(o.lng-a.lng);return new ze(c.subtract(t,u),c.add(e,h))},i.prototype._pxBoundsToTileRange=function(t){return new ze(t.min.divideBy(256).floor(),t.max.divideBy(256).ceil().subtract([1,1]))},i.prototype._wrapCoords=function(t){var e=[0,Math.pow(2,t[2])];return [ge(t[0],e),t[1],t[2]]},i.prototype._destroyTile=function(t){t.destroy(),t=null;},i.prototype._updateDraw=function(){var e=this,i=this.get("preAttrOptions"),o=this.get("attrOptions"),r=this.get("preStyleOption"),n=this.get("styleOptions");if(void 0===i&&void 0===r)return this._scaleByZoom(),this._initControllers(),this._initInteraction(),this._initMapEvent(),this.draw(),void this._setPreOption();if(!(!this._tiles.children.length>0)&&this._object3D.visible){if(t.Util.isEqual(i.color,o.color)&&t.Util.isEqual(i.filter,o.filter)||(this._tileCache.setNeedUpdate(),this._tiles.children.forEach(function(t){var i=e._tileCache.getTile(t.name);i.updateColor(),i.needUpdate=!1,e.scene._engine.update();})),t.Util.isEqual(i.size,o.size),t.Util.isEqual(i.shape,o.shape),!t.Util.isEqual(r,n)){var a={};t.Util.each(S(r,n),function(t){var e=t.type,i=t.key,o=t.value;"remove"!==e&&(a[i]=o);}),this._tiles.children(function(t){e._tileCache.get(t.name).updateStyle();});}this._setPreOption();}},i.prototype.destroy=function(){},i}(O),He=180/Math.PI,We=/\{([zxy])\}/g,Ge=function(e){function i(i,o,r){var n=this;e.call(this,{scales:{},attrs:{}}),this.layer=r,this._tile=i.split("_").map(function(t){return 1*t}),this._path=o,this._tileLnglatBounds=this._tileLnglatBounds(this._tile),this._tileBounds=this._tileBounds(this._tileLnglatBounds),this._center=this._tileBounds.getCenter(),this._centerLnglat=this._tileLnglatBounds.getCenter(),this._object3D=new t.Object3D({name:i}),this._object3D.frustumCulled=!1,this._object3D.onBeforeRender=function(){},this._isLoaded=!1,this.requestTileAsync(function(t){return n._init(t)});}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype._init=function(t){this.layerSource=t,null!==this.layerSource.data?(this.isValid=!0,this._initControllers(),this._createMesh()):this.isValid=!1;},i.prototype.repaint=function(){this._initControllers(),this._createMesh();},i.prototype.requestTileAsync=function(t){var e=this.layer.tileSource.getTileData(this._tile[0],this._tile[1],this._tile[2]);e.loaded?t(e.data):e.data.then(function(e){t(e);});},i.prototype._initControllers=function(){var t=new M({layer:this.layer,mesh:this}),e=new k({layer:this.layer,mesh:this});this.set("mappingController",t),this.set("bufferController",e);},i.prototype._createMesh=function(){},i.prototype._getTileURL=function(t){return t.s||(t.s=String.fromCharCode(97+Math.floor(3*Math.random()))),We.lastIndex=0,this._path.replace(We,function(e,i){return t[i]})},i.prototype._tileBounds=function(t){var e=this.layer.scene.project([t.getNorthEast().lng,t.getNorthEast().lat]),i=this.layer.scene.project([t.getSouthWest().lng,t.getSouthWest().lat]);return Fe(i,e)},i.prototype.getMesh=function(){return this._object3D},i.prototype._tileLnglatBounds=function(t){var e=this._tile2lng(t[0]+1,t[2]),i=this._tile2lng(t[0],t[2]),o=this._tile2lat(t[1]+1,t[2]),r=this._tile2lat(t[1],t[2]);return Be([i,r],[e,o])},i.prototype._tile2lng=function(t,e){return t/Math.pow(2,e)*360-180},i.prototype._tile2lat=function(t,e){var i=Math.PI-2*Math.PI*t/Math.pow(2,e);return He*Math.atan(.5*(Math.exp(i)-Math.exp(-i)))},i.prototype._retainParent=function(t,e,i,o){void 0===o&&(o=5);var r=Math.floor(t/2),n=Math.floor(e/2),a=i-1,s=[+r,+n,+a],l=this._tiles[s];return l&&l.active?(l.retain=!0,!0):(l&&l.loaded&&(l.retain=!0),a>o&&this._retainParent(r,n,a,o))},i.prototype.updateColor=function(){var t=this.get("bufferController");this.get("mappingController").update(),t._updateColorAttributes(this.getMesh().children[0]);},i.prototype.updateStyle=function(){this.get("bufferController")._updateStyle(this.getMesh().children[0]);},i.prototype._preRender=function(){},i.prototype.destroy=function(){e.prototype.destroy.call(this),o(this._object3D);},i}(t.Base),Ve=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.requestTileAsync=function(){var t=this;setTimeout(function(){t._mesh||t._requestTile();},0);},e.prototype._requestTile=function(){var t=this._createDebugMesh();this._createMesh(t),this.emit("tileLoaded");},e.prototype._getBufferData=function(t){var e=this._tileBounds.getTopLeft(),i=this._tileBounds.getBottomRight();return [{coordinates:[[e.x,e.y,0],[i.x,i.y,0]],images:t}]},e.prototype._createMesh=function(t){if(this._center){this._layerData=this._getBufferData(t);var e=new Kt({layerData:this._layerData});e.attributes.texture=e.texture;var i=this.layer.get("styleOptions"),o=Wt(e.attributes,i);return this._object3D.add(o),this._object3D}},e.prototype._createDebugMesh=function(){var t=document.createElement("canvas"),e=t.getContext("2d");return t.width=256,t.height=256,e.font="Bold 20px Helvetica Neue, Verdana, Arial",e.fillStyle="#ff0000",e.fillText(this._tile.join("/"),20,20),e.strokeStyle="red",e.rect(0,0,256,256),e.stroke(),t},e.prototype._abortRequest=function(){this._image&&(this._image.src="");},e.prototype.updateColor=function(){},e.prototype.getSelectFeature=function(){return {}},e.prototype.destroy=function(){this._abortRequest(),this._image=null,t.prototype.destroy.call(this);},e}(Ge),qe=function(t){function e(e,i){t.call(this,e,i),this.type="image";}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._createTile=function(t,e){return new Ve(t,this.url,e)},e}(Ue),Ze=function(t){function e(e,i,o){t.call(this,o);var r=this.getDefaultParameters(),n=r.uniforms,a=r.defines,s=X("mask_quard"),l=s.vs,c=s.fs;this.uniforms=Object.assign(n,this.setUniform(e)),this.type="MaskMaterial",this.defines=Object.assign(a,i),this.vertexShader=l,this.fragmentShader=c,this.transparent=!0;}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.getDefaultParameters=function(){return {uniforms:{},defines:{}}},e}(F),Ke=function(e){function i(){e.apply(this,arguments);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype._createMesh=function(){var t=this,e=this.layerData;return "point"===this.layer.get("layerType")&&(this.layer.shape=this.layer._getShape(e)),this.mesh=D(this.layer.get("layerType"),this.layer.shape)(e,this.layer),"composer"!==this.mesh.type?(this.mesh.onBeforeRender=function(e){t._renderMask(e);},this.mesh.onAfterRender=function(t){var e=t.context;e.clear(e.STENCIL_BUFFER_BIT),e.disable(e.STENCIL_TEST);},this._object3D.add(this.mesh)):this._object3D=this.mesh,setTimeout(function(){t.emit("tileLoaded");},0),this._object3D},i.prototype._renderMask=function(e){var i=this.layer.scene.getZoom();if(r(this.mesh,{u_time:this.layer.scene._engine.clock.getElapsedTime(),u_zoom:i}),"point"!==this.layer.get("layerType")){var o=new t.Scene;this.maskScene=o;var n=this._tileMaskMesh();o.add(n);var a=e.context;e.autoClear=!1,e.clearDepth(),a.enable(a.STENCIL_TEST),a.stencilOp(a.REPLACE,a.REPLACE,a.REPLACE),a.stencilFunc(a.ALWAYS,1,4294967295),a.clearStencil(0),a.clear(a.STENCIL_BUFFER_BIT),a.colorMask(!1,!1,!1,!1),this.layer.scene._engine.renderScene(o),a.colorMask(!0,!0,!0,!0),a.depthMask(!1),e.clearDepth(),a.stencilFunc(a.EQUAL,1,4294967295),a.stencilOp(a.KEEP,a.KEEP,a.KEEP);}},i.prototype._tileMaskMesh=function(){var e=this._tileBounds,i=[e.getBottomLeft().x,e.getBottomLeft().y,0],o=[e.getBottomRight().x,e.getBottomRight().y,0],r=[e.getTopLeft().x,e.getTopLeft().y,0],n=[e.getTopRight().x,e.getTopRight().y,0],a=i.concat(n,o,i,r,n),s=new t.BufferGeometry;s.addAttribute("position",new t.Float32BufferAttribute(a,3));var l=new Ze;return new t.Mesh(s,l)},i.prototype._abortRequest=function(){this.xhrRequest&&this.xhrRequest.abort();},i.prototype.getSelectFeature=function(t){var e=this.layerSource.originData.featureKeys[t];if(e&&void 0!==e.index){var i=e.index;return this.layerSource.originData.dataArray[i]}return null},i.prototype.destroy=function(){e.prototype.destroy.call(this),o(this.maskScene),this._object3D=null,this.maskScene=null,this.layerData=null;},i}(Ge),Ye=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype._createTile=function(t,e){return new Ke(t,this.url,e)},e}(Ue),Xe=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.shape=function(e,i){return t.prototype.shape.call(this,e,i),this.shape="text",this},e.prototype.draw=function(){this.type="text",this.add(D(this.type,this.shape)(this.layerData,this));},e}(O);c("PolygonLayer",Gt),c("PointLayer",qt),c("LineLayer",Zt),c("ImageLayer",Yt),c("RasterLayer",$t),c("HeatmapLayer",Jt),c("TileLayer",Ue),c("ImageTileLayer",qe),c("VectorTileLayer",Ye),c("TextLayer",Xe);var Qe=function(e){function i(){e.call(this);var t=window.devicePixelRatio||1;this.imageWidth=64*t,this.canvas=document.createElement("canvas"),this.canvas.style.cssText+="height: 512px;width: 512px;",this.canvas.width=8*this.imageWidth,this.canvas.height=8*this.imageWidth,this.ctx=this.canvas.getContext("2d"),this.images=[],this.imagesCount=0,this.imagePos={},this.imagesIds=[];}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.addImage=function(e,i){var o=this;this.imagesCount++,this.imagesIds.push(e);var r=this.imagesCount,n=r%8*this.imageWidth,a=parseInt(r/8)*this.imageWidth;if(this.imagePos[e]={x:n/this.canvas.width,y:a/this.canvas.height},this.texture=new t.Texture(this.canvas),"string"==typeof i)t.getImage({url:i},function(i,r){r.id=e,o.images.push(r),o.ctx.drawImage(r,n,a,o.imageWidth,o.imageWidth),o.texture.magFilter=t.LinearFilter,o.texture.minFilter=t.LinearFilter,o.texture.needsUpdate=!0,o.emit("imageLoaded");});else{var s=i.width,l=i.height,c=i.channels,u=new Uint8Array(s*l*c),h=new Image;h.width=s,h.height=l,h.data=u,h.id=e,this.images.push(h),this.ctx.drawImage(h,n,a,this.imageWidth,this.imageWidth),this.texture=new t.CanvasTexture(this.canvas),this.imagePos[e]={x:n>>9,y:a>>9},this.texture.needsUpdate=!0,this.emit("imageLoaded");}},i.prototype.removeImage=function(){},i}(t.EventEmitter),$e=ei,Je=ei,ti=1e20;function ei(t,e,i,o,r,n){this.fontSize=t||24,this.buffer=void 0===e?3:e,this.cutoff=o||.25,this.fontFamily=r||"sans-serif",this.fontWeight=n||"normal",this.radius=i||8;var a=this.size=this.fontSize+2*this.buffer;this.canvas=document.createElement("canvas"),this.canvas.width=this.canvas.height=a,this.ctx=this.canvas.getContext("2d"),this.ctx.font=this.fontWeight+" "+this.fontSize+"px "+this.fontFamily,this.ctx.textBaseline="middle",this.ctx.fillStyle="black",this.gridOuter=new Float64Array(a*a),this.gridInner=new Float64Array(a*a),this.f=new Float64Array(a),this.d=new Float64Array(a),this.z=new Float64Array(a+1),this.v=new Int16Array(a),this.middle=Math.round(a/2*(navigator.userAgent.indexOf("Gecko/")>=0?1.2:1));}function ii(t,e,i,o,r,n,a){for(var s=0;s<e;s++){for(var l=0;l<i;l++)o[l]=t[l*e+s];for(oi(o,r,n,a,i),l=0;l<i;l++)t[l*e+s]=r[l];}for(l=0;l<i;l++){for(s=0;s<e;s++)o[s]=t[l*e+s];for(oi(o,r,n,a,e),s=0;s<e;s++)t[l*e+s]=Math.sqrt(r[s]);}}function oi(t,e,i,o,r){i[0]=0,o[0]=-ti,o[1]=+ti;for(var n=1,a=0;n<r;n++){for(var s=(t[n]+n*n-(t[i[a]]+i[a]*i[a]))/(2*n-2*i[a]);s<=o[a];)a--,s=(t[n]+n*n-(t[i[a]]+i[a]*i[a]))/(2*n-2*i[a]);i[++a]=n,o[a]=s,o[a+1]=+ti;}for(n=0,a=0;n<r;n++){for(;o[a+1]<n;)a++;e[n]=(n-i[a])*(n-i[a])+t[i[a]];}}ei.prototype.draw=function(t){this.ctx.clearRect(0,0,this.size,this.size),this.ctx.fillText(t,this.buffer,this.middle);for(var e=this.ctx.getImageData(0,0,this.size,this.size),i=new Uint8ClampedArray(this.size*this.size),o=0;o<this.size*this.size;o++){var r=e.data[4*o+3]/255;this.gridOuter[o]=1===r?0:0===r?ti:Math.pow(Math.max(0,.5-r),2),this.gridInner[o]=1===r?ti:0===r?0:Math.pow(Math.max(0,r-.5),2);}for(ii(this.gridOuter,this.size,this.size,this.f,this.d,this.v,this.z),ii(this.gridInner,this.size,this.size,this.f,this.d,this.v,this.z),o=0;o<this.size*this.size;o++){var n=this.gridOuter[o]-this.gridInner[o];i[o]=Math.max(0,Math.min(255,Math.round(255-255*(n/this.radius+this.cutoff))));}return i},$e.default=Je;var ri=30;var ni=function(){for(var t=[],e=32;e<128;e++)t.push(String.fromCharCode(e));return t}(),ai=["fontFamily","fontWeight","characterSet","fontSize","sdf","buffer","cutoff","radius"];function si(t,e,i,o){t.font=o+" "+i+"px "+e,t.fillStyle="black",t.textBaseline="middle";}function li(t,e){for(var i=0;i<t.length;i++)e.data[4*i+3]=t[i];}var ci=function(){this.props={fontFamily:"sans-serif",fontWeight:"normal",characterSet:ni,fontSize:24,buffer:3,sdf:!0,cutoff:.25,radius:8},this._key=null,this._texture=new t.Texture,this.cache=new te(3);},ui={texture:{configurable:!0},mapping:{configurable:!0},scale:{configurable:!0},fontAtlas:{configurable:!0}};ui.texture.get=function(){return this._texture},ui.mapping.get=function(){var t=this.cache.get(this._key);return t&&t.mapping},ui.scale.get=function(){return 1},ui.fontAtlas.get=function(){return this._fontAtlas},ci.prototype.setProps=function(t){var e=this;void 0===t&&(t={}),ai.forEach(function(i){i in t&&(e.props[i]=t[i]);});var i=this._key;this._key=this._getKey();var o=this._getNewChars(this._key,this.props.characterSet),r=this.cache.get(this._key);if(r&&0===o.length)this._key!==i&&this._updateTexture(r);else{var n=this._generateFontAtlas(this._key,o,r);this._fontAtlas=n,this._updateTexture(n),this.cache.set(this._key,n);}},ci.prototype._updateTexture=function(e){var i=e.data;this._texture=new t.CanvasTexture(i),this._texture.minFilter=t.LinearFilter,this._texture.magFilter=t.LinearFilter,this._texture.flipY=!1,this._texture.format=t.AlphaFormat,this._texture.needUpdate=!0;},ci.prototype._generateFontAtlas=function(t,e,i){var o=this.props,r=o.fontFamily,n=o.fontWeight,a=o.fontSize,s=o.buffer,l=o.sdf,c=o.radius,u=o.cutoff,h=i&&i.data;h||((h=document.createElement("canvas")).width=1024);var p=h.getContext("2d");si(p,r,a,n);var f=function(t){var e=t.characterSet,i=t.getFontWidth,o=t.fontHeight,r=t.buffer,n=t.maxCanvasWidth,a=t.mapping;void 0===a&&(a={});var s=t.xOffset;void 0===s&&(s=0);var l=t.yOffset;void 0===l&&(l=0);var c=0,u=s;Array.from(e).forEach(function(t,e){if(!a[t]){var o=i(t,e);u+ri>n&&(u=0,c++),a[t]={x:u,y:l+c*ri,width:ri,height:ri,advance:o},u+=ri;}});var h,p=o+2*r;return {mapping:a,xOffset:u,yOffset:l+c*p,canvasHeight:(h=l+(c+1)*p,Math.pow(2,Math.ceil(Math.log2(h))))}}(Object.assign({getFontWidth:function(t){return p.measureText(t).width},fontHeight:1*a,buffer:s,characterSet:e,maxCanvasWidth:1024},i&&{mapping:i.mapping,xOffset:i.xOffset,yOffset:i.yOffset})),d=f.mapping,_=f.canvasHeight,v=f.xOffset,g=f.yOffset;if(h.height!==_){var y=p.getImageData(0,0,h.width,h.height);h.height=_,p.putImageData(y,0,0);}if(si(p,r,a,n),l)for(var m=new $e(a,s,c,u,r,n),b=p.getImageData(0,0,m.size,m.size),x=0,w=e;x<w.length;x+=1){var C=w[x];li(m.draw(C),b),p.putImageData(b,d[C].x,d[C].y);}else for(var M=0,A=e;M<A.length;M+=1){var T=A[M];p.fillText(T,d[T].x,d[T].y+1*a);}return {xOffset:v,yOffset:g,mapping:d,data:h,width:h.width,height:h.height}},ci.prototype._getKey=function(){var t=this.props,e=t.fontFamily,i=t.fontWeight,o=t.fontSize,r=t.buffer,n=t.sdf,a=t.radius,s=t.cutoff;return n?e+" "+i+" "+o+" "+r+" "+a+" "+s:e+" "+i+" "+o+" "+r},ci.prototype._getNewChars=function(t,e){var i=this.cache.get(t);if(!i)return e;var o=[],r=i.mapping,n=Object.keys(r);n=new Set(n);var a=e;return a instanceof Array&&(a=new Set(a)),a.forEach(function(t){n.has(t)||o.push(t);}),o},Object.defineProperties(ci.prototype,ui);var hi='precision highp float;\n#define PI 3.14159265359\n#define TWO_PI 6.28318530718\nuniform float u_strokeWidth;uniform vec4 u_stroke;uniform sampler2D u_texture;varying vec2 v_rs;varying vec2 v_uv;varying vec4 v_color;varying float v_shape;const float u_buffer=.75;uniform vec4 u_activeColor;const float u_gamma=.08;const vec3 halo=vec3(1.);void main(){\n#ifdef TEXCOORD_0\nvec2 pos=v_uv+gl_PointCoord/512.*64.;pos.y=1.-pos.y;vec4 textureColor=texture2D(u_texture,pos);\n#ifdef PICK\nif(worldId.x==0.&&worldId.y==0.&& worldId.z==0.&& textureColor==vec4(0.)){discard;return;}gl_FragColor=worldId;return;\n#endif\nif(v_color==vec4(0.)){gl_FragColor=textureColor; \n}else {gl_FragColor=step(0.01,textureColor.x)*v_color;}return;\n#endif\nif(v_color.a==0.)discard;vec4 pcolor=v_color;float ro=v_rs.x;float ri=v_rs.y;float d=0.;if(ro<3.){gl_FragColor=pcolor;return;}vec2 st=gl_PointCoord*2.-1.;float a=atan(st.x,st.y)+PI;float r=TWO_PI/v_shape;float ratio=1.+(1.1-smoothstep(2.8,6.,v_shape));float dis2center=cos(floor(.5+a/r)*r-a)*length(st)*ro*ratio;float alpha=smoothstep(ro,ro+.1,dis2center);if(alpha==1.){discard;}if(u_strokeWidth>0.){if(dis2center>ro-u_strokeWidth){gl_FragColor=vec4(u_stroke.xyz,u_stroke.a*(ro-dis2center));return;}else if(dis2center>ri){gl_FragColor=u_stroke;return;}}if(dis2center>ri-u_strokeWidth){float factor=ri-dis2center;if(u_strokeWidth==0.){float a=pcolor.a*factor;gl_FragColor=vec4(pcolor.rgb,a);}else{float a=u_stroke.a*(1.-factor)+pcolor.a*factor;gl_FragColor=vec4(u_stroke.rgb*(1.-factor)+pcolor.rgb*factor,a);}}else{gl_FragColor=pcolor;}\n#pragma include "pick"\n}',pi="precision highp float;attribute vec4 a_color;attribute float a_size;attribute float a_shape;uniform vec4 u_stroke;uniform float u_strokeWidth;uniform float u_opacity;uniform float u_zoom;varying vec4 v_color;varying vec2 v_rs;varying vec2 v_uv;varying float v_shape;uniform float u_activeId;uniform vec4 u_activeColor;void main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;v_color=a_color;v_color.a*=u_opacity;if(pickingId==u_activeId) {v_color=u_activeColor;}gl_Position= matModelViewProjection *vec4(position,1.0);gl_PointSize=a_size;v_rs=vec2(a_size,a_size-u_strokeWidth);\n#ifdef TEXCOORD_0\nv_uv=uv;\n#endif\n#ifdef SHAPE\nv_shape=a_shape;\n#endif\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}",fi='precision highp float;uniform vec4 u_baseColor : [ 1.0,0,0,1.0 ];uniform vec4 u_brightColor : [ 1.0,0,0,1.0 ];uniform vec4 u_windowColor : [ 1.0,0,0,1.0 ];uniform float u_zoom : 0;uniform float u_time : 0;uniform float u_near : 0;uniform float u_far : 1;\n#ifdef ANIMATE\nvarying vec2 v_texCoord;\n#endif\nvarying vec4 v_color;vec3 getWindowColor(float n,float hot,vec3 brightColor,vec3 darkColor) {float s=step(hot,n);vec3 color=mix(brightColor,vec3(0.9,0.9,1.0),n);return mix(darkColor,color,s);}float random (vec2 st) {return fract(sin(dot(st.xy,vec2(12.9898,78.233)))*43758.5453123);}float LinearizeDepth(){float z=gl_FragCoord.z*2.0-1.0;return (2.0*u_near*u_far)/(u_far+u_near-z*(u_far-u_near));}vec3 fog(vec3 color,vec3 fogColor,float depth){float fogFactor=clamp(depth,0.0,1.0);vec3 output_color=mix(fogColor,color,fogFactor);return output_color;}float sdRect(vec2 p,vec2 sz) {vec2 d=abs(p)-sz;float outside=length(max(d,0.));float inside=min(max(d.x,d.y),0.);return outside+inside;}void main() {if(v_color.w==0.0) {discard;return;}vec3 baseColor=u_baseColor.xyz;vec3 brightColor=u_brightColor.xyz;vec3 windowColor=u_windowColor.xyz;float targetColId=5.;float depth=1.0-LinearizeDepth()/u_far*u_zoom;vec3 fogColor=vec3(23.0/255.0,31.0/255.0,51.0/255.0);\n#ifdef ANIMATE\nif(v_texCoord.x < 0.) {vec3 foggedColor=fog(baseColor.xyz+vec3(0.12*0.9,0.2*0.9,0.3*0.9),fogColor,depth);gl_FragColor=vec4( foggedColor,v_color.w);}else {vec2 st=v_texCoord;vec2  UvScale=v_texCoord;float tStep=min(0.08,max(0.05*(18.0-u_zoom),0.02));float tStart=0.25*tStep;float tEnd=0.75*tStep;float u=mod(UvScale.x,tStep);float v=mod(UvScale.y,tStep);float ux=floor(UvScale.x/tStep);float uy=floor(UvScale.y/tStep);float n=random(vec2(ux,uy));float lightP=u_time;float head=1.0-step(0.005,st.y);/*step3*/float sU=step(tStart,u)-step(tEnd,u);float sV=step(tStart,v)-step(tEnd,v);vec2 windowSize=vec2(abs(tEnd-tStart),abs(tEnd-tStart));float dist=sdRect(vec2(u,v),windowSize);float s=sU*sV;float curColId=floor(UvScale.x/tStep);float sCol=step(targetColId-0.2,curColId)-step(targetColId+0.2,curColId);float mLightP=mod(lightP,2.);float sRow=step(mLightP-0.2,st.y)-step(mLightP,st.y);if(ux==targetColId){n=0.;}float timeP=min(0.75,abs ( sin(u_time/6.0) ) );float hot=smoothstep(1.0,0.0,timeP);vec3 color=mix(baseColor,getWindowColor(n,hot,brightColor,windowColor),s);float sFinal=s*sCol*sRow;color+=mix(baseColor,brightColor,sFinal*n);color=color*v_color.rgb;vec3 foggedColor=fog(color,fogColor,depth);gl_FragColor=vec4(foggedColor,1.0);}\n#else\ngl_FragColor=vec4(v_color.xyz,v_color.w);\n#endif\n#pragma include "pick"\n}',di='precision highp float;attribute vec4 a_color;\n#ifdef SHAPE\nattribute vec3 a_size;attribute vec3 a_shape;\n#endif\n#ifdef ANIMATE\nattribute vec2 faceUv;varying vec2 v_texCoord;\n#endif\nvarying vec4 v_color;uniform float u_zoom : 0;uniform float u_opacity : 1.0;uniform float u_activeId :-1;uniform vec4 u_activeColor : [1.0,0.0,0.0,1.0];\n#pragma include "lighting"\nvoid main() {\n#ifdef ANIMATE\nv_texCoord=faceUv;\n#endif\nv_color=a_color;v_color.a*=u_opacity;float scale=pow(2.0,(20.0-u_zoom));vec3 offset=vec3(0.);\n#ifdef SHAPE\noffset=vec3(a_size*scale*a_shape);\n#endif\ngl_Position=projectionMatrix*modelViewMatrix*vec4(position+offset,1.);\n#ifdef LIGHTING\nif (normal !=vec3(0.,0.,1.0)) {vec3 viewDir=normalize(cameraPosition-position);v_color.rgb*=calc_lighting(position,normal,viewDir);}\n#endif\nif(pickingId==u_activeId) {v_color=u_activeColor;}\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}',_i='precision highp float;varying vec4 v_color;void main() {gl_FragColor=v_color;\n#pragma include "pick"\n}',vi='precision highp float;attribute vec3 miter;attribute vec4 a_color;uniform float u_xOffset;uniform float u_yOffset;uniform float u_coverage;uniform float u_opacity;uniform float u_activeId;uniform vec4 u_activeColor;varying vec4 v_color;\n#pragma include "lighting"\nvoid main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;v_color=a_color;v_color.a*=u_opacity;if(pickingId==u_activeId) {v_color=u_activeColor;}float x=position.x+miter.x*u_xOffset*u_coverage;float y=position.y+miter.y*u_yOffset*u_coverage;float z=position.z+miter.z;\n#ifdef LIGHTING\nvec3 viewDir=normalize(cameraPosition-vec3(x,y,z));v_color.rgb*=calc_lighting(vec3(x,y,z),normal,viewDir);\n#endif\ngl_Position=matModelViewProjection*vec4(x,y,z,1.0);\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}',gi='precision highp float;varying vec4 v_color;void main() {gl_FragColor=v_color;\n#pragma include "pick"\n}',yi='precision highp float;attribute vec3 miter;attribute vec3 a_shape;attribute float a_size;attribute vec4 a_color;uniform float u_radius;uniform float u_coverage;uniform float u_opacity;uniform float u_angle;uniform float u_activeId;uniform vec4 u_activeColor;varying vec4 v_color;\n#pragma include "lighting"\nvoid main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;mat2 rotationMatrix=mat2(cos(u_angle),sin(u_angle),-sin(u_angle),cos(u_angle));v_color=a_color;v_color.a*=u_opacity;if(pickingId==u_activeId) {v_color=u_activeColor;}vec2 offset=vec2(rotationMatrix*miter.xy*u_radius*u_coverage );float x=position.x+offset.x;float y=position.y+offset.y;float z=miter.z*a_size;\n#ifdef LIGHTING\nvec3 viewDir=normalize(cameraPosition-vec3(x,y,z));v_color.rgb*=calc_lighting(vec3(x,y,z),normal,viewDir);\n#endif\ngl_Position=matModelViewProjection*vec4(x,y,z,1.0);\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}',mi='uniform float u_blur : 0;uniform float u_opacity : 1;uniform float u_strokeWidth : 1;uniform vec4 u_stroke : [1,1,1,1];uniform float u_strokeOpacity : 1;varying vec4 v_data;varying vec4 v_color;varying float v_radius;\n#pragma include "sdf_2d"\nvoid main() {int shape=int(floor(v_data.w+0.5));lowp float antialiasblur=v_data.z;float antialiased_blur=-max(u_blur,antialiasblur);float r=v_radius/(v_radius+u_strokeWidth);float outer_df;float inner_df;if (shape==0) {outer_df=sdCircle(v_data.xy,1.0);inner_df=sdCircle(v_data.xy,r);} else if (shape==1) {outer_df=sdEquilateralTriangle(1.1*v_data.xy);inner_df=sdEquilateralTriangle(1.1/r*v_data.xy);} else if (shape==2) {outer_df=sdBox(v_data.xy,vec2(1.));inner_df=sdBox(v_data.xy,vec2(r));} else if (shape==3) {outer_df=sdPentagon(v_data.xy,0.8);inner_df=sdPentagon(v_data.xy,r*0.8);} else if (shape==4) {outer_df=sdHexagon(v_data.xy,0.8);inner_df=sdHexagon(v_data.xy,r*0.8);} else if (shape==5) {outer_df=sdOctogon(v_data.xy,1.0);inner_df=sdOctogon(v_data.xy,r);} else if (shape==6) {outer_df=sdHexagram(v_data.xy,0.52);inner_df=sdHexagram(v_data.xy,r*0.52);} else if (shape==7) {outer_df=sdRhombus(v_data.xy,vec2(1.0));inner_df=sdRhombus(v_data.xy,vec2(r));} else if (shape==8) {outer_df=sdVesica(v_data.xy,1.1,0.8);inner_df=sdVesica(v_data.xy,r*1.1,r*0.8);}float opacity_t=smoothstep(0.0,antialiased_blur,outer_df);float color_t=u_strokeWidth < 0.01 ? 0.0 : smoothstep(antialiased_blur,0.0,inner_df\n);gl_FragColor=opacity_t*mix(v_color*u_opacity,u_stroke*u_strokeOpacity*v_color.a,color_t);\n#pragma include "pick"\n}',bi='\nattribute vec4 a_color;attribute float a_size;attribute float a_shape;attribute vec2 miter;uniform float u_zoom : 1.;uniform float u_stroke_width : 2.;uniform float u_activeId : 0.;uniform vec4 u_activeColor : [ 1.0,0,0,1.0 ];varying vec4 v_data;varying vec4 v_color;varying float v_radius;\n#pragma include "decode"\nvoid main() {v_color=a_color;vec2 extrude=miter;float radius=a_size;v_radius=radius;float zoom_scale=pow(2.,20.-u_zoom);vec2 offset=miter*(radius+u_stroke_width)*zoom_scale;gl_Position=projectionMatrix*modelViewMatrix*vec4(position.xy+offset,0.0,1.0);float antialiasblur=1.0/(radius+u_stroke_width);v_data=vec4(extrude,antialiasblur,a_shape);if(pickingId==u_activeId) {v_color=u_activeColor;}\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}',xi='precision highp float;varying float v_pickingId;varying vec4 v_color;void main() {if(v_pickingId <-0.1) {discard;}\n#ifdef ANIMATE \nif (vTime > 1.0 || vTime < 0.0) {discard;} \n#endif\ngl_FragColor=v_color;\n#pragma include "pick"\n}',wi="precision highp float;attribute float a_miter;attribute vec3 a_size;attribute vec3 a_shape;uniform float u_strokeWidth;uniform float u_strokeOpacity;uniform vec4 u_activeColor;uniform float u_activeId;uniform vec4 u_stroke;uniform float u_zoom;uniform float u_time;varying float vTime;varying float v_pickingId;varying vec4 v_color;void main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;float scale=pow(2.0,(20.0-u_zoom));vec3 newposition=position+(a_size+vec3(u_strokeWidth/2.,u_strokeWidth/2.,0))*scale*a_shape+vec3(0.,a_size.y*scale/4.,0.);;\n#ifdef ANIMATE \nvTime=1.0-(mod(u_time*50.,3600.)-position.z)/100.;\n#endif\nv_color=u_stroke;v_color.a*=u_strokeOpacity;v_pickingId=pickingId;if(v_pickingId==u_activeId) {v_color=u_activeColor;}vec3 pointPos=newposition.xyz+vec3(normal*u_strokeWidth*scale/2.0*a_miter);gl_Position=matModelViewProjection*vec4(pointPos,1.0);\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}",Ci="precision highp float;varying vec4 v_color;void main(){gl_FragColor=v_color;}",Mi="precision highp float;attribute vec4 a_color;attribute float a_size;varying vec4 v_color;uniform float u_activeId;uniform vec4 u_activeColor;uniform float u_opacity;void main(){mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;v_color=a_color;v_color.a*=u_opacity;if(pickingId==u_activeId){v_color=u_activeColor;}gl_Position=matModelViewProjection*vec4(position,1.);gl_PointSize=a_size;\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}",Ai='precision highp float;uniform float u_opacity : 1.0;uniform float u_dash_offset : 0.0;uniform float u_dash_ratio : 0.0;uniform float u_blur : 0.9;varying vec4 v_color;uniform float u_time : 0;\n#if defined DASHLINE  || defined ANIMATE\nvarying float v_distance_ratio;\n#endif\nvarying float v_dash_array;varying float v_time;varying vec2 v_normal;\n#ifdef TEXTURE\nuniform sampler2D u_texture;varying vec2 v_uv;varying float v_texture_y;varying float v_texture_percent;\n#endif\n#ifdef ANIMATE \nuniform float u_duration : 2.0;uniform float u_interval : 1.0;uniform float u_trailLength : 0.2;\n#endif\nvoid main() {\n#ifdef TEXTURE\nfloat texture_y_fract=fract(v_texture_y);if (texture_y_fract <=v_texture_percent) {vec4 tex_color=texture2D(u_texture,vec2(v_uv.x,1.0-0.125-v_uv.y+(texture_y_fract/v_texture_percent)*0.125));gl_FragColor=vec4(mix(v_color.rgb,tex_color.rgb,tex_color.a),v_color.a);} else {gl_FragColor=v_color;}\n#else\ngl_FragColor=v_color;\n#endif\n#ifdef DASHLINE\nfloat time=0.;\n#ifdef ANIMATE \ntime=u_time/1000.;\n#endif\ngl_FragColor.a*=u_opacity*ceil(mod(v_distance_ratio+u_dash_offset+time,v_dash_array)-(v_dash_array*u_dash_ratio));\n#else\ngl_FragColor.a*=u_opacity;\n#endif\n#ifdef ANIMATE \nfloat alpha=1.0-fract( mod(1.0-v_distance_ratio,u_interval)*(1.0/u_interval)+u_time/u_duration);alpha=(alpha+u_trailLength-1.0)/u_trailLength;alpha=smoothstep(0.,1.,alpha);gl_FragColor.a*=alpha;\n#endif\nfloat blur=1.-smoothstep(u_blur,1.,length(v_normal));gl_FragColor.a*=blur;\n#pragma include "pick"\n}',Ti="attribute float a_miter;attribute vec4 a_color;attribute float a_size;attribute float a_distance;attribute float a_dash_array;attribute float a_total_distance;uniform float u_zoom;uniform float u_time : 0;uniform float u_activeId : 0;uniform vec4 u_activeColor : [ 1.0,0,0,1.0 ];varying float v_time;varying vec4 v_color;varying float v_dash_array;varying vec2 v_normal;\n#if defined DASHLINE  || defined ANIMATE\nvarying float v_distance_ratio;\n#endif\n#ifdef ANIMATE \nuniform float u_duration : 2.0;uniform float u_interval : 1.0;uniform float u_trailLength : 0.2;\n#endif\n#ifdef TEXTURE\nattribute vec2 a_texture_coord;uniform float u_pattern_spacing : 0.0;varying vec2 v_uv;varying float v_texture_y;varying float v_texture_percent;\n#endif\nvoid main() {float extrude_scale=pow(2.0,20.0-u_zoom);v_color=a_color;v_dash_array=a_dash_array*pow(2.0,20.0-u_zoom);float distance_ratio=a_distance/a_total_distance;\n#if defined DASHLINE  || defined ANIMATE\nv_distance_ratio=distance_ratio;\n#endif\n#ifdef TEXTURE\nv_uv=vec2(a_texture_coord.x+0.125,a_texture_coord.y);if (a_miter > 0.0) {v_uv.x=a_texture_coord.x;}v_texture_y=a_distance/extrude_scale/(a_size+u_pattern_spacing);v_texture_percent=a_size/(a_size+u_pattern_spacing);\n#endif\nv_normal=vec2(normal*sign(a_miter));vec3 offset=vec3(normal*a_size*extrude_scale/2.0*a_miter);gl_Position=projectionMatrix*modelViewMatrix*vec4(position.xy+offset.xy,0.,1.0);if(pickingId==u_activeId) {v_color=u_activeColor;}\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}",Li='precision mediump float;uniform float u_opacity;varying vec4 v_color;uniform float u_time : 0;\n#if defined DASHLINE  || defined ANIMATE\nvarying float v_distance_ratio;\n#endif\n#ifdef ANIMATE \nuniform float u_duration : 2.0;uniform float u_interval : 1.0;uniform float u_trailLength : 0.2;\n#endif\nvoid main() {if(v_color.a==0.){discard;}gl_FragColor=v_color;gl_FragColor.a=v_color.a*u_opacity;\n#ifdef ANIMATE\nfloat alpha=1.0-fract( mod(1.0-v_distance_ratio,u_interval)*(1.0/u_interval)+u_time/u_duration);gl_FragColor.a*=alpha;\n#endif\n#pragma include "pick"\n}',ki="precision mediump float;attribute vec4 a_color;attribute vec4 a_instance;attribute float a_size;uniform float u_zoom;uniform float u_time;uniform float u_activeId : 0;uniform vec4 u_activeColor : [ 1.0,0,0,1.0 ];uniform mat4 matModelViewProjection;uniform float segmentNumber;  \nvarying vec4 v_color;\n#ifdef ANIMATE\nvarying float v_distance_ratio;\n#endif\nfloat maps (float value,float start1,float stop1,float start2,float stop2) {return start2+(stop2-start2)*((value-start1)/(stop1-start1));}float getSegmentRatio(float index) {return smoothstep(0.0,1.0,index/(segmentNumber-1.0));}float paraboloid(vec2 source,vec2 target,float ratio) {vec2 x=mix(source,target,ratio);vec2 center=mix(source,target,0.5);float dSourceCenter=distance(source,center);float dXCenter=distance(x,center);return (dSourceCenter+dXCenter)*(dSourceCenter-dXCenter);}vec3 getPos(vec2 source,vec2 target,float segmentRatio) {float vertex_height=paraboloid(source,target,segmentRatio);return vec3(mix(source,target,segmentRatio),sqrt(max(0.0,vertex_height)));}vec2 getExtrusionOffset(vec2 line_clipspace,float offset_direction) {vec2 dir_screenspace=normalize(line_clipspace);dir_screenspace=vec2(-dir_screenspace.y,dir_screenspace.x);vec2 offset=dir_screenspace*offset_direction*a_size*pow(2.0,20.0-u_zoom)/2.0;return offset;}void main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;vec2 source=a_instance.rg;vec2 target=a_instance.ba;float segmentIndex=position.x;float segmentRatio=getSegmentRatio(segmentIndex);float indexDir=mix(-1.0,1.0,step(segmentIndex,0.0));float nextSegmentRatio=getSegmentRatio(segmentIndex+indexDir);vec3 curr=getPos(source,target,segmentRatio);vec3 next=getPos(source,target,nextSegmentRatio);vec2 offset=getExtrusionOffset((next.xy-curr.xy)*indexDir,position.y);\n#ifdef ANIMATE\nv_distance_ratio=segmentIndex/segmentNumber;\n#endif\ngl_Position=matModelViewProjection*vec4(vec3(curr+vec3(offset,0.0)),1.0);v_color=a_color;if(pickingId==u_activeId) {v_color=u_activeColor;}\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}",Si='#define PI 3.1415926535\nprecision mediump float;attribute vec4 a_color;attribute vec4 a_instance;attribute float a_size;uniform float u_zoom;uniform float u_time;uniform float u_activeId : 0;uniform vec4 u_activeColor : [ 1.0,0,0,1.0 ];uniform mat4 matModelViewProjection;uniform float segmentNumber;  \nvarying vec4 v_color;\n#ifdef ANIMATE\nvarying float v_distance_ratio;\n#endif\n#pragma include "project"\nfloat maps (float value,float start1,float stop1,float start2,float stop2) {return start2+(stop2-start2)*((value-start1)/(stop1-start1));}float getSegmentRatio(float index) {return smoothstep(0.0,1.0,index/(segmentNumber-1.));}float paraboloid(vec2 source,vec2 target,float ratio) {vec2 x=mix(source,target,ratio);vec2 center=mix(source,target,0.5);float dSourceCenter=distance(source,center);float dXCenter=distance(x,center);return (dSourceCenter+dXCenter)*(dSourceCenter-dXCenter);}vec3 getPos(vec2 source,vec2 target,float segmentRatio) {float vertex_height=paraboloid(source,target,segmentRatio);return vec3(mix(source,target,segmentRatio),sqrt(max(0.0,vertex_height)));}vec2 getExtrusionOffset(vec2 line_clipspace,float offset_direction) {vec2 dir_screenspace=normalize(line_clipspace);dir_screenspace=vec2(-dir_screenspace.y,dir_screenspace.x);vec2 offset=dir_screenspace*offset_direction*a_size*pow(2.0,20.0-u_zoom)/2.0;return offset;}float getAngularDist (vec2 source,vec2 target) {vec2 delta=source-target;vec2 sin_half_delta=sin(delta/2.0);float a=sin_half_delta.y*sin_half_delta.y+cos(source.y)*cos(target.y)*sin_half_delta.x*sin_half_delta.x;return 2.0*atan(sqrt(a),sqrt(1.0-a));}vec2 interpolate (vec2 source,vec2 target,float angularDist,float t) {if(abs(angularDist-PI) < 0.001) {return (1.0-t)*source+t*target;}float a=sin((1.0-t)*angularDist)/sin(angularDist);float b=sin(t*angularDist)/sin(angularDist);vec2 sin_source=sin(source);vec2 cos_source=cos(source);vec2 sin_target=sin(target);vec2 cos_target=cos(target);float x=a*cos_source.y*cos_source.x+b*cos_target.y*cos_target.x;float y=a*cos_source.y*sin_source.x+b*cos_target.y*sin_target.x;float z=a*sin_source.y+b*sin_target.y;return vec2(atan(y,x),atan(z,sqrt(x*x+y*y)));}void main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;vec2 source=radians(unProjectFlat(a_instance.rg));vec2 target=radians(unProjectFlat(a_instance.ba));float angularDist=getAngularDist(source,target);float segmentIndex=position.x;float segmentRatio=getSegmentRatio(segmentIndex);float indexDir=mix(-1.0,1.0,step(segmentIndex,0.0));float nextSegmentRatio=getSegmentRatio(segmentIndex+indexDir);\n#ifdef ANIMATE\nv_distance_ratio=segmentIndex/segmentNumber;\n#endif\nvec3 curr=vec3(degrees(interpolate(source,target,angularDist,segmentRatio)),0.0);vec3 next=vec3(degrees(interpolate(source,target,angularDist,nextSegmentRatio)),0.0);vec2 offset=getExtrusionOffset((ProjectFlat(next.xy)-ProjectFlat(curr.xy))*indexDir,position.y);gl_Position=matModelViewProjection*vec4(vec3(vec3(ProjectFlat(curr.xy),2.)+vec3(offset,0.0)),1.0);v_color=a_color;if(pickingId==u_activeId) {v_color=u_activeColor;}\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}',Ii='precision highp float;varying vec4 v_color;varying float vTime;void main() {vec4 color=v_color;\n#ifdef ANIMATE \nif (vTime > 1.0 || vTime < 0.0) {discard;} \ncolor.a=color.a*vTime*1.5;\n#endif\ngl_FragColor=color;\n#pragma include "pick"\n}',Ei="precision highp float;attribute vec4 a_color;uniform float currentTime;uniform float u_time;uniform float u_opacity;varying float vTime;varying vec4 v_color;uniform float u_activeId;uniform vec4 u_activeColor;void main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;v_color=a_color;v_color.a*=u_opacity;if(pickingId==u_activeId) {v_color=u_activeColor;}\n#ifdef ANIMATE \nvTime=1.0-(mod(u_time*50.,3600.)-position.z)/100.;\n#endif\ngl_Position=matModelViewProjection*vec4(position.xy,10.,1.0);\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}",Oi="varying vec2 v_uv;void main(){v_uv=uv;gl_Position=projectionMatrix*modelViewMatrix*vec4( position,1.0 );}",Pi="uniform sampler2D u_texture;uniform sampler2D u_rampColors;uniform float u_opacity;varying vec2 v_uv;void main(){float intensity=texture2D(u_texture,v_uv).r;vec4 color=texture2D(u_rampColors,vec2(0.5,1.0-intensity));gl_FragColor=color;gl_FragColor.a=color.a*smoothstep(0.,0.05,intensity)*u_opacity;}",Di="precision highp float;uniform float u_intensity;varying float v_weight;varying vec2 v_extrude;void main(){float GAUSS_COEF=0.3989422804014327;float d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=v_weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,val,val,val);}",zi="precision highp float;attribute float a_weight;attribute vec2 a_dir;uniform float u_intensity;uniform float u_radius;uniform float u_zoom;varying vec2 v_extrude;varying float v_weight;void main(){v_weight=a_weight;float GAUSS_COEF=0.3989422804014327;float ZERO=1.0/255.0/16.0;float extrude_x=a_dir.x*2.0-1.0;float extrude_y=a_dir.y*2.0-1.0;vec2 extrude_dir=normalize(vec2(extrude_x,extrude_y));float S=sqrt(-2.0*log(ZERO/a_weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=extrude_dir*S;vec2 extrude= v_extrude*u_radius*pow(2.0,20.0-u_zoom); \nvec4 pos=vec4( position.xy+extrude,0.0,1.0);gl_Position=projectionMatrix*modelViewMatrix*pos;}",Fi='uniform sampler2D u_sdf_map;uniform float u_gamma_scale : 0.5;uniform float u_font_size : 24;uniform float u_opacity : 1.0;uniform vec4 u_stroke : [0,0,0,1];uniform float u_strokeWidth : 2.0;uniform float u_halo_blur : 0.5;varying vec4 v_color;varying vec2 v_uv;varying float v_gamma_scale;void main() {float dist=texture2D(u_sdf_map,v_uv).a;float fontScale=u_font_size/24.0;lowp float buff=(6.0-u_strokeWidth/fontScale)/SDF_PX;highp float gamma=(u_halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);highp float gamma_scaled=gamma*v_gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=mix(v_color*u_opacity,u_stroke,smoothstep(0.,0.5,1.-dist))*alpha;\n#pragma include "pick"\n}',ji="attribute vec2 a_pos;attribute vec2 a_tex;attribute vec2 a_offset;attribute vec4 a_color;attribute float a_size;uniform vec2 u_sdf_map_size;uniform vec2 u_viewport_size;uniform float u_activeId : 0;uniform vec4 u_activeColor : [1.0,0.0,0.0,1.0];varying vec2 v_uv;varying float v_gamma_scale;varying vec4 v_color;void main() {v_color=a_color;v_uv=a_tex/u_sdf_map_size;float fontScale=a_size/24.;vec4 projected_position=projectionMatrix*modelViewMatrix*vec4(a_pos,0.,1.);gl_Position=vec4(projected_position.xy/projected_position.w+a_offset*fontScale/u_viewport_size*2.,0.0,1.0);v_gamma_scale=gl_Position.w;if (pickingId==u_activeId) {v_color=u_activeColor;}\n#ifdef PICK\nworldId=id_toPickColor(pickingId);\n#endif\n}",Bi="precision highp float;varying vec2 v_texCoord;void main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;v_texCoord=uv;gl_Position= matModelViewProjection*vec4(position,1.0);}",Ri="precision mediump float;uniform sampler2D u_texture;uniform float u_opacity;varying vec2 v_texCoord;void main() {vec4 color=texture2D(u_texture,vec2(v_texCoord.x,1.0-v_texCoord.y));gl_FragColor=color*u_opacity;}",Ni="precision highp float;uniform vec4 u_extent;uniform sampler2D u_texture;uniform float u_opacity;uniform float u_size;uniform sampler2D u_colorTexture;uniform float u_min;uniform float u_max;varying vec2 v_texCoord;varying vec4 v_color;void main() {mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;float value=texture2D(u_texture,uv)[0];v_texCoord=uv;value=clamp(value,u_min,u_max);float value1= (value-u_min)/(u_max-u_min);vec2 ramp_pos=vec2(fract(16.0*(1.0-value1)),floor(16.0*(1.0-value1))/16.0);v_color=texture2D(u_colorTexture,ramp_pos);v_color.a*=u_opacity;vec2 range=u_extent.zw-u_extent.xy;gl_Position= matModelViewProjection*vec4(position.xy,value*100.,1.0);}",Ui="precision highp float;uniform sampler2D u_texture;uniform sampler2D u_colorTexture;uniform vec2 u_dimension;varying vec2 v_texCoord;varying vec4 v_color;uniform float u_min;uniform float u_max;uniform vec4 u_extent;\n#define PI 3.141592653589793\nvoid main() {vec2 u_latrange=vec2(3.83718,53.5636);float u_zoom=7.0;float u_maxzoom=10.0;vec2 epsilon=1.0/u_dimension;vec2 u_light=vec2(0.5000,5.8469);vec4 u_accent=vec4(0.,0.,0.,1.);vec4 u_highlight=vec4(1.0);vec4 u_shadow=vec4(0.,0.,0.,1.);float a=texture2D(u_texture,v_texCoord-epsilon)[0];float b=texture2D(u_texture,v_texCoord+vec2(0,-epsilon.y))[0];float c=texture2D(u_texture,v_texCoord+vec2(epsilon.x-epsilon.y))[0];float d=texture2D(u_texture,v_texCoord+vec2(-epsilon.x,0))[0];float e=texture2D(u_texture,v_texCoord)[0];float f=texture2D(u_texture,v_texCoord+vec2(epsilon.x,0))[0];float g=texture2D(u_texture,v_texCoord+vec2(-epsilon.x,epsilon.y))[0];float h=texture2D(u_texture,v_texCoord+vec2(0,epsilon.y))[0];float i=texture2D(u_texture,v_texCoord+epsilon)[0];float exaggeration=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;vec2 deriv=vec2((c+f+f+i)-(a+d+d+g),(g+h+h+i)-(a+b+b+c))/ pow(2.0,(u_zoom-u_maxzoom)*exaggeration+19.2562-u_zoom);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_texCoord.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*v_color*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=v_color;}",Hi="attribute vec4 a_color;uniform float u_zoom;uniform float u_opacity;varying vec4 v_color;uniform float u_activeId;uniform vec4 u_activeColor;void main(){mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;v_color=a_color;v_color.a*=u_opacity;if(pickingId==u_activeId){v_color=u_activeColor;}gl_Position=projectionMatrix*vec4(position.xy/4096.,0.,1.);}",Wi="varying vec4 v_color;void main(){gl_FragColor=v_color;}",Gi="precision highp float;void main(){mat4 matModelViewProjection=projectionMatrix*modelViewMatrix;gl_Position= matModelViewProjection*vec4(position,1.0);}",Vi="precision highp float;void main() {gl_FragColor=vec4(0.0,0.,0.,1.0);}",qi="#define PI 3.14159265359\n#define TWO_PI 6.28318530718",Zi="vec4 id_toPickColor(float pickingId) {float id=step(0.,pickingId)*pickingId;vec3 a=fract(vec3(1.0/255.0,1.0/(255.0*255.0),1.0/(255.0*255.0*255.0))*id);a-=a.xxy*vec3(0.0,1.0/255.0,1.0/255.0);vec4 worldColor=vec4(a,1);return worldColor;}",Ki="#define SHIFT_RIGHT17 1.0/131072.0\n#define SHIFT_RIGHT18 1.0/262144.0\n#define SHIFT_RIGHT19 1.0/524288.0\n#define SHIFT_RIGHT20 1.0/1048576.0\n#define SHIFT_RIGHT21 1.0/2097152.0\n#define SHIFT_RIGHT22 1.0/4194304.0\n#define SHIFT_RIGHT23 1.0/8388608.0\n#define SHIFT_RIGHT24 1.0/16777216.0\n#define SHIFT_LEFT17 131072.0\n#define SHIFT_LEFT18 262144.0\n#define SHIFT_LEFT19 524288.0\n#define SHIFT_LEFT20 1048576.0\n#define SHIFT_LEFT21 2097152.0\n#define SHIFT_LEFT22 4194304.0\n#define SHIFT_LEFT23 8388608.0\n#define SHIFT_LEFT24 16777216.0\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec4 decode_color(const vec2 encodedColor) {return vec4(unpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}",Yi='\nuniform float u_ambient : 1.0;uniform float u_diffuse : 1.0;uniform float u_specular : 1.0;uniform int u_num_of_directional_lights : 1;uniform int u_num_of_spot_lights : 0;\n#define SHININESS 32.0\n#define MAX_NUM_OF_DIRECTIONAL_LIGHTS 3\n#define MAX_NUM_OF_SPOT_LIGHTS 3\n#pragma include "common"\nstruct DirectionalLight {vec3 direction;vec3 ambient;vec3 diffuse;vec3 specular;};struct SpotLight {vec3 position;vec3 direction;vec3 ambient;vec3 diffuse;vec3 specular;float constant;float linear;float quadratic;float angle;float blur;float exponent;};uniform DirectionalLight u_directional_lights[MAX_NUM_OF_DIRECTIONAL_LIGHTS];uniform SpotLight u_spot_lights[MAX_NUM_OF_SPOT_LIGHTS];vec3 calc_directional_light(DirectionalLight light,vec3 normal,vec3 viewDir) {vec3 lightDir=normalize(light.direction);float diff=max(dot(normal,lightDir),0.0);vec3 halfwayDir=normalize(lightDir+viewDir);float spec=pow(max(dot(normal,halfwayDir),0.0),SHININESS);vec3 ambient=light.ambient*u_ambient;vec3 diffuse=light.diffuse*diff*u_diffuse;vec3 specular=light.specular*spec*u_specular;return ambient+diffuse+specular;}vec3 calc_lighting(vec3 position,vec3 normal,vec3 viewDir) {vec3 weight=vec3(0.0);for (int i=0; i < MAX_NUM_OF_DIRECTIONAL_LIGHTS; i++) {if (i >=u_num_of_directional_lights) {break;}weight+=calc_directional_light(u_directional_lights[i],normal,viewDir);}return weight;}',Xi="#ifdef PICK\nif(worldId.x==0.&&worldId.y==0.&& worldId.z==0.){discard;return;}gl_FragColor=worldId;return;\n#endif",Qi="/***2D signed distance field functions*@see http:*/float ndot(vec2 a,vec2 b ) { return a.x*b.x-a.y*b.y; }float sdCircle(vec2 p,float r) {return length(p)-r;}float sdEquilateralTriangle(vec2 p) {float k=sqrt(3.0);p.x=abs(p.x)-1.0;p.y=p.y+1.0/k;if( p.x+k*p.y > 0.0 ) p=vec2(p.x-k*p.y,-k*p.x-p.y)/2.0;p.x-=clamp( p.x,-2.0,0.0 );return-length(p)*sign(p.y);}float sdBox(vec2 p,vec2 b) {vec2 d=abs(p)-b;return length(max(d,vec2(0)))+min(max(d.x,d.y),0.0);}float sdPentagon(vec2 p,float r) {vec3 k=vec3(0.809016994,0.587785252,0.726542528);p.x=abs(p.x);p-=2.0*min(dot(vec2(-k.x,k.y),p),0.0)*vec2(-k.x,k.y);p-=2.0*min(dot(vec2( k.x,k.y),p),0.0)*vec2( k.x,k.y);p-=vec2(clamp(p.x,-r*k.z,r*k.z),r);return length(p)*sign(p.y);}float sdHexagon(vec2 p,float r) {vec3 k=vec3(-0.866025404,0.5,0.577350269);p=abs(p);p-=2.0*min(dot(k.xy,p),0.0)*k.xy;p-=vec2(clamp(p.x,-k.z*r,k.z*r),r);return length(p)*sign(p.y);}float sdOctogon(vec2 p,float r) {vec3 k=vec3(-0.9238795325,0.3826834323,0.4142135623 );p=abs(p);p-=2.0*min(dot(vec2( k.x,k.y),p),0.0)*vec2( k.x,k.y);p-=2.0*min(dot(vec2(-k.x,k.y),p),0.0)*vec2(-k.x,k.y);p-=vec2(clamp(p.x,-k.z*r,k.z*r),r);return length(p)*sign(p.y);}float sdHexagram(vec2 p,float r) {vec4 k=vec4(-0.5,0.8660254038,0.5773502692,1.7320508076);p=abs(p);p-=2.0*min(dot(k.xy,p),0.0)*k.xy;p-=2.0*min(dot(k.yx,p),0.0)*k.yx;p-=vec2(clamp(p.x,r*k.z,r*k.w),r);return length(p)*sign(p.y);}float sdRhombus(vec2 p,vec2 b) {vec2 q=abs(p);float h=clamp((-2.0*ndot(q,b)+ndot(b,b))/dot(b,b),-1.0,1.0);float d=length( q-0.5*b*vec2(1.0-h,1.0+h) );return d*sign( q.x*b.y+q.y*b.x-b.x*b.y );}float sdVesica(vec2 p,float r,float d) {p=abs(p);float b=sqrt(r*r-d*d);return ((p.y-b)*d>p.x*b)? length(p-vec2(0.0,b)): length(p-vec2(-d,0.0))-r;}",$i="#define PI 3.1415926535\n#define E 2.718281828459045\nvec2 ProjectFlat(vec2 lnglat){float maxs=85.0511287798;float lat=max(min(maxs,lnglat.y),-maxs);float scale=268435456.;float d=PI/180.;float x=lnglat.x*d;float y=lat*d;y=log(tan((PI/4.)+(y/2.)));float a=.5/PI,b=.5,c=-.5/PI;d=.5;x=scale*(a*x+b)-215440491.;y=scale*(c*y+d)-106744817.;return vec2(x,y);}vec2 unProjectFlat(vec2 px){float a=.5/PI;float b=.5;float c=-.5/PI;float d=.5;float scale=268435456.;float x=((px.x+215440491.)/scale-b)/a;float y=((px.y+106744817.)/scale-d)/c;y=(atan(pow(E,y))-(PI/4.))*2.;d=PI/180.;float lat=y/d;float lng=x/d;return vec2(lng,lat);}";function Ji(t){var e=t.target||t.srcElement;e.__resizeRAF__&&cancelAnimationFrame(e.__resizeRAF__),e.__resizeRAF__=requestAnimationFrame(function(){var i=e.__resizeTrigger__,o=i&&i.__resizeListeners__;o&&o.forEach(function(e){e.call(i,t);});});}var to=function(t,e){var i,o=this.document,r=o.attachEvent;if("undefined"!=typeof navigator&&(i=navigator.userAgent.match(/Trident/)||navigator.userAgent.match(/Edge/)),!t.__resizeListeners__)if(t.__resizeListeners__=[],r)t.__resizeTrigger__=t,t.attachEvent("onresize",Ji);else{"static"===getComputedStyle(t).position&&(t.style.position="relative");var n=t.__resizeTrigger__=o.createElement("object");n.setAttribute("style","position: absolute; top: 0; left: 0; height: 100%; width: 100%; pointer-events: none; z-index: -1; opacity: 0;"),n.setAttribute("class","resize-sensor"),n.setAttribute("tabindex","-1"),n.__resizeElement__=t,n.onload=function(){this.contentDocument.defaultView.__resizeTrigger__=this.__resizeElement__,this.contentDocument.defaultView.addEventListener("resize",Ji);},n.type="text/html",i&&t.appendChild(n),n.data="about:blank",i||t.appendChild(n);}t.__resizeListeners__.push(e);},eo="undefined"==typeof window?to:to.bind(window),io=function(t,e){var i=document.attachEvent,o=t.__resizeListeners__||[];if(e){var r=o.indexOf(e);-1!==r&&o.splice(r,1);}else o=t.__resizeListeners__=[];if(!o.length){if(i)t.detachEvent("onresize",Ji);else if(t.__resizeTrigger__){var n=t.__resizeTrigger__.contentDocument,a=n&&n.defaultView;a&&(a.removeEventListener("resize",Ji),delete a.__resizeTrigger__),t.__resizeTrigger__=!t.removeChild(t.__resizeTrigger__);}delete t.__resizeListeners__;}};function oo(){return new Worker(Ro.workerUrl)}eo.unbind=io;var ro=function(){this.active={};};ro.prototype.acquire=function(t){if(!this.workers)for(this.workers=[];this.workers.length<ro.workerCount;)this.workers.push(new oo);return this.active[t]=!0,this.workers.slice()},ro.prototype.release=function(t){delete this.active[t],0===Object.keys(this.active).length&&(this.workers.forEach(function(t){t.terminate();}),this.workers=null);},ro.workerCount=Math.max(Math.floor(window.navigator.hardwareConcurrency/2),1);var no=/\{([zxy])\}/g,ao=function(t){function e(e,i){t.call(this,Object.assign({},{type:"vector"},e)),this.cfg=e,this.workerController=i,this.urlTemplate=this.get("url");}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.loadTile=function(t,e){var i=t.id.split("_"),o=this._getTileURL({x:i[0],y:i[1],z:i[2]}),r=Object.assign({},{id:t.id,type:"vector"},this.cfg,{url:o});t.workerID=this.workerController.send("loadTile",r,function(t,i){e(t,i);}.bind(this));},e.prototype.abortTile=function(t){this.workerController.send("abortTile",{id:t.id,type:this.get("type"),sourceID:this.get("sourceID")},void 0,t.workerID);},e.prototype.unloadTile=function(t){this.workerController.send("removeTile",{id:t.id,type:this.get("type"),sourceID:this.get("sourceID")},void 0,t.workerID);},e.prototype._getTileURL=function(t){return t.s||(t.s=String.fromCharCode(97+Math.floor(3*Math.random()))),no.lastIndex=0,this.urlTemplate.replace(no,function(e,i){return t[i]})},e}(t.Base),so=180/Math.PI,lo=function(e,i){this.layer=e,this._object3D=new t.Object3D,this._object3D.name=i.tileId,this._tile=i.tileId.split("_").map(function(t){return 1*t}),this._tileLnglatBounds=this._tileLnglatBounds(this._tile),this._tileBounds=this._tileBounds(this._tileLnglatBounds),this._center=this._tileBounds.getCenter(),this._centerLnglat=this._tileLnglatBounds.getCenter(),this._init(i),this.maskScene=new t.Scene;var o=this._tileMaskMesh();this.maskScene.add(o),this._bufferData=i;};lo.prototype._init=function(t){this._createMesh(t);},lo.prototype.getFeatureIndex=function(t){return this._bufferData.featureKey.indexOf(t)},lo.prototype._createMesh=function(t){var e=this;return this.mesh=D(this.layer.get("type"),t.shape)(null,this.layer,t.buffer),"composer"!==this.mesh.type?(this.mesh.onBeforeRender=function(t){e._renderMask(t);var i=e.layer.scene.getZoom();r(e._object3D,{u_time:e.layer.scene._engine.clock.getElapsedTime(),u_zoom:i});},this.mesh.onAfterRender=function(t){var e=t.context;e.clear(e.STENCIL_BUFFER_BIT),e.disable(e.STENCIL_TEST);},this._object3D.add(this.mesh)):this._object3D=this.mesh,this._object3D},lo.prototype.getMesh=function(){return this._object3D},lo.prototype._renderMask=function(t){if("point"!==this.layer.get("layerType")){var e=t.context;t.autoClear=!1,t.clearDepth(),e.enable(e.STENCIL_TEST),e.stencilOp(e.REPLACE,e.REPLACE,e.REPLACE),e.stencilFunc(e.ALWAYS,1,4294967295),e.clearStencil(0),e.clear(e.STENCIL_BUFFER_BIT),e.colorMask(!1,!1,!1,!1),this.layer.scene._engine.renderScene(this.maskScene),e.colorMask(!0,!0,!0,!0),e.depthMask(!1),t.clearDepth(),e.stencilFunc(e.EQUAL,1,4294967295),e.stencilOp(e.KEEP,e.KEEP,e.KEEP);}},lo.prototype._tileMaskMesh=function(){var e=this._tileBounds,i=[e.getBottomLeft().x,e.getBottomLeft().y,0],o=[e.getBottomRight().x,e.getBottomRight().y,0],r=[e.getTopLeft().x,e.getTopLeft().y,0],n=[e.getTopRight().x,e.getTopRight().y,0],a=new Float32Array(i.concat(n,o,i,r,n)),s=new t.BufferGeometry;s.addAttribute("position",new t.Float32BufferAttribute(a,3));var l=new Ze;return new t.Mesh(s,l)},lo.prototype.getSelectFeature=function(t){var e=this.layerSource.originData.featureKeys[t];if(e&&void 0!==e.index){var i=e.index;return this.layerSource.originData.dataArray[i]}return null},lo.prototype._tileBounds=function(t){var e=this.layer.scene.project([t.getNorthEast().lng,t.getNorthEast().lat]),i=this.layer.scene.project([t.getSouthWest().lng,t.getSouthWest().lat]);return Fe(i,e)},lo.prototype._tileLnglatBounds=function(t){var e=this._tile2lng(t[0]+1,t[2]),i=this._tile2lng(t[0],t[2]),o=this._tile2lat(t[1]+1,t[2]),r=this._tile2lat(t[1],t[2]);return Be([i,r],[e,o])},lo.prototype._tile2lng=function(t,e){return t/Math.pow(2,e)*360-180},lo.prototype._tile2lat=function(t,e){var i=Math.PI-2*Math.PI*t/Math.pow(2,e);return so*Math.atan(.5*(Math.exp(i)-Math.exp(-i)))},lo.prototype.destroy=function(){o(this._object3D),o(this.maskScene),this._object3D=null,this.maskScene=null,this.layerData=null;};var co=function(e){function i(t,i){e.call(this,Object.assign({},{cacheLimit:50,minZoom:0,maxZoom:18,keepBuffer:0},i)),this._tileMap={},this.tileList={},this.scene=t,this._tileCache=new re(this.get("cacheLimit"),this._destroyTile.bind(this)),this._crs=ke,this.layers=this.scene.getLayers(),this._source=new ao(i,this.scene.style.WorkerController),this.layersTiles={};}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getLayerById=function(t){for(var e=this.scene.getLayers(),i=0;i<e.length;i+=1)if(e[i].layerId===1*t)return e[i]},i.prototype.update=function(){var t=this;this._calculateTileIDs();for(var e=function(e){var i=t.updateTileList[e].join("_"),o=t.tileList[i];o.loading=!0;var r=t._tileCache.getTile(i);if(void 0===r)t._source.loadTile(o,function(e,i){e||void 0===i||(t._renderTile(o,i),o.active=!0),o.loaded=!0,t._pruneTiles();});else{for(var n in o.active=!0,o.loaded=!0,r.mesh){var a=t.getLayerById(n),s=r.mesh[n];a.tiles.add(s.getMesh()),t._addPickMesh(a,s.getMesh()),t.scene._engine.update();}t._pruneTiles();}},i=0;i<t.updateTileList.length;i++)e(i);},i.prototype._renderTile=function(t,e){var i=t.id,o={rawData:e.rawTileData,mesh:{}};for(var r in e.buffer){var n=this.getLayerById(r),a=new lo(n,e.buffer[r]);o.mesh[r]=a,n.tiles.add(a.getMesh()),this._addPickMesh(n,a.getMesh()),this.scene._engine.update();}this._tileCache.setTile(o,i);},i.prototype.getSelectFeature=function(t,e,i){var o=this.tileZoom,r=this._crs.lngLatToPoint(je(i.lng,i.lat),o).divideBy(256).floor(),n=this._getParentTile(r.x,r.y,o,o-3),a=this.getLayerById(e).get("sourceOption").parser.sourceLayer,s=n.mesh[e].getFeatureIndex(t),l=this._getVectorFeature(n.rawData,a,s);return l?l.toGeoJSON(r.x,r.y,o):{}},i.prototype._getParentTile=function(t,e,i,o){if(i<o)return null;var r=[t,e,i].join("_"),n=this._tileCache.getTile(r);return n||this._getParentTile(Math.floor(t/2),Math.floor(e/2),i-1)},i.prototype._getVectorFeature=function(e,i,o){var r=new t.VectorTile(new t.PBF(e));if(!(o<0))return r.layers[i].feature(o)},i.prototype._calculateTileIDs=function(){this._tileMap={},this.updateTileList=[];var t=Math.floor(this.scene.getZoom()),e=this.get("minZoom"),i=this.get("maxZoom");if(this.tileZoom=t>i?i:t,this.scene.getZoom()<e)this._removeTiles();else{var o=this._getPixelBounds(),r=this._pxBoundsToTileRange(o),n=this.get("keepBuffer"),a=this.scene.getCenter(),s=this.scene.crs.lngLatToPoint(je(a.lng,a.lat),this.tileZoom).divideBy(256).floor();if(this._noPruneRange=new ze(r.getBottomLeft().subtract([n,-n]),r.getTopRight().add([n,-n])),!(isFinite(r.min.x)&&isFinite(r.min.y)&&isFinite(r.max.x)&&isFinite(r.max.y)))throw new Error("Attempted to load an infinite number of tiles");for(var l=r.min.y;l<=r.max.y;l++)for(var c=r.min.x;c<=r.max.x;c++){var u=[c,l,this.tileZoom],h=this.tileList[u.join("_")];h&&h.loading?(h.current=!0,h.retain=!0):(this.tileList[u.join("_")]={current:!0,active:!1,retain:!0,loading:!1,coords:u,id:u.join("_")},this.updateTileList.push(u));}this.updateTileList.sort(function(t,e){var i=t,o=e;return Math.pow(1*i[0]-s.x,2)+Math.pow(1*i[1]-s.y,2)-(Math.pow(1*o[0]-s.x,2)+Math.pow(1*o[1]-s.y,2))}),this._pruneTiles();}},i.prototype._getPixelBounds=function(){var t,e,i=this.scene.getBounds().toBounds(),o=i.getNorthEast(),r=i.getSouthWest(),n=this.tileZoom,a=this.scene.getCenter(),s=this.scene.crs.lngLatToPoint(je(o.lng,o.lat),n),l=this.scene.crs.lngLatToPoint(je(r.lng,r.lat),n),c=this.scene.crs.lngLatToPoint(je(a.lng,a.lat),n),u=c.y-s.y,h=l.y-c.y;if(a.lng-o.lng>0||a.lng-r.lng<0){var p=256*Math.pow(2,n)/360*(180-o.lng)+256*Math.pow(2,n)/360*(r.lng+180);a.lng-o.lng>0?e=p-(t=256*Math.pow(2,n)/360*(a.lng-o.lng)):t=p-(e=256*Math.pow(2,n)/360*(r.lng-a.lng));}else t=256*Math.pow(2,n)/360*(a.lng-r.lng),e=256*Math.pow(2,n)/360*(o.lng-a.lng);return new ze(c.subtract(t,u),c.add(e,h))},i.prototype._pxBoundsToTileRange=function(t){return new ze(t.min.divideBy(256).floor(),t.max.divideBy(256).ceil().subtract([1,1]))},i.prototype._loadTile=function(t,e){return this._source.loadTile(t,e)},i.prototype._unloadTile=function(t){if(this._source.unloadTile)return this._source.unloadTile(t,function(){})},i.prototype._abortTile=function(t){if(this._source.abortTile)return this._source.abortTile(t,function(){})},i.prototype.reload=function(){},i.prototype._reloadTile=function(){},i.prototype._removeTile=function(){},i.prototype.clearTiles=function(){},i.prototype._pruneTiles=function(){var t,e=this.tileZoom;for(var i in this.tileList){var o=this.tileList[i].coords;o[2]===e&&this._noPruneRange.contains(new Re(o[0],o[1]))||(this.tileList[i].current=!1,this.tileList[i].retain=!1);}for(var r in this.tileList)if((t=this.tileList[r]).current&&!t.active){var n=r.split("_").map(function(t){return 1*t}),a=n[0],s=n[1],l=n[2];this._retainParent(a,s,l,l-5)||this._retainChildren(a,s,l,l+2);}this._removeOutTiles();},i.prototype._retainParent=function(t,e,i,o){var r=Math.floor(t/2),n=Math.floor(e/2),a=i-1,s=this.tileList[[r,n,a].join("_")];return s&&s.active?(s.retain=!0,s.current=!0,!0):(s&&s.loaded&&(s.retain=!0),a>o&&this._retainParent(r,n,a,o))},i.prototype._retainChildren=function(t,e,i,o){for(var r=2*t;r<2*t+2;r++)for(var n=2*e;n<2*e+2;n++){var a=[r,n,i+1].join("_"),s=this.tileList[a];s&&s.active?(s.retain=!0,s.current=!0):(s&&s.loaded&&(s.retain=!0,s.current=!0),i+1<o&&this._retainChildren(r,n,i+1,o));}},i.prototype._addPickMesh=function(t,e){if("image"!==this.type){var i=t.get("pickingController"),o=e.children[0];o.name=e.name,i.addPickMesh(o);}},i.prototype._removeOutTiles=function(){var t=this;for(var e in this.tileList)this.tileList[e].retain||(this._abortTile(this.tileList[e]),this._unloadTile(this.tileList[e]),delete this.tileList[e]);for(var i=this.scene.getLayers(),o=function(e){var o=t.get("sourceID");if(i[e].get("sourceOption").id!==o)return {};i[e].tiles.children.forEach(function(o){var r=o.name;if(!t.tileList[r]){i[e].tiles.remove(o);var n=i[e].get("pickingController");n&&n.removePickMeshByName(r);}});},r=0;r<i.length;r++){var n=o(r);if(n)return n.v}},i.prototype._destroyTile=function(t,e){this._unloadTile(e);},i}(t.Base),uo=1;var ho=function t(e,i){this.workerPool=e,this.actors=[],this.currentActor=0,this.id=uo++;for(var o=this.workerPool.acquire(this.id),r=0;r<o.length;r++){var n=o[r],a=new t.Actor(n,i,this.id);a.name="Worker "+r,this.actors.push(a);}};ho.prototype.broadcast=function(t,e,i){i=i||function(){},function(t,e,i){if(!t.length)return i(null,[]);var o=t.length,r=new Array(t.length),n=null;t.forEach(function(t,a){e(t,function(t,e){t&&(n=t),r[a]=e,0==--o&&i(n,r);});});}(this.actors,function(i,o){i.send(t,e,o);},i);},ho.prototype.send=function(t,e,i,o){return ("number"!=typeof o||isNaN(o))&&(o=this.currentActor=(this.currentActor+1)%this.actors.length),this.actors[o].send(t,e,i,o),o},ho.prototype.remove=function(){this.actors.forEach(function(t){t.remove();}),this.actors=[],this.workerPool.release(this.id);},ho.Actor=t.Actor;var po=["mappingController","interacionController","pickingController","interactions","eventController"],fo=function(t){function e(e,i){t.call(this,i),this.scene=e,this._sourceCaches={},this.WorkerPool=new ro,this._tileMap={},this.WorkerController=new ho(this.WorkerPool,this),this.layerStyles={},this.layers=[],this.addMapEvent();}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.addSource=function(t,e){if(void 0!==this._sourceCaches[t])throw new Error("SourceID 已存在");e.sourceID=t,this._sourceCaches[t]=new co(this.scene,e);},e.prototype.getSource=function(t){return this._sourceCaches[t]},e.prototype.addLayer=function(t){var e=t.layerId;this.layers[e]=t;},e.prototype._addTileStyle=function(t){var e=t.layerId,i={};for(var o in t)-1===po.indexOf(o)&&(i[o]=t[o]);this.layerStyles[e]=i,this._layerStyleGroupBySourceID(),this.WorkerController.broadcast("setLayers",this.layerStyles);},e.prototype.removeTileStyle=function(t){delete this.layerStyles[t],this._layerStyleGroupBySourceID();},e.prototype._layerStyleGroupBySourceID=function(){var t=[];for(var e in this.layerStyles){var i=this.layerStyles[e].sourceOption.id,o=this.layerStyles[e].sourceOption.parser.sourceLayer;t[i]||(t[i]={}),t[i][o]||(t[i][o]=[]),t[i][o].push(this.layerStyles[e]);}this.sourceStyles=t;},e.prototype.update=function(t){for(var e in this._addTileStyle(t),this._sourceCaches)this._sourceCaches[e].update(this.layers,this.sourceStyles[e]);},e.prototype.addMapEvent=function(){var t=this;this.mapEventHander=v(function(){requestAnimationFrame(function(){for(var e in t._sourceCaches)t._sourceCaches[e].update(t.layers,t.sourceStyles[e]);});},200),this.scene.map.on("zoomchange",this.mapEventHander),this.scene.map.on("dragend",this.mapEventHander);},e.prototype.clearMapEvent=function(){this.scene.map.off("zoomchange",this.mapEventHander),this.scene.map.off("dragend",this.mapEventHander);},e.prototype.destroy=function(){this.WorkerController.remove();},e}(t.Base);function _o(t){return t.trim?t.trim():t.replace(/^\s+|\s+$/g,"")}var vo=window.document.documentElement.style;function go(t,e,i){var o=document.createElement(t);return o.className=e||"",i&&i.appendChild(o),o}function yo(t){var e=t.parentNode;e&&e.removeChild(t);}function mo(t,e){if(void 0!==t.classList)for(var i=_o(e).split(/\s+/),o=0,r=i.length;o<r;o++)t.classList.add(i[o]);else if(!function(t,e){if(void 0!==t.classList)return t.classList.contains(e);var i=wo(t);return i.length>0&&new RegExp("(^|\\s)"+e+"(\\s|$)").test(i)}(t,e)){var n=wo(t);xo(t,(n?n+" ":"")+e);}}function bo(t,e){void 0!==t.classList?t.classList.remove(e):xo(t,_o((" "+wo(t)+" ").replace(" "+e+" "," ")));}function xo(t,e){void 0===t.className.baseVal?t.className=e:t.className.baseVal=e;}function wo(t){return t.correspondingElement&&(t=t.correspondingElement),void 0===t.className.baseVal?t.className:t.className.baseVal}function Co(t){for(;t.firstChild;)t.removeChild(t.firstChild);}var Mo=function(t){if(!vo)return t[0];for(var e=0;e<t.length;e++)if(t[e]in vo)return t[e];return t[0]}(["transform","WebkitTransform"]);function Ao(t,e){t.style[Mo]=e;}var To=function(e){t.Util.assign(this,e),this._initControlPos();};To.prototype.addControl=function(t){t.addTo(this.scene);},To.prototype.removeControl=function(t){return t.remove(),this},To.prototype._initControlPos=function(){var t=this._controlCorners={},e="l7-",i=this._controlContainer=go("div",e+"control-container",this.scene.getContainer());function o(o,r){var n=e+o+" "+e+r;t[o+r]=go("div",n,i);}o("top","left"),o("top","right"),o("bottom","left"),o("bottom","right");},To.prototype.clearControlPos=function(){for(var t in this._controlCorners)yo(this._controlCorners[t]);yo(this._controlContainer),delete this._controlCorners,delete this._controlContainer;};var Lo=function(t){function e(e){t.call(this,Object.assign({},{position:"topright"},e));}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.setPosition=function(t){var e=this._scene;return e&&e.removeControl(this),this.set("position",t),e&&e.addControl(this),this},e.prototype.getContainer=function(){return this._container},e.prototype.addTo=function(t){this.remove(),this.isShow=!0,this._scene=t;var e=this._container=this.onAdd(t),i=this.get("position"),o=t.get("controlController")._controlCorners[i];return mo(e,"l7-control"),-1!==i.indexOf("bottom")?o.insertBefore(e,o.firstChild):o.appendChild(e),this},e.prototype.hide=function(){mo(this._container,"l7-control-hide"),this.isShow=!1;},e.prototype.show=function(){bo(this._container,"l7-control-hide"),this.isShow=!0;},e.prototype.remove=function(){if(!this._scene)return this;yo(this._container);},e.prototype._refocusOnMap=function(t){this._scene&&t&&t.screenX>0&&t.screenY>0&&this._scene.getContainer().focus();},e}(t.Base),ko=function(e){function i(i){e.call(this,Object.assign({},{position:"topleft",zoomInText:"+",zoomInTitle:"Zoom in",zoomOutText:"&#x2212;",zoomOutTitle:"Zoom out"},i)),t.bindAll(["_updateDisabled","_zoomIn","_zoomOut"],this),this._disabled=!1;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.onAdd=function(t){var e=go("div","l7-control-zoom l7-bar");return this._zoomInButton=this._createButton(this.get("zoomInText"),this.get("zoomInTitle"),"l7-control-zoom-in",e,this._zoomIn),this._zoomOutButton=this._createButton(this.get("zoomOutText"),this.get("zoomOutTitle"),"l7-control-zoom-out",e,this._zoomOut),t.on("zoomend",this._updateDisabled),t.on("zoomchange",this._updateDisabled),this._updateDisabled(),e},i.prototype.onRemove=function(t){t.off("zoomend",this._updateDisabled),t.off("zoomchange",this._updateDisabled);},i.prototype.disable=function(){return this._disabled=!0,this._updateDisabled(),this},i.prototype.enable=function(){return this._disabled=!1,this._updateDisabled(),this},i.prototype._zoomIn=function(){!this._disabled&&this._scene.getZoom()<this._scene.get("maxZoom")&&this._scene.zoomIn();},i.prototype._zoomOut=function(){!this._disabled&&this._scene.getZoom()>this._scene.get("minZoom")&&this._scene.zoomOut();},i.prototype._createButton=function(t,e,i,o,r){var n=go("a",i,o);return n.innerHTML=t,n.href="#",n.tile=e,n.addEventListener("click",r),n},i.prototype._updateDisabled=function(){var t=this._scene;bo(this._zoomInButton,"l7-disabled"),bo(this._zoomOutButton,"l7-disabled"),(this._disabled||t.getZoom()<=t.get("minZoom"))&&mo(this._zoomOutButton,"l7-disabled"),(this._disabled||t.getZoom()>=t.get("maxZoom"))&&mo(this._zoomInButton,"l7-disabled");},i}(Lo),So=function(e){function i(i){e.call(this,Object.assign({},{position:"bottomleft",maxWidth:100,metric:!0,updateWhenIdle:!1,imperial:!1},i)),t.bindAll(["_update"],this);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.onAdd=function(t){var e=go("div","l7-control-scale");return this._addScales("l7-control-scale-line",e),t.on(this.get("updateWhenIdle")?"moveend":"mapmove",this._update),this._update(),e},i.prototype.onRemove=function(t){t.off(this.get("updateWhenIdle")?"moveend":"mapmove",this._update);},i.prototype._addScales=function(t,e){this.get("metric")&&(this._mScale=go("div",t,e)),this.get("imperial")&&(this._iScale=go("div",t,e));},i.prototype._update=function(){var t=this._scene,e=this._scene.getSize().height/2,i=t.containerToLngLat({x:0,y:e}),o=t.containerToLngLat({x:this.get("maxWidth"),y:e}),r=t.crs.distance(we(i.lng,i.lat),we(o.lng,o.lat));this._updateScales(r);},i.prototype._updateScales=function(t){this.get("metric")&&t&&this._updateMetric(t),this.get("imperial")&&t&&this._updateImperial(t);},i.prototype._updateMetric=function(t){var e=this._getRoundNum(t),i=e<1e3?e+" m":e/1e3+" km";this._updateScale(this._mScale,i,e/t);},i.prototype._updateImperial=function(t){var e,i,o,r=3.2808399*t;r>5280?(e=r/5280,i=this._getRoundNum(e),this._updateScale(this._iScale,i+" mi",i/e)):(o=this._getRoundNum(r),this._updateScale(this._iScale,o+" ft",o/r));},i.prototype._updateScale=function(t,e,i){t.style.width=Math.round(this.get("maxWidth")*i)+"px",t.innerHTML=e;},i.prototype._getRoundNum=function(t){var e=Math.pow(10,(Math.floor(t)+"").length-1),i=t/e;return e*(i=i>=10?10:i>=5?5:i>=3?3:i>=2?2:1)},i}(Lo),Io=function(t){function e(e){t.call(this,Object.assign({},{position:"bottomright",prefix:'<a href="https://antv.alipay.com/zh-cn/l7/1.x/index.html" title="地理空间数据可视化引擎">AntV L7</a>'},e)),this._attributions={};}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.onAdd=function(t){this._container=go("div","l7-control-attribution");var e=t.getLayers();for(var i in e)e[i].get("attribution")&&this.addAttribution(e[i].get("attribution"));return this._update(),this._container},e.prototype.setPrefix=function(t){return this.set("prefix",t),this._update(),this},e.prototype.addAttribution=function(t){return t?(this._attributions[t]||(this._attributions[t]=0),this._attributions[t]++,this._update(),this):this},e.prototype.removeAttribution=function(t){return t?(this._attributions[t]&&(this._attributions[t]--,this._update()),this):this},e.prototype._update=function(){if(this._scene){var t=[];for(var e in this._attributions)this._attributions[e]&&t.push(e);var i=[];this.get("prefix")&&i.push(this.get("prefix")),t.length&&i.push(t.join(", ")),this._container.innerHTML=i.join(" | ");}},e}(Lo),Eo=function(e){function i(i){e.call(this,Object.assign({},{collapsed:!0,position:"topright",autoZIndex:!0,hideSingleBase:!1,sortLayers:!1},i)),this._layerControlInputs=[],this._layers=[],this._lastZIndex=0,this._handlingClick=!1;var o=this.get("baseLayers"),r=this.get("overlayers");for(var n in o)this._addLayer(o[n],n);for(var a in r)this._addLayer(r[a],a,!0);t.bindAll(["_checkDisabledLayers","_onLayerChange","collapse","extend","expand","_onInputClick"],this);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.onAdd=function(t){this._initLayout(),this._update(),this._scene=t,t.on("zoomend",this._checkDisabledLayers,this);for(var e=0;e<this._layers.length;e++)this._layers[e].layer.on("remove",this._onLayerChange),this._layers[e].layer.on("add",this._onLayerChange);return this._container},i.prototype.addTo=function(t){e.prototype.addTo.call(this,t);},i.prototype.addVisualLayer=function(t,e){return this._addLayer(t,e,!0),this._scene?this._update():this},i.prototype._initLayout=function(){var t="l7-control-layers",e=this._container=go("div",t),i=this.get("collapsed");e.setAttribute("aria-haspopup",!0);var o=this._form=go("form",t+"-list");i&&(this._scene.on("click",this.collapse),e.addEventListener("mouseenter",this.expand),e.addEventListener("mouseleave",this.collapse));var r=this._layersLink=go("a",t+"-toggle",e);r.href="#",r.title="Layers",i||this.expand(),this._baseLayersList=go("div",t+"-base",o),this._separator=go("div",t+"-separator",o),this._overlaysList=go("div",t+"-overlays",o),e.appendChild(o);},i.prototype._update=function(){if(!this._container)return this;Co(this._baseLayersList),Co(this._overlaysList),this._layerControlInputs=[];var t,e,i,o,r=0;for(i=0;i<this._layers.length;i++)o=this._layers[i],this._addItem(o),e=e||o.overlay,t=t||!o.overlay,r+=o.overlay?0:1;return this.get("hideSingleBase")&&(t=t&&r>1,this._baseLayersList.style.display=t?"":"none"),this._separator.style.display=e&&t?"":"none",this},i.prototype.expand=function(){mo(this._container,"l7-control-layers-expanded"),this._form.style.height=null;var t=this._scene.getSize().height-(this._container.offsetTop+50);return t<this._form.clientHeight?(mo(this._form,"l7-control-layers-scrollbar"),this._form.style.height=t+"px"):bo(this._form,"l7-control-layers-scrollbar"),this._checkDisabledLayers(),this},i.prototype.collapse=function(){return bo(this._container,"l7-control-layers-expanded"),this},i.prototype._checkDisabledLayers=function(){for(var t,e,i=this._layerControlInputs,o=this._scene.getZoom(),r=i.length-1;r>=0;r--)t=i[r],e=this._scene.getLayer(t.layerId),t.disabled=void 0!==e.get("minZoom")&&o<e.get("minZoom")||o<e.get("maxZoom")!==void 0&&o>e.get("maxZoom");},i.prototype._addLayer=function(t,e,i){var o=this;this._scene&&(t.on("add",this._onLayerChange),t.on("remove",this._onLayerChange)),this._layers.push({layer:t,name:e,overlay:i}),this.get("sortLayers")&&this._layers.sort(function(t,e){return o.get("sortFunction")(t.layer,e.layer,t.name,e.name)}),this.get("autoZIndex")&&t.setZIndex&&(this._lastZIndex++,t.setZIndex(this._lastZIndex)),this._expandIfNotCollapsed();},i.prototype._expandIfNotCollapsed=function(){return this._scene&&!this.get("collapsed")&&this.expand(),this},i.prototype._onLayerChange=function(t){this._handlingClick||this._update();var e=this._scene.getLayer(t.target.layerId),i=e.overlay?"add"===t.type?"overlayadd":"overlayremove":"add"===t.type?"baselayerchange":null;i&&this._map.fire(i,e);},i.prototype._createRadioElement=function(t,e){var i='<input type="radio" class="l7-control-layers-selector" name="'+t+'"'+(e?' checked="checked"':"")+"/>",o=document.createElement("div");return o.innerHTML=i,o.firstChild},i.prototype._addItem=function(t){var e,i=document.createElement("label"),o=!!this._scene.getLayer(t.layer.layerId);t.overlay?((e=document.createElement("input")).type="checkbox",e.className="l7-control-layers-selector",e.defaultChecked=o):e=this._createRadioElement("l7-base-layers",o),this._layerControlInputs.push(e),e.layerId=t.layer.layerId,e.addEventListener("click",this._onInputClick);var r=document.createElement("span");r.innerHTML=" "+t.name;var n=document.createElement("div");return i.appendChild(n),n.appendChild(e),n.appendChild(r),(t.overlay?this._overlaysList:this._baseLayersList).appendChild(i),this._checkDisabledLayers(),i},i.prototype._onInputClick=function(){var t,e,i=this._layerControlInputs,o=[],r=[];this._handlingClick=!0;for(var n=i.length-1;n>=0;n--)t=i[n],e=this._scene.getLayer(t.layerId),t.checked?o.push(e):t.checked||r.push(e);for(var a=0;a<r.length;a++)r[a].hide();for(var s=0;s<o.length;s++)o[s].show();this._handlingClick=!1,this._refocusOnMap();},i}(Lo),Oo=Object.freeze({__proto__:null,Base:Lo,Zoom:ko,Scale:So,Attribution:Io,Layers:Eo}),Po=["mouseout","mouseover","mousedown","mouseleave","touchstart","touchmove","touchend","mouseup","rightclick","click","dblclick"],Do=function(e){function i(t){e.call(this,t),this.handleWindowResized=this.handleWindowResized.bind(this),this._initMap(),this.crs=ke,this.fontAtlasManager=new ci,this._layers=[],this.animateCount=0;}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.getDefaultCfg=function(){return t.Global.scene},i.prototype._initEngine=function(t){this._engine=new s(t,this),this.addImage(),this.registerMapEvent(),Y("point",{vs:pi,fs:hi}),Y("common",{vs:qi,fs:qi}),Y("decode",{vs:Ki,fs:""}),Y("lighting",{vs:Yi,fs:""}),Y("pick",{vs:"",fs:Xi}),Y("sdf_2d",{vs:"",fs:Qi}),Y("project",{vs:$i,fs:""}),Y("pick_color",{vs:Zi,fs:Zi}),Y("circle",{vs:bi,fs:mi}),Y("polygon",{vs:di,fs:fi}),Y("grid",{vs:vi,fs:_i}),Y("hexagon",{vs:yi,fs:gi}),Y("pointline",{vs:wi,fs:xi}),Y("pointnormal",{vs:Mi,fs:Ci}),Y("meshline",{vs:Ti,fs:Ai}),Y("arcline",{vs:ki,fs:Li}),Y("greatcircle",{vs:Si,fs:Li}),Y("line",{vs:Ei,fs:Ii}),Y("heatmap_color",{vs:Oi,fs:Pi}),Y("heatmap_intensity",{vs:zi,fs:Di}),Y("text",{vs:ji,fs:Fi}),Y("image",{vs:Bi,fs:Ri}),Y("raster",{vs:Ni,fs:Ui}),Y("tilepolygon",{vs:Hi,fs:Wi}),Y("mask_quard",{vs:Gi,fs:Vi});},i.prototype._initContoller=function(){var t=new To({scene:this});if(this.set("controlController",t),this.get("zoomControl")){var e=(new ko).addTo(this);this.set("zoomControl",e);}if(this.get("scaleControl")){var i=(new So).addTo(this);this.set("scaleControl",i);}if(this.get("attributionControl")){var o=(new Io).addTo(this);this.set("attributionControl",o);}},i.prototype.addPickMesh=function(t){this._engine._picking.add(t);},i.prototype._initMap=function(){var e=this;this.mapContainer=this._getSceneContainer(),this.mapType=this.get("mapType")||"amap";var i=new(t.getMap(this.mapType))(this.mapContainer,this._attrs);i.mixMap(this),this.mapContainer=i.container,this._container=i.container,eo(this._container,this.handleWindowResized),i.on("mapLoad",function(){(e.map=i.map,e._markerContainier=i.l7_marker_Container,e._initEngine(i.renderDom),i.asyncCamera(e._engine),e.initLayer(),e._registEvents(),e.get("hash"))&&new(m("hash"))({layer:e})._onHashChange();e.style=new fo(e,{}),e._initContoller(),e.emit("loaded");});},i.prototype._getSceneContainer=function(){var t=this.get("id");return "string"==typeof t?document.getElementById(t):t instanceof HTMLElement?t:void 0},i.prototype.initLayer=function(){var t=this,e=function(e){i.prototype[e]=function(i){var o=new l[e](t,i);return t._layers.push(o),o};};for(var o in l)e(o);},i.prototype.addTileSource=function(t,e){this.style.addSource(t,e);},i.prototype.getTileSource=function(t){return this.style.getSource(t)},i.prototype.on=function(t,i){this.map&&this.map.on(t,i),e.prototype.on.call(this,t,i);},i.prototype.off=function(t,i){this.map&&this.map.off(t,i),e.prototype.off.call(this,t,i);},i.prototype.addImage=function(){var t=this;this.image=new Qe,this.image.on("imageLoaded",function(){t._engine.update();});},i.prototype._initEvent=function(){},i.prototype.getLayers=function(){return this._layers},i.prototype.getLayer=function(t){var e=!1;return this._layers.forEach(function(i){i.layerId!==t||(e=i);}),e},i.prototype._addLayer=function(){},i.prototype.getContainer=function(){return this._container},i.prototype.getMarkerContainer=function(){return this._markerContainier},i.prototype.map2Png=function(){this.scene._engine.update();var t=this.scene._engine._renderer.domElement.toDataURL();return [this.scene.map.getContainer().getElementsByClassName("amap-layer")[0].toDataURL(),t]},i.prototype._registEvents=function(){var t=this;this._eventHander=function(e){"CANVAS"===e.target.nodeName&&t._engine._picking.pickdata(e);},this._throttleHander=v(this._eventHander,30),Po.forEach(function(e){t._container.addEventListener(e,t._eventHander,!0);}),this._container.addEventListener("mousemove",this._throttleHander,!0);},i.prototype._unRegistEvents=function(){var t=this;Po.forEach(function(e){t._container.removeEventListener(e,t._eventHander,!0);}),this._container.removeEventListener("mousemove",this._throttleHander,!0);},i.prototype.removeLayer=function(t){var e=this._layers.indexOf(t);e>-1&&this._layers.splice(e,1),t.destroy(),t=null,this._engine.update();},i.prototype.startAnimate=function(){0===this.animateCount&&(this.unRegsterMapEvent(),this._engine.run()),this.animateCount++;},i.prototype.stopAnimate=function(){1===this.animateCount&&(this._engine.stop(),this.registerMapEvent()),this.animateCount++;},i.prototype.registerMapEvent=function(){var t=this;this._updateRender=function(){return t._engine.update()},this.map.on("mapmove",this._updateRender),this.map.on("camerachange",this._updateRender),this.map.on("resize",this._updateRender);},i.prototype.unRegsterMapEvent=function(){this.map.off("mapmove",this._updateRender),this.map.off("camerachange",this._updateRender),this.map.off("resize",this._updateRender);},i.prototype.addControl=function(t){return this.get("controlController").addControl(t),this},i.prototype.removeControl=function(t){this.get("controlController").removeControl(t);},i.prototype.render=function(){this._engine.update();},i.prototype.destroy=function(){this.get("controlController").clearControlPos(),e.prototype.destroy.call(this),this._layers.forEach(function(t){t.destroy();}),io(this._container,this.handleWindowResized),this._layers.length=0,this.image=null,this.fontAtlasManager=null,this.style.destroy(),this.style=null,this._engine.destroy(),this._engine=null,this.map.destroy(),this.unRegsterMapEvent(),this._unRegistEvents();},i.prototype.handleWindowResized=function(){this.emit("resize"),this._engine&&this._engine.resize();},i}(t.Base),zo={center:"translate(-50%,-50%)",top:"translate(-50%,0)","top-left":"translate(0,0)","top-right":"translate(-100%,0)",bottom:"translate(-50%,-100%)","bottom-left":"translate(0,-100%)","bottom-right":"translate(-100%,-100%)",left:"translate(0,-50%)",right:"translate(-100%,-50%)"};function Fo(t,e,i){var o=t.classList;for(var r in zo)o.remove("l7-"+i+"-anchor-"+r);o.add("l7-"+i+"-anchor-"+e);}var jo=function(e){function i(i){e.call(this,Object.assign({},{closeButton:!0,closeOnClick:!0,maxWidth:"240px",anchor:"bottom"},i)),this.timeout=0,t.bindAll(["_update","_onClickClose","remove"],this);}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype.addTo=function(t){var e=this;return this._scene=t,this._scene.on("camerachange",this._update),this._update(),this.get("closeOnClick")&&(this.timeout=setTimeout(function(){e._scene&&e._scene.on("click",e._onClickClose);},30)),this},i.prototype.setLnglat=function(t){return this.lngLat=t,this._scene&&(this._scene.on("camerachange",this._update),this._scene.on("resize",this._update)),this._update(t),this},i.prototype._update=function(){var t=this,e=this.lngLat;this._scene&&e&&this._content&&(this._container||(this._container=this.creatDom("div","l7-popup",this._scene.getMarkerContainer().parentNode),this._tip=this.creatDom("div","l7-popup-tip",this._container),this._container.appendChild(this._content),this.get("className")&&this.get("className").split(" ").forEach(function(e){return t._container.classList.add(e)}),this._container.addEventListener("mousedown",function(t){t.stopPropagation();})),this.get("maxWidth")&&this._container.style.maxWidth!==this.get("maxWidth")&&(this._container.style.maxWidth=this.get("maxWidth")),this._updatePosition(),Ao(this._container,""+zo[this.get("anchor")]),Fo(this._container,this.get("anchor"),"popup"));},i.prototype._updatePosition=function(){if(this._scene){var t=this._scene.lngLatToContainer(this.lngLat);this._container.style.left=t.x+"px",this._container.style.top=t.y+"px";}},i.prototype.setHTML=function(t){var e,i=window.document.createDocumentFragment(),o=window.document.createElement("body");for(o.innerHTML=t;e=o.firstChild;)i.appendChild(e);return this.setDOMContent(i)},i.prototype.setText=function(t){return this.setDOMContent(window.document.createTextNode(t))},i.prototype.setMaxWidth=function(t){return this.set("maxWidth",t),this._update(),this},i.prototype.setDOMContent=function(t){return this._createContent(),this._content.appendChild(t),this._update(),this},i.prototype._createContent=function(){this._content&&yo(this._content),this._content=go("div","l7-popup-content",this._container),this.get("closeButton")&&(this._closeButton=go("button","l7-popup-close-button",this._content),this._closeButton.type="button",this._closeButton.setAttribute("aria-label","Close popup"),this._closeButton.innerHTML="&#215;",this._closeButton.addEventListener("click",this._onClickClose));},i.prototype._onClickClose=function(){this.remove();},i.prototype.creatDom=function(t,e,i){var o=window.document.createElement(t);return void 0!==e&&(o.className=e),i&&i.appendChild(o),o},i.prototype.removeDom=function(t){t.parentNode&&t.parentNode.removeChild(t);},i.prototype.remove=function(){return this._content&&this.removeDom(this._content),this._container&&(this.removeDom(this._container),delete this._container),this._scene&&(this._scene.off("camerachange",this._update),this._scene.off("resize",this._update),this._scene.off("click",this._onClickClose),delete this._scene),clearTimeout(this.timeout),this.emit("close"),this},i.prototype.isOpen=function(){return !!this._scene},i}(t.Base),Bo=function(e){function i(i){e.call(this,Object.assign({},{element:"",anchor:"bottom",offset:[0,0],color:"#2f54eb",draggable:!1},i)),t.bindAll(["_update","_onMove","_onUp","_addDragHandler","_onMapClick"],this),this._init();}return e&&(i.__proto__=e),i.prototype=Object.create(e&&e.prototype),i.prototype.constructor=i,i.prototype._init=function(){var t=this,e=this.get("element");if(!e){this._defaultMarker=!0,e=go("div"),this.set("element",e);var i=document.createElementNS("http://www.w3.org/2000/svg","svg");i.setAttributeNS(null,"display","block"),i.setAttributeNS(null,"height","48px"),i.setAttributeNS(null,"width","48px"),i.setAttributeNS(null,"viewBox","0 0 1024 1024");var o=document.createElementNS("http://www.w3.org/2000/svg","path");o.setAttributeNS(null,"d","M512 490.666667C453.12 490.666667 405.333333 442.88 405.333333 384 405.333333 325.12 453.12 277.333333 512 277.333333 570.88 277.333333 618.666667 325.12 618.666667 384 618.666667 442.88 570.88 490.666667 512 490.666667M512 85.333333C346.88 85.333333 213.333333 218.88 213.333333 384 213.333333 608 512 938.666667 512 938.666667 512 938.666667 810.666667 608 810.666667 384 810.666667 218.88 677.12 85.333333 512 85.333333Z"),o.setAttributeNS(null,"fill",this.get("color")),i.appendChild(o),e.appendChild(i);}mo(e,"l7-marker"),e.addEventListener("click",function(e){t._onMapClick(e);}),Fo(e,this.get("anchor"),"marker"),this._popup=null;},i.prototype.addTo=function(t){return this.remove(),this._scene=t,this._scene.getMarkerContainer().appendChild(this.get("element")),this._scene.on("camerachange",this._update),this._scene.on("resize",this._update),this.setDraggable(this.get("draggable")),this._update(),this},i.prototype.remove=function(){return this._scene&&(this._scene.off("click",this._onMapClick),this._scene.off("resize",this._update),this._scene.off("camerachange",this._update),this._scene.off("move",this._update),this._scene.off("moveend",this._update),this._scene.off("mousedown",this._addDragHandler),this._scene.off("touchstart",this._addDragHandler),this._scene.off("mouseup",this._onUp),this._scene.off("touchend",this._onUp),delete this._scene),yo(this.get("element")),this._popup&&this._popup.remove(),this},i.prototype.setLnglat=function(t){return this._lngLat=t,this._popup&&this._popup.setLnglat(this._lngLat),this},i.prototype.getLnglat=function(){return this._lngLat},i.prototype.getElement=function(){return this.get("element")},i.prototype.setPopup=function(t){return this._popup=t,this._lngLat&&this._popup.setLnglat(this._lngLat),this},i.prototype.togglePopup=function(){var t=this._popup;return t?(t.isOpen()?t.remove():t.addTo(this._scene),this):this},i.prototype.getPopup=function(){return this._popup},i.prototype.getOffset=function(){},i.prototype.setDraggable=function(){},i.prototype.isDraggable=function(){return this._draggable},i.prototype._update=function(){this._scene&&(this._updatePosition(),Ao(this.get("element"),""+zo[this.get("anchor")]));},i.prototype._onMapClick=function(){var t=this.get("element");this._popup&&t&&this.togglePopup();},i.prototype._updatePosition=function(){if(this._scene){var t=this._pos=this._scene.lngLatToContainer(this._lngLat);this.get("element").style.left=t.x+"px",this.get("element").style.top=t.y+"px";}},i.prototype._bubbleUp=function(){var t=this,e=this.get("element");["mouseout","mouseover","mousemove","mousedown","mouseleave","mouseup","rightclick","click","dblclick","wheel"].forEach(function(i){e.addEventListener(i,function(e){t._scene.emit(i,e);});});},i.prototype._addDragHandler=function(){},i.prototype._onUp=function(){},i}(t.Base),Ro={version:t.Global.version,Scene:Do,Source:t.Source,TileSource:oe,registerParser:t.registerParser,registerTransform:t.registerTransform,registerLayer:c,registerInteraction:b,getInteraction:m,Popup:jo,Marker:Bo,Control:Oo};return Ro});

return L7;

}));
//# sourceMappingURL=L7-min.js.map
